package Accestat;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ϥ⥸塼
# Accestat.pm ver1.0.13
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-05-31
######################################################################
# Ƚ
sub get_lang ($$) {
my($this,$key) = @_;
return '' if !$key;
$key = lc $key;

# 쥳
my %lang = (
	'ja' => 'ܸ',
	'ja-jp' => 'ܸ',
	'af' => 'եꥫ󥹸',
	'sq' => 'ӥ',
	'eu' => 'Х',
	'bg' => '֥륬ꥢ',
	'be' => '٥롼',
	'ca' => '˥',
	'zh' => '',
	'zh-tw' => '()',
	'zh-cn' => '()',
	'zh-hk' => '()',
	'zh-sg' => '(󥬥ݡ)',
	'hr' => '',
	'cs' => '',
	'da' => 'ǥޡ',
	'nl' => '()',
	'nl-be' => '(٥륮)',
	'en' => 'Ѹ',
	'en-us' => 'Ѹ(ꥫ)',
	'en-gb' => 'Ѹ(ꥹ)',
	'en-au' => 'Ѹ(ȥꥢ)',
	'en-ca' => 'Ѹ(ʥ)',
	'en-nz' => 'Ѹ(˥塼)',
	'en-ie' => 'Ѹ()',
	'en-jm' => 'Ѹ(ޥ)',
	'en-bz' => 'Ѹ(٥꡼)',
	'en-tt' => 'Ѹ(ȥ˥)',
	'et' => 'ȥ˥',
	'fo' => 'ե',
	'fa' => 'ڥ륷',
	'fi' => 'եɸ',
	'fr' => 'ե󥹸(ե)',
	'fr-be' => 'ե󥹸(٥륮)',
	'fr-ca' => 'ե󥹸(ʥ)',
	'fr-ch' => 'ե󥹸()',
	'fr-lu' => 'ե󥹸(륯֥륰)',
	'gd' => '',
	'de' => 'ɥĸ(ɥ)',
	'de-ch' => 'ɥĸ()',
	'de-at' => 'ɥĸ(ȥꥢ)',
	'de-lu' => 'ɥĸ(륯֥륰)',
	'de-li' => 'ɥĸ(ҥƥ󥷥奿)',
	'el' => 'ꥷ',
	'hi' => 'ҥǥ',
	'hu' => 'ϥ󥬥꡼',
	'is' => 'ɸ',
	'in' => 'ɥͥ',
	'it' => 'ꥢ(ꥢ)',
	'it-ch' => 'ꥢ()',
	'ko' => 'ڹ',
	'ko-kr' => 'ڹ(̱)',
	'lv' => 'ȥӥ',
	'lt' => 'ȥ˥',
	'mk' => 'ޥɥ˥',
	'ms' => 'ޥ졼',
	'mt' => 'ޥ륿',
	'no' => 'Υ륦',
	'pl' => 'ݡɸ',
	'pt-br' => 'ݥȥ(֥饸)',
	'pt' => 'ݥȥ(ݥȥ)',
	'rm' => '졼ȥޥ󥹸',
	'ro' => '롼ޥ˥',
	'ro-mo' => '롼ޥ˥(ɥ)',
	'ru' => '',
	'ru-mo' => '(ɥ)',
	'sr' => 'ӥ',
	'sl' => '٥˥',
	'sb' => 'ӥ',
	'es' => 'ڥ',
	'es-mx' => 'ڥ(ᥭ)',
	'es-gt' => 'ڥ(ƥޥ)',
	'es-cr' => 'ڥ(ꥫ)',
	'es-pa' => 'ڥ(ѥʥ)',
	'es-do' => 'ڥ',
	'es-ve' => 'ڥ(٥ͥ)',
	'es-co' => 'ڥ(ӥ)',
	'es-pe' => 'ڥ(ڥ롼)',
	'es-ar' => 'ڥ(를)',
	'es-ec' => 'ڥ(ɥ)',
	'es-cl' => 'ڥ()',
	'es-uy' => 'ڥ(륰)',
	'es-py' => 'ڥ(ѥ饰)',
	'es-bo' => 'ڥ(ܥӥ)',
	'es-sv' => 'ڥ(륵Хɥ)',
	'es-hn' => 'ڥ(ۥ󥸥饹)',
	'es-ni' => 'ڥ(˥饰)',
	'es-pr' => 'ڥ(ץȥꥳ)',
	'sx' => 'ĸ',
	'sv' => 'ǥ',
	'sv-fi' => 'ǥ(ե)',
	'th' => '',
	'ts' => 'ĥ󥬸',
	'tn' => 'ĥʸ',
	'tr' => 'ȥ륳',
	'uk' => '饤ʸ',
	'ur' => 'ɥ',
	'vi' => '٥ȥʥ',
	'xh' => '',
	'ji' => 'ǥå',
	'zu' => '롼'
);
if (defined $lang{$key} && $lang{$key} ne '') {
	return $lang{$key} . ' [' . $key . ']';
} else {
	my($lang);
	$lang = $1 if $key =~ /^(\w+)\-/;
	return ($lang && $lang{$lang}) ? $lang{$lang} . '(?) [' . $key . ']' : $key;
}
}

sub query_to_keywords ($$;$) {
my($this,$query,$join) = @_;
$join = 1 if !wantarray;
my @keywords = ();

# 褯븡եॷܥå͡
my @name = (
	's',
	'search',
	'p',
	'MT',
	'kw',
	'key',
	'keyword',
	'Keywords',
	'q',
	'qt',
	'qry',
	'QUERY',
	'query',
	'QueryString',
	'target',
	'general',
	'word',
	'as_q',
	'Text'
);
my @name2 = (
	'^search%3A\\w+%3A\str$','^search:\\w+:str',
	'^FI_\d+$'
);
if ($query =~ /(^|&)m=[A-Za-z]+/) {
	@name = (
		'search',
		'MT',
		'kw',
		'key',
		'keyword',
		'Keywords',
		'q',
		'qt',
		'qry',
		'QUERY',
		'query',
		'QueryString',
		'word',
		'as_q',
		'as_epq',
		'as_oq'
	);
}

$query =~ s/#(.*?)$//g;
$query =~ s/\+/ /g;
while ($query =~ /\G([^=\&]*)[=]?([^\&]*)[\&]?/sg) {
	my($k,$v) = ($1,$2);

	if ((grep($k eq $_,@name) || grep($k =~ /$_/,@name2)) && 
		$v ne 'all' && $v ne 'combined' && 			# CGIк
		($v =~ /%u?[A-Fa-f0-9][A-Fa-f0-9]%[A-Fa-f0-9][A-Fa-f0-9]/ || $v =~ /[a-zA-Z]{2}/)) {

		$v =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
		if ($v =~ /(?:%[A-Fa-f0-9][A-Fa-f0-9]){2}/) {
			$v =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
			$v =~ s/\+/ /g;
		}
		my $v2 = $v;
		$v = $cgi::Jcode->set($v)->euc;
		$v = $cgi::Jcode->set($v2,'utf8')->euc if $v =~ /\?{3}/ || $v =~ /\&#xfff[a-f];/i;
		$v = $cgi::Jcode->set($v2,'sjis')->euc if $v =~ /\?{3}/ || $v =~ /\&#xfff[a-f];/i;
		undef $v2;
		$v =~ s/\%u([A-Fa-f0-9][A-Fa-f0-9])([A-Fa-f0-9][A-Fa-f0-9])/$cgi::Jcode->set(pack("C",hex($1)) . pack("C",hex($2)),'ucs2')->euc/ge;
		$this->jreplace('','{');
		$this->jreplace('','}');
		$this->jreplace('','(');
		$this->jreplace('',')');
		$v = $this->z_to_h($v,'euc');
		$v =~ s/(^|\s)cache:\S+/ /g;
		$v =~ s/["']//sg;
		$v =~ s/\&quot;//sg;
		$v =~ s/^\s+//sg;
		$v =~ s/\s+$//sg;
		$v =~ s/\s{2,}/ /sg;
		$v = lc $v;
		if ($join) {
			push(@keywords,$v);
		} else {
			$v =~ s/( [\&\|]+ | [\{\(\[]|[\]\)\}] | \- | and | or |\|)/ /gi;
			push(@keywords,split(/\s+/,$v));
		}
	}
}
if ($join) {
	my $kywd = join(' ',@keywords);
	$kywd =~ s/\s+/ /g;
	return (wantarray) ? ($kywd) : $kywd;
} else {
	return @keywords;
}
}

sub url_filter ($$;$) {
my($this,$url,$self) = @_;
if ($url =~ /^(.*)\?(.*)$/) {
	my($query,$count,%q,@del);
	($url,$query) = ($1,$2);
	$query =~ s/\x20/\+/g;
	if (!$self) {
		my %filter = (
			'yahoo\\.'	=>	['search\\.x','fr','tid','ei','meta','x','y','SpellState','search_x','sp','pstart','qrw','b','xargs','yuragi','fl'],
			'search\\.(msn|live)\\.'	=>	['FORM','first','cp','noredir','meta'],
			'google\\.'	=>	['hl','rls','hs','btnG','lr','revid','ei','ie','oi','oe','sa','resnum','ct','cd','rlz','adsafe','safe','channel','aq','sourceid','tab','meta','x','sitesearch'],
			'goo\\.ne\\.jp'	=>	['SM','FR','from'],
			'mixi\\.jp'	=>	['comment_count','page'],
			'/viewtopic.php' => ['sid'],
			'/start\\.cgi'	=> ['search%3A\\w+%3A\\w+','search:\\w+:\\w+','ct','f','u','uni','s','w','mod','and','search','q','p']
		);
		while (my($site,$queries) = each %filter) {
			if ($url =~ /$site/i) {
				@del = @$queries;
				last;
			}
		}
	}
	QUERY:
	while ($query =~ /\G([^=\&]*)=([^=\&]*)\&?/g) {
		my($k,$v) = ($1,$2);
		next QUERY if $v eq '' || (@del && grep($k =~ /^$_$/,@del));
		if ($url =~ m!/start.cgi$! && $k =~ /\%3D/i) {
			next QUERY if $k =~ /\.[xy]$/;
			$k =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
			KEY:
			while ($k =~ /\G([^=\&]*)=([^=\&]*)\&?/g) {
				my($k2,$v2) = ($1,$2);
				next KEY if @del && grep($k2 =~ /^$_$/,@del);
				if (ref $q{$k2} eq 'ARRAY') {
					push(@{$q{$k2}},$v2);
				} elsif (defined $q{$k2}) {
					$q{$k2} = [$q{$k2},$v2];
				} else {
					$q{$k2} = $v2;
				}
			}			
		} elsif (ref $q{$k} eq 'ARRAY') {
			push(@{$q{$k}},$v);
		} elsif (defined $q{$k}) {
			$q{$k} = [$q{$k},$v];
		} else {
			$q{$k} = $v;
		}
	}
	foreach my $k (sort {$a cmp $b} keys %q) {
		if (ref $q{$k} eq 'ARRAY') {
			foreach my $v (@{$q{$k}}) {
				$url .= (($count++) ? '&' : '?') . $k . '=' . $v;
			}
		} else {
			$url .= (($count++) ? '&' : '?') . $k . '=' . $q{$k};
		}
	}
}
return $url;
}

sub query_decode ($$;$) {
my($this,$query,$icode) = @_;
$query =~ s/\+/ /g;
$query =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
$query =~ s/\%u([A-Fa-f0-9][A-Fa-f0-9])([A-Fa-f0-9][A-Fa-f0-9])/$cgi::Jcode->set(pack("C",hex($1)) . pack("C",hex($2)),'ucs2')->euc/ge;
return $cgi::Jcode->set(\$query,(($icode) ? $icode : ($query =~ /=utf-8/i) ? 'utf8' : ''))->euc;
}

######################################################################
# ᥤ
sub run ($) {
my $this = shift;

#¸
$this->use_deco;
$this->stat_setting;

#եå
$this->log_check;

#إå
$this->print_header;

#
$this->access_stat;

#Ϸ̥إå
$this->contents_header;

#Ϸ
$this->print_report;

#եå
$this->contents_footer;
$this->print_footer;

}

######################################################################
# 
sub access_stat ($) {
my $this = shift;
my($access_log);
$this->{'access_count'} = 0;
return if defined $this->{'noLog'} && $this->{'noLog'};
use Fcntl qw(:flock);
foreach $access_log (@{$this->{'access_log'}}) {
	local(*LOG);
	if (open(LOG,$default::access_log . '/' . $access_log)) {
		binmode LOG;
		flock(LOG, LOCK_SH);

		while (<LOG>) {
			my(@data);
			$_ =~ s/\x0D?\x0A?$//s;
			@data = $this->svsplit(',',$_,-1);

			#оݥեå
			next if @setting::target && grep(eval{$data[2] =~ /$_/},@setting::target) == 0;

			#RSSޡ
			my($s,$m,$t);
			$s = $1 if $data[2] =~ s/[\?\&]utm_source=([^\&#=]*)//;
			$m = $1 if $data[2] =~ s/[\?\&]utm_medium=([^\&#=]*)//;
			$t = $1 if $data[2] =~ s/[\?\&]utm_term=([^\&#=]*)//;
			$data[2] =~ s/\&/\?/ if  ($s || $m || $t) && $data[2] !~ /\?/;
			if (!$data[5] && ($s || $m || $t)) {
				$data[5] = join(':', map($this->query_decode($_,'utf8'),grep($_ ne '',$m,$t,$s)));
			} elsif ($data[5]) {
				$data[5] =~ s/\&/\?/ if $data[5] =~ s/[\?\&]utm_\w+=[^\&#=]*//ig && $data[5] !~ /\?/;
			}
			$this->{'access_count'}++ if $this->log_stat($access_log,\@data);
		}
		close(LOG);
	}
}
}

sub log_stat ($$$) {
my($this,$access_log,$data) = @_;
return 0;
}

######################################################################
# Ϸɽ
sub print_report ($) {
my $this = shift;
return;
}

sub print_stat_report ($$$$;$$$$$$$$$$$$$$) {
my($this,$title,$array,$hash,$subhash,$grafhash,$max,$setting_key,$order,$name,$namealign,$namewidth,$num,$numwidth,$unit,$option,$optionwidth,$grafname) = @_;
my($lastpage);

#إå
if ((!defined $setting::download || $setting::download ne 'no') && $setting::stat{'download'}) {
	print $cgi::Jcode->set($title,'euc')->sjis . "\x0D\x0A" if defined $title && $title ne '';
	if ($setting::stat{'download'} eq 'csv') {
		print $this->svjoin(',',$cgi::Jcode->set($name,'euc')->sjis,$cgi::Jcode->set($num,'euc')->sjis,$cgi::Jcode->set($unit,'euc')->sjis) . "\x0D\x0A";
	} elsif ($setting::stat{'download'} eq 'tsv') {
		print $this->svjoin("\x09",$cgi::Jcode->set($name,'euc')->sjis,$cgi::Jcode->set($num,'euc')->sjis,$cgi::Jcode->set($unit,'euc')->sjis) . "\x0D\x0A";
	}
} else {
	$namewidth = 300 if !defined $namewidth || !$namewidth;
	$numwidth = 50 if !defined $numwidth || !$numwidth;
	$optionwidth = 30 if !defined $optionwidth ||  !$optionwidth;

	$this->{'Table'}->set(
		'styleH' => (($order) ? 'text-align: center; width: 30px,' : '') . 'text-align: center; width: ' . $namewidth . 'px,text-align: center; width: ' . $numwidth . 'px,text-align: center; width: ' . $this->{'BarGraph'}->{'barWidth'} . 'px' . (($option) ? ',text-align: center; width: ' . $optionwidth . 'px' : ''),
		'style0' => (($order) ? 'text-align: center; width: 30px,' : '') . 'text-align: ' . (($namealign) ? $namealign : 'center') . '; width: ' . $namewidth . 'px,text-align: right; width: ' . $numwidth . 'px,text-align: left; width: ' . $this->{'BarGraph'}->{'barWidth'} . 'px' . (($option) ? ',text-align: center; width: ' . $optionwidth . 'px' : '')
	);

	print '<div class="accestat-report">';
	print '<h2>' . $title . '</h2>' if defined $title && $title;
	if (defined $setting_key && $setting_key) {
		$setting::stat{$setting_key}{'u'} = '' if $this->is_nan($setting::stat{$setting_key}{'u'});
		my $cnt = @$array;
		$lastpage = ($setting::stat{$setting_key}{'u'}) ? (($cnt % $setting::stat{$setting_key}{'u'}) ? int($cnt / $setting::stat{$setting_key}{'u'}) + 1 : $cnt / $setting::stat{$setting_key}{'u'}) : 1;
		if (!$main::p || $main::p < 1) {
			$main::p = 1;
		} elsif ($main::p > $lastpage) {
			$main::p = $lastpage;
		}
		print '' . (($cnt) ? $cnt : '0') . ' (' . $main::p . '/'. $lastpage . 'ڡ)';
	}
	print $this->{'Table'}->table;

	print $this->{'Table'}->tr;
	print $this->{'Table'}->td('No.') if defined $order && $order;
	print $this->{'Table'}->td($name);
	print $this->{'Table'}->td($num);
	print $this->{'Table'}->td(((defined $grafname && $grafname ne '') ? $grafname : '') . (($unit) ? ' (' . $unit . ')' : ''));
	print $this->{'Table'}->td($option) if defined $option && $option;
	print $this->{'Table'}->_tr;
}

#Ϸ
my($count,$ranking,$k,$prev);
foreach $k (@$array) {
	my $n = (ref $grafhash) ? $$grafhash{$k} : $$hash{$k};
	if ((!defined $setting::download || $setting::download ne 'no') && $setting::stat{'download'}) {
		if ($setting::stat{'download'} eq 'csv') {
			print $this->svjoin(',',$cgi::Jcode->set($k,'euc')->sjis,$this->get_num($cgi::Jcode->set($hash->{$k},'euc')->sjis),$this->get_ratio($n,$max,$unit)) . "\x0D\x0A";
		} elsif ($setting::stat{'download'} eq 'tsv') {
			print $this->svjoin("\x09",$cgi::Jcode->set($k,'euc')->sjis,$this->get_num($cgi::Jcode->set($hash->{$k},'euc')->sjis),$this->get_ratio($n,$max,$unit)) . "\x0D\x0A";
		}
	} else {
		$count++;

		#ڡ
		if ($setting_key && $setting::stat{$setting_key}{'u'} && $setting::stat{$setting_key}{'u'} > 0) {
			if ($main::p > 0 && $setting::stat{$setting_key}{'u'} * ($main::p - 1) >= $count) {
				$ranking = $count if defined $order && $order && (!$prev || $n != $prev || !$ranking);
				$prev = $n;
				next;
			} elsif ($main::p > 0 && $setting::stat{$setting_key}{'u'} * $main::p < $count) {
				last;
			}
		}

		print $this->{'Table'}->tr;
		if (defined $order && $order) {
			$ranking = $count if !$prev || $n != $prev || !$ranking;
			print $this->{'Table'}->td($ranking);
		}
		print $this->{'Table'}->td($this->stat_key($k));
		print $this->{'Table'}->td($this->get_num($$hash{$k}));
		print $this->{'Table'}->td($this->{'BarGraph'}->bargraph($n,$max,$unit));
		print $this->{'Table'}->td($this->stat_option($k,$$hash{$k})) if defined $option && $option;
		print '</tr>';
		$prev = $n;
	}
	if (ref $subhash && ref $$subhash{$k}) {
		my($subkey);
		foreach $subkey (sort keys %{$$subhash{$k}}) {
			if ((!defined $setting::download || $setting::download ne 'no') && $setting::stat{'download'}) {
				if ($setting::stat{'download'} eq 'csv') {
					print $this->svjoin(',',$cgi::Jcode->set($subkey,'euc')->sjis,$this->get_num($cgi::Jcode->set($subhash->{$k}{$subkey},'euc')->sjis),$this->get_ratio(((ref $grafhash) ? $$grafhash{$subkey} : $cgi::Jcode->set($subhash->{$k}{$subkey},'euc')->sjis),$max,$unit)) . "\x0D\x0A";
				} elsif ($setting::stat{'download'} eq 'tsv') {
					print $this->svjoin("\x09",$cgi::Jcode->set($subkey,'euc')->sjis,$this->get_num($cgi::Jcode->set($subhash->{$k}{$subkey},'euc')->sjis),$this->get_ratio(((ref $grafhash) ? $$grafhash{$subkey} : $cgi::Jcode->set($subhash->{$k}{$subkey},'euc')->sjis),$max,$unit)) . "\x0D\x0A";
				}
			} else {
				print $this->{'Table'}->tr;
				print $this->{'Table'}->td('') if defined $order && $order;
				print $this->{'Table'}->td($this->stat_key($subkey,1));
				print $this->{'Table'}->td($this->get_num($$subhash{$k}{$subkey}));
				print $this->{'Table'}->td($this->{'BarGraph2'}->bargraph(((ref $grafhash) ? $$grafhash{$subkey} : $$subhash{$k}{$subkey}),$max,$unit));
				print $this->{'Table'}->td($this->stat_option($subkey,$$subhash{$k}{$subkey})) if defined $option && $option;
				print '</tr>';
			}
		}
	}
	$this->{'Table'}->{'row'}++ if ref $this->{'Table'};
}

if ((defined $setting::download && $setting::download eq 'no') || !$setting::stat{'download'} || ($setting::stat{'download'} ne 'csv' && $setting::stat{'download'} ne 'tsv')) {
	my $form_flag = 0;
	if ($setting::general{'postMethod'}) {
		$this->use_deco;
		$form_flag = 1;
	}
	print $this->{'Table'}->_table;
	print '<ul class="tools">';
	print '<li>';
	$setting::page{'stat'}{'indexButton'} = '' if !defined $setting::page{'stat'}{'indexButton'};
	if ($form_flag) {
		print $cgi::Deco->submit_button('index',$setting::page{'stat'}{'indexButton'},'Ķ','',{'m'=>'StatSetting','k'=>'setting'});
	} else {
		print $cgi::Deco->button(
			'index',
			$setting::page{'stat'}{'indexButton'},
			'./start.cgi?m=StatSetting&amp;k=setting',
			'Ķ'
		);
	}
	print '</li>';
	if (defined $setting_key && $setting_key) {
		if ($form_flag) {
			print '<li class="isolated"><label for="setting:' . $setting_key . '_u" class="datatitle">ɽ</label><input type="text" name="setting:' . $setting_key . '_u" id="setting:' . $setting_key . '_u" value="' . $this->escape($setting::stat{$setting_key}{'u'}) . '" size="3" maxlength="3" />';
			if (defined $order && $order) {
				print '<select name="setting:' . $setting_key . '_sort">';
				print '<option value="descend"' . (($setting::stat{$setting_key}{'sort'} eq 'descend') ? ' selected="selected"' : '') . '>߽</option>';
				print '<option value="ascend"' . (($setting::stat{$setting_key}{'sort'} eq 'ascend') ? ' selected="selected"' : '') . '></option>';
				print '</select>';
			}
			print '<input type="submit" name="m=' . $main::m . '&amp;k=' . $main::k . '" value="ɤ߹" /></li>';
		}
		if ($main::p > 1) {
			print '<li>';
			if ($form_flag) {
				print $cgi::Deco->submit_button('prev',$setting::page{'stat'}{'prevButton'},'Υڡ','',{'m'=>$main::m,'k'=>$main::k,'p'=>($main::p - 1)});
			} else {
				print $cgi::Deco->button(
					'prev',
					$setting::page{'stat'}{'prevButton'},
					'./start.cgi' . $this->set_query('url',['m','k']) . $this->add_query('url',{'p'=>$main::p - 1}),
					'Υڡ'
				);
			}
			print '</li>';
		}
		if ($main::p < $lastpage) {
			print '<li>';
			if ($form_flag) {
				print $cgi::Deco->submit_button('next',$setting::page{'stat'}{'nextButton'},'Υڡ','',{'m'=>$main::m,'k'=>$main::k,'p'=>($main::p + 1)});
			} else {
				print $cgi::Deco->button(
					'next',
					$setting::page{'stat'}{'nextButton'},
					'./start.cgi' . $this->set_query('url',['m','k']) . $this->add_query('url',{'p'=>$main::p + 1}),
					'Υڡ'
				);
			}
			print '</li>';
		}
	}	
	print '</ul></div>';
	
} else {
	print "\x0D\x0A";
}
}

sub stat_option ($$$) {
my($this,$key,$value) = @_;
}

sub stat_key ($$;$) {
my($this,$key,$normal_weight) = @_;
return ($normal_weight) ? $this->escape_without_html_entity($key) : '<strong>' . $this->escape_without_html_entity($key) . '</strong>';
}

sub get_num ($$) {
my($this,$num) = @_;
return ($num) ? $num : 0;
}

sub get_ratio ($$$) {
my($this,$point,$total,$unit) = @_;
if ($unit eq '%') {
	return (int(((($total) ? $point / $total : 0) * 10000) + 0.5) / 100);
} else {
	return $this->get_num($point);
}
}

######################################################################
# ϥ˥塼
sub print_stat_menu ($) {
my $this = shift;
#return if defined $this->{'noLog'} && $this->{'noLog'};

print '<ul class="tools">';
print '<li><img src="' . $env::image_dir . '/stat/leftend.gif" width="5" height="20" alt="ġ˥塼" border="0" /></li>';

# ڡ
print '<li>' . $this->submit_button($env::image_dir . '/stat/setting.gif',20,20,'Ķ','','m','StatSetting','k','setting') . '</li>';

# γ
print '<li>' . $this->submit_button($env::image_dir . '/stat/general.gif',20,20,'γ','','m','GeneralReport','k','general') . '</li>';

# ο
print '<li>' . $this->submit_button($env::image_dir . '/stat/access.gif',20,20,'ο','','m','AccessReport','k','access') . '</li>';

# ե̥󥭥
print '<li>' . $this->submit_button($env::image_dir . '/stat/request.gif',20,20,'ե̥󥭥','','m','RequestReport','k','request') . '</li>';

# åΨ
print '<li>' . $this->submit_button($env::image_dir . '/stat/click.gif',20,20,'åΨ','','m','ClickRatioReport','k','click') . '</li>';

# 󥯸󥭥
print '<li>' . $this->submit_button($env::image_dir . '/stat/referer.gif',20,20,'󥯸󥭥','','m','RefererReport','k','referer') . '</li>';

# 󥭥
print '<li>' . $this->submit_button($env::image_dir . '/stat/client.gif',20,20,'󥭥','','m','ClientReport','k','client') . '</li>';

# ɥ󥭥
print '<li>' . $this->submit_button($env::image_dir . '/stat/keyword.gif',20,20,'ɥ󥭥','','m','KeywordReport','k','keyword') . '</li>';

# ˬԤ­׺Ƹ
print '<li>' . $this->submit_button($env::image_dir . '/stat/tracer.gif',20,20,'ˬԤ­׺Ƹ','','m','TracerReport','k','tracer') . '</li>';

# ˬԤαĶ
print '<li>' . $this->submit_button($env::image_dir . '/stat/agent.gif',20,20,'ˬԤαĶ','','m','AgentReport','k','agent') . '</li>';

# ˬԤθĶ
print '<li>' . $this->submit_button($env::image_dir . '/stat/language.gif',20,20,'ˬԤθĶ','','m','LanguageReport','k','language') . '</li>';

# ˬԤΥ˥Ķ
print '<li>' . $this->submit_button($env::image_dir . '/stat/monitor.gif',20,20,'ˬԤΥ˥Ķ','','m','MonitorReport','k','monitor') . '</li>';

# ⡼
if ($this->is_secure('tools')) {
	print '<li>' . $this->submit_button($env::image_dir . '/stat/tools.gif',20,20,'⡼','','m','Tools','k','0000') . '</li>';
}

print '<li><img src="' . $env::image_dir . '/stat/rightend.gif" width="5" height="20" alt="ġ˥塼" border="0" /></li>';
print '</ul>';
}

######################################################################
# ƥĥإå
sub contents_header ($) {
my $this = shift;
return if (!defined $setting::download || $setting::download ne 'no') && defined $setting::stat{'download'} && ($setting::stat{'download'} eq 'csv' || $setting::stat{'download'} eq 'tsv');

#ե೫
print $this->form_start(
	'key'	=>	'stat',
	'name'	=>	'input'
);

#ϥ˥塼
$this->print_stat_menu;

#Ͼơ֥
$this->{'infoTable'} = Table->new;
if (defined $setting::page{'stat'}{'infoTable'} && ref $table::obj{$setting::page{'stat'}{'infoTable'}}) {
	%{$this->{'infoTable'}} = %{$table::obj{$setting::page{'stat'}{'infoTable'}}};
	$this->{'infoTable'}->{'fixed'} = 0;
} else {
	$this->{'infoTable'}->set(
		'fixed' => 0,
		'tableclass' => 'datatable',
		'trclass' => 'odd,even',
		'class0' => 'odd,even',
	);
}

#Ϸ̥ơ֥
$this->{'Table'} = Table->new;
if (defined $setting::page{'stat'}{'table'} && ref $table::obj{$setting::page{'stat'}{'table'}}) {
	%{$this->{'Table'}} = %{$table::obj{$setting::page{'stat'}{'table'}}};
	$this->{'Table'}->{'fixed'} = 0;
} else {
	$this->{'Table'}->set(
		'fixed' => 0,
		'tableclass' => 'datatable',
		'trclass' => 'odd,even',
		'class0' => 'odd,even',
		'thenabled' => 'true'
	);
}

#ե⥸塼ɤ߹
require CMONOS::CGI_Lib::BarGraph;
$this->{'BarGraph'} = BarGraph->new(
	\%setting::deco,
	$setting::page{'stat'}{'barColor'},
	$setting::page{'stat'}{'bgColor'},
	$setting::page{'stat'}{'barImage'},
	$setting::page{'stat'}{'bgImage'},
	$setting::page{'stat'}{'barWidth'}
);
$this->{'BarGraph2'} = BarGraph->new(
	\%setting::deco,
	$setting::page{'stat'}{'barColor2'},
	$setting::page{'stat'}{'bgColor2'},
	$setting::page{'stat'}{'barImage2'},
	$setting::page{'stat'}{'bgImage2'},
	$setting::page{'stat'}{'barWidth'}
);

#Ͼ
$this->stat_env;

#ȥ
print '<h1>' . $this->stat_title . '</h1>';
}

sub stat_title ($) {
my $this = shift;
return '';
}

sub contents_footer ($) {
my $this = shift;
return if (!defined $setting::download || $setting::download ne 'no') && defined $setting::stat{'download'} && ($setting::stat{'download'} eq 'csv' || $setting::stat{'download'} eq 'tsv');

#ϥ˥塼
$this->print_stat_menu;

print '</form>';
}

######################################################################
# Ͼ
sub stat_env ($) {
my $this = shift;

print $this->{'infoTable'}->table('id','accestat-env');

#о
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('оݥե');
print $this->{'infoTable'}->td($this->stat_target);
print $this->{'infoTable'}->_tr;

#оݴ
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('оݴ');
print $this->{'infoTable'}->td($this->stat_span);
print $this->{'infoTable'}->_tr;

#оݴ
if (defined $this->{'access_count'} && $this->{'access_count'} ne '') {
	print $this->{'infoTable'}->tr;
	print $this->{'infoTable'}->th('оݥ');
	print $this->{'infoTable'}->td($this->{'access_count'},'title','ϤǤ');
	print $this->{'infoTable'}->_tr;
}

#̾
$this->print_sub_stat_env;

print $this->{'infoTable'}->_table;
}

sub print_sub_stat_env ($) {
my $this = shift;
}

sub stat_target ($) {
my $this = shift;
if (@setting::target) {
	my $setting = join('<br />',@setting::target);
	if (defined $setting::stat{'target'}{'regexp'} && $setting::stat{'target'}{'regexp'}) {
		return ($setting,'title','ѥ줫˰פեΤ߲оݤȤʤޤɽޤǤޤˡ');	
	} else {
		$setting =~ s/\\(?!\\)//g;
		return ($setting,'title','ѥ줫˰פեΤ߲оݤȤʤޤɽޤߤޤˡ');
	}
} else {
	return ('ƤΥե');
}
}

sub stat_span ($) {
my $this = shift;
return 'ϲǽʥե뤬¸ߤޤ' if defined $this->{'noLog'} && $this->{'noLog'};

my($span_start);
if (defined $setting::stat{'span'}{'start'} && $setting::stat{'span'}{'start'}) {
	$span_start = $setting::stat{'span'}{'start'};
} else {
	$span_start = $1 if $this->{'access_log'}->[0] =~ /^([0-9]{8})/;
}
return $this->date($span_start,$setting::page{'stat'}{'datelimit'},$setting::page{'stat'}{'datetype'}) . '' . $this->date($setting::stat{'span'}{'end'},$setting::page{'stat'}{'datelimit'},$setting::page{'stat'}{'datetype'});
}

######################################################################
# 񤭹/ɤ߹
sub stat_setting ($) {
my $this = shift;
$this->_stat_setting;

#åȥե
if (!@default::target) {
	my $home_location = $this->home_location;
	push(@default::target,$home_location);
	if (defined $env::doublename && $env::doublename) {
		$home_location =~ s!^http[s]?://www\.!!si;
		push(@default::target,$home_location);
	}
}

#񤭹/ɤ߹
if ((%main::setting || %main::span) && (!$main::setting{'target_path'} || ($main::setting{'target_path'} && $main::setting{'target_path'} !~ /[<>]/ && $main::setting{'target_path'} !~ /\[url/i))) {
	if (%main::span) {
		$main::setting{'span_start'} = $this->get_stat_span(%{$main::span{'start'}});
		$main::setting{'span_end'} = $this->get_stat_span(%{$main::span{'end'}});
		($main::setting{'span_start'},$main::setting{'span_end'}) = ($main::setting{'span_end'},$main::setting{'span_start'}) if $main::setting{'span_start'} && $main::setting{'span_end'} && $main::setting{'span_start'} > $main::setting{'span_end'};
	}
	$main::setting{'target_path'} =~ s/[<>"]//gs if defined $main::setting{'target_path'} && $main::setting{'target_path'};
	$main::setting{'client_target'} =~ s/[<>"]//gs if defined $main::setting{'client_target'} && $main::setting{'client_target'};
	$main::setting{'client_referer'} =~ s/[<>"]//gs if defined $main::setting{'client_referer'} && $main::setting{'client_referer'};
	$main::setting{'click_target'} =~ s/[<>"]//gs if defined $main::setting{'click_target'} && $main::setting{'click_target'};

	if (defined $main::targetreset && $main::targetreset) {
		foreach (0..10) {
			$main::setting{'recenttarget_' . $_} = '';
		}
	} elsif (defined $main::setting{'target_path'} && $main::setting{'target_path'}) {
		my(%temp);
		$this->import_db($default::preference_dir . '/stat',\%temp,1,'recenttarget');
		my($n,$e,@recenttarget);
		foreach (sort keys %{$temp{'recenttarget'}}) {
			push(@recenttarget,$temp{'recenttarget'}{$_}) if defined $temp{'recenttarget'}{$_} && $temp{'recenttarget'}{$_} ne '';
			$e++ if $temp{'recenttarget'}{$_} eq $main::setting{'target_path'};
		}
		unshift(@recenttarget,$main::setting{'target_path'}) if !defined $e || !$e;
		$n = 0;
		foreach (@recenttarget) {
			last if $n > 9;
			$main::setting{'recenttarget_' . $n++} = $_;
		}
	}
	foreach my $k (keys %main::setting) {
		delete $main::setting{$k} if $k =~ /_u$/ && $main::setting{$k} && $this->is_nan($main::setting{$k});
	}

	$this->write_db($default::preference_dir . '/stat',\%main::setting,'','',\%setting::stat,1);

#ɤ߹ߤΤ
} else {
	$this->import_db($default::preference_dir . '/stat',\%setting::stat,1);
}

if (defined $setting::stat{'target'}{'path'} && $setting::stat{'target'}{'path'}) {
	@setting::target = $this->mk_regexp($setting::stat{'target'}{'path'},$setting::stat{'target'}{'regexp'});
}
if (defined $setting::stat{'client'}{'target'} && $setting::stat{'client'}{'target'}) {
	@setting::target_client = $this->mk_regexp($setting::stat{'client'}{'target'},$setting::stat{'client'}{'regexp'});
}
if (defined $setting::stat{'client'}{'referer'} && $setting::stat{'client'}{'referer'}) {
	@setting::target_client_referer = $this->mk_regexp($setting::stat{'client'}{'referer'},$setting::stat{'client'}{'refererRegexp'});
}
if (ref $setting::stat{'recenttarget'} eq 'HASH' && %{$setting::stat{'recenttarget'}}) {
	foreach (sort keys %{$setting::stat{'recenttarget'}}) {
		push(@setting::recenttarget,$setting::stat{'recenttarget'}{$_}) if defined $setting::stat{'recenttarget'}{$_} && $setting::stat{'recenttarget'}{$_} ne '';
	}
	undef %{$setting::stat{'recenttarget'}};
}
}

sub mk_regexp ($$;$) {
my($this,$key,$regexp) = @_;
my @target = grep($_ ne '',split(/\s+/,$key));
if ($regexp) {
	map($_ = '^' . quotemeta($_) . '$',@target) if $regexp == 2;
} else {
	map($_ = quotemeta $_,@target);
}
return @target;
}

sub get_stat_span ($@) {
my($this,%span) = @_;
return '' unless $span{'year'} && $span{'mon'} && $span{'mday'};
if ($this->is_impossible_mday($span{'year'},$span{'mon'},$span{'mday'})) {
	my @mdays = (0,31,28,31,30,31,30,31,31,30,31,30,31);
	$span{'mday'} = $mdays[$span{'mon'}];
}
return sprintf("%.4d", $span{'year'}) . sprintf("%.2d", $span{'mon'}) . sprintf("%.2d", $span{'mday'});
}

sub _stat_setting ($) {
my $this = shift;
return;
}

######################################################################
# إå/եå
sub print_header ($) {
my $this = shift;
if ((!defined $setting::download || $setting::download ne 'no') && defined $setting::stat{'download'} && $setting::stat{'download'} eq 'csv') {
	#$this->print_http_header('text/comma-separated-values');
	$this->print_http_header('application/csv');
} elsif ((!defined $setting::download || $setting::download ne 'no') && defined $setting::stat{'download'} && $setting::stat{'download'} eq 'tsv') {
	#$this->print_http_header('text/tab-separated-values');
	$this->print_http_header('application/tab-separated-values');
} else {
	$this->push_window_title($this->stat_title);
	$this->print_page_header('stat');
}
}

sub print_footer ($) {
my $this = shift;
# ڡեå
$this->print_page_footer('stat') if (defined $setting::download && $setting::download eq 'no') || !$setting::stat{'download'} || ($setting::stat{'download'} ne 'csv' && $setting::stat{'download'} ne 'tsv');
}

######################################################################
# եå
sub log_check ($) {
#no warnings qw(numeric);
my $this = shift;
my($time,@localtime,$logend,$from,$to);
$this->{'access_log_size'} = 0;

# ǥ쥯ȥΥ
opendir(LOG, $default::access_log);
@{$this->{'access_log'}} = grep($_ =~ /\d{8}\.csv$/ && ($this->{'access_log_size'} += -s $default::access_log . '/' . $_),readdir(LOG));
closedir(LOG);

# Υե/
$time = time;
$time += 86400 if defined $setting::general{'realtime'} && $setting::general{'realtime'};
@localtime = localtime($time);
$logend = ($localtime[5] + 1900) . sprintf("%.2d", $localtime[4] + 1) . sprintf("%.2d", $localtime[3]);
@{$this->{'access_log'}} = sort {$a <=> $b} grep(eval{$_ < $logend},@{$this->{'access_log'}});

if (@{$this->{'access_log'}}) {
	$this->{'year_start'} = $1 if ${$this->{'access_log'}}[0] =~ /^([0-9]{4})/;
	$this->{'year_end'} = $1 if ${$this->{'access_log'}}[$#{$this->{'access_log'}}] =~ /^([0-9]{4})/;

	$this->{'access_log_start'} = $1 if $this->{'access_log'}->[0] =~ /^([0-9]{8})/;
	$this->{'access_log_end'} = $1 if $this->{'access_log'}->[$#{$this->{'access_log'}}] =~ /^([0-9]{8})/;

	if ($setting::stat{'span'}{'end'} == 0 || $setting::stat{'span'}{'end'} >= $logend) {
		$setting::stat{'span'}{'end'} = $this->{'access_log_end'};
		$this->{'noEnd'} = 1;
	}
	@{$this->{'access_log'}} = grep(eval{$_ >= $setting::stat{'span'}{'start'}} && eval{$_ <= $setting::stat{'span'}{'end'}},@{$this->{'access_log'}});

} else {
	push(@{$this->{'dialog'}},'ϲǽʥե뤬¸ߤޤ');
	$this->{'noLog'} = 1;
}
}

sub submit_button ($$$$$@) {
my($this,$src,$width,$height,$alt,$onclick,%query) = @_;
my($name,$form);
if (%query) {
	$name = $this->add_query('url',\%query);
	$name =~ s/^\&//;
	$name =~ s/\&/\&amp;/g;
}
if ($src =~ /\.(gif|jpg|jpeg|png)$/i) {
	$form = '<input type="image"';
	$form .= ' name="' . $name . '"' if $name;
	$form .= ' width="' . $width . '"' if $width;
	$form .= ' height="' . $height . '"' if $height;
	$form .= ' src="' . (($cgi::output) ? $this->base_change($src,$cgi::output,$cgi::output_option) : $src) . '"';
	$form .= ' title="' . $alt . '" alt="' . $alt . '"' if defined $alt && $alt ne '';
	$form .= ' onclick="' . $onclick . '"' if defined $onclick && $onclick ne '';
	$form .= ' border="0" value="1" />';
} else {
	$form = '<input type="submit" name="' . $name . '" value="' . $alt . '"' . ((defined $onclick && $onclick ne '') ? ' onclick="' . $onclick . '"' : '') . ' />';
}
return $form;
}

sub tie_title_db {
my $this = shift;
return if !$setting::general{'getTitle'};
require CMONOS::CGI_Lib::HTTP_Client;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
tie(%{$this->{'url_to_title'}}, $env::dbm_file, $default::preference_dir . '/url_to_title', O_RDWR | O_CREAT, $env::dbm_mode);
}

sub untie_title_db {
my $this = shift;
return if !$setting::general{'getTitle'};
untie(%{$this->{'url_to_title'}});
}

sub url_to_title ($$$;$) {
my($this,$url,$site,$redirect) = @_;
return $this->jfold($this->escape($url),40,'r',0,'<wbr />') if !$url || $url !~ m!^https?://!i;
my($keyword,$cgi_url,$target_url,$title);
if ($url =~ /^(.*)\?(.*)$/) {
	$cgi_url = $1;
	$keyword = $this->query_to_keywords($2);
	$target_url = ($keyword || ($setting::general{'getTitle'} && $setting::general{'getTitle'} eq 'static')) ? 
		(($url =~ m!^http://www\.google\.[a-z\.]+/hws/search\?.*\&?(client=[^=\&]+)!) ? $cgi_url . '?' . $1 : $cgi_url)
		: $this->url_filter($url);
} else {
	$target_url = $url;
}
if ($setting::general{'getTitle'} && ref tied %{$this->{'url_to_title'}}) {
	if ($this->{'url_to_title'}{$target_url}) {
		$title = $this->{'url_to_title'}{$target_url};
	} else {
		my $res = HTTP_Client->new->request('GET' => $target_url);
		my $content;
		$content = $res->content('euc') if $res->is_success;
		if ($content && (($setting::general{'getShortTitle'} && $content =~ m/<meta name="title" content="([^">]+?)" \/>/si) || $content =~ m/<title(?!\w)[^>]*>(.*?)<\/title(?!\w)[^>]*>/si || $content =~ m/<h[1-6](?!\w)[^>]*>(.*?)<\/h[1-6]>/si)) {
			$title = $this->unescape($1);
			if ($target_url =~ m!/new/$! && $content =~ /<base href="[^"]+" \/>/ && $content =~ m/<meta name="title" content="([^">]+?)" \/>/si) {
				my $shorttitle = $this->unescape($1);
				$title =~ s/$shorttitle/ǿ/g;
			} elsif ($target_url =~ m!/start\.cgi$!) {
				unless ($title =~ s/(\s*[:\|\-]\s*|)\d{4}ǯ\d{1,2}( \d|\d{1,2}\(.*?\)|)//) {
					if ($setting::general{'getTitle'} && $setting::general{'getTitle'} eq 'static' && $content =~ m/<meta name="title" content="([^">]+?)" \/>/si) {
						my $shorttitle = $1;
						$title =~ s/(\s*[:\|\-]\s*|)$shorttitle//g;
					}
				}
			}
		}
		$title = $this->query_decode($target_url) if !$title;
		undef $content;
		undef $res;
		$this->{'url_to_title'}{$target_url} = $title;
	}
} else {
	$title = $cgi_url || $url;
	$title =~ s!^https?://!!i if $site;
	$title = $this->query_decode($title);
}
$title .= '(' . $keyword . ')' if $keyword;
$url =~ s!^(http://www.google.[\.\w]+/)url\?!$1search\?!;
$url =~ s/\%2B/\+/sg if $url =~ s/\%25([0-9a-fA-F][0-9a-fA-F])/\%$1/sg;
return '<div class="url-info"><strong><a href="' . $this->escape(($redirect) ? $this->redirect($url) : $url) . '" target="_blank">' . $this->jfold($this->escape_without_html_entity($title),40,'r',0,'<wbr />') . '</a></strong>' . (($title ne $url) ? '<div class="url">' . $this->jfold($this->escape($url),40,'r',0,'<wbr />') . '</div>' : '');
}

sub redirect ($$) {
my($this,$url) = @_;
return $url if !$setting::general{'redirect'};
my $encoded_url = $this->url_encode($url);
my $redirect_url = $setting::general{'redirect'};
return ($redirect_url =~ s/\%u/$encoded_url/g) ? $redirect_url : $url;
}

sub domain_info ($$;$) {
my($this,$host,$marker) = @_;
my $text = ($marker) ? $marker : $this->jfold($host,30,'r',0,'<wbr />');
if ($host =~ /\.([a-zA-Z]+)$/) {
	my $domain = 'http://www.' . $this->host_to_domain($host) . '/';
	$text = '<a href="' . $this->redirect($domain) . '" target="_blank" title="ɥᥤ򸵤˥֥Ȥǧ(¸ߤʤ⤢ޤ)">' . $text . '</a>';
} elsif ($marker) {
	$text = '';
}
if ($setting::general{'whois'} && $setting::general{'whois'} =~ /\%s/) {
	my $url = $setting::general{'whois'};
	my $domain = ($setting::stat{'client'}{'option'}) ? $host : $this->host_to_domain($host);
	$url =~ s/\%s/$domain/g;
	$text .= ' <a href="' . $this->escape($this->redirect($url)) . '" target="_blank" title="ɥᥤˤĤ WHOIS Ĵ٤">[?]</a>';
}
return $text;
}

sub host_to_domain ($$) {
my($this,$host) = @_;
return ($host =~ /([%\w\-]+\.[a-zA-Z]{3,})$/ || $host =~ /([%\w\-]+\.[a-zA-Z]{2,3}\.[a-zA-Z]{2})$/ || $host =~ /([%\w\-]+\.[a-zA-Z]{2})$/) ? $1 : $host;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;					#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 1;					#ơ֥ɤ߹
	$setting::page = 1;						#ڡɤ߹

	#省
	$setting::security_key = 'stat';			#ǥեȥƥ
	$setting::key = 'stat';					#ڡꥭ

	#å
	$cookie::id_enabled = 1 if !$cookie::id_enabled;						#ID󥯥åɤ߹

	#ɬܥե
	@setting::form = ('k','m');

}


1;

