package TracerReport;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
######################################################################
# ˬԤ­׺Ƹ⥸塼
# TracerReport.pm ver1.0.4
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ20011-01-27
######################################################################
# 
# 	$$data[0]	֡hhmmss
# 	$$data[1]	IPREMOTE_HOST
# 	$$data[2]	ե
# 	$$data[3]	饤ȴĶHTTP_USER_AGENT
# 	$$data[4]	饤ȼHTTP_ACCEPT_LANGUAGE
# 	$$data[5]	󥯸HTTP_REFERER
# 	$$data[6]	ɥ¦
# 	$$data[7]	ɥ¦ι⤵
# 	$$data[8]	Ѳǽʥ꡼
# 	$$data[9]	Ѳǽʥ꡼⤵
sub log_stat ($$$) {
my($this,$date,$data) = @_;
return 0 if !defined $$data[1];
$this->{'target_ua'} = $$data[3] if !$this->{'target_ua'} && $$data[1] eq $setting::stat{'tracer'}{'target'};
if ($this->{'target_ua'} && $setting::stat{'tracer'}{'target'} =~ /proxy\w+\.docomo\.ne\.jp/) {
	return 0 if $this->{'target_ua'} ne $$data[3];
} elsif ($$data[1] ne $setting::stat{'tracer'}{'target'}) {
	return 0;
}

my $atime = timelocal(substr($$data[0],4,2),substr($$data[0],2,2),substr($$data[0],0,2),substr($date,6,2),(substr($date,4,2)-1),substr($date,0,4));
$this->{'target_referer'}->{$atime} = $$data[5] if $$data[5] eq '' || !ref $this->{'target_atime'} || $$data[5] ne $this->{'target_request'}->{$this->{'target_atime'}->[$#{$this->{'target_atime'}}]};
$this->{'target_request'}->{$atime} = $$data[2];
$this->{'target_info'} = [$$data[3],$$data[4],$$data[6],$$data[7],$$data[8],$$data[9]] if !ref $this->{'target_info'};
push (@{$this->{'target_atime'}},$atime);

return 1;
}

sub _stat_setting ($) {
my $this = shift;
use Time::Local;
}

######################################################################
# ϴĶɲá
sub print_sub_stat_env ($) {
my $this = shift;
unless (ref $cgi::UserAgent) {
	require CMONOS::CGI_Lib::UserAgent;
	$cgi::UserAgent = UserAgent->new;
}
my @info = $cgi::UserAgent->get_user_agent_info($this->{'target_info'}[0]);
shift @info;
splice(@info,1,2,$info[1] . ' ' . $info[2]);
push(@info,$this->get_lang($1)) if $this->{'target_info'}[1] && $this->{'target_info'}[1] =~ /^([\w\-]+)/;
push(@info,'ɥ [' . $this->{'target_info'}[2] . '&times;' . $this->{'target_info'}[3] . ']') if $this->{'target_info'}[2] && $this->{'target_info'}[3];
push(@info,'꡼󥵥 [' . $this->{'target_info'}[4] . '&times;' . $this->{'target_info'}[5] . ']') if $this->{'target_info'}[4] && $this->{'target_info'}[5];
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('оIP');
print $this->{'infoTable'}->td(join(' / ',grep($_ =~ /\S/,@info)));
print $this->{'infoTable'}->_tr;
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('оIP');
print $this->{'infoTable'}->td(
	'<input type="text" name="setting:tracer_target" size="50" value="' . $this->escape($setting::stat{'tracer'}{'target'}) . '" />'
	. $this->submit_button($env::image_dir . '/stat/dog.gif',14,14,'­פƸޤ','','m','TracerReport','k','tracer') . ' ' . $this->domain_info($setting::stat{'tracer'}{'target'},'[site]')
);
print $this->{'infoTable'}->_tr;
}

######################################################################
# ϥȥ
sub stat_title ($) {
my $this = shift;
return 'ˬԤ­׺Ƹ';
}

######################################################################
# Ϸɽ
sub print_report ($) {
my $this = shift;
return if defined $this->{'noLog'} && $this->{'noLog'};
$this->tie_title_db;

#إå
if ($setting::stat{'download'} eq 'csv') {
	print $cgi::Jcode->set($this->stat_title . "\x0D\x0A" . $this->svjoin(',','','','ں߻','URL') . "\x0D\x0A",'euc')->sjis;
} elsif ($setting::stat{'download'} eq 'tsv') {
	print $cgi::Jcode->set($this->stat_title . "\x0D\x0A" . $this->svjoin("\x09",'','','ں߻','URL') . "\x0D\x0A",'euc')->sjis;
} else {
	print '<div class="note">=󥯸 =ǽΥڡ =ư</div>';
	$this->{'Table'}->set(
		'styleH' => 'text-align: center; width: 50px,text-align: center; width: 250px,text-align: center; width: 60px,text-align: center; width: 400px,text-align: center; width: 60px',
		'style0' => 'text-align: center; width: 50px,text-align: center; width: 250px,text-align: center; width: 60px,text-align: left; width: 400px,text-align: center; width: 60px'
	);
	print $this->{'Table'}->table;
	print $this->{'Table'}->tr;
	print $this->{'Table'}->td('');
	print $this->{'Table'}->td('');
	print $this->{'Table'}->td('ں߻');
	print $this->{'Table'}->td('URL');
	print $this->{'Table'}->td('åΨ');
	print $this->{'Table'}->_tr;
}

#Ϸ
if (ref $this->{'target_atime'}) {
	my($i);
	for ($i = 0; $i < @{$this->{'target_atime'}}; $i++) {
		my($mark,$atime,$length);
		$atime = $this->{'target_atime'}->[$i];
		if (($i + 1) < @{$this->{'target_atime'}} && !defined $this->{'target_referer'}->{$this->{'target_atime'}->[$i + 1]}) {
			$length = $this->{'target_atime'}->[$i + 1] - $atime;
		}
		if (defined $this->{'target_referer'}->{$atime}) {
			$this->{'Table'}->{'row'}++;
			$this->print_stat_report('','',$this->{'target_referer'}->{$atime},'',1) if defined $this->{'target_referer'}->{$atime} && $this->{'target_referer'}->{$atime};
			$mark = '';
		} else {
			$mark = '';
		}
		$this->print_stat_report($mark,$atime,$this->{'target_request'}->{$atime},$length) if defined $this->{'target_request'}->{$atime} && $this->{'target_request'}->{$atime};
	}
}
if ($setting::stat{'download'} eq 'csv' || $setting::stat{'download'} eq 'tsv') {
	print "\x0D\x0A";
} else {
	print $this->{'Table'}->_table;
}
$this->untie_title_db;
}

sub print_stat_report ($$$$;$$) {
my($this,$mark,$atime,$url,$length,$redirect) = @_;
$setting::page{'stat'}{'datetype'} = '' if !defined $setting::page{'stat'}{'datetype'};
$atime = ($atime) ? $this->date($atime,$setting::page{'stat'}{'datelimit'},'gmt' . $setting::page{'stat'}{'datetype'}) : '';
if (defined $length && $length) {
	$length = int($length / 3600) . ':' . sprintf("%.2d",int(($length % 3600) / 60)) . ':' . sprintf("%.2d",($length % 3600) % 60);
} else {
	$length = '';
}
if ($setting::stat{'download'} eq 'csv') {
	print $cgi::Jcode->set($this->svjoin(',',$mark,$atime,$length,$url) . "\x0D\x0A",'euc')->sjis;
} elsif ($setting::stat{'download'} eq 'tsv') {
	print $cgi::Jcode->set($this->svjoin("\x09",$mark,$atime,$length,$url) . "\x0D\x0A",'euc')->sjis;
} else {
	print $this->{'Table'}->tr;
	print $this->{'Table'}->td($mark);
	print $this->{'Table'}->td($atime);
	print $this->{'Table'}->td($length);
	print $this->{'Table'}->td((($url =~ m!^https?://!i) ? $this->url_to_title($url,0,$redirect): $this->escape($url)));
	if (grep(eval {$url =~ /\Q$_\E/},@default::target)) {
		print $this->{'Table'}->td($this->submit_button($env::image_dir . '/stat/node.gif',14,14,'Υե뤫Υ󥯤ΥåΨ󥭥󥰤ޤ','','m','ClickRatioReport','k','click','setting:click_target',$url));
	} else {
		print $this->{'Table'}->td();
	}
	print '</tr>';
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#ǥեȥ
	$main::k = 'tracer' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('tracer','TracerReport');

}


1;

