package LeafCounter;
require CMONOS::CGI_Lib::Field::Num;
@ISA = qw(Num);
use strict;
######################################################################
# եɥ⥸塼ʥåɴϢ
# LeafCounter.pm 1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2008-09-11
######################################################################
sub _set ($$) {
my($this,$setting) = @_;
$this->{'cols'} = 3;
$this->{'unit'} = ($default::english) ? '' : '';
return;
}

######################################################################
#	(0)-3 եDB
sub db ($) {
my $this = shift;
return 'thread_count';
}

######################################################################
#	(0)-8 obj->align;
sub align ($) {
my $this = shift;
return 'center';
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
my $this = shift;
return 0;
}

sub form {
my($this,$status,$original) = @_;
return '';
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my $this = shift;
delete $main::data{$this->{'id'}}{'str'};
return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
my($this,$str,$path,$c,$n,$db) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
my $sum = $this->sum_digit((defined $str && $str ne '') ? $str : $this->get_leaf_sum($n,$db));
return $this->field_tag(
	$this->style(
		'(' . $sum . ')',
		$this->{'style'},
		$this->{'fontsize'},
		$this->{'fontcolor'},
		$this->{'fontface'}
	)
);
}

sub get_leaf_sum ($$$) {
my($this,$n,$db) = @_;
my $sum = $db->{'thread_count'}->{$cgi::action->get_top($n,$db->{'tree'}->{$n})};
return ($sum) ? $sum : 0;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail {
my($this,$str,$path,$c,$n,$db) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return '' if (!defined $str || $str eq '') && !ref $db;
return '[' . $this->{'name'} . "]\x0A" . $this->sum_digit(((defined $str && $str ne '') ? $str : $this->get_leaf_sum($n,$db))) . "\x0A\x0A";
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text {
my($this,$str,$path,$c,$n,$db) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return '' if (!defined $str || $str eq '') && !ref $db;
return $this->sum_digit((defined $str && $str ne '') ? $str : $this->get_leaf_sum($n,$db));
}

sub sum_digit ($$) {
my($this,$sum) = @_;
if (defined $this->{'comma'} && $this->{'comma'}) {
	$sum =~ s/(\.\d{4,})/{my $d = $1;$d =~ s\/(\d{3})\/$1,\/g;$d}/ge;
	$sum =~ s/(\d{4,}(?=(\D|$)))/{my $d = $1;1 while $d =~ s\/(\d)(\d{3}(?=(\D|$)))\/$1,$2\/g;$d}/ge;
}
return $sum;
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$) {
my($this,$str) = @_;
return '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled) = @_;

#̾
my $name = 'data:' . $this->{'id'};

$this->print_field_info_form($name,1);

print '<fieldset>';
print '<legend>ɽ</legend>';
print '<label><input type="checkbox" name="' . $name . '_comma" id="' . $name . '_comma" value="1"' . ((defined $this->{'comma'} && $this->{'comma'}) ? ' checked="checked"' : '') . ' /> 头Ȥ˰̼ꤹ</label>';
print '</fieldset>';

if (!defined $html_disabled || !$html_disabled) {
	print '<fieldset>';
	print '<legend></legend>';
	print '<label><input type="checkbox" name="' . $name . '_searchOption" value="1"' . ((defined $this->{'searchOption'} && $this->{'searchOption'}) ? ' checked="checked"' : '') . ' /> ܤ</label>';
	print '</fieldset>';

	#ʸ
	$this->print_font_setting_form($name);
}
$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
$main::data{$this->{'id'} . '_searchOption'} = '' if !defined $main::data{$this->{'id'} . '_searchOption'} ||  $main::data{$this->{'id'} . '_searchOption'} eq '';
$main::data{$this->{'id'} . '_comma'} = '' if !defined $main::data{$this->{'id'} . '_comma'} ||  $main::data{$this->{'id'} . '_comma'} eq '';
return $this->is_valid_font_setting;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('xbb_leafcounter','LeafCounter','Ϣ');
}

1;
