package ViewSelector;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# եɥ⥸塼ɽڤؤܥ
# ViewSelector.pm 1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-06-14
######################################################################
sub set_my_type ($;$) {
my($v,$n) = @_;
if ($v) {
	if ($v =~ /tree/) {
		$ViewSelector::type = 'tree';
	} elsif ($v =~ /thread/) {
		$ViewSelector::type = 'articlelist';
	} elsif ($v =~ /article/) {
		if (defined $n && $n ne '') {
			$ViewSelector::type = 'article';
		} else {
			$ViewSelector::type = 'articlelist';
		}
	} else {
		$ViewSelector::type = 'list';
	}
} else {
	$ViewSelector::type = 'list';
}
}

sub _set ($$) {
my($this,$setting) = @_;
return if defined $ViewSelector::type && $ViewSelector::type;
if ($main::k eq 'viewer') {
	set_my_type($main::v,$main::n);
} elsif ($main::k =~ /tree/) {
	$ViewSelector::type = 'tree';
} else {
	$ViewSelector::type = 'list';
}
return;
}

######################################################################
#	(0)-3 եDB
sub db ($) {
my $this = shift;
return '';
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
my $this = shift;
return 0;
}

sub form {
my($this,$status,$original) = @_;
return '';
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my $this = shift;
delete $main::data{$this->{'id'}}{'str'};
return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
my($this,$str,$path,$c,$n,$db) = @_;
return $this->field_tag($this->get_tool_icon($n,$db));
}

sub has_content {
my $this = shift;
return 1;
}

sub get_tool_icon ($$$) {
my($this,$n,$db) = @_;
my($form,$info,$is_deleted,$top,$base_url,$settarget,$onclick,$dummy_window,$inline_flag,$word_flag,$form_flag);

if ($ViewSelector::type eq 'tree') {
	if (defined $this->{'icon'} && $this->{'icon'}) {
		$form .= '<div class="inline-toolbox">';
		$inline_flag = 1;
	} else {
		$word_flag = 1;
	}
}
$info = $db->{'tree'}->{$n};
$is_deleted = 1 if $info =~ /^d/;
$top = $cgi::action->get_top($n,$info);

if (!$word_flag && $setting::general{'postMethod'}) {
	$form_flag = 1;
	if (defined $cgi::output && $cgi::output) {
		$form .= $this->form_start(
			'key'	=>	'browse',
			'authorization'	=>	'disabled',
			'name'	=>	'tool_' . $n
		);
		$form .= '<input type="hidden" name="c" value="' . $this->escape($main::c) . '" />' if defined $main::c && $main::c ne '';
	} else {
		$settarget = 'cmonos.element.item(this.form).fixTarget();"' if $main::k ne 'viewer';
		$form .= $this->form_start(
			'key'	=>	'browse',
			'name'	=>	'tool_' . $n,
			'required'	=>	\@setting::form1
		);
	}
} else {
	$base_url = $cgi::path;
	if (defined $cgi::output && $cgi::output) {
		$base_url .= (defined $main::c && $main::c ne '') ? '?c=' . $main::c : '?s=';
	} else {
		$settarget = 'cmonos.element.item(this).fixTarget();' if $main::k ne 'viewer';
		my $query = $cgi::action->amp_escape($this->set_query('url',\@setting::form1));
		$base_url .= ($query) ? $query : '?s=';
	}
}
if (!defined $word_flag || !$word_flag) {
	if (defined $inline_flag && $inline_flag) {
		$form .= '<ul class="tools">';
	} else {
		my $style = '';
		$style .= 'text-align: ' . $this->{'align'} . ';' if defined $this->{'align'} && $this->{'align'};
		$style .= (($style) ? ' ' : '' ) . 'float: ' . $this->{'float'} . ';' if defined $this->{'float'} && $this->{'float'};
		$form .= '<ul class="tools"' . (($style ne '') ? ' style="' . $style . '"' : '') . '>';
	}
}

# ɽڤؤܥ
if (($this->{$ViewSelector::type . 'view'} || $this->{$ViewSelector::type . 'view'} eq '') && ($this->{'treeres'} || $this->{'listres'} || $this->{'articlelistres'} || $this->{'articleres'} || $this->{'treeres'} eq '' || $this->{'listres'} eq '' || $this->{'articlelistres'} eq '' || $this->{'articleres'} eq '')) {

	if (defined $word_flag && $word_flag) {
		my $url = $base_url . '&amp;n=' . $n . '&amp;t=' . $top;

		# ñɽ
		$form .= '<a href="' . $url . '&amp;m=Viewer&amp;k=viewer&amp;v=listarticle"' . (($settarget) ? ' onclick="' . $settarget . '"' : '') . '>[]</a>';
	
		# åɽ
		$form .= '<a href="' . $url . '&amp;m=Viewer&amp;k=viewer&amp;v=listthread"' . (($settarget) ? ' onclick="' . $settarget . '"' : '') . '>[å]</a>';
	
		# ĥ꡼ɽ
		$form .= '<a href="' . $url . '&amp;m=TreeView&amp;k=tree" target="treeViewer"' . (($main::k eq 'viewer') ? 'onclick="cmonos.window.open(\'treeViewer\',640,300);"' : '') . '>[ĥ꡼]</a>';

	} else {
		my($url);
		$url = $base_url if !defined $form_flag ||  !$form_flag;

		# ñɽ
		$form .= $cgi::action->view_switch_button('viewarticle','ñɽ',$url,{'n'=>$n,'t'=>$top,'v'=>'listarticle','m'=>'Viewer','k'=>'viewer'},'',$settarget);
	
		# åɽ
		$form .= $cgi::action->view_switch_button('viewthread','åɽ',$url,{'n'=>$n,'t'=>$top,'v'=>'listthread','m'=>'Viewer','k'=>'viewer'},'',$settarget);
	
		# ĥ꡼ɽ
		$form .= $cgi::action->view_switch_button(
			'viewtree',
			'ĥ꡼ɽ',
			$url,
			{'n'=>$n,'t'=>$top,'m'=>'TreeView','k'=>'tree'},
			'group-end',
			'cmonos.window.open(\'treeViewer\',640,300);',
			'treeViewer',
		);
	}
}
return $form . (($word_flag) ? '' : '</ul>' . (($form_flag) ? '</form>' : '') . (($inline_flag) ? '</div>' : '')) if $this->{$ViewSelector::type . 'edit'} eq '0' && $this->{$ViewSelector::type . 'res'} eq '0';


$onclick = 'cmonos.window.open(\'articleEditor\',640,480);';

# ܥ
if ($this->{$ViewSelector::type . 'edit'} || $this->{$ViewSelector::type . 'edit'} eq '') {

	if (defined $word_flag && $word_flag) {
		my($url);
		$url .= $base_url . '&amp;n=' . $n . '&amp;t=' . $top . '&amp;m=Editor&amp;k=editor&amp;v=' . $main::v;
		$url .= '&amp;opener=tree' if $main::k eq 'tree';
		$form .= ' ' if defined $form && $form ne '';

		# 
		if (!$cgi::output && $this->is_secure('remove')) {
			$form .= '<a href="' . $url . '&amp;rmthread=1" target="articleEditor" onclick="return confirm(\'ϼäޤ󡣤Υåɤ˺ޤ\') &amp;&amp; ' . $onclick . '">[åɺ]</a>';
		}

		# 
		if (!$cgi::output && (!$is_deleted && $this->is_secure('revise'))) {
			$form .= '<a href="' . $url . '&amp;delete=1" target="articleEditor" onclick="return confirm(\'ϼäޤ󡣤ε˺ޤ\') &amp;&amp; ' . $onclick . '">[]</a>' if !$cgi::output && $this->is_secure('delete',0,'revise');

		# 
			$form .= '<a href="' . $url . '" target="articleEditor" onclick="' . $onclick . '">[]</a>';
		}

	} else {
		my(%query,$url);
		%query = ('m'=>'Editor','k'=>'editor','v'=>$main::v,'n'=>$n,'t'=>$top);
		$query{'opener'} = 'tree' if $main::k eq 'tree';
		$url = $base_url if !$form_flag;

		# 
		if (!$cgi::output && $this->is_secure('remove')) {
			$form .= $cgi::action->view_switch_button('inputrmthread','åɺ',$url,{'rmthread'=>'1',%query},'group-end','return confirm(\'ϼäޤ󡣤Υåɤ˺ޤ\') &amp;&amp; ' . $onclick,'articleEditor');
		}

		# 
		if (!$cgi::output && (!$is_deleted && $this->is_secure('revise'))) {
			$form .= $cgi::action->view_switch_button('inputdelete','',$url,{'delete'=>'1',%query},'','return confirm(\'ϼäޤ󡣤ε˺ޤ\') &amp;&amp; ' . $onclick,'articleEditor') if !$cgi::output && $this->is_secure('delete',0,'revise');
		
		# 
			$form .= $cgi::action->view_switch_button('inputedit','',$url,\%query,'group-end',$onclick,'articleEditor');	
		}
	}
}

# 쥹ܥ
if (!$is_deleted && ($this->{$ViewSelector::type . 'res'} || !defined $this->{$ViewSelector::type . 'res'} || $this->{$ViewSelector::type . 'res'} eq '') && ((defined $setting::security{'inputchild'}{'passwordCheck'} && $setting::security{'inputchild'}{'passwordCheck'} eq 'nocheck') || (!$cgi::output && $this->is_secure('inputchild')))) {

	if (defined $word_flag && $word_flag) {
		my $url .= $base_url . '&amp;m=Editor&amp;k=editor&amp;parent=' . $n . '&amp;v=' . $main::v . '&amp;t=' . $top . (($main::p) ? '&amp;p=' . $main::p : '');
		$url .= '&amp;opener=tree' if $main::k eq 'tree';
		$form .= ' ' if defined $form && $form ne '';

		# 쥹
		$form .= '<a href="' . $url . '" target="articleEditor" onclick="' . $onclick . '">[ֿ]</a>';
	
	} else {
		my %query = ('m'=>'Editor','k'=>'editor','v'=>$main::v,'parent'=>$n,'t'=>$top);
		$query{'p'} = $main::p if $main::p;
		$query{'opener'} = 'tree' if $main::k eq 'tree';

		# 쥹
		$form .= $cgi::action->view_switch_button('inputres','ֿ',(($form_flag) ? '' : $base_url),\%query,'',$onclick,'articleEditor');
	}
}

if (!defined $word_flag ||  !$word_flag) {
	$form .= '</ul>';
	$form .= '</form>' if defined $form_flag && $form_flag;
	$form .= '</div>' if defined $inline_flag && $inline_flag;
}
return $form;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
my $this = shift;
return 0;
}

sub format_for_mail {
my($this,$str,$path,$c,$n,$db) = @_;
return '';
}

#---------------------------------------------------------------------
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail {
my($this,$str,$path,$c,$n,$db) = @_;
return $this->field_tag($this->get_tool_icon($n,$db));
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text_enabled ($) {
my $this = shift;
return 0;
}

sub format_for_text {
my($this,$str,$path,$c,$n,$db) = @_;
return '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$) {
my($this,$str) = @_;
return '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled) = @_;
my($name,$searchOption_checked,$comma_checked,$note);

#̾
$name = 'data:' . $this->{'id'};

$this->print_field_info_form($name,1);

print '<fieldset>';
print '<legend>ɽ</legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><span class="datatitle">ɽ</span></td>';
print '<td class="field">';

#ơ֥
require CMONOS::CGI_Lib::Table;
my $table = Table->new;
$table->set(
	'tableclass' => 'tooltable',
	'thenabled' => 'true',
	'trclass' => 'odd,even',
	'class0' => 'odd,even',
	'classF' => 'name',
	'style0' => 'text-align: center; width: 100px;'
);

#ɽ
print $table->table;
print $table->tr;
print $table->td('');
print $table->td('ɽڤؤ<br />ܥ');
print $table->td('<br />ܥ');
print $table->td('ֿ<br />ܥ');
print $table->_tr;
my %type_name = (
	'tree' => 'ĥ꡼ɽ',
	'list' => 'ɽ',
	'articlelist' => 'ɽ',
	'article' => 'ñɽ'
);
my($type);
foreach $type ('tree','list','articlelist','article') {
	print $table->tr;
	print $table->td($type_name{$type});
	my($icon);
	foreach $icon ('view','edit','res') {
		print $table->td(
			'<input type="checkbox" name="data:'
			. $this->{'id'} . '_' . $type . $icon . '" value="1"'
			. (($this->{$type . $icon} || $this->{$type . $icon} eq '') ? ' checked="checked"' : '') . ' />'
		);
	}
	print $table->_tr;
}
print $table->_table;
undef %type_name;
undef %{$table};
undef $table;

print '<div class="hints">ɤɽǤֿܥɽʤ硢ɽڤؤܥɽޤ</div>';
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_align"></label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_align','','',$this->{'align'},
	''			=>		'',
	'left'		=>		'',
	'center'	=>		'·',
	'right'		=>		''
);
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_float"></label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_float','','',$this->{'float'},
	''		=>		'',
	'left'		=>		'',
	'right'		=>		''
);
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">ץ</span></td>';
print '<td class="field"><label><input type="checkbox" name="' . $name . '_icon" value="1"' . (($this->{'icon'}) ? ' checked="checked"' : '') . ' /> ĥ꡼ɽ[ʸ]ǤϤʤɽ</label>';
print '</td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

$this->print_setting_save_button;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my($type);
foreach $type ('tree','list','articlelist','article') {
	my($icon);
	foreach $icon ('view','edit','res') {
		$main::data{$this->{'id'} . '_' . $type . $icon} = '0' if !defined $main::data{$this->{'id'} . '_' . $type . $icon} || !$main::data{$this->{'id'} . '_' . $type . $icon};
	}
}
$main::data{$this->{'id'} . '_icon'} = '' if !defined $main::data{$this->{'id'} . '_icon'} || !$main::data{$this->{'id'} . '_icon'};
return 1;
}

######################################################################
#	(7) obj->search_form;
sub search_form_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('xbb_viewselector','ViewSelector','ɽڤؤܥ');
}

1;
