package FieldSeparator;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# եɥ⥸塼ʥեɶڤ
# FieldSeparator.pm 1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-06-14
######################################################################
sub _set ($$) {
my($this,$setting) = @_;
$this->{'cols'} = 60;
return;
}

# --------------------------------------------------------------------
#	(0)-3 бDB
sub db ($) {
my $this = shift;
return '';
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
my $this = shift;
return 0;
}

sub form {
my($this,$status,$original) = @_;
my($form);
$form .= '</tbody></table>';
if (defined $this->{'hr'} && $this->{'hr'}) {
	$form .= '<hr class="field-separator"' . (($this->{'hrsize'}) ? ' size="' . $this->{'hrsize'} . '"' : '') . (($this->{'hrcolor'}) ? ' color="' . $this->{'hrcolor'} . '"' : '') . ' />';
}
if (defined $this->{'default'} && $this->{'default'} ne '') {
	my($font,$str);
	$str = $this->tag_fix($this->{'default'},2);
	$font = ' size="' . $this->{'formfontsize'} . '"' if defined $this->{'formfontsize'} && $this->{'formfontsize'} ne '';
	$font .= ' color="' . $this->{'formfontcolor'} . '"' if defined $this->{'formfontcolor'} && $this->{'formfontcolor'} ne '';
	$font .= ' face="' . $this->{'formfontface'} . '"' if defined $this->{'formfontface'} && $this->{'formfontface'} ne '';
	$str = '<font' . $font . '>' . $str . '</font>' if defined $font && $font ne '';
	if (defined $this->{'formstyle'} && $this->{'formstyle'} =~ /:/) {
		$form .= '<div class="separator-description" style="' . $this->{'formstyle'} . '">' . $str . '</div>';
	} elsif (defined $this->{'formstyle'} && $this->{'formstyle'} ne '') {
		$form .= '<div class="' . $this->{'formstyle'} . '">' . $str . '</div>';
	} else {
		$form .= '<div class="separator-description">' . $str . '</div>';
	}
}
$form .= '<table class="field-table"><tbody>';
return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my $this = shift;
return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format_enabled ($) {
my $this = shift;
return $this->{'formatEnabled'};
}

sub usual_format {
my($this,$str) = @_;
if ($this->{'formatEnabled'} && defined $this->{'default'} && $this->{'default'} ne '') {
	return $this->style(
		$this->tag_fix($this->{'default'},2),
		$this->{'style'},
		$this->{'fontsize'},
		$this->{'fontcolor'},
		$this->{'fontface'}
	);
} else {
	return '';
}
}

sub has_content {
my $this = shift;
return ($this->{'formatEnabled'} && defined $this->{'default'} && $this->{'default'} ne '') ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
my $this = shift;
return 1;
}

sub format_for_mail {
my($this,$str) = @_;
return '' if !$this->{'formatEnabled'};
my($mail);
$mail .= "\x0A";
$mail .= '------------------------------------------------------------' . "\x0A" if defined $this->{'hr'} && $this->{'hr'};
$mail .= $this->{'default'} . "\x0A" if defined $this->{'default'} && $this->{'default'};
$mail .= "\x0A";
return $mail;
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text_enabled ($) {
my $this = shift;
return $this->{'formatEnabled'};
}

sub format_for_text {
my($this,$str) = @_;
return $this->{'default'};
}

sub format_for_detail_enabled ($) {
my $this = shift;
return $this->{'formatEnabled'};
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled) = @_;
my($name);

#̾
$name = 'data:' . $this->{'id'};

$this->print_field_info_form($name,1);
print '<fieldset>';
print '<legend></legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">ڤ</span></td>';
print '<td class="field" cols="3"><label for="' . $name . '_hr"><input type="checkbox" name="' . $name . '_hr" id="' . $name . '_hr" value="1"' . ((defined $this->{'hr'} && $this->{'hr'}) ? ' checked="checked"' : '') . ' /> ڤɽ</label></td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_hrsize">ڤ</label></td>';
print '<td class="q-field">';

print $this->mk_select_menu(
	$name . '_hrsize','','',$this->{'hrsize'},
	''		=>		'',
	'1'		=>		'1',
	'2'		=>		'2',
	'3'		=>		'3',
	'4'		=>		'4',
	'5'		=>		'5',
	'6'		=>		'6',
	'7'		=>		'7',
	'8'		=>		'8',
	'9'		=>		'9',
	'10'	=>		'10'
);

print ' <span>ԥ</span></td>';
print '<td class="field-name"><label class="' . $name . '_hrcolor">ڤ</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_hrcolor" id="' . $name . '_hrcolor" value="' . $this->escape($this->{'hrcolor'}) . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'' . $name . '_hrcolor\',\'dom\')" style="background-color: ' . $this->escape($this->{'hrcolor'}) . '" onchange="cmonos.validate.field(this).asColor()" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'' . $name . '_hrcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'' . $name . '_hrcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'' . $name . '_hrcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'' . $name . '_hrcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_default">ڤʸ</label></td>';
print '<td class="field" colspan="3">';
print '<textarea name="' . $name . '_default" id="' . $name . '_default" cols="56" rows="6" wrap="soft" title="եɶڤʸꤷޤ">' . $this->escape($this->{'default'}) . '</textarea>';
print '</td>';
print '</tr>';
print '<tr><td class="field-name"><label for="' . $name . '_formfontsize">ʸʸ</label></td>';
print '<td class="q-field">';

print $this->mk_select_menu(
	$name . '_formfontsize','','',$this->{'formfontsize'},
	''		=>		'',
	'1'		=>		'',
	'2'		=>		'侮',
	'3'		=>		'ɸ',
	'4'		=>		'礭',
	'5'		=>		'礭',
	'6'		=>		'礭',
	'7'		=>		'礭'
);

print '</td>';
print '<td class="field-name"><label for="' . $name . '_formfontcolor">ʸʸ</label></td>';
print '<td class="q-field">';
print '<input type="text" name="' . $name . '_formfontcolor" id="' . $name . '_formfontcolor" value="' . $this->escape($this->{'formfontcolor'}) . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'' . $name . '_formfontcolor\',\'dom\')" style="background-color: ' . $this->escape($this->{'formfontcolor'}) . '" onchange="cmonos.validate.field(this).asColor()" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'' . $name . '_formfontcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'' . $name . '_formfontcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'' . $name . '_formfontcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'' . $name . '_formfontcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_formfontface">ʸե</label></td>';
print '<td class="field" colspan="3"><input type="text" name="' . $name . '_formfontface" id="' . $name . '_formfontface" value="' . $this->escape($this->{'formfontface'}) . '" size="56" /></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_formstyle">ʸɽ</label></td>';
print '<td class="field" colspan="3">';
print '<input type="text" name="' . $name . '_formstyle" id="' . $name . '_formstyle" value="' . $this->escape($this->{'formstyle'}) . '" size="56" />';
print '<div class="note">ΥեɤΥꤷƲ</div>';
print '<div class="note">":" ޤޤʤϥ饹Ȳᤵޤ</div>';
print '</td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

#ʸ
if (!defined $html_disabled ||  !$html_disabled) {
	print '<fieldset><legend>ɽ</legend>';
	print '<label><input type="checkbox" name="' . $name . '_formatEnabled" value="1"' . (($this->{'formatEnabled'}) ? ' checked="checked"' : '') . ' /> ˤʸɽ(ڤɽޤ)</label>';
	print '</fieldset>';
	$this->print_font_setting_form($name);
}
$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my $is_valid = $this->is_valid_font_setting;

#åܥåк
$main::data{$this->{'id'} . '_hr'} = '' if !defined $main::data{$this->{'id'} . '_hr'} ||  $main::data{$this->{'id'} . '_hr'} eq '';
$main::data{$this->{'id'} . '_formatEnabled'} = '' if !defined $main::data{$this->{'id'} . '_formatEnabled'} ||  $main::data{$this->{'id'} . '_formatEnabled'} eq '';

#Ⱦѱѿ
$main::data{$this->{'id'} . '_formstyle'} = $this->z_to_h($main::data{$this->{'id'} . '_formstyle'},'euc') if defined $main::data{$this->{'id'} . '_formstyle'} && $main::data{$this->{'id'} . '_formstyle'};

if ($main::data{$this->{'id'} . '_hrcolor'} ne '' && $this->is_invalid_color($main::data{$this->{'id'} . '_hrcolor'})) {
	push(@{$cgi::action->{'dialog'}},'ڤ򹹿ǤޤǤǧƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_hrcolor'};
	$is_valid = 0;
}
if ($main::data{$this->{'id'} . '_formfontcolor'} ne '' && $this->is_invalid_color($main::data{$this->{'id'} . '_formfontcolor'})) {
	push(@{$cgi::action->{'dialog'}},'ʸʸ򹹿ǤޤǤǧƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_formfontcolor'};
	$is_valid = 0;
}

return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub search_form_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('z_separator','FieldSeparator','եɶڤ');
}

1;
