package FileUL;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# ե⥸塼ʥեźա
# FileUL.pm 1.1.9
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-05-20
######################################################################
#	(0)-8 obj->align;
sub align ($) {
my $this = shift;
return 'center';
}

######################################################################
sub __set ($$) {
my($this,$setting) = @_;
if (ref $setting && defined $setting->{'mimetype'} && $setting->{'mimetype'} ne '') {
	undef %{$this->{'ext_type'}};
	undef %{$this->{'type_ext'}};
	undef %{$this->{'mimename'}};
	delete $this->{'ext_type'};
	delete $this->{'type_ext'};
	delete $this->{'mimename'};
	my @mime = split(/\x0A|,\s*/,$$setting{'mimetype'});
	foreach my $type (@mime) {
		next if !defined $type || $type eq '';
		if ($type =~ /^([^:]+):([^:]+)[:]{0,1}([^:]*)$/) {
			$this->{'ext_type'}{$2} = $1;
			$this->{'type_ext'}{$1} = $2;
			$this->{'mimename'}{$2} = ($3 ne '') ? $3 : $2;
		}
	}
}
unless (ref $cgi::Image) {
	require CMONOS::CGI_Lib::Image;
	$cgi::Image = Image->new;
}

#ʣǤϿ
$this->{'elements'} = 1;

$this->___set($setting);
return;
}

sub ___set ($$) {
my($this,$setting) = @_;
$this->{'maxsize'} = 128000 if !$this->{'maxsize'};

#ե륢åץ
$cgi::enctype_multipart = 1;
}

######################################################################
# obj->image(path[,\data,option])
#		եбɽ뤿Υ֤ޤ
#		3232ǡenv::iconDirꤷǥ쥯ȥˤʤФʤޤ
sub image ($;$$$$) {
my($this,$path,$data,$embed_option,$align,$valign) = @_;
return (($this->{'is_temporary_data'} || $path) && ref $data && $data->{'type'}) ? $this->_image($path,$data,$embed_option,$align,$valign,$this->{'id'} . '.') : '';
}

sub _image ($;$$$$$) {
my($this,$path,$data,$embed_option,$align,$valign,$prefix) = @_;
my($out,$original_dir,$file_name,$icon_dir,$icon_image,$file_type,$attribute,$div_flag,$size,$previewpath);
$prefix = '' if !defined $prefix;
if ($data->{'previewtype'}) {
	my $ppath = ($this->{'is_temporary_data'} && $this->{'is_posted_preview'}) ? $cgi::input->get_public_clipboard : $path;
	$ppath = $this->base_change($ppath,$cgi::output,$cgi::output_option) if $cgi::output || $cgi::output_option;
	$previewpath = $ppath . '/' . $prefix . 'preview.' . $data->{'previewtype'};
}
$path = $cgi::input->get_public_clipboard if $this->{'is_temporary_data'} && $this->{'is_posted_file'};
$original_dir = $path;
$size = -s $path . '/' . $prefix . ((defined $data->{'name'} && $data->{'name'} ne '' && $data->{'name'} !~ m!/!) ? $data->{'name'} . '.' : '') . $data->{'type'};
if (!$size) {
	return '';
} elsif ($size >= 1000000) {
	$size = $this->digit(int(($size + 50000)/100000)/10) . 'MB';
} elsif ($size >= 1000) {
	$size = int(($size + 500)/1000) . 'KB';
} else {
	$size .= 'B';
}
$path = $this->base_change($path,$cgi::output,$cgi::output_option) if $cgi::output || $cgi::output_option;
$file_name = $prefix . ((defined $data->{'name'} && $data->{'name'} ne '' && $data->{'name'} !~ m!/!) ? $data->{'name'} . '.' : '') . $data->{'type'};
$path = $path . '/' . $file_name;
$data->{'border'} = 0 if !defined $data->{'border'};
$file_type = (defined $data->{'type'}) ? lc $data->{'type'} : '';
$embed_option = '' if !defined $embed_option;
$align = '' if !defined $align;
$valign = '' if !defined $valign;
$div_flag = (defined $valign && ($valign eq 'top' || $valign eq 'bottom')) ? 1 : 0;

#ץӥ塼¸ߤ
if (defined $data->{'previewtype'} && $data->{'previewtype'}
	 && (!defined $this->{'icon_type'} || $this->{'icon_type'} ne 'image' || $file_type !~ /^(gif|jpg|jpeg|png)$/i)
	 && (!defined $this->{'thumbnail'} || $this->{'thumbnail'} ne 'no')
	 && (
			((!$this->{'html5Enabled'} || !grep($_ eq $file_type,@Common::html5_video)) && !grep($_ eq $file_type,'flv',(($this->{'useFlash'}) ? ('mp3','mp4') : ())))
		 || !$data->{'width'} || ($this->{'maxwidth'} && $data->{'width'} > $this->{'maxwidth'})
		 || !$data->{'height'} || ($this->{'maxheight'} && $data->{'height'} > $this->{'maxheight'})
		)
	) {
	my $title = (defined $data->{'title'}) ? $this->escape_without_html_entity($data->{'title'}) . '(' . $size . ')' : $size;
	$title =~ s/[\x0A\x0D]//sg;
	if (!$this->{'icon_type'}) {
		$out .= '<div class="object"' . (($align ne '') ? ' style="text-align: ' . $align . '"' : '') . '>' if defined $div_flag && $div_flag;
		$out .= '<a href="' . $path . '"';
		if ($this->{'rel'} && grep($_ eq $file_type,'gif','jpg','png')) {
			$out .= ' rel="' . $this->{'rel'} . '"';
		} elsif (grep($_ eq $file_type,'gif','jpg','png',@Common::html5_audio,@Common::qt_plug,@Common::image_plug,@Common::sound_plug)) {
			$out .= $this->set_fileviewer_window($data,640,480,((@Common::qt_plug && grep($_ eq $file_type,@Common::qt_plug)) ? 48 : 0));
		}
		$out .= ' title="' . $title . '">';
	}
	$out .= '<img src="' . $previewpath . '"';
	$out .= ' width="' . $data->{'previewwidth'} . '"' if defined $data->{'previewwidth'} && $data->{'previewwidth'};
	$out .= ' height="' . $data->{'previewheight'} . '"' if defined $data->{'previewheight'} && $data->{'previewheight'};
	$out .= ' border="' . $data->{'border'} . '"' if defined $data->{'border'} && $data->{'border'} ne '';
	$out .= ' alt="' . $title . '" title="' . $title . '"';
	$out .= ' style="float: ' . $align . '"' if !$div_flag && $align ne '';
	$out .= ' />';
	if (!$this->{'icon_type'}) {
		$out .= '</a>';
		$out .= '</div>' if $div_flag;
	}
	return $out;

#ե
} elsif ($file_type =~ /^(gif|jpg|jpeg|png)$/i) {
	my $max_width = (defined $this->{'icon_type'} && $this->{'icon_type'} eq 'preview' && $this->{'previewwidthlimit'} && (!$this->{'maxwidth'} || $this->{'previewwidthlimit'} < $this->{'maxwidth'})) ? $this->{'previewwidthlimit'} : $this->{'maxwidth'};
	my $max_height = (defined $this->{'icon_type'} && $this->{'icon_type'} eq 'preview' && $this->{'previewheightlimit'} && (!$this->{'maxheight'} || $this->{'previewheightlimit'} < $this->{'maxheight'})) ? $this->{'previewheightlimit'} : $this->{'maxheight'};
	my $url = (defined $data->{'title'} && !$this->is_invalid_url($data->{'title'})) ? $this->escape_without_html_entity($data->{'title'}) : '';
	return ((!$this->{'icon_type'} && $div_flag) ? '<div class="object"' . (($align ne '') ? ' style="text-align: ' . $align . '"' : '') . '>' : '') . (($url) ? '<a href="' . $url . '" target="_blank">' : '') . $cgi::Image->image_tag($path,$data->{'width'},$data->{'height'},$data->{'border'},((defined $data->{'title'} && !$url) ? $data->{'title'} : ''),((!$this->{'icon_type'} && !$div_flag && $align ne '') ? ' style="float: ' . $align . '"' : ''),$max_width,$max_height,'','',(($url) ? 1 : 0)) . (($url) ? '</a>' : '') . ((!$this->{'icon_type'} && $div_flag) ? '</div>' : '');

#Ѥ˽񤭽Ф碪μ
} elsif ($this->{'icon_type'}) {


#ʬäƤե(QT etc)
} elsif ($data->{'width'} && (!$this->{'maxwidth'} || ($this->{'maxwidth'} && $data->{'width'} <= $this->{'maxwidth'}))
	 && $data->{'height'} && (!$this->{'maxheight'} || ($this->{'maxheight'} && $data->{'height'} <= $this->{'maxheight'}))
	 && grep($_ eq $file_type,(@Common::qt_plug,@Common::image_plug,'flv'))) {
	my $title = (defined $data->{'title'}) ? $this->escape_without_html_entity($data->{'title'}) : '';
	$out .= '<div class="object"' . (($align ne '') ? ' style="' . (($div_flag) ? 'text-align' : 'float') . ': ' . $align . '"' : '') . '>';

	#Flash
	if ($file_type eq 'swf') {
		$out .= '<object type="application/x-shockwave-flash" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="' . $data->{'width'} . '" height="' . $data->{'height'} . '"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= ' ' . $embed_option if $embed_option ne '';
		$out .= '>';
		$out .= '<param name="movie" value="' . $path . '"></param>';
		$out .= '<param name="quality" value="autohigh"></param>';
		$out .= '<param name="salign" value="TL"></param>';
		$out .= '<embed type="application/x-shockwave-flash" src="' . $path . '" width="' . $data->{'width'} . '" height="' . $data->{'height'} . '" quality="autohigh" salign="TL" pluginspage="http://get.adobe.com/flashplayer/"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= ' ' . $embed_option if $embed_option ne '';
		$out .= '></embed></object>';
	
	#Director
	} elsif ($file_type eq 'dcr') {
		$out .= '<object type="application/x-director" classid="clsid:166B1BCA-3F9C-11CF-8075-444553540000" width="' . $data->{'width'} . '" height="' . $data->{'height'} . '"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= ' ' . $embed_option if $embed_option ne '';
		$out .= '>';
		$out .= '<param name="src" value="' . $path . '"></param>';
		$out .= '<param name="swStretchStyle" value="stage"></param>';
		$out .= '<param name="swRemote" value="swSaveEnabled=\'true\' swVolume=\'true\' swRestart=\'true\' swPausePlay=\'true\' swFastForward=\'true\' "></param>';
		$out .= '<param name="bgColor" value="#cccccc"></param>';
		$out .= '<param name="swStretchHAlign" value="Left"></param>';
		$out .= '<param name="swStretchVAlign" value="Top"></param>';
		$out .= '<embed src="' . $path . '" bgcolor="#cccccc" swstretchhalign="Left" swstretchvalign="Top" width="' . $data->{'width'} . '" height="' . $data->{'height'} . '" swremote="swSaveEnabled=\'true\' swVolume=\'true\' swRestart=\'true\' swPausePlay=\'true\' swFastForward=\'true\' " swstretchstyle="stage" type="application/x-director" pluginspage="http://get.adobe.com/shockwave/"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= ' ' . $embed_option if $embed_option ne '';
		$out .= '></embed></object>';
	
	#FLV
	} elsif ($file_type eq 'flv' || ($this->{'useFlash'} && $file_type eq 'mp4')) {
		my $videotag_enabled;
		my $player = (($cgi::output || $cgi::output_option) ? $this->base_change($env::javascript,$cgi::output,$cgi::output_option) : $env::javascript) . '/player.swf';
		my $flash_vars = $this->escape($this->url_encoded_query({
			'path' => $this->base_change($original_dir . '/' . $file_name,$env::javascript . '/player',$cgi::output_option),
			'type' => $file_type,
			'frontcolor' => 'FFFFFF',
			'backcolor' => '000000',
			'fullscreen' => 'true',
			(($data->{'previewtype'}) ? ('thumbnail' => $previewpath) : ())
		}));
		if (($this->{'useFlash'} && $file_type eq 'mp4') && $this->{'html5Enabled'}) {
			$videotag_enabled = 1;
			$out .= $this->media_tag_start('video',$path,$data,$title,(($data->{'previewtype'}) ? $previewpath : ''),$embed_option);
		}
		$out .= '<object type="application/x-shockwave-flash" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="' . $data->{'width'} . '" height="' . $data->{'height'} . '"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= ' ' . $embed_option if $embed_option ne '';
		$out .= '>';
		$out .= '<param name="movie" value="' . $player . '"></param>';
		$out .= '<param name="quality" value="high"></param>';
		$out .= '<param name="allowScriptAccess" value="sameDomain"></param>';
		$out .= '<param name="allowFullScreen" value="true"></param>';
		$out .= '<param name="flashVars" value="' . $flash_vars . '"></param>';
		$out .= '<embed type="application/x-shockwave-flash" src="' . $player . '" width="' . $data->{'width'} . '" height="' . $data->{'height'} . '"';
		$out .= ' quality="high"';
		$out .= ' allowscriptaccess="sameDomain"';
		$out .= ' allowfullscreen="true"';
		$out .= ' flashvars="' . $flash_vars . '"';
		$out .= ' pluginspage="http://get.adobe.com/flashplayer/"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= ' ' . $embed_option if $embed_option ne '';
		$out .= '></embed></object>';
		$out .= '</video>' if $videotag_enabled;
	
	#QT
	} else {
		my $controller;
		my $videotag_enabled;
		my $height = $data->{'height'};
		if ($data->{'width'} && $data->{'height'} && @Common::qt_plug && grep($_ eq $file_type,@Common::qt_plug)) {
			$height += 16;
			$controller = 'true';
		} else {
			$controller = 'false';
		}
		if ($this->{'html5Enabled'} && @Common::html5_video && grep($_ eq $file_type,@Common::html5_video)) {
			$videotag_enabled = 1;
			$out .= $this->media_tag_start('video',$path,$data,$title,(($data->{'previewtype'}) ? $previewpath : ''),$embed_option);
		}
		$out .= '<object classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B" width="' . $data->{'width'} . '" height="' . $height . '"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= ' ' . $embed_option if $embed_option ne '';
		$out .= '>';
		$out .= '<param name="src" value="' . $path . '"></param>';
		$out .= '<param name="autoplay" value="false"></param>';
		$out .= '<param name="scale" value="aspect"></param>';
		$out .= '<param name="controller" value="' . $controller . '"></param>';
		$out .= '<embed src="' . $path . '" width="' . $data->{'width'} . '" height="' . $height . '" scale="aspect" autoplay="false" controller="' . $controller . '" pluginspage="http://www.apple.com/quicktime/download/"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= ' ' . $embed_option if $embed_option ne '';
		$out .= '></embed></object>';
		$out .= '</video>' if $videotag_enabled;
	}
	$out .= '<div class="file-download"><a href="' . $path . '" title="' . $size . '">[Download:' . $size . ']</a></div>' if !$this->{'dlDisabled'};
	$out .= '</div>';
	return $out;

#QTsound
} elsif ((!$this->{'maxwidth'} || ($this->{'maxwidth'} && 100 < $this->{'maxwidth'}))
	 && (!$this->{'maxheight'} || ($this->{'maxheight'} && 16 < $this->{'maxheight'}))
	 && grep($_ eq $file_type,@Common::sound_plug)) {
	my $audiotag_enabled;
	my $title = (defined $data->{'title'}) ? $this->escape_without_html_entity($data->{'title'}) : '';
	$out .= '<div class="object"' . (($align ne '') ? ' style="' . (($div_flag) ? 'text-align' : 'float') . ': ' . $align . '"' : '') . '>';
	if ($this->{'html5Enabled'} && @Common::html5_audio && grep($_ eq $file_type,@Common::html5_audio)) {
		$audiotag_enabled = 1;
		$out .= $this->media_tag_start('audio',$path,$data,$title,'',$embed_option);
	}
	if ($this->{'useFlash'} && $file_type eq 'mp3') {
		my $width = ($this->{'maxwidth'} && (!$data->{'width'} || $data->{'width'} > $this->{'maxwidth'})) ? $this->{'maxwidth'} : ($this->{'widthlimit'} && (!$data->{'width'} || $data->{'width'} > $this->{'widthlimit'})) ? $this->{'widthlimit'} : ($data->{'width'}) ? $data->{'width'} : 240;
		my $player = (($cgi::output || $cgi::output_option) ? $this->base_change($env::javascript,$cgi::output,$cgi::output_option) : $env::javascript) . '/player.swf';
		my $flash_vars = $this->escape($this->url_encoded_query({
			'path' => $this->base_change($original_dir . '/' . $file_name,$env::javascript . '/player',$cgi::output_option),
			'type' => 'mp3',
			'frontcolor' => 'FFFFFF',
			'backcolor' => '000000',
			(($data->{'previewtype'}) ? ('thumbnail' => $previewpath) : ())
		}));
		$out .= '<object type="application/x-shockwave-flash" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="' . $width . '" height="' . (($data->{'previewtype'} && $data->{'height'}) ? $data->{'height'} : '27') . '"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= ' ' . $embed_option if $embed_option ne '';
		$out .= '>';
		$out .= '<param name="movie" value="' . $player . '"></param>';
		$out .= '<param name="quality" value="high"></param>';
		$out .= '<param name="allowScriptAccess" value="sameDomain"></param>';
		$out .= '<param name="allowFullScreen" value="true"></param>';
		$out .= '<param name="flashVars" value="' . $flash_vars . '"></param>';
		$out .= '<embed type="application/x-shockwave-flash" src="' . $player . '" width="' . $width . '" height="' . (($data->{'previewtype'} && $data->{'height'}) ? $data->{'height'} : '27') . '"';
		$out .= ' quality="high"';
		$out .= ' allowscriptaccess="sameDomain"';
		$out .= ' allowfullscreen="true"';
		$out .= ' flashvars="' . $flash_vars . '"';
		$out .= ' pluginspage="http://get.adobe.com/flashplayer/"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= ' ' . $embed_option if $embed_option ne '';
		$out .= '></embed></object>';

	} else {
		my $width = ($data->{'width'}) ? ($data->{'width'} > $this->{'maxwidth'}) ? $this->{'maxwidth'} : $data->{'width'} : 100;
		$out .= '<object classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B" width="' . $width . '" height="16"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= '>';
		$out .= '<param name="src" value="' . $path . '"></param>';
		$out .= '<param name="autoplay" value="false"></param>';
		$out .= '<param name="controller" value="true"></param>';
		$out .= '<embed src="' . $path . '" width="' . $width . '" height="16" autoplay="false" controller="true" pluginspage="http://www.apple.com/quicktime/download/"';
		$out .= ' title="' . $title . '"' if $title ne '';
		$out .= ' ' . $embed_option if $embed_option ne '';
		$out .= '></embed></object>';
	}
	$out .= '</audio>' if $audiotag_enabled;
	$out .= '<div class="file-download"><a href="' . $path . '" title="' . $size . '">[Download:' . $size . ']</a></div>' if !$this->{'dlDisabled'};
	$out .= '</div>';
	return $out;

}

#źեե
if (defined $cgi::output && $cgi::output) {
	$icon_dir = $this->base_change($env::icon_dir,$cgi::output);
} else {
	$icon_dir = $env::icon_dir;
}
if (!@env::icon_images && $env::icon_dir && -d $env::icon_dir) {
	opendir(DIR,$env::icon_dir);
	@env::icon_images = readdir(DIR);
	closedir(DIR);
}

#
($icon_image) = grep($_ =~ /^$file_type\./,@env::icon_images);

#QTץ饰ɽΤǤࡼӡ
if (@Common::qt_plug && grep($_ eq $file_type,@Common::qt_plug)) {
	$attribute = $this->set_fileviewer_window($data,352,255,50);
	$icon_image = 'mov.png' if !$icon_image && grep($_ eq 'mov.png',@env::icon_images);

#ץ饰ɽΤǤ
} elsif (@Common::image_plug && grep($_ eq $file_type,@Common::image_plug)) {
	$attribute = $this->set_fileviewer_window($data,600,400);
	$icon_image = 'image.png' if !$icon_image && grep($_ eq 'image.png',@env::icon_images);

#QTsound
} elsif (@Common::sound_plug && grep($_ eq $file_type,@Common::sound_plug)) {
	$attribute = $this->set_fileviewer_window($data,320,20);
	$icon_image = 'sound.png' if !$icon_image && grep($_ eq 'sound.png',@env::icon_images);

}

my $title = (defined $data->{'title'}) ? $this->escape_without_html_entity($data->{'title'}) . '(' . $size . ')' : $size;
$icon_image = 'unknown.png' if !$icon_image;
$attribute .= ' title="' . $title . '"';

$icon_dir .= '/' if $icon_dir !~ m!/$!;
$out .= '<div class="object"' . (($align ne '') ? ' style="text-align: ' . $align . '"' : '') . '>' if $div_flag;
if ($this->{'html5Enabled'}) {
	if (@Common::html5_video && grep($_ eq $file_type,@Common::html5_video)) {
		$out .= $this->media_tag_start('video',$path,$data,$title,(($data->{'previewtype'}) ? $previewpath : ''),$embed_option);
		$out .= '</video>';
	} elsif (@Common::html5_audio && grep($_ eq $file_type,@Common::html5_audio)) {
		$out .= $this->media_tag_start('audio',$path,$data,$title,'',$embed_option);
		$out .= '</audio>';
	}
}
$out .= '<a href="' . $path . '"' . $attribute . '>';
$out .= '<img src="' . $icon_dir . $icon_image . '" border="0" width="32" height="32" alt="' . $title . '"' . ((!$div_flag && $align ne '') ? ' style="float: ' . $align . '"' : '') . ' />';
$out .= '</a>';
$out .= '</div>' if $div_flag;

return $out;
}

sub media_tag_start ($$$$;$$) {
my($this,$type,$path,$data,$title,$preview,$embed_option) = @_;
$title = $this->escape_without_html_entity($data->{'title'}) if !$title && defined $data->{'title'};
my($w,$h) = ($data->{'width'},$data->{'height'});
my $style = '';
if ($this->{'maxwidth'}) {
	if (!$w) {
		$style .= 'max-width:' . $this->{'maxwidth'} . 'px;';
	} elsif ($w > $this->{'maxwidth'}) {
		$h = int($h * $this->{'maxwidth'} / $w) if $h;
		$w = $this->{'maxwidth'};
	}
}
if ($this->{'maxheight'}) {
	if (!$h) {
		$style .= 'max-height:' . $this->{'maxheight'} . 'px;';
	} elsif ($h > $this->{'maxheight'}) {
		$w = int($w * $this->{'maxheight'} / $h) if $w;
		$h = $this->{'maxheight'};
	}
}
return '<' . $type
		. ' src="' . $path . '"'
		. (($w) ? ' width="' . $w . '"' : '')
		. (($h) ? ' height="' . $h . '"' : '')
		. ((defined $title && $title ne '') ? ' title="' . $title . '"' : '')
		. (($this->{'autoplayEnabled'}) ? ' autoplay="autoplay"' : '')
		. (($this->{'preloadDisabled'} || $preview) ? ' preload="none"' : '')
		. (($this->{'loopEnabled'}) ? ' loop="loop"' : '')
		. ((!$this->{'controlsDisabled'}) ? ' controls="controls"' : '')
		. (($preview) ? ' poster="' . $preview . '"' : '')
		. (($embed_option) ? ' ' . $embed_option : '')
		. (($style) ? ' style="' . $style . '"' : '')
		. '>';
}

sub set_fileviewer_window ($$) {
my($this,$data,$w,$h,$c) = @_;
my($width,$height) = ($data->{'width'},$data->{'height'});
$width = $w || 640 if !$width;
$height = $h || 480 if !$height;
my($win_width,$win_height) = ($width,$height);
$win_width = 800 if !$win_width || $win_width > 800;
$win_height = 600 if !$win_height || $win_height > 600;
if ($c) {
	$height += $c;
	$win_height += $c;
}
return " target=\"fileViewer\" onclick=\"if(typeof cmonos == 'object'){cmonos.window.open('fileViewer',$width,$height)}else{window.open('','fileViewer','width=$win_width,height=$win_height,scrollbars=yes,resizable=yes')} return true\"";
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
$this->search_ext;
return (@{$this->{'filetype'}} || (defined $main::search{$this->{'id'}}{'str'} && $main::search{$this->{'id'}}{'str'} ne '')) ? 1 : 0;
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
my($matched,$cmt_matched,%data);
return 1 if !$this->match_enabled;

#ǡʬ
%data = $this->elements($$str);

#ĥҾȹ
$matched = 0;
if (@{$this->{'filetype'}}) {
	my($e,$ext);
	foreach (@{$this->{'filetype'}}) {
		if ($_ eq '-e') {
			if (defined $data{'type'} && $data{'type'} ne '') {
				$matched = 1;
				last;
			}
		} elsif ($_ eq '!e') {
			if (!defined $data{'type'} || $data{'type'} eq '') {
				$matched = 1;
				last;
			}
		} else {
			if (eval{$data{'type'} =~ /^\Q$_\E$/i}) {
				$matched = 1;
				last;
			}
		}
	}
} else {
	$matched = 1;
}

#Ⱦȹ
if ($matched && $this->{'comment'}) {
	my($i,$euc);
	$this->mk_pattern if !ref $this->{'pattern'};
	$i = 'i' if defined $main::search{$this->{'id'}}{'i'} && $main::search{$this->{'id'}}{'i'};
	$euc = 1 if defined $$str && length $$str < 200;

	$cmt_matched = (!defined $main::search{$this->{'id'}}{'mode'} || $main::search{$this->{'id'}}{'mode'} ne 'and') ? 0 : 1; 
	foreach (@{$this->{'pattern'}}) {
		if ($this->jmatch(\$data{'comment'},$_,$i,1,$euc)) {
			$cmt_matched = 1 if !defined $main::search{$this->{'id'}}{'mode'} || $main::search{$this->{'id'}}{'mode'} ne 'and'
		} elsif (defined $main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'and') {
			$cmt_matched = 0;
		}
	}
	$matched = 0 if !$cmt_matched;
}

return $matched;
}

#оݥեγĥһ
sub search_ext ($) {
my $this = shift;
return if ref $this->{'filetype'};

if (defined $main::search{$this->{'id'}}{'ext'} && $main::search{$this->{'id'}}{'ext'} ne '') {
	$main::search{$this->{'id'}}{'ext'} = $this->z_to_h($main::search{$this->{'id'}}{'ext'});
	push(@{$this->{'filetype'}},split(/\s+/,$main::search{$this->{'id'}}{'ext'}));
	map($_ =~ s/^\.//,@{$this->{'filetype'}});
}

$this->scalar_to_array(\$main::search{$this->{'id'}}{'type'});
push(@{$this->{'filetype'}},@{$main::search{$this->{'id'}}{'type'}});

@{$this->{'filetype'}} = grep(defined $_ && $_ ne '',@{$this->{'filetype'}});
if (grep($_ ne '-e' && $_ ne '!e',@{$this->{'filetype'}})) {
	@{$this->{'filetype'}} = grep($_ ne '-e' && $_ ne '!e',@{$this->{'filetype'}});
}
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status,$original,$path) = @_;
return '' if $ENV{'HTTP_USER_AGENT'} && $ENV{'HTTP_USER_AGENT'} =~ /(?:DoCoMo|KDDI|UP\.Browser)/i;		# docomo au

my($name,$form,@menu,$title,$v);

#̾˥ǡID
$name = 'data:' . $this->{'id'};

#ǥեȺ
$main::data{$this->{'id'}}{'comment'} = $this->{'default'} if (!defined $status || $status eq '') && (!defined $main::data{$this->{'id'}}{'comment'} || $main::data{$this->{'id'}}{'comment'} eq '');
$title = $this->escape($main::data{$this->{'id'}}{'title'});

#ơ֥
if ((!$this->{'nostyle'} || $this->{'nostyle'} <= 2) && defined $main::data{$this->{'id'}}{'comment'} && $main::data{$this->{'id'}}{'comment'} =~ /<!--_[ct]sv(?!\w)[^>]*-->/) {
	my $tag = ($this->{'csv'}) ? 'no' : 'tag';
	$main::data{$this->{'id'}}{'comment'} = $this->{'Table'}->text_to_sv($main::data{$this->{'id'}}{'comment'},$tag,'csv');
}

#եɥ͡+إå
$form = $this->field_header('50');

#åץɥե
$form .= '<table class="sub-field-table"><tbody>';
if ($this->{'importEnabled'}) {
	$form .= '<tr><td class="sub-field-name"><label for="' . $name . ':url" class="datatitle">URL</label></td><td class="sub-field">';
	$form .= '<input type="text" name="' . $name . ':url" id="' . $name . ':url" size="36" value="' . $this->escape($main::data{$this->{'id'}}{'url'}) . '"' . (($this->{'is_invalid_field'}{'url'}) ? $this->set_invalid_class : '') . ' title="ƥĤ URL ꤷޤ" />';
	if (($this->{'photoSharingServiceName'} && $this->{'photoSharingServiceAccount'}) || $this->{'photoSharingServiceRSS'}) {
		$form .= ' <a href="./start.cgi' . $this->escape($this->get_query_for_editor) . '" target="photoViewer" class="note" onclick="cmonos.window.open(\'photoViewer\',640,600)">ƥİ򳫤</a>';
		$form .= '<div id="content-sample-' . $this->{'id'} . '"></div>';
	}
	$form .= '</td></tr>';
}
$form .= '<tr><td class="sub-field-name"><label for="' . $name . ':file">ե</label></td><td class="sub-field">';
$form .= '<input type="file" name="' . $name . ':file" id="' . $name . ':file"' . (($this->{'is_invalid_field'}{'file'}) ? $this->set_invalid_class : '') . ' />';
$form .= '<div class="note">(&lt; ' . $this->{'maxsize'} . ' byte) </div>' if defined $this->{'maxsize'} && $this->{'maxsize'};

#ե¸ߤå
($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'},$main::data{$this->{'id'}}{'type'},$main::data{$this->{'id'}}{'name'}) = ('','','','') unless $main::data{$this->{'id'}}{'type'} && -f ((!$cgi::input->{'clipboard_expired'} && $this->{'is_posted_file'}) ? $cgi::input->get_public_clipboard : ($path || './')) . '/' . $this->{'id'} . ((defined $main::data{$this->{'id'}}{'name'} && $main::data{$this->{'id'}}{'name'} ne '' && $main::data{$this->{'id'}}{'name'} !~ /\W/) ? '.' . $main::data{$this->{'id'}}{'name'} : '') . '.' . $main::data{$this->{'id'}}{'type'};

#
if (defined $this->{'imagesize'} && $this->{'imagesize'}) {
	$form .= '</td></tr><tr><td class="sub-field-name"><span class="datatitle"></span></td><td class="sub-field">';
	$form .= '<label><input type="text" name="' . $name . ':width" id="' . $name . ':width" size="4"';
	$form .= ' value="' . $this->escape($main::data{$this->{'id'}}{'width'}) . '"' if defined $main::data{$this->{'id'}}{'width'} && $main::data{$this->{'id'}}{'width'};
	$form .= $this->set_invalid_class if $this->{'is_invalid_field'}{'width'};
	$form .= ' /></label>';
	$form .= '<span class="note"> (&lt;' . $this->{'widthlimit'} . ') </span>' if $this->{'widthlimit'};
	$form .= '<label><input type="text" name="' . $name . ':height" size="4"';
	$form .= ' value="' . $this->escape($main::data{$this->{'id'}}{'height'}) . '"' if defined $main::data{$this->{'id'}}{'height'} && $main::data{$this->{'id'}}{'height'};
	$form .= $this->set_invalid_class if $this->{'is_invalid_field'}{'height'};
	$form .= ' /></label>';
	$form .= '<span class="note"> (&lt;' . $this->{'heightlimit'} . ') </span>' if $this->{'heightlimit'};
	$form .= '<span class="unit">ԥ</span>';
} else {
	$form .= '<div class="note">(&lt; ' . (($this->{'widthlimit'}) ? $this->{'widthlimit'} : '&infin;') . '  ' . (($this->{'heightlimit'}) ? $this->{'heightlimit'} : '&infin;') . ' <span class="unit">ԥ</span>) </div>' if (defined $this->{'widthlimit'} && $this->{'widthlimit'}) || (defined $this->{'heightlimit'} && $this->{'heightlimit'});
	$form .= '<input type="hidden" name="' . $name . ':width" value="' . $this->escape($main::data{$this->{'id'}}{'width'}) . '" />';
	$form .= '<input type="hidden" name="' . $name . ':height" value="' . $this->escape($main::data{$this->{'id'}}{'height'}) . '" />';
}
$form .= '</td></tr>';
if (!$this->{'titlefrom'} || !$this->{'usertitledisabled'} || !ref $this->{'field_obj'}->{$this->{'titlefrom'}} || $this->{'field_obj'}->{$this->{'titlefrom'}}->{'class'} ne 'text' || ($this->{'field_obj'}->{$this->{'titlefrom'}}->{'rows'} && $this->{'field_obj'}->{$this->{'titlefrom'}}->{'rows'} > 1)) {
	$form .= '<tr><td class="sub-field-name"><label for="' . $name . ':title">ȥ</label></td><td class="sub-field"><input type="text" name="' . $name . ':title" id="' . $name . ':title" size="36"';
	$form .= ' value="' . $title . '"' if defined $title && $title;
	$form .= ' title="եɽǤʤäȤɽʸϤޤ" /></td></tr>';
}

#ץӥ塼
if (defined $this->{'preview'} && $this->{'preview'}) {
	$form .= '<tr><td class="sub-field-name">';
	$form .= '<label for="' . $name . ':preview">ͥ</label></td><td class="sub-field">';
	$form .= '<input type="file" name="' . $name . ':preview" id="' . $name . ':preview" value="' . $this->escape($main::data{$this->{'id'}}{'preview'}) . '"' . (($this->{'is_invalid_field'}{'preview'}) ? $this->set_invalid_class : '') . ' />';
	$form .= '<div class="note">(&lt; ' . (($this->{'previewwidthlimit'}) ? $this->{'previewwidthlimit'} : '&infin;') . '  ' . (($this->{'previewheightlimit'}) ? $this->{'previewheightlimit'} : '&infin;') . ' <span class="unit">ԥ</span>) </div>' if $this->{'previewwidthlimit'} || $this->{'previewheightlimit'};
	$form .= '</td></tr>';
}
$form .= '</tbody></table>';

#¸եɽ
if (((defined $status && $status ne '') || $this->{'is_posted_file'} || $this->{'is_posted_preview'}) && ((defined $main::data{$this->{'id'}}{'type'} && $main::data{$this->{'id'}}{'type'} ne '') || ($this->{'preview'} && $main::data{$this->{'id'}}{'previewtype'}))) {
	local $this->{'is_temporary_data'} = (!$cgi::input->{'clipboard_expired'}) ? 1 : 0;
	$form .= '<div class="sample-image">';
	my $max_width = $this->{'maxwidth'};
	$this->{'maxwidth'} = (!$max_width || $max_width > 300) ? 300 : $max_width;
	if (defined $main::data{$this->{'id'}}{'type'} && $main::data{$this->{'id'}}{'type'} ne '') {
		$form .= $this->image($path,$main::data{$this->{'id'}},$this->{'option'});
		if ($this->{'is_temporary_data'} && $this->{'is_posted_file'}) {
			$form .= '<div class="extra-field"><label><input type="checkbox" name="option:' . $this->{'id'} . ':cancel" value="1" /> <strong>̤</strong>ե</label></div>';
		} elsif (!$this->{'required'}) {
			$form .= '<div class="extra-field"><label><input type="checkbox" name="' . $name . ':delete" value="1"' . (($this->{'is_temporary_data'} && $main::data{$this->{'id'}}{'delete'}) ? ' checked="checked"' : '') . ' /> Υե</label></div>';
		}
		$form .= '<input type="hidden" name="' . $name . ':type" value="' . $this->escape($main::data{$this->{'id'}}{'type'}) . '" />';
		$form .= '<input type="hidden" name="' . $name . ':name" value="' . $this->escape($main::data{$this->{'id'}}{'name'}) . '" />';
	}
	if ($this->{'preview'} && $main::data{$this->{'id'}}{'previewtype'}) {
		if (!defined $main::data{$this->{'id'}}{'type'} || $main::data{$this->{'id'}}{'type'} eq '') {
			$form .= '<img src="' . (($this->{'is_temporary_data'} && $this->{'is_posted_preview'}) ? $cgi::input->get_public_clipboard : $path) . '/' . $this->{'id'} . '.preview.' . $main::data{$this->{'id'}}{'previewtype'} . '"';
			$form .= ' width="' . $main::data{$this->{'id'}}{'previewwidth'} . '"' if defined $main::data{$this->{'id'}}{'previewwidth'} && $main::data{$this->{'id'}}{'previewwidth'};
			$form .= ' height="' . $main::data{$this->{'id'}}{'previewheight'} . '"' if defined $main::data{$this->{'id'}}{'previewheight'} && $main::data{$this->{'id'}}{'previewheight'};
			$form .= ' alt="' . $title . '" title="' . $title . '"' if defined $title && $title ne '';
			$form .= ' />';
		}
		if ($this->{'is_temporary_data'} && $this->{'is_posted_preview'}) {
			$form .= '<div class="extra-field"><label><input type="checkbox" name="option:' . $this->{'id'} . ':previewcancel" value="1" /> <strong>̤</strong>ͥ</label></div>';
		} else {
			$form .= '<div class="extra-field"><label><input type="checkbox" name="' . $name . ':deletepreview" value="1"' . (($this->{'is_temporary_data'} && $main::data{$this->{'id'}}{'deletepreview'}) ? ' checked="checked"' : '') . ' /> Υͥ</label></div>';
		}
		$form .= '<input type="hidden" name="' . $name . ':previewtype" value="' . $this->escape($main::data{$this->{'id'}}{'previewtype'}) . '" />';
		$form .= '<input type="hidden" name="' . $name . ':previewwidth" value="' . $this->escape($main::data{$this->{'id'}}{'previewwidth'}) . '" />';
		$form .= '<input type="hidden" name="' . $name . ':previewheight" value="' . $this->escape($main::data{$this->{'id'}}{'previewheight'}) . '" />';
	}
	$form .= '</div>';
	$this->{'maxwidth'} = $max_width;
	delete $this->{'is_temporary_data'};
}

#
$form .= $this->comment_form($name,$original) if $this->{'comment'};

$form .= $this->field_footer;
return $form;
}

sub comment_form ($$$) {
my($this,$name,$original) = @_;
$main::data{$this->{'id'}}{'valign'} = 'top' if (!defined $main::data{$this->{'id'}}{'type'} || $main::data{$this->{'id'}}{'type'} eq '') && (!defined $main::data{$this->{'id'}}{'comment'} || $main::data{$this->{'id'}}{'comment'} eq '') && (!defined $main::data{$this->{'id'}}{'align'} || $main::data{$this->{'id'}}{'align'} eq '') && (!defined $main::data{$this->{'id'}}{'valign'} || $main::data{$this->{'id'}}{'valign'} eq '');
$this->{'cols'} = 40 if !$this->{'cols'};
my $form = '<div class="additional-field"><label for="' . $name . ':comment"></label>';

#ƥ
#⤵1ʲξ
if (!$this->{'rows'} || $this->{'rows'} <= 1) {
	$main::data{$this->{'id'}}{'comment'} =~ s/\x0A//gs;
	$form .= '<input type="text" name="' . $name . ':comment" id="' . $name . ':comment" size="' . $this->{'cols'} . '"';
	$form .= ' maxlength="' . $this->{'maxlength'} . '"' if $this->{'maxlength'};
	$form .= ' value="' . $this->escape($this->unescape_data_tag($main::data{$this->{'id'}}{'comment'})) . '"' if defined $main::data{$this->{'id'}}{'comment'} && $main::data{$this->{'id'}}{'comment'};
	$form .= $this->set_invalid_class if $this->{'is_invalid_field'}{'comment'};
	$form .= ' />';

#⤵2ʾξ
} else {
	#$main::data{$this->{'id'}}{'comment'} =~ s/<br(?!\w)[^>]*>/\x0A/sig;
	$form .= '<textarea name="' . $name . ':comment" id="' . $name . ':comment" cols="' . $this->{'cols'} . '" rows="' . $this->{'rows'} . '"' . (($this->{'is_invalid_field'}{'preview'}) ? $this->set_invalid_class : '') . '>';
	$form .= $this->escape($this->blockquote_to_quotation($this->unescape_data_tag($main::data{$this->{'id'}}{'comment'}),$this->{'cols'})) if defined $main::data{$this->{'id'}}{'comment'} && $main::data{$this->{'id'}}{'comment'};
	$form .= '</textarea>';

	#ġܥå
	my $original_text = (ref $original eq 'HASH' && defined $original->{'comment'} && $original->{'comment'} ne '') ? $original->{'comment'} : '';
	$form .= $this->textarea_tool('data:' . $this->{'id'} . ':comment',$original_text);	
	$form .= '<div class="hints">޶ڤʸϡưŪɽѴޤ</div>' if defined $this->{'csv'} && $this->{'csv'};
}
$form .= '</div>';

#
$form .= '<div class="additional-field"><span class="datatitle">եɽ</span>';
$form .= $this->mk_select_menu(
	$name . ':align','','',$main::data{$this->{'id'}}{'align'},
	''			=>		'',
	'left'		=>		'',
	'center'	=>		'',
	'right'		=>		''
);
$form .= $this->mk_select_menu(
	$name . ':valign','','',$main::data{$this->{'id'}}{'valign'},
	''			=>		'',
	'top'		=>		'',
	'middle'	=>		'',
	'bottom'	=>		''
);
$form .= '</div>';
return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my($this,$path) = @_;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
my($is_valid,$name,$width,$height,$type,$file_name,$preview_name,$preview_width,$preview_height,$preview_type,$previewwidthlimit,$previewheightlimit);
$is_valid = 1;
$name = 'data:' . $this->{'id'} . ':file';
$this->fill(
	\$main::data{$this->{'id'}}{'width'},
	\$main::data{$this->{'id'}}{'height'},
	\$main::data{$this->{'id'}}{'type'},
	\$main::data{$this->{'id'}}{'name'}
);
$preview_name = 'data:' . $this->{'id'} . ':preview';
if ($this->{'preview'}) {
	$main::data{$this->{'id'}}{'previewwidth'} = $main::data{$this->{'id'}}{'previewheight'} = $main::data{$this->{'id'}}{'previewtype'} = '' if !$default::static && (!defined $main::n || $main::n eq '');
	$this->fill(
		\$main::data{$this->{'id'}}{'previewwidth'},
		\$main::data{$this->{'id'}}{'previewheight'},
		\$main::data{$this->{'id'}}{'previewtype'}
	);
	$previewwidthlimit = ($this->{'previewwidthlimit'}) ? $this->{'previewwidthlimit'} : ($this->{'maxwidth'}) ? $this->{'maxwidth'} : '';
	$previewheightlimit = ($this->{'previewheightlimit'}) ? $this->{'previewheightlimit'} : ($this->{'maxheight'}) ? $this->{'maxheight'} : '';
}
	
#ȥ
if ($this->{'titlefrom'} && ref $this->{'field_obj'}->{$this->{'titlefrom'}} && $this->{'field_obj'}->{$this->{'titlefrom'}}->{'class'} =~ /^text/ && (!$this->{'field_obj'}->{$this->{'titlefrom'}}->{'rows'} || $this->{'field_obj'}->{$this->{'titlefrom'}}->{'rows'} == 1) && (!defined $main::data{$this->{'id'}}{'title'} || $main::data{$this->{'id'}}{'title'} eq '' || $this->{'usertitledisabled'})) {
	$main::data{$this->{'id'}}{'title'} = (defined $main::data{$this->{'titlefrom'}}{'str'}) ? $main::data{$this->{'titlefrom'}}{'str'} : '';
	$main::data{$this->{'id'}}{'title'} =~ s/<>[#0-9a-zA-z]{3,10}\Z//s;
	$this->detag(\$main::data{$this->{'id'}}{'title'});
}
$main::data{$this->{'id'}}{'title'} =~ s/[\x0A\x0D]//gs if $main::data{$this->{'id'}}{'title'};

#¸եξ
($width,$height) = ($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'}) if $this->{'imagesize'};
if (!$path || !-d $path) {
	$main::data{$this->{'id'}}{'width'} = $main::data{$this->{'id'}}{'height'} = '' if !$this->{'imagesize'};
	$main::data{$this->{'id'}}{'type'} = $main::data{$this->{'id'}}{'name'} = '';
	$main::data{$this->{'id'}}{'previewwidth'} = $main::data{$this->{'id'}}{'previewheight'} = $main::data{$this->{'id'}}{'previewtype'} = '' if $this->{'preview'};
	undef $path;
} else {
	($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'},$main::data{$this->{'id'}}{'type'},$main::data{$this->{'id'}}{'name'}) = $this->get_field_file_info(
		$path,
		$main::data{$this->{'id'}}{'width'},
		$main::data{$this->{'id'}}{'height'},
		$main::data{$this->{'id'}}{'type'},
		$main::data{$this->{'id'}}{'name'},
		'preview'
	);
	if ($this->{'imagesize'}) {
		$main::data{$this->{'id'}}{'width'} = $width if $width && !$main::data{$this->{'id'}}{'width'};
		$main::data{$this->{'id'}}{'height'} = $height if $height && !$main::data{$this->{'id'}}{'height'};
	}
	if ($this->{'preview'}) {
		($main::data{$this->{'id'}}{'previewwidth'},$main::data{$this->{'id'}}{'previewheight'},$main::data{$this->{'id'}}{'previewtype'}) = $this->get_field_file_info(
			$path,
			$main::data{$this->{'id'}}{'previewwidth'},
			$main::data{$this->{'id'}}{'previewheight'},
			$main::data{$this->{'id'}}{'previewtype'},
			'preview',
			'',
			1
		);
	}
}

#źեեμ
if ($main::clipboard_id && !$main::data{$this->{'id'}}{'file'} && !$main::option{$this->{'id'}}{'cancel'}) {
	$cgi::input->inherit_posted_file_properties($name);
}
my %properties = $cgi::input->get_posted_file_properties_from_param($name);
if ($properties{'delete'}) {
	delete $properties{'delete'};
	$cgi::input->set_posted_file_properties_from_param($name,0,\%properties);
}
my %preview_properties = ();
if (defined $this->{'preview'} && $this->{'preview'}) {
	if ($main::clipboard_id && !$main::data{$this->{'id'}}{'preview'} && !$main::option{$this->{'id'}}{'previewcancel'}) {
		$cgi::input->inherit_posted_file_properties($preview_name);
	}
	%preview_properties = $cgi::input->get_posted_file_properties_from_param($preview_name);
}
if ($preview_properties{'delete'}) {
	delete $preview_properties{'delete'};
	$cgi::input->set_posted_file_properties_from_param($preview_name,0,\%preview_properties);
}

#URLǡ
if (!$properties{'filename'} && $main::data{$this->{'id'}}{'url'}) {
	if ($this->is_invalid_url($main::data{$this->{'id'}}{'url'})) {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : '') . ' ƥĤɤ߹ߤ˼ԤޤURL ǧƤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'url'} = 1;
		$is_valid = 0;
	} else {
		%properties = ();
		my $path = $cgi::input->set_clipboard('data:' . $this->{'id'} . ':file',0);
		require CMONOS::CGI_Lib::HTTP_Client;
		my $res = HTTP_Client->new->request('GET' => $this->image_url_encode($main::data{$this->{'id'}}{'url'}),{},'','','',$path . '/data');
		if ($res->is_success) {
			my $url = $res->url || 'image.jpg';
			$url =~ s/\#.*?$//;
			$url =~ s/\?.*?$//;
			$url =~ s/\.jpeg/.jpg/i;
			my $ext = ($url =~ /\.(\w+)$/) ? $1 : '';
			$properties{'name'} = $properties{'filename'} = $main::data{$this->{'id'}}{'file'} = ($url =~ /([^\/]+)$/) ? $1 : '';
			$properties{'type'} = $Common::mime_type{$ext} || 'application/octet-stream';
			$cgi::input->set_posted_file_properties($path,\%properties);
			delete $main::data{$this->{'id'}}{'url'};
		} else {
			push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : '') . ' ƥĤɤ߹ߤ˼Ԥޤ') if ref $cgi::action;
			$this->{'is_invalid_field'}{'url'} = 1;
			$is_valid = 0;
		}
	}
} elsif (defined $main::data{$this->{'id'}}{'url'}) {
	delete $main::data{$this->{'id'}}{'url'};
}

#źեեν
if ($properties{'filename'}) {
	my($is_image,@stat);

	#źեե뤬ե뤫ɤå
	@stat = $cgi::Image->input_info($cgi::input,$name,0,$this->{'widthlimit'},$this->{'heightlimit'},1,\%properties);
	if (@stat > 2) {
		($width,$height,$type) = @stat;
		$is_image = 1;
	} elsif ($properties{'filename'} =~ /\.(\w+)$/) {
		$type = $1;
	} else {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'ǧƤŬڤʳĥҤĤƤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'file'} = 1;
		$is_valid = 0;
	}
	
	#ե륵å
	if ($this->{'maxsize'} && $cgi::input->get_posted_file_size_from_param($name) > $this->{'maxsize'}) {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'Υե륵ǧƤ' . $this->{'maxsize'} . 'ХȰˤƤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'file'} = 1;
		$is_valid = 0;
	}
	
	if (defined $this->{'anyfile'} && $this->{'anyfile'}) {
		#⤷ʤ
	} elsif (ref $this->{'type_ext'} eq 'HASH' && %{$this->{'type_ext'}}) {
		#MIME-TYPEå
		if (!defined $this->{'type_ext'}{$properties{'type'}}) {
			my $mimename = '';
			foreach my $ext (sort keys %{$this->{'mimename'}}) {
				$mimename .= (($mimename) ? ',' : '') . $this->{'mimename'}{$ext} . (($this->{'mimename'}{$ext} ne $ext) ? '(' . $ext . ')' : '')
			}
			push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'ΥեǧƤΤߵĤƤޤ' . $mimename) if ref $cgi::action;
			$this->{'is_invalid_field'}{'file'} = 1;
			$is_valid = 0;
		} else {
			$properties{'filename'} =~ s/\.\w+$/\.$this->{'type_ext'}{$properties{'type'}}/;
		}
	} elsif (!$is_image) {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'ϡWebŬǤϤޤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'file'} = 1;
		$is_valid = 0;
	}

	#ե̾
	$file_name = $this->z_to_h($properties{'filename'},'euc');
	$file_name =~ s/\.\w+?$//s;
	$file_name =~ s/[\s\.\-\+]+/_/gs;
	$file_name = '' if $file_name =~ /\W/ || $file_name eq 'preview';

	#ץӥ塼ư
	if ($this->{'preview'} && $env::clipboard && $cgi::Image->image_magick_enabled && $is_image && ($main::data{$this->{'id'}}{'deletepreview'} || !$main::data{$this->{'id'}}{'previewtype'}) && !$cgi::input->get_posted_file_size_from_param($preview_name) && (($previewwidthlimit && $width > $previewwidthlimit) || ($previewheightlimit && $height > $previewheightlimit))) {
		%preview_properties = $cgi::input->clone_posted_file($name,$preview_name);
	}

	if (!$is_valid) {
		$cgi::input->remove_posted_file($name);
		undef %properties;
	}

} else {
	($width,$height,$type,$file_name) = ($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'},$main::data{$this->{'id'}}{'type'},$main::data{$this->{'id'}}{'name'});
	$file_name = '' if $file_name =~ /\W/ || $file_name eq 'preview';
	if ($type && ref $this->{'ext_type'} eq 'HASH' && %{$this->{'ext_type'}} && !defined $this->{'ext_type'}{$type}) {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'Υե륿פǧƤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'file'} = 1;
		$is_valid = 0;
	}
}

#å
if ($this->{'widthlimit'} && $width && $width > $this->{'widthlimit'}) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'βǧƤ' . $this->{'widthlimit'} . 'ԥˤƤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'file'} = $this->{'is_invalid_field'}{'width'} = 1;
	$is_valid = 0;
}
if ($this->{'heightlimit'} && $height && $height > $this->{'heightlimit'}) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'ι⤵ǧƤ' . $this->{'heightlimit'} . 'ԥˤƤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'file'} = $this->{'is_invalid_field'}{'height'} = 1;
	$is_valid = 0;
}

#ɬܹ
if ($this->{'required'} && (!defined $type || $type eq '')) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'ꤷƤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'file'} = 1;
	$is_valid = 0;
}

#ͥν
if (defined $this->{'preview'} && $this->{'preview'}) {
	if ($preview_properties{'filename'}) {
		my $is_valid_preview = 1;

		#źեե뤬ե뤫ɤå
		my @stat = $cgi::Image->input_info($cgi::input,$preview_name,0,$previewwidthlimit,$previewheightlimit,1,\%preview_properties);
		if (@stat > 2) {
			($preview_width,$preview_height,$preview_type) = @stat;
		} else {
			push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'Υͥʥץӥ塼ˤǧƤWeb ŬǤϤޤ') if ref $cgi::action;
			$this->{'is_invalid_field'}{'preview'} = 1;
			$is_valid_preview = $is_valid = 0;
		}

		#ե륵å
		if ($this->{'maxsize'} && $cgi::input->get_posted_file_size_from_param($preview_name) > $this->{'maxsize'}) {
			push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'Υͥʥץӥ塼˥ե륵ǧƤ' . $this->{'maxsize'} . 'ХȰˤƤ') if ref $cgi::action;
			$this->{'is_invalid_field'}{'preview'} = 1;
			$is_valid_preview = $is_valid = 0;
		}

		if (!$is_valid_preview) {
			$cgi::input->remove_posted_file($preview_name);
			undef %preview_properties;
		}

	} else {
		($preview_width,$preview_height,$preview_type) = ($main::data{$this->{'id'}}{'previewwidth'},$main::data{$this->{'id'}}{'previewheight'},$main::data{$this->{'id'}}{'previewtype'});
		if ($preview_type && $preview_type !~ /^(gif|jpg|png)$/) {
			push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'Υͥʥץӥ塼ˤǧƤWeb ŬǤϤޤ') if ref $cgi::action;
			$this->{'is_invalid_field'}{'preview'} = 1;
			$is_valid = 0;
		}
	}

	#å
	if ($previewwidthlimit && $preview_width && $preview_width > $previewwidthlimit) {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'Υͥʥץӥ塼˲ǧƤ' . $this->{'previewwidthlimit'} . 'ԥˤƤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'preview'} = 1;
		$is_valid = 0;
	}
	if ($previewheightlimit && $preview_height && $preview_height > $previewheightlimit) {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'źեե') . 'Υͥʥץӥ塼˹⤵ǧƤ' . $this->{'previewheightlimit'} . 'ԥˤƤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'preview'} = 1;
		$is_valid = 0;
	}
}

#Ȥ˶ػʸ󤢤
$is_valid = 0 if $this->{'comment'} && !$this->is_not_taboo('comment');

return 0 if !defined $is_valid || !$is_valid;

#ǡ
my($w,$h,$t,$na,$pw,$ph,$pt);
($w,$h,$t,$na) = ($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'},$main::data{$this->{'id'}}{'type'},$main::data{$this->{'id'}}{'name'});
($pw,$ph,$pt) = ($main::data{$this->{'id'}}{'previewwidth'},$main::data{$this->{'id'}}{'previewheight'},$main::data{$this->{'id'}}{'previewtype'}) if $this->{'preview'};

#եͽ
my @ignore_keys = ('file','delete','preview','deletepreview');
if (!$this->{'required'} && $main::data{$this->{'id'}}{'delete'} && !$properties{'filename'}) {
	push(@ignore_keys,'width','height','type','name');
	$cgi::input->parameters_trash(\$main::data{$this->{'id'}}{'width'},\$main::data{$this->{'id'}}{'height'},\$main::data{$this->{'id'}}{'type'},\$main::data{$this->{'id'}}{'name'});
} else {
	$file_name = '' if $file_name =~ /\W/ || $file_name eq 'preview';
	($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'},$main::data{$this->{'id'}}{'type'},$main::data{$this->{'id'}}{'name'}) = ($width,$height,$type,$file_name);
}
if (!$this->{'preview'} || ($main::data{$this->{'id'}}{'deletepreview'} && !$preview_properties{'filename'})) {
	push(@ignore_keys,'previewwidth','previewheight','previewtype');
	$cgi::input->parameters_trash(\$main::data{$this->{'id'}}{'previewwidth'},\$main::data{$this->{'id'}}{'previewheight'},\$main::data{$this->{'id'}}{'previewtype'});
} else {
	($main::data{$this->{'id'}}{'previewwidth'},$main::data{$this->{'id'}}{'previewheight'},$main::data{$this->{'id'}}{'previewtype'}) = ($preview_width,$preview_height,$preview_type);
}

#ǡ
$this->data(@ignore_keys);

#ե¸/ͽ
if ($properties{'filename'}) {
	$mail::file .= '<' . $name . '>,' if !$default::static && ($this->{'mail'} || $setting::field_for_mail);		#᡼źͽ
	$cgi::input->save_file(
		$name,
		'!' . $this->{'id'} . ((defined $main::data{$this->{'id'}}{'name'} && $main::data{$this->{'id'}}{'name'} ne '' && $main::data{$this->{'id'}}{'name'} !~ /\W/) ? '.' . $main::data{$this->{'id'}}{'name'} : '') . '.' . $main::data{$this->{'id'}}{'type'},
		'',
		'',
		'',
		$this->{'id'} . '(\\.(?!preview)\\w+)?'
	);
	$this->{'is_posted_file'} = 1;
} elsif (!$this->{'required'} && $main::data{$this->{'id'}}{'delete'}) {
	$properties{'delete'} = $this->{'id'} . '(\\.(?!preview)\\w+)?';
	$cgi::input->set_posted_file_properties_from_param($name,0,\%properties);
}
if ($preview_properties{'filename'}) {
	$cgi::input->save_file(
		$preview_name,
		'!' . $this->{'id'} . '.preview.' . $preview_type,
		'',
		'',
		'',
		$this->{'id'} . '\\.preview'
	);
	$this->{'is_posted_preview'} = 1;
} elsif (!$this->{'preview'} || $main::data{$this->{'id'}}{'deletepreview'}) {
	$preview_properties{'delete'} = $this->{'id'} . '\\.preview';
	$cgi::input->set_posted_file_properties_from_param($preview_name,0,\%preview_properties);
}
delete $main::data{$this->{'id'}}{'file'};
delete $main::data{$this->{'id'}}{'preview'};

#ϤΥå(ǡ礭DataˤޤȤ᤿ˤ狼ʤ)
if (!$this->is_not_too_long('str','') && $this->is_not_empty('type')) {
	$na = '' if $na =~ /\W/ || $na eq 'preview';
	($main::data{$this->{'id'}}{'width'},$main::data{$this->{'id'}}{'height'},$main::data{$this->{'id'}}{'type'},$main::data{$this->{'id'}}{'name'}) = ($w,$h,$t,$na);
	($main::data{$this->{'id'}}{'previewwidth'},$main::data{$this->{'id'}}{'previewheight'},$main::data{$this->{'id'}}{'previewtype'}) = ($pw,$ph,$pt) if $this->{'preview'};
	$this->{'is_invalid_field'}{'comment'} = 1;
	return 0;
}
return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
return $this->field_tag($str) if !defined $str || $str eq '';

my(%data,$align,$div);
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
undef $str;
$this->preview_complement(\%data,$path) if $default::static && $this->{'preview'} && $this->{'previewComplementEnabled'};
return $this->image($path,\%data,$this->{'option'}) if $this->{'icon_type'};
return $this->field_tag($this->data_tag_from_ref(\%data),1) if (!defined $data{'type'} || $data{'type'} eq '') && (!defined $data{'comment'} || $data{'comment'} eq '');

#
if (defined $this->{'comment'} && $this->{'comment'}) {
	#
	my $image = $this->image($path,\%data,$this->{'option'},$data{'align'},$data{'valign'});

	#Ĵ
	$this->text_conv(\$data{'comment'});
	$this->text_fix(\$data{'comment'},$this->{'csv'});
	$str = $this->data_tag('comment',$data{'comment'});

	if (!defined $data{'valign'} || $data{'valign'} eq '' || $data{'valign'} eq 'middle' || !defined $image || $image eq '') {
		$str = $this->style($image . $str,$this->{'style'},$this->{'fontsize'},$this->{'fontcolor'},$this->{'fontface'});
	} else {
		$str = $this->style($str,$this->{'style'},$this->{'fontsize'},$this->{'fontcolor'},$this->{'fontface'});
		if ($data{'valign'} eq 'top') {
			$str = $image . $str;
		} elsif ($data{'valign'} eq 'bottom') {
			$str .= $image;
		}
	}
} else {
	$str = $this->image($path,\%data,$this->{'option'});
}
if ($this->{'is_temporary_data'}) {
	if ($main::data{$this->{'id'}}{'delete'} && !$this->{'required'} && !$this->{'is_posted_file'}) {
		$str .= '<div class="note">Υե</div>';
	}
	if ($main::data{$this->{'id'}}{'deletepreview'} && !$this->{'is_posted_preview'}) {
		$str .= '<div class="note">Υͥ</div>';
	}
}
return $this->field_tag($this->data_tag_from_ref(\%data,'comment') . $str);
}

sub preview_complement ($$$) {
my($this,$data,$path) = @_;
return 1 if !$data->{'type'} || $data->{'previewtype'} || !$cgi::Image->image_magick_enabled || ($data->{'type'} ne 'jpg' && $data->{'type'} ne 'gif' && $data->{'type'} ne 'png');
my $file_path = $path . '/' . $this->{'id'} . '.' . ((defined $data->{'name'} && $data->{'name'} ne '' && $data->{'name'} !~ m!/!) ? $data->{'name'} . '.' : '') . $data->{'type'};
my $preview_path = $path . '/' . $this->{'id'} . '.preview.' . $data->{'type'};
my $previewwidthlimit = ($this->{'previewwidthlimit'}) ? $this->{'previewwidthlimit'} : ($this->{'maxwidth'}) ? $this->{'maxwidth'} : '';
my $previewheightlimit = ($this->{'previewheightlimit'}) ? $this->{'previewheightlimit'} : ($this->{'maxheight'}) ? $this->{'maxheight'} : '';
return 1 if !$previewwidthlimit && !$previewheightlimit;
my($width,$height) = $cgi::Image->fit($file_path,$previewwidthlimit,$previewheightlimit);
if ($width && $height) {
	my $magick = Image::Magick->new;
	$magick->Read($file_path);
	$magick->Resize('width' => $width, 'height' => $height);
	$magick->Write($preview_path);
	undef $magick;
	if (-s $preview_path) {
		($data->{'previewwidth'},$data->{'previewheight'},$data->{'previewtype'}) = ($width,$height,$data->{'type'});
		return 1;
	} else {
		unlink $preview_path;
		return 0;
	}
}
return 0;
}

sub has_content {
my($this,$str) = @_;
return 0 if !defined $str || $str eq '';
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return (%data && ((defined $data{'type'} && $data{'type'} ne '') || (defined $data{'comment'} && $data{'comment'} ne ''))) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail {
my($this,$str,@data) = @_;
local $this->{'thumbnail'} = 'no' if $this->{'nopreviewdetail'};
return $this->usual_format($str,@data);
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail {
my($this,$str) = @_;
return '' if !defined $str || $str eq '';
my(%data);
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return '' if !$data{'type'} && !$data{'comment'};
$str = '[' . $this->name . "]\x0A" . (($data{'type'}) ? '(źեե' . (($data{'title'}) ? ':' . $data{'title'} : '') . ')' : '') . ((defined $data{'comment'}) ? "\x0A" . $this->blockquote_to_quotation($data{'comment'},70) : '');
$str =~ s/[\x0A]*\Z/\x0A\x0A/s;
return $str;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
my($this,$str) = @_;
return '' if !defined $str || $str eq '';
my(%data);
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return '' if !$data{'type'} && !$data{'comment'};
return $this->blockquote_to_quotation($data{'comment'},(($this->{'cols'}) ? $this->{'cols'} : 40)) . (($data{'type'}) ? ' (źեեͭ' . (($data{'title'}) ? ':' . $data{'title'} : '') . ')' : '');
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled,$tips) = @_;
my($name);

#̾
$name = 'data:' . $this->{'id'};

$this->print_field_info_form($name);
print '<fieldset>';
print '<legend></legend>';
print '<div class="hints">ͤĶ硢źդ䤷ޤ</div>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_maxsize">ե륵</label></td>';
print '<td class="field" colspan="3"><input type="text" name="' . $name . '_maxsize" id="' . $name . '_maxsize" value="' . $this->escape($this->{'maxsize'}) . '" size="15" /> <span class="unit">byte</span><div class="hints">̵꤬硢128,000byte128KBˤꤵޤ</div></td>';
print '</tr>';
if (!$html_disabled) {
	print '<tr>';
	print '<td class="field-name"><label for="' . $name . '_maxwidth">粣ʲ</label></td>';
	print '<td class="q-field"><input type="text" name="' . $name . '_maxwidth" id="' . $name . '_maxwidth" value="' . $this->escape($this->{'maxwidth'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '<td class="field-name"><label for="' . $name . '_maxheight">⤵ʲ</label></td>';
	print '<td class="q-field"><input type="text" name="' . $name . '_maxheight" id="' . $name . '_maxheight" value="' . $this->escape($this->{'maxheight'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '</tr>';
}
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_widthlimit">¡ʲ</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_widthlimit" id="' . $name . '_widthlimit" value="' . $this->escape($this->{'widthlimit'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
print '<td class="field-name"><label for="' . $name . '_heightlimit">⤵¡ʲ</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_heightlimit" id="' . $name . '_heightlimit" value="' . $this->escape($this->{'heightlimit'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><input type="checkbox" name="' . $name . '_imagesize" id="' . $name . '_imagesize" value="1"' . ((defined $this->{'imagesize'} && $this->{'imagesize'}) ? ' checked="checked"' : '') . ' /></td>';
print '<td class="field" colspan="3"><label for="' . $name . '_imagesize">ɽ</label>';
print '<div class="hints">֥饦ɽǤեˤΤŬѤޤ</div>';
print '<div class="hints">Ķ硢ɽ˽̾ޤ</div>' if !defined $html_disabled || !$html_disabled;
print '<div class="hints">Ķ硢źդ䤷ޤ</div>';
print '</td>';
print '</tr>';
if (!$default::static && !$setting::field_for_mail) {
	print '<tr>';
	print '<td class="field-name"><input type="checkbox" name="' . $name . '_mail" id="' . $name . '_mail" value="1"' . ((defined $this->{'mail'} && $this->{'mail'}) ? ' checked="checked"' : '') . ' /></td>';
	print '<td class="field" colspan="3"><label for="' . $name . '_mail">Υ᡼˥եźդ</label></td>';
	print '</tr>';
}
print '<tr class="tbody-end">';
print '<td class="field-name"><input type="checkbox" name="' . $name . '_dlDisabled" id="' . $name . '_dlDisabled" value="1"' . ((defined $this->{'dlDisabled'} && $this->{'dlDisabled'}) ? ' checked="checked"' : '') . ' /></td>';
print '<td class="field" colspan="3"><label for="' . $name . '_dlDisabled">ɥ󥯤ɽʤ</label></td>';
print '</tr>';
print '</tbody>';
if (!$html_disabled) {
	print '<tbody>';
	print '<tr class="tbody-end">';
	print '<td class="field-name"><label for="' . $name . '_option">ץ</label></td>';
	print '<td class="field" colspan="3"><input type="text" name="' . $name . '_option" id="' . $name . '_option" value="' . $this->escape($this->{'option'}) . '" size="50" title="źեեݤΥץꤷޤ" /></td>';
	print '</tr>';
	print '</tbody>';
	print '<tbody>';
	print '<tr class="tbody-end">';
	print '<td class="field-name"><span class="datatitle">MP3/MP4</span></td>';
	print '<td class="field" colspan="3">';
	print '<label><input type="checkbox" name="' . $name . '_useFlash" value="1"' . (($this->{'useFlash'}) ? ' checked="checked"' : '') . ' /> <a href="http://sourceforge.net/projects/gsplayer/" target="_blank">GS Player</a>  MP3  MP4 եɽ롣</label></li>';
	print '</td>';
	print '</tr>';
	print '</tbody>';
	print '<tbody>';
	print '<tr class="tbody-end">';
	print '<td class="field-name"><label title="HTML5  &lt;video&gt;/&lt;audio&gt; Ѥ뤫ɤꤷޤ֥饦ˤäƺǤեۤʤޤΤդƤ"><input type="checkbox" name="' . $name . '_html5Enabled" value="1"' . ((defined $this->{'html5Enabled'} && $this->{'html5Enabled'}) ? ' checked="checked"' : '') . ' />&lt;video&gt;/&lt;audio&gt;</label></td>';
	print '<td class="field" colspan="3"><ol class="checkbox">';
	print '<li><label><input type="checkbox" name="' . $name . '_preloadDisabled" value="1"' . (($this->{'preloadDisabled'}) ? ' checked="checked"' : '') . ' /> ư衦򤢤餫ɤ߹<strong>ʤ</strong></label></li>';
	print '<li><label><input type="checkbox" name="' . $name . '_autoplayEnabled" value="1"' . (($this->{'autoplayEnabled'}) ? ' checked="checked"' : '') . ' /> ư衦ư롣</label></li>';
	print '<li><label><input type="checkbox" name="' . $name . '_loopEnabled" value="1"' . (($this->{'loopEnabled'}) ? ' checked="checked"' : '') . ' /> ư衦롼׺롣</label></li>';
	print '<li><label><input type="checkbox" name="' . $name . '_controlsDisabled" value="1"' . (($this->{'controlsDisabled'}) ? ' checked="checked"' : '') . ' /> ȥ顼ɽ<strong>ʤ</strong></label></li>';
	print '</ol></td>';
	print '</tr>';
	print '</tbody>';
}
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_mimetype">MIME-TYPE </label></td>';
print '<td class="field" colspan="3">';
print '<div class="extra-field"><label><input type="checkbox" name="' . $name . '_anyfile" value="1"' . ((defined $this->{'anyfile'} && $this->{'anyfile'}) ? ' checked="checked"' : '') . ' /> ƤΥեĤ</label></div>';
print '<textarea name="' . $name . '_mimetype" id="' . $name . '_mimetype" cols="80" rows="6" wrap="off">' . $this->escape($this->{'mimetype'}) . '</textarea>';
$this->print_mimetype_menu($name . '_mimetype');
print '<div class="hints">꤬ʤ硢WebŬΤ߼դޤ</div>';
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_titlefrom">ȥ<span class="note">(ʸ)</span></label></td>';
print '<td class="field" colspan="3">ȥ뤬ʤȤ';
print '<select name="' . $name . '_titlefrom" id="' . $name . '_titlefrom">';
print '<option value=""></option>';
foreach my $id (sort {$this->{'field_obj'}->{$a}->{'ORDER'} <=> $this->{'field_obj'}->{$b}->{'ORDER'} || $a <=> $b} keys %{$this->{'field_obj'}}) {
	next unless ref $this->{'field_obj'}->{$id} && $this->{'field_obj'}->{$id}->{'class'} =~ /^text/ && (!$this->{'field_obj'}->{$id}->{'rows'} || $this->{'field_obj'}->{$id}->{'rows'} == 1);
	print '<option value="' . $id . '"' . ((defined $this->{'titlefrom'} && $this->{'titlefrom'} eq $id) ? ' selected="selected"' : '') . '>' . $this->jfold($this->{'field_obj'}->{$id}->name,32,'I',1) . '</option>';
}
print '</select>饿ȥ';
print '<div class="extra-field"><label><input type="checkbox" name="' . $name . '_usertitledisabled" value="1"' . (($this->{'usertitledisabled'}) ? ' checked="checked"' : '') . ' /> ˤΥեɤͤ򥿥ȥˤ롣</label></div>';
print '</td>';
print '</tr>';
print '</tbody>';
if (!$html_disabled) {
	print '<tbody>';
	print '<tr>';
	print '<td class="field-name"><label><input type="checkbox" name="' . $name . '_preview" id="' . $name . '_preview" value="1"' . ((defined $this->{'preview'} && $this->{'preview'}) ? ' checked="checked"' : '') . ' /> ͥ</label></td>';
	print '<td class="field" colspan="3"><label><input type="checkbox" name="' . $name . '_nopreviewdetail" id="' . $name . '_nopreviewdetail" value="1"' . ((defined $this->{'nopreviewdetail'} && $this->{'nopreviewdetail'}) ? ' checked="checked"' : '') . ' /> ǤΤߥͥѤ롣</label></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="' . $name . '_previewwidthlimit"><span class="note">(ͥ)</span></label></td>';
	print '<td class="q-field"><input type="text" name="' . $name . '_previewwidthlimit" id="' . $name . '_previewwidthlimit" value="' . $this->escape($this->{'previewwidthlimit'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '<td class="field-name"><label for="' . $name . '_previewheightlimit">⤵<span class="note">(ͥ)</span></label></td>';
	print '<td class="q-field"><input type="text" name="' . $name . '_previewheightlimit" id="' . $name . '_previewheightlimit" value="' . $this->escape($this->{'previewheightlimit'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '</tr>';
	if ($default::static && $cgi::Image->image_magick_enabled) {
		print '<tr>';
		print '<td class="field-name"><span class="datatitle">䴰</span></td>';
		print '<td class="field" colspan="3"><label><input type="checkbox" name="' . $name . '_previewComplementEnabled" id="' . $name . '_previewComplementEnabled" value="1"' . (($this->{'previewComplementEnabled'}) ? ' checked="checked"' : '') . ' /> 񤭽Ф˥ͥߤĤʤȤåץɤ()ե뤫롣</label></td>';
		print '</tr>';
	}
	print '</tbody>';
}
print '</table>';
print '</fieldset>';
if (!$html_disabled) {
	print '<fieldset>';
	print '<legend><label for="' . $name . '_rel">󥯤 rel °</label></legend>';
	print '<input type="text" name="' . $name . '_rel" id="' . $name . '_rel" value="' . $this->escape($this->{'rel'}) . '" size="16" />';
	print '<div class="note">lightbox Ȥꤷޤ&quot;lightbox[picture]&quot;</div></fieldset>';
}

print '<fieldset>';
print '<legend><label><input type="checkbox" name="' . $name . '_importEnabled" value="1"' . ((defined $this->{'importEnabled'} && $this->{'importEnabled'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'import-settings\').disappear(!this.checked);" /> ƥɤ߹</label></legend>';
print '<table class="field-table" id="import-settings">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_photoSharingServiceName">̿ͭӥ</label></td>';
print '<td class="q-field">';
print $this->mk_select_menu(
	$name . '_photoSharingServiceName','','',$this->{'photoSharingServiceName'},
	'TwitPic'		=>		'TwitPic',
	'Twitgoo'		=>		'Twitgoo',
	'Mobypicture'	=>		'Mobypicture',
	'img.ly'		=>		'img.ly',
	'flickr'		=>		'flickr',
	'hatena'		=>		'ϤƤʡեȥ饤',
);
print '</td>';
print '<td class="field-name"><label for="' . $name . '_photoSharingServiceAccount"></label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_photoSharingServiceAccount" id="' . $name . '_photoSharingServiceAccount" value="' . $this->escape($this->{'photoSharingServiceAccount'}) . '" size="20" title="̿ͭӥΥȤꤷޤ" /></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_photoSharingServiceRSS">¾ RSS URL</label></td>';
print '<td class="field" colspan="3"><input type="text" name="' . $name . '_photoSharingServiceRSS" id="' . $name . '_photoSharingServiceRSS" value="' . $this->escape($this->{'photoSharingServiceRSS'}) . '" size="90" title="¾μ̿ͭӥ RSS" />';
print '<div class="hints">ּ̿ͭӥץ˥塼֤¾ RSS URLפͥ褵ޤ</div></td>';
print '</tr>';
print '</tbody>';
print '</table>';
print '</fieldset>';
print $this->javascript('cmonos.element.item(\'import-settings\').disappear(true);') if !$this->{'importEnabled'};

print '<fieldset>';
print '<legend></legend>';
print '<label><input type="checkbox" name="' . $name . '_comment" value="1"' . ((defined $this->{'comment'} && $this->{'comment'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.tagClass(\'div\',\'cmtsetting\',\'fieldset\',\'cmtsetting\').disappear(!this.checked);" /> ɲä</label>';
print '<div class="cmtsetting">';

if (!defined $default::static || !$default::static) {
	print '<label><input type="checkbox" name="' . $name . '_noFileSearchForm" value="1"' . (($this->{'noFileSearchForm'}) ? ' checked="checked"' : '') . ' /> ܺپǥȸΤɽ</label>';
}

print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_cols"></label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_cols" id="' . $name . '_cols" value="' . $this->escape($this->{'cols'}) . '" size="3" title="βꤷޤ" /> <span class="unit">ʸ(Ⱦ)</span></td>';
print '<td class="field-name"><label for="' . $name . '_rows">⤵</label></td>';
print '<td class="q-field"><input type="text" name="' . $name . '_rows" id="' . $name . '_rows" value="' . $this->escape($this->{'rows'}) . '" size="3" title="ι⤵ꤷޤ" /> <span class="unit">ʸ</span></td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_maxlength">ʸ</label></td>';
print '<td class="field" colspan="3"><input type="text" name="' . $name . '_maxlength" id="' . $name . '_maxlength" value="' . $this->escape($this->{'maxlength'}) . '" size="3" title="Ȥʸ¤ޤ" /> <span class="unit">ʸ(Ⱦ)</span></td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_default">ǥե</label></td>';
print '<td class="field" colspan="3"><textarea name="' . $name . '_default" cols="' . (($this->{'cols'}) ? $this->{'cols'} : '72') . '" rows="' . (($this->{'rows'}) ? $this->{'rows'} : '4') . '" wrap="soft">' . $this->escape($this->{'default'}) . '</textarea>' . ((defined $tips) ? $tips : '') . '</td>';
print '</tr>';
print '</tbody></table>';
print '</div></fieldset>';
print '<fieldset class="cmtsetting">';
print '<legend>ʸ()</legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_taboowords">ػʸ</label></td>';
print '<td class="field" colspan="3"><textarea name="' . $name . '_taboowords" id="' . $name . '_taboowords" cols="72" rows="4" wrap="off">' . $this->escape($this->{'taboowords'}) . '</textarea>';
print '<label class="auto-fit" title="⤵Ƥ˹碌"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'' . $name . '_taboowords\').setAutoFit(this.checked);" />եå</label>';
print '<div class="extra-field"><label><input type="checkbox" name="' . $name . '_tabooregexp" value="1"' . ((defined $this->{'tabooregexp'} && $this->{'tabooregexp'}) ? ' checked="checked"' : '') . ' /> ɽѤ</label></div>';
print '<div class="note">ػʸ󤴤Ȥ˲</div>';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_convtable">ʸѴɽ</label></td>';
print '<td class="field" colspan="3"><textarea name="' . $name . '_convtable" id="' . $name . '_convtable" cols="72" rows="4" wrap="off" title="񼰤˽äʸѴɽꤷޤ">' . $this->escape($this->{'convtable'}) . '</textarea>';
print '<label class="auto-fit" title="⤵Ƥ˹碌"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'' . $name . '_convtable\').setAutoFit(this.checked);" />եå</label>';
print '<div class="extra-field"><label><input type="checkbox" name="' . $name . '_convregexp" value="1"' . ((defined $this->{'convregexp'} && $this->{'convregexp'}) ? ' checked="checked"' : '') . ' /> ɽѤ</label></div>';
print '<div class="note">񼰡Ѵоʸ=&gt;Ѵʸ[]</div>';
print '<div class="example">ˡ=>ʶ/SPAM=>spamʸ</div>';
print '</td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

if (defined $html_disabled && $html_disabled) {
	print '<input type="hidden" name="' . $name . '_csv" value="0" />';

} else {
	print '<div class="cmtsetting">';

	#ν
	$this->print_html_tag_setting_form($name,'()');

	#ʸȾʸ̤ʤ
	$this->print_ignorecase_setting_form($name,'()');

	#ʸ
	$this->print_font_setting_form($name,'()');

	#ơ֥
	$this->print_table_setting_form($name,'()');

	print '</div>';
}

$this->print_setting_save_button;
print $this->javascript('cmonos.element.tagClass(\'div\',\'cmtsetting\',\'fieldset\',\'cmtsetting\').disappear(true);') if !$this->{'comment'};
return;
}

sub print_mimetype_menu ($$) {
my($this,$target) = @_;
print '<div class="toolbox"><select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'' . $target . '\').quotationByMenu(this)">';
print '<option value="">MIME-TYPE ɲ</option>';
print '<option value="' . $this->jsquot('image/jpeg:jpg:JPEG\nimage/pjpeg:jpg:JPEG\nimage/gif:gif:GIF\nimage/png:png:PNG\nimage/x-png:png:PNG\n') . '">Web Ŭ</option>';
print '<option value="' . $this->jsquot('application/pdf:pdf:PDF\n') . '">PDF</option>';
print '<option value="' . $this->jsquot('application/epub+zip:epub:ePub\n') . '">ePub</option>';
print '<option value="' . $this->jsquot('video/mp4:mp4:MPEG4\n') . '">MPEG4</option>';
print '<option value="' . $this->jsquot('audio/m4a:m4a:MPEG4\n') . '">MPEG4</option>';
print '<option value="' . $this->jsquot('video/x-flv:flv:FLV\n') . '">FLV</option>';
print '<option value="' . $this->jsquot('video/3gpp2:3g2:3G2\n') . '">3G2</option>';
print '<option value="' . $this->jsquot('video/mp4:m4v:MPEG4\n') . '">MPEG4</option>';
print '<option value="' . $this->jsquot('video/ogg:ogg:Ogg\n') . '">Ogg</option>';
print '<option value="' . $this->jsquot('video/ogg:ogv:OggVideo\n') . '">OggVideo</option>';
print '<option value="' . $this->jsquot('audio/ogg:oga:OggAudio\n') . '">OggAudio</option>';
print '<option value="' . $this->jsquot('video/webm:webm:WebM\n') . '">WebM</option>';
print '<option value="' . $this->jsquot('audio/mpeg:mp3:MP3\n') . '">MP3</option>';
print '<option value="' . $this->jsquot('audio/aac:aac:AAC\n') . '">AAC</option>';
print '<option value="' . $this->jsquot('audio/wav:wav:WAV\n') . '">WAV</option>';
print '<option value="' . $this->jsquot('audio/midi:mid:MIDI\n') . '">MIDI</option>';
print '<option value="' . $this->jsquot('video/mpeg:mpg:MPEG\n') . '">MPEG</option>';
print '<option value="' . $this->jsquot('video/quicktime:mov:QuickTimeư\n') . '">QuickTimeư</option>';
print '<option value="' . $this->jsquot('video/x-msvideo:avi:AVI\n') . '">AVI</option>';
print '<option value="' . $this->jsquot('application/x-shockwave-flash:swf:Flash\n') . '">Flash</option>';
print '<option value="' . $this->jsquot('application/lha:lzh:LZH\n') . '">LZH</option>';
print '<option value="' . $this->jsquot('application/zip:zip:ZIP\n') . '">ZIP</option>';
print '<option value="' . $this->jsquot('application/x-compressed:tgz:TGZ\n') . '">TGZ</option>';
print '<option value="' . $this->jsquot('application/x-stuffit:sit:sit\n') . '">sit</option>';
print '<option value="' . $this->jsquot('application/x-macbinary:bin:bin\n') . '">bin</option>';
print '<option value="' . $this->jsquot('application/mac-binhex40:hqx:hqx\n') . '">hqx</option>';
print '<option value="' . $this->jsquot('audio/x-pn-realaudio:ra:ra\n') . '">ra</option>';
print '<option value="' . $this->jsquot('image/pict:pct:PICT\nimage/pict:pict:PICT\n') . '">PICT</option>';
print '<option value="' . $this->jsquot('image/tiff:tif:TIFF\n') . '">TIFF</option>';
print '<option value="' . $this->jsquot('image/x-icon:ico:ե\n') . '">ե</option>';
print '<option value="' . $this->jsquot('video/x-ms-wmv:wmv:WMV\n') . '">WMV</option>';
print '<option value="' . $this->jsquot('video/x-ms-asf:asf:ASF\n') . '">ASF</option>';
print '<option value="' . $this->jsquot('application/postscript:eps:EPS\n') . '">EPS</option>';
print '<option value="' . $this->jsquot('application/postscript:ai:Illustrator\n') . '">Illustrator</option>';
print '<option value="' . $this->jsquot('application/vnd.adobe.photoshop:psd:Photoshop\n') . '">Photoshop</option>';
print '<option value="' . $this->jsquot('application/x-director:dcr:Director\n') . '">Director</option>';
print '<option value="' . $this->jsquot('text/comma-separated-values:csv:CSV\n') . '">CSV</option>';
print '<option value="' . $this->jsquot('text/plain:txt:TEXT\n') . '">TEXT</option>';
print '<option value="' . $this->jsquot('text/xml:xml:XML\n') . '">XML</option>';
print '<option value="' . $this->jsquot('text/xml:kml:KML\n') . '">KML</option>';
print '<option value="' . $this->jsquot('text/html:html:HTML\ntext/html:htm:HTML\n') . '">HTML</option>';
print '<option value="' . $this->jsquot('application/x-tex:tex:TeX\n') . '">TeX</option>';
print '<option value="' . $this->jsquot('application/vnd.ms-powerpoint:ppt:PowerPoint\napplication/vnd.openxmlformats-officedocument.presentationml.presentation:pptx:PowerPoint\n') . '">PowerPoint</option>';
print '<option value="' . $this->jsquot('application/vnd.ms-excel:xls:Excel\napplication/vnd.openxmlformats-officedocument.spreadsheetml.sheet:xlsx:Excel\n') . '">Excel</option>';
print '<option value="' . $this->jsquot('application/msword:doc:Word\napplication/vnd.openxmlformats-officedocument.wordprocessingml.document:docx:Word\n') . '">Word</option>';
print '<option value="' . $this->jsquot('application/vnd.oasis.opendocument.text:odt:OpenDocumentץ\n') . '">OpenDocumentץ</option>';
print '<option value="' . $this->jsquot('application/vnd.oasis.opendocument.spreadsheet:ods:OpenDocumentɽ׻\n') . '">OpenDocumentɽ׻</option>';
print '<option value="' . $this->jsquot('application/vnd.oasis.opendocument.presentation:odp:OpenDocumentץ쥼ơ\n') . '">OpenDocumentץ쥼ơ</option>';
print '<option value="' . $this->jsquot('application/vnd.oasis.opendocument.graphics:odg:OpenDocument޷\n') . '">OpenDocument޷</option>';
print '<option value="' . $this->jsquot('application/vnd.oasis.opendocument.formula:odf:OpenDocument\n') . '">OpenDocument</option>';
print '<option value="' . $this->jsquot('application/vnd.oasis.opendocument.database:odb:OpenDocumentǡ١\n') . '">OpenDocumentǡ١</option>';
print '</select>';
print ' MIME-TYPE:ĥ:եμ[]</div>';
print '<div class="example">image/jpeg:jpg:JPEG</div>';
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting {
my $this = shift;
my $is_valid = 1;
$is_valid = 0 if !$this->is_valid_text_setting;
$is_valid = 0 if !$this->is_valid_file_setting;

#åܥå
$main::data{$this->{'id'} . '_preview'} = '' if !defined $main::data{$this->{'id'} . '_preview'} || $main::data{$this->{'id'} . '_preview'} eq '';
$main::data{$this->{'id'} . '_importEnabled'} = '' if !$main::data{$this->{'id'} . '_importEnabled'};
$main::data{$this->{'id'} . '_comment'} = '' if !defined $main::data{$this->{'id'} . '_comment'} || $main::data{$this->{'id'} . '_comment'} eq '';
$main::data{$this->{'id'} . '_imagesize'} = '' if !defined $main::data{$this->{'id'} . '_imagesize'} || $main::data{$this->{'id'} . '_imagesize'} eq '';
$main::data{$this->{'id'} . '_anyfile'} = '' if !defined $main::data{$this->{'id'} . '_anyfile'} || $main::data{$this->{'id'} . '_anyfile'} eq '';
$main::data{$this->{'id'} . '_noFileSearchForm'} = '' if !defined $main::data{$this->{'id'} . '_noFileSearchForm'} || $main::data{$this->{'id'} . '_noFileSearchForm'} eq '';
$main::data{$this->{'id'} . '_dlDisabled'} = '' if !defined $main::data{$this->{'id'} . '_dlDisabled'} || $main::data{$this->{'id'} . '_dlDisabled'} eq '';
$main::data{$this->{'id'} . '_convregexp'} = '' if !defined $main::data{$this->{'id'} . '_convregexp'} ||  $main::data{$this->{'id'} . '_convregexp'} eq '';
$main::data{$this->{'id'} . '_tabooregexp'} = '' if !defined $main::data{$this->{'id'} . '_tabooregexp'} ||  $main::data{$this->{'id'} . '_tabooregexp'} eq '';
$main::data{$this->{'id'} . '_nopreviewdetail'} = '' if !defined $main::data{$this->{'id'} . '_nopreviewdetail'} ||  $main::data{$this->{'id'} . '_nopreviewdetail'} eq '';
$main::data{$this->{'id'} . '_usertitledisabled'} = '' if !defined $main::data{$this->{'id'} . '_usertitledisabled'} || !$main::data{$this->{'id'} . '_usertitledisabled'};
$main::data{$this->{'id'} . '_previewComplementEnabled'} = '' if $default::static && (!defined $main::data{$this->{'id'} . '_previewComplementEnabled'} || !$main::data{$this->{'id'} . '_previewComplementEnabled'});
$main::data{$this->{'id'} . '_ignoreCase'} = '' if !$main::data{$this->{'id'} . '_ignoreCase'};
$main::data{$this->{'id'} . '_useFlash'} = '' if !$main::data{$this->{'id'} . '_useFlash'};
$main::data{$this->{'id'} . '_html5Enabled'} = '' if !$main::data{$this->{'id'} . '_html5Enabled'};
$main::data{$this->{'id'} . '_autoplayEnabled'} = '' if !$main::data{$this->{'id'} . '_autoplayEnabled'};
$main::data{$this->{'id'} . '_preloadDisabled'} = '' if !$main::data{$this->{'id'} . '_preloadDisabled'};
$main::data{$this->{'id'} . '_loopEnabled'} = '' if !$main::data{$this->{'id'} . '_loopEnabled'};
$main::data{$this->{'id'} . '_controlsDisabled'} = '' if !$main::data{$this->{'id'} . '_controlsDisabled'};

if (defined $main::data{$this->{'id'} . '_photoSharingServiceRSS'} && $main::data{$this->{'id'} . '_photoSharingServiceRSS'} ne '' && $this->is_invalid_url($main::data{$this->{'id'} . '_photoSharingServiceRSS'})) {
	push(@{$cgi::action->{'dialog'}},'¾μ̿ͭӥ RSS URL ǧƤ') if ref $cgi::action;
	$is_valid = 0;
	delete $main::data{$this->{'id'} . '_photoSharingServiceRSS'};
}

#
$this->detag(\$main::data{$this->{'id'} . '_mimetype'}) if defined $main::data{$this->{'id'} . '_mimetype'} && $main::data{$this->{'id'} . '_mimetype'};
if ($main::data{$this->{'id'} . '_photoSharingServiceAccount'}) {
	$this->detag(\$main::data{$this->{'id'} . '_photoSharingServiceAccount'});
	$main::data{$this->{'id'} . '_photoSharingServiceAccount'} =~ s![\s/]+!!gs;
}

$this->escape(\$main::data{$this->{'id'} . '_rel'}) if defined $main::data{$this->{'id'} . '_rel'} && $main::data{$this->{'id'} . '_rel'};

$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
my $this = shift;
my $form = '<tr><td class="field-name"><span class="datatitle">' . $this->{'name'} . '</span></td><td class="field">';

if (!$this->{'comment'} || !$this->{'noFileSearchForm'}) {
	my($size,@mimename,$mime);
	@mimename = sort keys %{$this->{'mimename'}} if ref $this->{'mimename'} && %{$this->{'mimename'}};
	if (@mimename) {
		$size = @mimename;
		$size += 2;
		$size = 8 if $size > 8;
	}

	#ǥե
	$this->search_ext;
	$form .= '<select name="search:' . $this->{'id'} . ':type"' . (($size) ? ' size="' . $size . '" multiple="multiple"' : '') . '>';
	$form .= '<option value=""></option>' if !$size;

	#Ѹɽ
	if (defined $default::english && $default::english) {
		$form .= '<option value="!e"' . ((@{$this->{'filetype'}} && grep($_ eq '!e',@{$this->{'filetype'}})) ? ' selected="selected"' : '') . '>No file</option>';
		$form .= '<option value="-e"' . ((@{$this->{'filetype'}} && grep($_ eq '-e',@{$this->{'filetype'}})) ? ' selected="selected"' : '') . '>Some file</option>';
	
	#ܸ
	} else {
		$form .= '<option value="!e"' . ((@{$this->{'filetype'}} && grep($_ eq '!e',@{$this->{'filetype'}})) ? ' selected="selected"' : '') . '>ե̵</option>';
		$form .= '<option value="-e"' . ((@{$this->{'filetype'}} && grep($_ eq '-e',@{$this->{'filetype'}})) ? ' selected="selected"' : '') . '>եͭ</option>';
	}

	foreach $mime (@mimename) {
		$form .= '<option value="' . $mime . '"' . ((@{$this->{'filetype'}} && grep($_ eq $mime,@{$this->{'filetype'}})) ? ' selected="selected"' : '') . '>' . $this->{'mimename'}{$mime} . '</option>';
	}
	$form .= '</select>';

	if (defined $this->{'anyfile'} && $this->{'anyfile'}) {
		my $type = (defined $main::search{$this->{'id'}}{'ext'}) ? $this->escape($main::search{$this->{'id'}}{'ext'}) : '';

		#Ѹɽ
		if (defined $default::english && $default::english) {
			$form .= '<div class="extra-field"><label for="search:' . $this->{'id'} . ':ext">Extension</label> <input type="text" size="20" name="search:' . $this->{'id'} . ':ext" id="search:' . $this->{'id'} . ':ext" value="' . $type . '" /></div>';
			$form .= '<div class="note">ex) .gif .jpg etc..</div>';
		
		#ܸ
		} else {
			$form .= '<div class="extra-field"><label for="search:' . $this->{'id'} . ':ext">ĥһ</label> <input type="text" size="20" name="search:' . $this->{'id'} . ':ext" id="search:' . $this->{'id'} . ':ext" value="' . $type . '" /></div>';
			$form .= '<div class="note">ʣξϥڡǶڤ</div>';
		}
	}
}

#Ȥθ
if (defined $this->{'comment'} && $this->{'comment'}) {
	my($key,$checked);
	$key = (defined $main::search{$this->{'id'}}{'str'} && $main::search{$this->{'id'}}{'str'}) ? $this->escape($main::search{$this->{'id'}}{'str'}) : '';
	$checked = (defined $main::search{$this->{'id'}}{'i'} && $main::search{$this->{'id'}}{'i'}) ? ' checked="checked"' : '';
	$form .= '<div class="extra-field">';

	#Ѹɽ
	if (defined $default::english && $default::english) {
		$form .= '<label for="search:' . $this->{'id'}. ':str">Comment</label> ' if !defined $this->{'noFileSearchForm'} ||  !$this->{'noFileSearchForm'};
		$form .= '<input type="text" size="20" name="search:' . $this->{'id'} . ':str" id="search:' . $this->{'id'} . ':str" value="' . $key . '" />';
		$form .= $this->mk_select_menu(
			'search:' . $this->{'id'} . ':mode','','',$main::search{$this->{'id'}}{'mode'},
			'and'	=>		'Matches on all words',
			'or'	=>		'Matches on any word',
			'A'		=>		'Begins with any word',
			'Z'		=>		'Finishes with any word'
		);
		$form .= '</div>';
		$form .= '<div class="extra-field"><label><input type="checkbox" name="search:' . $this->{'id'} . ':i" value="1"' . $checked . ' /> Do case-insensitive pattern matching.</label></div>';

	#ܸ
	} else {
		$form .= '<label for="search:' . $this->{'id'}. ':str">ȸ</label> ' if !defined $this->{'noFileSearchForm'} ||  !$this->{'noFileSearchForm'};
		$form .= '<input type="text" size="20" name="search:' . $this->{'id'} . ':str" id="search:' . $this->{'id'} . ':str" value="' . $key . '" />';
		$form .= $this->mk_select_menu(
			'search:' . $this->{'id'} . ':mode','','',$main::search{$this->{'id'}}{'mode'},
			'and'	=>		'Ƥʸޤ',
			'or'	=>		'줫ʸޤ',
			'A'		=>		'줫ʸ󤫤Ϥޤ',
			'Z'		=>		'줫ʸǽ'
		);
		$form .= '</div>';
		$form .= '<div class="extra-field"><label><input type="checkbox" name="data:' . $this->{'id'} . ':i" value="1"' . $checked . ' /> ʸȾʸ̤ʤ</label></div>';
	}
}

return $form;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
sub get_enclosure_attributes ($$$$$) {
my($this,$str,$path,$c,$n) = @_;
my(%data,$size);
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return () if !$data{'type'};
$path = $path . '/' . $this->{'id'} . ((defined $data{'name'} && $data{'name'} ne '' && $data{'name'} !~ /\W/) ? '.' . $data{'name'} : '') . '.' . $data{'type'};
$size = -s $path;
return (
	'url'		=> $this->full_path($path),
	'length'	=> (($size) ? $size : ''),
	'type'		=> (($data{'type'}) ? (ref $this->{'ext_type'} && $this->{'ext_type'}{$data{'type'}}) ? $this->{'ext_type'}{$data{'type'}} : ($Common::mime_type{$data{'type'}}) ? $Common::mime_type{$data{'type'}} : 'application/octet-stream' : 'application/octet-stream')
);
}

######################################################################
sub editor_enabled ($) {
my $this = shift;
return ($this->{'importEnabled'} && ($this->{'photoSharingServiceName'} && $this->{'photoSharingServiceAccount'}) || $this->{'photoSharingServiceRSS'}) ? 1 : 0;
}

sub is_secure_user_for_edit ($) {
my $this = shift;
if ($this->{'refererCheck'}) {
	my $my_url = $this->my_url;
	return ($ENV{'HTTP_REFERER'} && $ENV{'HTTP_REFERER'} =~ /^\Q$my_url\E/) ? 1 : 0;
} else {
	return 1;
}
}

sub set_user_generated_field_editor_page_settings ($) {
my $this = shift;
	$setting::page{'ugfieldeditor'}{'title'} = 'ƥİ';
#	$setting::page{'ugfieldeditor'}{'text'} = '#000000'; 
#	$setting::page{'ugfieldeditor'}{'link'} = '#0000ff';
#	$setting::page{'ugfieldeditor'}{'alink'} = '#99ffff';
#	$setting::page{'ugfieldeditor'}{'vlink'} = '#000099';
#	$setting::page{'ugfieldeditor'}{'hover'} = '#00ffff';
#	$setting::page{'ugfieldeditor'}{'nodeco'} = 'no';
#	$setting::page{'ugfieldeditor'}{'bgcolor'} = '#ffffff';
#	$setting::page{'ugfieldeditor'}{'bodyId'} = 'image-viewer';
#	$setting::page{'ugfieldeditor'}{'cssFileName'} = '';
# 	$setting::page{'ugfieldeditor'}{'CSS'} = 'h1 { font-size: large; font-weight: bold; text-indent: 1em; font-family: "ҥ饮γѥ Pro W3",Osaka,"ͣ Хå",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'h2 { font-size: medium; font-weight: bold; font-family: "ҥ饮γѥ Pro W3",Osaka,"ͣ Хå",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'hr { border-width: 1 0 0 0; }';
# 	$setting::page{'ugfieldeditor'}{'background'} = '';
# 	$setting::page{'ugfieldeditor'}{'bgproperties'} = '';
# 	$setting::page{'ugfieldeditor'}{'topmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'leftmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'javascript'} = '';
# 	$setting::page{'ugfieldeditor'}{'header'} = '';
# 	$setting::page{'ugfieldeditor'}{'headerFileName'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImageAlign'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImage'} = '';
# 	$setting::page{'ugfieldeditor'}{'align'} = '';
# 	$setting::page{'ugfieldeditor'}{'width'} = '';
# 	$setting::page{'ugfieldeditor'}{'deco'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleText'} = '';
return 1;
}

sub print_user_generated_field_editor ($) {
my $this = shift;
my $site;
my $site_url;
my $hash;
my $items;
my $rss =	($this->{'photoSharingServiceRSS'}) ? $this->{'photoSharingServiceRSS'} :
			($this->{'photoSharingServiceName'} eq 'TwitPic') ? 'http://twitpic.com/photos/' . $this->{'photoSharingServiceAccount'} . '/feed.rss' :
			($this->{'photoSharingServiceName'} eq 'Twitgoo') ? 'http://twitgoo.com/u/' . $this->{'photoSharingServiceAccount'} . '/?format=rss' :
			($this->{'photoSharingServiceName'} eq 'Mobypicture') ? 'http://www.mobypicture.com/rss/' . $this->{'photoSharingServiceAccount'} . '/user.rss' :
			($this->{'photoSharingServiceName'} eq 'img.ly') ? 'http://img.ly/images/' . $this->{'photoSharingServiceAccount'} . '.rss' :
			($this->{'photoSharingServiceName'} eq 'flickr') ? 'http://api.flickr.com/services/feeds/photos_public.gne?id=' . $this->{'photoSharingServiceAccount'} . '&format=rss_200' :
			($this->{'photoSharingServiceName'} eq 'hatena') ? 'http://f.hatena.ne.jp/' . $this->{'photoSharingServiceAccount'} . '/rss' : '';

if ($rss) {
	require CMONOS::CGI_Lib::HTTP_Client;
	my $res = HTTP_Client->new->request('GET' => $rss);
	$hash = $res->hash('euc') if $res->is_success;
	if (ref $hash) {
		if (ref $hash->{'rss'}) {
			$site = $hash->{'rss'}->{'channel'}->{'title'} if defined $hash->{'rss'}->{'channel'}->{'title'};
			$site_url = $hash->{'rss'}->{'channel'}->{'link'} if defined $hash->{'rss'}->{'channel'}->{'link'};
			if (ref $hash->{'rss'}->{'channel'}->{'item'}) {
				$hash->{'rss'}->{'channel'}->{'item'} = [$hash->{'rss'}->{'channel'}->{'item'}] if ref $hash->{'rss'}->{'channel'}->{'item'} eq 'HASH';
				$items = $hash->{'rss'}->{'channel'}->{'item'};
			}
		} elsif (ref $hash->{'rdf:RDF'}) {
			$site = $hash->{'rdf:RDF'}->{'channel'}->{'title'} if defined $hash->{'rdf:RDF'}->{'channel'}->{'title'};
			$site_url = $hash->{'rdf:RDF'}->{'channel'}->{'link'} if defined $hash->{'rdf:RDF'}->{'channel'}->{'link'};
			if (ref $hash->{'rdf:RDF'}->{'item'}) {
				$hash->{'rdf:RDF'}->{'item'} = [$hash->{'rdf:RDF'}->{'item'}] if ref $hash->{'rdf:RDF'}->{'item'} eq 'HASH';
				$items = $hash->{'rdf:RDF'}->{'item'};
			}
		} elsif (ref $hash->{'feed'}) {
			$site = (ref $hash->{'feed'}->{'title'}) ? $hash->{'feed'}->{'title'}->{'value'} : $hash->{'feed'}->{'title'} if defined $hash->{'feed'}->{'title'};
			$site_url = $this->get_atom_value($hash->{'feed'}->{'link'},'html','href') if defined $hash->{'feed'}->{'link'};
			if (ref $hash->{'feed'}->{'entry'}) {
				$hash->{'feed'}->{'entry'} = [$hash->{'feed'}->{'entry'}] if ref $hash->{'feed'}->{'entry'} eq 'HASH';
				$items = $hash->{'feed'}->{'entry'};
			}
		}
	}
}
$setting::page{'ugfieldeditor'}{'title'} = $this->escape($site) . ' ' if $site;
my $css = <<CSS;
body {
  margin: 0;
  padding: 0;
  background: #FFF none;
}
p#summary {
  background-repeat: repeat-x;
  background-position: top;
  background-image: url('/lib/image/bg_plastic_light.gif');
  background-color: #f3f3f3;
  border: 1px solid #ddd;
  border-bottom-color: #bbb;
  padding: 10px 20px;
  text-align: center;
  color: #000000;
  margin: 0;
}
p#summary a {
  color: #000000;
  text-decoration: underline;
}
ul {
  margin: 0;
  padding: 0;
  list-style-type: none;
}
ul li {
  margin: 0;
  padding: 0;
  display: -moz-inline-box;
  display: inline-block;
  vertical-align: middle;
  /display: inline;
  /zoom: 1;
  _display: inline;
  _zoom: 1;
}
ul a {
  display: block;
  text-decoration: none;
  padding: 4px;
  border-radius: 4px;
  -moz-border-radius: 4px;
  -webkit-border-radius: 4px;
  -o-border-radius: 4px;
  -ms-border-radius: 4px;
}
ul a:hover, ul a.selected {
  background-color: #FF0;
}
ul a:active {
  background-color: #FFD;
}
ul a img {
  display: block;
  border: none;
}
CSS
$cgi::action->set_css($css);

if (ref $items) {
my $javascript = <<SCRIPT;
cmonos.form.setImageUrl = function (url,sample) {
	if (opener && opener.document.getElementById('data:$main::id:url')) {
		opener.document.getElementById('data:$main::id:url').value = url;
		cmonos.element.item(opener.document.getElementById('data:$main::id:url')).removeClassName('invalid-field');
		opener.document.getElementById('content-sample-$main::id').innerHTML = sample;
	} else {
		alert("ƤӽФեबߤĤޤ");
	}
	window.close();
};
SCRIPT
	$cgi::action->set_javascript($javascript);
}
$cgi::action->print_page_header('ugfieldeditor');
print '<p id="summary">';
print '<a href="' . $this->escape($this->image_url_encode($site_url)) . '" target="_blank">' if $site_url;
if ($site) {
	print $this->escape($site);
} else {
	print 'ƥ';
}
print '</a>' if $site_url;
print ' ';
print '</p>';
if (ref $items) {
	print '<ul>';
	foreach my $item (@{$items}) {
		my($url,$preview_url,$sample);
		if (ref $item->{'media:content'}) {
			$url = $item->{'media:content'}{'url'};
			next if $item->{'media:content'}{'type'} && $item->{'media:content'}{'type'} !~ m!^(?:image|video|audio)/!;
			$preview_url = (ref $item->{'media:thumbnail'} && $item->{'media:thumbnail'}{'url'}) ? $item->{'media:thumbnail'}{'url'} : $url;
			if ($url) {
				$url =~ s!/mini_([^/]+)$!/original_$1!;
				$url =~ s/_m(\.\w+)$/$1/;
			}
		} elsif ($item->{'hatena:imageurl'}) {
			$url = $item->{'hatena:imageurl'};
			$preview_url = ($item->{'hatena:imageurlmedium'}) ? $item->{'hatena:imageurlmedium'} : ($item->{'hatena:imageurlsmall'}) ? $item->{'hatena:imageurlsmall'} : $url;
		} elsif ($item->{'link'} && !ref $item->{'link'} && $item->{'link'} =~ m!https?://twitpic.com/([^/]+)!i) {
			$url = 'http://twitpic.com/show/full/' . $1 . '.jpg';
			$preview_url = ($item->{'description'} && !ref $item->{'description'} && $item->{'description'} =~ /<img src="(.*?)"/si) ? $1 : $url;
		} elsif (ref $item->{'enclosure'}) {
			$url = $item->{'enclosure'}{'url'};
			next if $item->{'enclosure'}{'type'} && $item->{'enclosure'}{'type'} !~ m!^(?:image|video|audio)/!;
			$preview_url = (ref $item->{'media:thumbnail'} && $item->{'media:thumbnail'}{'url'}) ? $item->{'media:thumbnail'}{'url'} : $url;
			if ($url) {
				$url =~ s!/mini_([^/]+)$!/original_$1!;
				$url =~ s/_m(\.\w+)$/$1/;
			}
		}
		next if !$url;
		$url = $this->image_url_encode($url);
		$preview_url = $this->image_url_encode($preview_url);
		$sample = '<a href="' . $this->escape($url) . '" target="_blank"><img src="' . $preview_url . '" style="border:none;max-width:240px;max-height:240px" /></a>';
		print '<li><a href="JavaScript:cmonos.form.setImageUrl(\'' . $this->escape($url) . '\',\'' . $this->escape($sample) . '\')" title="ΥƥĤɤ߹"><img src="' . $preview_url . '" /></a></li>';
	}
	print '</ul>';
}
$cgi::action->print_page_footer('ugfieldeditor');
return 1;
}

sub image_url_encode ($$) {
my($this,$text) = @_;
return '' if !defined $text || $text eq '';
$text = $this->jcode_convert($text,'utf8');
$text =~ s/([\x80-\xFF])/'%' . sprintf("%.2X", unpack("C", $1))/eg;
$text =~ s/\x20/+/g;
return $text;
}

sub get_atom_value ($$$$) {
my($this,$element,$type,$name) = @_;
return '' if !defined $element;
$element = [$element] if !ref $element || ref $element ne 'ARRAY';
foreach my $this_element (@$element) {
	if (defined $this_element->{'type'} && $this_element->{'type'} =~ /$type/ && defined $this_element->{$name}) {
		return $this_element->{$name};
	}
}
return '';
}

sub user_generated_field_edit ($) {
my $this = shift;
return 1;
}

sub get_query_for_editor ($;$$$) {
my($this,$c) = @_;
return '?m=UserGeneratedFieldEditor&k=ugfieldeditor&id=' . $this->{'id'}
	 . (($default::subdivided && defined $main::c) ? '&c=' . $main::c : '')
	 . (($main::m && $main::m !~ /\W/ && $main::m ne 'UserGeneratedFieldEditor') ? '&mod=' . $main::m : ($main::mod && $main::mod !~ /\W/ && $main::mod ne 'UserGeneratedFieldEditor') ? '&mod=' . $main::mod : '')
	 . (($main::p && $main::p !~ /\W/) ? '&p=' . $main::p : '');
}

######################################################################
#sub import {
BEGIN {
Field::class_register('file','FileUL','եź');
}

1;
