package UserGeneratedField;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# ե⥸塼ʥ桼եɡ
# UserGeneratedField.pm 1.0.17
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-06-14
######################################################################
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

# DAT񤭤Υ⡼ɤΤɬ
sub set_ownerpower ($) {
my $this = shift;
if (!defined $env::ownerpower || $env::ownerpower eq '') {
	my $uid = (stat('./start.cgi'))[4];
	$env::ownerpower = ($uid ne $> && $uid ne $<) ? 0 : 1;		
}
}

sub set_external_file_status ($) {
my $this = shift;
if ($default::static) {
	$this->{'externalFileDisabled'} = 0;
} elsif ($this->{'Hidden'} || (defined $this->{'Open'} && $this->{'Open'} == 0) || !defined $this->{'externalFileDisabled'}) {
	$this->{'externalFileDisabled'} = 1;
}
return;
}

# obj->is_secure;
sub is_as_secure_as ($$;$) {
my($this,$check_level,$secure_email) = @_;

#ѥɥå
if (!defined $check_level || $check_level eq '' || $check_level eq 'master') {
	if ($this->is_master) {
		return 1;
	} else {
		return 0;
	}

#ʡѥɥå
} elsif ($check_level eq 'owner') {
	if ($this->is_owner) {
		return 1;
	} else {
		push(@{$cgi::action->{'dialog'}},$cgi::Register->error_dialog) if ref $cgi::action && ref $cgi::Register;
		return 0;
	}

#Ʊʡѥɥå
} elsif ($check_level eq 'owners') {
	if ($this->is_one_of_owners) {
		return 1;
	} else {
		push(@{$cgi::action->{'dialog'}},$cgi::Register->error_dialog) if ref $cgi::action && ref $cgi::Register;
		return 0;
	}

#Ͽѥɥå
} elsif ($check_level eq 'member') {
	if (ref $secure_email && $this->is_authorized(@$secure_email)) {
		return 1;
	} elsif ((!defined $secure_email || !ref $secure_email) && $this->is_registered_user) {
		return 1;
	} else {
		push(@{$cgi::action->{'dialog'}},$cgi::Register->error_dialog) if ref $cgi::action && ref $cgi::Register;
		return 0;
	}

#åʤ
} elsif ($check_level eq 'nocheck') {
	return 1;
}

return 0;
}

sub unauthorized_alert ($) {
my $this = shift;
if (ref $cgi::action) {
	$cgi::action->print_password_check_form($setting::key);
} else {
	$this->error404;
}
}

sub get_user_generated_field_editor_url ($;$$$) {
my($this,$is_http_url,$c,$n) = @_;
return (($is_http_url) ? $this->my_url : $ENV{'SCRIPT_NAME'}) . $this->get_query_for_user_generated_field_editor(0,$c,$n);
}

sub get_query_for_user_generated_field_editor ($;$) {
my($this,$for_post) = @_;
return '';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
return 1 if defined $main::search{$this->{'id'}}{'check'} && $main::search{$this->{'id'}}{'check'} ne '';
return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
return 1 if !defined $main::search{$this->{'id'}}{'check'} || $main::search{$this->{'id'}}{'check'} eq '';
my(%data,$field_enabled);
%data = $this->elements($$str);
$field_enabled = (defined $data{'memory'} && ($data{'memory'} eq '' || $data{'memory'} > 0)) ? 1 : 0;
if (($main::search{$this->{'id'}}{'check'} && $field_enabled) || (!$main::search{$this->{'id'}}{'check'} && !$field_enabled)) {
	return 1;
} else {
	return 0;
}
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status,$original,$path) = @_;
if ($main::option{$this->{'id'}}{'rebuild'} && $path && $path !~ m!/$! && -f $path . '/' . $this->{'id'} . '.ssi' && ($this->field_memory_required || !defined $this->{'masterMemory'} || $this->{'masterMemory'} ne '0' || -s $path . '/' . $this->{'id'} . '.ssi')) {
	$this->set_embed_files($main::data{$this->{'id'}}{'memory'},$main::data{$this->{'id'}},$path,$main::c,$main::n);
}
$this->pre_form_option($path);

#եɥ͡+إå
my $form = '';

#
if ($this->field_memory_required || !defined $this->{'masterMemory'} || $this->{'masterMemory'} eq '' || $this->{'masterMemory'}) {
	$form .= '<tr><td class="sub-field-name"><label for="data:' . $this->{'id'} . ':memory">¸</label></td><td class="sub-field"><input type="text" size="3" maxlength="3" name="data:' . $this->{'id'} . ':memory" id="data:' . $this->{'id'} . ':memory" value="' . ((defined $main::data{$this->{'id'}}{'memory'}) ? $main::data{$this->{'id'}}{'memory'} : ($this->{'masterMemory'} && $this->{'masterMemory'} < 100) ? $this->{'masterMemory'} : '100') . '"' . (($this->{'is_invalid_field'}{'memory'}) ? $this->set_invalid_class : '') . ' /><span class="unit"></span> <span class="note">(' . (($this->{'masterMemory'}) ? '' . $this->{'masterMemory'} . ' / ' : '') . '' . (($this->{'masterMemory'}) ? $this->{'masterMemory'} . '' : '̵') . ' / 0 = ' . $this->name(1) . 'ĺ)</span></td></tr>';
}

#᡼ǽ
if ($this->{'mailToUser'}) {
	$form .= '<tr><td class="sub-field-name"><label for="data:' . $this->{'id'} . ':mailto">εǽ</label></td><td class="sub-field">';
	$form .= '<select name="data:' . $this->{'id'} . ':mailto" id="data:' . $this->{'id'} . ':mailto">';
	$form .= '<option value=""' . ((!defined $main::data{$this->{'id'}}{'mailto'} || $main::data{$this->{'id'}}{'mailto'} eq '') ? ' selected="selected"' : '') . '></option>';
	if (defined $this->{'mailToUser'} && $this->{'mailToUser'}) {
		foreach my $id (sort {$this->{'field_obj'}->{$a}->{'ORDER'} <=> $this->{'field_obj'}->{$b}->{'ORDER'} || $a <=> $b} keys %{$this->{'field_obj'}}) {
			$form .= '<option value="' . $id . '"' . ((!defined $main::data{$this->{'id'}}{'mailto'} || $main::data{$this->{'id'}}{'mailto'} eq $id) ? ' selected="selected"' : '') . '>' . $this->{'field_obj'}->{$id}->{'name'} . ' </option>' if ref $this->{'field_obj'}->{$id} && $this->{'field_obj'}->{$id}->{'e-mail'};
		}
		$form .= '<option value="master"' . ((!defined $main::data{$this->{'id'}}{'mailto'} || $main::data{$this->{'id'}}{'mailto'} eq 'master') ? ' selected="selected"' : '') . '>ͥɥ쥹 </option>' if $this->{'mailtoMaster'} || $this->{'mailtoOwners'};
	}
	$form .= '</select>';
	$form .= '</td></tr>';
}

if (!$this->{'externalFileDisabled'} && -f $path . '/' . $this->{'id'} . '.ssi' && ($this->field_memory_required || !defined $this->{'masterMemory'} || $this->{'masterMemory'} ne '0' || -s $path . '/' . $this->{'id'} . '.ssi')) {
	$form .= '<tr><td class="sub-field-name"><span class="datatitle">' . $this->name(1) . 'ƹ</span></td>';
	$form .= '<td class="sub-field"><label><input type="checkbox" name="option:' . $this->{'id'} . ':rebuild" value="1" /> ' . $this->name(1) . 'ƹۤ</label></td></tr>';
}
if (-f $path . '/' . $this->{'id'} . '.dat') {
	$form .= '<tr><td class="sub-field-name"><span class="datatitle">' . $this->name(1) . 'Խ</span></td>';
	$form .= '<td class="sub-field">' . $this->field_editor_link($this->name(1) . 'Խɥ򳫤') . '</td></tr>';
}
$form .= $this->additional_form($path);
return ($form) ? $this->field_header . '<table class="sub-field-table"><tbody>' . $form . '</tbody></table>' . $this->field_footer : '';
}

sub field_memory_required ($) {
my $this = shift;
return 1;
}

sub pre_form_option ($$) {
my $this = shift;
}

sub additional_form ($) {
my $this = shift;
my $form = '';
if ($this->{'pendingEnabled'}) {
	$form .= '<tr><td class="sub-field-name"><span class="datatitle">ɽΥߥ</span></td>';
	$form .= '<td class="sub-field"><label><input type="checkbox" name="data:' . $this->{'id'} . ':approvalRequired" value="1"' . (($main::data{$this->{'id'}}{'approvalRequired'}) ? ' checked="checked"' : '') . ' /> ǧޤɽʤ</label></td></tr>';
}
return $form;
}

sub field_editor_link ($$;$$$) {
my($this,$name,$id,$style,$c,$n) = @_;
return '<a href="' . $this->escape($this->get_user_generated_field_editor_url(0,$c,$n)) . '" target="UserGeneratedFieldEditor"' . (($id) ? ' id="' . $id . '"' : '') . (($style) ? ' style="' . $style . '"' : '') . ' onclick="cmonos.window.open(\'UserGeneratedFieldEditor\',640,600)">' . $name . '</a>';
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my($this,$path) = @_;
my $is_valid = 1;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
if ($main::data{$this->{'id'}}{'memory'} && $this->is_nan($main::data{$this->{'id'}}{'memory'})) {
	push(@{$cgi::action->{'dialog'}},'¸ǧƤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'memory'} = 1;
	$main::data{$this->{'id'}}{'memory'} = '';
	$is_valid = 0;
}
if (!$this->field_memory_required && defined $this->{'masterMemory'} && $this->{'masterMemory'} eq '0') {
	$main::data{$this->{'id'}}{'memory'} = 0;
} elsif ($main::data{$this->{'id'}}{'memory'} && $this->{'masterMemory'} && $main::data{$this->{'id'}}{'memory'} > $this->{'masterMemory'}) {
	push(@{$cgi::action->{'dialog'}},$this->name . ' ¸ޥ¸ĶƤޤ' . $this->{'masterMemory'} . 'ʲˤƤ') if ref $cgi::action;
	$this->{'is_invalid_field'}{'memory'} = 1;
	$main::data{$this->{'id'}}{'memory'} = $this->{'masterMemory'};
	$is_valid = 0;
}
if (!$this->{'mailtoMaster'} && !$this->{'mailtoOwners'} && !$this->{'mailToUser'}) {
	$main::data{$this->{'id'}}{'mailto'} = '';
} elsif (!$this->{'mailToUser'} && (!defined $main::data{$this->{'id'}}{'mailto'} || $main::data{$this->{'id'}}{'mailto'} ne 'master')) {
	$main::data{$this->{'id'}}{'mailto'} = 'master';
}
$main::data{$this->{'id'}}{'approvalRequired'} = '' if !$this->{'pendingEnabled'} || !$main::data{$this->{'id'}}{'approvalRequired'};
$is_valid = 0 if !$this->_is_valid_data($path);
$this->data if $is_valid;
return $is_valid;
}

sub _is_valid_data ($;$) {
my $this = shift;
return 1;
}

sub get_user_generated_field_data ($$$$;$$) {
my($this,$memory,$data_ref,$path,$c,$n) = @_;
return '';
}

sub get_query_keys ($) {
my $this = shift;
return [];
}

sub add_query_for_form ($;$$) {
my($this,$c,$n) = @_;
return '';
}

sub get_output_path ($) {
my $this = shift;
if ($default::static) {
	return ($default::file) ? $default::file : (!$master::home || $master::home eq $default::home) ? $default::home . ((defined $main::c && $main::c ne '') ? '/' . $main::c : '') . '/' . $main::n . '/index.html' : $default::home . '/' . $main::n . '/index.html';
} else {
	return '';
}
}

sub get_user_generated_field_data_for_text ($$$$) {
my($this,$memory,$data_ref,$path) = @_;
return '';
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=ɽǡ/path=ե¸ǥ쥯ȥ
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
$this->set_embed_files($data{'memory'},\%data,$path,$c,$n,0,1,1);
return $this->field_tag(
	$this->data_tag_from_ref(\%data)
		. ((defined $data{'memory'} && $data{'memory'} eq '0') ? '' : 
			($this->{'externalFileDisabled'} || (!$default::static && $this->{'update_is_failed'})) ? $this->get_user_generated_field_data($data{'memory'},\%data,$path,$c,$n) : $this->include_external_file($path . '/' . $this->{'id'} . '.ssi',1,$this->get_output_path,(($default::static) ? 0 : 1))
		),
	((defined $data{'memory'} && $data{'memory'} eq '0') ? 1 : 0)
);
}

sub has_content {
my($this,$str) = @_;
return 1 if !defined $str || $str eq '';
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return (%data && defined $data{'memory'} && $data{'memory'} eq '0') ? 0 : 1;
}

sub set_embed_files ($$$$$$;$$$) {
my($this,$memory,$data_ref,$path,$c,$n,$get_content,$set_dir,$init_flag) = @_;
my $content = '';
if ($this->{'externalFileDisabled'} || (defined $memory && $memory eq '0')) {
	if (-d $path || ($set_dir && $this->set_dir($path))) {
		if (!-f $path . '/' . $this->{'id'} . '.ssi' || -s $path . '/' . $this->{'id'} . '.ssi') {
			$this->write_file($path . '/' . $this->{'id'} . '.js','',1);
			$this->write_file($path . '/' . $this->{'id'} . '.ssi','',1);
		}
	}
	$content = $this->get_user_generated_field_data($memory,$data_ref,$path,$c,$n,1) if $get_content;
} elsif (!$init_flag || $cgi::on_refreshing || !-f $path . '/' . $this->{'id'} . '.ssi' || !-s $path . '/' . $this->{'id'} . '.ssi') {
	if (-d $path || ($set_dir && $this->set_dir($path))) {
		my $data = '';
		($data,$content) = $this->get_user_generated_field_data($memory,$data_ref,$path,$c,$n);
		$this->write_file($path . '/' . $this->{'id'} . '.ssi',\$data,1);
		$this->mk_external_javascript($path . '/' . $this->{'id'} . '.ssi',$path . '/' . $this->{'id'} . '.js',$data);
	}
}
return $content;
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
my($this,$str,$path) = @_;
return '' if !defined $str || $str eq '';
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return (!defined $data{'memory'} || $data{'memory'} ne '0') ? '[' . $this->name . "]\x0A" . (($path) ? $this->get_user_generated_field_data_for_text($data{'memory'},\%data,$path) : (($default::english) ? 'yes' : '') . "\x0A\x0A") : '';
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
my($this,$str,$path) = @_;
return '' if !defined $str ||  $str eq '';
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return (!defined $data{'memory'} || $data{'memory'} ne '0') ? (($path) ? $this->get_user_generated_field_data_for_text($data{'memory'},\%data,$path) : (($default::english) ? 'yes' : '')) : '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$) {
my($this,$str) = @_;
return '' if !defined $str ||  $str eq '';
my(%data,$form);
%data = $this->elements($str);
$form = '<dl class="input-confirmation">';
$form .= '<dt>¸</dt><dd>' . $data{'memory'} . '</dd>';
$form .= '<dt>εǽ</dt><dd>' . (($data{'mailto'} eq '') ? '' : (($data{'mailto'} eq 'master') ? 'ͥɥ쥹 ' : ((ref $this->{'field_obj'}->{$data{'mailto'}}) ? $this->{'field_obj'}->{$data{'mailto'}}->{'name'} . ' ' : ''))) . '</dd>' if $this->{'mailToUser'};
$form .= '<dt>ɽΥߥ</dt><dd>ǧޤɽʤ</dd>' if$this->{'pendingEnabled'} && $data{'approvalRequired'} ;
$form .= $this->_confirmation(\%data);
$form .= '</dl>';
return $form;
}

sub _confirmation ($$) {
my($this,$data) = @_;
return '';
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_sub_setting ($) {
my $this = shift;
my $is_valid = 1;
$this->tag_fix(\$main::data{$this->{'id'} . '_template'}) if defined $main::data{$this->{'id'} . '_template'} && $main::data{$this->{'id'} . '_template'};

$is_valid = 0 if !$this->_is_valid_sub_setting;
if (defined $main::data{$this->{'id'} . '_masterMemory'} && $main::data{$this->{'id'} . '_masterMemory'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_masterMemory'})) {
	push(@{$cgi::action->{'dialog'}},'¸򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_masterMemory'};
	$is_valid = 0;
} elsif ($this->field_memory_required && defined $main::data{$this->{'id'} . '_masterMemory'} && $main::data{$this->{'id'} . '_masterMemory'} eq '0') {
	push(@{$cgi::action->{'dialog'}},'¸򹹿ǤޤǤ0 礭ʿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_masterMemory'};
	$is_valid = 0;
}
if (defined $main::data{$this->{'id'} . '_datelimit'} && $main::data{$this->{'id'} . '_datelimit'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_datelimit'})) {
	push(@{$cgi::action->{'dialog'}},'򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_datelimit'};
	$is_valid = 0;
}

#åܥå
$main::data{$this->{'id'} . '_type'} = '' if !defined $main::data{$this->{'id'} . '_type'} || !$main::data{$this->{'id'} . '_type'};
$main::data{$this->{'id'} . '_pendingEnabled'} = '' if !defined $main::data{$this->{'id'} . '_pendingEnabled'} || !$main::data{$this->{'id'} . '_pendingEnabled'};
$main::data{$this->{'id'} . '_externalFileDisabled'} = 0 if !defined $main::data{$this->{'id'} . '_externalFileDisabled'} || !$main::data{$this->{'id'} . '_externalFileDisabled'};
$main::data{$this->{'id'} . '_mTime'} = '' if !defined $main::data{$this->{'id'} . '_mTime'} || !$main::data{$this->{'id'} . '_mTime'};
$main::data{$this->{'id'} . '_mailtoMaster'} = '' if !defined $main::data{$this->{'id'} . '_mailtoMaster'} || $main::data{$this->{'id'} . '_mailtoMaster'} eq '';
$main::data{$this->{'id'} . '_mailtoOwners'} = '' if !defined $main::data{$this->{'id'} . '_mailtoOwners'} || $main::data{$this->{'id'} . '_mailtoOwners'} eq '';
$main::data{$this->{'id'} . '_mailToUser'} = '' if !defined $main::data{$this->{'id'} . '_mailToUser'} || $main::data{$this->{'id'} . '_mailToUser'} eq '';

return $is_valid;
}

sub _is_valid_sub_setting ($) {
my $this = shift;
return 1;
}

######################################################################
#	obj->search_form;
sub search_form ($) {
my $this = shift;
return '<tr><td class="field-name"><label for="search:' . $this->{'id'} . ':check">' . $this->name . '</label></td><td class="field">'
	. $this->mk_select_menu(
		'search:' . $this->{'id'} . ':check','','',$main::search{$this->{'id'}}{'check'},
		''	=>  '',
		'1'	=>  (($default::english) ? 'ON' : 'ͭ'),
		'0'	=>  (($default::english) ? 'OFF' : '̵')
	)
	. '</td></tr>';
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
sub update_enabled ($) {
my $this = shift;
return 1;
}

######################################################################
sub editor_enabled ($) {
my $this = shift;
return 1;
}

######################################################################
sub get_invalid_field_list ($$) {
my($this,$prefix) = @_;
return '' if !defined $this->{'is_invalid_field'} || !ref $this->{'is_invalid_field'};
my @invalid_fields = map {$prefix . ':' . $_} keys %{$this->{'is_invalid_field'}};
delete $this->{'is_invalid_field'};
return (@invalid_fields) ? join(';',@invalid_fields) : '';
}

sub get_message_string ($) {
my $this = shift;
if (ref $cgi::action) {
	my @message = $cgi::action->dialog;
	if (@message) {
		map {
			$_ =~ s/\\n//g;
			$_ =~ s/;//g;
		} @message;
		return join(';',@message);
	}
}
return '';
}

sub get_authorized_level ($) {
my $this = shift;
if ($this->is_master) {
	return 4;
} elsif ($this->is_owner) {
	return 3;
} elsif ($this->is_one_of_owners) {
	return 2;
} elsif ($this->is_registered_user) {
	return 1;
} else {
	return 0;
}
}

sub save_pending_db ($$$) {
my($this,$editor_url,$record_title) = @_;
my @pending_db = ($env::pending_db);
my $time = time;
my $title = '';
if ($default::subdivided && $default::master_preference_dir && $default::master_preference_dir ne $default::preference_dir) {
	$this->import_db($default::master_preference_dir . '/general', \%master::general,1) if !%master::general;
	$title .= (($title ne '') ? ':' : '') . $master::general{'cginame'} if defined $master::general{'cginame'} && $master::general{'cginame'} ne '';
	push(@pending_db,$default::master_preference_dir . '/pending');
}
$title .= (($title ne '') ? ':' : '') . $setting::general{'cginame'} if defined $setting::general{'cginame'} && $setting::general{'cginame'} ne '';
$title .= (($title ne '') ? ':' : '') . $record_title if defined $record_title && $record_title ne '';
$title .= '(' . $this->name . ')';
push(@pending_db,$default::preference_dir . '/pending') if $default::preference_dir;
foreach my $db (@pending_db) {
	my(%pending);
	tie(%pending, $env::dbm_file, $db, O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %pending) {
		$pending{$editor_url} = $time . "\x09" . $title;
	}
	untie %pending;
}
}

sub delete_pending_item ($$) {
my($this,$editor_url) = @_;
my @pending_db = ($env::pending_db);
my $time = time;
push(@pending_db,$default::master_preference_dir . '/pending') if $default::subdivided && $default::master_preference_dir && $default::master_preference_dir ne $default::preference_dir;
push(@pending_db,$default::preference_dir . '/pending') if $default::preference_dir;
foreach my $db (@pending_db) {
	my(%pending);
	tie(%pending, $env::dbm_file, $db, O_RDWR, $env::dbm_mode);
	if (ref tied %pending) {
		delete $pending{$editor_url};
	}
	untie %pending;
}
}

sub get_value_by_key ($$$) {
my($this,$db,$key) = @_;
my(%db,$data);
tie(%db, $env::dbm_file, $db, O_RDONLY, $env::dbm_mode);
if (ref tied %db) {
	$data = $db{$key};
}
untie %db;
return ($data) ? $data : '';
}

######################################################################
sub navi_update ($$$$$$;$) {
my($this,$new_item,$viewer_url,$delete_this) = @_;
my($tag,$file_name,$setting_name) = $this->get_navi_info;
my $new_id = (ref $new_item || $delete_this) ? $this->mk_user_generated_field_id($main::c,$main::n) : '';
my @navifiles = ({'path' => $env::externalfiles . '/' . $file_name,'template' => ''},$this->get_additional_recent_item_list($file_name,$setting_name));
my $http_domain = $this->http_my_domain;
$viewer_url =~ s/^$http_domain//;
foreach my $i (@navifiles) {
	my $data = $this->read_file($i->{'path'},1);
	my $template = $this->get_recent_items_template($tag,$i->{'template'},$data);
	my $limit = $this->get_limit_from_template($tag,\$template);
	my $item_template = ($template =~ /<!--article(?!\w)([^>]*)-->(.*?)<!--\/article-->/s) ? $this->include_header_and_footer($1,$2) : '<!--title--><!--/title-->';
	my $count = 0;
	my $new_data = (ref $new_item && ++$count) ? '<!--article id="' . $new_id . '"-->' . $this->mk_recent_items_article($new_item,$item_template,$viewer_url) . '<!--/article-->' : '';
	ARTICLE:
	while ($data =~ /<!--article(?!\w)([^>]*)-->(.*?)<!--\/article-->/sg) {
		my($setting,$article_data) = ($1,$2);
		my $id = ($setting =~ /\s+id="(.*?)"/) ? $1 : '';
		next ARTICLE if $id eq '' || ($new_id ne '' && $id eq $new_id);
		$new_data .= '<!--article id="' . $id . '"-->' . $this->mk_recent_items_article($this->get_array_from_template($article_data),$item_template) . '<!--/article-->';
		last ARTICLE if ++$count >= $limit;
	}
	if ($new_data) {
		$template =~ s/<!--$tag(?!\w)([^>]*)-->(.*?)<!--\/$tag-->/$this->include_header_and_footer($1,$2,$tag)/sge;
		$template =~ s/<!--article(?!\w)[^>]*-->.*<!--\/article-->/$new_data/s;
	}
	$this->write_file($i->{'path'},\$template,1);
	$this->mk_external_javascript($i->{'path'},'',$template);
}
}

sub get_additional_recent_item_list ($$$) {
my $this = shift;
return ();
}

sub get_limit_from_template ($$) {
my($this,$tag,$template) = @_;
if ($$template =~ /<!--$tag(?!\w)([^>]*)-->/s) {
	my $setting = $1;
	return $1 if $setting =~ /\s+limit="(\d+)"/s;
}
return 10;
}

sub get_recent_items_template ($$;$$) {
my($this,$tag,$template,$recent_items) = @_;
if ($template) {
	$template = '<!--article-->' . $template . '<!--/article-->' if $template !~ /<!--article(?!\w)[^>]*-->/s;
	$template = '<!--' . $tag . ' limit="10"-->' . $template . '<!--/' . $tag . '-->' if $template !~ /<!--$tag(?!\w)[^>]*-->/s;
	return $template;
} else {
	if ($recent_items) {
		require CMONOS::CGI_Lib::IndexSweeper;
		return IndexSweeper->new->_mk_template_from($recent_items);
	} else {
return <<TEMPLATE;
<!--$tag limit="10"-->
<!--head-->
<ul class="index">
<!--/head-->
<!--article--><!--head-->
<li>
<!--/head-->
<!--title maxlength="32"--><!--/title-->
<!--foot-->
</li>
<!--/foot-->
<!--/article--><!--foot-->
</ul>
<!--/foot-->
<!--/$tag-->
TEMPLATE
	}
}
}

######################################################################
sub is_short_parameters ($) {
return 0;
}

sub get_field_data ($) {
my $this = shift;
return {};
}

sub get_file_directory ($) {
my $this = shift;
return '.';
}

sub get_db_directory ($) {
my $this = shift;
return '.';
}

sub get_all_mail_field_data_list ($) {
my $this = shift;
my @addr = ();
my($id,$field);
while (($id,$field) = each %{$this->{'field_obj'}}) {
	push(@addr,$this->get_mail_field_data($id)) if $field->{'class'} =~ /email/;
}
return $this->get_address(@addr);
}

sub get_mail_field_data ($$) {
my($this,$mailto) = @_;
return '';
}

sub get_title_field_data ($$) {
my $this = shift;
return '';
}

sub get_viewer_url ($;$$) {
my $this = shift;
return '';
}

sub get_trackback_url ($;$$) {
my($this,$c,$n) = @_;
return '';
}

######################################################################
sub is_editable ($) {
my $this = shift;
$this->mk_settings_for_editor;
if (%main::data) {
	$this->delete_pending_item($this->get_user_generated_field_editor_url(1)) if !$this->{'delete_only'};
	my($id,$action,$editable);
	while (($id,$action) = each %main::data) {
		if ($action) {
			$editable = 1;
			last;
		}
	}
	return 0 if !$editable;
} else {
	return 0;
}
return 1;
}

sub mk_settings_for_editor ($) {
my $this = shift;
return 1 if ref $this->{'field_data'};
$this->{'field_data'} = $this->get_field_data;
$this->{'file_directory'} = $this->get_file_directory;
$this->{'dat_path'} = $this->{'file_directory'} . '/' . $this->{'id'} . '.dat';
if (!$this->is_as_secure_as('member',[$this->get_all_mail_field_data_list])) {
	if ($this->{'deletable'}) {
		$this->{'delete_only'} = 1;
	} else {
		$this->unauthorized_alert;
	}
}
return 1;
}

sub rm_settings_for_editor ($) {
my $this = shift;
delete $this->{'field_data'};
delete $this->{'file_directory'};
delete $this->{'dat_path'};
delete $this->{'delete_only'};
return 1;
}

sub print_user_generated_field_editor ($) {
my $this = shift;
return 1;
}

sub user_generated_field_edit ($) {
my $this = shift;
return 1;
}

sub is_secure_user_for_update ($) {
my $this = shift;
return (!$this->is_short_parameters && (!$this->{'generatableUser'} || $this->is_as_secure_as($this->{'generatableUser'}))) ? 1 : 0;
}

sub is_secure_user_for_edit ($) {
my $this = shift;
if ($this->is_short_parameters) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Prameters is short.' : 'ɬפǤޤǤ')) if ref $cgi::action;
	return 0;
}
return ($this->is_secure_user_for_update && $this->is_as_secure_as('member')) ? 1 : 0;
}

######################################################################
sub feed_field_rss ($$$) {
my($this,$file_name,$item) = @_;
my($rss_dir,$link,$master_rss_dir,$master_link) = $this->get_rss_path;
return 0 if !defined $item || ref $item ne 'HASH' || (!$item->{'link'} && !ref $item->{'delete'} && !ref $item->{'delete_prefix'});
my $favicon_url = $this->full_path($this->favicon_path);
my $favicon = ($favicon_url) ? {'value' => {'url' => $favicon_url}} : '';
my $delete_only = (((ref $item->{'delete'} && @{$item->{'delete'}}) || (ref $item->{'delete_prefix'} && @{$item->{'delete_prefix'}})) && !$item->{'link'}) ? 1 : 0;
my $rss_name = $this->get_rss_name;
my $rss_type = ($file_name ne 'index') ? ucfirst $file_name : '';
require CMONOS::CGI_Lib::Feed::RSS2_0;
delete $item->{'enclosure'} if ref $item->{'enclosure'} && !$item->{'enclosure'}{'url'};

#ΥRSS
my $title = ((defined $env::title && $env::title ne '') ? $env::title : '');
my $copyright = (defined $env::copyright && $env::copyright ne '') ? $env::copyright : '';
if ($setting::general{'siteRSSEnabled'} || $setting::general{'commentRSSEnabled'}) {
	RSS2_0->new(
		'path'					=>	'../../' . $file_name . '.xml',
		'maxitem'				=>	(($env::rss_maxitem) ? $env::rss_maxitem : 15),
		'description_maxlength'	=>	(($env::rss_description_maxlength) ? $env::rss_description_maxlength : 128),
		'delete_only'			=>	$delete_only,
		'xmlns'					=>	{'content' 	=>	'http://purl.org/rss/1.0/modules/content/'},
		'utm_medium'			=>	'Site' . (($rss_type) ? '(' . $rss_type . ')' : ''),
		'channel_element'		=>	{
										'title'			=>	(($title ne '') ? $title . ':' . $rss_name : '' . $rss_name),
										'link'			=>	$this->home_location,
										'description'	=>	'' . $rss_name . 'Ǥ',
										'copyright'		=>	$copyright,
										'image'			=>	$favicon,
									},
	)->update($item);
}

#ޥRSS
my $cgi_id = ($default::id) ? $default::id : '';
$cgi_id =~ s/^_//;
$cgi_id =~ s/_/:/g;
if ($master_rss_dir && defined $main::c && $main::c ne '' && $this->set_dir($master_rss_dir)) {
	my $description = '';
	my $icon = '';
	if ($default::subdivided && $default::master_preference_dir) {
		$this->import_db($default::master_preference_dir . '/general', \%master::general,1) if !%master::general;
		$title .= (($title ne '') ? ':' : '') . $master::general{'cginame'} if defined $master::general{'cginame'} && $master::general{'cginame'} ne '';
		$copyright .= (($copyright ne '') ? '/' : '') . $master::general{'mastername'} if defined $master::general{'mastername'} && $master::general{'mastername'} ne '';
		$icon = ($master::general{'icon'} && -f $master_rss_dir . '/' . $master::general{'icon'}) ? {'value' => {'url' => $this->full_path($master_rss_dir . '/' . $master::general{'icon'})}} : $favicon;
		$description = $master::general{'description'} if defined $master::general{'description'};
	} else {
		$title .= (($title ne '') ? ':' : '') . $setting::general{'cginame'} if defined $setting::general{'cginame'} && $setting::general{'cginame'} ne '';
		$copyright .= (($copyright ne '') ? '/' : '') . $setting::general{'mastername'} if defined $setting::general{'mastername'} && $setting::general{'mastername'} ne '';
		$icon = ($setting::general{'icon'} && -f $master_rss_dir . '/' . $setting::general{'icon'}) ? {'value' => {'url' => $this->full_path($master_rss_dir . '/' . $setting::general{'icon'})}} : $favicon;
		$description = $setting::general{'description'} if defined $setting::general{'description'};
		$rss_name = $this->name(1);
	}
	if ($setting::general{'masterRSSEnabled'}) {
		RSS2_0->new(
			'path'					=>	$master_rss_dir . '/' . $file_name . '.xml',
			'maxitem'				=>	(($env::rss_maxitem) ? $env::rss_maxitem : 15),
			'description_maxlength'	=>	(($env::rss_description_maxlength) ? $env::rss_description_maxlength : 128),
			'delete_only'			=>	$delete_only,
			'xmlns'					=>	{'content' 	=>	'http://purl.org/rss/1.0/modules/content/'},
			'utm_medium'			=>	$cgi_id . (($rss_type) ? '(' . $rss_type . ')' : ''),
			'channel_element'		=>	{
											'title'			=>	(($title ne '') ? $title . ':' . $rss_name : '' . $rss_name),
											'link'			=>	$master_link,
											'description'	=>	'' . $rss_name . 'Ǥ',
											'copyright'		=>	$copyright,
											'image'			=>	((ref $icon) ? $icon : $favicon),
										},
		)->update($item);
	}
}

#RSS
if ($rss_dir && $setting::general{'RSSEnabled'} && $this->set_dir($rss_dir)) {
	if ($master_rss_dir && defined $main::c && $main::c ne '' && !$default::subdivided) {
		$this->import_db($default::preference_dir . '/category',\%setting::category,1) if !%setting::category;
		$title .= (($title ne '') ? ':' : '') . $setting::category{$main::c}{'name'} if ref $setting::category{$main::c} && $setting::category{$main::c}{'name'};
	} else {
		$copyright .= (($copyright ne '') ? '/' : '') . $setting::general{'mastername'} if defined $setting::general{'mastername'} && $setting::general{'mastername'} ne '';
		$title .= (($title ne '') ? ':' : '') . $setting::general{'cginame'} if defined $setting::general{'cginame'} && $setting::general{'cginame'} ne '';
	}
	my $icon = ($setting::general{'icon'} && -f $rss_dir . '/' . $setting::general{'icon'}) ? {'value' => {'url' => $this->full_path($rss_dir . '/' . $setting::general{'icon'})}} : $favicon;
	RSS2_0->new(
		'path'					=>	$rss_dir . '/' . $file_name . '.xml',
		'maxitem'				=>	(($env::rss_maxitem) ? $env::rss_maxitem : 15),
		'description_maxlength'	=>	(($env::rss_description_maxlength) ? $env::rss_description_maxlength : 128),
		'delete_only'			=>	$delete_only,
		'xmlns'					=>	{'content' 	=>	'http://purl.org/rss/1.0/modules/content/'},
		'utm_medium'			=>	$cgi_id . (($master_rss_dir && defined $main::c && $main::c ne '') ? ':' . $main::c : '') . (($rss_type) ? '(' . $rss_type . ')' : ''),
		'channel_element'		=>	{
										'title'			=>	(($title ne '') ? $title . ':' . $this->name(1) : '' . $this->name(1)),
										'link'			=>	$link,
										'description'	=>	'' . $this->name(1) . 'Ǥ',
										'copyright'		=>	$copyright,
										'image'			=>	((ref $icon) ? $icon : $favicon),
									},
	)->update($item);
}
}

sub delete_field_rss_item ($$$) {
my($this,$file_name,$delete) = @_;
$this->feed_field_rss($file_name,{'delete'	=> [$delete]});
}

sub get_rss_path ($) {
my $this = shift;
return ();
}

sub get_rss_name ($) {
my $this = shift;
return $this->name(1);
}

######################################################################
sub post_update ($;$) {
my $this = shift;
return 1;
}

1;
