package Holiday;
use strict;
######################################################################
# ⥸塼
# Holiday.pm 1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
#support@cmonos.jp
#http://cmonos.jp/
#  ǽ2008-02-01
######################################################################
#
#		require CMONOS::CGI_Lib::Holiday;
#		obj = Calendar->new(year);
#
#		obj->{'mon'}{'mday'} = name;
#			mon		[1-12]
#			mday	
#			name	̾
#
######################################################################
#	ͻ
#	http://www.asahi-net.or.jp/~CI5M-NMR/misc/holiday.html
#	http://www.asahi-net.or.jp/~CI5M-NMR/misc/equinox.html
#	http://www.top.or.jp/~cpop/syunbun.htm
#	ŤʻޤȤƤä˿鴶դޤ
######################################################################
#	ѵ
#	ΥץȤCMONOSͭƤޤ
#	Υ֥롼󽸤ϡʲξ˽꼫ͳ˺ۤǤޤ
#		ɽѹƤϤޤ
#		äϡ̾ԤϢ衦Ľꡦ
#		Ʋ
#	ΥץȤѤȤˤäʤ»ˤ
#	CMONOSǤ餤ޤ
######################################################################
#֥Ⱥ
sub new ($$) {
my($pkg,$year) = @_;
my $this = {};
bless $this;

#ܤν
#if ($ENV{'TZ'} =~ /JST/i) {
	$this->jp($year) if $year;
#}
return $this;
}

#ǯȽ
sub is_leap_year ($$) {
my($this,$year) = @_;
return 1 if ($year % 4 == 0 && $year % 100 != 0) || $year % 400 == 0;
}

#եå
sub is_impossible_mday ($$$$) {
my($this,$y,$m,$d) = @_;
my $feb = 28;
$feb++ if $this->is_leap_year($y);
if ((($m == 4 || $m == 6 || $m == 9 || $m == 11) && $d > 30) || ($m == 2 && $d > $feb) || $d > 31) {
	return 1;
} else {
	return 0;
}
}

#ĥ顼θ
sub get_wday ($$$$) {
my($this,$year,$mon,$mday) = @_;
if ($mon == 1 || $mon == 2) {
	$year--;
	$mon+=12;
}
return int($year + int($year/4) - int($year/100) + int($year/400) + int(2.6*$mon+1.6) + $mday) % 7;
}

#n w
sub week ($$$$$) {
my($this,$year,$mon,$week,$wday) = @_;
my($first,$mday);
$first = $this->get_wday($year,$mon,1);
$mday = ($week * 7) + $wday - $first - 6;
return ($wday >= $first) ? $mday : 7 + $mday;
}

#ʬ1900Y2099
sub s_equinox ($$) {
my($this,$year) = @_;
return $this->gauss(0.24242 * $year - $this->gauss($year/4) + 35.84);
}

#ʬ1900Y2099
sub a_equinox ($$) {
my($this,$year) = @_;
return $this->gauss(0.24204 * $year - $this->gauss($year/4) + 39.01);
}

sub gauss ($$) {
my($this,$n) = @_;
return ($n >= 0) ? int($n) : int($n-1);
}

# --------------------------------------------------------------------
#	ܤν
sub jp ($$) {
my($this,$year) = @_;
$this->holidays_j(
	$year,
	1, 1 => '', "New Year's Day",
	1, (($year < 2000) ? 15 : $this->week($year,1,2,1)) => 'ͤ', 'Coming of Age Day',
	2, 11 => 'ǰ', 'National Foundation Day',
	3, $this->s_equinox($year) => 'ʬ', 'Vernal Equinox',
	4, 29 => (($year < 1989) ? 'ŷ()' : ($year < 2007) ? 'ߤɤ' : '¤'), (($year < 2007) ? 'Greenery Day' : 'Showa Day'),
	5, 3 => 'ˡǰ', 'Constitution Memorial Day',
	(($year >= 1988) ? (5, 4 => (($year < 2007) ? '̱ε' : 'ߤɤ'), (($year < 2007) ? 'Holiday for a Nation' : 'Greenery Day')) : ()),
	5, 5 => 'ɤ', 'Child Day',
	(($year >= 1996) ? (7, (($year < 2003) ? 20 : $this->week($year,7,3,1)) => '', 'Marine Day') : ()),
	(($year >= 1966) ? (9, (($year < 2003) ? 15 : $this->week($year,9,3,1)) => 'Ϸ', 'Respect for the Aged Day') : ()),
	9, $this->a_equinox($year) => 'ʬ', 'Autumnal Equinox',
	(($year >= 1966) ? (10, (($year < 2000) ? 10 : $this->week($year,10,2,1)) => 'ΰ', 'Health and Sports Day') : ()),
	11, 3 => 'ʸ', 'National Culture Day',
	11, 23 => 'ϫդ', 'Labor Thanksgiving Day',
	(($year >= 1989) ? (12, 23 => 'ŷ(ʿ)', "Emperor's Birthday (Akihito)") : ())
);
return $this;
}

sub holidays_j ($$) {
my $this = shift;
my $year = shift;
my($m,$d,$j,$e);
$this->{'holiday'} = {};
while (($m,$d,$j,$e) = splice(@_,0,4)) {
	if ($year >= 1973 && (defined $this->{'holiday'}{$m}{$d} && $this->{'holiday'}{$m}{$d} ne '') || $this->get_wday($year,$m,$d) == 0) {
		my($fm,$fd) = ($this->is_impossible_mday($year,$m,$d+1)) ? ($m+1,1) : ($m,$d+1);
		$this->{'holiday'}{$fm}{$fd} = ($default::english) ? 'Holiday' : 'ؤ';
	} elsif ($year >= 2003 && $m == 9 && $d == 23 && $this->{'holiday'}{$m}{21} && !$this->{'holiday'}{$m}{22}) {
		$this->{'holiday'}{$m}{$d-1} = ($default::english) ? 'Holiday' : '̱ˡˤ';
	}
	$this->{'holiday'}{$m}{$d} = ($default::english) ? $e : $j;
}
}

sub is_holiday ($$$) {
my($this,$m,$d) = @_;
return ($m && $d && ref $this->{'holiday'}{$m} && $this->{'holiday'}{$m}{$d}) ? 1 : 0;
}

sub name ($$$) {
my($this,$m,$d) = @_;
return ($m && $d && ref $this->{'holiday'}{$m} && $this->{'holiday'}{$m}{$d}) ? $this->{'holiday'}{$m}{$d} : '';
}


1;