package JPrefecture;
use strict;
######################################################################
# ܤƻܸ
# JPrefecture.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ֥Ȥ롣
sub new ($) {
my $pkg = shift;
my $this = {};
bless $this;
$this;
}

sub get_prefecture_name_by_id ($$) {
my($this,$id) = @_;
my %pref_name_table = $this->get_prefecture_name_hash;
return $pref_name_table{$id};
}

sub get_prefecture_name_hash ($) {
my $this = shift;
return (
	1 => '̳ƻ',

	2 => 'Ŀ',
	3 => '긩',
	4 => 'ܾ븩',
	5 => 'ĸ',
	6 => '',
	7 => 'ʡ縩',

	8 => '븩',
	9 => 'ڸ',
	10 => 'ϸ',
	11 => '̸',
	12 => 'ո',
	13 => '',
	14 => '',

	15 => '㸩',
	16 => 'ٻ',
	17 => '',
	18 => 'ʡ温',
	19 => '',
	20 => 'Ĺ',
	21 => '츩',
	22 => 'Ų',
	23 => 'θ',

	24 => 'Ÿ',
	25 => '츩',
	26 => '',
	27 => '',
	28 => 'ʼ˸',
	29 => 'ɸ',
	30 => '²λ',

	31 => 'Ļ踩',
	32 => '纬',
	33 => '',
	34 => '縩',
	35 => '',

	36 => '縩',
	37 => '',
	38 => 'ɲ',
	39 => 'θ',

	40 => 'ʡ',
	41 => '츩',
	42 => 'Ĺ긩',
	43 => 'ܸ',
	44 => 'ʬ',
	45 => 'ܺ긩',
	46 => '縩',
	47 => '츩'
)
}

sub get_prefecture_id_by_name ($$) {
my($this,$name) = @_;
my %pref_id_table = $this->get_prefecture_id_hash;
return $pref_id_table{$name};
}

sub get_prefecture_id_hash ($) {
my $this = shift;
return (
	'̳ƻ' => 1,

	'Ŀ' => 2,
	'긩' => 3,
	'ܾ븩' => 4,
	'ĸ' => 5,
	'' => 6,
	'ʡ縩' => 7,

	'븩' => 8,
	'ڸ' => 9,
	'ϸ' => 10,
	'̸' => 11,
	'ո' => 12,
	'' => 13,
	'' => 14,

	'㸩' => 15,
	'ٻ' => 16,
	'' => 17,
	'ʡ温' => 18,
	'' => 19,
	'Ĺ' => 20,
	'츩' => 21,
	'Ų' => 22,
	'θ' => 23,

	'Ÿ' => 24,
	'츩' => 25,
	'' => 26,
	'' => 27,
	'ʼ˸' => 28,
	'ɸ' => 29,
	'²λ' => 30,

	'Ļ踩' => 31,
	'纬' => 32,
	'' => 33,
	'縩' => 34,
	'' => 35,

	'縩' => 36,
	'' => 37,
	'ɲ' => 38,
	'θ' => 39,

	'ʡ' => 40,
	'츩' => 41,
	'Ĺ긩' => 42,
	'ܸ' => 43,
	'ʬ' => 44,
	'ܺ긩' => 45,
	'縩' => 46,
	'츩' => 47
)
}

sub get_region_name_by_id ($$) {
my($this,$id) = @_;
my %region_name_table = $this->get_region_name_hash;
return $region_name_table{$id};
}

sub get_region_name_hash ($) {
my $this = shift;
return (
	1 => '̳ƻ',
	2 => '',
	3 => '',
	4 => '',
	5 => '',
	6 => '',
	7 => '͹',
	8 => '彣',
	9 => ''
)
}

sub get_region_id_by_name ($$) {
my($this,$name) = @_;
my %region_id_table = $this->get_region_id_hash;
return $region_id_table{$name};
}

sub get_region_id_hash ($) {
my $this = shift;
return (
	'̳ƻ' => 1,
	'' => 2,
	'' => 3,
	'' => 4,
	'' => 5,
	'' => 6,
	'͹' => 7,
	'彣' => 8,
	'' => 9
)
}

sub get_prefecture_id_array_by_region_id ($$) {
my($this,$rid) = @_;
if ($rid == 1) {
	return (1);
} elsif ($rid == 2) {
	return (2..7);
} elsif ($rid == 3) {
	return (8..14);
} elsif ($rid == 4) {
	return (15..23);
} elsif ($rid == 5) {
	return (24..30);
} elsif ($rid == 6) {
	return (31..35);
} elsif ($rid == 7) {
	return (36..39);
} elsif ($rid == 8) {
	return (40..46);
} elsif ($rid == 9) {
	return (47);
}
}

sub get_region_id_by_prefecture_id ($$) {
my($this,$pid) = @_;
if ($pid == 1) {
	return 1;
} elsif ($pid >= 2 && $pid <= 7) {
	return 2;
} elsif ($pid >= 8 && $pid <= 14) {
	return 3;
} elsif ($pid >= 15 && $pid <= 23) {
	return 4;
} elsif ($pid >= 24 && $pid <= 30) {
	return 5;
} elsif ($pid >= 31 && $pid <= 35) {
	return 6;
} elsif ($pid >= 36 && $pid <= 39) {
	return 7;
} elsif ($pid >= 40 && $pid <= 46) {
	return 8;
} elsif ($pid == 47) {
	return 9;
}
}

1;
