package FieldEditor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# եԽ⥸塼
# FieldEditor.pm ver1.1.7
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-10-15
######################################################################
# ¹
sub run ($) {
my $this = shift;
my($new_field_id);

#եɥǡ١ΰ֤ʤɤ
$this->set_field;

#եɥ⥸塼ɤ߹
$this->call_field($setting::field);

if (defined $main::next && $main::next) {
	$main::data{'P'}++;
} elsif (defined $main::prev && $main::prev) {
	$main::data{'P'}--;
}

#Խ񤭹
if (defined $main::a && $main::a eq 'e') {
	#no warnings qw(numeric);
	my($k,$v,%old,%redundancy_forbidden,$no,$id);
	push (@main::delete,$main::delete) if defined $main::delete && $main::delete;
	@main::delete = grep(defined $_ && $_ ne '',@main::delete);
	%redundancy_forbidden = ();

	#ʥǡν
	push(@check::checkbox,'required','cookie');
	while (($k,$v) = each %main::order) {
		foreach (@check::checkbox) {
			$main::data{$k . '_' . $_} = '' if !defined $main::data{$k . '_' . $_} || $main::data{$k . '_' . $_} eq '';
		}
		$main::data{$k . '_pkg'} = $Field::modules{$main::data{$k . '_class'}};
		$this->detag(\$main::data{$k . '_name'});
		$this->field_setting_check($k);
	}

	#ɽǡɤ߹
	%old = $this->import_order($default::field_pref_dir . '/' . $setting::field_db_name,\%main::order,\%redundancy_forbidden);

	#ǡ
	if (@main::delete) {
		#Ƚؤαƶ
		foreach (@main::delete) {
			delete $old{$_};
			delete $main::order{$_};
		}
		$this->delete_field(@main::delete);
	}

	#Ƚ
	$no = 0;
	foreach $id (sort {
			$main::order{$a} <=> $main::order{$b} || 
			$old{$b} <=> $old{$a} || 
			$main::order{$a} cmp $main::order{$b} || 
			$a <=> $b
		} keys %old) {

		$no++;
		$main::data{'ORDER_' . $no} = $id;
		$main::data{$id . '_ORDER'} = $no;
		if (@field::redundancy_forbidden) {
			if (defined $redundancy_forbidden{$main::data{$id . '_class'}} && $redundancy_forbidden{$main::data{$id . '_class'}}) {
				if ($redundancy_forbidden{$main::data{$id . '_class'}} ne $id) {
					push(@{$this->{'dialog'}},'ID:' . $id . 'ΥեɥפѹƤ' . $Field::fieldname{$main::data{$id . '_class'}} . 'פϤǤ¸ߤƤޤ');
					delete $main::data{$id . '_class'};
				}
			} elsif (grep($_ eq $main::data{$id . '_class'},@field::redundancy_forbidden)) {
				$redundancy_forbidden{$main::data{$id . '_class'}} = $id;
			}
		}
	}

	#
	if (defined $main::new{'name'} && $main::new{'name'} ne '') {
		if (@field::redundancy_forbidden && $redundancy_forbidden{$main::new{'class'}}) {
			$main::id = '';		
			push(@{$this->{'dialog'}},'եɤΥեɥפѹƤ' . $Field::fieldname{$main::new{'class'}} . 'פϤǤ¸ߤƤޤ');
		} else {
			my($k,$v,$n);
			while (1) {
				$n++;
				last if !defined $old{$n} || $old{$n} eq '';
			}
			$no++;
			$new_field_id = $n;
			$main::data{'ORDER_' . $no} = $n;
			$main::data{$n . '_ORDER'} = $no;
			while (($k,$v) = each %main::new) {
				$main::data{$n . '_' . $k} = $v;
			}
			$main::data{$n . '_pkg'} = $Field::modules{$main::data{$n . '_class'}};
			$this->detag(\$main::data{$n . '_name'});
			$this->field_setting_check($n);
			$main::id = $n if $main::id && $main::id eq 'new';
			@main::delete = grep($_ ne $n,@main::delete);
		}
	} elsif (defined $main::id && $main::id eq 'new') {
		$main::id = '';
		push(@{$this->{'dialog'}},'ե̾ϤƤޤ');
	}

	undef %old;
	$this->field_general_setting_check;
	$this->write_db($default::field_pref_dir . '/' . $setting::field_db_name,\%main::data,'ORDER',\@main::delete,\%setting::field,1);

#ե񤭹
} elsif (defined $main::id && defined $main::a && $main::id ne '' && $main::a eq 'd') {
	my $field = Field->new($main::class,$main::id);
	$field->set();
	$field->is_valid_setting;
	$this->write_db($default::field_pref_dir . '/' . $setting::field_db_name,\%main::data,'','',\%setting::field,1);
	undef %$field;
	undef $field;
}
undef(%main::data);

#եɥ֥Ⱥ
$this->use_field('field',$default::field_pref_dir . '/' . $setting::field_db_name,$setting::field,$setting::field_style_disabled,$setting::field_tag_enabled,$setting::field_tag_name,1);
$this->mk_field($new_field_id) if defined $new_field_id && $new_field_id;

#եѥͥ
if (defined $main::id && $main::id ne '' && ref $field::obj{$main::id}) {

	#ڡإå
	$this->jump_menu('tools','field');
	$this->print_page_header('tools');
	
	#ե
	print '<fieldset class="toolbox" id="toolnavi">';
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'fieldlist',
		'required'	=>	\@setting::form
	);
	print '<input type="submit" value="" />';
	print '</form>';

	my($prev,$next);
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'fieldselector',
		'required'	=>	\@setting::form
	);
	print '<select name="id" onchange="submit()">';
	foreach (sort {$a <=> $b} keys %field::ORDER) {
		next unless ref $field::obj{$field::ORDER{$_}};
		$prev = $_ if $_ < $field::obj{$main::id}->{'ORDER'};
		$next = $_ if !$next && $_ > $field::obj{$main::id}->{'ORDER'};
		print '<option value="' . $field::ORDER{$_} . '"' . (($main::id && $main::id == $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
	}
	print '</select><input type="submit" value="" />';
	print '</form>';

	if ($prev && $prev > 0) {
		print $this->form_start(
			'key'	=>	'tools',
			'name'	=>	'prevfield',
			'required'	=>	\@setting::form
		);
		print '<input type="submit" name="id=' . $field::ORDER{$prev} . '" value="Υե" />';
		print '</form>';
	}
	if ($next && $next > 1) {
		print $this->form_start(
			'key'	=>	'tools',
			'name'	=>	'nextfield',
			'required'	=>	\@setting::form
		);
		print '<input type="submit" name="id=' . $field::ORDER{$next} . '" value="Υե" />';
		print '</form>';
	}
	print '</fieldset>';

	print '<h1>' . (($setting::jump_menu{$main::k}) ? $setting::jump_menu{$main::k} . '' : '') . 'ե</h1>';
	
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'method'	=>	'post',
		'required'	=>	\@setting::form
	);
	print '<input type="hidden" name="id" value="' . $this->escape($main::id) . '" />';
	print '<input type="hidden" name="class" value="' . $field::obj{$main::id}->{'class'} . '" />';
	print '<input type="hidden" name="a" value="d" />';
	$field::obj{$main::id}->print_setting_form($this->is_not_html,$this->tips);

#եԽѥͥ
} else {

	#ڡإå
	$this->set_onload('cmonos.element.tagClass(\'th\',\'foldable\',\'td\',\'foldable\').disappear(true);') if $this->{'foldable'} && $main::foldup;
	$this->jump_menu('tools','field');
	$this->print_page_header('tools');

	print '<h1>' . (($setting::jump_menu{$main::k}) ? $setting::jump_menu{$main::k} . '' : '') . 'եԽ</h1>';
	
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'method'	=>	'post',
		'required'	=>	\@setting::form
	);
	print '<input type="hidden" name="a" value="e" />';
	print '<fieldset><legend>եԽ</legend>';

	#ơ֥
	require CMONOS::CGI_Lib::Table;
	my $table = Table->new;
	$table->set(
		'tableclass' 	=> 'tooltable',
		'trclass' 		=> 'odd,even',
		'class0' 		=> 'odd,even',
		'style0' 		=> 'white-space: nowrap;text-align: center;',
		'classF' 		=> 'caution foldable',
		'thenabled' 	=> 'true'
	);

	#ڡ
	my(@field_no,$lastpage,$prev,$next,$from,$to,$count);
	@field_no = sort {$a <=> $b} keys %field::ORDER;
	$lastpage = (@field_no && $field::U) ? ((@field_no % $field::U) ? int(@field_no / $field::U) + 1 : @field_no / $field::U) : 1;
	if (!$field::P || $field::P < 1) {
		$field::P = 1;
	} elsif ($field::P > $lastpage) {
		$field::P = $lastpage;
	}
	($from,$to) = (($field::U * ($field::P - 1)),($field::U * $field::P)) if $field::U;

	print '(' . $field::P . '/' . $lastpage . ' ڡ)';
	my @foldable;
	if (defined $this->{'foldable'} && $this->{'foldable'}) {
		print ' <label><input type="checkbox" name="foldup" value="1" onclick="cmonos.element.tagClass(\'th\',\'foldable\',\'td\',\'foldable\').disappear(this.checked);"' . (($main::foldup) ? ' checked="checked"' :'') . ' /> ޤ</label>';
	}
	print $table->table;

	#إå
	print $table->tr;
	print $table->td('');
	print $table->td('ɽ',{'class' => 'even foldable'});
	print $table->td('ID');
	print $table->td('ե̾');
	print $table->td('ɬܹ',{'class' => 'odd foldable'});
	print $table->td('',{'class' => 'even foldable'});
	print $table->td('եɥ',{'class' => 'odd foldable'});
	print $table->td('ܺ',{'class' => 'even foldable'});
	$this->print_setting_item_name($table);
	print $table->_tr;

	#
	foreach (@field_no) {
		next unless ref $field::obj{$field::ORDER{$_}};
		$count++;

		#ڡ
		if ($field::U) {
			if ($from >= $count) {
				$prev = 1;
				next;
			} elsif ($to < $count) {
				$next = 1;
				last;
			}
		}

		print $table->tr;
		print $table->td('<input type="checkbox" name="delete" value="' . $field::ORDER{$_} . '" onclick="cmonos.form.field(this).checkboxConfirm(\'' . $field::obj{$field::ORDER{$_}}->{'name'} . ' ˴ϢƤΥǡޤ˺ޤ\')" />');
		print $table->td('<input type="text" name="order:' . $field::ORDER{$_} . '" value="' . $_ . '" size="2" maxlength="2" />',{'class' => 'even foldable'});
		print $table->td($field::ORDER{$_});
		if (defined $this->{'long_name_enabled'} && $this->{'long_name_enabled'}) {
			print $table->td('<textarea name="data:' . $field::ORDER{$_} . '_name" rows="3" cols="30" title="[եɥ롼̾:]ե̾">' . $field::obj{$field::ORDER{$_}}->{'name'} . '</textarea>');
		} else {
			print $table->td('<input type="text" name="data:' . $field::ORDER{$_} . '_name" value="' . $field::obj{$field::ORDER{$_}}->{'name'} . '" size="20" title="[եɥ롼̾:]ե̾" />');
		}
		if ($field::obj{$field::ORDER{$_}}->required_enabled) {
			print $table->td('<input type="checkbox" name="data:' . $field::ORDER{$_} . '_required" value="1"' . ((defined $field::obj{$field::ORDER{$_}}->{'required'} && $field::obj{$field::ORDER{$_}}->{'required'}) ? ' checked="checked"' : '') . ' />',{'class' => 'odd foldable'});
		} else {
			print $table->td('',{'class' => 'odd foldable'});
		}
		if ($field::obj{$field::ORDER{$_}}->cookie_enabled) {
			print $table->td('<input type="checkbox" name="data:' . $field::ORDER{$_} . '_cookie" value="1"' . ((defined $field::obj{$field::ORDER{$_}}->{'cookie'} && $field::obj{$field::ORDER{$_}}->{'cookie'}) ? ' checked="checked"' : '') . ' />',{'class' => 'even foldable'});
		} else {
			print $table->td('',{'class' => 'even foldable'});
		}
		print $table->td($field::obj{$field::ORDER{$_}}->menu('data:' . $field::ORDER{$_} . '_class'),{'class' => 'odd foldable'});
		print $table->td('<input type="submit" name="id=' . $field::ORDER{$_} . '" value="ܺ" title="ߤ¸ƾܺ򳫤ޤ" />',{'class' => 'even foldable'});
		$this->print_setting_items($table,$field::obj{$field::ORDER{$_}},'data:' . $field::ORDER{$_} . '_',$field::ORDER{$_});
		print $table->_tr;
	}

	#
	if (!defined $next ||  !$next) {
		my $field = Field->new('text','NEW');
		$field->set();
		print $table->tr;
		print $table->td('&nbsp;');
		print $table->td('&nbsp;',{'class' => 'even foldable'});
		print $table->td('');
		if (defined $this->{'long_name_enabled'} && $this->{'long_name_enabled'}) {
			print $table->td('<textarea name="new:name" rows="3" cols="30"></textarea>');
		} else {
			print $table->td('<input type="text" name="new:name" size="20" />');
		}
		print $table->td('<input type="checkbox" name="new:required" value="1" />',{'class' => 'odd foldable'});
		print $table->td('<input type="checkbox" name="new:cookie" value="1" />',{'class' => 'even foldable'});
		print $table->td($field->menu('new:class'),{'class' => 'odd foldable'});
		print $table->td('<input type="submit" name="id=new" value="ܺ" title="ߤ¸ƾܺ򳫤ޤ" />',{'class' => 'even foldable'});
	
		$this->print_setting_items($table,$field,'new:','');
	
		undef %$field;
		undef $field;
	
		print $table->_tr;
	}

	print $table->_table;

	print $this->note;
	print '</fieldset><fieldset class="submit"><label>ɽ <input type="text" name="data:U" value="' . $this->escape($field::U) . '" size="3" maxlength="3" /></label>';
	print '<input type="submit" name="prev" value="Υڡ" />' if defined $prev && $prev;
	print '<input type="submit" name="next" value="Υڡ" />' if defined $next && $next;
	print '<input type="hidden" name="data:P" value="' . $field::P . '" /><input type="submit" value="¸" class="save" /></fieldset>';

	$this->print_sub_setting_items;

	undef %$table;
	undef $table;
	
}
print '</form>';

#ڡեå
$this->print_page_footer('tools');
}

sub field_setting_check ($$) {
my($this,$k) = @_;
return;
}

sub field_general_setting_check ($) {
my $this = shift;
return;
}

sub note ($) {
my $this = shift;
return;
}

sub import_order ($$$$) {
#no warnings "untie";
my($this,$db,$order,$redundancy_forbidden) = @_;
my(%db);
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
tie(%db, $env::dbm_file, $db, O_RDONLY, $env::dbm_mode);
if (ref tied %db) {
	my($key,$value,%order);
	while (($key,$value) = each %db) {
		if ($key =~ /^ORDER_(.*)$/) {
			$order{$value} = $1;
			$$order{$value} = $1 unless defined $$order{$value} && $$order{$value} ne '';
		} elsif (@field::redundancy_forbidden && $key =~ /^(\d+)_class$/ && grep($_ eq $value,@field::redundancy_forbidden) && !grep($_ eq $1,@main::delete) && (!defined $main::data{$1 . '_class'} || $main::data{$1 . '_class'} eq $value)) {
			$$redundancy_forbidden{$value} = $1;
		}
	}
	untie %db;
	return %order;
} else {
	untie %db;
	my($dbname);
	$dbname = '\n' . $1 if $db ne $env::register_db && $db =~ m!([^/]+)$!;
	push(@{$this->{'dialog'}},'եǡ١ɤ߹ߤ˼ԤޤΤޤ޺Ȥ³ȴ¸ߤ꤬ǽޤ');
	return ();
}
}

sub mk_field ($$) {
my($this,$id) = @_;
return 1;
}

sub is_not_html ($) {
my $this = shift;
return 0;
}

sub set_field ($) {
my $this = shift;
push(@{$this->{'dialog'}},'ץȥ顼եԽ⥸塼˰۾郎ޤ');
$this->print_error_dialog('tools');
}

sub print_setting_item_name ($$) {
my($this,$table) = @_;
return;
}

sub print_setting_items ($$$$$) {
my($this,$table,$field,$name,$id) = @_;
return;
}

sub print_sub_setting_items ($) {
my($this) = @_;
return;
}

sub delete_field ($@) {
my($this,@delete) = @_;
return;
}

sub tips ($) {
my $this = shift;
return;
}

1;
