package SharedPreferenceRemover;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ͭ⥸塼
# SharedPreferenceRemover.pm ver1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-04-15
######################################################################
# ¹
sub run ($) {
my $this = shift;
my(%shared_pref);
use Fcntl qw(:flock);
push(@main::target_db,$main::target_db) if defined $main::target_db && $main::target_db ne '';
@main::target_db = grep(defined $_ && $_ ne '',@main::target_db);
undef $main::target_db;
$main::a = '' if !defined $main::a;

local(*DIR);
foreach my $type ($backup::default{'pref'},$backup::default{'field'}) {
	next if !$type;
	my $path = ($env::user_default_dir || $env::default_dir) . '/' . $type;
	if (opendir(DIR,$path)) {
		my $file;
		while ($file = readdir(DIR)) {
			next if $file =~ /^\./;
			if ($file =~ /^\w+\.([a-zA-Z0-9]+)\.default$/) {
				my $id = $1;
				if (!defined $shared_pref{$id}) {
					local(*BAK);
					if (open(BAK, $path . '/' . $file)) {
						binmode BAK;
						flock(BAK, LOCK_EX);
							$shared_pref{$id} = <BAK>;
						close(BAK);
						chomp $shared_pref{$id};
					}
				}
			}
		}
		closedir(DIR);
	}
}

if (@main::target_db && $main::a) {
	my %removed;
	foreach my $type ($backup::default{'pref'},$backup::default{'field'}) {
		next if !$type;
		my $path = ($env::user_default_dir || $env::default_dir) . '/' . $type;
		if (opendir(DIR,$path)) {
			my @files = readdir(DIR);
			closedir(DIR);
			foreach my $file (@files) {
				next if $file =~ /^\./;
				if ($file =~ /^\w+\.([a-zA-Z0-9]+)\.default$/) {
					my $id = $1;
					if (grep($_ eq $id,@main::target_db)) {
						$removed{$id}++ if unlink $path . '/' . $file;
					}
				}
			}
		}
	}
	$this->remove_relational_files(\@main::target_db);
	foreach my $id (sort keys %removed) {
		push(@{$this->{'dialog'}},'' . $shared_pref{$id} . '(' . $id . ')פޤ');
		delete $shared_pref{$id};
	}
	undef @main::target_db;

} elsif ($main::a) {
	push(@{$this->{'dialog'}},'붦꤬ͭꤵƤޤ');

}

#ڡإå
$this->jump_menu('tools','share');
$this->print_page_header('tools');

print '<h1>ͭ</h1>';

if (%shared_pref) {
	#no warnings qw(numeric);
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'method'	=>	'post',
		'onsubmit'	=>	'return confirm(\'ϼäޤ˺ޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
		'required'	=>	\@setting::form
	);
	print '<input type="hidden" name="a" value="delete" />';
	print '<fieldset><legend>붦ͭ</legend>';
	my @shared_pref_list = sort {$a <=> $b || $a cmp $b} keys %shared_pref;
	print '<select name="target_db" multiple="multiple" size="' . (scalar @shared_pref_list) . '">';
	foreach my $id (@shared_pref_list) {
		print '<option value="' . $id . '">' . $shared_pref{$id} . '(' . $id . ')</option>';
	}
	print '</select>';
	print '</fieldset>';
	print '<fieldset class="delete"><input type="submit" value="" /></fieldset></form>';
} else {
	print '<fieldset><div class="hints">꤬ͭ¸ߤޤ</div></fieldset>';
}

#ڡեå
$this->print_page_footer('tools');

}

sub remove_relational_files ($$) {
my($this,$target) = @_;
return 1;
}

1;
