package StyleSheetEditor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# CSSե⥸塼
# StyleSheetEditor.pm ver1.0.4
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-01-21
######################################################################
# ¹
sub run ($) {
my $this = shift;
my($k,$v);
unless (ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
use Fcntl qw(:flock);

#񤭹ߥå
if (defined $main::a && $main::a eq 'w') {

	#åȥե̾
	$main::target = $this->z_to_h($main::target) if $main::target;	#ȾѲ
	if ($this->is_a_reserved_word($main::target)) {
		push(@{$this->{'dialog'}},'ե̾ǧƤ');
		$main::target = '<new>';

	} else {
		my $is_valid = 1;
		my $is_empty = 1;
		my %name = (
			'a_link' => '',
			'a_visited' => 'ˬѤߥ',
			'a_hover' => 'С',
			'a_active' => 'ƥ֥',
			'p__a_link' => '&lt;p&gt;',
			'p__a_visited' => '&lt;p&gt;ˬѤߥ',
			'p__a_hover' => '&lt;p&gt;⥪С',
			'p__a_active' => '&lt;p&gt;⥢ƥ֥'
		);
	
		my($selector);
		foreach $selector ('HEADER','body','a_link','a_visited','a_hover','a_active','body___table','p','p__a_link','p__a_visited','p__a_hover','p__a_active','_____container','div_____container','blockquote____quotation___blockquote____quotation__blockquote','MAIN') {
		#foreach $selector (sort keys %main::data) {
			next if !ref $main::data{$selector};
			my($property);
			foreach $property (sort keys %{$main::data{$selector}}) {
				my $pname = '';
				$pname = $1 if $property =~ /^(.*)_[a-z]+$/;
				if ($pname eq 'background') {
					$pname = 'ط';
				} else {
					$pname =~ s/_/ /g;
				}
	
				if (defined $main::data{$selector}{$property} && $main::data{$selector}{$property} ne '') {
	
					#񼰥å
					if ($property =~ /color$/ && $this->is_invalid_color($main::data{$selector}{$property}) && $main::data{$selector}{$property} !~ /^#[0-9a-fA-F]{3}$/) {
						$is_valid = 0;
						#delete $main::data{$selector}{$property};
						push(@{$this->{'dialog'}},(($name{$selector}) ? $name{$selector} . '' : '') . $pname . 'ǧƤ');		

					#Ȥ
					} else {
						$main::data{$selector}{$property} = $this->z_to_h($main::data{$selector}{$property});	#ȾѲ
						$main::data{$selector}{$property} .= 'px' if ($property =~ /^margin/ || $property eq 'font-size' || $property eq 'width' || $property eq 'height') && $main::data{$selector}{$property} ne '0' && $main::data{$selector}{$property} =~ /^\-?[0-9\.]+$/;	#ñ䴰
						if ($property eq 'USER') {
							$main::data{$selector}{'USER'} =~ s/^\s*\@charset.*?;//gm;
							$main::data{$selector}{'USER'} =~ s!^/\*------VICUNA_(START|E_N_D)------\*/$!!gm;
							$main::data{$selector}{'USER'} =~ s!^/\*------HEADER_(START|E_N_D)------\*/$!!gm;
							$main::data{$selector}{'USER'} =~ s!^/\*------BLOCKQUOTE_COLOR_(START|E_N_D)------\*/$!!gm;
						}
						$is_empty = 0;
					}
				}
			}
		}
	
		#ѿ
		if ($main::blockquote_color) {
			if ($this->is_invalid_cscolor($main::blockquote_color)) {
				$is_valid = 0;
				push(@{$this->{'dialog'}},'ѿοǧƤ');
				#undef $main::blockquote_color;
			}
		}
		
		#VICUNA
		if ($main::vicuna_url) {
			$main::vicuna_url =~ s/["'\)\(]//g;
			if (
					$main::vicuna_url eq './vicuna/0-import.css' || $main::vicuna_url eq './vicuna/import.css' || 
					$main::vicuna_url eq 'vicuna/0-import.css' || $main::vicuna_url eq 'vicuna/import.css' || 
					$main::vicuna_url eq $this->path_change($env::css,$ENV{'SCRIPT_NAME'},'abs') . '/vicuna/0-import.css' || $main::vicuna_url eq $this->path_change($env::css,$ENV{'SCRIPT_NAME'},'abs') . '/vicuna/import.css'
				) {
				$main::vicuna_url = '';			
			} elsif ($main::vicuna_url !~ m!/(0-|)import.css$!s) {
				$is_valid = 0;
				push(@{$this->{'dialog'}},'Vicuna CMS Ѥ CSS Ȥƻꤵ줿եɸŪʹ¤ǤϤޤ');
			}
			if (!$main::vicuna || $main::vicuna ne 'import') {
				push(@{$this->{'dialog'}},'Vicuna CMS  CSS ɤ߹ޤʤ硢桼 CSS ϼޤ');
			}
		}
	
		#񤭹
		if ($is_empty) {
			push(@{$this->{'dialog'}},$main::target . '.css ι˼ԤޤꤵƤޤ');
		} elsif (!$is_valid) {
			push(@{$this->{'dialog'}},$main::target . '.css ι˼Ԥޤ');
		} else {
			$this->write_style_sheet($main::target);
		}
	}

} else {

	#
	if (defined $main::a && $main::a eq 'del' && defined $main::target) {
		if ($main::target ne 'default' && !$this->is_a_reserved_word($main::target)) {
			unlink $env::css . '/' . $main::target . '.css';
			push(@{$this->{'dialog'}},$main::target . '.css ޤ');
			$main::target = 'default';
		} else {
			push(@{$this->{'dialog'}},$this->escape($main::target) . '.css ϺǤޤ');
		}
	}
	$main::target = 'default' if !defined $main::target || $main::target eq '' || ($main::target ne '<new>' && $this->is_a_reserved_word($main::target));

	#ɤ߹
	$this->read_style_sheet($main::target) if $main::target ne '<new>';
}

#륷ȥ˥塼
if (opendir(CSSDIR,$env::css)) {
	my @menu = grep(-f $env::css . '/' . $_ && $_ =~ /^\w+\.css$/ && $_ ne 'default.css' && $_ ne 'common.css' && $_ ne 'image.css',readdir(CSSDIR));
	closedir(CSSDIR);
	$setting::page{'tools'}{'subMenu'} = $this->form_start(
		'key'	=>	$setting::security_key,
		'name'	=>	'fileselector',
		'required'	=>	\@setting::form
	);
	$setting::page{'tools'}{'subMenu'} .= '<select name="target" onchange="submit()"><option value="default">default.css</option>';
	foreach (sort @menu) {
		my $name = $_;
		$name =~ s/\.css$//;
		$setting::page{'tools'}{'subMenu'} .= '<option value="' . $name . '"' . ((defined $main::target && $main::target eq $name) ? ' selected="selected"' : '') . '>' . $_ . '</option>';
	}
	$setting::page{'tools'}{'subMenu'} .= '<option value="&lt;new&gt;"></option><option value="&lt;new&gt;"' . ((defined $main::target && $main::target eq '<new>') ? ' selected="selected"' : '') . '></option></select>';
	$setting::page{'tools'}{'subMenu'} .= '<input name="subJumpMenu" type="submit" value="" /></form>';
}

require CMONOS::CGI_Lib::StyleSheetHelper;
$this->{'helper'} = StyleSheetHelper->new;

#ڡإå
$this->set_onload("cmonos.element.tagClass('fieldset','foldable','tbody','foldable','tr','foldable').disappear(true);") if !defined $main::unfold || !$main::unfold;
$this->set_onload("cmonos.element.tagClass('tbody','hiddenp').disappear(true);") if !defined $main::unfold2 || !$main::unfold2;
$this->jump_menu('tools');
$this->print_page_header('tools');

#ȥ
print '<h1 title="CSSեޤ">륷Խ</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=>	'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="w" />';

print '<fieldset class="toggle">';
print '<label><input type="checkbox" name="unfold" value="1" onclick="cmonos.element.tagClass(\'fieldset\',\'foldable\',\'tbody\',\'foldable\',\'tr\',\'foldable\').disappear(!this.checked);"' . (($main::unfold) ? ' checked="checked"' : '') . ' /> ܤɽ</label> ';
print '<label><input type="checkbox" name="unfold2" value="1" onclick="cmonos.element.tagClass(\'tbody\',\'hiddenp\').disappear(!this.checked);"' . (($main::unfold2) ? ' checked="checked"' : '') . ' /> &lt;p&gt;󥯿ɽ</label>';
print '</fieldset>';

unless (-d $env::css) {
	print '</form><p>ץȥ顼CSSե¸ǥ쥯ȥ꤬ߤĤޤ</p>';
	$this->print_page_footer('tools');
	return;
}
print '<fieldset>';
print '<legend><label for="target">åȥե</label></legend>';
print $this->path_change($env::css,$ENV{'SCRIPT_NAME'},'abs');
print '/<input type="text" size="20" maxlength="20" name="target" id="target" value="';
print (($main::target eq '<new>') ? '' : $this->escape($main::target));
print '" title="ȾѱѿΤߤꤷޤ" />.cssȾѱѿ';
print '<div class="warning">¸եƱ̾Υե̾ˤȴ¸ե뤬񤭤ޤ</div>' if $main::target eq '<new>';
print '</fieldset>';

print '<fieldset class="foldable"><legend>Vicuna CMS CSS ɤ߹</legend>';
print '<div class="note">ä URL ꤵʤ "' . $this->path_change($env::css,$ENV{'SCRIPT_NAME'},'abs') . '/vicuna/' . ((-f $env::css . '/vicuna/0-import.css') ? '0-import.css' : 'import.css') . '" ɤ߹ߤޤ' . ((!-f $env::css . '/vicuna/0-import.css' && !-f $env::css . '/vicuna/import.css') ? ' <span class="warning">ե뤬ߤĤޤ</span>' : '') . '</div>';
print '<ol class="checkbox">';
print '<li><label><input type="radio" name="vicuna" value="none"' . ((!$main::vicuna || $main::vicuna eq 'none') ? ' checked="checked"' : '') . ' /> ɤ߹ޤʤ</label></li>';
print '<li><label><input type="radio" name="vicuna" value="import"' . (($main::vicuna && $main::vicuna eq 'import') ? ' checked="checked"' : '') . ' /> ɤ߹</label> (<label>桼CSS <input type="text" name="vicuna_url" size="50" value="' . $this->escape($main::vicuna_url) . '" title="ɤ߹ߤ 0-import.css  URL ꤷޤ" /></label>)</li>';
print '</ol>';
print '</fieldset>';

print '<fieldset class="foldable"><legend><label for="data:HEADER:USER">եƬʬ</label></legend>';
print '<textarea cols="80" rows="8" name="data:HEADER:USER" id="data:HEADER:USER" wrap="off" class="content-editor-area">', $this->escape($main::data{'HEADER'}{'USER'}), '</textarea>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label for="target">&lt;body&gt;</label></legend>';

print '<fieldset>';
print '<legend>طʲ</legend>';
print $cgi::Deco->background_menu('data:body:background_image','background',120,$main::data{'body'}{'background_image'});
print '<div class="extra-field"><label for="data:body:background_attachment"><input type="checkbox" name="data:body:background_attachment" id="data:body:background_attachment" value="fixed"';
print ((defined $main::data{'body'}{'background_attachment'} && $main::data{'body'}{'background_attachment'} eq 'fixed') ? ' checked="checked"' : '');
print ' /> طʲ</label></div>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label for="data:body:background_color">طʿ</label></legend>';
print '<input type="text" name="data:body:background_color" id="data:body:background_color" value="', $this->escape($main::data{'body'}{'background_color'});
print '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:body:background_color\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" style="background-color: ', $this->escape($main::data{'body'}{'background_color'}), '" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:body:background_color\')" ondblclick="cmonos.tool.colorPalette.open(\'data:body:background_color\',\'window\')">';
print '<img src="', $env::image_dir, '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:body:background_color\')" ondblclick="cmonos.tool.colorSlider.open(\'data:body:background_color\',\'window\')">';
print '<img src="', $env::image_dir, '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</fieldset>';

print '<fieldset>';
print '<legend>ޡ</legend>';

print '<table class="field-table"><tbody>';

print '<tr>';
$this->print_margin_setting_field('body','top','ޡ','ޡꤷޤ');
$this->print_margin_setting_field('body','bottom','ޡ','ޡꤷޤ');
print '</tr>';

print '<tr>';
$this->print_margin_setting_field('body','left','ޡ','ޡꤷޤ');
$this->print_margin_setting_field('body','right','ޡ','ޡꤷޤ');
print '</tr>';

print '</tbody></table></fieldset>';

print '<fieldset>';
print '<legend>ƥ</legend>';

print '<table class="field-table"><tbody><tr class="tbody-end">';
$this->print_color_setting_field('body','ƥ','ƥ');
$this->print_text_align_setting_field('body','ƥ','ƥ');
print '</tr></tbody>';

$this->print_link_setting_field('a_link','','󥯤Υꤷޤ');
$this->print_link_setting_field('a_visited','ˬѤߥ','ˬѤߥ󥯤Υꤷޤ');
$this->print_link_setting_field('a_hover','С','С󥯤Υꤷޤ');
$this->print_link_setting_field('a_active','ƥ֥','ƥ֥󥯤Υꤷޤ');

print '</table></fieldset>';

print '<fieldset class="foldable">';
print '<legend><label for="data:body:USER">¾ body </label></legend>';
print '<textarea cols="80" rows="8" name="data:body:USER" id="data:body:USER" wrap="off" class="content-editor-area" title="&lt;body&gt;Υꤷޤ">', $this->escape($main::data{'body'}{'USER'}), '</textarea>';
$this->{'helper'}->print_menu('data:body:USER');
print '</fieldset>';
print '</fieldset>';

print '<fieldset>';
print '<legend>ե</legend>';

print '<table class="field-table"><tbody><tr class="tbody-end">';
$this->print_line_height_setting_field('body___table','','Դֳ֤ꤷޤ');
$this->print_font_size_setting_field('body___table','եȥ','եȥꤷޤ');
print '</tr><tr>';
$this->print_font_family_setting_field('body___table','եȤμ','եȤμꤷޤ',1);
print '</tbody></table></fieldset>';

print '<fieldset>';
print '<legend>ѥ饰ա&lt;p&gt;</legend>';

print '<fieldset>';
print '<legend>ƥ</legend>';

print '<table class="field-table"><tbody><tr>';
$this->print_line_height_setting_field('p','ѥ饰','ѥ饰ա&lt;p&gt;Դֳ֤ꤷޤ',1);
print '</tr></tbody>';

$this->print_link_setting_field('p__a_link','&lt;p&gt;','ѥ饰ա&lt;p&gt;Υ󥯤Υꤷޤ','hiddenp');
$this->print_link_setting_field('p__a_visited','&lt;p&gt;ˬѤߥ','ѥ饰ա&lt;p&gt;ˬѤߥ󥯤Υꤷޤ','hiddenp');
$this->print_link_setting_field('p__a_hover','&lt;p&gt;⥪С','ѥ饰ա&lt;p&gt;ΥС󥯤Υꤷޤ','hiddenp');
$this->print_link_setting_field('p__a_active','&lt;p&gt;⥢ƥ֥','ѥ饰ա&lt;p&gt;Υƥ֥󥯤Υꤷޤ','hiddenp');

print '</table></fieldset>';

print '<fieldset class="foldable">';
print '<legend><label for="data:p:USER">¾Υѥ饰</label></legend>';
print '<textarea cols="80" rows="8" name="data:p:USER" id="data:p:USER" wrap="off" class="content-editor-area" title="&lt;p&gt;Υꤷޤ">', $this->escape($main::data{'p'}{'USER'}), '</textarea>';
$this->{'helper'}->print_menu('data:p:USER');
print '</fieldset>';
print '</fieldset>';

print '<fieldset class="foldable">';
print '<legend>ƥĥꥢ&lt;*** id="container"&gt;</legend>';

print '<fieldset>';
print '<legend>ޡ</legend>';
print '<table class="field-table"><tbody>';
print '<tr>';
$this->print_margin_setting_field('_____container','top','ޡ','ޡꤷޤ');
$this->print_margin_setting_field('_____container','bottom','ޡ','ޡꤷޤ');
print '</tr>';
print '<tr>';
$this->print_margin_setting_field('_____container','left','ޡ','ޡꤷޤ');
$this->print_margin_setting_field('_____container','right','ޡ','ޡꤷޤ');
print '</tr>';
print '</tbody></table></fieldset>';

print '<fieldset>';
print '<legend>ƥ</legend>';
print '<table class="field-table"><tbody>';
print '<tr>';
$this->print_text_align_setting_field('_____container','ƥ','ƥ');
print '</tr>';
print '</tbody></table></fieldset>';

print '<fieldset class="foldable">';
print '<legend><label for="data:_____container:USER">¾Υƥĥꥢ</label></legend>';
print '<textarea cols="80" rows="8" name="data:_____container:USER" id="data:_____container:USER" wrap="off" class="content-editor-area" title="&lt;<*** id="container"&gt;Υꤷޤ">', $this->escape($main::data{'_____container'}{'USER'}), '</textarea>';
$this->{'helper'}->print_menu('data:_____container:USER');
print '</fieldset>';

print '</fieldset>';

print '<fieldset class="foldable">';
print '<legend>ƥĥꥢ&lt;div id="container"&gt;</legend>';

print '<fieldset>';
print '<legend>ܥå</legend>';
print '<table class="field-table"><tbody>';
print '<tr>';
print '<td class="field-name"><label for="data:div_____container:width"></label></td><td class="q-field"><input type="text" name="data:div_____container:width" id="data:div_____container:width" value="' . $this->escape($main::data{'div_____container'}{'width'}) . '" size="12" /></td>';
print '<td class="field-name"><label for="data:div_____container:height">⤵</label></td><td class="q-field"><input type="text" name="data:div_____container:height" id="data:div_____container:height" value="' . $this->escape($main::data{'div_____container'}{'height'}) . '" size="12" /></td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label for="data:div_____container:background_color">طʿ</label></legend>';
print '<input type="text" name="data:div_____container:background_color" id="data:div_____container:background_color" value="', $this->escape($main::data{'div_____container'}{'background_color'});
print '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:div_____container:background_color\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" style="background-color: ', $this->escape($main::data{'div_____container'}{'background_color'}), '" />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:div_____container:background_color\')" ondblclick="cmonos.tool.colorPalette.open(\'data:div_____container:background_color\',\'window\')">';
print '<img src="', $env::image_dir, '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:div_____container:background_color\')" ondblclick="cmonos.tool.colorSlider.open(\'data:div_____container:background_color\',\'window\')">';
print '<img src="', $env::image_dir, '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label for="data:div_____container:USER">¾Υƥĥꥢ&lt;div id="container"&gt;</label></legend>';
print '<textarea cols="80" rows="8" name="data:div_____container:USER" id="data:div_____container:USER" wrap="off" class="content-editor-area" title="&lt;div id="container"&gt;Υꤷޤ">', $this->escape($main::data{'div_____container'}{'USER'}), '</textarea>';
$this->{'helper'}->print_menu('data:div_____container:USER');
print '</fieldset>';

print '</fieldset>';

print '<fieldset>';
print '<legend>ѥ֥å</legend>';
print '<fieldset>';
print '<legend>ѿ</legend>';
print '<input type="text" name="blockquote_color" id="blockquote_color" value="' . $this->escape($main::blockquote_color) . '" title="ʣꤹȤ , Ƕڤޤ" size="70" onclick="cmonos.tool.colorPalette.open(\'blockquote_color+\',\'dom\')" onchange="cmonos.form.field(this).quotColorSample()" onfocus="cmonos.form.field(this).quotColorSample()" />';
print '<a href="JavaScript:cmonos.tool.colorPalette.open(\'blockquote_color+\')" ondblclick="cmonos.tool.colorPalette.open(\'blockquote_color+\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print $this->javascript(
<<'JAVASCRIPT'
cmonos.form.quotColorSample = function () {
	if (this.currentField && this.currentField.value == '') {
		document.getElementById('quotation-color-sample').innerHTML = '';
		this.currentField.style.backgroundColor = '';
	} else {
		var qsample = '';
		var fixed_color = '';
		var qcolor = this.currentField.value.split(/\s*,\s*/).reverse();
		for (var i=0; i<qcolor.length; i++) {
			if (qcolor[i] != null && qcolor[i].search(/^#[0-9a-fA-F]{6}$/) != -1) {
				qsample = '<blockquote style="color: ' + qcolor[i] + '; border-left-style: solid; border-left-width: 2px; margin-left: 0; margin-right: 0; padding-left: 8px; padding-right: 0;">' + qsample + 'Hello World !</blockquote>';
				fixed_color = qcolor[i] + ((fixed_color != '') ? ',' + fixed_color : '');
			}
		}
		document.getElementById('quotation-color-sample').innerHTML = qsample;
		this.currentField.value = fixed_color;
	}
}
JAVASCRIPT
);
print '<div id="quotation-color-sample"></div>';
print '</fieldset>';
print '<fieldset class="foldable">';
print '<legend><label for="data:blockquote____quotation___blockquote____quotation__blockquote:USER">¾ΰѥ֥å&lt;blockquote id="quotation"&gt;</label></legend>';
print '<textarea cols="80" rows="8" name="data:blockquote____quotation___blockquote____quotation__blockquote:USER" id="data:blockquote____quotation___blockquote____quotation__blockquote:USER" wrap="off" class="content-editor-area" title="&lt;blockquote class="quotation"&gt;Υꤷޤ">', $this->escape($main::data{'blockquote____quotation___blockquote____quotation__blockquote'}{'USER'}), '</textarea>';
$this->{'helper'}->print_menu('data:blockquote____quotation___blockquote____quotation__blockquote:USER');
print '</fieldset>';

print '</fieldset>';

print '<fieldset>';
print '<legend><label for="data:MAIN:USER">嵭ʳ</label></legend>';
print '<textarea cols="80" rows="30" name="data:MAIN:USER" id="data:MAIN:USER" wrap="off" ondblclick="cmonos.tool.colorPalette.open(\'data:MAIN:USER+\',\'dom\')" class="content-editor-area" title="嵭ʳΥꤷޤ">', $this->escape($main::data{'MAIN'}{'USER'}), '</textarea>';
$this->{'helper'}->print_menu('data:MAIN:USER');
print '</fieldset>';

print '<fieldset class="submit"><input type="submit" value="¸" class="save" /></fieldset></form>';

if (defined $main::target && $main::target ne '' && $main::target ne '<new>' && $main::target ne 'default' && !$this->is_a_reserved_word($main::target)) {
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'delete',
		'method'	=>	'post',
		'required'	=>	[@setting::form,'target']
	);
	print '<fieldset class="delete"><input type="submit" name="a=del" value="" onclick="return confirm(\'ϼäޤ˺ޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();" /></fieldset></form>';
}

#ڡեå
$this->print_page_footer('tools');
}


sub is_a_reserved_word ($$) {
my($this,$word) = @_;
return ($word eq 'common' || $word eq 'image' || $word eq 'tools' || $word !~ /^\w+$/) ? 1 : 0;
}

sub print_line_height_setting_field ($$$$;$) {
my($this,$name,$jname,$title,$colspan) = @_;
$main::data{$name}{'line_height'} =~ s/em\s*$// if $main::data{$name}{'line_height'};
print '<td class="field-name"><label for="data:' . $name . ':line_height">' . ((defined $jname) ? $jname : '') . 'Դֳ</label></td><td' . (($colspan) ? ' class="field" colspan="3"' : ' class="q-field"') . '>';
print $this->mk_select_menu(
	'data:' . $name . ':line_height',$title,'',$main::data{$name}{'line_height'},
	''			=>		'',
	'1'		=>		'1ʸ',
	'1.2'		=>		'1.2ʸ',
	'1.5'		=>		'1.5ʸ',
	'1.8'		=>		'1.8ʸ',
	'2'		=>		'2ʸ',
	'2.5'		=>		'2.5ʸ'
);
print '</td>';
}

sub print_text_align_setting_field ($$$$;$) {
my($this,$name,$jname,$title,$colspan) = @_;
print '<td class="field-name"><label for="data:' . $name . ':text_align">' . ((defined $jname) ? $jname : '') . '·</label></td><td' . (($colspan) ? ' class="field" colspan="3"' : ' class="q-field"') . '>';
print $this->mk_select_menu(
	'data:' . $name . ':text_align',$title,'',$main::data{$name}{'text_align'},
	''			=>		'',
	'left'		=>		'·',
	'center'	=>		'·',
	'right'		=>		'·',
	'justify'	=>		'ξü·'
);
print '</td>';
}

sub print_font_size_setting_field ($$$$) {
my($this,$name,$jname,$title) = @_;
print '<td class="field-name"><label for="data:' . $name . ':font_size">' . ((defined $jname) ? $jname : '') . '</label></td>';
print '<td class="q-field"><input type="text" name="data:' . $name . ':font_size" id="data:' . $name . ':font_size" value="' . $this->escape($main::data{$name}{'font_size'}) . '" size="16"' . (($title) ? ' title="' . $title . '"' : '') . ' /></td>';
}

sub print_font_family_setting_field ($$$$) {
my($this,$name,$jname,$title,$colspan) = @_;
print '<td class="field-name"><label for="data:' . $name . ':font_family">' . ((defined $jname) ? $jname : '') . '</label></td>';
print '<td class="field"' . (($colspan) ? ' colspan="3"' : '') . '><input type="text" name="data:' . $name . ':font_family" id="data:' . $name . ':font_family" value="' . $this->escape($main::data{$name}{'font_family'}) . '" size="64"' . (($title) ? ' title="' . $title . '"' : '') . ' />';
print '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:', $name, ':font_family\').quotationByMenu(this)">';
print '<option value=""></option>';
print '<option value="\'Lucida Grande\',\'Hiragino Kaku Gothic Pro\',\'ҥ饮γѥ Pro W3\',\'HiraKakuProN-W3\',Verdana,\'ᥤꥪ\',Meiryo,\'ͣ Хå\',\'MS PGothic\',\'ͣ å\',\'MS Gothic\',Osaka,arial,helvetica,sans-serif">å</option>';
print '<option value="\'Hiragino Mincho Pro\',\'ҥ饮ī Pro W3\',\'HiraMinProN-W3\',\'ͣ ī\',\'MS PMincho\',\'ͣ ī\',\'MS Mincho\',serif">ī</option>';
print '<option value="\'Hiragino Maru Gothic Pro\',\'ҥ饮δݥ Pro W4\',\'ᥤꥪ\',Meiryo,\'ͣ Хå\',\'MS PGothic\',Verdana,sans-serif">ݥå</option>';
print '</select></td>';
}

sub print_color_setting_field ($$$$;$) {
my($this,$name,$jname,$title,$colspan) = @_;
print '<td class="field-name"><label for="data:', $name, ':color">' . ((defined $jname) ? $jname : '') . '</label></td>';
print '<td' . (($colspan) ? ' class="field" colspan="3"' : ' class="q-field"') . '>';
print '<input type="text" name="data:', $name, ':color" id="data:' . $name . ':color" value="' . ((defined $main::data{$name}{'color'}) ? $main::data{$name}{'color'} : '');
print '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:', $name, ':color\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"' . ((defined $main::data{$name}{'color'}) ? ' style="background-color: ' . $main::data{$name}{'color'} : '') . '"';
print (($title) ? ' title="' . $title . 'ꤷޤ"' : '');
print ' />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:', $name, ':color\')" ondblclick="cmonos.tool.colorPalette.open(\'data:', $name, ':color\',\'window\')">';
print '<img src="', $env::image_dir, '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:', $name, ':color\')" ondblclick="cmonos.tool.colorSlider.open(\'data:', $name, ':color\',\'window\')">';
print '<img src="', $env::image_dir, '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</td>';
}

sub print_margin_setting_field ($$$$$) {
my($this,$name,$align,$jname,$title) = @_;
print '<td class="field-name"><label for="data:' . $name . ':margin_' . $align . '">' . ((defined $jname) ? $jname : '') . '</label></td>';
print '<td class="q-field"><input type="text" name="data:' . $name . ':margin_' . $align . '" id="data:' . $name . ':margin_' . $align . '" value="' . $this->escape($main::data{$name}{'margin_' . $align}) . '" size="7"' . (($title) ? ' title="' . $title . '"' : '') . ' /></td>';
}

sub print_link_setting_field ($$$$;$) {
my($this,$name,$jname,$title,$class) = @_;
print '<tbody' . ((defined $class && $class ne '') ? ' class="' . $class . '"' : '') . '><tr class="tbody-start"><td class="field-name"><label for="data:' . $name . ':color">' . ((defined $jname) ? $jname : '') . '</label></td>';
print '<td class="q-field"><input type="text" name="data:', $name, ':color" id="data:', $name, ':color" value="', ((defined $main::data{$name}{'color'}) ? $main::data{$name}{'color'} : '');
print '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:', $name, ':color\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"' . ((defined $main::data{$name}{'color'}) ? ' style="background-color: ' . $main::data{$name}{'color'} : '') . '"';
print (($title) ? ' title="' . $title . '"' : '');
print ' />';
print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:', $name, ':color\')" ondblclick="cmonos.tool.colorPalette.open(\'data:', $name, ':color\',\'window\')">';
print '<img src="', $env::image_dir, '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:', $name, ':color\')" ondblclick="cmonos.tool.colorSlider.open(\'data:', $name, ':color\',\'window\')">';
print '<img src="', $env::image_dir, '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
print '</td><td class="field-name"><label for="data:' . $name . ':text_decoration">' . ((defined $jname) ? $jname : '') . '</label></td><td class="q-field">';
print $this->mk_select_menu(
	'data:' . $name . ':text_decoration',((defined $jname) ? $jname : '') . 'ꤷޤ','',$main::data{$name}{'text_decoration'},
	''						=>		'',
	'none'					=>		'̵',
	'underline'				=>		'',
	'overline'				=>		'',
	'overline underline'	=>		'+'
);
print '</td></tr>';

print '<tr class="foldable">';
print '<td class="field-name"><label for="data:', $name, ':USER">¾</label></td>';
print '<td class="field" colspan="3"><textarea cols="70" rows="8" name="data:', $name, ':USER" id="data:', $name, ':USER" wrap="off" ondblclick="cmonos.tool.colorPalette.open(\'data:', $name, ':USER+\',\'dom\')"';
print (($title) ? ' title="' . $title . '"' : '');
print '>', $this->escape($main::data{$name}{'USER'}), '</textarea>';
$this->{'helper'}->print_menu('data:' . $name . ':USER',1);
print '</td></tr></tbody>';
}

######################################################################
#륷Ƚ񤭹ɤ߹
sub write_style_sheet ($$) {
my($this,$target) = @_;
return if $target !~ /^\w+$/;
my $path = $env::css . '/' . $target . '.css';
my $image_dir_path = $this->base_change($env::image_dir,$path);

local(*OUT);
if (open(OUT, ">>$path")) {
	flock(OUT, LOCK_EX);
	truncate(OUT, 0);
	seek(OUT, 0, 0);

	print OUT '@charset "EUC-JP";',"\x0A\x0A";
	if (defined $main::vicuna && $main::vicuna eq 'import') {
		print OUT '/*------VICUNA_START------*/',"\x0A";
		if ($main::vicuna_url ne '') {
			print OUT '@import url(\'' . $main::vicuna_url . '\');',"\x0A";
		} elsif (-f $env::css . '/vicuna/0-import.css') {
			print OUT '@import url(\'./vicuna/0-import.css\');',"\x0A";
		} elsif (-f $env::css . '/vicuna/import.css') {
			print OUT '@import url(\'./vicuna/import.css\');',"\x0A";
		} else {
			print OUT '@import url(\'./vicuna/0-import.css\');',"\x0A";
			print OUT '@import url(\'./vicuna/import.css\');',"\x0A";
		}
		print OUT '/*------VICUNA_E_N_D------*/',"\x0A\x0A";
	}
	if (defined $main::data{'HEADER'}{'USER'} && $main::data{'HEADER'}{'USER'}) {
		print OUT '/*------HEADER_START------*/',"\x0A";
		print OUT $main::data{'HEADER'}{'USER'},"\x0A";
		print OUT '/*------HEADER_E_N_D------*/',"\x0A\x0A";
	}

	my($selector);
	#foreach $selector (sort keys %main::data) {
	foreach $selector ('body','a_link','a_visited','a_hover','a_active','body___table','p','p__a_link','p__a_visited','p__a_hover','p__a_active','_____container','div_____container','blockquote____quotation___blockquote____quotation__blockquote') {
		#next if $selector eq 'HEADER' || $selector eq 'MAIN';
		my $css_selector = $selector;
		$css_selector =~ s/______/>/g;
		$css_selector =~ s/_____/#/g;
		$css_selector =~ s/____/./g;
		$css_selector =~ s/___/, /g;
		$css_selector =~ s/__/ /g;
		$css_selector =~ s/_/:/g;

		my($property,$style);
		foreach $property (sort keys %{$main::data{$selector}}) {
			my $css_property = $property;
			$css_property =~ s/_/-/g;

			if (defined $main::data{$selector}{$property} && $main::data{$selector}{$property} ne '') {
				if ($property eq 'USER') {
					$main::data{$selector}{'USER'} =~ s/^\s*/  /gm;
					$main::data{$selector}{'USER'} =~ s/[\x0A]+/\x0A/gs;
				} elsif ($property =~ /_image$/) {
					my $image = ($property =~ /^background_/) ? 'background' : 'misc';
					$style .= '  ' . $css_property . ': url("';
					$style .= $image_dir_path . '/' . $image . '/' . $cgi::Deco->background_file_name($image,$main::data{$selector}{$property}) . '");' . "\x0A";
				} else {
					$style .= '  ' . $css_property . ': ' . $main::data{$selector}{$property} . ';' . "\x0A";				
				}
			}
		}
		if ($selector eq 'blockquote____quotation___blockquote____quotation__blockquote' && $main::blockquote_color) {
			$main::blockquote_color =~ s/\s+//sg;
			my @blockquote_color = split(/,/, $main::blockquote_color);
			my $color;
			my $n = 0;
			print OUT '/*------BLOCKQUOTE_COLOR_START------*/',"\x0A";
			foreach $color (@blockquote_color) {
				print OUT 'blockquote.quotation' . (' blockquote' x $n++) . ' {color: ' . $color . '}' . "\x0A";
			}
			print OUT 'blockquote.quotation blockquote {margin: 0}',"\x0A";
			print OUT '/*------BLOCKQUOTE_COLOR_E_N_D------*/',"\x0A";
			if (!$style && !$main::data{$selector}{'USER'}) {
				$main::data{$selector}{'USER'} .= '  background: none;' . "\x0A";
				$main::data{$selector}{'USER'} .= '  border: none;' . "\x0A";
				$main::data{$selector}{'USER'} .= '  padding: 0 0 0 8px;' . "\x0A";
				$main::data{$selector}{'USER'} .= '  margin-top: 0.8em;' . "\x0A";
				$main::data{$selector}{'USER'} .= '  margin-bottom: 0.8em;' . "\x0A";
				$main::data{$selector}{'USER'} .= '  border-left-style: solid !important;' . "\x0A";
				$main::data{$selector}{'USER'} .= '  border-left-width: 2px !important;' . "\x0A";
			}
		}
		$style .= $main::data{$selector}{'USER'} . (($main::data{$selector}{'USER'} =~ /\x0A$/s) ? '' : "\x0A") if defined $main::data{$selector}{'USER'} && $main::data{$selector}{'USER'};
		if (defined $style && $style ne '') {
			print OUT $css_selector, ' {', "\x0A";
			print OUT $style;
			print OUT '}', "\x0A";
		}
	}
	print OUT "\x0A", $main::data{'MAIN'}{'USER'}, "\x0A" if defined $main::data{'MAIN'}{'USER'} && $main::data{'MAIN'}{'USER'};

	close(OUT);
	push(@{$this->{'dialog'}},$target . '.css 򹹿ޤ');
} else {
	push(@{$this->{'dialog'}},$target . '.css ι˼Ԥޤե򳫤ޤ');
}
}

sub read_style_sheet ($$) {
my($this,$target) = @_;
return if $target !~ /^\w+$/;
my($css);
my $path = $env::css . '/' . $target . '.css';
my $image_dir_path = $this->base_change($env::image_dir,$path);

#ɤ߹
local(*FILE);
if (open(FILE, $path)) {
	binmode FILE;
	flock(FILE, LOCK_EX);
	$css = join('',<FILE>);
	close(FILE);
} else {
	push(@{$this->{'dialog'}},$target . '.css ĤޤǤ');
	return;
}
$css =~ s/\x0D\x0A/\x0A/sg;
$css =~ s/\x0D/\x0A/sg;
$css = $cgi::Jcode->set(\$css)->euc;

#
$css =~ s!\@charset\s*["'].*?["'][;]?[\x0A]+!!s;
if ($css =~ s!/\*------VICUNA_START------\*/\x0A(.*)/\*------VICUNA_E_N_D------\*/\x0A\x0A!!s && $1 =~ /\@import url\('(.*?)'\);/) {
	my $url = $1;
	$main::vicuna = 'import';
	if ($url eq './vicuna/0-import.css' || $url eq './vicuna/import.css') {
		$main::vicuna_url = '';
	} else {
		$main::vicuna_url = $url;
	}
} else {
	$main::vicuna = 'none';
}
$main::data{'HEADER'}{'USER'} = $1 if $css =~ s!/\*------HEADER_START------\*/\x0A(.*)/\*------HEADER_E_N_D------\*/\x0A\x0A!!s;
$main::blockquote_color = $this->blockquote_colors($1) if $css =~ s!/\*------BLOCKQUOTE_COLOR_START------\*/\x0A(.*?)/\*------BLOCKQUOTE_COLOR_E_N_D------\*/\x0A!!s;

my($selector,$body___table);
foreach $selector ('body','a:link','a:visited','a:hover','a:active','body, table','p','p a:link','p a:visited','p a:hover','p a:active','#container','div#container','blockquote.quotation, blockquote.quotation blockquote') {
	#next if $selector eq 'HEADER' || $selector eq 'MAIN';
	my $data_selector = $selector;
	$data_selector =~ s/\:/_/g;
	$data_selector =~ s/\, /___/g;
	$data_selector =~ s/ /__/g;
	$data_selector =~ s/\./____/g;
	$data_selector =~ s/\#/_____/g;
	$data_selector =~ s/\>/______/g;

	if ($css =~ s/(\A|\x0A)$selector\s*\{(.*?)\}[\x0A]?/$1/s) {
		my $style = $2;
		my($property,@properties);
		if ($selector eq 'body') {
			@properties = ('background-color','background-image','background-attachment','margin-top','margin-left','margin-right','margin-bottom','color','text-align');
		} elsif ($selector eq 'p') {
			@properties = ('line-height');
		} elsif ($selector eq 'body, table') {
			@properties = ('line-height','font-size','font-family');
		} elsif ($selector =~ /^(p |)a:/) {
			@properties = ('color','text-decoration');
		} elsif ($selector eq '#container') {
			@properties = ('margin-top','margin-left','margin-right','margin-bottom','text-align');
		} elsif ($selector eq 'div#container') {
			@properties = ('width','height','background-color');
		}
		foreach $property (@properties) {
			my $data_property = $property;
			$data_property =~ s/-/_/g;

			if ($style =~ s/(\A|\x0A)[\x20\x09]*$property\s*:\s*(.*?)(;[\x0A]?|\Z)/$1/s) {
				my $value = $2;
				$value =~ s/[\x0A]+$//s;
				if ($property =~ /-image$/) {
					$value = $1 if $value =~ /url\s*\(\s*["'](.*?)["']\s*\)/;
					if ($value =~ /^$image_dir_path/ && $value =~ /\/(\w+)\.(gif|jpg|png)$/) {
						$value = $1;
					}  else {
						$main::data{$data_selector}{'USER'} .= '  ' . $property . ': url("' . $value . '");' . "\x0A";
						next;
					}
				}
				$main::data{$data_selector}{$data_property} = $value;
			}
		}
		$style =~ s/\A\s+/  /;
		$style =~ s/\s+\Z/\x0A/;
		if ($selector eq 'body, table') {
			$body___table .= "body, table {\x0A" .  $style . "\x0A}\x0A" if $style =~ /:/;
		} else {
			$main::data{$data_selector}{'USER'} .= $style;
		}
	}
}
$css =~ s/\A\s+//;
$css =~ s/\s+\Z/\x0A/;
$main::data{'MAIN'}{'USER'} = ((defined $body___table && $body___table) ? $body___table : '') . $css;
}

sub blockquote_colors ($$) {
my($this,$css) = @_;
my $regexp = '\s+blockquote';
my $selector_regexp = '';
my @blockquote_color = ();
my $n = 1;
while ($css =~ s/blockquote\.quotation$selector_regexp\s*{(.*?)}//s) {
	my $style = $1;
	push(@blockquote_color,$1) if $style =~ /color:\s*([#\w]+)/;
	$selector_regexp = $regexp x $n++;
}
return @blockquote_color ? join(',',@blockquote_color) : '';
}

######################################################################
# ⥸塼ɤ߹
#sub import {
BEGIN {
#no warnings qw(once);
unless ($default::subdivided && defined $main::c && $main::c ne '') {

	#饹Ͽ
	Common::class_register('0110','StyleSheetEditor');

	#ġϿ
	$setting::jump_menu{'0110'} = 'CSSեԽ()';						#줬ǥե
	$setting::master_check_option{'0110'} = 1;
}
}


1;
