package CalSearch;
require CMONOS::Calendar::CalCommon;
@ISA = qw(CalCommon);
use strict;
######################################################################
# ٥ȸեɽ⥸塼
# CalSearch.pm ver1.0.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-06-04
######################################################################
# ֥Ⱥ
sub new ($) {
my $pkg = shift;
my $this = {};
bless $this, $pkg;
return $this;
}

######################################################################
#٥ȥꥹ
sub print_events ($) {
my $this = shift;

#ե졼
if (defined $setting::page{$setting::key}{'searchFrameTitle'} && $setting::page{$setting::key}{'searchFrameTitle'}) {
	print $this->frame_start(
		$setting::page{$setting::key}{'searchFrame'},
		$setting::page{$setting::key}{'searchFrameWidth'},
		'box',
		'calendar-search-frame',
		'<h2>٥ȸ</h2>',
	);
} else {
	print  $this->frame_start(
		$setting::page{$setting::key}{'searchFrame'},
		$setting::page{$setting::key}{'searchFrameWidth'},
		'box',
		'calendar-search-frame',
	);
	print '<h2>٥ȸ</h2>';
}

#ե
print  $this->form_start(
	'key'	=>	'browse',
	'name'	=>	'input',
	'required'	=>	['k','m','date']
);

print  '<table class="field-table"><tbody>';

my $title_field = ($field::for{'title'}) ? $field::for{'title'} : ($field::for{'key'}) ? $field::for{'key'} : ($field::for{'name'}) ? $field::for{'name'} : "";
my $search_count = 0;
foreach (sort {$a <=> $b} keys %field::ORDER) {
	if (
		ref $field::obj{$field::ORDER{$_}}
		&& (
			$field::ORDER{$_} eq $title_field
			|| $field::obj{$field::ORDER{$_}}->{'class'} eq 'xcal_category'
			|| (defined $setting::security{'detail'}{'passwordCheck'} && $setting::security{'detail'}{'passwordCheck'} eq 'nocheck')
			|| $this->is_one_of_owners
		)
		&& !$field::obj{$field::ORDER{$_}}->{'Hidden'}
		&& ($field::obj{$field::ORDER{$_}}->{'Open'} || $this->is_secure('secret'))
		&& $field::obj{$field::ORDER{$_}}->{'searchEnabled'}
		&& $field::obj{$field::ORDER{$_}}->search_form_enabled
	) {
		print  $field::obj{$field::ORDER{$_}}->search_form;
		$search_count++;
	}
}

print  '</tbody><tbody><tr class="tbody-start"><td class="reset-box"><input type="button" value="ꥻå" onclick="cmonos.form.item(this.form).resetAll(\'search:\')" /></td><td class="submit-box">';
if ($search_count > 1) {
	print  '<select name="and">';
	print  '<option value="1">Ƥξ˰</option>';
	print  '<option value="0"';
	print  ' selected="selected"' if !$main::and;
	print  '>줫ξ˰</option>';
	print  '</select>';
}
if (!$setting::page{'viewer'}{'defaultView'} || $setting::page{'viewer'}{'defaultView'} ne 'M') {
	print $this->mk_select_menu(
		'v','ͽɽˡ','',$main::v,
		'd'	=>	'ɽ',
		'w'	=>	'ɽ',
		'm'	=>	'ɽ'
	);
}
print '<input type="submit" value="' . (($default::english) ? 'Search' : '') . '" />';
print  '</td></tr></tbody></table>';
print  '</form>';

#ե졼ཪλ
print  $this->frame_end($setting::page{$setting::key}{'searchFrame'},$setting::page{$setting::key}{'searchFrameWidth'},'box','calendar-search-frame',1);

}

sub page_title ($$) {
my($this,$date) = @_;
return '';
}

sub have_timetable ($) {
my $this = shift;
return 0;
}

1;
