package CalUserGeneratedField;
use strict;
######################################################################
# ե⥸塼Calendar 桼եɡ
# CalUserGeneratedField.pm 1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-08-28
######################################################################
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

sub get_query_for_user_generated_field_editor ($;$$$) {
my($this,$for_post,$c,$n) = @_;
$c = (defined $c && $c ne '') ? $c : (defined $main::c && $main::c ne '') ? $main::c : '';
$n = (defined $n && $n ne '') ? $n : $main::n;
if ($for_post) {
	return $this->add_query('post',
		{
			'm'		=>	'UserGeneratedFieldEditor',
			'k'		=>	'ugfieldeditor',
			'id'	=>	$this->{'id'},
			(($default::subdivided) ? ('c' => $c) : ()),
			'n' => $main::n
		}
	)
} else {
	return '?m=UserGeneratedFieldEditor&k=ugfieldeditor&id=' . $this->{'id'} . (($default::subdivided) ? '&c=' . $c : '') . '&n=' . $n;
}
}

sub _mk_user_generated_field_id ($;$$) {
my($this,$c,$n) = @_;
return (($default::subdivided && defined $c && $c ne '') ? '-' . $c : '') . '-' . (($n) ? $n : 'new') . '-' . $this->{'id'};
}

sub get_query_keys ($) {
my $this = shift;
if ($this->{'externalFileDisabled'}) {
	return [grep($_ ne 'c' && $_ ne 'n',@setting::form)];
} else {
	return [];
}
}

sub add_query_for_form ($;$$) {
my($this,$c,$n) = @_;
return $this->add_query('post',{'n' => $n,(($default::subdivided && defined $main::c && $main::c ne '') ? ('c' => $c) : ())});
}

sub get_output_path ($) {
my $this = shift;
return '';
}

sub is_short_parameters ($) {
return (!$default::db || !$default::file || ($default::subdivided && (!defined $main::c || $main::c eq '')) || !defined $main::n || $main::n eq '') ? 1 : 0;
}

sub get_field_data ($) {
my $this = shift;
my(%db,$data);
tie(%db, $env::dbm_file, $default::db . '/' . $this->db, O_RDONLY, $env::dbm_mode);
if (ref tied %db) {
	$data = $db{$main::n};
}
untie %db;
return ($data) ? {$this->elements($data)} : {};
}

sub get_file_directory ($) {
my $this = shift;
return $default::file . '/' . $main::n;
}

sub get_db_directory ($) {
my $this = shift;
return $default::db;
}

sub get_mail_field_data ($$) {
my($this,$mailto) = @_;
return '' if !ref $field::obj{$mailto} || $field::obj{$mailto}->{'class'} !~ /email/;
my(%mail);
my $addr = '';
tie(%mail, $env::dbm_file, $default::db . '/' . $field::obj{$mailto}->db, O_RDONLY, $env::dbm_mode);
if (ref tied %mail) {
	$addr = $mail{$main::n} if $mail{$main::n};
}
untie %mail;
return ($addr) ? join(',',$this->get_address($addr)) : '';
}

sub get_title_field_data ($$) {
my $this = shift;
return '' if !$field::for{'title'} || !ref $field::obj{$field::for{'title'}};
my(%title);
my $title = '';
tie(%title, $env::dbm_file, $default::db . '/' . $field::obj{$field::for{'title'}}->db, O_RDONLY, $env::dbm_mode);
if (ref tied %title) {
	$title = $title{$main::n} if $title{$main::n};
}
untie %title;
$this->text_color(\$title);
return $title;
}

sub get_viewer_url ($;$$) {
my($this,$c,$n) = @_;
return $this->my_url . '?m=DetailViewer' . (($default::subdivided && defined $c && $c ne '') ? '&c=' . $c : '') . ((defined $n && $n ne '') ? '&n=' . $n : '');
}

sub post_update ($;$) {
my($this,$unadditional) = @_;
if (!$unadditional && $this->{'mTime'}) {
	my(%mtime,$time);
	$time = time;

	#ν񤭹
	tie(%mtime, $env::dbm_file, $default::db . '/mtime', O_RDWR, $env::dbm_mode);
	if (ref tied %mtime && $mtime{$main::n}) {
		$mtime{$main::n} = $time;
	}
	untie %mtime;

	#ƥ꡼
	if (defined $default::subdivided && $default::subdivided) {
		my(%category_mtime);
		tie(%category_mtime, $env::dbm_file, $default::master_db_dir . '/category_mtime', O_RDWR, $env::dbm_mode);
		if (ref tied %category_mtime && $category_mtime{$main::c}) {
			$category_mtime{$main::c} = $time;
			$category_mtime{'Last-Modified'} = $time;
		}
		untie %category_mtime;
	}
}
return 1;
}

sub is_secure_user_for_update ($) {
my $this = shift;
return 0 if $this->is_short_parameters;
$this->read_security_settings;
return ((!$this->{'generatableUser'} || $this->is_as_secure_as($this->{'generatableUser'})) && (($this->{'Open'} && $this->is_secure('browse',1)) || $this->is_secure('secret',1))) ? 1 : 0;
}

sub get_rss_path ($) {
my $this = shift;
return (
	$default::file,
	$this->my_url . '?' . (($default::subdivided && defined $main::c && $main::c ne '') ? 'c=' . $main::c . '&' : ''),
	(($default::subdivided) ? $default::master_file_dir : ''),
	(($default::subdivided) ? $this->my_url : '')
);
}



1;
