package EventCategory;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# եɥ⥸塼ʥ٥ȥƥ꡼
# EventCategory.pm 1.0.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-02-05
######################################################################
sub _set ($$) {
my($this,$setting) = @_;

#٥ȥƥ꡼
$this->import_db($default::preference_dir . '/event_category',\%setting::event_category,1) unless %setting::event_category && ref $setting::event_category{'ORDER'} && %{$setting::event_category{'ORDER'}};
$this->{'disabled'} = 1 if !%setting::event_category || !ref $setting::event_category{'ORDER'} || !%{$setting::event_category{'ORDER'}};
$this->{'field_for'}{'category'} = $this->{'id'};
return;
}

######################################################################
#	(0)-3 եDB
sub db ($) {
my $this = shift;
return 'category';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
return 0 if $this->{'disabled'};
return ((defined $main::search{$this->{'id'}}{'str'} && $main::search{$this->{'id'}}{'str'} ne '') || (ref $main::search{$this->{'id'}}{'str'} && @{$main::search{$this->{'id'}}{'str'}})) ? 1 : 0;
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
return 1 if !$this->match_enabled;
$this->scalar_to_array(\$main::search{$this->{'id'}}{'str'}) if !ref $main::search{$this->{'id'}}{'str'};
foreach (@{$main::search{$this->{'id'}}{'str'}}) {
	next if !defined $_ || $_ eq '';
	return 1 if defined $$str && $$str eq $_;
}
return 0;
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
my $this = shift;
return ($this->{'disabled'}) ? 0 : 1;
}

sub form {
my($this,$status,$original) = @_;
return '' if $this->{'disabled'} || ($this->{'required'} && values %{$setting::event_category{'ORDER'}} == 1);
my @data = ($main::data{$this->{'id'}}{'str'});
my $form = $this->field_header('','data:' . $this->{'id'} . ':str');
$form .= $this->event_category_menu('data:' . $this->{'id'} . ':str',0,\@data,$this->{'is_invalid_field'}{'str'});
$form .= $this->field_footer;
return $form;
}

sub event_category_menu ($$$$;$) {
my($this,$name,$multiple_flag,$selected,$is_invalid_field) = @_;
my($form);
$form .= '<select name="' . $name . '" id="' . $name . '"' . (($multiple_flag) ? ' multiple="multiple"' : '') . (($is_invalid_field) ? $this->set_invalid_class : '') . '>';
$form .= '<option value=""></option>';
foreach my $c (sort {$a <=> $b} keys %{$setting::event_category{'ORDER'}}) {
	my $id = $setting::event_category{'ORDER'}{$c};
	if (!defined $id || !ref $setting::event_category{$id} || !$setting::event_category{$id}{'closed'} || $this->is_secure('setClosedEvent',0,'closed')) {
		$form .= '<option value="' . $id . '"' . ((ref $selected eq 'ARRAY' && @$selected && grep(defined $_ && $_ ne '' && $id eq $_,@$selected)) ? ' selected="selected"' : '') . '>' . $setting::event_category{$id}{'name'} . '</option>';	
	}
}
$form .= '</select>';
return $form;
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
my $this = shift;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
if ($this->{'disabled'}) {
	delete $main::data{$this->{'id'}}{'str'};
	return 1;
}
if ($this->{'required'}) {
	my @categories = values %{$setting::event_category{'ORDER'}};
	$main::data{$this->{'id'}}{'str'} = $categories[0] if @categories == 1;
}
my $id = $main::data{$this->{'id'}}{'str'};
if (!defined $id || !$id) {
	if ($this->{'required'}) {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : 'ƥ꡼') . '򤷤Ƥ') if ref $cgi::action;
		$main::data{$this->{'id'}}{'str'} = '';
		$this->{'is_invalid_field'}{'str'} = 1;
		return 0;
	}
} elsif (!defined $setting::event_category{$id}{'name'} || $setting::event_category{$id}{'name'} eq '') {
	push(@{$cgi::action->{'dialog'}},'ꤵ줿' . (($this->{'name'}) ? $this->{'name'} : 'ƥ꡼') . '¸ߤޤ') if ref $cgi::action;
	$main::data{$this->{'id'}}{'str'} = '';
	$this->{'is_invalid_field'}{'str'} = 1;
	return 0;
} elsif ($setting::event_category{$id}{'closed'} && !$this->is_secure('setClosedEvent',0,'closed')) {
	push(@{$cgi::action->{'dialog'}},'ꤵ줿' . (($this->{'name'}) ? $this->{'name'} : 'ƥ꡼') . 'ߤĤޤǤ') if ref $cgi::action;
	$main::data{$this->{'id'}}{'str'} = '';
	$this->{'is_invalid_field'}{'str'} = 1;
	return 0;
}
return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format_enabled ($) {
my $this = shift;
return ($this->{'disabled'}) ? 0 : 1;
}

sub usual_format {
my($this,$str,$path,$c,$n) = @_;
return '' if defined $this->{'disabled'} && $this->{'disabled'};
$str = $$str{'str'} if ref $str eq 'HASH';
return '' if !defined $str || !$str || !$setting::event_category{$str}{'name'};
return $this->field_tag(
	$this->style(
		$this->escape($setting::event_category{$str}{'name'}),
		$this->{'style'},
		$this->{'fontsize'},
		$this->{'fontcolor'},
		$this->{'fontface'}
	)
);
}

sub has_content {
my($this,$str) = @_;
return 0 if defined $this->{'disabled'} && $this->{'disabled'};
$str = $$str{'str'} if ref $str eq 'HASH';
return (defined $str && $str && $setting::event_category{$str}{'name'}) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
my $this = shift;
return ($this->{'disabled'}) ? 0 : 1;
}

sub format_for_mail {
my($this,$str,$path,$c,$n) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return '' if !defined $str || !$str || !$setting::event_category{$str}{'name'};
return '[' . $this->{'name'} . "]\x0A" . $setting::event_category{$str}{'name'} . "\x0A\x0A";
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text_enabled ($) {
my $this = shift;
return ($this->{'disabled'}) ? 0 : 1;
}

sub format_for_text {
my($this,$str,$path,$c,$n) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return '' if !defined $str || !$str || !$setting::event_category{$str}{'name'};
return $setting::event_category{$str}{'name'} . "\x0A\x0A";
}

sub format_for_detail_enabled ($) {
my $this = shift;
return ($this->{'disabled'}) ? 0 : 1;
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return ($this->{'disabled'}) ? 1 : 0;
}

sub confirmation ($$) {
my($this,$str) = @_;
return '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled) = @_;

#̾
my $name = 'data:' . $this->{'id'};
$this->print_field_info_form($name,$this->{'disabled'},(($this->{'disabled'}) ? 'Բġ٥ȥƥ꡼꤬ߤĤޤ' : ''));

$this->print_font_setting_form($name);
$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
return $this->is_valid_font_setting;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
my $this = shift;
return '' if defined $this->{'disabled'} && $this->{'disabled'};
$this->scalar_to_array(\$main::search{$this->{'id'}}{'str'});
my $form = '<tr><td class="field-name"><label for="search:' . $this->{'id'} . ':str">' . $this->{'name'} . '</label></td><td class="field">';
$form .= $this->event_category_menu('search:' . $this->{'id'} . ':str',1,$main::search{$this->{'id'}}{'str'});
$form .= '</td></tr>';
return $form;
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('xcal_category','EventCategory','٥ȥƥ꡼');
}

1;
