package InfoField;
require CMONOS::CGI_Lib::Tools::FieldEditor;
@ISA = qw(FieldEditor);
use strict;
######################################################################
# ڡեԽ⥸塼
# InfoField.pm ver1.0.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-03-24
######################################################################
# եɤ߹
sub set_field ($) {
my $this = shift;
$setting::field_db_name = 'infofield' if !defined $setting::field_db_name;
$setting::field = 2 if !defined $setting::field || $setting::field != 2;
$setting::field_tag_name = 'info' if !defined $setting::field_tag_name;
$master::home = $default::home;
if ($default::subdivided && defined $main::c && $main::c ne '') {
	$default::home = '.' if !defined $default::home || $default::home eq '';
	$default::home .= '/' . $main::c;
}
}

######################################################################
#
sub print_sub_setting_items ($) {
my $this = shift;
return if !%field::obj;

print '<fieldset><legend>üե</legend><table class="field-table"><tbody>';

print '<tr><td class="field-name"><label for="data:for_title">ȥե</label></td>';
print '<td class="field"><select name="data:for_title" id="data:for_title" title="ǥåǡΥȥȤɽեɤꤷޤ">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	my $id = $field::ORDER{$_};
	next unless ref $field::obj{$id} && $field::obj{$id}->{'class'} =~ /^text/;
	print '<option value="' . $id . '"' . ((defined $field::for{'title'} && $field::for{'title'} eq $id) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$id}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_description">ե</label></td>';
print '<td class="field"><select name="data:for_description" id="data:for_description" title="ǥåǡȤɽեɤꤷޤ">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	my $id = $field::ORDER{$_};
	next unless ref $field::obj{$id} && $field::obj{$id}->{'class'} =~ /^text/;
	print '<option value="' . $id . '"' . ((defined $field::for{'description'} && $field::for{'description'} eq $id) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$id}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_icon">ե</label></td>';
print '<td class="field"><select name="data:for_icon" id="data:for_icon" title="ǥåǡΥȤɽեɤꤷޤ">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	my $id = $field::ORDER{$_};
	next unless ref $field::obj{$id} && ($field::obj{$id}->{'class'} =~ /^file/i || $field::obj{$id}->{'class'} =~ /_image/i);
	print '<option value="' . $id . '"' . ((defined $field::for{'icon'} && $field::for{'icon'} eq $id) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$id}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_author">ɮԥե</label></td>';
print '<td class="field"><select name="data:for_author" id="data:for_author" title="ǥåǡɮԤȤɽեɤꤷޤ">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	my $id = $field::ORDER{$_};
	next unless ref $field::obj{$id} && ($field::obj{$id}->{'class'} =~ /^text/ || $field::obj{$id}->{'class'} eq 'select_menu' || $field::obj{$id}->{'class'} eq 'select_box');
	print '<option value="' . $id . '"' . ((defined $field::for{'author'} && $field::for{'author'} eq $id) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$id}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_media">ǥե</label></td>';
print '<td class="field"><select name="data:for_media" id="data:for_media" title="RSSۿ˵źեǥȤɽեɤꤷޤ">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && ($field::obj{$field::ORDER{$_}}->{'class'} eq 'file' || $field::obj{$field::ORDER{$_}}->{'class'} eq 'file_banner' || $field::obj{$field::ORDER{$_}}->{'class'} eq 'file_media' || $field::obj{$field::ORDER{$_}}->{'class'} eq 'file_shipainter');
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'media'} && $field::for{'media'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_coordinates">ɸե</label></td>';
print '<td class="field"><select name="data:for_coordinates" id="data:for_coordinates" title="Googleޥåפ˥ǥåɽݺɸȤեɤꤷޤ">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->{'class'} eq 'webapi_gmap';
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'coordinates'} && $field::for{'coordinates'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '</tbody></table>';
print '</fieldset>';

print '<fieldset class="submit"><input type="submit" value="¸" class="save" /></fieldset>';
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
if (!$default::subdivided || ($default::subdivided && defined $main::c && $main::c ne '')) {

	#饹Ͽ
	Common::class_register('H101','InfoField');

	#ġϿ
	$setting::jump_menu{'H101'} = 'ڡե' if !defined $setting::jump_menu{'H101'};
}
}

1;
