package CGIRegister;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use strict;
######################################################################
# CGIϿ⥸塼
# CGIRegister.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
sub site_scan ($) {
#no warnings qw(numeric);
my $this = shift;
my($navi_db,$navi_setting,@navi_disabled,%db,%old_order,%data,@folder,$dir,%del,@delete,$tool_navi_uri,$javascript,$t);
($default::navi_db = $default::preference_dir) =~ s/setup$/navimaker/ if !$default::navi_db;
$navi_db = $default::navi_db . '/navi_db';
@navi_disabled = ();
$navi_setting = $this->read_file('../navimaker/default.pl');
if ($navi_setting =~ /\@disabled\s*=\s*\((.*?)\)/s) {
	my $setting = $1;
	$setting =~ s/'//gs;
	$setting =~ s/\s+//gs;
	@navi_disabled = split(/,/,$setting);
}
undef $navi_setting;
@navi_disabled = (
	'GateKeeper',
	'NaviMaker',
	'Register',
	'SetupAssistant',
	'MaintenanceStation',
	'ZipCodeSearch'
) if !@navi_disabled;

use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
tie(%db, $env::dbm_file, $navi_db, O_RDONLY, $env::dbm_mode);
if (ref tied %db) {
	my($key,$value);
	while (($key,$value) = each %db) {
		next unless $key =~ /^ORDER_(.*)$/;
		$old_order{$value} = $1;
	}
}
untie %db;

local(*DIR);
%del = %old_order;
opendir(DIR, '../');
@folder = grep($_ !~ /^\./ && -d '../' . $_,readdir(DIR));
closedir(DIR);
foreach $dir (@folder) {
	my($setting,$name,$lib,$preference_dir,$mode,$subdivided,$title,$uri,$id,%general);
	local(*SETTING);
	next if !-f '../' . $dir . '/start.cgi' || !open(SETTING,'../' . $dir . '/default.pl');
	$setting = join('',<SETTING>);
	close(SETTING);
	if ($setting =~ /^[\x20\x09]*\$lib[\x20\x09]*=[\x20\x09]*["']?([^"']+?)["']?;/m) {
		$lib = $1;
	} else {
		next;
	}
	next if grep($_ eq $lib,@navi_disabled);
	if ($setting =~ /^[\x20\x09]*\$preference_dir[\x20\x09]*=(.*?);/m) {
		$preference_dir = eval($1);
	} else {
		next;
	}
	if ($setting =~ /^[\x20\x09]*\$name[\x20\x09]*=[\x20\x09]*["']?([^"']+?)["']?;/m) {
		$name = $1;
	}
	if ($lib eq 'HomePageMaker') {
		$mode = 'date' if $setting =~ /^[\x20\x09]*\$date[\x20\x09]*=[\x20\x09]*["']?([^"']+?)["']?;/m && $1;
		$uri = eval($1) if $setting =~ /^[\x20\x09]*\$home[\x20\x09]*=(.*?);/m;
	} elsif ($lib eq 'HomePageMakerLite') {
		$uri = eval($1) if $setting =~ /^[\x20\x09]*\$home[\x20\x09]*=(.*?);/m;
	} else {
		$uri = '../' . $dir . '/start.cgi';
	}
	if ($setting =~ /^[\x20\x09]*\$subdivided[\x20\x09]*=[\x20\x09]*["']?([^"']+?)["']?;/m) {
		$subdivided = $1;
	}
	if ($setting =~ /^[\x20\x09]*\$id[\x20\x09]*=[\x20\x09]*["'](\w+)["'];/m) {
		$id = $1;
	} else {
		$id = $dir;
	}
	tie(%general, $env::dbm_file, $preference_dir . '/general', O_RDONLY, $env::dbm_mode);
	my($html_flag);
	if (ref tied %general) {
		$title = ($general{'cginame'}) ? $general{'cginame'} : ($name) ? $name : $dir;
		$html_flag = $general{'html'} if !$subdivided && $lib eq 'Baobab';
	}
	untie %general;
	if ($html_flag) {
		my(%security);
		tie(%security, $env::dbm_file, $preference_dir . '/security', O_RDONLY, $env::dbm_mode);
		if (ref tied %security) {
			$html_flag = 0 if $security{'browse_passwordCheck'} ne 'nocheck' || $security{'secret_passwordCheck'} ne 'nocheck' || $security{'closed_passwordCheck'} ne 'nocheck';
		}
		untie %security;
		if ($html_flag) {
			$mode = 'html';
			$uri = '../' . $dir . '/files/index.html';
		}
	}
	$title = $name if !defined $title || $title eq '';
	$data{$dir . '_title'} = $title;
	$data{$dir . '_id'} = $id;
	$data{$dir . '_uri'} = $uri;
	$data{$dir . '_lib'} = $lib;
	$data{$dir . '_mode'} = $mode;
	$data{$dir . '_subdivided'} = $subdivided;
	delete $del{$dir};
	$old_order{$dir} = 1 if !defined $old_order{$dir};
}

#ǡ
if (%del) {
	push(@delete,grep($_ !~ /^URI\d+$/,keys %del));
	undef %del;
}

#ܤνȽؤαƶ
foreach (@delete) {
	delete $old_order{$_};
}

#Ƚ
my $no = 0;
foreach (
	sort {
		$old_order{$a} <=> $old_order{$b} || 
		$a <=> $b || 
		$a cmp $b
	} keys %old_order
) {
	$no++;
	$data{'ORDER_' . $no} = $_;
	$data{$_ . '_ORDER'} = $no;
}
undef %old_order;
$this->write_db($navi_db,\%data,'ORDER',\@delete);

$t = time;
$javascript = <<JAVA;
cmonos.tool.refreshNavi = function() {
	if (parent.tool_navi) {
		parent.tool_navi.location.href = parent.tool_navi.location.href + '?mode=tool&amp;stamp=$t';
	}
}
JAVA
$this->set_onload('cmonos.tool.refreshNavi()');
$this->set_javascript($javascript);
}


1;