package CSSUpdater;
require CMONOS::SetupAssistant::Tools::JavaScriptUpdater;
@ISA = qw(JavaScriptUpdater);
use strict;
######################################################################
# CSSåץǡ⥸塼
# CSSUpdater.pm ver1.0.3
# Copyright (C) 2008-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-11-29
######################################################################
# ¹
sub run ($) {
my $this = shift;
$this->get_setup_env;
my $updater_enabled = (-d $env::template_dir . '/site/default/htdocs/lib/css') ? 1 : 0;
if (!@main::target && defined $main::target && $main::target ne '') {
	push(@main::target,$main::target);
	undef $main::target;
}

#åץǡ
$this->update if $updater_enabled && @main::target;

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>CSS åץǡ</h1>';
print '<p>"' . $this->get_path_for_log($env::template_dir) . '/site/default/htdocs/lib/css" ʲ CSSե Τ򤵤줿 CSSե ƤΥȥƥץ졼ȤƤΥ֥ǥ쥯ȥ css ե<strong></strong>ԡޤ</p>';
if (!$updater_enabled) {
	print '<fieldset>åץǡȤɬפʥƥץ졼ȤߤĤޤ</fieldset>';
} else {
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'method'	=>	'post',
		'onsubmit'	=>	'return confirm(\' CSS ǸŤ CSS 񤭤ޤ¹Ը塢Ť CSS Ǥޤѹޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
		'required'	=>	\@setting::form
	);
	if ($this->{'update_log'}) {
		print '<fieldset><legend>CSS åץǡȥ</legend><ol>';
		print $this->{'update_log'};
		print '</ol></fieldset>';
	}
	if (opendir(CSSDIR,$env::template_dir . '/site/default/htdocs/lib/css')) {
		my @menu = grep(-f $env::template_dir . '/site/default/htdocs/lib/css/' . $_ && $_ =~ /^[\w\-]+\.css$/ && $_ !~ /(^|\-)image\.css$/ && $_ ne 'site-navi.css',readdir(CSSDIR));
		print '<fieldset><legend>åץǡо CSS ե</legend><ol class="checkbox">';
		foreach my $name (sort @menu) {
			print '<li><label><input type="checkbox" name="target" value="' . $name . '"' . (($name eq 'common.css' || $name eq 'tools.css') ? ' checked="checked"' : '') . ' /> ' . $name . '</label></li>';
		}
		print '<li><label><input type="checkbox" name="target" value="images" /> CSS Ϣ</label></li>';
		print '</ol></fieldset>';
	}
	print '<fieldset class="submit"><input type="submit" value="CSS 򥢥åץǡȤ" /></fieldset></form>';
}

#ڡեå
$this->print_page_footer('tools');
}

sub update ($) {
my $this = shift;
my($dir);
local(*TEMP);
foreach $dir ('',$this->sub_directory_scan($default::cgi_data_root)) {
	$this->css_update($dir);
}
if (opendir(TEMP,$env::template_dir . '/site')) {
	my @template = grep($_ ne 'default' && $_ !~ /\./ && -d $env::template_dir . '/site/' . $_,readdir(TEMP));
	closedir(TEMP);
	foreach $dir (@template) {
		$this->css_update($dir,1);
	}
}
return $this;
}

sub css_update ($$$) {
my($this,$home_dir,$is_template) = @_;
my $new_version = $env::template_dir . '/site/default/htdocs/lib/css';
my $css_dir = ($is_template) ? $env::template_dir . '/site/' . $home_dir . '/htdocs/lib/css' : (!$home_dir) ? $env::css : '../..' . $home_dir . '/lib/css';
return 0 if !-d $css_dir || !-d $new_version || !-f $css_dir . '/common.css';
my $css_path = ($is_template) ? $this->get_path_for_log($css_dir) : $this->path_change($css_dir,$ENV{'SCRIPT_NAME'},'abs');
foreach my $f (@main::target) {
	if ($f =~ /^[\w\-]+\.css$/ && ($main::updating || ($f !~ /(^|\-)image\.css$/ && $f ne 'site-navi.css'))) {
		$this->file_copy($new_version . '/' . $f,$css_dir . '/' . $f);
		$this->{'update_log'} .= '<li>' . $css_path . '/' . $f . '</li>';
	}
}
if (grep($_ eq 'images',@main::target)) {
	my $new_image_dir = $env::template_dir . '/site/default/htdocs/lib/image';
	my $css_image_dir = ($is_template) ? $env::template_dir . '/site/' . $home_dir . '/htdocs/lib/image' : (!$home_dir && $env::css =~ /^(.*\/)[\/]+$/) ? $1 . 'image' : '../..' . $home_dir . '/lib/image';
	$this->directory_copy($new_image_dir,$css_image_dir);
	$this->{'update_log'} .= '<li>' . (($is_template) ? $this->get_path_for_log($css_image_dir) : $this->path_change($css_image_dir,$ENV{'SCRIPT_NAME'},'abs')) . '</li>';
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('s304','CSSUpdater');

	#˥塼Ͽ
	$setting::jump_menu{'s304'} = 'CSS åץǡ';

}



1;
