package MasterInfo;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use strict;
use Fcntl qw(:DEFAULT :flock);
######################################################################
# ѹ⥸塼
# MasterInfo.pm ver1.0.13
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-03-15
######################################################################
# ¹
sub run ($;$) {
my($this,$install) = @_;
my($valid_flag,$is_document_root,$error_flag,$doctype,$master_password_encrypted,$env_doctype,@title_and_description);
$is_document_root = 1 if $install || !$cgi::input->home_directory(1);
$this->get_setup_env if !$install;

#ϥå
if (defined $main::password && $main::password ne '') {
	if ($main::password =~ /^\w{6,}$/) {
		if ($main::password eq $main::password2) {
			if ($env::session_enabled) {
				$master_password_encrypted = 1;
				$main::password = $cgi::Register->encrypt($main::password);
			}
			$valid_flag = 1;
		} else {
			push(@{$this->{'dialog'}},'ǧΤΥѥɤפޤ');
			$error_flag = 1;
		}
	} else {
		push(@{$this->{'dialog'}},'ѥɤ6ʸʾȾѱѿˤƤ');
		$error_flag = 1;
	}
} elsif ($main::a && $install) {
	push(@{$this->{'dialog'}},'ޥѥɤɬꤷƤ');
	$error_flag = 1;
}
if (defined $main::emailaddr && $main::emailaddr ne '') {
	$main::emailaddr = $this->z_to_h($main::emailaddr);
	if (!$install && $main::emailaddr eq $env::master_email) {
		undef $main::emailaddr;
	} elsif ($this->is_invalid_email_address($main::emailaddr)) {
		push(@{$this->{'dialog'}},'ͥ᡼륢ɥ쥹ǧƤ');
		$error_flag = 1;
	} else {
		$valid_flag = 1;
	}
} elsif ($main::a && $install) {
	push(@{$this->{'dialog'}},'ͥ᡼륢ɥ쥹ɬꤷƤ');
	$error_flag = 1;
}
if (defined $main::title && $main::title ne '') {
	if (!$install && $main::title eq $env::title) {
		undef $main::title;
	} else {
		$this->env_escape(\$main::title);
		$valid_flag = 1;
	}
} elsif ($main::a && $install) {
	push(@{$this->{'dialog'}},'ȥȥɬꤷƤ');
	$error_flag = 1;
}
if (defined $main::copyright && $main::copyright ne $env::copyright) {
	$this->env_escape(\$main::copyright);
	$valid_flag = 1;
} else {
	undef $main::copyright;
}
if (defined $main::description && $main::description ne $env::description) {
	$this->env_escape(\$main::description);
	$valid_flag = 1;
} else {
	undef $main::description;
}
if (defined $main::rss_marker && $main::rss_marker ne '') {
	$main::rss_marker = '0' if $main::rss_marker ne '1';
	if ($main::rss_marker eq $env::rss_marker) {
		undef $main::rss_marker;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::doctype && $main::doctype =~ /^(html5|(?:xhtml1|html401)(?:strict|transitional|loose))$/) {
	if ($main::doctype eq 'html5') {
		$doctype = '<!DOCTYPE html>';
	} elsif ($main::doctype eq 'xhtml1strict') {
		$doctype = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">';
	} elsif ($main::doctype eq 'xhtml1transitional') {
		$doctype = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	} elsif ($main::doctype eq 'html401strict') {
		$doctype = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">';
	} elsif ($main::doctype eq 'html401loose') {
		$doctype = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
	} else {
		$doctype = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">';
	}
	if ($doctype eq $env::doctype) {
		undef $doctype;
		undef $main::doctype;
	} else {
		$valid_flag = 1;
	}
} else {
	undef $main::doctype;
}
if (defined $main::inline_navi && $main::inline_navi ne '') {
	if ($main::inline_navi eq $env::inline_navi) {
		undef $main::inline_navi;
	} else {
		$main::inline_navi = '0' if $main::inline_navi ne '1';
		$valid_flag = 1;
	}
}
if (defined $main::window_title_format && $main::window_title_format ne '') {
	$main::window_title_format = $this->escape_without_html_entity($main::window_title_format);
	$main::window_title_format =~ s/'//g;
	if ($main::window_title_format eq $env::window_title_format) {
		undef $main::window_title_format;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::session_enabled && $main::session_enabled ne '') {
	$main::session_enabled = '0' if $main::session_enabled ne '1' && $main::session_enabled ne '2';
	if ($main::session_enabled eq $env::session_enabled) {
		undef $main::session_enabled;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::session_security && $main::session_security ne '') {
	$main::session_security = 'ip,agent' if $main::session_security ne 'ip' && $main::session_security ne 'agent' && $main::session_security ne 'none';
	if ($main::session_security eq $env::session_security) {
		undef $main::session_security;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::openid_enabled && $main::openid_enabled ne '') {
	$main::openid_enabled = '0' if $main::openid_enabled ne '1';
	if ($main::openid_enabled eq $env::openid_enabled) {
		undef $main::openid_enabled;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::password_threshold) {
	if ($main::password_threshold ne '' && $this->is_nan($main::password_threshold)) {
		push(@{$this->{'dialog'}},'ƤѥǧڼԲǧƤ');
		$error_flag = 1;
	} elsif ($main::password_threshold eq $env::password_threshold) {
		undef $main::password_threshold;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::password_latency) {
	if ($main::password_latency ne '' && $this->is_nan($main::password_latency)) {
		push(@{$this->{'dialog'}},'ѥɥåԤ֤ǧƤǤϤޤ');
		$error_flag = 1;
	} elsif ($main::password_latency eq $env::password_latency) {
		undef $main::password_latency;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::user_id && $main::user_id ne '') {
	$main::user_id = 'individual' if $main::user_id ne 'shared';
	if (!$env::home_dir_id || $is_document_root || ($env::register_cgi && $env::register_cgi eq '../pswd/start.cgi' && $main::user_id eq 'individual') || ($env::register_cgi && $env::register_cgi ne '../pswd/start.cgi' && $main::user_id eq 'shared')) {
		undef $main::user_id;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::rss_maxitem && $main::rss_maxitem ne '') {
	if ($this->is_nan($main::rss_maxitem)) {
		push(@{$this->{'dialog'}},'RSS 絭ǧƤǤϤޤ');
		$error_flag = 1;
	} elsif ($main::rss_maxitem eq $env::rss_maxitem) {
		undef $main::rss_maxitem;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::rss_description_maxlength && $main::rss_description_maxlength ne '') {
	if ($this->is_nan($main::rss_description_maxlength)) {
		push(@{$this->{'dialog'}},'RSS ܺǧƤǤϤޤ');
		$error_flag = 1;
	} elsif ($main::rss_description_maxlength eq $env::rss_description_maxlength) {
		undef $main::rss_description_maxlength;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::google_maps_api_key && $main::google_maps_api_key ne $env::google_maps_api_key) {
	$main::google_maps_api_key =~ s/[^\w\-]//g;
	$valid_flag = 1;
} else {
	undef $main::google_maps_api_key;
}
if (defined $main::google_analytics_embedded && $main::google_analytics_embedded ne '') {
	$main::google_analytics_embedded = '0' if $main::google_analytics_embedded ne '1';
	if ($main::google_analytics_embedded eq $env::google_analytics_embedded) {
		undef $main::google_analytics_embedded;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::google_analytics_uacct && $main::google_analytics_uacct ne $env::google_analytics_uacct) {
	$main::google_analytics_uacct =~ s/[^\w\-]//g;
	$valid_flag = 1;
} else {
	undef $main::google_analytics_uacct;
}
if (defined $main::amazon_access_key && $main::amazon_access_key ne '') {
	$main::amazon_access_key =~ s/['\s]+//g;
	if ($main::amazon_access_key eq $env::amazon_access_key) {
		undef $main::amazon_access_key;
	} else {
		$valid_flag = 1;
	}
} elsif ($env::amazon_access_key && $main::delete_amazon_access_key) {
	$main::amazon_access_key = '';
} else {
	undef $main::amazon_access_key;
}
if (defined $main::amazon_secret_access_key && $main::amazon_secret_access_key ne '') {
	$main::amazon_secret_access_key =~ s/['\s]+//g;
	if ($main::amazon_secret_access_key eq $env::amazon_secret_access_key) {
		undef $main::amazon_secret_access_key;
	} else {
		$valid_flag = 1;
	}
} elsif ($env::amazon_secret_access_key && $main::delete_amazon_secret_access_key) {
	$main::amazon_secret_access_key = '';
} else {
	undef $main::amazon_secret_access_key;
}
if (defined $main::amazon_associates_id && $main::amazon_associates_id ne '') {
	$main::amazon_associates_id =~ s/['\s]+//g;
	if ($main::amazon_associates_id eq $env::amazon_associates_id) {
		undef $main::amazon_associates_id;
	} else {
		$valid_flag = 1;
	}
}
if (defined $main::cookie_lifetime && $main::cookie_lifetime ne '') {
	if ($this->is_nan($main::cookie_lifetime) || $main::cookie_lifetime < 3) {
		push(@{$this->{'dialog'}},'Cookie ¸ǧƤ3ʾοˤƤ');
		$error_flag = 1;
	} elsif ($main::cookie_lifetime == $env::cookie_lifetime) {
		undef $main::cookie_lifetime;
	} else {
		$valid_flag = 1;
	}
}
if ($main::a) {
	if (!$main::master_email_required && $env::master_email_required) {
		$main::master_email_required = 0;
		$valid_flag = 1;
	} elsif ($main::master_email_required && !$env::master_email_required) {
		$main::master_email_required = 1;
		$valid_flag = 1;
	} else {
		undef $main::master_email_required;
	}
	if (!$main::noindex && $env::noindex) {
		$main::noindex = 0;
		$valid_flag = 1;
	} elsif ($main::noindex && !$env::noindex) {
		$main::noindex = 1;
		$valid_flag = 1;
	} else {
		undef $main::noindex;
	}
}

#env.pl񤭴
if ($main::a && $valid_flag && !$error_flag) {
	local(*FILE);
	my($data,$env_path,$top_cgi_path,$cookie_path,$top_dir_fixed);
	$env_path = $default::cgi_data . '/lib/env.pl';
	if ($install && $default::http_home_dir) {
		$env::top_dir = $default::http_home_dir;
		$default::http_home_dir = '';
		$top_dir_fixed = 1;
	}
	$data = $this->read_file($env_path);
	$data =~ s/^[\x20\x09]*\$master_password[\x20\x09]*=[^;]*;/\$master_password = '$main::password';/gm if defined $main::password && $main::password ne '';
	$data =~ s/^[\x20\x09]*\$master_password_encrypted[\x20\x09]*=[^;]*;/\$master_password_encrypted = 1;/gm if defined $main::password && $main::password ne '' && $master_password_encrypted;
	$data =~ s/^[\x20\x09]*\$master_email_required[\x20\x09]*=[^;]*;/\$master_email_required = $main::master_email_required;/gm if defined $main::master_email_required && $main::master_email_required ne '';
	$data =~ s/^[\x20\x09]*\$master_email[\x20\x09]*=[^;]*;/\$master_email = '$main::emailaddr';/gm if defined $main::emailaddr && $main::emailaddr ne '';
	$data =~ s/^[\x20\x09]*\$title[\x20\x09]*=.*?';/\$title = '$main::title';/gm if defined $main::title && $main::title ne '';
	$data =~ s/^[\x20\x09]*\$copyright[\x20\x09]*=.*?';/\$copyright = '$main::copyright';/gm if defined $main::copyright;
	$data =~ s/^[\x20\x09]*\$description[\x20\x09]*=.*?';/\$description = '$main::description';/gm if defined $main::description;
	$data =~ s/^[\x20\x09]*\$rss_marker[\x20\x09]*=[^;]*;/\$rss_marker = $main::rss_marker;/gm if defined $main::rss_marker && $main::rss_marker ne '';
	$data =~ s/^[\x20\x09]*\$doctype[\x20\x09]*=[^;]*;/\$doctype = '$doctype';/gm if defined $doctype && $doctype ne '';
	$data =~ s/^[\x20\x09]*\$inline_navi[\x20\x09]*=[^;]*;/\$inline_navi = $main::inline_navi;/gm if defined $main::inline_navi && $main::inline_navi ne '';
	$data =~ s/^[\x20\x09]*\$window_title_format[\x20\x09]*=.*?';/\$window_title_format = '$main::window_title_format';/gm if defined $main::window_title_format && $main::window_title_format ne '';
	$data =~ s/^[\x20\x09]*\$session_enabled[\x20\x09]*=[^;]*;/\$session_enabled = $main::session_enabled;/gm if defined $main::session_enabled && $main::session_enabled ne '';
	$data =~ s/^[\x20\x09]*\$session_security[\x20\x09]*=[^;]*;/\$session_security = '$main::session_security';/gm if defined $main::session_security && $main::session_security ne '';
	$data =~ s/^[\x20\x09]*\$openid_enabled[\x20\x09]*=[^;]*;/\$openid_enabled = $main::openid_enabled;/gm if defined $main::openid_enabled && $main::openid_enabled ne '';
	if (defined $main::password_threshold) {
		if ($main::password_threshold ne '') {
			$data =~ s/^[\x20\x09]*\$password_threshold[\x20\x09]*=[^;]*;/\$password_threshold = $main::password_threshold;/gm;
		} else {
			$data =~ s/^[\x20\x09]*\$password_threshold[\x20\x09]*=[^;]*;/\$password_threshold = '';/gm;
		}
	}
	if (defined $main::password_latency) {
		if ($main::password_latency ne '') {
			$data =~ s/^[\x20\x09]*\$password_latency[\x20\x09]*=[^;]*;/\$password_latency = $main::password_latency;/gm;
		} else {
			$data =~ s/^[\x20\x09]*\$password_latency[\x20\x09]*=[^;]*;/\$password_latency = '';/gm;
		}
	}
	$data =~ s/^[\x20\x09]*\$rss_maxitem[\x20\x09]*=[^;]*;/\$rss_maxitem = $main::rss_maxitem;/gm if defined $main::rss_maxitem && $main::rss_maxitem ne '';
	$data =~ s/^[\x20\x09]*\$rss_description_maxlength[\x20\x09]*=[^;]*;/\$rss_description_maxlength = $main::rss_description_maxlength;/gm if defined $main::rss_description_maxlength && $main::rss_description_maxlength ne '';
	$data =~ s/^[\x20\x09]*\$google_maps_api_key[\x20\x09]*=[^;]*;/\$google_maps_api_key = '$main::google_maps_api_key';/gm if defined $main::google_maps_api_key;
	$data =~ s/^[\x20\x09]*\$google_analytics_uacct[\x20\x09]*=[^;]*;/\$google_analytics_uacct = '$main::google_analytics_uacct';/gm if defined $main::google_analytics_uacct;
	$data =~ s/^[\x20\x09]*\$google_analytics_embedded[\x20\x09]*=[^;]*;/\$google_analytics_embedded = $main::google_analytics_embedded;/gm if defined $main::google_analytics_embedded && $main::google_analytics_embedded ne '';
	$data =~ s/^[\x20\x09]*\$amazon_access_key[\x20\x09]*=[^;]*;/\$amazon_access_key = '$main::amazon_access_key';/gm if defined $main::amazon_access_key && $main::amazon_access_key ne '';
	$data =~ s/^[\x20\x09]*\$amazon_secret_access_key[\x20\x09]*=[^;]*;/\$amazon_secret_access_key = '$main::amazon_secret_access_key';/gm if defined $main::amazon_secret_access_key && $main::amazon_secret_access_key ne '';
	$data =~ s/^[\x20\x09]*\$amazon_associates_id[\x20\x09]*=[^;]*;/\$amazon_associates_id = '$main::amazon_associates_id';/gm if defined $main::amazon_associates_id && $main::amazon_associates_id ne '';
	$data =~ s/^[\x20\x09]*\$cookie_lifetime[\x20\x09]*=[^;]*;/\$cookie_lifetime = $main::cookie_lifetime;/gm if defined $main::cookie_lifetime && $main::cookie_lifetime ne '';
	$data =~ s/^[\x20\x09]*\$noindex[\x20\x09]*=[^;]*;/\$noindex = $main::noindex;/gm if defined $main::noindex && $main::noindex ne '';
	if ($main::user_id) {
		if ($main::user_id eq 'shared') {
			$cookie_path = $this->user_directory(1) . (($env::top_dir) ? $env::top_dir : '');
			$cookie_path = '/' if !$cookie_path;
			$top_cgi_path = $env::image_lib;
			$top_cgi_path =~ s/\/[^\/]+$//;
			$data =~ s!^[\x20\x09]*\$session_store[\x20\x09]*=[^;]*;!\$session_store = '$default::cgi_data_root/data/session_store';!gm;
			$data =~ s!^[\x20\x09]*\$register_cgi[\x20\x09]*=[^;]*;!\$register_cgi = '$top_cgi_path/pswd/start.cgi';!gm;
			$data =~ s!^[\x20\x09]*\$register_db[\x20\x09]*=[^;]*;!\$register_db = '$default::cgi_data_root/preferences/register';!gm;
			$data =~ s/^[\x20\x09]*\$cookie_path[\x20\x09]*=[^;]*;/\$cookie_path = '$cookie_path';/gm;
		} else {
			$cookie_path = $this->user_directory(1) . (($env::top_dir) ? $env::top_dir : '') . (($default::http_home_dir) ? $default::http_home_dir : '');
			$cookie_path = '/' if !$cookie_path;
			$data =~ s!^[\x20\x09]*\$session_store[\x20\x09]*=[^;]*;!\$session_store = '$default::cgi_data/data/session_store';!gm;
			$data =~ s!^[\x20\x09]*\$register_cgi[\x20\x09]*=[^;]*;!\$register_cgi = '../pswd/start.cgi';!gm;
			$data =~ s!^[\x20\x09]*\$register_db[\x20\x09]*=[^;]*;!\$register_db = '$default::cgi_data/preferences/register';!gm;
			$data =~ s/^[\x20\x09]*\$cookie_path[\x20\x09]*=[^;]*;/\$cookie_path = '$cookie_path';/gm;
		}
	}
	$data =~ s/^[\x20\x09]*#?[\x20\x09]*\$top_dir[\x20\x09]*=[^;]*;/\$top_dir = '$env::top_dir';/gm if $top_dir_fixed;
	if (open (FILE, ">>$env_path")) {
		binmode FILE;
		flock(FILE, LOCK_EX);
		truncate(FILE, 0);
		seek(FILE, 0, 0);
		print FILE $data;
		close(FILE);
		push(@{$this->{'dialog'}},'򹹿ޤ') if !$install;
		$this->rename_navi_file($main::inline_navi) if defined $main::inline_navi && $main::inline_navi ne '';
		if ($main::user_id) {
			if ($main::user_id eq 'shared') {
				$env::session_store = "$default::cgi_data_root/data/session_store";
				$env::register_cgi = "$top_cgi_path/pswd/start.cgi";
				$env::register_db = "$default::cgi_data_root/preferences/register";
				$env::cookie_path = $cookie_path;
			} else {
				$env::session_store = "$default::cgi_data/data/session_store";
				$env::register_cgi = '../pswd/start.cgi';
				$env::register_db = "$default::cgi_data/preferences/register";
				$env::cookie_path = $cookie_path;
			}
			if ($env::session_enabled && $this->use_session(1)) {
				$session::id = $this->read_cookie_direct($this->login_cookie_name(1));
				$session::is_changed = 1;
			} else {
				$this->use_register(1);
				$this->login_cookie_name(1);
				$main::set_cookie_id = 1;
			}
		}
		if ((defined $main::password && $main::password ne '') || (defined $main::emailaddr && $main::emailaddr ne '')) {
			$env::master_password = $main::pswd = $main::password if defined $main::password && $main::password ne '';
			$env::master_password_encrypted = 1 if defined $main::password && $main::password ne '' && $master_password_encrypted;
			$env::master_email = $main::email = $main::emailaddr if defined $main::emailaddr && $main::emailaddr ne '';
			if ($env::session_enabled && $this->use_session(1)) {
				$session::id = $cgi::Session->set_user_info($main::email,{'encrypted_password' => $main::pswd},$session::id);
				$session::is_changed = 1;
			} else {
				$this->use_register(1);
				$main::set_cookie_id = 1;
			}
		}
		$env::master_email_required = $main::master_email_required if defined $main::master_email_required && $main::master_email_required ne '';
		@title_and_description = ($env::title,$env::description,$env::window_title_format,$env::noindex,$main::title,$main::description,$main::window_title_format,$main::noindex) if !$install && (defined $main::title || defined $main::description || defined $main::window_title_format || defined $main::noindex);
		$env::title = $main::title if defined $main::title && $main::title ne '';
		$env::copyright = $main::copyright if defined $main::copyright;
		$env::description = $main::description if defined $main::description;
		$env::rss_marker = $main::rss_marker if defined $main::rss_marker && $main::rss_marker ne '';
		$env::doctype = $doctype if defined $doctype && $doctype ne '';
		$env::inline_navi = $main::inline_navi if defined $main::inline_navi && $main::inline_navi ne '';
		$env::window_title_format = $main::window_title_format if defined $main::window_title_format && $main::window_title_format ne '';
		$env::session_enabled = $main::session_enabled if defined $main::session_enabled && $main::session_enabled ne '';
		$env::session_security = $main::session_security if defined $main::session_security && $main::session_security ne '';
		$env::openid_enabled = $main::openid_enabled if defined $main::openid_enabled && $main::openid_enabled ne '';
		$env::password_threshold = $main::password_threshold if defined $main::password_threshold;
		$env::password_latency = $main::password_latency if defined $main::password_latency;
		$env::rss_maxitem = $main::rss_maxitem if defined $main::rss_maxitem && $main::rss_maxitem ne '';
		$env::rss_description_maxlength = $main::rss_description_maxlength if defined $main::rss_description_maxlength && $main::rss_description_maxlength ne '';
		$env::google_maps_api_key = $main::google_maps_api_key if defined $main::google_maps_api_key;
		$env::google_analytics_uacct = $main::google_analytics_uacct if defined $main::google_analytics_uacct;
		$env::google_analytics_embedded = $main::google_analytics_embedded if defined $main::google_analytics_embedded && $main::google_analytics_embedded ne '';
		$env::amazon_access_key = $main::amazon_access_key if defined $main::amazon_access_key && $main::amazon_access_key ne '';
		$env::amazon_secret_access_key = $main::amazon_secret_access_key if defined $main::amazon_secret_access_key && $main::amazon_secret_access_key ne '';
		$env::amazon_associates_id = $main::amazon_associates_id if defined $main::amazon_associates_id && $main::amazon_associates_id ne '';
		$env::cookie_lifetime = $main::cookie_lifetime if defined $main::cookie_lifetime && $main::cookie_lifetime ne '';
		$env::noindex = $main::noindex if defined $main::noindex && $main::noindex ne '';
		undef $main::emailaddr;
		undef $main::password;
		undef $main::master_email_required;
		undef $main::title;
		undef $main::description;
		undef $main::copyright;
		undef $main::rss_marker;
		undef $main::doctype;
		undef $main::inline_navi;
		undef $main::window_title_format;
		undef $main::session_enabled;
		undef $main::session_security;
		undef $main::openid_enabled;
		undef $main::user_id;
		undef $main::password_threshold;
		undef $main::password_latency;
		undef $main::rss_maxitem;
		undef $main::rss_description_maxlength;
		undef $main::google_maps_api_key;
		undef $main::google_analytics_uacct;
		undef $main::google_analytics_embedded;
		undef $main::amazon_access_key;
		undef $main::amazon_secret_access_key;
		undef $main::delete_amazon_access_key;
		undef $main::delete_amazon_secret_access_key;
		undef $main::amazon_associates_id;
		undef $main::cookie_lifetime;
		undef $main::noindex;
		return 1 if $install;
	} else {
		push(@{$this->{'dialog'}},(($install) ? '˼Ԥޤ' : 'ι˼Ԥޤ').$env_path);
	}
} elsif (defined $error_flag && $error_flag) {
	push(@{$this->{'dialog'}},(($install) ? '˼Ԥޤ' : 'ι˼Ԥޤ'));
}
undef $doctype;

#ڡإå
if (@title_and_description) {
	require CMONOS::CGI_Lib::ProgressBar;
	$cgi::ProgressBar = ProgressBar->new;
	$this->set_css($cgi::ProgressBar->css);
	$this->set_javascript($cgi::ProgressBar->javascript);
}
$this->jump_menu('tools') if !$install;
$this->print_page_header('tools');

if ($install) {
	print '<h1>ꢪ󥹥ȡ</h1>';
	print '<p class="note">ϥ󥹥ȡѹ뤳ȤǤޤ</p>';
} else {
	$cgi::ProgressBar->print_progress_bar('ե') if @title_and_description;
	print '<h1>ѹ</h1>';
}
print '<fieldset><legend>եå</legend><ol id="refresh-log"></ol></fieldset>' if @title_and_description && $main::log;
print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=>	'return confirm(\'' . (($install) ? 'ǤǤϥ󥹥ȡ⡢֥åȥåץȡפѹ뤳ȤǤޤ' : 'ϼäޤѹޤ') . '\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="1" />';
print '<fieldset><table class="field-table"><tbody>';
print '<tr>';
print '<td class="field-name"><label for="password">ޥѥ</label></td>';
print '<td class="field"><input type="password" name="password" id="password" size="50" /></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="password2">ޥѥɡʳǧ</label></td>';
print '<td class="field"><input type="password" name="password2" id="password2" size="50" />';
print '<div class="hints">ѥɤ "' . $this->rand_char_sample . '"</div>';
print(($install) ? '<div class="warning">ɬꤷƤ</div>' : '<div class="hints">̵ξѹޤ</div>');
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="emailaddr">ͥɥ쥹</label></td>';
print '<td class="field"><input type="text" name="emailaddr" id="emailaddr" size="30" value="' . $this->escape((defined $main::emailaddr && $main::emailaddr ne '') ? $main::emailaddr : $env::master_email) . '" />';
print(($install) ? '<div class="warning">ɬꤷƤ</div>' : '');
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><span class="datatitle">ޥѥǧ</span></td>';
print '<td class="field"><label><input type="checkbox" name="master_email_required" value="1"' . (($main::master_email_required || (!defined $main::master_email_required && $env::master_email_required)) ? ' checked="checked"' : '') . ' /> ޥѥɤǧڤݡͥ᡼륢ɥ쥹׵᤹</label></td>';
print '</tr>';
print '</tbody><tbody>';
print '<tr>';
print '<td class="field-name"><label for="session_enabled">桼ε</label></td>';
print '<td class="field"><select name="session_enabled" id="session_enabled">';
print '<option value="2"' . (((defined $main::session_enabled && $main::session_enabled eq '2') || (!defined $main::session_enabled && $env::session_enabled eq '2')) ? ' selected="selected"' : '') . '>ƤΥ桼򥻥åˤäݻ</option>';
print '<option value="1"' . (((defined $main::session_enabled && $main::session_enabled eq '1') || (!defined $main::session_enabled && $env::session_enabled eq '1')) ? ' selected="selected"' : '') . '>ѥɾȥåԥ󥰥Ⱦ򥻥åˤäݻ</option>';
print '<option value="0"' . (((defined $main::session_enabled && $main::session_enabled eq '0') || (!defined $main::session_enabled && $env::session_enabled eq '0')) ? ' selected="selected"' : '') . '>Cookie ƤΥ桼򵭲</option>';
print '</select>';
print '<div class="hints">åǤϥ桼Ȥ˥ˡ ID 꿶 ID б<strong>桼󤬥о¸</strong>ޤ</div>';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="cookie_lifetime">Cookie ¸</label></td>';
print '<td class="field"><input type="text" name="cookie_lifetime" id="cookie_lifetime" size="6" value="' . $this->escape((defined $main::cookie_lifetime && $main::cookie_lifetime ne '') ? $main::cookie_lifetime : $env::cookie_lifetime) . '" /> ';
print '</td>';
print '</tr>';
if ($env::session_enabled) {
	print '<tr>';
	print '<td class="field-name"><label for="session_security">ѥɤκƳǧ</label></td>';
	print '<td class="field"><select name="session_security" id="session_security">';
	print '<option value="ip,agent"' . (((defined $main::session_security && $main::session_security eq 'ip,agent') || (!defined $main::session_security && $env::session_security eq 'ip,agent')) ? ' selected="selected"' : '') . '>ǧڻƱIPƱ쥨ȤǤʤѥɤƳǧ</option>';
	print '<option value="ip"' . (((defined $main::session_security && $main::session_security eq 'ip') || (!defined $main::session_security && $env::session_security eq 'ip')) ? ' selected="selected"' : '') . '>ǧڻƱIPǤʤѥɤƳǧ</option>';
	print '<option value="agent"' . (((defined $main::session_security && $main::session_security eq 'agent') || (!defined $main::session_security && $env::session_security eq 'agent')) ? ' selected="selected"' : '') . '>ǧڻƱ쥨ȤǤʤѥɤƳǧ</option>';
	print '<option value="none"' . (((defined $main::session_security && $main::session_security eq 'none') || (!defined $main::session_security && $env::session_security eq 'none')) ? ' selected="selected"' : '') . '>ǧڻȥåIDפХѥɤǧʤ</option>';
	print '</select>';
	print '</td>';
	print '</tr>';
	if (eval{require LWP::UserAgent} && eval 'use Crypt::SSLeay;1;') {
		print '<tr>';
		print '<td class="field-name"><label for="openid_enabled">OpenID ˤǧ</label></td>';
		print '<td class="field"><select name="openid_enabled" id="openid_enabled">';
		print '<option value="0"' . (((defined $main::openid_enabled && $main::openid_enabled eq '0') || (!defined $main::openid_enabled && $env::openid_enabled eq '0')) ? ' selected="selected"' : '') . '>OpenID ˤǧڤĤʤ</option>';
		print '<option value="1"' . (((defined $main::openid_enabled && $main::openid_enabled eq '1') || (!defined $main::openid_enabled && $env::openid_enabled eq '1')) ? ' selected="selected"' : '') . '>OpenID ˤǧڤĤ</option>';
		print '</select>';
		print '</td>';
		print '</tr>';
	}
}
print '<tr>';
print '<td class="field-name"><span class="datatitle">ѥɥå</span></td>';
print '<td class="field">';
print '<label><input type="text" name="password_threshold" id="password_threshold" size="3" value="' . $this->escape((defined $main::password_threshold) ? $main::password_threshold : $env::password_threshold) . '" /> ʾѥǧڤ˼ԤȤ</label>';
print '<label><input type="text" name="password_latency" id="password_latency" size="3" value="' . $this->escape((defined $main::password_latency) ? $main::password_latency : $env::password_latency) . '" /> ʬ֥ѥǧڤ䤹롣</label>';
print '</td>';
print '</tr>';
if ($env::home_dir_id && !$is_document_root) {
	my $user_id = ($env::register_cgi && $env::register_cgi eq '../pswd/start.cgi') ? 'individual' : 'shared';
	print '<tr class="tbody-end">';
	print '<td class="field-name"><label for="user_id">ζͭ</label></td>';
	print '<td class="field"><select name="user_id" id="user_id">';
	print '<option value="shared"' . (((defined $main::user_id && $main::user_id eq 'shared') || (!defined $main::user_id && $user_id eq 'shared')) ? ' selected="selected"' : '') . '>Ǿؤȶͭ</option>';
	print '<option value="individual"' . (((defined $main::user_id && $main::user_id eq 'individual') || (!defined $main::user_id && $user_id eq 'individual')) ? ' selected="selected"' : '') . '>򤳤Υǥ쥯ȥǤΤѤ</option>';
	print '</select>';
	print '</td>';
	print '</tr>';
}
print '</tbody><tbody>';
print '<tr>';
print '<td class="field-name"><label for="title">ȥȥ</label></td>';
print '<td class="field"><input type="text" name="title" id="title" size="30" value="' . $this->escape((defined $main::title && $main::title ne '') ? $main::title : $env::title) . '" />';
print(($install) ? '<div class="warning">ɬꤷƤ</div>' : '');
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="copyright">Ȥ</label></td>';
print '<td class="field"><input type="text" name="copyright" id="copyright" size="30" value="' . $this->escape((defined $main::copyright && $main::copyright ne '') ? $main::copyright : $env::copyright) . '" />';
print '<div class="hints">RSSΥȤɽʤɤ˻Ѥޤ</div>';
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="description">Ȥ</label></td>';
print '<td class="field"><textarea name="description" id="description" cols="60" rows="2">' . $this->escape((defined $main::description && $main::description ne '') ? $main::description : $env::description) . '</textarea>';
print '<div class="hints">RSSΥȤʤɤ˻Ѥޤ</div>';
print '</td>';
print '</tr>';
print '</tbody><tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="doctype">DOCTYPE </label></td>';
print '<td class="field"><select name="doctype" id="doctype">';
if (!defined $env::doctype || $env::doctype =~ / XHTML 1.0 Transitional/ || $env::doctype eq '') {
	$env_doctype = 'xhtml1transitional';
} elsif ($env::doctype =~ /<!DOCTYPE html>/i) {
	$env_doctype = 'html5';
} elsif ($env::doctype =~ / XHTML 1.0 Strict/) {
	$env_doctype = 'xhtml1strict';
} elsif ($env::doctype =~ / HTML 4.01 Strict/) {
	$env_doctype = 'html401strict';
} elsif ($env::doctype =~ / HTML 4.01 Transitional/) {
	$env_doctype = 'html401transitional';
} elsif ($env::doctype =~ /html4\/loose\.dtd/) {
	$env_doctype = 'html401loose';
} else {
	$env_doctype = '';
	print '<option value="">' . $this->escape($env::doctype) . '</option>';
}
print '<option value="html5"' . (((defined $main::doctype && $main::doctype eq 'html5') || (!defined $main::doctype && $env_doctype eq 'html5')) ? ' selected="selected"' : '') . '>HTML5</option>';
print '<option value="xhtml1strict"' . (((defined $main::doctype && $main::doctype eq 'xhtml1strict') || (!defined $main::doctype && $env_doctype eq 'xhtml1strict')) ? ' selected="selected"' : '') . '>XHTML1.0</option>';
print '<option value="xhtml1transitional"' . (((defined $main::doctype && $main::doctype eq 'xhtml1transitional') || (!defined $main::doctype && $env_doctype eq 'xhtml1transitional')) ? ' selected="selected"' : '') . '>XHTML1.0(ߴ⡼)</option>';
print '<option value="html401strict"' . (((defined $main::doctype && $main::doctype eq 'html401strict') || (!defined $main::doctype && $env_doctype eq 'html401strict')) ? ' selected="selected"' : '') . '>HTML4.01</option>';
print '<option value="html401transitional"' . (((defined $main::doctype && $main::doctype eq 'html401transitional') || (!defined $main::doctype && $env_doctype eq 'html401transitional')) ? ' selected="selected"' : '') . '>HTML4.01( IE ߴ)</option>';
print '<option value="html401loose"' . (((defined $main::doctype && $main::doctype eq 'html401loose') || (!defined $main::doctype && $env_doctype eq 'html401loose')) ? ' selected="selected"' : '') . '>HTML4.01(ߴ⡼)</option>';
print '</select>';
print '</td>';
print '</tr>';
print '</tbody><tbody>';
if (!$install) {
	print '<tr class="tbody-end">';
	print '<td class="field-name"><label for="inline_navi">ʥӥ</label></td>';
	print '<td class="field"><select name="inline_navi" id="inline_navi">';
	print '<option value="1"' . (((defined $main::inline_navi && $main::inline_navi eq '1') || (!defined $main::inline_navi && $env::inline_navi eq '1')) ? ' selected="selected"' : '') . '></option>';
	print '<option value="0"' . (((defined $main::inline_navi && $main::inline_navi eq '0') || (!defined $main::inline_navi && $env::inline_navi eq '0')) ? ' selected="selected"' : '') . '>ե졼ʬ</option>';
	print '</select>';
	print '</td>';
	print '</tr>';
}
print '</tbody><tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="inline_navi">ɥȥեޥå</label></td>';
print '<td class="field"><select name="window_title_format" id="window_title_format">';
foreach my $wf (':,:',' | , | ',' | , | ,1',' | , &lt; ,1',' | ,,1',' | ') {
	print '<option value="' . $wf . '"' . (((defined $main::window_title_format && $main::window_title_format eq $wf) || (!defined $main::window_title_format && $env::window_title_format eq $wf)) ? ' selected="selected"' : '') . '>' . $this->window_title($wf,'ȥȥ','祫ƥ꡼','ƥ꡼','ڡȥ') . '</option>';
}
print '</select>';
print(($install) ? '' : '<div class="warning">ƥ꡼άեޥåȤ饫ƥ꡼άʤեޥåȤѹ硢Ū񤭽ФڡǤϡ򹹿ʤ¤ꥫƥ꡼ά줿ޤޤˤʤޤ</div>');
print '</td>';
print '</tr>';
print '</tbody><tbody>';
print '<tr>';
print '<td class="field-name"><label for="rss_maxitem">RSS 絭</label></td>';
print '<td class="field"><input type="text" name="rss_maxitem" id="rss_maxitem" size="3" value="' . $this->escape((defined $main::rss_maxitem && $main::rss_maxitem ne '') ? $main::rss_maxitem : $env::rss_maxitem) . '" /> ';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="rss_description_maxlength">RSS ܺ</label></td>';
print '<td class="field"><input type="text" name="rss_description_maxlength" id="rss_description_maxlength" size="3" value="' . $this->escape((defined $main::rss_description_maxlength && $main::rss_description_maxlength ne '') ? $main::rss_description_maxlength : $env::rss_description_maxlength) . '" /> (Ⱦ)';
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="description">RSS Υ URL</label></td>';
print '<td class="field"><select name="rss_marker" id="rss_marker">';
print '<option value="0"' . (((defined $main::rss_marker && $main::rss_marker eq '0') || (!defined $main::rss_marker && $env::rss_marker eq '0')) ? ' selected="selected"' : '') . '>RSS ΥǤ뤳Ȥ򼨤ѿɲäʤ</option>';
print '<option value="1"' . (((defined $main::rss_marker && $main::rss_marker eq '1') || (!defined $main::rss_marker && $env::rss_marker eq '1')) ? ' selected="selected"' : '') . '>RSS ΥǤ뤳Ȥ򼨤ѿɲä</option>';
print '</select>';
print '</td>';
print '</tr>';
print '</tbody><tbody>';
print '<tr>';
print '<td class="field-name"><label for="google_maps_api_key"><a href="http://www.google.com/apis/maps/signup.html" target="_blank">Google Maps API </a></label></td>';
print '<td class="field"><input type="text" name="google_maps_api_key" id="google_maps_api_key" size="90" value="' . $this->escape((defined $main::google_maps_api_key && $main::google_maps_api_key ne '') ? $main::google_maps_api_key : $env::google_maps_api_key) . '" />';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="google_analytics_uacct"><a href="http://www.google.co.jp/analytics/ja-JP/" target="_blank">Google Analytics 桼</a></label></td>';
print '<td class="field"><input type="text" name="google_analytics_uacct" id="google_analytics_uacct" size="30" value="' . $this->escape((defined $main::google_analytics_uacct && $main::google_analytics_uacct ne '') ? $main::google_analytics_uacct : $env::google_analytics_uacct) . '" />';
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="google_analytics_embedded">Google Analytics </a></label></td>';
print '<td class="field"><select name="google_analytics_embedded" id="google_analytics_embedded">';
print '<option value="1"' . (((defined $main::google_analytics_embedded && $main::google_analytics_embedded eq '1') || (!defined $main::google_analytics_embedded && $env::google_analytics_embedded eq '1')) ? ' selected="selected"' : '') . '>ǥեȤǥȥå󥰥ɤ</option>';
print '<option value="0"' . (((defined $main::google_analytics_embedded && $main::google_analytics_embedded eq '0') || (!defined $main::google_analytics_embedded && $env::google_analytics_embedded eq '0')) ? ' selected="selected"' : '') . '>ǥեȤǤϥȥå󥰥ɤޤʤ</option>';
print '</select>';
print '</td>';
print '</tr>';
print '</tbody><tbody>';
print '<tr>';
print '<td class="field-name"><label for="amazon_access_key"><a href="https://aws-portal.amazon.com/gp/aws/developer/registration/index.html" target="_blank">Amazon </a></label></td>';
print '<td class="field"><input type="text" name="amazon_access_key" id="amazon_access_key" size="30" value="' . $this->escape($main::amazon_access_key) . '" />';
if ($env::amazon_access_key) {
	print ' <label><input type="checkbox" name="delete_amazon_access_key" id="delete_amazon_access_key" value="1"' . (($main::delete_amazon_access_key) ? ' checked="checked"' : '') . ' />';
	print '<div class="hints">ߤ=' . $this->escape($this->blur_text($env::amazon_access_key)) . '</div>';
	print '<div class="hints">̵ξѹޤ</div>';
}
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="amazon_secret_access_key">Amazon ̩Υ</label></td>';
print '<td class="field"><input type="text" name="amazon_secret_access_key" id="amazon_secret_access_key" size="50" value="' . $this->escape($main::amazon_secret_access_key) . '" />';
if ($env::amazon_secret_access_key) {
	print ' <label><input type="checkbox" name="delete_amazon_secret_access_key" id="delete_amazon_secret_access_key" value="1"' . (($main::delete_amazon_secret_access_key) ? ' checked="checked"' : '') . ' />';
	print '<div class="hints">ߤ=' . $this->escape($this->blur_text($env::amazon_secret_access_key)) . '</div>';
	print '<div class="hints">̵ξѹޤ</div>';
}
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="amazon_associates_id">Amazon  ID</label></td>';
print '<td class="field"><input type="text" name="amazon_associates_id" id="amazon_associates_id" size="30" value="' . $this->escape((defined $main::amazon_associates_id && $main::amazon_associates_id ne '') ? $main::amazon_associates_id : $env::amazon_associates_id) . '" />';
print '</td>';
print '</tr>';
print '</tbody><tbody>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">ȤؤϿ</span></td>';
print '<td class="field"><label><input type="checkbox" name="noindex" value="1"' . (($main::noindex || (!defined $main::noindex && $env::noindex)) ? ' checked="checked"' : '') . ' /> Ȥθ̤ˤΥȤɽ뤳Ȥݤ</label></td>';
print '</tr>';
print '</tbody></table></fieldset>';
print '<fieldset class="submit">';
print '<label><input type="checkbox" name="log" value="1"' . (($main::log) ? ' checked="checked"' : '') . ' /> ɽ</label> ' if !$install;
print '<input type="submit" value="' . (($install) ? 'δ CMONOS.JP 򥤥󥹥ȡ뤹' : 'ѹ') . '" /></fieldset></form>';

#ڡեå
$this->print_page_footer('tools');

$this->refresh_title_and_description(@title_and_description) if @title_and_description;
exit if $install;
}

sub blur_text ($$) {
my($this,$text) = @_;
return '' if !$text;
$text =~ s/^(.{10}).*$/$1.../;
return $text . '(ȾʬάƤޤ)';
}

sub rename_navi_file($$) {
my($this,$inline_navi_flag) = @_;
return if !-d '../top' || !-f '../top/start.cgi';
my($top_page_path,$index_path,%db);
$top_page_path = '../../top.' . (($env::ssi) ? $env::ssi_ext : 'html');
$index_path = '../../index.' . (($env::ssi) ? $env::ssi_ext : 'html');
eval 'use ' . $env::dbm_file . ';';
if (defined $inline_navi_flag && $inline_navi_flag) {
	if (-f $top_page_path) {
		rename('../../index.html','../../frame.html');
		rename($top_page_path,$index_path);
		$this->change_default_setting('../top/default.pl','home','\'../../index.\' . (($env::ssi) ? $env::ssi_ext : \'html\')');
		$this->change_default_setting('../navimaker/default.pl','frame_path','\'../../frame.html\'');
	}
	tie(%db, $env::dbm_file, $default::preferences . '/navimaker/navi_db', O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %db) {
		$db{'top_uri'} = '../../index.' . (($env::ssi) ? $env::ssi_ext : 'html');
	}
	untie %db;
} else {
	if (!-f $top_page_path) {
		rename($index_path,$top_page_path);
		rename('../../frame.html','../../index.html');
		$this->change_default_setting('../top/default.pl','home','\'../../top.\' . (($env::ssi) ? $env::ssi_ext : \'html\')');
		$this->change_default_setting('../navimaker/default.pl','frame_path','\'../../index.html\'');
	}
	tie(%db, $env::dbm_file, $default::preferences . '/navimaker/navi_db', O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %db) {
		$db{'top_uri'} = '../../top.' . (($env::ssi) ? $env::ssi_ext : 'html');
	}
	untie %db;
}
}

sub change_default_setting ($$$$) {
my($this,$path,$name,$value) = @_;
local(*FILE);
my $data = $this->read_file($path);
$data =~ s/^[\x20\x09]*\$$name[\x20\x09]*=[^;]*;/\$$name = $value;/gm;
$this->write_file($path,\$data);
}

######################################################################
#ȥΥեå
sub refresh_title_and_description ($$$$$$$$$) {
my($this,$old_title,$old_description,$old_format,$old_noindex,$new_title,$new_description,$new_format,$new_noindex) = @_;
my(@cgi,@html_files,$count,$total,$dialog,$refresh_log);
local(*DIR);
return 0 unless opendir(DIR,'../');
@cgi = grep($_ !~ /^\./ && -d '../' . $_ && -f '../' . $_ . '/default.pl',readdir(DIR));
closedir(DIR);
foreach my $dir (@cgi) {
	my($setting,$lib,$path,$subdivided,$default_pl);
	$default_pl = '../' . $dir . '/default.pl';
	$setting = $this->read_file($default_pl,1);
	if ($setting && $setting =~ /^[\x20\x09]*\$lib[\x20\x09]*=[\x20\x09]*["']?([^"']+?)["']?;/m) {
		$lib = $1;
	} else {
		next;
	}
	if ($setting =~ /^[\x20\x09]*\$subdivided[\x20\x09]*=[\x20\x09]*["']?([^"']+?)["']?;/m) {
		$subdivided = $1;
	}
	if ($lib eq 'HomePageMaker') {
		$path = $this->un_base_change(eval($1),$default_pl) if $setting =~ /^[\x20\x09]*\$home[\x20\x09]*=(.*?);/m;
		if (opendir(DIR,$path)) {
			my @articles;
			while (my $file = readdir(DIR)) {
				next if $file =~ /^\./;
				if (-d $path . '/' . $file) {
					push(@articles,$path . '/' . $file);
				} elsif (-f $path . '/' . $file && $file =~ /\.(s?html?|ssi)$/i) {
					push(@html_files,$path . '/' . $file);
				}
			}
			closedir(DIR);
			foreach my $dir (@articles) {
				my @articles2;
				if (opendir(DIR,$dir)) {
					while (my $file = readdir(DIR)) {
						next if $file =~ /^\./;
						if ($subdivided) {
							if (-d $dir . '/' . $file) {
								push(@articles2,$dir . '/' . $file);
							} elsif (-f $dir . '/' . $file && $file =~ /\.(s?html?|ssi)$/i) {
								push(@html_files,$dir . '/' . $file);
							}
						} elsif ($file =~ /^(\d+|index)\.s?html?$/i && -f $dir . '/' . $file) {
							push(@html_files,$dir . '/' . $file);
						}
					}
					closedir(DIR);
					if (@articles2) {
						foreach my $dir2 (@articles2) {
							if (opendir(DIR,$dir2)) {
								push(@html_files,map($dir2 . '/' . $_,grep($_ =~ /^(\d+|index)\.s?html?$/i && -f $dir2 . '/' . $_,readdir(DIR))));
								closedir(DIR);
							}
						}
					}
				}
			}
		}
	} elsif ($lib eq 'HomePageMakerLite') {
		push(@html_files,$this->un_base_change(eval($1),$default_pl)) if $setting =~ /^[\x20\x09]*\$home[\x20\x09]*=(.*?);/m;
	} elsif ($lib eq 'Baobab') {
		$path = $this->un_base_change(eval($1),$default_pl) if $setting =~ /^[\x20\x09]*\$file[\x20\x09]*=(.*?);/m;
		if ($subdivided) {
			if (opendir(DIR,$path)) {
				push(@html_files,map($path . '/' . $_ . '/index.html',grep($_ !~ /^\./ && -d $path . '/' . $_ && -f $path . '/' . $_ . '/index.html',readdir(DIR))));
				closedir(DIR);
			}
		} else {
			push(@html_files,$path . '/index.html');
		}
	} else {
		next;
	}	
}
push(@html_files,$env::externalfiles . '/metaindex.ssi') if $env::externalfiles . '/metaindex.ssi';
$total = @html_files + 3;
if (@html_files) {
	my($site_title,$format);
	if ((defined $new_title && $new_title ne '') || $new_format) {
		$site_title = (defined $new_title && $new_title ne '') ? $new_title : $old_title;
		$format = {};
		($format->{'old'}->{'site_title_separator'},$format->{'old'}->{'category_separator'},$format->{'old'}->{'reverse'}) = split(/,/,$old_format,3);
		$format->{'site_title_separator'} = (defined $format->{'old'}->{'site_title_separator'}) ? quotemeta($format->{'old'}->{'site_title_separator'}) : '';
		$format->{'category_separator'} = (defined $format->{'old'}->{'category_separator'}) ? quotemeta($format->{'old'}->{'category_separator'}) : '';
		if ($new_format) {
			($format->{'new'}->{'site_title_separator'},$format->{'new'}->{'category_separator'},$format->{'new'}->{'reverse'}) = split(/,/,$new_format,3);
			$dialog .= '<li>ɥȥ򥫥ƥ꡼άեޥåȤ饫ƥ꡼άʤեޥåȤѹޤŪ񤭽ФڡǤϡ򹹿ʤ¤ꥫƥ꡼ά줿ޤޤˤʤޤΤǤդ</li>' if !$format->{'old'}->{'category_separator'} && $format->{'new'}->{'category_separator'};
		}
	}
	foreach my $path (@html_files) {
		$count++;
		my $changed = 0;
		my $html = $this->read_file($path,1);
		$changed = 1 if ref $format && $html =~ s/(<title(?!\w)[^>]*>)(.*?)(<\/title>)/$1 . $this->refresh_window_title($2,$old_title,$site_title,$format) . $3/iges;
		if (defined $new_title && $new_title ne '') {
			my $old = quotemeta $old_title;
			$changed = 1 if $html =~ s/<\!--(sitetitle)(?!\w)([^>]*)-->(.*?)<\!--\/sitetitle(?!\w)[^>]*-->/$this->item_tag_replace($1,$2,$3,$new_title,1)/iges;
			$changed = 1 if $html =~ s/(<\!--topicpath(?!\w)[^>]*-->.*?<!--data-->.*?<a(?!\w)[^>]*>).*?(<\/a>)/$1$new_title$2/igs;
			$changed = 1 if $html =~ s/(<link rel="home"[^>]* title=")$old("[^>]*>)/$1$new_title$2/igs;
			$changed = 1 if $html =~ s/(<link rel="alternate" type="application\/rss\+xml"[^>]* title=")$old( - [^>"]*"[^>]*>)/$1$new_title$2/igs;
		}
		if (defined $new_description) {
			$changed = 1 if $html =~ s/<\!--(sitedescription)(?!\w)([^>]*)-->(.*?)<\!--\/sitedescription(?!\w)[^>]*-->/$this->item_tag_replace($1,$2,$3,$new_description,1)/iges;
			if ($old_description) {
				my $old = quotemeta $old_description;
				$changed = 1 if $html =~ s/(>\s*| title="| alt=")$old_description(\s*<|")/$1$new_description$2/;
			}
		}
		if (defined $new_noindex && $new_noindex ne '') {
			if ($new_noindex) {
				$changed = 1 if $html !~ /<meta\s+name="robots"\s+content="noindex,\s*nofollow"\s*\/?>\s*/i && ($html =~ s/(<meta\s+http-equiv="Content-Style-Type"\s+content="text\/css"\s*\/?>\s*)/$1<meta name="robots" content="noindex,nofollow" \/>\x0A/is || $html =~ s/(\s*<\/head>)/\x0A<meta name="robots" content="noindex,nofollow" \/>$1/is);
			} else {
				$changed = 1 if $html =~ s/<meta\s+name="robots"\s+content="noindex,\s*nofollow"\s*\/?>\s*//gsi;
			}
		}
		if ($changed) {
			$this->write_file($path,\$html,1);
			$this->mk_external_javascript($path) if $path =~ /\.ssi$/;
			$refresh_log .= '<li>' . $this->path_change($path,$ENV{'SCRIPT_NAME'},'abs') . '</li>' if $main::log;
			$refresh_log = '' if $cgi::ProgressBar->update($count,$total,20,(($refresh_log) ? 'document.getElementById(\'refresh-log\').innerHTML += \'' . $refresh_log . '\';' : ''));
		}
	}
}
if ((defined $new_title && $new_title ne '') || defined $new_description) {
	my $navi_modified = 0;
	foreach my $path ($env::externalfiles . '/site-navi.ssi',$env::externalfiles . '/site-navi-sjis.ssi',$env::externalfiles . '/site-navi-utf8.ssi') {
		$count++;
		my $changed = 0;
		my $html = $this->read_file($path,1);
		my $sitetitle = (defined $old_title && $old_title ne '') ? $old_title : '';
		my $sitedescription = (defined $old_description && $old_description ne '') ? $old_description : '<!--sitedescription--><!--/sitedescription-->';
		my $title = (defined $new_title && $new_title ne '') ? $new_title : '';
		my $description = (defined $new_description && $new_description ne '') ? $new_description : '<!--sitedescription--><!--/sitedescription-->';
		if ($path =~ /\/site-navi-(sjis|utf8)\.ssi$/) {
			my $ocode = $1;
			$this->jcode_convert(\$sitetitle,$ocode,'euc');
			$this->jcode_convert(\$sitedescription,$ocode,'euc');
			$this->jcode_convert(\$title,$ocode,'euc');
			$this->jcode_convert(\$description,$ocode,'euc');
		}
		$sitetitle = quotemeta $sitetitle;
		$sitedescription = quotemeta $sitedescription;
		$changed = 1 if $sitetitle ne '' && $title ne '' && $html =~ s/(>\s*| title="| alt=")$sitetitle(\s*<|")/$1$title$2/;
		$changed = 1 if defined $new_description && $sitedescription ne '' && $description ne '' && $html =~ s/(>\s*| title="| alt=")$sitedescription(\s*<|")/$1$description$2/;
		if ($changed) {
			$navi_modified = 1;
			$this->write_file($path,\$html,1);
			$this->mk_external_javascript($path);
			$refresh_log .= '<li>' . $this->path_change($path,$ENV{'SCRIPT_NAME'},'abs') . '</li>' if $main::log;
			$refresh_log = '' if $cgi::ProgressBar->update($count,$total,20,(($refresh_log) ? 'document.getElementById(\'refresh-log\').innerHTML += \'' . $refresh_log . '\';' : ''));
		}
	}
	$dialog .= '<li>ʥӥ򹹿ޤȥȥʤɤ̤˹Ƥʤϡʥӥ᡼Ρ֥ʥӥ񤭽Фפ¹ԤƤޤǼġ֥ХХ֡פΥǥեȥڡϡ񤭹ߤޤǹޤΤǤդ</li>' if $navi_modified;
}
$dialog .= '<li>ȤΥɥȥ򹹿ޤ</li>' if (defined $new_title && $new_title ne '') || $new_format;
$dialog .= '<li>ȤθϿ򹹿ޤ</li>' if defined $new_noindex && $new_noindex ne '';
$cgi::ProgressBar->update($count,$total,0,(($refresh_log) ? 'document.getElementById(\'refresh-log\').innerHTML += \'' . $refresh_log . '\';' : '') . 'document.getElementById(\'cgi-dialog-list\').innerHTML += \'' . (($dialog) ? $dialog : '<li>顼</li>') . '\';');
$cgi::ProgressBar->remove;
}

sub refresh_window_title ($$$$) {
my($this,$title,$old_title,$site_title,$format) = @_;
$old_title = quotemeta $old_title;
if (ref $format->{'new'}) {
	my @title_path = ();
	if ($format->{'old'}->{'reverse'}) {
		$title =~ s/$format->{'site_title_separator'}$old_title$//s if $format->{'site_title_separator'} ne '';
		@title_path = ($format->{'category_separator'} ne '') ? reverse(split(/$format->{'category_separator'}/,$title)) : ($title);
	} else {
		$title =~ s/^$old_title$format->{'site_title_separator'}//s if $format->{'site_title_separator'} ne '';
		@title_path = ($format->{'category_separator'} ne '') ? split(/$format->{'category_separator'}/,$title) : ($title);
	}
	@title_path = grep(defined $_ && $_ ne '' && $_ =~ /\S/,@title_path);
	return ((defined $site_title) ? $site_title : '') if !@title_path;
	if (defined $format->{'new'}->{'category_separator'} && $format->{'new'}->{'category_separator'} ne '') {
		@title_path = reverse @title_path if $format->{'new'}->{'reverse'};
		$title = join($format->{'new'}->{'category_separator'},@title_path);
	} else {
		$title = $title_path[$#title_path];
	}
	if (defined $site_title && $site_title ne '') {
		if ($format->{'new'}->{'reverse'}) {
			$title .= $format->{'new'}->{'site_title_separator'} . $site_title;
		} else {
			$title = $site_title . $format->{'new'}->{'site_title_separator'} . $title;
		}
	}
} elsif ($format->{'site_title_separator'} ne '') {
	if ($format->{'old'}->{'reverse'}) {
		$title =~ s/$format->{'site_title_separator'}$old_title$/$format->{'old'}->{'site_title_separator'}$site_title/s;
	} else {
		$title =~ s/^$old_title$format->{'site_title_separator'}/$site_title$format->{'old'}->{'site_title_separator'}/s;
	}
}
return $this->escape_without_html_entity($title);
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('00s0','MasterInfo');

	#˥塼Ͽ
	$setting::jump_menu{'00s0'} = 'ѹ';

}



1;
