package SubDirSize;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use File::Find;
use strict;
######################################################################
# ֥ǥ쥯ȥꥵ⥸塼
# SubDirSize.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ¹
sub run ($) {
my $this = shift;
$this->get_setup_env;

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>֥ǥ쥯ȥꥵ</h1>';

my($list) = $this->sub_directory_size_list($default::cgi_data_root . ($default::home_dir || ''));
if ($list) {
	print '<ul>' . $list . '</ul>';
} else {
	print '<p>֥ǥ쥯ȥ꤬ߤĤޤ</p>';
}

#ڡեå
$this->print_page_footer('tools');
}

sub sub_directory_size_list ($;$$) {
my($this,$dir,$home_dir,$folder) = @_;
my($size,$count) = (0,0);
my @subdirs = ();
my @files = ();
my $list = '';
my $sublist = '';
$home_dir = '' if !defined $home_dir;
local(*DIR);
return('',0,0) unless opendir(DIR,$dir);
@files = grep($_ !~ /^\.(?!\w)/,readdir(DIR));
closedir(DIR);
foreach my $file (@files) {
	my $path = $dir . '/' . $file;
	if (-f $path) {
		$size += -s $path;
		$count++;
	} elsif (-d $path) {
		my($sub,$s,$c) = ('',0,0);
		if (-f $path . '/lib/env.pl') {
			($sub,$s,$c) = $this->sub_directory_size_list($path,$home_dir . '/' . $file,$file);
			$sublist .= $sub;
			push(@subdirs,$file);
		} else {
			($s,$c) = $this->directory_size($path);
		}
		$size += $s;
		$count += $c;
	}
}
if (opendir(DIR,'../..' . ($home_dir || '/'))) {
	my @files = grep($_ !~ /^\.(?!\w)/,readdir(DIR));
	closedir(DIR);
	foreach my $file (@files) {
		my $path = '../..' . ($home_dir || '/') . '/' . $file;
		if (-f $path) {
			$size += -s $path;
			$count++;
		} elsif (-d $path && !grep($_ eq $file,@subdirs)) {
			my($s,$c) = $this->directory_size($path);
			$size += $s;
			$count += $c;
		}
	}
}
my $mb = int($size / 10000 + 0.5) / 100;
return(
	'<li><span style="font-size:' . (1 + (($mb && $mb > 1000) ? 1 : (int($mb) / 1000))) . 'em">' . ($folder || 'Υǥ쥯ȥ') . $this->subdir_name($dir . '/lib/env.pl') . ' = ' . $mb . 'MB/' . $count . 'ե</span>' . (($sublist) ? '<ul>' . $sublist . '</ul>' : '') . '</li>',
	$size,
	$count
);
}

sub directory_size ($$) {
my($this,$path) = @_;
my($size,$count) = (0,0);
find(sub { if (-f $_) { $size += -s $_; $count++; } }, $path);
return($size,$count);
}

sub subdir_name ($$) {
my($this,$path) = @_;
my $data = $this->read_file($path,1);
if ($data =~ /^[\x20\x09]*\$title[\x20\x09]*=\s*["']([^'"]*)["'];/m) {
	return ' (' . $1 . ')';
} else {
	return '';
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
if (!$env::subdirectory_disabled) {

	#饹Ͽ
	Common::class_register('s503','SubDirSize');

	#˥塼Ͽ
	$setting::jump_menu{'s503'} = '֥ǥ쥯ȥꥵ';
}
}



1;
