package SCOrderShippingInfo;
require CMONOS::TableMaker::Field::TMUserGeneratedField;
require CMONOS::CGI_Lib::Field;
@ISA = qw(TMUserGeneratedField Field);
use strict;
######################################################################
# ⥸塼
# SCOrderShippingInfo.pm 1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-06-14
######################################################################
%SCOrderShippingInfo::url = (
	'ͥޥ'	=> 'http://toi.kuronekoyamato.co.jp/cgi-bin/tneko?init',
	'ڥꥫ'		=> 'https://info.jpexpress.jp/confirm/confirmIndex.html',
	''			=> 'http://k2k.sagawa-exp.co.jp/p/sagawa/web/okurijoinput.jsp',
	'ʡ̱'			=> 'http://www1.fukutsu.co.jp/inq/index.html',
	'椦ѥå'		=> 'http://tracking.post.japanpost.jp/service/jsp/refi/DP311-00100.jsp',
	'椦᡼'		=> 'http://tracking.post.japanpost.jp/service/jsp/refi/DP311-00100.jsp'
);
######################################################################
#	(0)-3 եDB
sub db ($) {
my $this = shift;
return 'shipping';
}

# --------------------------------------------------------------------
sub _set ($$) {
my $this = shift;
unless (ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
@{$this->{'authorities'}} = $this->get_address($this->{'authority'});
$this->scalar_to_array(\$this->{'order'});
$this->import_db($default::preference_dir . '/terms',\%setting::payment,1) if !%setting::payment;
$this->{'field_for'}{'shipping_info'} = $this->{'id'};
$this->scalar_to_array(\$this->{'mailto'});
$this->{'datetype'} = (($setting::general{'datetype'}) ? $setting::general{'datetype'} : '') if !$this->{'datetype'};
return;
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
$this->scalar_to_array(\$main::search{$this->{'id'}}{'service'});
return ((ref $main::search{$this->{'id'}}{'service'} && @{$main::search{$this->{'id'}}{'service'}}) || $main::search{$this->{'id'}}{'shipped'} || $main::search{$this->{'id'}}{'number'}) ? 1 : 0;
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
return 1 if !$this->match_enabled;
my($service,$number) = split(/\t/,$$str);
if ($main::search{$this->{'id'}}{'number'}) {
	@{$this->{'pattern'}} = split(/\s+/,$main::search{$this->{'id'}}{'number'}) if !ref $this->{'pattern'};
	return ($number && grep($_ eq $number,@{$this->{'pattern'}})) ? 1 : 0;
} else {
	return ((!$main::search{$this->{'id'}}{'shipped'} || ($main::search{$this->{'id'}}{'shipped'} eq 'true' && $number) || ($main::search{$this->{'id'}}{'shipped'} eq 'false' && !$number)) && $service && (!@{$main::search{$this->{'id'}}{'service'}} || grep($_ eq $service,@{$main::search{$this->{'id'}}{'service'}}))) ? 1 : 0;
}
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status,$original,$path) = @_;
my($form,$service,$number,$time,$comment);
($service,$number,$time,$comment) = ($main::data{$this->{'id'}}{'str'}) ? split(/\t/,$main::data{$this->{'id'}}{'str'}) : ('','','','');
$form = $this->field_header;
if (ref $cgi::action && $cgi::action->{'digital_content_only'}) {
	$form .= ($default::english) ? 'Download Only.' : '';
} elsif ($number) {
	$form .= $this->shipping_info($service,$number,$time,$comment);
} else {
	$form .= $this->delivery_service_menu('data:' . $this->{'id'} . ':service',[$service],$this->{'is_invalid_field'});
}
$form .= $this->field_footer;
return $form;
}

sub delivery_service_menu ($$$$;$$) {
my($this,$name,$data,$is_invalid,$is_multiple) = @_;
return ($is_multiple) ? '' : (defined $this->{'order'}[0]) ? ($this->{'service'}{$this->{'order'}[0]}{'name'}) ? $this->{'service'}{$this->{'order'}[0]}{'name'} : $this->{'service'}{$this->{'order'}[0]}{'service'} : '' if !ref $this->{'order'} || !@{$this->{'order'}} || @{$this->{'order'}} == 1;
my($id,$form);
$form .= '<select name="' . $name . '"' . (($is_multiple) ? ' multiple="multiple"' : '') . (($is_invalid) ? $this->set_invalid_class : '') . '>';
foreach $id (@{$this->{'order'}}) {
	my $service = ($this->{'service'}{$id}{'name'}) ? $this->{'service'}{$id}{'name'} : $this->{'service'}{$id}{'service'};
	$form .= '<option value="' . $this->escape($service) . '"' . ((ref $data && grep(defined $_ && $_ eq $service,@$data)) ? ' selected="selected"' : '') . '>' . $this->escape($service) . '</option>';
}
$form .= '</select>';
return $form;
}

sub shipping_info ($$$;$$$) {
my($this,$service,$number,$time,$comment,$for_text) = @_;
my $info = '';
if ($for_text) {
	return $this->date($time,0,$this->{'datetype'} . 'gmt<d') . 'в٤ޤ' . "\x0A" . '[' . $service . (($number && $number ne 'shipped') ? ':' . $number : '') . ']' . ((defined $comment && $comment ne '') ? "\x0A" . $comment : '');	
} else {
	return '<a href="' . $this->service_url($service,$number) . '" target="_blank" class="shipping-link">' . 
		$this->date($time,3,$this->{'datetype'} . 'gmt<d') . 'в٤ޤ</a><br />[' . $service . (($number && $number ne 'shipped') ? ':' . $number : '') . ']' .
		((defined $comment && $comment ne '') ? '<div class="shipping-comment">' . $this->autolink($comment,1) . '</div>' : '');
}
}

sub service_url ($$$) {
my($this,$service,$number) = @_;
my $url = '';
$number = '' if $number eq 'shipped';
if ($SCOrderShippingInfo::url{$service}) {
	$url = $SCOrderShippingInfo::url{$service};
} else {
	my($id);
	foreach $id (@{$this->{'order'}}) {
		if ($service eq $this->{'service'}{$id}{'name'}) {
			if ($SCOrderShippingInfo::url{$this->{'service'}{$id}{'service'}}) {
				$url = $SCOrderShippingInfo::url{$this->{'service'}{$id}{'service'}};
			} elsif ($this->{'service'}{$id}{'url'}) {
				$url = $this->{'service'}{$id}{'url'};
			}
			last;
		}
	}
}
$url =~ s/_number_/$number/sg;
return $url;
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
my $this = shift;
if (ref $cgi::action && $cgi::action->{'digital_content_only'}) {
	$main::data{$this->{'id'}}{'str'} = '';
	return 1;
}
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
my $is_valid = 1;
my($data,$service,$number,$time,$comment);
$data = '';
if (!$cgi::action->{'new_data'}) {
	my %db;
	use Fcntl qw(:DEFAULT);
	eval 'use ' . $env::dbm_file . ';';
	tie(%db, $env::dbm_file, "$default::db/$main::c/$this->{'id'}", O_RDONLY, $env::dbm_mode);
	if (ref tied %db && defined $db{$main::n}) {
		$data = $db{$main::n};
	}
	untie %db;
	($service,$number,$time,$comment) = ($data) ? split(/\t/,$data,4) : ('','','','');
} elsif ($main::data{$this->{'id'}}{'str'}) {
	($service,$number,$time,$comment) = split(/\t/,$main::data{$this->{'id'}}{'str'},4);
}
$service = $main::data{$this->{'id'}}{'service'} if (!$service || !$number) && $main::data{$this->{'id'}}{'service'};
if (!$number) {
	if ($service && ($SCOrderShippingInfo::url{$service} || grep($service eq $this->{'service'}{$_}{'name'},@{$this->{'order'}}))) {
		$main::data{$this->{'id'}}{'str'} = $service;
	} elsif (!$service && @{$this->{'order'}} && @{$this->{'order'}} == 1 && defined $this->{'order'}[0] && $this->{'order'}[0] ne '') {
		$main::data{$this->{'id'}}{'str'} = $service = ($this->{'service'}{$this->{'order'}[0]}{'name'}) ? $this->{'service'}{$this->{'order'}[0]}{'name'} : $this->{'service'}{$this->{'order'}[0]}{'service'};
	} elsif (!$this->{'required'} && !$service) {
		$is_valid = 0;
		push(@{$cgi::action->{'dialog'}},$this->name . 'ꤷƤ') if ref $cgi::action;
	} elsif ($service) {
		$is_valid = 0;
		push(@{$cgi::action->{'dialog'}},$this->name . '꤬ޤ' . $this->escape($service) . ' ϤѤˤʤޤ') if ref $cgi::action;
	}
} else {
	$main::data{$this->{'id'}}{'str'} = $data;
}
if ($is_valid && $service && $this->cod_is_unavailable($service)) {
	$is_valid = 0;
	if ((!ref $this->{'order'} || !@{$this->{'order'}} || @{$this->{'order'}} == 1) && defined $this->{'field_for'}{'payment_method'} && ref $this->{'field_obj'}{$this->{'field_for'}{'payment_method'}}) {
		push(@{$cgi::action->{'dialog'}},$this->{'field_obj'}{$this->{'field_for'}{'payment_method'}}->name . '꤬ޤ' . $this->escape($service) . ' бƤޤ') if ref $cgi::action;
	} else {
		push(@{$cgi::action->{'dialog'}},$this->name . '꤬ޤ' . $this->escape($service) . ' бƤޤ') if ref $cgi::action;
	}
}
$is_valid = 0 if $is_valid && !$this->is_not_empty('str');
if ($is_valid) {
	$cookie::data{'data:' . $this->{'id'} . ':str'} = $main::data{$this->{'id'}}{'str'} if $this->{'cookie'} && $main::set_cookie && defined $main::data{$this->{'id'}}{'str'};
} else {
	$this->{'is_invalid_field'} = 1;
}
return $is_valid;
}

sub cod_is_unavailable ($$) {
my($this,$service) = @_;
return 1 if !$setting::payment{'codenabled'} && defined $this->{'field_for'}{'payment_method'} && $main::data{$this->{'field_for'}{'payment_method'}}{'str'} && $main::data{$this->{'field_for'}{'payment_method'}}{'str'} eq 'cod';
my($id);
foreach $id (@{$this->{'order'}}) {
	if ($service eq $this->{'service'}{$id}{'name'} || $service eq $this->{'service'}{$id}{'service'}) {
		if (!$this->{'service'}{$id}{'cod'} && defined $this->{'field_for'}{'payment_method'} && $main::data{$this->{'field_for'}{'payment_method'}}{'str'} && $main::data{$this->{'field_for'}{'payment_method'}}{'str'} eq 'cod') {
			return 1;
		} else {
			return 0;
		}
	}
}
return 0;
}

######################################################################
#	obj->is_secure;
sub is_secure_user ($) {
my $this = shift;

#ѥɥå
if (!defined $this->{'checkerLevel'} || $this->{'checkerLevel'} eq '' || $this->{'checkerLevel'} eq 'master') {
	if ($this->is_master) {
		return 1;
	} else {
		return 0;
	}

#ʡѥɥå
} elsif ($this->{'checkerLevel'} eq 'owner') {
	if ($this->is_owner) {
		return 1;
	} else {
		push(@{$cgi::action->{'dialog'}},$cgi::Register->error_dialog) if ref $cgi::Register;
		return 0;
	}

#Ʊʡѥɥå
} elsif ($this->{'checkerLevel'} eq 'owners') {
	if ($this->is_one_of_owners) {
		return 1;
	} else {
		push(@{$cgi::action->{'dialog'}},$cgi::Register->error_dialog) if ref $cgi::Register;
		return 0;
	}

#Ͽѥɥå
} elsif ($this->{'checkerLevel'} eq 'member') {
	if ($this->is_authorized(@{$this->{'authorities'}})) {
		return 1;
	} else {
		push(@{$cgi::action->{'dialog'}},$cgi::Register->error_dialog) if ref $cgi::Register;
		return 0;
	}
}

return 0;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=ɽǡ/path=ե¸ǥ쥯ȥ
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
my($out,$service,$number,$time,$comment,$id);
$id = $this->mk_user_generated_field_id($c,$n);
$str = $$str{'str'} if ref $str eq 'HASH';
($service,$number,$time,$comment) = ($str) ? split(/\t/,$str) : ('','','','');
if ($this->is_secure_user) {
	my $is_updated_record = $this->is_updated_record($c,$n);
	$out .= $this->form_start(
		'id'		=>	(($id) ? $id . '-form' : ''),
		'name'		=>	(($id) ? $id . '-form' : ''),
		'method'	=> 'post',
		'onsubmit'	=>	'return cmonos.form.item(this).submit(\'' . $id . '\');',
		'required'	=>	\@setting::form
	);
	$out .= '<input type="hidden" name="id" value="' . $this->{'id'} . '" />';
	$out .= '<input type="hidden" name="c" value="' . $c . '" />' if !grep($_ eq 'c',@setting::form);
	$out .= '<input type="hidden" name="n" value="' . $n . '" />' if !grep($_ eq 'n',@setting::form);
	$out .= '<div class="warning">' . $this->date($time,3,$this->{'datetype'} . 'gmt<d') . '˽в٤Ƥޤ</div>' if $time;
	$out .= '<table class="sub-field-table"><tbody>';
	$out .= '<tr><td class="field-name"><label for="ship:service">ȼ</label></td><td class="field">' . (($service) ? $service : $this->delivery_service_menu('data:' . $this->{'id'} . ':service',[(($is_updated_record && $main::ship{'service'}) ? $main::ship{'service'} : ())])) . '</td></tr>';
	$out .= '<tr><td class="field-name"><label for="ship:number">ʪֹ</label></td><td class="field"><input type="text" name="ship:number" id="ship:number" size="20" value="' . $this->escape(($is_updated_record && $main::ship{'number'}) ? $main::ship{'number'} : ($number) ? $number : '') . '"' . (($is_updated_record && $this->{'is_invalid_field'}{'number'}) ? ' class="invalid-field"' : '') . ' onchange="cmonos.validate.field(this).bailOut()" /></td></tr>';
	$out .= '<tr class="tbody-end"><td class="field-name"><label for="ship:comment"></label></td><td class="field"><textarea name="ship:comment" id="ship:comment" cols="20" rows="3"' . (($is_updated_record && $this->{'is_invalid_field'}{'comment'}) ? ' class="invalid-field"' : '') . ' onchange="cmonos.validate.field(this).bailOut()">' . $this->escape(($is_updated_record && $main::ship{'comment'}) ? $main::ship{'comment'} : ($comment) ? $comment : '') . '</textarea></td></tr>';
	$out .= '</tbody><tbody>';
	$out .= '<tr><td class="submit-box" colspan="2">';
	$out .= $cgi::Deco->submit_button('submit',$this->{'button'},(($default::english) ? 'Submit' : ((($time) ? 'ںơ' : '') . 'вٴλ')),{'id' => $id . '-submit'},{'ship:shipped' => 1},'',(($time) ? '-visited' : ''));
	$out .= '</td></tr></tbody></table>';
	$out .= '</form>';
	return $out;
} elsif ($service) {
	return $this->style(
		(($number) ? $this->shipping_info($service,$number,$time,$comment) : $service),
		$this->{'style'},
		$this->{'fontsize'},
		$this->{'fontcolor'},
		$this->{'fontface'}
	);
} else {
	return '';
}
}

sub has_content {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return (($str && $str =~ /^\S/) || $this->is_secure_user) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
my($this,$str) = @_;
return '' if !defined $str || $str eq '';
$str = '[' . $this->name . "]\x0A" . $this->format_for_text($str);
$str =~ s/[\x0A]*\Z/\x0A\x0A/s;
return $str;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
my($this,$str) = @_;
return '' if !defined $str || $str eq '';
$str = $$str{'str'} if ref $str eq 'HASH';
my($service,$number,$time,$comment) = ($str) ? split(/\t/,$str) : ('','','','');
return ($number) ? $this->shipping_info($service,$number,$time,$comment,1) : ($service) ? $service : '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$) {
my($this,$str) = @_;
my($service,$number,$time,$comment);
if (ref $cgi::action && $cgi::action->{'digital_content_only'}) {
	$service = ($default::english) ? 'Download Only.' : '';
} else {
	$str = $$str{'str'} if ref $str eq 'HASH';
	($service,$number,$time,$comment) = ($str) ? split(/\t/,$str) : ('','','','');
}
if ($service) {
	return $this->style(
		(($number) ? $this->shipping_info($service,$number,$time,$comment) : $service),
		$this->{'style'},
		$this->{'fontsize'},
		$this->{'fontcolor'},
		$this->{'fontface'}
	);
} else {
	return '';
}
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my $this = shift;

#̾
my $name = 'data:' . $this->{'id'};

$this->print_field_info_form($name);

require CMONOS::CGI_Lib::Table;
my $table = Table->new;
$table->set(
	'tableclass' => 'tooltable',
	'trclass' => 'odd,even',
	'class0' => 'odd,even',
	'classF' => 'caution',
	'thenabled' => 'true'
);
print '<fieldset>';
print '<legend>ӥꥹ</legend>';
print $table->table;

#إå
print $table->tr;
print $table->td('');
print $table->td('ɽ');
print $table->td('ӥ');
print $table->td('ӥ̾');
print $table->td('URL');
print $table->td('') if $setting::payment{'codenabled'};
print $table->_tr;

#
my($id,$n);
foreach $id (@{$this->{'order'}}) {
	$this->print_delivery_service_setting($name,$table,$id,++$n,$this->{'service'}{$id});
}
$id = 1;
$id++ while ref $this->{'service'}{$id};
$this->print_delivery_service_setting($name,$table,$id,++$n);

print $table->_table;
undef %$table;
undef $table;

print '<div class="hints">ӥ֤¾װʳξ硢ӥ̾ URL ꤹɬפϤޤ</div>';
print '</fieldset>';

print '<fieldset>';
print '<legend>вپ񤭹</legend>';
print '<fieldset>';
print '<legend><label for="' . $name . '_checkerLevel">񤭹߸¤Τ桼</label></legend>';
print $this->mk_select_menu(
	$name . '_checkerLevel','','',$this->{'checkerLevel'},
	'master'	=>		'ޥ',
	'owner'		=>		'',
	'owners'	=>		'Ʊʡ',
	'member'	=>		'ϿС'
);
print '</fieldset>';
print '<fieldset>';
print '<legend><label for="' . $name . '_authority">ϿСץ᡼륢ɥ쥹</label></legend>';
print '<textarea name="' . $name . '_authority" id="' . $name . '_authority" cols="56" rows="5" wrap="off">' . $this->escape($this->{'authority'}) . '</textarea>';
print '<div class="note">ϿСʣλϥޡ+ԡˤǶڤޤ</div>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label for="' . $name . '_datetype">вٻɽ</label></legend>';
$this->print_date_type_menu($name . '_',$this->{'datetype'});
print '</fieldset>';

print '<fieldset>';
print '<legend>εϿ</legend>';
print '<label><input type="checkbox" name="' . $name . '_mTime" id="' . $name . '_mTime" value="1" ' . ((defined $this->{'mTime'} && $this->{'mTime'}) ? ' checked="checked"' : '') . ' /> вٴλ˹ǡ١򹹿롣</label>';
print '</fieldset>';

print '<fieldset>';
print '<legend>ܥ</legend>';
print $cgi::Deco->button_menu(
	$name . '_button',
	'submit',
	120,
	$this->{'button'}
);
print '</fieldset>';

print '<fieldset>';
print '<legend>вΥ᡼</legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_mailto">Υ᡼</label></td>';
print '<td class="field"><select name="' . $name . '_mailto" id="' . $name . '_mailto" multiple="multiple">';
foreach my $id (sort {$this->{'field_obj'}->{$a}->{'ORDER'} <=> $this->{'field_obj'}->{$b}->{'ORDER'} || $a <=> $b} keys %{$this->{'field_obj'}}) {
	if (defined $this->{'field_obj'}{$id}->{'e-mail'} && $this->{'field_obj'}{$id}->{'e-mail'}) {
		print '<option value="' . $id . '"' . ((ref $this->{'mailto'} && grep($_ eq $id,@{$this->{'mailto'}})) ? ' selected="selected"' : '') . '>' . $this->{'field_obj'}{$id}->name . '</option>';
	}
}
print '</select>';
print '<div class="note">̵ξ硢εǽưޤ</div></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_subject">ɽ</label></td>';
print '<td class="field"><input type="text" name="' . $name . '_subject" id="' . $name . '_subject" size="70" value="' . $this->escape($this->{'subject'}) . '" /></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_msg"></label></td>';
print '<td class="field"><textarea name="' . $name . '_msg" id="' . $name . '_msg" cols="70" rows="10">' . $this->escape($this->{'msg'}) . '</textarea>';
print '<div class="toolbox">';
print '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'' . $name . '_msg\').quotationByMenu(this)" title="Υϥ᡼бͤѴޤ">';
print '<option value=""></option>';
print '<option value="&lt;name&gt;">&lt;name&gt;[̾ե' . (($this->{'field_for'}{'name'} && ref $this->{'field_obj'}{$this->{'field_for'}{'name'}}) ? '' . $this->{'field_obj'}{$this->{'field_for'}{'name'}}->name . '' : '') . ']</option>';
print '<option value="&lt;key&gt;">&lt;key&gt;[ե' . (($this->{'field_for'}{'key'} && ref $this->{'field_obj'}{$this->{'field_for'}{'key'}}) ? '' . $this->{'field_obj'}{$this->{'field_for'}{'key'}}->name . '' : '') . ']</option>';
print '<option value="&lt;title&gt;">&lt;title&gt;[ȥե' . (($this->{'field_for'}{'title'} && ref $this->{'field_obj'}{$this->{'field_for'}{'title'}}) ? '' . $this->{'field_obj'}{$this->{'field_for'}{'title'}}->name . '' : '') . ']</option>';
print '<option value="&lt;service&gt;">&lt;service&gt;[ȼ]</option>';
print '<option value="&lt;deliurl&gt;">&lt;deliurl&gt;[ȼԤURL]</option>';
print '<option value="&lt;number&gt;">&lt;number&gt;[ʪֹ]</option>';
print '<option value="&lt;comment&gt;">&lt;comment&gt;[]</option>';
print '<option value="&lt;date&gt;">&lt;date&gt;[ȯ]</option>';
print '<option value="&lt;data&gt;">&lt;data&gt;[ǡΰ]</option>';
print '<option value="&lt;url&gt;">&lt;url&gt;[ǡURL]</option>';
print '<option value="&lt;input&gt;">&lt;input&gt;[ǡԽURL]</option>';
print '<option value="&lt;register&gt;">&lt;register&gt;[ɥ쥹ϿURL]</option>';
print '</select>';
print '</div></td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

print '<fieldset>';
print '<legend>ǥե</legend>';
print $this->delivery_service_menu($name . '_default',[$this->{'default'}]);
print '</fieldset>';
print '</fieldset>';

$this->print_font_setting_form($name);
$this->print_setting_save_button;
return;
}

sub print_delivery_service_setting ($$$$$;$) {
my($this,$name,$table,$id,$n,$data) = @_;
$name .= '_service_' . $id . '_';
print $table->tr;
print $table->td((ref $data) ? '<input type="checkbox" name="delete:' . $id . '" value="1" />' : '');
print $table->td('<input type="hidden" name="oldorder:' . $id . '" value="' . $n . '" /><input type="text" name="order:' . $id . '" value="' . $n . '" size="2" maxlength="2" />');
print $table->td($this->default_delivery_service_menu($name . 'service',((ref $data) ? $data->{'service'} : '')));
print $table->td('<input type="text" name="' . $name . 'name" value="' . ((ref $data) ? $this->escape($data->{'name'}) : '') . '" size="20" />');
print $table->td('<input type="text" name="' . $name . 'url" value="' . ((ref $data) ? $this->escape($data->{'url'}) : '') . '" size="30" />');
print $table->td('<input type="checkbox" name="' . $name . 'cod" value="1"' . ((ref $data && $data->{'cod'}) ? ' checked="checked"' : '') . ' />') if $setting::payment{'codenabled'};
print $table->_tr;
}

sub default_delivery_service_menu ($$$$;$$) {
my($this,$name,$service) = @_;
my($s,$form);
$form .= '<select name="' . $name . '">';
$form .= '<option value=""></option>';
foreach $s (sort keys %SCOrderShippingInfo::url) {
	$form .= '<option value="' . $this->escape($s) . '"' . (($service && $service eq $s) ? ' selected="selected"' : '') . '>' . $this->escape($s) . '</option>';
}
$form .= '<option value=""' . (($service && $s && $service eq $s) ? ' selected="selected"' : '') . '>¾</option>';
$form .= '</select>';
return $form;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my $is_valid = $this->is_valid_font_setting;
my($id,@services,%name_check);
foreach $id (sort {$a <=> $b} keys %main::order) {
	if (!$id) {
		$id = '0';
		delete $main::data{$this->{'id'} . '_service_' . $id . '_service'};
		delete $main::data{$this->{'id'} . '_service_' . $id . '_name'};
		delete $main::data{$this->{'id'} . '_service_' . $id . '_url'};
		delete $main::data{$this->{'id'} . '_service_' . $id . '_cod'};
	} elsif ($main::delete{$id} || (!$main::data{$this->{'id'} . '_service_' . $id . '_service'} && (!defined $main::data{$this->{'id'} . '_service_' . $id . '_name'} || $main::data{$this->{'id'} . '_service_' . $id . '_name'} eq ''))) {
		$main::data{$this->{'id'} . '_service_' . $id . '_service'} = "\x7F";
		$main::data{$this->{'id'} . '_service_' . $id . '_name'} = "\x7F";
		$main::data{$this->{'id'} . '_service_' . $id . '_url'} = "\x7F";
		$main::data{$this->{'id'} . '_service_' . $id . '_cod'} = "\x7F";
	} else {
		push(@services,$id);
		$this->tag_fix(\$main::data{$this->{'id'} . '_service_' . $id . '_name'});
		if ($main::data{$this->{'id'} . '_service_' . $id . '_name'} ne '' && $name_check{$main::data{$this->{'id'} . '_service_' . $id . '_name'}}++) {
			push(@{$cgi::action->{'dialog'}},$main::data{$this->{'id'} . '_service_' . $id . '_name'} . 'Ȥӥ̾ϴ˻ȤƤޤ') if ref $cgi::action;
			$main::data{$this->{'id'} . '_service_' . $id . '_name'} .= '\'';
			$is_valid = 0;
		}
		$main::data{$this->{'id'} . '_service_' . $id . '_cod'} = 0 if !$main::data{$this->{'id'} . '_service_' . $id . '_cod'} || !$setting::payment{'codenabled'};
		if (defined $main::data{$this->{'id'} . '_service_' . $id . '_url'} && $main::data{$this->{'id'} . '_service_' . $id . '_url'} ne '' && $this->is_invalid_url($main::data{$this->{'id'} . '_service_' . $id . '_url'})) {
			push(@{$cgi::action->{'dialog'}},'URLޤ') if ref $cgi::action;
			delete $main::data{$this->{'id'} . '_service_' . $id . '_url'};
			$is_valid = 0;
		}
	}
}
$main::data{$this->{'id'} . '_order'} = [(sort {$main::order{$a} <=> $main::order{$b} || $main::oldorder{$b} <=> $main::oldorder{$a} || $main::order{$a} cmp $main::order{$b} || $a <=> $b} @services)];
$main::data{$this->{'id'} . '_subject'} =~ s/[\x0A\x0D]+//g if defined $main::data{$this->{'id'} . '_subject'};
$main::data{$this->{'id'} . '_mTime'} = 0 if !defined $main::data{$this->{'id'} . '_mTime'} || !$main::data{$this->{'id'} . '_mTime'};
$main::data{$this->{'id'} . '_authority'} = $this->z_to_h($main::data{$this->{'id'} . '_authority'},'euc') if defined $main::data{$this->{'id'} . '_authority'} && $main::data{$this->{'id'} . '_authority'};
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
return $is_valid;
}

######################################################################
#	(6) obj->search_form;
sub search_form ($) {
my $this = shift;
my($form);
$form = '<tr class="tbody-end"><td class="field-name"><span class="datatitle">' . $this->{'name'} . '</span></td><td class="field">';
$form .= $this->delivery_service_menu('search:' . $this->{'id'} . ':service',[$main::search{$this->{'id'}}{'service'}],0,1);
$form .= $this->mk_select_menu(
	'search:' . $this->{'id'} . ':shipped','','',$main::search{$this->{'id'}}{'shipped'},
	''		=>		'',
	'false'	=>		'̤в',
	'true'	=>		'вٺ'
);
$form .= '<input type="text" name="search:' . $this->{'id'} . ':number" id="search:' . $this->{'id'} . ':number" size="16" value="' . $this->escape($main::search{$this->{'id'}}{'number'}) . '" title="ʪֹ" />';
$form .= '</td></tr>';
return $form;
}

######################################################################
#	(11) obj->update;
sub update_enabled ($) {
my $this = shift;
return 1;
}

sub is_secure_user_for_edit ($) {
my $this = shift;
return 0;
}

sub _update_error ($$) {
my($this,$is_ajax) = @_;
return ($is_ajax) ? {
	'status'			=>	'error',
	'error_fields'		=>	$this->get_invalid_field_list('ship'),
	'message'			=>	$this->get_message_string,
	'authorized_level'	=>	$this->get_authorized_level
} : 0;
}

sub update ($;$) {
my($this,$is_ajax) = @_;
my(%db,$time,$c,$n,$db,$content);
$this->save_update_target;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
if (!$this->is_secure_user) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : '') . '򹹿ǤޤǤ¤ޤ');
	return $this->_update_error($is_ajax);
}
if (!$main::ship{'shipped'}) {
	push(@{$cgi::action->{'dialog'}},'ֽвٴλץܥ򲡤Ƥ') if ref $cgi::action;
	return $this->_update_error($is_ajax);
}
if ($main::ship{'number'} =~ /\W/) {
	$this->{'is_invalid_field'}{'number'} = 1;
	push(@{$cgi::action->{'dialog'}},'ʪֹ˱ѿʳʸ󤬴ޤޤƤޤ') if ref $cgi::action;
	return $this->_update_error($is_ajax);
}
$db = $default::db . '/' . $main::c;
$n = $main::n;
$c = $main::c;
$this->detag(\$main::ship{'comment'});
$main::ship{'comment'} =~ s/\s+\Z//s;
$time = time;
$env::dbm_file = 'AnyDBM_File' if !defined $env::dbm_file ||  $env::dbm_file eq '';
$env::dbm_mode = 0666 if !defined $env::dbm_mode ||  $env::dbm_mode eq '';
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
tie(%db, $env::dbm_file, $db . '/shipping', O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %db) {
	$main::ship{'service'} = $1 if $db{$n} =~ /^([^\t]+)/;
	$main::ship{'service'} = (@{$this->{'order'}} && @{$this->{'order'}} == 1 && defined $this->{'order'}[0] && $this->{'order'}[0] ne '') ? ($this->{'service'}{$this->{'order'}[0]}{'name'}) ? $this->{'service'}{$this->{'order'}[0]}{'name'} : $this->{'service'}{$this->{'order'}[0]}{'service'} : '' if !$main::ship{'service'};
	$main::ship{'number'} = '' if !defined $main::ship{'number'};
	$main::ship{'comment'} = '' if !defined $main::ship{'comment'};
	if ($main::ship{'service'}) {
		$db{$n} = join("\x09",$main::ship{'service'},$main::ship{'number'},$time,$main::ship{'comment'});
		$content = $this->shipping_info($main::ship{'service'},$main::ship{'number'},$time,$main::ship{'comment'}) if $is_ajax;
	} else {
		untie %db;
		$this->{'is_invalid_field'}{'service'} = 1;
		push(@{$cgi::action->{'dialog'}},'ȼԤꤵƤޤ') if ref $cgi::action;
		return $this->_update_error($is_ajax);
	}
} else {
	untie %db;
	push(@{$cgi::action->{'dialog'}},'顼\nǡ١˥ǤޤǤ') if ref $cgi::action;
	return $this->_update_error($is_ajax);
}
untie %db;

#Υ᡼
if (ref $this->{'mailto'} && @{$this->{'mailto'}}) {
	my(@mailto);
	foreach (@{$this->{'mailto'}}) {
		my(%mail);
		tie(%mail, $env::dbm_file, $db . '/' . $_, O_RDONLY, $env::dbm_mode);
		push(@mailto,$this->get_address($mail{$n})) if defined $mail{$n} && $mail{$n};
		untie(%mail);
	}
	if (@mailto) {
		my($subject,$msg,$name,$bcc,$register_url,$script_name,$deliurl,$url,$input,$date);
		$subject = ($this->{'subject'}) ? $this->{'subject'} : 'ʸʤȯޤ';
		$msg = ($this->{'msg'}) ? $this->{'msg'} : 'ʸʤȯޤ' . "\x0A" . '<url>';
		$subject =~ s/<service>/$main::ship{'service'}/igs;
		$msg =~ s/<service>/$main::ship{'service'}/igs;
		$subject =~ s/<comment>/$main::ship{'comment'}/igs;
		$msg =~ s/<comment>/$main::ship{'comment'}/igs;
		$subject =~ s/<number>/$main::ship{'number'}/igs;
		$msg =~ s/<number>/$main::ship{'number'}/igs;
		$deliurl = $this->service_url($main::ship{'service'},$main::ship{'number'});
		$msg =~ s/<deliurl>/$deliurl/igs;
		$date = $this->date($time,3,$this->{'datetype'} . 'gmt<d');
		$msg =~ s/<date>/$date/igs;
		if ($subject =~ /<name>/i || $msg =~ /<name>/i) {
			$name = ($default::english) ? 'you' : 'ʤ';
			if (defined $this->{'field_for'}{'name'} && $this->{'field_for'}{'name'}) {
				my(%name);
				tie(%name, $env::dbm_file, $db . '/' . $this->{'field_obj'}{$this->{'field_for'}{'name'}}->db, O_RDONLY, $env::dbm_mode);
				$name = $name{$n} if defined $name{$n} && $name{$n} ne '';
				untie(%name);
			}
			$subject =~ s/<name>/$name/igs;
			$msg =~ s/<name>/$name/igs;
		}
		if ($subject =~ /<key>/i || $msg =~ /<key>/i) {
			my $key = ($default::english) ? 'this' : '';
			if (defined $this->{'field_for'}{'key'} && $this->{'field_for'}{'key'}) {
				my(%key);
				tie(%key, $env::dbm_file, $db . '/' . $this->{'field_obj'}{$this->{'field_for'}{'key'}}->db, O_RDONLY, $env::dbm_mode);
				$key = $key{$n} if defined $key{$n} && $key{$n} ne '';
				untie(%key);
			}
			$subject =~ s/<key>/$key/igs;
			$msg =~ s/<key>/$key/igs;
		}
		if ($subject =~ /<title>/i || $msg =~ /<title>/i) {
			my $title = ($default::english) ? 'this' : '';
			if (defined $this->{'field_for'}{'title'} && $this->{'field_for'}{'title'}) {
				my(%title);
				tie(%title, $env::dbm_file, $db . '/' . $this->{'field_obj'}{$this->{'field_for'}{'title'}}->db, O_RDONLY, $env::dbm_mode);
				$title = $title{$n} if defined $title{$n} && $title{$n} ne '';
				untie(%title);
			}
			$subject =~ s/<title>/$title/igs;
			$msg =~ s/<title>/$title/igs;
		}
		if ($msg =~ /<data>/i) {
			my($list,$file_dir);
			$file_dir = "$default::file/$c/$n";
			foreach my $id (sort {$this->{'field_obj'}->{$a}->{'ORDER'} <=> $this->{'field_obj'}->{$b}->{'ORDER'} || $a <=> $b} keys %{$this->{'field_obj'}}) {
				next if !$this->{'field_obj'}{$id}->format_for_mail_enabled;
				my(%data);
				tie(%data, $env::dbm_file, $db . '/' . $this->{'field_obj'}{$id}->db, O_RDONLY, $env::dbm_mode);
				$list .= $this->{'field_obj'}{$id}->format_for_mail($data{$n},$file_dir,$c,$n);
				untie(%data);
			}
			$msg =~ s/<data>/$list/igs;
		}
		$script_name .= $this->my_url;
		$url = $script_name . '?m=DetailViewer&k=detail&c=' . $main::c . '&n=' . $main::n;
		$msg =~ s/<url>/$url/igs;
		$input = $script_name . '?m=Input&k=input&c=' . $main::c . '&n=' . $main::n;
		$msg =~ s/<input>/$input/igs;
		$register_url = $this->http_my_domain . $this->path_change($env::register_cgi,$ENV{'SCRIPT_NAME'},'abs');
		$msg =~ s/<register>/$register_url/igs;
		unless (ref $cgi::SendMail) {
			require CMONOS::CGI_Lib::SendMail;
			$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
		}
		foreach (@mailto) {
			$bcc .= ',' if defined $bcc && $bcc ne '';
			$bcc .= ($name && $name ne 'you' && $name ne 'ʤ') ? $name . ' <' . $_ . '>' : $_;
		}
		$cgi::SendMail->send_mail(
			'Bcc'		=>  $bcc,
			'From'		=>  (($setting::general{'master'}) ? (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}) : $env::master_email),
			'Subject'	=>  $subject,
			'message'	=>  $msg . "\x0A\x0A",
			'info'		=>  0
		);
	}
}
undef %main::ship;
$this->post_update;
if ($is_ajax) {
	return {
		'status'			=>	'success',
		'form'				=>	(($content) ? $content : ''),
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level
	};
} else {
	return 0;
}
}

sub editor_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	CMONOS::CGI_Lib::UserGeneratedField Υԡ
sub get_invalid_field_list ($$) {
my($this,$prefix) = @_;
return '' if !defined $this->{'is_invalid_field'} || !ref $this->{'is_invalid_field'};
my @invalid_fields = map {$prefix . ':' . $_} keys %{$this->{'is_invalid_field'}};
delete $this->{'is_invalid_field'};
return (@invalid_fields) ? join(';',@invalid_fields) : '';
}

sub get_message_string ($) {
my $this = shift;
if (ref $cgi::action) {
	my @message = $cgi::action->dialog;
	if (@message) {
		map {
			$_ =~ s/\\n//g;
			$_ =~ s/;//g;
		} @message;
		return join(';',@message);
	}
}
return '';
}

sub get_authorized_level ($) {
my $this = shift;
if ($this->is_master) {
	return 4;
} elsif ($this->is_owner) {
	return 3;
} elsif ($this->is_one_of_owners) {
	return 2;
} elsif ($this->is_registered_user) {
	return 1;
} else {
	return 0;
}
}

######################################################################
#sub import {
BEGIN {
#no warnings qw(once);
if (defined $default::type && $default::type eq 'order' && defined $env::checkout && $env::checkout && !$setting::field_for_mail) {
	Field::class_register('yorder_shipping','SCOrderShippingInfo','');
	push(@field::redundancy_forbidden,'yorder_shipping');
}
}

1;
