package GMapViewer;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
######################################################################
# Googleޥåɽ⥸塼
# GMapViewer.pm ver1.0.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-03-22
######################################################################
# ᥤ
sub run ($) {
my $this = shift;
my($title,$has_coordinates,$search_form,$sc,$gmap_url);


#---------------------------------------------------------------------
#ǧԤܷٹ
$this->set_pending_item_alert if !defined $main::mod && !defined $main::w && !defined $main::s && $this->is_secure('tools');

$this->replace_category_list;

#ܺپ
$has_coordinates = (defined $field::for{'coordinates'} && ref $field::obj{$field::for{'coordinates'}} && $field::obj{$field::for{'coordinates'}}->{'class'} && $field::obj{$field::for{'coordinates'}}->{'class'} eq 'webapi_gmap') ? 1 : 0;
foreach (sort {$a <=> $b} keys %field::ORDER) {
	my $id = $field::ORDER{$_};
	if (!$has_coordinates && $field::obj{$id}->{'class'} eq 'webapi_gmap') {
		$field::for{'coordinates'} = $id;
		$has_coordinates = 1;
	}
	next unless ref $field::obj{$id} && !$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret')) && $field::obj{$id}->{'searchEnabled'} && $field::obj{$id}->search_form_enabled && $field::for{'coordinates'} ne $id;
	$search_form .= $field::obj{$id}->search_form;
	$sc++;
}

#Բ
if (!$has_coordinates) {
	$this->print_viewer_header;
	print '<p>ɸեɤߤĤʤᡢGoogleޥåפɽ뤳ȤǤޤ</p>';
	$this->print_viewer_footer;
	exit;
} elsif ($sc && $setting::page{'gmap'}{'floatingSearchFormEnabled'}) {
my $javascript = <<JAVASCRIPT;
cmonos.tool.gmapviewer = {
	floatingSearchForm : function () {
		var search_form = document.getElementById('search-form');
		if (search_form) {
			search_form.className = 'floating-search-form';
			search_form.style.position = (navigator.userAgent.indexOf("MSIE") != -1 && typeof document.documentElement.style.msInterpolationMode == "undefined") ? "absolute" : "fixed";
			var user_position = cmonos.document.getCookie("SEARCH_BOX_POSITION").split(/,/);
			if (user_position.length == 2) {
				search_form.style.left = (parseInt(user_position[0]) > 0) ? user_position[0] : 0;
				search_form.style.top = (parseInt(user_position[1]) > 0) ? user_position[1] : 0;
			} else {
				search_form.style.left = 120 + 'px';
				search_form.style.top = 120 + 'px';
			}
			var set_draggable = function () {
				cmonos.element.item(search_form).draggable(
					{
						endeffect	:	function(e) {
							cmonos.document.setCookie('SEARCH_BOX_POSITION',e.style.left + ',' + e.style.top);
						}
					}
				);
			};
			for (var i=0; i < search_form.elements.length; i++) {
				if (search_form.elements[i].type) {
					cmonos.element.item(search_form.elements[i]).addEventListener('mousedown',function(e) { cmonos.element.clearDraggable().dragDisabled(); });
					cmonos.element.item(search_form.elements[i]).addEventListener('mouseup',function(e) { cmonos.element.dragEnabled(); });
					cmonos.element.item(search_form.elements[i]).addEventListener('blur',function(e) { cmonos.element.dragEnabled(); });
				}
			}
			document.getElementById('search-legend').innerHTML = '<a href="javascript:void(0)" id="toggle-search-box" onclick="cmonos.tool.gmapviewer.toggleSearchForm(); return false;" title="ޤ" class="closebox">[-]</a> ' + document.getElementById('search-legend').innerHTML;
			if (cmonos.document.getCookie("SEARCH_BOX_MINIMIZED") == "true") this.toggleSearchForm();
			set_draggable();
		}
	},

	toggleSearchForm : function () {
		var toggle_button = document.getElementById('toggle-search-box');
		if (document.getElementById('search-field-table').style.display == null || document.getElementById('search-field-table').style.display != 'none') {
			document.getElementById('search-field-table').style.display = 'none';
			toggle_button.innerHTML = '[+]';
			toggle_button.title = '';
			toggle_button.className = 'openbox';
			cmonos.document.setCookie('SEARCH_BOX_MINIMIZED','true');
		} else {
			document.getElementById('search-field-table').style.display = '';	
			toggle_button.innerHTML = '[-]';
			toggle_button.title = 'ޤ';
			toggle_button.className = 'closebox';
			cmonos.document.setCookie('SEARCH_BOX_MINIMIZED','false');
		}
	}
}
JAVASCRIPT
	$this->set_javascript($javascript);
	$this->set_onload('cmonos.tool.gmapviewer.floatingSearchForm();');
}

#
my @favorites;
if ($main::fv && $this->favorites_enabled) {
	@favorites = grep($_ ne '' && $_ !~ /\D/,split(/,/,$this->read_cookie_direct('favorites')));
	$this->{'has_favorites'} = 1 if @favorites;
}

#ڡإå
$this->print_viewer_header;
$this->print_toolbox_top;


#---------------------------------------------------------------------
#ܺ٤򳫤ɥ
#ǥեȹܤΤ߾󥦥ɥɽ
my($window_width,$window_height);
my $same_window = 0;
if ($this->{'has_template'}) {
	while ($setting::page{$setting::key}{'template'} =~ /<!--field\s[^>]*id="([^>"]+)"[^>]*-->/g) {
		my $id = $1;
		if (ref $field::obj{$id} && $field::obj{$id}{'class'} eq 'xtm_detail') {
			if ($field::obj{$id}{'sameWindow'}) {
				$same_window = 1;
			} else {
				$window_width = $field::obj{$id}{'windowWidth'} if $field::obj{$id}{'windowWidth'};
				$window_height = $field::obj{$id}{'windowHeight'} if $field::obj{$id}{'windowHeight'};
			}
			last;
		}
	}
} else {
	foreach my $o (sort {$a <=> $b} keys %field::ORDER) {
		my $id = $field::ORDER{$o};
		if (ref $field::obj{$id} && $field::obj{$id}{'class'} eq 'xtm_detail') {
			if ($field::obj{$id}{'sameWindow'}) {
				$same_window = 1;
			} else {
				$window_width = $field::obj{$id}{'windowWidth'} if $field::obj{$id}{'windowWidth'};
				$window_height = $field::obj{$id}{'windowHeight'} if $field::obj{$id}{'windowHeight'};
			}
			last;
		}
		next unless ref $field::obj{$id} && !$field::obj{$id}->{'Hidden'} && $field::obj{$id}->{'Default'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret'));
		next if grep($_ eq $id,@{$this->{'selectedField'}});
		push(@{$this->{'selectedField'}},$id);
	}
}


#---------------------------------------------------------------------
#GoogleޥåϿ
$gmap_url = $this->escape(
	$env::javascript . '/gmap.html?' . $this->url_encoded_query(
		{
			(($env::google_maps_api_key) ? ('key' => $env::google_maps_api_key) : ()),
			'z'				=>	(($setting::page{$setting::key}{'z'}) ? $setting::page{$setting::key}{'z'} : 4),
			't'				=>	(($setting::page{$setting::key}{'t'}) ? $setting::page{$setting::key}{'t'} : ''),
			'c'				=>	(($setting::page{$setting::key}{'c'}) ? $setting::page{$setting::key}{'c'} : '36.315125,137.504883'),
			((!$setting::page{$setting::key}{'refreshDisabled'}) ? ('r' => 1) : ()),
			'sf' => 'search-form',
			'i' => '1',
			'ns' => '1',
			(($setting::page{$setting::key}{'gmapWidth'}) ? ('width' => $setting::page{$setting::key}{'gmapWidth'}) : ()),
			(($setting::page{$setting::key}{'gmapHeight'}) ? ('height' => $setting::page{$setting::key}{'gmapHeight'}) : ()),
			(($setting::page{$setting::key}{'gmapOverView'}) ? ('om' => 1) : ()),
			(($setting::page{$setting::key}{'gmapStreetView'}) ? ('sv' => 1) : ()),
			(($setting::page{$setting::key}{'gmapSearch'}) ? ('s' => 1) : ()),
			(($same_window) ? ('tr' => 'p') : ($setting::page{$setting::key}{'gmapLinkTarget'}) ? ('tr' => $setting::page{$setting::key}{'gmapLinkTarget'}) : ('tr' => 'd')),
			(($setting::page{$setting::key}{'gmapMaxWidth'}) ? ('mw' => $setting::page{$setting::key}{'gmapMaxWidth'}) : ()),
			(($setting::page{$setting::key}{'placeListEnabled'}) ? ('lb' => 'list-box','li' => 'list') : ()),
			(($window_width) ? ('dw' => $window_width) : ()),
			(($window_height) ? ('dh' => $window_height) : ()),
		}
	)
);
print '<iframe class="gmap-index" id="gmap-viewer"';
print ' src="' . $gmap_url . '"';
print ' width="' . (($setting::page{'gmap'}{'gmapWidth'}) ? $setting::page{'gmap'}{'gmapWidth'} : 400) . '"';
print ' height="' . (($setting::page{'gmap'}{'gmapHeight'}) ? $setting::page{'gmap'}{'gmapHeight'} : 400) . '"';
print ' scrolling="no" marginwidth="0" marginheight="0" frameborder="0">';
print '<a href="' . $gmap_url . '" target="_blank">ɥϿޤ򳫤</a>';
print '</iframe>';

#---------------------------------------------------------------------
#ɽܤΥꥹ
if ($setting::page{$setting::key}{'placeListEnabled'}) {
	print '<div id="list-box" class="section box"><ul id="list"></ul></div>'
}

#---------------------------------------------------------------------
#ե
my @form = grep($_ ne 'm' && $_ ne 'k' && $_ ne 'search' && $_ ne 'and',@setting::form);
print $this->form_start(
	'action'	=>	$this->my_url,
	'key'		=>	'browse',
	'id'		=>	'search-form',
	'name'		=>	'search-form',
	'required'	=>	\@form
);
print '<input type="hidden" name="m" value="GMapViewer" alt="KMLViewer" />';
print '<input type="hidden" name="fav" value="' . join(',',@favorites) . '" />' if @favorites;	
if ($sc) {
	print '<fieldset id="search"><legend id="search-legend">' . (($default::english) ? 'Search' : '') . '</legend>';
	print '<table class="field-table" id="search-field-table"><tbody>';
	print $search_form;
	print '<tr class="tbody-start">';
	print '<td class="reset-box"><input type="button" value="' . (($default::english) ? 'Reset' : 'ꥻå') . '" onclick="cmonos.form.item(this.form).resetAll(\'search:\')" /></td>';
	print '<td class="submit-box">';
	if ($sc > 1) {
		print '<select name="and">';
		print '<option value="1">' . (($default::english) ? 'Matches on all requirements' : 'Ƥξ˰') . '</option>';
		print '<option value="0"' . ((!$main::and) ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Matches on any requirements' : '줫ξ˰') . '</option>';
		print '</select>';
	}
	print '<input type="submit" value="' . (($default::english) ? 'Search' : '') . '" />';
	print '</td></tr></tbody></table></fieldset>';
}
print '</form>';


#---------------------------------------------------------------------
#ڡեå
$this->print_toolbox_bottom;
$this->print_page_return_form;
$this->print_viewer_footer;

}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;					#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 1;						#ơ֥ɤ߹
	$setting::page = 1;						#ڡɤ߹

	$setting::field_db_name = 'inputfield';	#եDB
	$setting::field = 2;						#եɤ߹ߡ2=ꥸʥɤ߹
	$setting::field_style_disabled = 2;			#2=եꥹ̵/1=եΤ̵
	$setting::field_tag_enabled = 'no';				#tag=Τ/all=Ƥ/no=Ĥʤ

	#省
	$setting::security_key = 'browse';							#ǥեȥƥ
	$setting::key = 'gmap';						#ڡꥭ

	#å
	$cookie::id_enabled = 1;							#ID󥯥åɤ߹

	#ǥեȥ
	$main::k = 'gmap' if !defined $main::k || !$main::k;

	#ɬܥե
	@setting::form = ('k','m','c','f','u','uni','s','w','mod','and','search','q','fv') if !@setting::form;
	$main::mod = $main::m;

	#饹Ͽ
	Common::class_register('gmap','GMapViewer');

	#᡼CSS
	$setting::image_css = 'tablemaker-image.css';

}

1;
