package InputBase;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
######################################################################
# ǡϴܥ⥸塼
# InputBase.pm ver1.0.8
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-08-11
######################################################################
# ᥤ
sub run ($) {
my $this = shift;
$this->gc_download_directory if $default::type && $default::type eq 'order';
$main::a = '' if !defined $main::a;
if (defined $main::record_id && $main::record_id && $main::record_id !~ /\D/) {
	$main::c = int($main::record_id / 1000000);
	$main::n = $main::record_id - ($main::c * 1000000);
}
$main::c = '' if !defined $main::c || $main::c =~ /\D/;
$main::n = '' if !defined $main::n || $main::n =~ /\D/;
if ($main::rewind) {
	$main::rewind =~ s/\D//g;
	undef $main::rewind if !defined $main::n || $main::n eq '' || $main::a eq 'w' || !$main::rewind || !-d "$default::file/$main::c/$main::n/archives.pending/$main::rewind";
}
$field::obj{$field::for{'mail'}}->{'required'} = 1 if $default::type && $default::type eq 'order' && $field::for{'mail'} && ref $field::obj{$field::for{'mail'}};
use Fcntl qw(:DEFAULT :flock);
eval 'use ' . $env::dbm_file . ';';

#ƥ꡼ɤ߹
$this->import_db($default::preference_dir . '/category',\%setting::category,1);
$setting::category{'LIMIT'} = 2000 if !defined $setting::category{'LIMIT'} || !$setting::category{'LIMIT'};

#ƥ꡼
if ((!defined $main::c || $main::c eq '') && (!ref $setting::category{'ORDER'} || !%{$setting::category{'ORDER'}} || (keys %{$setting::category{'ORDER'}}) <= 1)) {
	$main::c = 1;
	if (!ref $setting::category{$main::c} || !%{$setting::category{$main::c}}) {
		$this->mk_category($main::c);
	} else {
		$this->set_dir("$default::db/1");
		$this->set_dir("$default::file/1");
	}
}

#
$this->get_order_info if $default::type && $default::type eq 'order' && defined $main::c && $main::c ne '' && defined $main::n && $main::n ne '';

$this->allocate_category if $main::c eq '' || !ref $setting::category{$main::c};
$this->update;

#ڡإå
$this->print_page_header($setting::key);
$this->print_contents_header;

#ե
print $this->form_start(
	'key'		=>	$setting::key,
	'name'		=>	'input',
	'multi'		=>	$cgi::enctype_multipart,
	'method'	=> 'post',
	'onsubmit'	=> 'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="w" />';

#եǼǥ쥯ȥ
my $path = "$default::file/$main::c/$main::n";

print '<table class="field-table"><tbody>';
my $top_field = $this->top_field;
if ($top_field && ref $field::obj{$top_field}) {
	print $field::obj{$top_field}->form($main::n,'',$path);
	print '</tbody><tbody>';
}
foreach my $o (sort {$a <=> $b} keys %field::ORDER) {
	my $id =  $field::ORDER{$o};
	next if $top_field && $top_field == $id;
	if (ref $field::obj{$id}) {
		my $field = $field::obj{$id};
		if ((defined $main::n && $main::n ne '') || ($field->{'class'} ne 'user_xtime' && $field->{'class'} ne 'xtm_checker')) {
			if ($field->{'protected'} && (
					(defined $main::n && $main::n ne '' && !$this->is_secure('reviseProtectedFields',0,'revise'))
					 || ((!defined $main::n || $main::n eq '') && !$this->is_secure('inputProtectedFields',0,'input'))
				)) {
				next;
			} elsif (!$field->has_content($main::data{$id}) && $this->is_skip_field($field)) {
				next;
			} elsif ($this->is_reserved_field($field)) {
				$field->print_confirmation_form_table_row($path,$main::c,$main::n);
			} else {
				print $field->form($main::n,'',$path);
			}
		}
	}
}
print '</tbody>';
$this->print_submit_button_in_table;
print '</table>';
$this->print_submit_button;
print '</form>';
$this->print_contents_footer;
$this->print_page_footer($setting::key);
}

sub top_field ($$) {
my $this = shift;
}

sub get_order_info ($) {
my $this = shift;
}

sub is_skip_field ($$) {
my $this = shift;
return 0;
}

sub is_skippable_field ($$) {
my($this,$field) = @_;
return ($default::type && $default::type eq 'order' && $field->{'skippable'} && $field->input_enabled && $field->{'class'} !~ /^(?:ug|xtm|yorder)_/ && (!$field->{'field_for'}{'mail'} || $field->{'field_for'}{'mail'} ne $field->{'id'})) ? 1 : 0;
}

sub is_reserved_field ($$) {
my $this = shift;
return 0;
}

sub allocate_category ($) {
my $this = shift;
}

sub update ($) {
my $this = shift;
}

sub print_contents_header ($) {
my $this = shift;
}

sub print_submit_button_in_table ($) {
my $this = shift;
}

sub print_submit_button ($) {
my $this = shift;
}

sub input_is_valid ($) {
my $this = shift;
my $is_valid = 1;

#ϥå
foreach my $o (sort {$a <=> $b} keys %field::ORDER) {
	my $id = $field::ORDER{$o};
	if (
			ref $field::obj{$id}
		 && (
					!$field::obj{$id}->{'protected'}
				 || (defined $main::n && $main::n ne '' && $this->is_secure('reviseProtectedFields',0,'revise'))
				 || ((!defined $main::n || $main::n eq '') && $this->is_secure('inputProtectedFields',0,'input'))
			)
		 && (
				$field::obj{$id}->has_content($main::data{$id})
			 || !$this->{'digital_content_only'}
			 || !$this->is_skippable_field($field::obj{$id})
			)
	) {
		$is_valid = 0 if !$field::obj{$id}->is_valid_data(($main::n ne '') ? "$default::file/$main::c/$main::n" : '');
	}
}

#Ϣ³å
if ($main::n eq '' && $setting::general{'ipStopper'} && $setting::general{'latest'}) {
	my($mtime,$ip) = split(/:/,$setting::general{'latest'});
	if ($ip && $mtime && $ip eq $this->to_host($ENV{'REMOTE_ADDR'}) && time - $mtime <= $setting::general{'ipStopper'}) {
		push(@{$this->{'dialog'}},'Ϣ³ޤΤϢ³¤Ƥޤ꤬ʤϡФ餯Ƥ⤦ʤƤ');
		$is_valid = 0;
	}
}
return $is_valid;
}

sub print_confirmation_table ($$) {
my($this,$button_required) = @_;
print $this->form_start(
	'key'	=>	$setting::key,
	'name'	=>	'input',
	'method'	=> 'post',
	'onsubmit'	=> 'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="set_cookie" value="1" />' if $cookie::enabled && $main::set_cookie;
print '<input type="hidden" name="a" value="w" />';
print '<table class="field-table"><tbody>';
my $path = "$default::file/$main::c/$main::n";
foreach my $o (sort {$a <=> $b} keys %field::ORDER) {
	my $id = $field::ORDER{$o};
	if (
			ref $field::obj{$id}
		 && defined $main::data{$id}{'str'}
		 && ((defined $main::n && $main::n ne '') || $field::obj{$id}->{'class'} ne 'user_xtime')
		 && (
					!$field::obj{$id}->{'protected'}
				 || (defined $main::n && $main::n ne '' && $this->is_secure('reviseProtectedFields',0,'revise'))
				 || ((!defined $main::n || $main::n eq '') && $this->is_secure('inputProtectedFields',0,'input'))
			)
	) {
		$field::obj{$id}->print_confirmation_form_table_row($path,$main::c,$main::n);
	}
}
print '</tbody>';
print '<tbody><tr class="tbody-start"><td class="submit-box" colspan="2"><input type="submit" name="cancel=1" value="' . (($default::english) ? 'Cancel' : '󥻥') . '" class="cancel" /><input type="submit" name="ok=1" value="' . (($default::english) ? 'OK' : '') . '" class="save" /></td></tr></tbody>' if $button_required;
print '</table>';
$this->print_confirmation_button;
print '</form>';
}

sub print_confirmation_button ($) {
my $this = shift;
}

sub print_checkout_button ($) {
my $this = shift;
}

sub thanks ($;$) {
my($this,$closebutton_only) = @_;
my($list,$record,$url,$script_name,$input,$register_url,%thanks,$key,$name,$title);
if ($field::for{'name'} && defined $main::data{$field::for{'name'}}{'str'} && $main::data{$field::for{'name'}}{'str'} ne '') {
	$name = $field::obj{$field::for{'name'}}->format_for_text($main::data{$field::for{'name'}}{'str'});
} else {
	$name = '';
}
if ($field::for{'key'} && defined $main::data{$field::for{'key'}}{'str'} && $main::data{$field::for{'key'}}{'str'} ne '') {
	$key = $field::obj{$field::for{'key'}}->format_for_text($main::data{$field::for{'key'}}{'str'});
} else {
	$key = '';
}
if ($field::for{'title'} && defined $main::data{$field::for{'title'}}{'str'} && $main::data{$field::for{'title'}}{'str'} ne '') {
	$title = $field::obj{$field::for{'title'}}->format_for_text($main::data{$field::for{'title'}}{'str'});
} else {
	$title = '';
}

#Ϥɤ߹
$this->import_db($default::preference_dir . '/thanks',\%thanks);

#ưֿ᡼
$record = $main::c * 1000000 + $main::n;
$script_name .= $this->my_url;
$url = $script_name . '?m=DetailViewer&k=detail&c=' . $main::c . '&n=' . $main::n;
$register_url = $this->http_my_domain . $this->path_change($env::register_cgi,$ENV{'SCRIPT_NAME'},'abs');
$input = $script_name . '?m=Input&k=input&c=' . $main::c . '&n=' . $main::n;
if ($thanks{'resmsg'} && $field::for{'mail'} && ref $field::obj{$field::for{'mail'}} && $field::obj{$field::for{'mail'}}->{'e-mail'} && $field::obj{$field::for{'mail'}}->{'class'} =~ /email/ && $main::data{$field::for{'mail'}}{'str'}) {
	$thanks{'resmsg'} =~ s/<name>/$name/igs;
	$thanks{'ressubject'} =~ s/<name>/$name/igs;
	$thanks{'resmsg'} =~ s/<key>/$key/igs;
	$thanks{'ressubject'} =~ s/<key>/$key/igs;
	$thanks{'resmsg'} =~ s/<title>/$title/igs;
	$thanks{'ressubject'} =~ s/<title>/$title/igs;
	if ($thanks{'resmsg'} =~ /<data>/i) {
		$list = $this->data_for_notice_mail(\%field::obj,\%main::data);
		$thanks{'resmsg'} =~ s/<data>/$list/igs;
	}
	$thanks{'ressubject'} =~ s/<record>/$record/igs;
	$thanks{'resmsg'} =~ s/<record>/$record/igs;
	$thanks{'resmsg'} =~ s/<url>/$url/igs;
	$thanks{'resmsg'} =~ s/<input>/$input/igs;
	$thanks{'resmsg'} =~ s/<register>/$register_url/igs;
	unless (ref $cgi::SendMail) {
		require CMONOS::CGI_Lib::SendMail;
		$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
	}
	$cgi::SendMail->send_mail(
		'Bcc'		=>  (($main::data{$field::for{'name'}}{'str'}) ? $main::data{$field::for{'name'}}{'str'} . ' <' . $main::data{$field::for{'mail'}}{'str'} . '>' : $main::data{$field::for{'mail'}}{'str'}),
		'From'		=>  (($setting::general{'master'}) ? (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}) : $env::master_email),
		'Subject'	=>  $thanks{'ressubject'},
		'message'	=>  $thanks{'resmsg'} . "\x0A\x0A",
		'info'		=>	0
	);
	undef $thanks{'resmsg'};
	undef $thanks{'ressubject'};
}

#񤭹ߤ
$thanks{'thankstitle'} =~ s/<name>/$name/igs;
$thanks{'thanks'} =~ s/<name>/$name/igs;
$thanks{'thankstitle'} =~ s/<key>/$key/igs;
$thanks{'thanks'} =~ s/<key>/$key/igs;
$thanks{'thankstitle'} =~ s/<title>/$title/igs;
$thanks{'thanks'} =~ s/<title>/$title/igs;
if (defined $thanks{'thanks'} && $thanks{'thanks'} =~ /<data>/i) {
	$list = $this->data_for_notice_mail(\%field::obj,\%main::data) if !defined $list || !$list;
	$this->escape(\$list);
	$thanks{'thanks'} =~ s/<data>/$list/igs;
}
$thanks{'thankstitle'} =~ s/<record>/$record/igs;
$thanks{'thanks'} =~ s/<record>/$record/igs;
$thanks{'thanks'} =~ s/<url>/$url/igs;
$thanks{'thanks'} =~ s/<input>/$input/igs;
$thanks{'thanks'} =~ s/<register>/$register_url/igs;
if (defined $thanks{'thankstitle'} && $thanks{'thankstitle'} ne '') {
	$this->push_window_title($thanks{'thankstitle'});
	$setting::page{$setting::key}{'titleText'} =~ s/((<[^>]+>)*)[^<]+/$1$thanks{'thankstitle'}/s if defined $setting::page{$setting::key}{'titleText'} && $setting::page{$setting::key}{'titleText'} ne '';
}
$this->print_page_header($setting::key);
if (defined $thanks{'thanks'} && $thanks{'thanks'} ne '') {
	$this->tag_fix(\$thanks{'thanks'},2,0,0,1);
	$this->autolink(\$thanks{'thanks'});
	print $thanks{'thanks'};
} else {
	print '<p>Ͽޤ</p>';
}
$this->print_contents_footer($closebutton_only);
$this->print_page_footer($setting::key);
exit;
}

sub print_contents_footer ($;$) {
my($this,$closebutton_only) = @_;
print '<div id="close-button">' . $this->close_button($this->{'referer_url'},$setting::page{'closeButton'},$setting::page{'backButton'},$closebutton_only) . '</div>';
}

######################################################################
# ͽ쥳ɤκ
sub gc ($) {
my $this = shift;
my(%expire,%pending,@delete,$nocount);
$nocount = 0;
tie(%expire, $env::dbm_file, "$default::db/$main::c/expire", O_RDONLY, $env::dbm_mode);
tie(%pending, $env::dbm_file, "$default::db/$main::c/pending", O_RDONLY, $env::dbm_mode);
if (ref tied %expire) {
	my $t = time;
	while (my($n,$v) = each %expire) {
		if ($v < $t) {
			push(@delete,$n);
			$nocount++ if !ref tied %pending || !$pending{$n} || $pending{$n} !~ /^1/;
		}
	}
}
untie %pending;
untie %expire;
if (@delete) {
	use File::Path;
	foreach my $n (@delete) {
		$this->delete_all_data("$default::db/$main::c",$n);
		rmtree "$default::file/$main::c/$n";
		$this->index_sweeper($main::c,$n);
	}
}
if ($nocount) {
	my(%category);
	tie(%category, $env::dbm_file, $default::preference_dir . '/category', O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %category) {
		$category{$main::c . '_total'} -= @delete if $category{$main::c . '_total'};
		$category{$main::c . '_count'} -= $nocount if $category{$main::c . '_count'};
		$setting::category{$main::c}{'total'} = $category{$main::c . '_total'} || 0;
		$setting::category{$main::c}{'count'} = $category{$main::c . '_count'} || 0;
	}
	untie %category;
	$this->write_category_list;
}
}

######################################################################
# ƥ꡼
sub mk_category ($$;$$) {
my($this,$id,$name,$order) = @_;
my(%new,$category_count);
$this->set_dir("$default::db/$id");
$this->set_dir("$default::file/$id");
$category_count = keys %{$setting::category{'ORDER'}};
if ($order && $order <= $category_count) {
	my %order = %{$setting::category{'ORDER'}};
	foreach (sort {$a <=> $b} keys %order) {
		if ($_ == $order) {
			$setting::category{$id}{'ORDER'} =  $new{$id . '_ORDER'} = $order;
			$setting::category{'ORDER'}{$order} = $new{'ORDER_' . $order} = $id;
			$setting::category{$id}{'name'} = $new{$id . '_name'} = (defined $name && $name) ? $name : $order;
		}
		if ($new{'ORDER_' . $_}) {
			my $o = $_ + 1;
			my $i = $order{$_};
			$setting::category{$i}{'ORDER'} =  $new{$i . '_ORDER'} = $o;
			$setting::category{'ORDER'}{$o} = $new{'ORDER_' . $o} = $i;
		}
	}
} else {
	$setting::category{$id}{'ORDER'} = $new{$id . '_ORDER'} = $category_count + 1;
	$setting::category{'ORDER'}{$new{$id . '_ORDER'}} = $new{'ORDER_' . $new{$id . '_ORDER'}} = $id;
	$setting::category{$id}{'name'} = $new{$id . '_name'} = (defined $name && $name) ? $name : $new{$id . '_ORDER'};
}
$this->write_db($default::preference_dir . '/category',\%new);
}

######################################################################
#ǡ١ɤ߽
sub dbm ($;$) {
my($this,$read_only) = @_;
my($flags,$dir,$filedir,$user_info);
return 1 if $setting::general{'mailonly'};

#ǥ쥯ȥ
$dir = "$default::db/$main::c";
if (!$this->set_dir($dir)) {
	push(@{$this->{'dialog'}},'ǡ١񤭹ߤ˼Ԥޤ¸ѥǥ쥯ȥ꤬¸ߤޤ');
	return;
}
$filedir = "$default::file/$main::c/$main::n";

if ((!$read_only && $main::a eq 'w') || $main::rewind) {

	#EMailǡ١˵Ͽ
#	if (defined $default::type && $default::type eq 'account' && $this->{'new_data'}) {
#		my(%email_to_id);
#		tie(%email_to_id, $env::dbm_file, $default::db . '/email_to_id', O_RDWR | O_CREAT, $env::dbm_mode);
#		if (ref tied %email_to_id) {
#			$email_to_id{$main::data{$field::for{'mail'}}{'str'}} = $main::n;
#		}
#		untie %email_to_id;
#	}

	#ν񤭹
	my(%mtime,%ctime,%ip,%agent,%general,$this_ip,$time,$last);
	$time = time;

	tie(%mtime, $env::dbm_file, $dir . '/mtime', O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %mtime) {
		$last = $mtime{$main::n};
		$mtime{$main::n} = $time;
	}
	untie %mtime;
	
	$this->{'new_record'} = 1 if $this->{'new_data'} || $time - $last > 10800;

	#ν񤭹
	tie(%ctime, $env::dbm_file, $dir . '/ctime', O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %ctime) {
		$ctime{$main::n} = $time if !$ctime{$main::n} || $this->{'new_data'};
	}
	untie %ctime;

	$this_ip = $this->to_host($ENV{'REMOTE_ADDR'});
	$user_info = $this_ip . "\x0A" . $ENV{'HTTP_USER_AGENT'} . "\x0A" . (($main::email) ? $main::email : '');
	if (!$this->{'keep_original_user_info'}) {

		#ƼIPν񤭹
		tie(%ip, $env::dbm_file, $dir . '/ip', O_RDWR | O_CREAT, $env::dbm_mode);
		if (ref tied %ip) {
			$ip{$main::n} = $this_ip;
		}
		untie %ip;

		#ƼԴĶν񤭹
		tie(%agent, $env::dbm_file, $dir . '/agent', O_RDWR | O_CREAT, $env::dbm_mode);
		if (ref tied %agent) {
			$agent{$main::n} = $ENV{'HTTP_USER_AGENT'};
		}
		untie %agent;
	}

	#̾Ͽ
	if ($field::NAMEREGISTER && $field::for{'name'} && defined $main::data{$field::for{'name'}}{'str'} && $main::data{$field::for{'name'}}{'str'} ne '' && $this->use_register) {
		my $user_name = $main::data{$field::for{'name'}}{'str'};
		if (defined $user_name && $user_name ne '') {
			$user_name =~ s/<>([#0-9a-zA-z]{3,10})\Z//s;
			$user_info .= "\x0A" . $user_name;
			$cgi::Register->user_name_register($main::pswd,$main::email,$user_name,$security::registered);
		}
	}

	#̾󹹿
	tie(%general, $env::dbm_file, $default::preference_dir . '/general', O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %general) {
		$general{'latest'} = $time . ':' . $this_ip;
		$general{'mtime'} = $time;
	}
	untie %general;
	$setting::general{'mtime'} = $time;

	#ֹ浭Ͽ
	if ($default::type && $default::type eq 'order') {
		my(%category);
		tie(%category, $env::dbm_file, $default::preference_dir . '/category', O_RDWR | O_CREAT, $env::dbm_mode);
		$category{$main::c . '_latestnumber'} = $setting::category{$main::c}{'latestnumber'} = ($category{$main::c . '_latestnumber'}) ? ($category{$main::c . '_latestnumber'} + 1) : 1 if ref tied %category;
		untie %category;
	}

	if (!$main::rewind) {

		#ե¸
		$cgi::input->fix_all_files($filedir);

		if (ref $cgi::input->{'dialog'} && @{$cgi::input->{'dialog'}}) {
			push(@{$this->{'dialog'}},@{$cgi::input->{'dialog'}});
		}
	}

	#ƥк
	local(*OUT);
	if (open(OUT, ">>$default::file/index.html")) {
		flock(OUT, LOCK_EX);
		truncate(OUT, 0);
		seek(OUT, 0, 0);
		print OUT '<html><head><meta http-equiv="Refresh" content="0; URL=' . $cgi::path . '?c=' . $main::c . '" /></head><body></body></html>';
		close(OUT);
	}

	if ($main::rewind) {
		$flags = O_RDONLY;
	} else {
		$flags = O_RDWR | O_CREAT;
	}
} else {
	$flags = O_RDONLY;
}

while (my($id,$field) = each %field::obj) {
	my $db = $field->db;
	if (defined $db && $db && (!$read_only || ($main::a eq 'w' && $field->input_enabled && !$this->is_reserved_field($field)) || !$field->input_enabled || $this->is_reserved_field($field))) {
		my %db;
		tie(%db, $env::dbm_file, $dir . '/' . $db, $flags, $env::dbm_mode);
		if (ref tied %db) {
	
			#񤭹
			if ($main::a eq 'w' && $field->input_enabled && !$this->is_reserved_field($field)) {
				if (!$field->{'protected'}
					 || (!$this->{'new_data'} && $this->is_secure('reviseProtectedFields',0,'revise'))
					 || ($this->{'new_data'} && $this->is_secure('inputProtectedFields',0,'input'))
				) {
					eval '$db{$main::n} = $main::data{$id}{\'str\'}';
					if (defined $@ && $@) {
						push(@{$this->{'dialog'}},'񤭹ߤ˼Ԥޤ(' . $field->{'name'} . ')');
					} else {
						$field->settle_up($filedir);
					}
				}

			#ɤ߹
			} elsif (!$read_only || !$field->input_enabled || $this->is_reserved_field($field)) {
				%{$main::data{$id}} = $field->elements($db{$main::n});
			}
		} elsif ($main::a && $main::a eq 'w' && !$read_only) {
			push(@{$this->{'dialog'}},'ǡ١³ǤޤǤ(' . $field->{'name'} . ')');
		}
		untie %db;
	}
}
$this->feed_db_rss($main::c,$main::n,\%main::data) if ((!$read_only && defined $main::a && $main::a eq 'w') || $main::rewind) && (!$field::for{'pending'} || !$main::data{$field::for{'pending'}}{'str'} || $main::data{$field::for{'pending'}}{'str'} !~ /^1/);

if ($setting::general{'rewindable'}) {
	my $archives_dir = $filedir . '/archives.pending'; 
	if (!$read_only && $main::a eq 'w') {
		my $current_dir = $archives_dir . '/' . $this->time_id; 
		use File::Path;
		if ($this->set_dir($archives_dir)) {
			$this->write_file(
				$archives_dir . '/.htaccess',
				'Satisfy all' . "\x0A"
					. 'order deny,allow' . "\x0A"
					. 'deny from all' . "\x0A",
				1
			);
			rmtree $current_dir if -d $current_dir;
			if ($this->set_dir($current_dir)) {
				$this->write_file(
					$current_dir . '/.htaccess',
					'Satisfy all' . "\x0A"
						. 'order deny,allow' . "\x0A"
						. 'deny from all' . "\x0A",
					1
				);
				$this->directory_copy($filedir,$current_dir,0,['^\\.','\\.(?:js|ssi|dat)$']);
				if ($this->set_dir($current_dir . '/data')) {
					$this->write_file(
						$current_dir . '/data/.htaccess',
						'Satisfy all' . "\x0A"
							. 'order deny,allow' . "\x0A"
							. 'deny from all' . "\x0A",
						1
					);
					$this->write_file(
						$current_dir . '/data/author',
						$user_info,
						1
					);
					while (my($id,$field) = each %field::obj) {
						my $db = $field->db;
						if (defined $db && $db && $db ne 'pending' && $field->input_enabled && !$field->update_enabled && !$this->is_reserved_field($field)) {
							my(%db,$data);
							tie(%db, $env::dbm_file, $dir . '/' . $db, O_RDONLY, $env::dbm_mode);
							$data = $db{$main::n} if ref tied %db;
							untie %db;
							if (defined $data) {
								$this->write_file(
									$current_dir . '/data/' . $db,
									\$data,
									1
								);
							}
						}
					}
				}
			}
		}
		$this->archives_gc($archives_dir);
	} elsif ($main::rewind && $this->is_secure('rewind')) {
		my $current_dir = $archives_dir . '/' . $main::rewind; 
		if (-d $current_dir) {
			my $new_dir = $archives_dir . '/' . $this->time_id;
			$this->directory_copy($current_dir,$filedir,0,['^\\.','\\.(?:js|ssi|dat)$']);
			$this->directory_copy($current_dir,$new_dir,1);
			$this->write_file(
				$new_dir . '/data/author',
				\$user_info,
				1
			);
			while (my($id,$field) = each %field::obj) {
				my $db = $field->db;
				if (defined $db && $db && $db ne 'pending' && $field->input_enabled && !$field->update_enabled && !$this->is_reserved_field($field)) {
					my($data);
					$data = $this->read_file($current_dir . '/data/' . $db,1) if -f $current_dir . '/data/' . $db;
					if (defined $data) {
						my(%db);
						tie(%db, $env::dbm_file, $dir . '/' . $db, O_RDWR, $env::dbm_mode);
						$db{$main::n} = $data if ref tied %db;
						untie %db;
						%{$main::data{$id}} = $field->elements($data);
					}
				}
			}
		}
		$this->archives_gc($archives_dir);
	}
}
}

sub archives_gc ($$) {
my($this,$archives_dir) = @_;
if (opendir(DIR, $archives_dir)) {
	my @dir = sort {$this->sort_by(\$a,\$b,'descend')} grep($_ !~ /^\./ && -d $archives_dir . '/' . $_,readdir(DIR));
	closedir(DIR);
	if (($setting::general{'rewindable'} + 1) < @dir) {
		foreach my $n (($setting::general{'rewindable'} + 1)..(@dir - 1)) {
			rmtree $archives_dir . '/' . $dir[$n];
		}
	}
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;					#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 1;						#ơ֥ɤ߹
	$setting::page = 1;						#ڡɤ߹

	$setting::field_db_name = 'inputfield';	#եDB
	$setting::field = 2;						#եɤ߹ߡ2=ꥸʥɤ߹
	$setting::field_style_disabled = 2;			#2=եꥹ̵/1=եΤ̵
	$setting::field_tag_enabled = 'no';				#tag=Τ/all=Ƥ/no=Ĥʤ

	#å
	$cookie::id_enabled = 1;							#ID󥯥åɤ߹
	$cookie::default_enabled = 1;				#桼󥯥åɤ߹
	$cookie::name = 'INPUT';
	$cookie::path = $ENV{'SCRIPT_NAME'};

	#᡼CSS
	$setting::image_css = 'order-image.css' if $default::type && $default::type eq 'order';

	if ($ENV{'QUERY_STRING'}) {
		undef $main::a;
		undef $main::delete if $main::delete && !$cgi::input->referer_is_me(1);
	} elsif ($ENV{'REQUEST_METHOD'} eq 'POST' && !$cgi::input->referer_is_me) {
		undef $main::a;
		undef $main::delete;
	}
}

1;
