package TileViewer;
require CMONOS::TableMaker::Viewer;
@ISA = qw(Viewer);
use strict;
######################################################################
# ӥ塼⥸塼
# TileViewer.pm ver1.1.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ɽեɼ
sub get_selected_fields ($) {
my $this = shift;
return if ref $this->{'selectedField'} && @{$this->{'selectedField'}};

#ƥץ졼Ȥɤ߹
if (defined $setting::page{$setting::key}{'template'} && $setting::page{$setting::key}{'template'} ne '') {
	my(@field);
	unless (ref $this->{'template'}) {
		require CMONOS::CGI_Lib::Template;
		$this->{'template'} = Template->new;
	}
	$this->{'template'}->set(
		'field_style_disabled' => $setting::field_style_disabled,
		'field_tag_enabled' => $setting::field_tag_enabled
	);
	@field = $this->{'template'}->template_parser(\$setting::page{$setting::key}{'template'});
	if (@field) {
		@{$this->{'selectedField'}} = @field;
		$setting::page{$setting::key}{'template'} = $this->{'template'}->deco($setting::page{$setting::key}{'template'});
		$this->{'has_template'} = 1;
	}
}

#ǥեȹܤΤߥɽ
if (!defined $this->{'has_template'} || !$this->{'has_template'}) {
	my($id);
	foreach (sort {$a <=> $b} keys %field::ORDER) {
		$id = $field::ORDER{$_};
		next unless ref $field::obj{$id} && !$field::obj{$id}->{'Hidden'} && $field::obj{$id}->{'Default'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret'));
		next if grep($_ eq $id,@{$this->{'selectedField'}});
		push(@{$this->{'selectedField'}},$id);
	}
}

}

######################################################################
# ƥĥإå
sub print_contents_header ($) {
my $this = shift;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
$main::uni = $main::u if !$main::uni;

#ġܥå
$setting::page{$setting::key}{'toolboxTop'} = 1 if !defined $setting::page{$setting::key}{'toolboxTop'} && !defined $setting::page{$setting::key}{'toolboxBottom'};
$this->print_toolbox('top') if defined $setting::page{$setting::key}{'toolboxTop'} && $setting::page{$setting::key}{'toolboxTop'};

#ڡؤΥ
$this->print_page_jump_form;

#ե졼Ĵ
$this->{'tile_frame_start'} = $this->{'tile_frame_end'} = '';
my $cell_style = '';
if ($setting::page{$setting::key}{'tileFrame'} && ref $frame::obj{'frame'}{$setting::page{$setting::key}{'tileFrame'}}) {
	my($temp,$contents,@frame_setting);
	@frame_setting = (
		'framewidth' => $setting::page{$setting::key}{'tileWidth'},
		'frameheight' => $setting::page{$setting::key}{'tileHeight'},
	);
	push(@frame_setting,'contentsalign',$setting::page{$setting::key}{'tileAlign'}) if $setting::page{$setting::key}{'tileAlign'};
	push(@frame_setting,'contentsvalign',$setting::page{$setting::key}{'tileValign'}) if $setting::page{$setting::key}{'tileHeight'} && $setting::page{$setting::key}{'tileValign'};
	$contents = '_C_';
	$temp = $cgi::Deco->frame('frame',$setting::page{$setting::key}{'tileFrame'},\$contents,'','no','',0,@frame_setting);
	($this->{'tile_frame_start'},$this->{'tile_frame_end'}) = split(/_C_/,$temp);
	$cell_style .= 'vertical-align:' . $setting::page{$setting::key}{'tileValign'} . ';' if !$setting::page{$setting::key}{'tileHeight'} && $setting::page{$setting::key}{'tileValign'};

} elsif ($setting::page{$setting::key}{'tileWidth'} || $setting::page{$setting::key}{'tileHeight'}) {
	$cell_style .= 'width:' . $setting::page{$setting::key}{'tileWidth'} . 'px;' if $setting::page{$setting::key}{'tileWidth'};
	$cell_style .= 'height:' . $setting::page{$setting::key}{'tileHeight'} . 'px;' if $setting::page{$setting::key}{'tileHeight'};
	$cell_style .= 'text-align:' . $setting::page{$setting::key}{'tileAlign'} . ';' if $setting::page{$setting::key}{'tileAlign'};
	$cell_style .= 'vertical-align:' . $setting::page{$setting::key}{'tileValign'} . ';' if $setting::page{$setting::key}{'tileValign'};
}

my $handle = $this->{'filehandle'};
if (!defined $setting::page{$setting::key}{'tileTableEnabled'} || $setting::page{$setting::key}{'tileTableEnabled'}) {

	#ڡ
	$setting::page{$setting::key}{'tableCols'} = 3 if !$setting::page{$setting::key}{'tableCols'};
	$main::u = int($main::u / $setting::page{$setting::key}{'tableCols'} + 0.99999) * $setting::page{$setting::key}{'tableCols'};
	$main::uni = $main::u if !$main::uni;

	$this->{'Table'} = Table->new;
	if (ref $table::obj{$setting::page{$setting::key}{'table'}}) {
		%{$this->{'Table'}} = %{$table::obj{$setting::page{$setting::key}{'table'}}};
	} else {
		$this->{'Table'}->set(
			'tableclass' => 'tile-table',
			'class0' => 'tile-cell',
			(($cell_style) ? ('style0' => $cell_style) : ())
		);
	}

	#ơ֥볫
	print $handle ($this->{'Table'}->table);

	#
	$this->{'Table'}->limit($setting::page{$setting::key}{'tableCols'});

} else {
	$this->{'li_attributes'} = ($cell_style) ? ' style="' . $cell_style . '"' : '';
	print $handle '<ul class="tile">';
}
}

######################################################################
# ƥĥեå
sub print_contents_footer ($) {
my $this = shift;

#ơ֥뽪λ
my $handle = $this->{'filehandle'};
if (ref $this->{'Table'}) {
	print $handle ($this->{'Table'}->trtd('',1));
	print $handle ($this->{'Table'}->_table);
} else {
	print $handle '</ul>';
}

#ڡؤΥ
$this->print_page_jump_form;

$this->print_toolbox('bottom') if defined $setting::page{$setting::key}{'toolboxBottom'} && $setting::page{$setting::key}{'toolboxBottom'};
$this->print_download_form;
$this->print_page_return_form;

}

######################################################################
# 쥳
sub print_record ($$$) {
my($this,$c,$n) = @_;
my($temp,%temp,$path,$id);
$path = "$default::file/$c/$n";

foreach $id (@{$this->{'selectedField'}}) {
	next unless ref $field::obj{$id} && $field::obj{$id}->usual_format_enabled;
	my $db = $field::obj{$id}->db;
	unless (!$db || ref tied %{$this->{'DB'}{$c}{$db}}) {
		tie(%{$this->{'DB'}{$c}{$db}}, $env::dbm_file, "$default::db/$c/$db", O_RDONLY, $env::dbm_mode);
	}
	if (defined $this->{'has_template'} && $this->{'has_template'}) {
		$temp{$id} = ($db) ? $this->{'DB'}{$c}{$db}{$n} : '';
	} else {
		$temp .=  '<div>' . ((defined $field::for{'key'} && $id eq $field::for{'key'}) ? '<strong>' : '') . $field::obj{$id}->usual_format((($db) ? $this->{'DB'}{$c}{$db}{$n} : ''),$path,$c,$n) . ((defined $field::for{'key'} && $id eq $field::for{'key'}) ? '</strong>' : '') . '</div>';
	}
}
if (defined $this->{'has_template'} && $this->{'has_template'}) {
	$temp = $this->{'template'}->replace($setting::page{$setting::key}{'template'},\%temp,'',$path,$c,$n);
}

return if !defined $temp || $temp eq '';
my $handle = $this->{'filehandle'};
print $handle ((ref $this->{'Table'}) ? $this->{'Table'}->trtd($this->{'tile_frame_start'} . $temp . $this->{'tile_frame_end'}) : '<li' . $this->{'li_attributes'} . '>' . $this->{'tile_frame_start'} . $temp . $this->{'tile_frame_end'} . '</li>');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	$setting::field_tag_enabled = 'no';				#tag=Τ/all=Ƥ/no=Ĥʤ
	$setting::field_style_disabled = 2;			#2=եꥹ̵/1=եΤ̵

	#省
	$setting::key = 'tile' if !defined $setting::key || !$setting::key;	#ڡꥭ

	#ǥեȥ
	$main::k = 'tile' if !defined $main::k || !$main::k;

	#饹Ͽ
	Common::class_register('tile','TileViewer');
}

1;
