package RecordSweeper;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
######################################################################
# 쥳⥸塼
# RecordSweeper.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ¹
sub run ($) {
my $this = shift;
my($error,@folder,%year);
@main::c = push(@main::c,$main::c) if !@main::c && defined $main::c;
undef $main::c;

use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

#
if ($main::delete && @main::c && !$this->is_nan($main::mday) && !$this->is_nan($main::mon) && !$this->is_nan($main::year) && !$this->is_impossible_mday($main::year,$main::mon,$main::mday)) {
	my($limit,$c,$gcount,$ncount);
	$gcount = $ncount = 0;
		
	#ɬפʥ⥸塼
	use File::Path;
	use Time::Local;
	$limit = timelocal(0,0,0,$main::mday,$main::mon-1,$main::year);
	foreach $c (@main::c) {
		my(%expire,%mtime,@delete);
		next if !$c || $this->is_nan($c) || !-d "$default::db/$c";
		tie(%expire, $env::dbm_file, "$default::db/$c/expire", O_RDONLY, $env::dbm_mode);
		if (ref tied %expire) {
			my($n,$t,$time);
			$time = time;
			while (($n,$t) = each %expire) {
				push(@delete,$n) if $t < $time;
			}
		}
		untie %expire;
		tie(%mtime, $env::dbm_file, "$default::db/$c/mtime", O_RDONLY, $env::dbm_mode);
		if (ref tied %mtime) {
			my($n,$t,$time);
			$time = time;
			while (($n,$t) = each %mtime) {
				push(@delete,$n) if $t < $time;
			}
		}
		untie %mtime;
		if (@delete) {
			my $n;
			foreach $n (@delete) {
				$this->delete_all_data("$default::db/$c",$n);
				rmtree "$default::file/$c/$n";
				$ncount++;
			}
		}
		$gcount++;
	}
	push(@{$this->{'dialog'}}, $gcount . ' ƥ꡼碌 ' . $ncount . ' 쥳ɤޤ');
} elsif ($main::delete) {
	push(@{$this->{'dialog'}},(@main::c) ? 'դλ꤬ޤ' : 'ƥ꡼ꤷƤ');
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1 title="쥳ɤΰԤޤ">쥳ɤ</h1>';
my($mday,$mon,$year) = (localtime(time))[3..5];
$year += 1900;
$mon++;
if (!defined $main::year || !$main::year) {
	$main::year = $year - 3;
	$main::mon = $mon;
}

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=> 'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);

#ƥ꡼
$this->print_category_selector(
	'',
	'<fieldset><legend><label for="c">쥳ɤ륫ƥ꡼</label></legend>',
	'</fieldset>'
);

print '<fieldset class="delete">';
print '<select name="by">';
print '<option value="ctime"></option>';
print '<option value="mtime"';
print ((defined $main::by && $main::by eq 'mtime') ? ' selected="selected"' : '');
print '></option>';
print '</select>  ';

print '<label><select name="year">';
foreach (($year-10)..$year) {
	print '<option value="', $_, '"';
	print (($main::year && $main::year == $_) ? ' selected="selected"' : '');
	print '>', $_, '</option>';
}
print '</select>ǯ</label> ';

print '<label><select name="mon">';
foreach (1..12) {
	print '<option value="', $_, '"';
	print (($main::mon && $main::mon == $_) ? ' selected="selected"' : '');
	print '>', $_, '</option>';
}
print '</select></label> ';

print '<label><select name="mday">';
foreach (1..31) {
	print '<option value="', $_, '"';
	print (($main::mday && $main::mday == $_) ? ' selected="selected"' : '');
	print '>', $_, '</option>';
}
print '</select></label> ';

print ' Ť쥳ɤ <input type="submit" name="delete=1" value="" onclick="return confirm(\'ϼäޤ˺ޤ\');" />';
print '</fieldset></form>';

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);
if (!$default::subdivided || ($default::subdivided && defined $main::c && $main::c ne '')) {

	#饹Ͽ
	Common::class_register('t303','RecordSweeper');

	#˥塼Ͽ
	$setting::jump_menu{'t303'} = '쥳ɤ';

}
}



1;
