package TsvViewer;
require CMONOS::TableMaker::Viewer;
@ISA = qw(Viewer);
use strict;
######################################################################
# tsvɥ⥸塼
# TsvViewer.pm ver1.1.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2008-08-17
######################################################################
# ƥĥ
sub print_viewer_header ($) {
my $this = shift;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
my($agent);
$agent = ($ENV{'HTTP_USER_AGENT'}) ? $ENV{'HTTP_USER_AGENT'} : '';
if ($agent =~ /win/i) {
	$this->{'jcode'} = 'sjis';
	$this->{'\n'} = "\x0D\x0A";
} elsif ($agent =~ /mac/i) {
	$this->{'jcode'} = 'sjis';
	$this->{'\n'} = "\x0D";
} else {
	$this->{'jcode'} = '';
	$this->{'\n'} = "\x0A";
}

$main::u = 0;
#$this->print_http_header('text/tab-separated-values');
$this->print_http_header('application/tab-separated-values');
}

######################################################################
# ڡեå
sub print_viewer_footer ($) {
my $this = shift;
}

######################################################################
# 쥳
sub print_record ($$$) {
my($this,$c,$n) = @_;
my($col,$jcode);
$jcode = $this->{'jcode'} if $this->{'jcode'};
$col = 0;
foreach (@{$this->{'selectedField'}}) {
	next unless ref $field::obj{$_} && $field::obj{$_}->format_for_text_enabled;
	my($db,$v);
	$db = $field::obj{$_}->db;
	if (defined $db && $db) {
		unless (ref tied %{$this->{'DB'}{$c}{$db}}) {
			tie(%{$this->{'DB'}{$c}{$db}}, $env::dbm_file, "$default::db/$c/$db", O_RDONLY, $env::dbm_mode);
		}
		$v = $field::obj{$_}->format_for_text($this->{'DB'}{$c}{$db}{$n},"$default::file/$c/$n",$c,$n);
	} else {
		$v = $field::obj{$_}->format_for_text('');
	}
	$v =~ s/\t/   /gs;
	$v =~ s/(\x0D\x0A|\x0D|\x0A|<br \/>)/\x0B/gs;
	$this->jcode_convert(\$v,$jcode,'euc') if $jcode;
	print "\x09" if defined $col && $col;
	print $v;
	undef $v;
	$col++;
}

print $this->{'\n'};
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#省
	$setting::key = 'none';						#ڡꥭ

	#ǥեȥ
	$main::k = 'tsv' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('tsv','TsvViewer');
}

1;
