package LanguageReport;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
######################################################################
# ˬԤθĶ⥸塼
# LanguageReport.pm ver1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-01-30
######################################################################
# 
# 	$$data[0]	֡hhmmss
# 	$$data[1]	IPREMOTE_HOST
# 	$$data[2]	ե
# 	$$data[3]	饤ȴĶHTTP_USER_AGENT
# 	$$data[4]	饤ȼHTTP_ACCEPT_LANGUAGE
# 	$$data[5]	󥯸HTTP_REFERER
# 	$$data[6]	ɥ¦
# 	$$data[7]	ɥ¦ι⤵
# 	$$data[8]	Ѳǽʥ꡼
# 	$$data[9]	Ѳǽʥ꡼⤵
sub log_stat ($$$) {
my($this,$date,$data) = @_;
my($lang);

$lang = (defined $$data[4] && $$data[4] =~ /^([\w\-]+)/) ? $1 : '';
return 0 if $lang eq '';

if (!$this->{'is_counted'}{$$data[1] . $$data[3]}) {
	$lang = lc $lang;
	$lang =~ s/^ja-\w+$/ja/;
	$this->{'http_accept_language'}->{$lang}++;
	$this->{'is_counted'}{$$data[1] . $$data[3]} = 1;
	$this->{'user_count'}++;
}
return 1;
}

######################################################################
# Ĵ
sub stat_key ($$) {
my($this,$key) = @_;
return '<strong>' . $this->get_lang($key) . '</strong>';
}

######################################################################
# ϥȥ
sub stat_title ($) {
my $this = shift;
return 'ˬԤθĶ';
}

######################################################################
# Ϸɽ
sub print_report ($) {
my $this = shift;
undef %{$this->{'is_counted'}};
delete $this->{'is_counted'};
return if defined $this->{'noLog'} && $this->{'noLog'};

my(@ranking);
@ranking = sort {$this->sort_by(\$this->{'http_accept_language'}->{$a},\$this->{'http_accept_language'}->{$b},'descend') || $a cmp $b} keys %{$this->{'http_accept_language'}};

$this->print_stat_report(
	'',
	\@ranking,
	$this->{'http_accept_language'},
	'',
	'',
	$this->{'user_count'},
	'',
	1,
	'',
	'center',
	180,
	'桼',
	100,
	'%'
);
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#ǥեȥ
	$main::k = 'language' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('language','LanguageReport');

}


1;

