package RefererReport;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
######################################################################
# 󥯸󥭥󥰥⥸塼
# RefererReport.pm ver1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-01-30
######################################################################
# 
# 	$$data[0]	֡hhmmss
# 	$$data[1]	IPREMOTE_HOST
# 	$$data[2]	ե
# 	$$data[3]	饤ȴĶHTTP_USER_AGENT
# 	$$data[4]	饤ȼHTTP_ACCEPT_LANGUAGE
# 	$$data[5]	󥯸HTTP_REFERER
# 	$$data[6]	ɥ¦
# 	$$data[7]	ɥ¦ι⤵
# 	$$data[8]	Ѳǽʥ꡼
# 	$$data[9]	Ѳǽʥ꡼⤵
sub log_stat ($$$) {
my($this,$date,$data) = @_;
my $referer = (defined $$data[5]) ? $$data[5] : '';

# ⤫Υ󥯤
return 0 if grep(eval {$referer =~ /\Q$_\E/},@default::target) || !$referer;

# refererϿ
if ($referer =~ m!^https?://!i) {
	$referer = $this->url_filter($referer);
	my $mtime = substr($date,0,8) . $$data[0];
	my $url = $this->rm_query($referer);
	$this->{'referer_mtime'}->{$url} = $mtime if !$this->{'referer_mtime'}->{$url} || $mtime < $this->{'referer_mtime'}->{$url};
}

# ǥ󥰥ڡΤߥ
if ($setting::stat{'referer'}{'landing'}) {
	return 0 if $this->{'is_counted'}{$$data[1]};
	$this->{'is_counted'}{$$data[1]} = 1;
}

# CGIΥ󥯤
if ($setting::stat{'referer'}{'option'} =~ /nocgi$/) {
	return 0 if $referer =~ /\?/ || $referer =~ /\.cgi$/i;
	$referer =~ s/#.*$//s;

# CGIξʬ̵
} elsif ($setting::stat{'referer'}{'option'} =~ /ignore$/) {
	$referer = $this->rm_query($referer);

# Ȥǽ
} elsif ($setting::stat{'referer'}{'option'} eq 'site') {
	$referer = $1 if $referer =~ /^(http[s]?:\/\/[^\/]+)/is;
}

$this->{'http_referer'}->{$referer}++ if !$this->{'referer_ip'}->{$referer}->{$$data[1]};
$this->{'referer_ip'}->{$referer}->{$$data[1]}++;
return 1;
}

sub rm_query ($$) {
my($this,$url) = @_;
$url =~ s/[#\?].*$//s;
$url =~ s/(\.(cgi|php|pl|asp))(?=\W).*$/$1/s;
$url =~ s/(\.[s]?htm[l]?)(?=\W).*?$/$1/s;
return $url;
}

######################################################################
# ϴĶɲá
sub print_sub_stat_env ($) {
my $this = shift;
print $this->{'infoTable'}->tr;
print $this->{'infoTable'}->th('ˡ');
print $this->{'infoTable'}->td(
	'<select name="setting:referer_option">'
	. '<option value="">URLñ̤ǽפ</option>'
	. '<option value="ignore"' . (($setting::stat{'referer'}{'option'} eq 'ignore') ? ' selected="selected"' : '') . '>CGIξʬȥ󥫡̵뤹</option>'
	. '<option value="time_ignore"' . (($setting::stat{'referer'}{'option'} eq 'time_ignore') ? ' selected="selected"' : '') . '>CGIξʬȥ󥫡̵뤹ʿ</option>'
	. '<option value="nocgi"' . (($setting::stat{'referer'}{'option'} eq 'nocgi') ? ' selected="selected"' : '') . '>CGIΥ󥯤ȥ󥫡̵뤹</option>'
	. '<option value="time_nocgi"' . (($setting::stat{'referer'}{'option'} eq 'time_nocgi') ? ' selected="selected"' : '') . '>CGIΥ󥯤ȥ󥫡̵뤹ʿ</option>'
	. '<option value="site"' . (($setting::stat{'referer'}{'option'} eq 'site') ? ' selected="selected"' : '') . '>ñ̤ǽפ</option>'
	. '</select>'
	. '<select name="setting:referer_landing">'
	. '<option value="">ˬΥ󥯸⥫Ȥ</option>'
	. '<option value="1"' . (($setting::stat{'referer'}{'landing'}) ? ' selected="selected"' : '') . '>Υ󥯸ΤߥȤ</option>'
	. '</select> '
	. $this->submit_button($env::image_dir . '/stat/referer.gif',20,20,'󥯸󥭥','','m','RefererReport','k','referer')
);
print $this->{'infoTable'}->_tr;
}

######################################################################
# Ĵ
sub stat_key ($$) {
my($this,$key) = @_;
return $this->url_to_title($key,(($setting::stat{'referer'}{'option'} && $setting::stat{'referer'}{'option'} eq 'site') ? 1 : 0),1);
}

######################################################################
# ɲù
sub stat_option ($$$) {
my($this,$key,$value) = @_;
return $this->submit_button($env::image_dir . '/stat/visitor.gif',14,14,'ˬԥꥹȤɽޤ','','m','ClientReport','k','client','setting:client_referer',$key,'setting:client_target','','setting:client_option','','setting:client_refererRegexp',(($setting::stat{'referer'}{'option'}) ? '' : 2),'setting:client_refererLanding',(($setting::stat{'referer'}{'landing'}) ? 1 : 0));
}

######################################################################
# ϥȥ
sub stat_title ($) {
my $this = shift;
return '󥯸' . (($setting::stat{'referer'}{'option'} eq 'site') ? '' : 'URL') . (($setting::stat{'referer'}{'option'} =~ /^time/) ? 'ʿ' : '󥭥');
}

######################################################################
# Ϸɽ
sub print_report ($) {
my $this = shift;
return if defined $this->{'noLog'} && $this->{'noLog'};
$this->tie_title_db;

# refererϿ
my(%referer);
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
tie(%referer, $env::dbm_file, $default::preference_dir . '/referer_log', O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %referer) {
	my($url,$t);
	while (($url,$t) = each %{$this->{'referer_mtime'}}) {
		if (!$referer{$url} || $referer{$url} > $this->{'referer_mtime'}->{$url}) {
			$referer{$url} = $this->{'referer_mtime'}->{$url};
		} else {
			$this->{'referer_mtime'}->{$url} = $referer{$url};
		}
	}
}
untie %referer;

my(@ranking);
$setting::stat{'referer'}{'sort'} = 'descend' if !defined $setting::stat{'referer'}{'sort'} ||  $setting::stat{'referer'}{'sort'} eq '';

# 
if ($setting::stat{'referer'}{'option'} =~ /^time/) {
	@ranking = sort {
		$this->sort_by(\$this->{'referer_mtime'}->{$a},\$this->{'referer_mtime'}->{$b},$setting::stat{'referer'}{'sort'}) || 
		$this->sort_by(\$this->{'http_referer'}->{$a},\$this->{'http_referer'}->{$b},$setting::stat{'referer'}{'sort'}) || 
		$a cmp $b
	} keys %{$this->{'http_referer'}};
	$this->print_stat_report(
		'',
		\@ranking,
		$this->{'referer_mtime'},
		'',
		$this->{'http_referer'},
		$this->{'http_referer'}->{$this->maximum($this->{'http_referer'})},
		'referer',
		1,
		'󥯸URL',
		'left',
		300,
		'饢',
		200,
		'',
		'ˬ',
		50
	);

# ¾
} else {
	@ranking = sort {
		$this->sort_by(\$this->{'http_referer'}->{$a},\$this->{'http_referer'}->{$b},$setting::stat{'referer'}{'sort'}) || 
		$a cmp $b
	} keys %{$this->{'http_referer'}};
	$this->print_stat_report(
		'',
		\@ranking,
		$this->{'http_referer'},
		'',
		'',
		((!ref $this->{'http_referer'} || !%{$this->{'http_referer'}}) ? 0 : ($setting::stat{'referer'}{'sort'} && $setting::stat{'referer'}{'sort'} eq 'ascend') ? $this->{'http_referer'}->{$ranking[$#ranking]} : $this->{'http_referer'}->{$ranking[0]}),
		'referer',
		1,
		'󥯸' . (($setting::stat{'referer'}{'option'} && $setting::stat{'referer'}{'option'} eq 'site') ? '' : 'URL'),
		'left',
		300,
		'',
		100,
		'',
		'ˬ',
		50
	);
}
$this->untie_title_db;
}

sub get_num ($$) {
my($this,$num) = @_;
if ($setting::stat{'referer'}{'option'} =~ /^time/) {
	return $this->date($num,$setting::page{'stat'}{'datelimit'},$setting::page{'stat'}{'datetype'});
} else {
	return ($num) ? $num : 0;
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#ǥեȥ
	$main::k = 'referer' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('referer','RefererReport');
}


1;

