package LogSweeper;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ⥸塼
# LogSweeper.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ¹
sub run ($) {
my $this = shift;
my(@access_log,$size,$removed);

#ڡɤ߹
$this->import_db($default::preference_dir . '/page',\%setting::page,1,'stat');

# 
if ($main::delete{'year'} && $main::delete{'mon'} && $main::delete{'mday'}) {
	#no warnings qw(numeric);
	my $delete = sprintf("%.4d", $main::delete{'year'}) . sprintf("%.2d", $main::delete{'mon'}) . sprintf("%.2d", $main::delete{'mday'});
	($size,@access_log) = $this->log_size;
	$removed = $this->log_sweeper($main::option,grep($_ <= $delete,@access_log));
	$removed += 0;
	push(@{$this->{'dialog'}},$removed . 'Υޤ');
}

($size,@access_log) = $this->log_size;

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1 title="ޤ"></h1>';

if (@access_log) {
	$this->print_log_env($size,\@access_log);
	$this->print_delete_setting(\@access_log);

} else {
	print '<fieldset>ߤΤȤϰ⵭ϿƤޤ</fieldset>'
}

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# 
sub log_size ($) {
#no warnings qw(numeric);
my $this = shift;
my(@access_log,$size);

# ǥ쥯ȥΥ
opendir(LOG, $default::access_log);
@access_log = grep($_ =~ /\d{8}\.csv$/ && ($size += -s $default::access_log . '/' . $_),readdir(LOG));
closedir(LOG);

@access_log = sort {$a <=> $b || $a cmp $b} @access_log;
return ($size,@access_log);
}

######################################################################
# ξ
sub print_log_env ($$$) {
my($this,$size,$log) = @_;

#Ͼơ֥
my $this_table = Table->new;
if (ref $table::obj{$setting::page{'stat'}{'infoTable'}}) {
	%{$this_table} = %{$table::obj{$setting::page{'stat'}{'infoTable'}}};
	$this_table->{'fixed'} = 1;
} else {
	$this_table->set(
		'fixed' => 1,
		'tableclass' => 'tooltable',
		'trclass' => 'odd,even',
		'class0' => 'odd,even',
		'style0' => 'text-align: left'
	);
}

#ե⥸塼ɤ߹
require CMONOS::CGI_Lib::BarGraph;
my $bargraph = BarGraph->new(
	\%setting::deco,
	$setting::page{'stat'}{'barColor'},
	$setting::page{'stat'}{'bgColor'},
	$setting::page{'stat'}{'barImage'},
	$setting::page{'stat'}{'bgImage'},
	$setting::page{'stat'}{'barWidth'}
);

print '<fieldset><legend>ξ</legend>';
print $this_table->table;

#
print $this_table->tr;
print $this_table->th('¸');
print $this_table->td($this->log_span($$log[0],$$log[$#{$log}]));
print $this_table->_tr;

#ڡ
my $limit = $setting::general{'limit'};
$limit = $default::limit if !defined $limit ||  !$limit;
$limit = 100000 if !defined $limit ||  !$limit;
print $this_table->tr;
print $this_table->th('ڡ');
print $this_table->td(' ' . $this->digit($limit) . ' byte');
print $this_table->_tr;

#
print $this_table->tr;
print $this_table->th('ڡ');
print $this_table->td($this->digit($size) . ' byte');
print $this_table->_tr;

#ڡΨ
print $this_table->tr;
print $this_table->th('ڡΨ');
print $this_table->td($bargraph->bargraph($size,$limit,'%'));
print $this_table->_tr;

print $this_table->_table;
print '</fieldset>';
}

sub log_span ($$$) {
my($this,$from,$to) = @_;
$from = $1 if $from =~ /^(\d{8})/;
$to = $1 if $to =~ /^(\d{8})/;
return $this->date($from,$setting::page{'stat'}{'datelimit'},$setting::page{'stat'}{'datetype'}) . '' . $this->date($to,$setting::page{'stat'}{'datelimit'},$setting::page{'stat'}{'datetype'});
}

sub print_delete_setting ($$) {
my($this,$log) = @_;
my($year,$mon,$mday,$year_end);

($year,$mon,$mday) = ($1,$2,$3) if $$log[0] =~ /^([0-9]{4})([0-9]{2})([0-9]{2})/;
$year_end = $1 if $$log[$#{$log}] =~ /^([0-9]{4})([0-9]{2})([0-9]{2})/;

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);
print '<fieldset class="delete">';
print '<label><select name="delete:year">';
foreach ($year..$year_end) {
	print '<option value="' . $_ . '"' . (($_ == $year) ? ' selected="selected"' : '') . '>' . $_ . '</option>';
}
print '</select>ǯ</label> ';
print '<label><select name="delete:mon">';
foreach (1..12) {
	print '<option value="' . $_ . '"' . (($_ == $mon) ? ' selected="selected"' : '') . '>' . $_ . '</option>';
}
print '</select></label> ';
print '<label><select name="delete:mday">';
foreach (1..31) {
	print '<option value="' . $_ . '"' . (($_ == $mday) ? ' selected="selected"' : '') . '>' . $_ . '</option>';
}
print '</select></label>';
print ' <input type="submit" value="Υ" />';

print '<div class="external-field"><label><input type="checkbox" name="option" value="1" /> եꤵ줿ɥ쥹</label></div>' if defined $setting::general{'mailto'} && $setting::general{'mailto'};
print '</fieldset></form>';
}

######################################################################
# 
sub log_sweeper ($$;@) {
my($this,$option,@unlink) = @_;
my($file,$removed);
return 0 if !@unlink;
map($_ = $default::access_log . '/' . $_,@unlink);

# եΥХåå
if ($option && $setting::general{'mailto'}) {
	my($msg);
	$msg = '' . $setting::general{'cginame'} . "\x0A";
	$msg .= "\x0A";
	$msg .= 'ͤˤŤޤ' . "\x0A";

	$msg .= "\x0A";
	$msg .= 'źեեϺ줿Ǥ' . "\x0A";
	$msg .= 'ե̾աyyyymmdd' . "\x0A";
	$msg .= 'csvʥ޶ڤƥȡ' . "\x0A";
	$msg .= "\x0A";
	$msg .= '֡hhmmss,' . "\x0A";
	$msg .= 'IPREMOTE_HOST,' . "\x0A";
	$msg .= 'ե,' . "\x0A";
	$msg .= '饤ȴĶHTTP_USER_AGENT,' . "\x0A";
	$msg .= '饤ȼHTTP_ACCEPT_LANGUAGE,' . "\x0A";
	$msg .= '󥯸HTTP_REFERER,' . "\x0A";
	$msg .= 'ɥ¦,' . "\x0A";
	$msg .= 'ɥ¦ι⤵,' . "\x0A";
	$msg .= '꡼,' . "\x0A";
	$msg .= '꡼⤵' . "\x0A";
	$msg .= "\x0A";

	unless (ref $cgi::SendMail) {
		require CMONOS::CGI_Lib::SendMail;
		$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
	}

	$cgi::SendMail->send_mail(
		'Bcc'		=>  $setting::general{'mailto'},
		'From'		=>  (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}),
		'Subject'	=>  'Ťޤ',
		'message'	=>  $msg,
		'file'		=>  \@unlink
	);
}
$removed = 0;
foreach $file (@unlink) {
	$removed++ if unlink $file;
}
return $removed;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('a200','LogSweeper');

	#˥塼Ͽ
	$setting::jump_menu{'a200'} = '';

}



1;
