package BbUserGeneratedField;
use strict;
######################################################################
# ե⥸塼Baobab 桼եɡ
# BbUserGeneratedField.pm 1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-08-28
######################################################################
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

sub get_query_for_user_generated_field_editor ($;$$$) {
my($this,$for_post,$c,$n) = @_;
$c = (defined $c && $c ne '') ? $c : (defined $main::c && $main::c ne '') ? $main::c : '';
$n = (defined $n && $n ne '') ? $n : $main::n;
if ($for_post) {
	return $this->add_query('post',
		{
			'm'		=>	'UserGeneratedFieldEditor',
			'k'		=>	'ugfieldeditor',
			'id'	=>	$this->{'id'},
			(($default::subdivided) ? ('c' => $c) : ()),
			'n' => $main::n
		}
	)
} else {
	return '?m=UserGeneratedFieldEditor&k=ugfieldeditor&id=' . $this->{'id'} . (($default::subdivided) ? '&c=' . $c : '') . '&n=' . $n;
}
}

sub _mk_user_generated_field_id ($;$$) {
my($this,$c,$n) = @_;
return (($default::subdivided && defined $c && $c ne '') ? '-' . $c : '') . '-' . $n . '-' . $this->{'id'};
}

sub get_query_keys ($) {
my $this = shift;
if ($this->{'externalFileDisabled'}) {
	return [grep($_ ne 'c' && $_ ne 'n',@setting::form)];
} else {
	return [];
}
}

sub add_query_for_form ($;$$) {
my($this,$c,$n) = @_;
return $this->add_query('post',{'n' => $n,(($default::subdivided && defined $main::c && $main::c ne '') ? ('c' => $c) : ())});
}

sub get_output_path ($) {
my $this = shift;
return '';
}

sub is_short_parameters ($) {
return (!$default::db || !$default::file || ($default::subdivided && (!defined $main::c || $main::c eq '')) || !defined $main::n || $main::n eq '') ? 1 : 0;
}

sub get_field_data ($) {
my $this = shift;
my(%db,$data);
tie(%db, $env::dbm_file, $default::db . '/' . $this->db, O_RDONLY, $env::dbm_mode);
if (ref tied %db) {
	$data = $db{$main::n};
}
untie %db;
return ($data) ? {$this->elements($data)} : {};
}

sub get_file_directory ($) {
my $this = shift;
return (defined $main::n) ? $default::file . '/' . $main::n : '';
}

sub get_db_directory ($) {
my $this = shift;
return $default::db;
}

sub get_mail_field_data ($$) {
my($this,$mailto) = @_;
return '' if !ref $field::obj{$mailto} || $field::obj{$mailto}->{'class'} !~ /email/;
my(%mail);
my $addr = '';
tie(%mail, $env::dbm_file, $default::db . '/' . $field::obj{$mailto}->db, O_RDONLY, $env::dbm_mode);
if (ref tied %mail) {
	$addr = $mail{$main::n} if $mail{$main::n};
}
untie %mail;
return ($addr) ? join(',',$this->get_address($addr)) : '';
}

sub get_title_field_data ($$) {
my $this = shift;
return '' if !$field::for{'title'} || !ref $field::obj{$field::for{'title'}};
my(%title);
my $title = '';
tie(%title, $env::dbm_file, $default::db . '/' . $field::obj{$field::for{'title'}}->db, O_RDONLY, $env::dbm_mode);
if (ref tied %title) {
	$title = $title{$main::n} if $title{$main::n};
}
untie %title;
$this->text_color(\$title);
return $title;
}

sub get_viewer_url ($;$$) {
my($this,$c,$n) = @_;
if (defined $n && $n ne '') {
	if ($default::subdivided && defined $c && $c ne '') {
		return $this->my_url . '?c=' . $c . '&n=' . $n . '&v=listarticle';
	} else {
		return $this->my_url . '?n=' . $n . '&v=listarticle';
	}
} else {
	if ($default::subdivided && defined $c && $c ne '') {
		return $this->my_url . '?c=' . $c;
	} else {
		return $this->my_url;
	}
}
}

sub post_update ($;$) {
my($this,$unadditional) = @_;
if (!$unadditional && $this->{'mTime'}) {
	my(%mtime,%thread_mtime,%tree,$time,@info,$thread_id);
	$time = time;
	tie(%tree, $env::dbm_file, $default::db . '/tree', O_RDONLY, $env::dbm_mode);
	if (ref tied %tree) {
		@info = split(/,/,$tree{$main::n});
	}
	untie(%tree);
	$thread_id = (defined $info[0] && $info[0] && defined $info[1] && $info[1] ne '') ? $info[1] : $main::n;

	#ν񤭹
	tie(%mtime, $env::dbm_file, $default::db . '/mtime', O_RDWR, $env::dbm_mode);
	if (ref tied %mtime && $mtime{$main::n}) {
		$mtime{$main::n} = $time;
	}
	untie %mtime;
	tie(%thread_mtime, $env::dbm_file, $default::db . '/thread_mtime', O_RDWR, $env::dbm_mode);
	if (ref tied %thread_mtime && $thread_mtime{$thread_id}) {
		$thread_mtime{$thread_id} = $time;
	}
	untie %thread_mtime;

	#ƥ꡼
	if (defined $default::subdivided && $default::subdivided) {
		my(%category_mtime);
		tie(%category_mtime, $env::dbm_file, $default::master_db_dir . '/category_mtime', O_RDWR, $env::dbm_mode);
		if (ref tied %category_mtime && $category_mtime{$main::c}) {
			$category_mtime{$main::c} = $time;
			$category_mtime{'Last-Modified'} = $time;
		}
		untie %category_mtime;
	}
}
if ($setting::general{'html'} && $setting::security{'browse'}{'passwordCheck'} eq 'nocheck' && $setting::security{'secret'}{'passwordCheck'} eq 'nocheck' && $setting::security{'closed'}{'passwordCheck'} eq 'nocheck') {
	require CMONOS::Baobab::Viewer;
	local(@setting::form,$cgi::action,%main::search,$main::q);
	$cgi::action = Common->new('viewer');
	$cgi::action->import_db($default::preference_dir . '/page',\%setting::page,1,'article');
	$cgi::action->run((($default::file) ? $default::file : '.') . '/index.html');
}
return 1;
}

sub is_secure_user_for_update ($) {
my $this = shift;
return 0 if $this->is_short_parameters;
$this->read_security_settings;
return ((!$this->{'generatableUser'} || $this->is_as_secure_as($this->{'generatableUser'})) && (($this->{'Open'} && $this->is_secure('browse',1)) || $this->is_secure('secret',1))) ? 1 : 0;
}

sub get_rss_path ($) {
my $this = shift;
my $my_url = $this->my_url;
my $my_category_url = $my_url . '?' . (($default::subdivided && defined $main::c && $main::c ne '') ? 'c=' . $main::c . '&' : '');
if ($setting::security{'browse'}{'passwordCheck'} eq 'nocheck' && $setting::security{'closed'}{'passwordCheck'} eq 'nocheck') {
	return (
		$default::file,
		(($setting::general{'html'}) ? $this->full_path((($default::file) ? $default::file : '.') . '/index.html') : $my_category_url),
		(($default::subdivided) ? $default::master_file_dir : ''),
		(($default::subdivided) ? $my_url : '')
	);
} else {
	return (
		$default::file,
		$my_category_url,
		(($default::subdivided) ? $default::master_file_dir : ''),
		(($default::subdivided) ? $my_url : '')
	);
}
}



1;
