package ThreadXtime;
require CMONOS::CGI_Lib::Field::Xtime;
@ISA = qw(Xtime);
use strict;
######################################################################
# եɥ⥸塼ʥåɺ/
# ThreadXtime.pm 1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-06-14
######################################################################
#	(0)-3 եDB
sub db ($) {
my $this = shift;
return (defined $this->{'timetype'} && $this->{'timetype'} ne '') ? $this->{'timetype'} : 'thread_mtime';
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
my $this = shift;
return 0;
}

sub form {
my($this,$status,$original) = @_;
return '';
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my $this = shift;
delete $main::data{$this->{'id'}}{'str'};
return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
my($this,$str,$path,$c,$n,$db) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return $this->field_tag(
	$this->style(
		(($str) ? $this->field_date($str) : $this->get_thread_xdate($n,$db)),
		$this->{'style'},
		$this->{'fontsize'},
		$this->{'fontcolor'},
		$this->{'fontface'}
	)
);
}

sub has_content {
my($this,$str,$type,$path,$c,$n,$db) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
my $date = ($str) ? $this->field_date($str) : $this->get_thread_xdate($n,$db);
return ($date) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_detail(str);
sub format_for_detail_enabled {
my $this = shift;
return ($this->{'info'} || $this->{'detail'}) ? 1 : 0;
}

sub get_thread_xdate ($$$) {
my($this,$n,$db) = @_;
return $this->field_date($db->{$this->{'timetype'}}->{$cgi::action->get_top($n,$db->{'tree'}->{$n})});
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$) {
my($this,$str) = @_;
return '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled) = @_;

#̾
my $name = 'data:' . $this->{'id'};

$this->print_field_info_form($name,1);

print '<fieldset>';
print '<legend>ɽ</legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_timetype"></label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_timetype','','',$this->{'timetype'},
	'thread_mtime'		=>		'åɹ',
	'thread_ctime'		=>		'åɺ'
);
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_datetype">ɽ</label></td>';
print '<td class="field">';
$this->print_date_type_menu($name . '_',$this->{'datetype'},'','',1,$this->{'dateformat'});
print '</td>';
print '</tr>';
print '<tr><td class="field-name"><label for="' . $name . '_datelimit">ɽ</label></td>';
print '<td class="field"><input type="text" size="3" maxlength="3" name="' . $name . '_datelimit" id="' . $name . '_datelimit" value="' . $this->escape($this->{'datelimit'}) . '" /> ʤɽʤ礦/Τ/';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><input type="checkbox" name="' . $name . '_detail" id="' . $name . '_detail" value="1"' . ((defined $this->{'detail'} && $this->{'detail'}) ? ' checked="checked"' : '') . ' /></td>';
print '<td class="field"><label for="' . $name . '_detail">ɽˤɽ</label></td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';
print '<fieldset>';
print '<legend></legend>';
print '<label><input type="checkbox" name="' . $name . '_searchOption" value="1"' . ((defined $this->{'searchOption'} && $this->{'searchOption'}) ? ' checked="checked"' : '') . ' /> ܤ</label>';
print '</fieldset>';
$this->print_font_setting_form($name);
$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my $is_valid = 1;
$main::data{$this->{'id'} . '_detail'} = 0 if !$main::data{$this->{'id'} . '_detail'};
$main::data{$this->{'id'} . '_searchOption'} = 0 if !$main::data{$this->{'id'} . '_searchOption'};
if (defined $main::data{$this->{'id'} . '_datelimit'} && $main::data{$this->{'id'} . '_datelimit'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_datelimit'})) {
	push(@{$cgi::action->{'dialog'}},'򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_datelimit'};
	$is_valid = 0;
}
$is_valid = 0 if !$this->is_valid_font_setting;
return $is_valid;
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('xbb_threadxtime','ThreadXtime','åɺ/');
}

1;
