package TreeView;
require CMONOS::Baobab::BbCommon;
@ISA = qw(BbCommon);
use strict;
######################################################################
# ХХ֥ĥ꡼ɽ⥸塼
# TreeView.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ¹
sub run ($) {
my $this = shift;
my(%db,@list,$is_secure);
@list = ();

use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
require CMONOS::Baobab::BbTree;
my $view_obj = BbTree->new;

unless (ref tied %{$db{'tree'}}) {
	tie(%{$db{'tree'}}, $env::dbm_file, "$default::db/tree", O_RDONLY, $env::dbm_mode);
}
unless (ref tied %{$db{'thread_category'}}) {
	tie(%{$db{'thread_category'}}, $env::dbm_file, "$default::db/thread_category", O_RDONLY, $env::dbm_mode);
}

#åɥƥ꡼å
if ($main::n || $main::t) {
	my($top);
	if (defined $main::n && $main::n) {
		$top = $this->get_top($main::n,$db{'tree'}->{$main::n});
	} else {
		$top = $main::t;
	}

	if ($field::for{'category'} && %{$thread::category{'ORDER'}}) {
		my $category = $db{'thread_category'}->{$top};
		$is_secure = 1 if !defined $category || !ref $thread::category{$category} || !$thread::category{$category}{'closed'} || $this->is_secure('closed');
	} else {
		$is_secure = 1;
	}

	if (defined $is_secure && $is_secure) {
		$main::t = $top;
		@list = ($main::t);	
	}
}

$this->use_icon('baobab','bb_icon');
$this->use_deco();

#ڡåƥ
$this->set_css($view_obj->css);

#إå
$this->print_page_header('tree');

if (defined $is_secure && $is_secure) {

	#ɬפDBɤ߹
	$this->tie_db(\%db,$view_obj->required_field);

	#ڡȽ
	$main::p = $view_obj->list_count('',\%db,\@list,$main::p,$main::t,$main::n);

	#إå
	$view_obj->print_list_header(\*STDOUT,'',$main::p);

	#ꥹ
	$view_obj->print_articles(\*STDOUT,'',\%db,\@list,$main::p);

	#եå
	$view_obj->print_list_footer(\*STDOUT,'',$main::p);
}

#DB³
$this->untie_db(\%db);

#եå
$this->print_page_footer('tree');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#Ƽ省
	$setting::security_key = 'browse' if !defined $setting::security_key ||  $setting::security_key eq '';	#ǥեȥƥ

	#ڡꥭ
	$setting::key = 'tree' if !defined $setting::key ||  $setting::key eq '';

	#ǥեȥ
	$main::k = 'tree' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('tree','TreeView');
}

1;
