package PollBase;
require CMONOS::CGI_Lib::Field::UserGeneratedField;
@ISA = qw(UserGeneratedField);
use strict;
use Fcntl qw(:flock);
######################################################################
# ե⥸塼ʥ󥱡ȡ
# PollBase.pm 1.0.7
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-12-18
######################################################################
sub __set ($$) {
my($this,$setting) = @_;
unless (ref $cgi::Image) {
	require CMONOS::CGI_Lib::Image;
	$cgi::Image = Image->new;
}
unless (ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
unless (ref $cgi::BarGraph) {
	require CMONOS::CGI_Lib::BarGraph;
	$cgi::BarGraph = BarGraph->new;
}

#
$this->{'elements'} = 1;
$this->{'barColor'} = '#6699ff' if !defined $this->{'barColor'} ||  !$this->{'barColor'};
$this->{'bgColor'} = '#eeeeee' if !defined $this->{'bgColor'} ||  !$this->{'bgColor'};
$this->{'barWidth'} = 150 if !defined $this->{'barWidth'} ||  !$this->{'barWidth'};
$this->{'rule'} = 1 if !defined $this->{'rule'} || $this->{'rule'} eq '';
$this->{'cancelLimit'} = 604800 if !defined $this->{'rule'} || $this->{'rule'} eq '';
$this->{'voteButtonName'} = 'OK' if !defined $this->{'voteButtonName'} || $this->{'voteButtonName'} eq '';
$this->{'cols'} = 40 if !$this->{'cols'};
$this->{'rows'} = 1 if !$this->{'rows'};
$this->{'appendableUser'} = 'nocheck' if !$this->{'appendableUser'};
$this->{'generatableUser'} = 'nocheck' if !$this->{'generatableUser'};
$this->{'datetype'} = (($setting::general{'datetype'}) ? $setting::general{'datetype'} : '') if !$this->{'datetype'};
$this->set_ownerpower;
$this->set_external_file_status;
delete $this->{'deletable'};
return;
}

######################################################################
#	(2) obj->form;
sub pre_form_option ($$) {
my($this,$path) = @_;
delete $main::option{$this->{'id'}}{'new'} if defined $main::option{$this->{'id'}}{'new'} && $main::option{$this->{'id'}}{'new'} ne '' && -f $path . '/' . $this->{'id'} . '.dat';
}

sub additional_form ($$) {
my($this,$path) = @_;
local(*DAT);
my $memory_count = 0;
if (open(DAT, $path . '/' . $this->{'id'} . '.dat')) {
	binmode DAT;
	flock(DAT, LOCK_SH);
	while (my $line = <DAT>) {
		chomp $line;
		$memory_count++ if $line;
	}
	close(DAT);
}
my $memory = ($this->{'masterMemory'} && (!defined $main::data{$this->{'id'}}{'memory'} || $main::data{$this->{'id'}}{'memory'} eq '' || $main::data{$this->{'id'}}{'memory'} > $this->{'masterMemory'})) ? $this->{'masterMemory'} : $main::data{$this->{'id'}}{'memory'};
my $appendable = ($memory && $memory_count >= $memory) ? 0 : 1;
my $form = '<tr>';
$form .= '<td class="sub-field-name"><label for="data:' . $this->{'id'} . ':title"></label></td>';
$form .= '<td class="sub-field">';
$form .= '<input type="text" name="data:' . $this->{'id'} . ':title" id="data:' . $this->{'id'} . ':title" size="32" value="' . $this->escape($main::data{$this->{'id'}}{'title'}) . '" />';
$form .= '</td></tr><tr>';
$form .= '<td class="sub-field-name"><span class="datatitle">ɽ</span></td>';
$form .= '<td class="sub-field">';
$form .= '<ol class="checkbox">';
$form .= '<li><label><input type="checkbox" name="data:' . $this->{'id'} . ':shuffleDisabled" id="data:' . $this->{'id'} . ':shuffleDisabled" value="1"' . (($main::data{$this->{'id'}}{'shuffleDisabled'}) ? ' checked="checked"' : '') . ' /> ɼȤ˹ܤ򥷥åե<strong>ʤ</strong></label></li>';
$form .= '<li><label><input type="checkbox" name="data:' . $this->{'id'} . ':appendable" id="data:' . $this->{'id'} . ':appendable" value="1"' .  (($main::data{$this->{'id'}}{'appendable'}) ? ' checked="checked"' : '') . ' /> ɲùǽˤ</label></li>' if $this->{'appendable'};
$form .= '<li><label><input type="checkbox" name="data:' . $this->{'id'} . ':approvalRequired" id="data:' . $this->{'id'} . ':approvalRequired" value="1"' .  (($main::data{$this->{'id'}}{'approvalRequired'}) ? ' checked="checked"' : '') . ' /> ǧޤɲùܤɽʤ</label></li>' if $this->{'appendable'} && $this->{'pendingEnabled'};
$form .= '</ol>';
$form .= '<div class="warning">¸Ķḽ߹ܤɲä뤳Ȥޤ</div>' if $this->{'appendable'} && !$appendable;
$form .= '</td></tr><tr>';
$form .= '<td class="sub-field-name"><span class="datatitle">ɼ</span></td>';
$form .= '<td class="sub-field">';

if ($main::data{$this->{'id'}}{'closing'} && !$main::option{$this->{'id'}}{'year'} && !$main::option{$this->{'id'}}{'mon'} && !$main::option{$this->{'id'}}{'mday'} && !defined $main::option{$this->{'id'}}{'hour'} && !defined $main::option{$this->{'id'}}{'min'}) {
	my @localtime = localtime($main::data{$this->{'id'}}{'closing'});
	$main::option{$this->{'id'}}{'year'} = $localtime[5] + 1900;
	$main::option{$this->{'id'}}{'mon'} = $localtime[4] + 1;
	$main::option{$this->{'id'}}{'mday'} = $localtime[3];
	$main::option{$this->{'id'}}{'hour'} = $localtime[2];
	$main::option{$this->{'id'}}{'min'} = $localtime[1];
}
my $this_year = (localtime())[5] + 1900;
$form .= '<label><select name="option:' . $this->{'id'} . ':year" id="option:' . $this->{'id'} . ':year">';
$form .= '<option value=""></option>';
foreach (($this_year-10)..($this_year+10)) {
	$form .= '<option value="' . $_ . '"' . (($main::option{$this->{'id'}}{'year'} && $main::option{$this->{'id'}}{'year'} == $_) ? ' selected="selected"' : '') . '>' . $_ . '</option>';
}
$form .= '</select>ǯ</label> ';
$form .= '<label><select name="option:' . $this->{'id'} . ':mon" id="option:' . $this->{'id'} . ':mon">';
$form .= '<option value=""></option>';
foreach (1..12) {
	$form .= '<option value="' . $_ . '"' . (($main::option{$this->{'id'}}{'mon'} && $main::option{$this->{'id'}}{'mon'} == $_) ? ' selected="selected"' : '') . '>' . $_ . '</option>';
}
$form .= '</select></label> ';
$form .= '<label><select name="option:' . $this->{'id'} . ':mday" id="option:' . $this->{'id'} . ':mday">';
$form .= '<option value=""></option>';
foreach (1..31) {
	$form .= '<option value="' . $_ . '"' . (($main::option{$this->{'id'}}{'mday'} && $main::option{$this->{'id'}}{'mday'} == $_) ? ' selected="selected"' : '') . '>' . $_ . '</option>';
}
$form .= '</select></label>';
$form .= '<a href="javascript:void(0)" onclick="cmonos.tool.calendarPalette.open(\'option:' . $this->{'id'} . ':year\',\'option:' . $this->{'id'} . ':mon\',\'option:' . $this->{'id'} . ':mday\')" title="åȥդǤޤ"><img src="' . $env::image_dir . '/tool/calendar.gif" width="15" height="15" border="0" alt="ѥͥ" /></a>';
$form .= ' <label><select name="option:' . $this->{'id'} . ':hour">';
$form .= '<option value=""></option>';
foreach (0..23) {
	$form .= '<option value="' . $_ . '"' . ((defined $main::option{$this->{'id'}}{'hour'} && $main::option{$this->{'id'}}{'hour'} ne '' && $main::option{$this->{'id'}}{'hour'} eq $_) ? ' selected="selected"' : '') . '>' . $_ . '</option>';
}
$form .= '</select></label>';
$form .= '<label><select name="option:' . $this->{'id'} . ':min">';
$form .= '<option value=""></option>';
foreach (0..59) {
	$form .= '<option value="' . $_ . '"' . ((defined $main::option{$this->{'id'}}{'min'} && $main::option{$this->{'id'}}{'min'} ne '' && $main::option{$this->{'id'}}{'min'} eq $_) ? ' selected="selected"' : '') . '>' . $_ . '</option>';
}
$form .= '</select>ʬ</label>';
$form .= ' <select onchange="cmonos.form.item(this.form).setDateFromDay(this.options[this.selectedIndex].value,\'option:' . $this->{'id'} . ':year\',\'option:' . $this->{'id'} . ':mon\',\'option:' . $this->{'id'} . ':mday\',\'option:' . $this->{'id'} . ':hour\',\'option:' . $this->{'id'} . ':min\');">';
$form .= '<option value=""></option>';
$form .= '<option value="">ꥻå</option>';
$form .= '<option value="0"></option>';
$form .= '<option value="1"></option>';
$form .= '<option value="2">ä</option>';
$form .= '<option value="7">1ָ</option>';
$form .= '<option value="14">2ָ</option>';
$form .= '<option value="30">30</option>';
$form .= '<option value="183">Ⱦǯ</option>';
$form .= '<option value="365">1ǯ</option>';
$form .= '</select>';
if ($appendable) {
	$form .= '</tr>';
	$form .= '<tr><td class="sub-field-name"><label for="option:' . $this->{'id'} . ':new"></label></td>';
	$form .= '<td class="sub-field"><textarea name="option:' . $this->{'id'} . ':new" id="option:' . $this->{'id'} . ':new" cols="32" rows="6" wrap="off"' . (($this->{'is_invalid_field'}{'new'}) ? $this->set_invalid_class : '') . '>' . $this->escape(($main::option{$this->{'id'}}{'new'}) ? $main::option{$this->{'id'}}{'new'} : (!defined $main::data{$this->{'id'}}{'memory'}) ? $this->{'default'} : '') . '</textarea>';
	$form .= '<div class="note">ʹܤȤ˲ԡ</div>';
	$form .= '</td></tr>';
}
return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub _is_valid_data ($) {
my $this = shift;
$main::data{$this->{'id'}}{'appendable'} = 0 if !$this->{'appendable'} || !$main::data{$this->{'id'}}{'appendable'};
$main::data{$this->{'id'}}{'shuffleDisabled'} = 0 if !$main::data{$this->{'id'}}{'shuffleDisabled'};
if (defined $main::option{$this->{'id'}}{'new'} && $main::option{$this->{'id'}}{'new'} ne '') {
	my @new_item = grep($_ ne '',split(/\x0A+/,$main::option{$this->{'id'}}{'new'}));
	if ($this->{'type'} && $this->{'type'} eq 'j' && grep($this->is_not_japanese($_),@new_item)) {
		push(@{$cgi::action->{'dialog'}},'ܤܸǤϤʤܤޤޤƤޤ') if ref $cgi::action;
		$this->{'is_invalid_field'}{'new'} = 1;
		return 0;
	}
	my $path = $this->get_file_directory;
	my $dat_path = $path . '/' . $this->{'id'} . '.dat';
	my $data = '';
	my $newid = 0;
	my %name = ();
	my $time = time;
	my $e = 0;
	my $memory_count = 0;
	my $memory = ($this->{'masterMemory'} && (!defined $main::data{$this->{'id'}}{'memory'} || $main::data{$this->{'id'}}{'memory'} eq '' || $main::data{$this->{'id'}}{'memory'} > $this->{'masterMemory'})) ? $this->{'masterMemory'} : $main::data{$this->{'id'}}{'memory'};
	if (-f $dat_path) {
		local(*DAT);
		if (open(DAT, $dat_path)) {
			binmode DAT;
			flock(DAT, LOCK_SH);
			while (my $line = <DAT>) {
				chomp $line;
				my($id,$mtime,$approved,$name,$num,$ip,$agent) = $this->svsplit("\x09",$line,-1);
				$name{$this->get_unified_name($name)} = 1;
				$newid = $id;
				$memory_count++;
			}
			close(DAT);
			$e = 1;
		}
	}
	foreach my $item (@new_item) {
		my $uname = $this->get_unified_name($item);
		if ($memory && $memory_count >= $memory) {
			push(@{$cgi::action->{'dialog'}},'¸ãΤ ' . $this->name(1) . ' ˤĤιܤɲäǤޤǤ') if ref $cgi::action;
			last;
		}
		if ($uname ne '' && !$name{$uname}) {
			$data .= $this->svjoin("\x09",++$newid,$time,1,$item,0,'','') . "\x0A";
			$memory_count++;
		}
		$name{$uname}++;
	}
	if ($data) {
		if ($e) {
			local(*DAT);
			if (open(DAT, ">>$dat_path")) {
				binmode DAT;
				flock(DAT, LOCK_EX);
				print DAT $data;
				close(DAT);
				chmod((($env::ownerpower) ? 0600 : $env::file_mode), $dat_path);
				delete $main::option{$this->{'id'}}{'new'};
				push(@{$cgi::action->{'dialog'}},$this->name(1) . ' ˿ܤɲäޤ') if ref $cgi::action;
				$this->set_embed_files($main::data{$this->{'id'}}{'memory'},$main::data{$this->{'id'}},$path,$main::c,$main::n);
			}
		} else {
			my $name = 'data:' . $this->{'id'} . ':poll';
			$cgi::input->post_clipboard($name,0,$data,{
				'filename' => 'data.dat',
				'name' => $name,
				'type' => 'application/octet-stream',
			});
			$cgi::input->save_file($name,'!' . $this->{'id'} . '.dat');
		}
	} else {
		push(@{$cgi::action->{'dialog'}},$this->name(1) . ' ɲä줿ܤϴ¸ߤޤ') if ref $cgi::action;
		delete $main::option{$this->{'id'}}{'new'};
	}
}
if ($main::option{$this->{'id'}}{'year'} && $main::option{$this->{'id'}}{'mon'} && $main::option{$this->{'id'}}{'mday'}) {
	if ($this->is_impossible_mday($main::option{$this->{'id'}}{'year'},$main::option{$this->{'id'}}{'mon'},$main::option{$this->{'id'}}{'mday'})) {
		push(@{$this->{'dialog'}},'ɼ¤ʤդǤ');
		return 0;
	} else {
		use Time::Local;
		$this->dfill(\$main::option{$this->{'id'}}{'hour'},\$main::option{$this->{'id'}}{'min'});
		$main::data{$this->{'id'}}{'closing'} = timelocal(0,$main::option{$this->{'id'}}{'min'},$main::option{$this->{'id'}}{'hour'},$main::option{$this->{'id'}}{'mday'},($main::option{$this->{'id'}}{'mon'}-1),$main::option{$this->{'id'}}{'year'});	
	}
}
return 1;
}

sub get_unified_name ($$) {
my($this,$name) = @_;
return '' if !defined $name;
$name = $this->z_to_h($cgi::Jcode->set(\$name,'euc')->h2z->euc,'euc');
$name =~ s/\s+/ /g;
$name =~ s/^\s//;
$name =~ s/\s$//;
$name = lc $name;
return $name;
}

######################################################################
sub mk_table_object ($$) {
my($this,$id) = @_;
my $table;
if ($id) {
	if (ref $table::obj{$id}) {
		$table = $table::obj{$id};
	} elsif (ref $setting::table{$id}) {
		$this->use_table;
		$table = $table::obj{$id};
	}
}
if (!ref $table) {
	$table = Table->new;
	$table->set(
		'tableclass' => 'datatable',
		'trclass' => 'odd,even',
		'class0' => 'odd,even',
	);
}
return $table;
}

sub get_user_generated_field_data ($$$$;$$$) {
my($this,$memory,$data_ref,$path,$c,$n,$content_only) = @_;
my($ranking_table);
my $approval_required = ($data_ref->{'approvalRequired'}) ? 1 : 0;
my $shuffle_disabled = ($data_ref->{'shuffleDisabled'}) ? 1 : 0;
my $external_file_disabled = (!$default::static && $this->{'update_is_failed'}) ? 1 : $this->{'externalFileDisabled'};
my $content_id = $this->mk_user_generated_field_id($c,$n);
my $poll_count = 0;
my $memory_count = 0;
my $ranking = '';
my $poll = '';
my %poll_name = ();
my %poll_votes = ();
my $rank = 0;
my $count = 0;
my $prev = -1;
my $max_width = 0;
my $closed = ($data_ref->{'closing'} && $data_ref->{'closing'} <= time) ? 1 : 0;
my $form_enabled = (!$closed && (!$external_file_disabled || $this->is_as_secure_as($this->{'generatableUser'}))) ? 1 : 0;
my $appendable = ($this->{'appendable'} && $data_ref->{'appendable'} && (!$external_file_disabled || $this->is_as_secure_as($this->{'appendableUser'}))) ? 1 : 0;
$memory = $this->{'masterMemory'} if $this->{'masterMemory'} && (!defined $memory || $memory eq '' || $memory > $this->{'masterMemory'});
$this->use_deco($this->get_output_path);
local(*DAT);
if (open(DAT, $path . '/' . $this->{'id'} . '.dat')) {
	binmode DAT;
	flock(DAT, LOCK_SH);
	while (my $line = <DAT>) {
		chomp $line;
		my($id,$mtime,$approved,$name,$num,$ip,$agent) = $this->svsplit("\x09",$line,-1);
		$memory_count++;
		if (!$this->{'pendingEnabled'} || !$approval_required || $approved) {
			$poll_votes{$id} = $num;
			$poll_name{$id} = $name;
			$poll_count++;
			last if $memory && $poll_count >= $memory;
		}
	}
	close(DAT);
}
if (!$poll_count && (!$appendable || $content_only)) {
	$cgi::Deco->restore_output;
	return '';
}
$ranking_table = $this->mk_table_object($this->{'rankingTable'});
$ranking = $ranking_table->table;
foreach my $item_id (sort {$this->sort_by(\$poll_votes{$b},\$poll_votes{$a}) || $a cmp $b} keys %poll_votes) {
	if (!$max_width) {
		$max_width = ($this->{'max'}) ? $this->{'max'} : 150;
		$max_width = $poll_votes{$item_id} if $poll_votes{$item_id} > $max_width;
	}
	my $name = $poll_name{$item_id};
	$this->text_conv(\$name);
	$this->text_fix(\$name,$this->{'csv'});
	$count++;
	$rank = $count if $poll_votes{$item_id} != $prev;
	$ranking .= $ranking_table->tr;
	$ranking .= $ranking_table->td('<div class="poll-rank-' . $rank . '">' . $rank . '</div>');
	$ranking .= $ranking_table->td(
		$name . 
		$cgi::BarGraph->bargraph(
			$poll_votes{$item_id},
			$max_width,
			(($default::english) ? ' votes' : 'ɼ'),
			(($content_only && $content_only == 2) ? '' : $content_id . '-' . $item_id),
			$this->{'barColor'},
			$this->{'bgColor'},
			$this->{'barImage'},
			$this->{'bgImage'},
			(($external_file_disabled && $this->{'maxwidth'} && $this->{'maxwidth'} < $this->{'barWidth'}) ? $this->{'maxwidth'} : $this->{'barWidth'})
		)
	);
	$ranking .= $ranking_table->td($poll_votes{$item_id} . (($default::english) ? ' votes' : 'ɼ'));
	$ranking .= $ranking_table->_tr;
	$prev = $poll_votes{$item_id};
}
$ranking .= $ranking_table->_table;
if ($content_only && $content_only == 2) {
	$cgi::Deco->restore_output;
	return $ranking;
}
$ranking .= '<p class="poll-info">';
$ranking .= '<a id="' . $content_id . '-form-link" href="javascript:void(0)" onclick="cmonos.element.item(\'' . $content_id . '\',\'' . $content_id . '-form\').toggle()">' . (($default::english) ? ' Form' : 'եɽ') . '</a>' if $form_enabled;
$ranking .= '[' . $this->date($data_ref->{'closing'},(($this->{'externalFileDisabled'}) ? $this->{'datelimit'} : 0),'gmt' . $this->{'datetype'}) . 'λ]' if $closed;
$ranking .= $this->field_editor_link((($default::english) ? '[EDIT]' : '[Խ]'),$content_id . '-editor-link','display: none',$c,$n);
$ranking .= '</p>';
if ($content_only) {
	$cgi::Deco->restore_output;
	return $ranking;
}

$poll = (defined $data_ref->{'title'} && $data_ref->{'title'} ne '') ? '<p class="poll-title">' . $this->escape($data_ref->{'title'}) . '</p>' : '';
if ($form_enabled) {
	my $is_updated_record = ($external_file_disabled) ? $this->is_updated_record($c,$n) : 0;
	my $poll_table = $this->mk_table_object($this->{'pollTable'});
	my @item_list = ($shuffle_disabled) ? (sort {$a <=> $b} keys %poll_votes) : $this->shuffle(keys %poll_votes);
	$appendable = ($appendable && (!defined $memory || $memory eq '' || $memory_count < $memory)) ? 1 : 0;
	$poll .= $this->form_start(
		'key'		=>	(($external_file_disabled && $setting::security_key) ? $setting::security_key : ''),
		'id'		=>	$content_id . '-form',
		'name'		=>	$content_id . '-form',
		'method'	=> 'post',
		'class'		=> 'poll-form',
		'onsubmit'	=>	'return cmonos.form.item(this).submit(\'' . $content_id . '\',[],\'\',\'' . $this->to_host($ENV{'SERVER_NAME'}) . '\',\'' . (($env::cookie_path) ? $env::cookie_path : $this->home_directory) . '\');',
		'required'	=>	$this->get_query_keys
	);
	$poll .= $this->add_query_for_form($c,$n);
	$poll .= $this->add_query('post',{'id' => $this->{'id'}});
	
	#ߡ
	if ($appendable) {
		$poll .= '<fieldset class="user-generated-content-input-form">';
		$poll .= 'Your Name : <input type="text" name="name" size="30" /><br />';
		$poll .= 'Your E-Mail : <input type="text" name="emailaddress" size="30" /><br />';
		$poll .= 'Your Url : <input type="text" name="url" size="30" /><br />';
		$poll .= 'Your Comment : <textarea name="comment" rows="3" cols="30"></textarea>';
		$poll .= '</fieldset>';
	}
	
	$poll .= $poll_table->table;
	foreach my $item_id (@item_list) {
		my $name = $poll_name{$item_id};
		my $eid = $content_id . '-' . $item_id . '-poll';
		$this->text_conv(\$name);
		$this->text_fix(\$name,$this->{'csv'});
		$poll .= $poll_table->tr;
		$poll .= $poll_table->td('<input type="radio" name="poll:item" id="' . $eid . '" value="' . $item_id . '" />');
		$poll .= $poll_table->td('<label for="' . $eid . '">' . $name . '</label>');
		$poll .= $poll_table->_tr;
	}
	if ($appendable) {
		$poll .= $poll_table->tr;
		$poll .= $poll_table->td('<input type="radio" name="poll:item" id="' .  $content_id . '-other-poll" value="other" />');
		if ($this->{'rows'} && $this->{'rows'} > 1) {
			$poll .= $poll_table->td('<textarea name="poll:new" id="' . $content_id . '-new" cols="' . $this->{'cols'} . '" rows="' . $this->{'rows'} . '"' . (($is_updated_record && $this->{'is_invalid_field'}{'new'}) ? ' class="invalid-field"' : '') . ' onfocus="cmonos.form.checkboxSyncById(\'' .  $content_id . '-other-poll\',true);" onchange="cmonos.validate.field(this).bailOut()" title="' . (($default::english) ? 'Others' : '¾') . '">' . (($is_updated_record) ? $this->escape($main::poll{'new'}) : '') . '</textarea>' . $this->textarea_tool('poll:new','',$content_id . '-new'));
		} else {
			$poll .= $poll_table->td('<input type="text" size="' . $this->{'cols'} . '" id="' . $content_id . '-new" name="poll:new" value="' . (($is_updated_record) ? $this->escape($main::poll{'new'}) : '') . '" onfocus="cmonos.form.checkboxSyncById(\'' .  $content_id . '-other-poll\',true);" onchange="cmonos.validate.field(this).bailOut()"' . (($is_updated_record && $this->{'is_invalid_field'}{'new'}) ? ' class="invalid-field"' : '') . ' title="' . (($default::english) ? 'Others' : '¾') . '" />');
		}
		$poll .= $poll_table->_tr;
	}
	$poll .= $poll_table->_table;
	$poll .= '<div class="poll-submit">';
	$poll .= $cgi::Deco->submit_button('vote',$this->{'button'},$this->{'voteButtonName'},{'id' => $content_id . '-submit'},'','abs');
	$poll .= '</div>';
	$poll .= '<p class="poll-info">[' . $this->date($data_ref->{'closing'},(($this->{'externalFileDisabled'}) ? $this->{'datelimit'} : 0),'gmt' . $this->{'datetype'}) . 'ޤ]</p>' if $data_ref->{'closing'};
	$poll .= '<p class="poll-info"><a id="' . $content_id . '-content-link" href="javascript:void(0)" onclick="cmonos.element.item(\'' . $content_id . '\',\'' . $content_id . '-form\').toggle()">' . $this->name(1) . (($default::english) ? ' Result' : '̤򸫤') . '</a></p>';
	$poll .= '</form>';
	$poll .= '<div id="' . $content_id . '" class="poll-result">' . $ranking . '</div>';
	$poll .= $this->javascript('cmonos.form.toggleByUser("' . $content_id . '","",' . (($this->{'rule'}) ? 'true' : 'false') . ',' . (($this->{'hiddenResult'}) ? 'true' : 'false') . ');cmonos.form.showEditButton("' . $content_id . '-editor-link")');
} else {
	$poll .= '<form id="' . $content_id . '-form"></form><div id="' . $content_id . '" class="poll-result">' . $ranking . '</div>';
}
$cgi::Deco->restore_output;
return (wantarray) ? ($poll,$ranking) : $poll;
}

sub shuffle ($@) {
my $this = shift;
my @list;
push(@list, splice(@_, int(rand(@_)))) while @_;
return @list;
}

sub get_user_generated_field_data_for_text ($$$$) {
my($this,$memory,$data_ref,$path) = @_;
my(%poll_data);
my $approval_required = ($data_ref->{'approvalRequired'}) ? 1 : 0;
my $poll_count = 0;
my $memory_count = 0;
my $rank = 0;
my $count = 0;
my $prev = 0;
my $ranking = (defined $data_ref->{'title'} && $data_ref->{'title'} ne '') ? $data_ref->{'title'} . "\x0A" : '';
local(*DAT);
if (open(DAT, $path . '/' . $this->{'id'} . '.dat')) {
	binmode DAT;
	flock(DAT, LOCK_SH);
	while (my $line = <DAT>) {
		chomp $line;
		my($id,$mtime,$approved,$name,$num,$ip,$agent) = $this->svsplit("\x09",$line,-1);
		$memory_count++;
		if (!$this->{'pendingEnabled'} || !$approval_required || $approved) {
			$poll_data{$id} = $num;
			$poll_count++;
			last if $memory && $poll_count >= $memory;
		}
	}
	close(DAT);
}
foreach my $item_name (sort {$this->sort_by(\$poll_data{$b},\$poll_data{$a}) || $a cmp $b} keys %poll_data) {
	$this->text_conv(\$item_name);
	$this->detag(\$item_name);
	$count++;
	$rank = $count if $poll_data{$item_name} != $prev;
	$ranking .= $rank . '=' . $item_name . '(' . $poll_data{$item_name} . (($default::english) ? ' votes' : 'ɼ')  . ")\x0A";
	$prev = $poll_data{$item_name};
}
$ranking .= "\x0A";
return $ranking;
}

sub _confirmation ($$) {
my($this,$data) = @_;
my $form = '';
$form .= '<dt></dt><dd>' . $this->escape($main::data{$this->{'id'}}{'title'}) . '</dd>' if defined $main::data{$this->{'id'}}{'title'} && $main::data{$this->{'id'}}{'title'} ne '';
$form .= '<dt>ɽ</dt>';
$form .= '<dd>ɼȤ˹ܤ򥷥åե<strong>' . (($main::data{$this->{'id'}}{'shuffleDisabled'}) ? 'ʤ' : '') . '</strong></dd>';
$form .= '<dd>ɲùǽˤ</dd>' if $this->{'appendable'} && $main::data{$this->{'id'}}{'appendable'};
$form .= '<dd>ǧޤɲùܤɽʤ</dd>' if $this->{'appendable'} && $this->{'pendingEnabled'} && $main::data{$this->{'id'}}{'approvalRequired'};
if ($main::option{$this->{'id'}}{'year'}) {
	$form .= '<dt>ɼ</dt>';
	$form .= '<dd>' . $main::option{$this->{'id'}}{'year'} . 'ǯ' . $main::option{$this->{'id'}}{'mon'} . '' . $main::option{$this->{'id'}}{'mday'} . '';
	$form .= $main::option{$this->{'id'}}{'hour'} . '' . $main::option{$this->{'id'}}{'min'} . 'ʬ';
	$form .= '<input type="hidden" name="option:' . $this->{'id'} . ':year" value="' . $main::option{$this->{'id'}}{'year'} . '" />';
	$form .= '<input type="hidden" name="option:' . $this->{'id'} . ':mon" value="' . $main::option{$this->{'id'}}{'mon'} . '" />';
	$form .= '<input type="hidden" name="option:' . $this->{'id'} . ':mday" value="' . $main::option{$this->{'id'}}{'mday'} . '" />';
	$form .= '<input type="hidden" name="option:' . $this->{'id'} . ':hour" value="' . $main::option{$this->{'id'}}{'hour'} . '" />';
	$form .= '<input type="hidden" name="option:' . $this->{'id'} . ':min" value="' . $main::option{$this->{'id'}}{'min'} . '" />';
	$form .= '</dd>';
}
if ($main::option{$this->{'id'}}{'new'}) {
	$form .= '<dt></dt><dd><ol><li>';
	$form .= join('</li><li>',map($this->escape($_),split(/\x0A/,$main::option{$this->{'id'}}{'new'})));
	$form .= '</li></ol>';
	$form .= '<input type="hidden" name="option:' . $this->{'id'} . ':new" value="' . $this->escape($main::option{$this->{'id'}}{'new'}) . '" />';
	$form .= '</dd>';
}
return $form;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my $this = shift;

#̾
my $name = 'data:' . $this->{'id'};

$this->print_field_info_form($name);

print '<fieldset>';
print '<legend></legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">ɽ</span></td>';
print '<td class="field"><label><input type="checkbox" name="' . $name . '_appendable" id="' . $name . '_appendable" value="1"' . (($this->{'appendable'}) ? ' checked="checked"' : '') . ' /> ɲùǽˤ</label></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><span class="datatitle"></span></td>';
print '<td class="field"> <input type="text" size="3" name="' . $name . '_cols" value="' . $this->escape($this->{'cols'}) . '" /> ʸ  ⤵ <input type="text" size="3" name="' . $name . '_rows" value="' . $this->escape($this->{'rows'}) . '" /> ʸ</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">ϥå</span></td>';
print '<td class="field"><label><input type="checkbox" name="' . $name . '_type" id="' . $name . '_type" value="j"' . (($this->{'type'} && $this->{'type'} eq 'j') ? ' checked="checked"' : '') . ' /> ܸʸɬ</label></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_masterMemory">¸</label></td>';
print '<td class="field"><input type="text" name="' . $name . '_masterMemory" id="' . $name . '_masterMemory" value="' . $this->escape($this->{'masterMemory'}) . '" size="3" title="Ƶͥ褹¸ꤷޤ" /> <span class="unit"></span></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_maxlength">ʸ</label></td>';
print '<td class="field"><input type="text" name="' . $name . '_maxlength" id="' . $name . '_maxlength" value="' . $this->escape($this->{'maxlength'}) . '" size="3" title="ʸ¤ޤ" /> <span class="unit">ʸȾѡ</span></td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_appendableUser">ɲø</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_appendableUser','','',$this->{'appendableUser'},
	'master'	=>		'ޥ',
	'owner'		=>		'',
	'owners'	=>		'Ʊʡ',
	'member'	=>		'ϿС',
	'nocheck'	=>		'åʤ'
);
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><span class="datatitle">ɽΥߥ</span></td>';
print '<td class="field"><label><input type="checkbox" name="' . $name . '_pendingEnabled" id="' . $name . '_pendingEnabled" value="1"' . ((defined $this->{'pendingEnabled'} && $this->{'pendingEnabled'}) ? ' checked="checked"' : '') . ' /> ǧޤɽʤȤǽˤ</label></td>';
print '</tr>';
print '</tbody>';
if (!$default::static) {
	print '<tbody>';
	print '<tr class="tbody-end">';
	print '<td class="field-name"><span class="datatitle"></span></td>';
	print '<td class="field"><ol class="checkbox">';
	print '<li><label><input type="checkbox" name="' . $name . '_externalFileDisabled" id="' . $name . '_externalFileDisabled" value="1"' . ((defined $this->{'externalFileDisabled'} && $this->{'externalFileDisabled'}) ? ' checked="checked"' : '') . ' /> JavaScript ˤߤǤϤʤ褹 ( JavaScript եʤ)</label></li>';
	print '<li><label><input type="checkbox" name="' . $name . '_mTime" id="' . $name . '_mTime" value="1"' . ((defined $this->{'mTime'} && $this->{'mTime'}) ? ' checked="checked"' : '') . ' /> ɲû˹ǡ١򹹿</label></li>';
	print '</ol>';
	print '</td>';
	print '</tr>';
	print '</tbody>';
}
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_mailtoMaster">ɲ</label></td>';
print '<td class="field">';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_mailtoMaster" id="' . $name . '_mailtoMaster" value="1"' . ((defined $this->{'mailtoMaster'} && $this->{'mailtoMaster'}) ? ' checked="checked"' : '') . ' />ͥɥ쥹</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_mailtoOwners" value="1"' . ((defined $this->{'mailtoOwners'} && $this->{'mailtoOwners'}) ? ' checked="checked"' : '') . ' />Ʊʡɥ쥹</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_mailToUser" value="1"' . ((defined $this->{'mailToUser'} && $this->{'mailToUser'}) ? ' checked="checked"' : '') . ' />桼ꥢɥ쥹</label></li>';
print '</ol>';
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_taboowords">ػʸ</label></td>';
print '<td class="field"><textarea name="' . $name . '_taboowords" id="' . $name . '_taboowords" cols="56" rows="4" wrap="off">' . $this->escape($this->{'taboowords'}) . '</textarea>';
print '<div class="extra-field"><label><input type="checkbox" name="' . $name . '_tabooregexp" value="1"' . ((defined $this->{'tabooregexp'} && $this->{'tabooregexp'}) ? ' checked="checked"' : '') . ' /> ɽѤ</label></div>';
print '<div class="note">ػʸ󤴤Ȥ˲</div>';
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_convtable">ʸѴɽ</label></td>';
print '<td class="field"><textarea name="' . $name . '_convtable" id="' . $name . '_convtable" cols="56" rows="4" wrap="off" title="񼰤˽äʸѴɽꤷޤ">' . $this->escape($this->{'convtable'}) . '</textarea>';
print '<div class="extra-field"><label><input type="checkbox" name="' . $name . '_convregexp" value="1"' . ((defined $this->{'convregexp'} && $this->{'convregexp'}) ? ' checked="checked"' : '') . ' /> ɽѤ</label></div>';
print '<div class="note">񼰡Ѵоʸ=&gt;Ѵʸ[]</div>';
print '<div class="example">ˡ=>ʶ/SPAM=>spamʸ</div>';
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_default">ǥեȤ</label></td>';
print '<td class="field"><textarea name="' . $name . '_default" id="' . $name . '_default" cols="56" rows="6" wrap="off">' . $this->escape($this->{'default'}) . '</textarea></td>';
print '<div class="note">ʹܤȤ˲ԡ</div>';
print '</td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';
$this->print_html_tag_setting_form($name,'(ɲù)');
$this->print_table_setting_form($name,'(ơ֥)');

print '<fieldset>';
print '<legend>ɼ</legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_rule">Ϣ³ɼ</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_rule','Ϣ³ɼ','',$this->{'rule'},
	'0'	=> '¤ʤ',
	'1'	=> 'Ʊ IP Ϣ³ɼ',
	'2'	=> ' IP Ϣ³ɼ'
);
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_cancelLimit">´</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_cancelLimit','´','',$this->{'cancelLimit'},
	'0'			=> '̵',
	'86400'		=> '1',
	'259200'	=> '3',
	'604800'	=> '7',
	'1209600'	=> '14',
	'2592000'	=> '30',
	'5184000'	=> '60',
	'7776000'	=> '90'
);
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_generatableUser">ѥ</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_generatableUser','','',$this->{'generatableUser'},
	'master'	=>		'ޥ',
	'owner'		=>		'',
	'owners'	=>		'Ʊʡ',
	'member'	=>		'ϿС',
	'nocheck'	=>		'åʤ'
);
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
if (!$default::static) {
	print '<tr>';
	print '<td class="field-name"><span class="datatitle">ɽ</span></td>';
	print '<td class="field"><label for="' . $name . '_datelimit"><input type="text" size="3" maxlength="3" name="' . $name . '_datelimit" id="' . $name . '_datelimit" value="' . $this->escape($this->{'datelimit'}) . '" /> ʤɽʤ礦/Τ/</label></td>';
	print '</tr>';
}
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_datetype">ɽ</label></td>';
print '<td class="field">';
$this->print_date_type_menu($name . '_',$this->{'datetype'});
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><span class="datatitle">׷ɽ</span></td>';
print '<td class="field"><ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_hiddenResult" id="' . $name . '_hiddenResult" value="1"' . ((defined $this->{'hiddenResult'} && $this->{'hiddenResult'}) ? ' checked="checked"' : '') . ' /> ɼƤʤ桼ˤϽ׷̤ɽʤ</label></li>';
print '</ol>';
print '</td>';
print '</tr>';
print '</tbody>';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_pollTable">ɼեơ֥</label></td>';
print '<td class="field">';
$this->print_table_menu($name,'pollTable');
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="' . $name . '_pollTable">׷̥ơ֥</label></td>';
print '<td class="field">';
$this->print_table_menu($name,'rankingTable');
print '</td>';
print '</tr>';
print '</tbody>';
print '</tbody></table>';
print '</fieldset>';

$cgi::BarGraph->print_bargraph_setting_form($this->{'id'},'','',0,$this);
print '<fieldset>';
print '<legend><label for="' . $name . '_max">պ</label></legend>';
print '<input type="text" name="' . $name . '_max" value="' . $this->escape($this->{'max'}) . '" size="6" /> ɼ';
print '</fieldset>';

print '<fieldset>';
print '<legend>ܥ</legend>';
print '<fieldset>';
print '<legend><label for="' . $name . '_voteButtonName">ɼܥ̾</label></legend>';
print '<input type="text" name="' . $name . '_voteButtonName" value="' . $this->escape($this->{'voteButtonName'}) . '" size="50" /></fieldset>';
print '<fieldset>';
print '<legend>ɼܥ</legend>';
print $cgi::Deco->button_menu(
	$name . '_button',
	'vote',
	120,
	$this->{'button'}
);
print '</fieldset>';
print '</fieldset>';

$this->print_setting_save_button;
}

######################################################################
#	(6) obj->is_valid_setting;
sub _is_valid_sub_setting ($) {
my $this = shift;
my $is_valid = 1;
if (defined $main::data{$this->{'id'} . '_max'} && $main::data{$this->{'id'} . '_max'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_max'})) {
	push(@{$cgi::action->{'dialog'}},'պͤ򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_max'};
	$is_valid = 0;
}
$this->detag(\$main::data{$this->{'id'} . '_voteButtonName'}) if defined $main::data{$this->{'id'} . '_voteButtonName'} && $main::data{$this->{'id'} . '_voteButtonName'};
$main::data{$this->{'id'} . '_hiddenResult'} = '' if !defined $main::data{$this->{'id'} . '_hiddenResult'} || $main::data{$this->{'id'} . '_hiddenResult'} eq '';
return $is_valid;
}

######################################################################
#	(11) obj->update;
sub update ($;$) {
my($this,$is_ajax) = @_;
$this->save_update_target;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};

#ϤΥå
my $input_is_valid = 1;
my $new_item = '';
if ($main::name || $main::emailaddress || $main::url || $main::comment) {
	push(@{$cgi::action->{'dialog'}},'Error!') if ref $cgi::action;
	$input_is_valid = 0;
} elsif (!defined $main::poll{'item'} || $main::poll{'item'} eq '') {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please select one.' : '򤵤Ƥޤ')) if ref $cgi::action;
	$this->{'is_invalid_field'}{'poll'} = 1;
	$input_is_valid = 0;
} elsif ($main::poll{'item'} eq 'other') {
	$new_item = (defined $main::poll{'new'}) ? $this->get_unified_name($main::poll{'new'}) : '';
	if (!$this->{'appendable'}) {
		push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please select one.' : 'ߡܤɲä뤳Ȥ϶ػߤƤޤ')) if ref $cgi::action;
		$this->{'is_invalid_field'}{'new'} = 1;
		$input_is_valid = 0;
	} elsif ($this->{'appendableUser'} && !$this->is_as_secure_as($this->{'appendableUser'})) {
		push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please select one.' : 'ܤɲä븢¤ޤ')) if ref $cgi::action;
		$this->{'is_invalid_field'}{'new'} = 1;
		$input_is_valid = 0;
	} elsif ($new_item eq '') {
		push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please input new name.' : 'ܤϤƤ')) if ref $cgi::action;
		$this->{'is_invalid_field'}{'new'} = 1;
		$input_is_valid = 0;
	} elsif ($this->{'type'} && $this->{'type'} eq 'j' && $this->is_not_japanese($new_item)) {
		push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error!' : 'ܤܸˤƤ')) if ref $cgi::action;
		$this->{'is_invalid_field'}{'new'} = 1;
		$input_is_valid = 0;
	} elsif ($this->is_taboo_string($main::poll{'new'},$this->{'taboowords'},$this->{'tabooregexp'})) {
		push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! Please select one.' : 'ܤ˶ػߤ줿礬¸ߤޤ')) if ref $cgi::action;
		$this->{'is_invalid_field'}{'new'} = 1;
		$input_is_valid = 0;
	} elsif ($this->{'maxlength'} && $this->{'maxlength'} < length($main::poll{'new'})) {
		push(@{$cgi::action->{'dialog'}},(($default::english) ? 'New item is too long.' : 'ܤĹ᤮ޤ')) if ref $cgi::action;
		$this->{'is_invalid_field'}{'new'} = 1;
		$input_is_valid = 0;
	}
} else {
	delete $main::poll{'new'};
}

#ϥ顼
if (!$input_is_valid) {
	$this->{'update_is_failed'} = 1 if !$default::static && !$is_ajax;
	return ($is_ajax) ? {
		'status'			=>	'error',
		'error_fields'		=>	$this->get_invalid_field_list('poll'),
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level
	} : 0;
}

#Ǽɤ߹
my $setting = $this->get_field_data;
my $file_dir = $this->get_file_directory;
my $dat_path = $file_dir . '/' . $this->{'id'} . '.dat';
my $memory = ($this->{'masterMemory'} && (!defined $setting->{'memory'} || $setting->{'memory'} eq '' || $setting->{'memory'} > $this->{'masterMemory'})) ? $this->{'masterMemory'} : $setting->{'memory'};

#Ǽĺ
if (!ref $setting || (defined $setting->{'memory'} && $setting->{'memory'} eq '0')) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! This poll was closed.' : $this->name(1) . ' ĺƤޤ')) if ref $cgi::action;
	return ($is_ajax) ? {
		'status'			=>	'error',
		'hide_form'			=>  1,	
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level
	} : 0;
}
if ($setting->{'closing'} && $setting->{'closing'} <= time) {
	my $content = $this->set_embed_files($memory,$setting,$file_dir,$main::c,$main::n,1);
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Error! This poll was closed.' : $this->name(1) . ' ڤޤ')) if ref $cgi::action;
	return ($is_ajax) ? {
		'status'			=>	'error',
		'hide_form'			=>  1,	
		'show_content'		=>  1,	
		'content'			=>  $content,	
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level
	} : 0;
}

local(*DAT);
my $update_id = '';
my $is_repeater = 0;
my $memory_count = 0;
my $newid = 0;
my $approval_required = ($this->{'pendingEnabled'} && $setting->{'approvalRequired'}) ? 1 : 0;
my $now = time;
if (open(DAT, $dat_path)) {
	binmode DAT;
	flock(DAT, LOCK_SH);
		while (my $line = <DAT>) {
		chomp $line;
		$memory_count++;
		my($id,$mtime,$approved,$name,$num,$ip,$agent) = $this->svsplit("\x09",$line,-1);
		if ($new_item ne '' && $new_item eq $this->get_unified_name($name)) {
			delete $main::poll{'new'};
			delete $main::poll{'item'};
			$new_item = '';
			$update_id = $id;
			if ($approved) {
				push(@{$cgi::action->{'dialog'}},(($default::english) ? 'There is a same item.' : 'ܤƱƤιܤ¸ߤƤޤƱƤιܤ˲ûޤ')) if ref $cgi::action;
			} else {
				push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Thank you for your new item.' : 'ܤƤǧ줿塢ɽޤ')) if ref $cgi::action;
			}
		}
		if (defined $main::poll{'item'} && $main::poll{'item'} eq $id) {
			if ($approval_required && !$approved) {
				$input_is_valid = 0;
				last;
			} else {
				$update_id = $id;
			}
		}
		if ($this->{'rule'} && $ip) {
			$ip =~ s/\d+/\\d+/g if $ip =~ /\d/ && $ip =~ /[^\.\d]/ && $this->{'rule'} == 2;
			if ($this->client_ip_is_matched($ip) && (!$this->{'cancelLimit'} || !$mtime || $now - $mtime > $this->{'cancelLimit'})) {
				$is_repeater = 1;
				last;
			}
		}
		$newid = $id;
	}
	close(DAT);
}
if ($is_repeater) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Do not vote twice.' : 'Ϣ³ɼϤθ')) if ref $cgi::action;
	$this->{'update_is_failed'} = 1 if !$default::static && !$is_ajax;
	return ($is_ajax) ? {
		'status'			=>	'error',
		'message'			=>	$this->get_message_string,
		'show_content'		=>	1,
		'hide_form'			=>	1,
		'submitted'			=>	1,
		'authorized_level'	=>	$this->get_authorized_level
	} : 0;
} elsif (!$input_is_valid) {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'You can not vote this item.' : 'ǧƤʤܤɼ뤳ȤϤǤޤ')) if ref $cgi::action;
	$this->{'update_is_failed'} = 1 if !$default::static && !$is_ajax;
	return ($is_ajax) ? {
		'status'			=>	'error',
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level
	} : 0;
} elsif ($update_id eq '' && $new_item eq '') {
	push(@{$cgi::action->{'dialog'}},(($default::english) ? 'You can not vote this item.' : 'ɼ줿ܤ¸ߤޤ')) if ref $cgi::action;
	$this->{'update_is_failed'} = 1 if !$default::static && !$is_ajax;
	return ($is_ajax) ? {
		'status'			=>	'error',
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level
	} : 0;
}

#
my $viewer_url = $this->get_viewer_url($main::c,$main::n);
my $editor_url = $this->get_user_generated_field_editor_url(1);
my $user_ip = $this->to_host($ENV{'REMOTE_ADDR'});
my $user_agent = $ENV{'HTTP_USER_AGENT'};
my $content = '';
my $set_embed_files = 1;
if (defined $main::poll{'new'} && $main::poll{'new'} ne '') {
	if (defined $memory && $memory ne '' && $memory_count >= $memory) {
		push(@{$cgi::action->{'dialog'}},(($default::english) ? 'This poll was closed.' : 'ܿ¸ãΤǡʾ񤭹ळȤޤ')) if ref $cgi::action;
		return ($is_ajax) ? {
			'status'			=>	'error',
			'hide_form'			=>	1,
			'show_content'		=>	1,
			'message'			=>	$this->get_message_string,
			'authorized_level'	=>	$this->get_authorized_level
		} : 0;
	}
	if (open(DAT, ">>$dat_path")) {
		binmode DAT;
		flock(DAT, LOCK_EX);
		print DAT $this->svjoin("\x09",++$newid,$now,(($approval_required) ? 0 : 1),$main::poll{'new'},1,$user_ip,$user_agent) . "\x0A";
		close(DAT);
		chmod((($env::ownerpower) ? 0600 : $env::file_mode), $dat_path);
	} else {
		push(@{$cgi::action->{'dialog'}},'ܤ¸˼Ԥޤ') if ref $cgi::action;
		$this->{'update_is_failed'} = 1 if !$default::static && !$is_ajax;
		return ($is_ajax) ? {
			'status'			=>	'error',
			'message'			=>	$this->get_message_string,
			'authorized_level'	=>	$this->get_authorized_level
		} : 0;
	}

	#Υ᡼
	if ($this->{'mailtoMaster'} || $this->{'mailtoOwners'} || ($this->{'mailToUser'} && $setting->{'mailto'} && $setting->{'mailto'} ne '')) {
		my $bcc = (($this->{'mailToUser'} && $setting->{'mailto'} && $setting->{'mailto'} ne '') ? $this->get_mail_field_data($setting->{'mailto'}) : '');
		$bcc .= (($bcc) ? ',' : '') . $setting::general{'master'} if defined $this->{'mailtoMaster'} && $this->{'mailtoMaster'} && $setting::general{'master'};
		$bcc .= (($bcc) ? ',' : '') . $setting::general{'owners'} if defined $this->{'mailtoOwners'} && $this->{'mailtoOwners'} && $setting::general{'owners'};
		if ($bcc) {
			unless (ref $cgi::SendMail) {
				require CMONOS::CGI_Lib::SendMail;
				$cgi::SendMail = SendMail->new(
					((defined $env::sendmail) ? $env::sendmail : ''),
					((defined $env::master_email) ? $env::master_email : ''),
					'',
					((ref $cgi::input) ? $cgi::input : ''),
					1
				);
			}
			my $msg = $this->name . '˿ܤɲäޤ' . "\x0A";
			$msg .= 'ܤɲä줿ڡ : ' . $viewer_url . "\x0A";
			$msg .= 'Խġ : ' . $editor_url . "\x0A" if $approval_required;
			$msg .= "\x0A\x0A";
			$msg .= ' : ' . $main::poll{'new'} . "\x0A\x0A";
			$cgi::SendMail->send_mail(
				'Bcc'		=>  $bcc,
				'From'		=>  $env::master_email,
				'Subject'	=>  $this->name . '˿ܤɲäޤ',
				'message'	=>  $msg,
				'info'		=>	1
			);
			push(@{$this->{'dialog'}},$cgi::SendMail->dialog);
		}
	}
	if ($approval_required) {
		$this->save_pending_db($editor_url,$this->get_title_field_data);
		push(@{$cgi::action->{'dialog'}},(($default::english) ? 'Thank you for your new item.' : 'ܤƤǧ줿塢ɽޤ')) if ref $cgi::action;
		$set_embed_files = 0;
	}

} else {
	$this->{'mTime'} = 0 if !$default::static;
	my $temp_path = $file_dir . '/' . $this->{'id'} . '.temp.dat';
	my $done = 0;
	local(*TEMP);
	if (open(TEMP, ">>$temp_path")) {
		binmode TEMP;
		flock(TEMP, LOCK_EX);
		truncate(TEMP, 0);
		seek(TEMP, 0, 0);
		if (open(DAT, $dat_path)) {
			binmode DAT;
			flock(DAT, LOCK_SH);
			my $line;
			while ($line = <DAT>) {
				chomp $line;
				my($id,$mtime,$approved,$name,$num,$ip,$agent) = $this->svsplit("\x09",$line,-1);
				if ($update_id eq $id) {
					print TEMP $this->svjoin("\x09",$id,$now,$approved,$name,++$num,$user_ip,$user_agent), "\x0A";
				} else {
					print TEMP $line, "\x0A";
				}
			}
			close(DAT);
			$done = 1;
		}
		close(TEMP);
	}
	if ($done) {
		rename($temp_path,$dat_path);
		chmod((($env::ownerpower) ? 0600 : $env::file_mode), $dat_path);
	}
}
if ($set_embed_files) {
	$content = $this->set_embed_files($memory,$setting,$file_dir,$main::c,$main::n,1);
	$this->post_update;
}
delete $main::poll{'item'};
delete $main::poll{'new'};
return ($is_ajax) ? {
	'status'			=>	'success',
	'show_content'		=>	1,
	'content'			=>	$content,
	'hide_form'			=>	1,
	'submitted'			=>	1,
	'message'			=>	$this->get_message_string,
	'authorized_level'	=>	$this->get_authorized_level
} : 1;
}

######################################################################
sub set_user_generated_field_editor_page_settings ($) {
my $this = shift;
	$setting::page{'ugfieldeditor'}{'title'} = $this->detag($this->get_title_field_data);
#	$setting::page{'ugfieldeditor'}{'text'} = '#000000'; 
#	$setting::page{'ugfieldeditor'}{'link'} = '#0000ff';
#	$setting::page{'ugfieldeditor'}{'alink'} = '#99ffff';
#	$setting::page{'ugfieldeditor'}{'vlink'} = '#000099';
#	$setting::page{'ugfieldeditor'}{'hover'} = '#00ffff';
#	$setting::page{'ugfieldeditor'}{'nodeco'} = 'no';
#	$setting::page{'ugfieldeditor'}{'bgcolor'} = '#ffffff';
	$setting::page{'ugfieldeditor'}{'bodyId'} = 'poll-editor';
	$setting::page{'ugfieldeditor'}{'cssFileName'} = 'poll-editor.css';
# 	$setting::page{'ugfieldeditor'}{'CSS'} = 'h1 { font-size: large; font-weight: bold; text-indent: 1em; font-family: "ҥ饮γѥ Pro W3",Osaka,"ͣ Хå",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'h2 { font-size: medium; font-weight: bold; font-family: "ҥ饮γѥ Pro W3",Osaka,"ͣ Хå",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'hr { border-width: 1 0 0 0; }';
# 	$setting::page{'ugfieldeditor'}{'background'} = '';
# 	$setting::page{'ugfieldeditor'}{'bgproperties'} = '';
# 	$setting::page{'ugfieldeditor'}{'topmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'leftmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'javascript'} = '';
# 	$setting::page{'ugfieldeditor'}{'header'} = '';
# 	$setting::page{'ugfieldeditor'}{'headerFileName'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImageAlign'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImage'} = '';
# 	$setting::page{'ugfieldeditor'}{'align'} = '';
# 	$setting::page{'ugfieldeditor'}{'width'} = '';
# 	$setting::page{'ugfieldeditor'}{'deco'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleText'} = '';
return 1;
}

sub user_generated_field_edit ($) {
my $this = shift;
return 0 if !$this->is_editable || $this->{'delete_only'};
local(*DAT,*TEMP);
my $done = 0;
my $set_embed_files = 0;
my $approval_required = ($this->{'pendingEnabled'} && $this->{'field_data'}->{'approvalRequired'}) ? 1 : 0;
my $temp_path = $this->{'file_directory'} . '/' . $this->{'id'} . '.temp.dat';
my $new_item = (defined $main::data{'new'}) ? $this->get_unified_name($main::data{'new'}) : '';
my $newid = 0;
if (open(TEMP, ">>$temp_path")) {
	binmode TEMP;
	flock(TEMP, LOCK_EX);
	truncate(TEMP, 0);
	seek(TEMP, 0, 0);
	if (open(DAT, $this->{'dat_path'})) {
		binmode DAT;
		flock(DAT, LOCK_SH);
		my $line;
		while ($line = <DAT>) {
			chomp $line;
			my @data = $this->svsplit("\x09",$line,-1);
			$newid = $data[0];
			if ($new_item ne '' && $new_item eq $this->get_unified_name($data[3]) && (!$main::data{$data[0]} || $main::data{$data[0]} ne 'delete')) {
				delete $main::data{'new'};
				undef $new_item;
			}
			if ($main::data{$data[0]}) {
				if ($main::data{$data[0]} eq 'delete') {
					$set_embed_files = 1 if !$approval_required || $data[2];
					next;
				} elsif ($approval_required) {
					if ($main::data{$data[0]} eq 'approve') {
						$set_embed_files = 1 if !$data[2];
						$data[2] = 1; 
					} else {
						$set_embed_files = 1 if $data[2];
						$data[2] = 0; 
					}
				} else {
					$data[2] = 1;
				}
				print TEMP $this->svjoin("\x09",@data),"\x0A";
			} else {
				print TEMP $line,"\x0A";
			}
		}
		close(DAT);
		if ($new_item ne '') {
			print TEMP $this->svjoin("\x09",++$newid,time,1,$main::data{'new'},0,'','') . "\x0A";
			delete $main::data{'new'};
			undef $new_item;
			$set_embed_files = 1;
		}
		$done = 1;
	}
	close(TEMP);
}
if ($done) {
	rename($temp_path,$this->{'dat_path'});
	chmod((($env::ownerpower) ? 0600 : $env::file_mode), $this->{'dat_path'});
}
$this->set_embed_files($this->{'field_data'}->{'memory'},$this->{'field_data'},$this->{'file_directory'},$main::c,$main::n) if $set_embed_files;
$this->post_update;
return 1;
}

sub print_user_generated_field_editor ($) {
my $this = shift;
$this->mk_settings_for_editor;
my $approval_required = ($this->{'pendingEnabled'} && $this->{'field_data'}->{'approvalRequired'}) ? 1 : 0;
my $memory = ($this->{'masterMemory'} && (!defined $this->{'field_data'}->{'memory'} || $this->{'field_data'}->{'memory'} eq '' || $this->{'field_data'}->{'memory'} > $this->{'masterMemory'})) ? $this->{'masterMemory'} : $this->{'field_data'}->{'memory'};
my $memory_count = 0;
$cgi::action->print_page_header('ugfieldeditor','','',0,'',$this->name . 'Խ');
print $this->form_start(
	'key'	=>	'ugfieldeditor',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=>	'return cmonos.form.item(this).isNotSubmitted()'
);
print $this->get_query_for_user_generated_field_editor(1);
print '<input type="hidden" name="action" value="edit" />';
print '<table class="poll-editor"><tbody>';
local(*DAT);
if (open(DAT, $this->{'dat_path'})) {
	binmode DAT;
	flock(DAT, LOCK_SH);
	while (my $line = <DAT>) {
		chomp $line;
		my($id,$mtime,$approved,$name,$num,$ip,$agent) = $this->svsplit("\x09",$line,-1);
		$memory_count++;
		print '<tr class="' . (($approval_required && !$approved) ? 'pending-item' : 'approved-item') . '" id="item-' . $id . '">';
		print '<td class="controller">';
		print '<label><input type="radio" name="data:' . $id . '" value="' . (($approved) ? '' : 'approve') . '"' . ((!$approval_required || $approved) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'item-' . $id . '\').changeClassName(\'approved-item\',this.checked);" />ǧ</label>';
		print '<br /><label><input type="radio" name="data:' . $id . '" value="' . ((!$approved) ? '' : 'pending') . '"' . ((!$approved) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'item-' . $id . '\').changeClassName(\'pending-item\',this.checked);" />α</label>' if $approval_required;
		print '<br /><label><input type="radio" name="data:' . $id . '" value="delete" onclick="cmonos.element.item(\'item-' . $id . '\').changeClassName(\'delete-item\',this.checked);" /></label>';
		print '</td>';
		$this->text_conv(\$name);
		$this->text_fix(\$name,$this->{'csv'});
		print '<td class="item">';
		print '<div class="item-id">' . $id . '</div>';
		print '<div class="item-name">' . $name . '</div>';
		print $cgi::BarGraph->bargraph(
			$num,
			(($this->{'max'}) ? $this->{'max'} : 150),
			(($default::english) ? ' votes' : 'ɼ'),
			'vote-' . $id,
			$this->{'barColor'},
			$this->{'bgColor'},
			$this->{'barImage'},
			$this->{'bgImage'},
			$this->{'barWidth'}
		);
		print '<div class="latest-user-info">' . $this->date($mtime,(($this->{'externalFileDisabled'}) ? $this->{'datelimit'} : 0),'gmt' . $this->{'datetype'}) . '/' . $ip . '</div>';
		print '</td>';
		print '<td class="votes">' . $num . (($default::english) ? ' votes' : 'ɼ') . '</td>';
		print '</tr>';
	}
	close(DAT);
}
if ($memory_count < $memory) {
	print '<tr class="new-item"><td class="controller"></td><td colspan="2" class="item">';
	if ($this->{'rows'} && $this->{'rows'} > 1) {
		print '<textarea name="data:new" id="data:new" cols="' . $this->{'cols'} . '" rows="' . $this->{'rows'} . '">' .  $this->escape($main::data{'new'}) . '</textarea>' . $this->textarea_tool('data:new');
	} else {
		print '<input type="text" size="' . $this->{'cols'} . '" name="data:new" value="' . $this->escape($main::new) . '" />';
	}
	print '</td></tr>';
}
print '</tbody></table>';
print '<input type="submit" value="" class="submit" />';
print '</form>';
print '<form action="#"><fieldset><legend>ߤν(HTML)</legend><textarea rows="8" cols="50" style="width: 100%">';
print $this->escape($this->get_user_generated_field_data($memory,$this->{'field_data'},$this->{'file_directory'},$main::c,$main::n,2));
print '</textarea></fieldset></form>';
$cgi::action->print_page_footer('ugfieldeditor');
$this->rm_settings_for_editor;
return 1;
}

######################################################################
#sub import {
BEGIN {
if (!$setting::field_for_mail && (!defined $default::type || $default::type eq '')) {
	$setting::deco_dir{'vote'} = 'ɼ ܥ';
	$setting::deco_type{'vote'} = 'button';
}
}

1;
