package HTMLHelper;
require CMONOS::CGI_Lib::Common;
@ISA = qw(Common);
use strict;
######################################################################
# HTML⥸塼
# HTMLHelper.pm 1.0.2
# Copyright (C) 2007-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-12-30
######################################################################
sub new ($;@) {
my $pkg = shift;
my $this = {};
bless $this;
$this;
}

######################################################################
#åȤ򳫤³
sub html_helper_menu ($$;$$$$) {
my($this,$name,$optional_menu,$tag_disabled,$csv_enabled,$id) = @_;
my $form = '<select id="' . (($id) ? $id : $name) . '-helper" class="tool" onchange="cmonos.form.item(this.form).fieldname(\'' . $name . '\').quotationByMenu(this)"' . (($csv_enabled) ? ' title="޶ڤʸ(CSV)&lt;!--csv--&gt;&lt;!--/csv--&gt; ǰϤȡưŪɽѴޤ"' : '') . '>';
$form .= '<option value="">ִ</option>';

if (defined $optional_menu && $optional_menu ne '') {	
	$form .= $optional_menu;
	$form .= '<option value=""></option>';
}

$form .= '<option value="&amp;hearts;">&hearts;[]</option>';
$form .= '<option value="&amp;laquo;">&laquo;[]</option>';
$form .= '<option value="&amp;raquo;">&raquo;[]</option>';
$form .= '<option value="&amp;yen;">&yen;[]</option>';

if ($csv_enabled) {
	$form .= '<option value=""></option>';
	$form .= '<option value="&lt;!--csv--&gt;&lt;!--/csv--&gt;">CSV</option>';		
	$form .= '<option value="&lt;!--tate--&gt;&lt;!--/tate--&gt;">Ľ񤭥</option>';		
}

$form .= '<option value=""></option>';
$form .= '<option value="[[&lt;=&amp;lt;,&gt;=&amp;gt;]]">(&lt;&gt;)[Ѵ]</option>';
$form .= '<option value="[[&amp;=&amp;amp;,&lt;=&amp;lt;,&quot;=&amp;quot;,&gt;=&amp;gt;]]">(&lt;&gt;&quot;&amp;)[Ѵ]</option>';
$form .= '<option value="[[&amp;lt;=&lt;,&amp;gt;=&gt;]]">ײ(&lt;&gt;)[Ѵ]</option>';
$form .= '<option value="[[&amp;lt;=&lt;,&amp;gt;=&gt;,&amp;quot;=&quot;,&amp;amp;=&amp;]]">ײ(&lt;&gt;&quot;&amp;)[Ѵ]</option>';
$form .= '<option value="[[REPLACE]]">[ִ]</option>';

if (!$tag_disabled) {
	$form .= '<option value=""></option>';
	$form .= '<option value="&lt;a href=&quot;&quot; target=&quot;_blank&quot;&gt;&lt;/a&gt;">&lt;a&gt;[]</option>';
	$form .= '<option value="&lt;strong&gt;&lt;/strong&gt;">&lt;strong&gt;[Ĵ]</option>';
	$form .= '<option value="&lt;em&gt;&lt;/em&gt;">&lt;em&gt;[Ĵ]</option>';
	$form .= '<option value="&lt;del&gt;&lt;/del&gt;">&lt;del&gt;[]</option>';
	$form .= '<option value="&lt;ins&gt;&lt;/ins&gt;">&lt;ins&gt;[]</option>';
	$form .= '<option value="&lt;blockquote&gt;&lt;/blockquote&gt;">&lt;blockquote&gt;[]</option>';
	$form .= '<option value="&lt;q cite=&quot;&quot;&gt;&lt;/q&gt;">&lt;q&gt;[]</option>';
	$form .= '<option value="&lt;cite&gt;&lt;/cite&gt;">&lt;cite&gt;[ŵ]</option>';
	$form .= '<option value="' . $this->jsquot('&lt;ul&gt;\n&lt;li&gt;&lt;/li&gt;\n&lt;/ul&gt;') . '">&lt;ul&gt;[ꥹ]</option>';
	$form .= '<option value="' . $this->jsquot('&lt;ol&gt;\n&lt;li&gt;&lt;/li&gt;\n&lt;/ol&gt;') . '">&lt;ol&gt;[ֹꥹ]</option>';
	$form .= '<option value="&lt;li&gt;&lt;/li&gt;">&lt;li&gt;[ꥹ]</option>';
	$form .= '<option value="' . $this->jsquot('&lt;dl&gt;\n&lt;dt&gt;&lt;/dt&gt;\n&lt;dd&gt;&lt;/dd&gt;\n&lt;/dl&gt;') . '">&lt;dl&gt;[ꥹ]</option>';
	$form .= '<option value="&lt;pre&gt;&lt;/pre&gt;">&lt;pre&gt;[]</option>';
	$form .= '<option value="&lt;code&gt;&lt;/code&gt;">&lt;code&gt;[]</option>';
	$form .= '<option value="&lt;code class=&quot;html-source-code&quot;&gt;&lt;/code&gt;">&lt;code&gt;[HTML]</option>';
	$form .= '<option value="&lt;abbr title=&quot;&quot;&gt;&lt;/abbr&gt;">&lt;abbr&gt;[ά]</option>';
	$form .= '<option value="&lt;acronym title=&quot;&quot;&gt;&lt;/acronym&gt;">&lt;acronym&gt;[Ƭʸά]</option>';
	$form .= '<option value="&lt;dfn&gt;&lt;/dfn&gt;">&lt;dfn&gt;[Ѹ]</option>';
	$form .= '<option value="&lt;h1&gt;&lt;/h1&gt;">&lt;h1&gt;[Ф1]</option>';
	$form .= '<option value="&lt;h2&gt;&lt;/h2&gt;">&lt;h2&gt;[Ф2]</option>';
	$form .= '<option value="&lt;h3&gt;&lt;/h3&gt;">&lt;h3&gt;[Ф3]</option>';
	$form .= '<option value="&lt;h4&gt;&lt;/h4&gt;">&lt;h4&gt;[Ф4]</option>';
	$form .= '<option value="&lt;h5&gt;&lt;/h5&gt;">&lt;h5&gt;[Ф5]</option>';
	$form .= '<option value="&lt;h6&gt;&lt;/h6&gt;">&lt;h6&gt;[Ф6]</option>';
}

$form .= '<option value=""></option>';
$form .= '<option value="&amp;reg;">&reg;[]</option>';
$form .= '<option value="&amp;copy;">&copy;[]</option>';
$form .= '<option value="&amp;plusmn;">&plusmn;[]</option>';
$form .= '<option value="&amp;sect;">&sect;[]</option>';
$form .= '<option value="&amp;cent;">&cent;[]</option>';
$form .= '<option value="&amp;pound;">&pound;[]</option>';
$form .= '<option value="&amp;micro;">&micro;[]</option>';
$form .= '<option value="&amp;lt;">&lt;[]</option>';
$form .= '<option value="&amp;gt;">&gt;[]</option>';
$form .= '<option value="&amp;times;">&times;[]</option>';
$form .= '<option value="&amp;divide;">&divide;[]</option>';
$form .= '<option value="&amp;sup1;">&sup1;[]</option>';
$form .= '<option value="&amp;sup2;">&sup2;[]</option>';
$form .= '<option value="&amp;sup3;">&sup3;[]</option>';
$form .= '<option value="&amp;para;">&para;[]</option>';
$form .= '<option value="&amp;deg;">&deg;[]</option>';
$form .= '<option value="&amp;spades;">&spades;[]</option>';
$form .= '<option value="&amp;clubs;">&clubs;[]</option>';
$form .= '<option value="&amp;diams;">&diams;[]</option>';
$form .= '</select>';
return $form;
}

1;