package ImageMenuEditor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use Fcntl qw(:flock);
######################################################################
# ˥塼Խ⥸塼
# ImageMenuEditor.pm ver1.1.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-03-17
######################################################################
# ¹
sub run ($) {
my $this = shift;
my(%image);
unless (ref $cgi::Image) {
	require CMONOS::CGI_Lib::Image;
	$cgi::Image = Image->new;
}
$main::a = '' if !defined $main::a;
$main::target = '' if !defined $main::target;
my $image_dir = '';
if ($main::target =~ /^\w{1,16}$/ && (($main::a eq 'new' && $this->set_dir($env::image_dir . '/imagemenu/' . $main::target)) || ($main::a ne 'new' && -d $env::image_dir . '/imagemenu/' . $main::target))) {
	$image_dir = $env::image_dir . '/imagemenu/' . $main::target;
	if ($main::a eq 'e' && !$main::remove) {
		push(@main::delete,$main::delete) if !@main::delete && $main::delete;
		foreach (@main::delete) {
			unlink $image_dir . '/' . $_ if $_ =~ /^\w+\.(gif|png|jpg)$/i;
		}
		if (defined $main::new{'file'} && $main::new{'file'} ne '') {
			my $new_file = ($main::new{'file'} =~ /([^\/\\:]*)(\.[^\.]+)$/) ? $1 . (lc $2) : $main::new{'file'};
			if ($cgi::Image->is_not_a_web_image($cgi::input,'new:file')) {
				push(@{$this->{'dialog'}},'ɲäǤޤǤե֥饦ɽǤ(GIF,JPEG,PNG)ˤƤ');
			} elsif ($new_file !~ /^\w{1,16}\.(gif|png|jpg)$/) {
				push(@{$this->{'dialog'}},'ɲäǤޤǤե̾ѿˤƤ');
			} elsif (-f $image_dir . '/' . $new_file) {
				push(@{$this->{'dialog'}},'ɲäǤޤǤƱ̾βե뤬¸ߤޤ');
			} else {
				$cgi::input->save_file('new:file','<client>',['image/jpeg:jpg','image/pjpeg:jpg','image/gif:gif','image/png:png','image/x-png:png'],'',$image_dir);
				$cgi::input->clear_clipboard;
				if (-f $image_dir . '/' . $new_file) {
					my $key = $new_file;
					$key =~ s/\.(gif|jpg|png)$/_$1/i;
					$main::image{$key}{'file'} = $new_file;
					$main::image{$key}{'no'} = (defined $main::new{'no'} && $main::new{'no'} ne '') ? $main::new{'no'} : 999;
					$main::image{$key}{'name'} = ($main::new{'name'}) ? $main::new{'name'} : '';
					$main::image{$key}{'reserved'} = ($main::new{'reserved'}) ? $main::new{'reserved'} : '';
					undef %main::new;
				}
			}
		}
		$this->write_image_menu($image_dir,\%image,\%main::image,\$main::title);
	} elsif ($main::remove) {
		use File::Path;
		rmtree $image_dir;
		push(@{$this->{'dialog'}},'˥塼եޤ');
		$image_dir = '';
		$main::target = '';
	} else {
		$main::title = $this->read_image_menu($image_dir,\%image);
	}
} elsif ($main::a eq 'new') {
	push(@{$this->{'dialog'}},'˥塼եǤޤǤ16αѿˤƤ');
}

#ڡإå
$this->jump_menu('tools');

#˥塼ե쥯
local(*DIR);
if (opendir(DIR,$env::image_dir . '/imagemenu')) {
	my @menu = grep($_ !~ /^\./ && -d $env::image_dir . '/imagemenu/' . $_,readdir(DIR));
	closedir(DIR);
	$setting::page{'tools'}{'subMenu'} = $this->form_start(
		'key'	=>	$setting::security_key,
		'name'	=>	'folderselector',
		'required'	=>	\@setting::form
	);
	$setting::page{'tools'}{'subMenu'} .= '<select name="target" onchange="submit()"><option value=""></option>';
	$setting::page{'tools'}{'subMenu'} .= '<option value=""></option>' if @menu;
	foreach (sort @menu) {
		my $title = $this->get_image_menu_name($_);
		$setting::page{'tools'}{'subMenu'} .= '<option value="' . $_ . '"' . ((defined $main::target && $main::target eq $_) ? ' selected="selected"' : '') . '>' . ((defined $title && $title ne '') ? $title : $_) . '</option>';
	}
	$setting::page{'tools'}{'subMenu'} .= '</select><input name="subJumpMenu" type="submit" value="" /></form>';
}

#ڡإå
$this->print_page_header('tools');
print '<h1>˥塼Խ</h1>';

#
if ($image_dir eq '') {
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'method'	=> 'post',
		'onsubmit'	=>	'return cmonos.validate.field(document.input.target).asWord() &amp;&amp; cmonos.form.item(this).isNotSubmitted()',
		'required'	=>	\@setting::form
	);
	print '<input type="hidden" name="a" value="new" />';
	print '<fieldset class="submit">';
	print '<label for="target" class="datatitle">ե̾</label><input type="text" name="target" value="' . $this->escape($main::target) . '" size="16" maxlength="16" />';	
	print '<input type="submit" value="ե" /></fieldset></form>';
	$this->print_page_footer('tools');
	exit;
}

#եإå
print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'multi'	=> 1,
	'onsubmit'	=>	'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);

print '<input type="hidden" name="target" value="' . $main::target . '" />';
print '<input type="hidden" name="a" value="e" />';
print '<fieldset><legend><label for="title">˥塼̾</label></legend>';
print '<input type="text" name="title" value="' . $this->escape($main::title) . '" size="30" />';
print '</fieldset>';
print '<fieldset><legend>Ⱥ</legend>';

#ơ֥
require CMONOS::CGI_Lib::Table;
my $table = Table->new;
$table->set(
	'tableclass' => 'tooltable',
	'trclass' => 'odd,even',
	'class0' => 'odd,even',
	'style0' => 'white-space: nowrap;text-align: center;',
	'thenabled' => 'true',
	'classF' => 'caution'
);

print $table->table;

#إå
print $table->tr;
print $table->td('');
print $table->td('ɽ');
print $table->td('ե̾');
print $table->td('̾');
print $table->td('');
print $table->td('ʡ');
print $table->_tr;

#no warnings qw(numeric);
my($key,$n);
$n = 0;
foreach $key (sort {$image{$a}{'no'} <=> $image{$b}{'no'} || $a cmp $b} keys %image) {
	print $table->tr;
	print $table->td('<input type="checkbox" name="delete" value="' . $image{$key}{'file'} . '" />');
	print $table->td('<input type="text" name="image:' . $key . ':no" value="' . (++$n) . '" size="3" />');
	print $table->td($image{$key}{'file'});
	print $table->td('<input type="text" name="image:' . $key . ':name" value="' . $this->escape($image{$key}{'name'}) . '" size="20" />');
	print $table->td($cgi::Image->tag($image_dir . '/' . $image{$key}{'file'},0,$image{$key}{'name'},'',200,150));
	print $table->td('<input type="checkbox" name="image:' . $key . ':reserved" value="1"' . (($image{$key}{'reserved'}) ? ' checked="checked"' : '') . ' title="¤Τʤ̥桼λѤػߤ륪ץǤ" />');
	print $table->_tr;
}
print $table->tr;
print $table->td('');
print $table->td('<input type="text" name="new:no" value="' . (++$n) . '" size="3" />');
print $table->td('');
print $table->td('<input type="text" name="new:name" value="' . $this->escape($main::new{'name'}) . '" size="20" />');
print $table->td('<input type="file" name="new:file" value="' . $this->escape($main::new{'file'}) . '" />');
print $table->td('<input type="checkbox" name="new::reserved" value="1"' . (($main::new{'reserved'}) ? ' checked="checked"' : '') . ' title="¤Τʤ̥桼λѤػߤ륪ץǤ" />');
print $table->_tr;

print $table->_table;
print '</fieldset>';
print '<fieldset class="submit"><input type="submit" value="¸" class="save" /></fieldset>';
print '<fieldset class="delete"><input type="submit" name="remove" value="β˥塼ե" onclick="return confirm(\'ϼäޤˤβ˥塼եޤ\')" /></fieldset>';
print '</form>';

#ڡեå
$this->print_page_footer('tools');

}

######################################################################
# ˥塼񤭹
sub write_image_menu ($$$) {
#no warnings qw(numeric);
my($this,$image_dir,$image,$new_image,$title) = @_;
my($key);
local(*NAME);
my $old_title = $this->read_image_menu($image_dir,$image);
if (defined $$title) {
	$$title =~ s/[\x0A\x0D]/ /sg;
	$$title =~ s/:/&#58;/g;
} else {
	$$title = $old_title;
}
my $n = 0;
my $is_opened = 0;
if (open (NAME, ">>$image_dir/name.txt")) {
	binmode NAME;
	flock(NAME, LOCK_EX);
	truncate(NAME, 0);
	seek(NAME, 0, 0);
	print NAME $$title, "\x0A" if $$title ne '';
	$is_opened = 1;
}
foreach $key (sort {$new_image->{$a}->{'no'} <=> $new_image->{$b}->{'no'} || $image->{$a}->{'no'} <=> $image->{$b}->{'no'} || $a cmp $b} keys %$image) {
	$new_image->{$key}->{'name'} =~ s/[\x0A\x0D]/ /sg;
	$new_image->{$key}->{'name'} =~ s/:/&#58;/g;
	$new_image->{$key}->{'reserved'} = '' if !$new_image->{$key}->{'reserved'};
	$image->{$key}->{'no'} = $new_image->{$key}->{'no'} = ++$n;
	$image->{$key}->{'name'} = $new_image->{$key}->{'name'};
	$image->{$key}->{'reserved'} = $new_image->{$key}->{'reserved'};
	print NAME $image->{$key}->{'file'} . ':' . $image->{$key}->{'name'} . ':' . $image->{$key}->{'reserved'} . "\x0A" if $is_opened;
}
close (NAME) if $is_opened;
}

######################################################################
# ˥塼ɤ߹
sub read_image_menu ($$$) {
my($this,$image_dir,$image) = @_;
my($file);
my $n = 0;
my $title = '';
%$image = ();
local(*DIR);
local(*NAME);
opendir(DIR,$image_dir);
$image_dir .= '/';
while ($file = readdir(DIR)) {
	if ($file =~ /\.(gif|jpg|png)$/i && $file !~ /^\./ && -f $image_dir . $file) {
		my $key = $file;
		$key =~ s/\.(gif|jpg|png)$/_$1/i;
		$image->{$key}{'file'} = $file;
		$image->{$key}{'name'} = '';
		$image->{$key}{'no'} = 999;
		$image->{$key}{'reserved'} = '';
	}
}
closedir(DIR);
if (open(NAME,$image_dir . 'name.txt')) {
	my $line;
	while ($line = <NAME>) {
		chomp $line;
		if (!$n && $line !~ /:/) {
			$title = $line;
			$n++;
			next;
		}
		my($file,$name,$reserved) = split(/:/,$line,3);
		my $key = $file;
		$key =~ s/\.(gif|jpg|png)$/_$1/i;
		next if !ref $image->{$key};
		$n++;
		$image->{$key}{'name'} = $name;
		$image->{$key}{'no'} = $n;
		$image->{$key}{'reserved'} = $reserved;
	}
	close(NAME);
}
return $title;
}

sub get_image_menu_name ($$) {
my($this,$image) = @_;
my $title = '';
local(*NAME);
if (open(NAME, $env::image_dir . '/imagemenu/' . $image . '/name.txt')) {
	$title = <NAME>;
	close(NAME);
	chomp $title if $title;
}
return ($title && $title !~ /:/) ? $title : '';
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);
unless (defined $default::subdivided && $default::subdivided && defined $main::c && $main::c ne '') {

	#饹Ͽ
	Common::class_register('0101','ImageMenuEditor');

	#˥塼Ͽ
	$setting::jump_menu{'0101'} = '˥塼Խ()';
	$setting::master_check_option{'0101'} = 1;
}
}

1;
