package Preference;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ⥸塼
# Preference.pm ver1.1.5
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-12-20
######################################################################
# ¹
sub run ($) {
#no warnings qw(once);
my $this = shift;
my($k,$v);

$this->set_preferences;

#񤭹
if (defined $main::a && $main::a eq 'w') {
	my($id);

	$this->get_setting_items;
	push(@main::id,$main::id) if defined $main::id;
	push(@main::id,$preference::id) if !@main::id;
	foreach $id (@main::id) {
		my($k,$v);
		$id .= '_' if defined $id && $id ne '';

		#ɬܹܥå
		while (($k,$v) = each %check::required) {
			if (!defined $main::data{$id . $k} || $main::data{$id . $k} eq '') {
				push(@{$this->{'dialog'}},$v . 'ϤƤޤ');
				delete $main::data{$id . $k};
			}
		}

		#åܥåĴ
		foreach (@check::checkbox) {
			$main::data{$id . $_} = '' if !defined $main::data{$id . $_} || $main::data{$id . $_} eq '';
		}

		#
		foreach (@check::notag) {
			$this->detag(\$main::data{$id . $_}) if defined $main::data{$id . $_} && $main::data{$id . $_} ne '';
		}

		#
		foreach (@check::tagfix) {
			$this->tag_fix(\$main::data{$id . $_}) if defined $main::data{$id . $_} && $main::data{$id . $_} ne '';
		}

		#顼񼰥å
		while (($k,$v) = each %check::color) {
			if (defined $main::data{$id . $k} && $main::data{$id . $k} ne '' && $this->is_invalid_color($main::data{$id . $k})) {
				push(@{$this->{'dialog'}},$v . '򹹿ǤޤǤǧƤ');
				delete $main::data{$id . $k};
			}
		}

		#ʣ顼񼰥å
		while (($k,$v) = each %check::colors) {
			if (defined $main::data{$id . $k} && $main::data{$id . $k} ne '' && $this->is_invalid_cscolor($main::data{$id . $k})) {
				push(@{$this->{'dialog'}},$v . '򹹿ǤޤǤǧƤ');
				delete $main::data{$id . $k};
			}
		}

		#᡼񼰥å
		while (($k,$v) = each %check::email) {
			if (defined $main::data{$id . $k} && $main::data{$id . $k} ne '' && $this->is_invalid_email_address($main::data{$id . $k})) {
				push(@{$this->{'dialog'}},$v . '򹹿ǤޤǤ᡼륢ɥ쥹ǧƤ');
				delete $main::data{$id . $k};
			}
		}

		#ʣ᡼񼰥å
		while (($k,$v) = each %check::emails) {
			if (defined $main::data{$id . $k} && $main::data{$id . $k} ne '' && $this->is_invalid_email_address_header($main::data{$id . $k})) {
				push(@{$this->{'dialog'}},$v . '򹹿ǤޤǤ᡼륢ɥ쥹ǧƤ');
				delete $main::data{$id . $k};
			}
		}

		#URL񼰥å
		while (($k,$v) = each %check::url) {
			if (defined $main::data{$id . $k} && $main::data{$id . $k} ne '' && $this->is_invalid_url($main::data{$id . $k})) {
				push(@{$this->{'dialog'}},$v . '򹹿ǤޤǤURLǧƤ');
				delete $main::data{$id . $k};
			}
		}

		#å
		while (($k,$v) = each %check::num) {
			if (defined $main::data{$id . $k} && $main::data{$id . $k} ne '' && $this->is_nan($main::data{$id . $k})) {
				push(@{$this->{'dialog'}},$v . '򹹿ǤޤǤȾѿˤƤ');
				delete $main::data{$id . $k};
			}
		}

		#Ⱦѱѿå
		while (($k,$v) = each %check::word) {
			$main::data{$id . $k} = $this->z_to_h($main::data{$id . $k});
			if (defined $main::data{$id . $k} && $main::data{$id . $k} ne '' && $main::data{$id . $k} =~ /[^\w\-\x20]/) {
				push(@{$this->{'dialog'}},$v . '򹹿ǤޤǤȾѱѿˤƤ');
				delete $main::data{$id . $k};
			}
		}

		#å
		while (($k,$v) = each %check::maxlength) {
			if (defined $main::data{$id . $k} && length($id . $k . $main::data{$id . $k}) > $env::db_maxlength && $env::db_maxlength > 0) {
				push(@{$this->{'dialog'}},$v . '򹹿ǤޤǤ̥СǤ');
				delete $main::data{$id . $k};
			}
		}

		#å
		while (($k,$v) = each %check::imagefile) {
			my $n = $id . $k;
			if (defined $main::data{$n} && defined $preference::filedir{$k} && $main::data{$n} ne '' && $preference::filedir{$k} ne '') {
				if ($this->is_invalid_image($n,$k,$v)) {
					push(@{$this->{'dialog'}},$v . '򹹿ǤޤǤ');
					$this->pref_unlink_file($preference::filedir{$k},$n) if defined $main::delete{$n} && $main::delete{$n};
					delete $main::data{$n};
				}
			} elsif (defined $main::delete{$n} && $main::delete{$n}) {
				$this->pref_unlink_file($preference::filedir{$k},$n);
			} else {
				delete $main::data{$n};
			}
		}
	}

	#⥸塼륪ꥸʥå
	$this->is_valid_setting;

	#񤭹
	$this->write_settings;

	#
	$this->update_settings;
	$cgi::input->clear_clipboard;

} else {
	#ɤ߹
	$this->read_settings;
}

#ڡإå
$this->set_page_header;
$this->jump_menu('tools',$preference::submenukey);
$this->print_page_header('tools');

$this->print_progress_bar;

#ȥ
print '<h1 title="' . $preference::title . '">' . $preference::name . '</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method' => 'post',
	'onsubmit'	=>	'return cmonos.form.item(this).isNotSubmitted()',
	'multi'	=>	(($cgi::enctype_multipart) ? 1 : 0),
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="w" />';

$this->print_preference_panel;

print '</form>';

#ڡեå
$this->print_page_footer('tools');

$this->site_update;
}

######################################################################
#񤭹ɤ߹
sub write_settings ($) {
my $this = shift;
$this->write_db($default::preference_dir . '/' . $preference::db,\%main::data,'','',\%main::data,0,@preference::import_key);
}

sub read_settings ($) {
my $this = shift;
$this->import_db($default::preference_dir . '/' . $preference::db,\%main::data,0,@preference::import_key);
}

######################################################################
# å
sub is_invalid_image ($$$$) {
my($this,$inputname,$key,$name) = @_;
my($is_valid,$width,$height,$ext,$formname);
$is_valid = 1;
$formname = 'data:' . $inputname;

#źեե뤬ե뤫ɤå
unless (ref $cgi::Image) {
	require CMONOS::CGI_Lib::Image;
	$cgi::Image = Image->new;
}
($width,$height,$ext) = $cgi::Image->input_info($cgi::input,$formname,0,$check::widthlimit{$key},$check::heightlimit{$key},1);
	
#MIME-TYPEå
if (!defined $ext || $ext eq '') {
	push(@{$this->{'dialog'}}, $name . 'Υե륿פǧƤ');
	$is_valid = 0;
}
	
#ե륵å
if (defined $check::maxsize{$key} && $check::maxsize{$key} > 0 && $cgi::input->get_posted_file_size_from_param($formname) > $check::maxsize{$key}) {
	push(@{$this->{'dialog'}},$name . 'Υե륵ǧƤ' . $check::maxsize{$key} . 'ХȰˤƤ');
	$is_valid = 0;
}

#å
if (defined $check::widthlimit{$key} && defined $width && $check::widthlimit{$key} > 0 && $width > $check::widthlimit{$key}) {
	push(@{$this->{'dialog'}},$name . 'βǧƤ' . $check::widthlimit{$key} . 'ԥˤƤ');
	$is_valid = 0;
}
if (defined $check::heightlimit{$key} && defined $height && $check::heightlimit{$key} > 0 && $height > $check::heightlimit{$key}) {
	push(@{$this->{'dialog'}},$name . 'ι⤵ǧƤ' . $check::heightlimit{$key} . 'ԥˤƤ');
	$is_valid = 0;
}

if ($is_valid) {
	$main::data{$inputname} = $inputname . '.' . $ext;
	$main::data{$inputname . 'width'} = $width;
	$main::data{$inputname . 'height'} = $height;
	$cgi::input->save_file(
		$formname,
		'!' . $inputname,
		'',
		'',
		$preference::filedir{$key},
	);
	return 0;

} else {
	delete $main::data{$inputname};
	delete $main::data{$inputname . 'width'};
	delete $main::data{$inputname . 'height'};
	return 1;
}
}

sub pref_unlink_file ($$$) {
my($this,$dir,$name) = @_;
unlink($this->fileglob($dir,'^' . $name . '\.','f')) if defined $dir && $dir;
$main::data{$name} = '';
$main::data{$name . 'width'} = '';
$main::data{$name . 'height'} = '';
delete $main::delete{$name};
}

######################################################################
# ե
sub print_image_upload_form ($$$$) {
my($this,$inputname,$key,$data) = @_;

#ե¸ߤå
($$data{$key},$$data{$key . 'width'},$$data{$key . 'height'}) = () unless $$data{$key} && -f $preference::filedir{$key} . '/' . $$data{$key};

#åץɥե
print '<input type="file" name="data:' . $inputname . '" id="data:' . $inputname . '" />';
print '<div class="note">(&lt; ' . $check::maxsize{$key} . ' byte)</div>' if $check::maxsize{$key};
print '<div class="note">(&lt; ' . (($check::widthlimit{$key}) ? $check::widthlimit{$key} : '&infin;') . '  ' . (($check::heightlimit{$key}) ? $check::heightlimit{$key} : '&infin;') . ' ԥ)</div>' if (defined $check::widthlimit{$key} && $check::widthlimit{$key}) || (defined $check::heightlimit{$key} && $check::heightlimit{$key});

#¸եɽ
if (defined $$data{$key} && $$data{$key} ne '') {
	print  '<div class="sample-image">';
	unless (ref $cgi::Image) {
		require CMONOS::CGI_Lib::Image;
		$cgi::Image = Image->new;
	}
	print $cgi::Image->image_tag(
		$preference::filedir{$key} . '/' . $$data{$key},
		$$data{$key . 'width'},
		$$data{$key . 'height'}
	);
	print '<div class="extra-field"><label><input type="checkbox" name="delete:' . $inputname . '" value="1" /> Υե</label></div>';
	print '</div>';
}
return;
}

######################################################################
# Ķ
sub set_preferences ($) {
my $this = shift;
push(@{$this->{'dialog'}},'ץȥ顼Preference ⥸塼˰۾郎ޤ');
$this->print_error_dialog('tools');
}

sub set_page_header ($) {
my $this = shift;
return;
}

######################################################################
# å
sub get_setting_items ($) {
my $this = shift;
return;
}

######################################################################
# ѥͥ
sub print_preference_panel ($) {
my $this = shift;
push(@{$this->{'dialog'}},'ץȥ顼Preference ⥸塼˰۾郎ޤ');
$this->print_error_dialog('tools');
}

######################################################################
# å
sub is_valid_setting ($) {
my $this = shift;
return;
}

######################################################################
# 
sub update_settings ($) {
my $this = shift;
return;
}

sub print_progress_bar ($) {
my $this = shift;
return;
}

sub site_update ($) {
my $this = shift;
return;
}


1;
