package PreferenceShare;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use Fcntl qw(:DEFAULT :flock);
######################################################################
# ζͭ⥸塼
# PreferenceShare.pm ver1.1.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-04-15
######################################################################
# ¹
sub run ($) {
my $this = shift;
my(%shareable_db);
push(@main::shareable_db,$main::shareable_db) if defined $main::shareable_db && $main::shareable_db ne '';
@main::shareable_db = grep(defined $_ && $_ ne '',@main::shareable_db);
undef $main::shareable_db;
$main::a = '' if !defined $main::a;
$this->get_shareable_db_info(\%shareable_db);

if (@main::shareable_db && $main::a) {
	my(@preference_id,$is_invalid);
	$main::prefid = $this->z_to_h($main::prefid,'euc') if $main::prefid;
	if (!defined $main::prefid && $main::prefid eq '') {
		push(@{$this->{'dialog'}},' ID ϤƤ');
		$is_invalid = 1;
	} elsif ($main::prefid !~ /^[0-9a-zA-Z]{1,16}$/) {
		push(@{$this->{'dialog'}},' ID 16ʸȾѱѿˤƤ');
		$is_invalid = 1;
	} elsif (grep($_ eq $main::prefid,$this->get_existing_pref_id)) {
		push(@{$this->{'dialog'}},' ID ϴ˻ѤƤޤ̤ ID ѹƤ');
		$is_invalid = 1;
	}
	$main::prefname =~ s/[<>]//sg;
	$main::prefname =~ s/\s+/ /sg;
	$main::prefname =~ s/\s+$//s;
	if (!defined $main::prefname && $main::prefname eq '') {
		push(@{$this->{'dialog'}},'̾ϤƤ');
		$is_invalid = 1;
	}
	if (!$is_invalid) {
		eval 'use ' . $env::dbm_file . ';';
		my @pref_type = ();
		foreach my $db (@main::shareable_db) {
			if ($shareable_db{$db}{'pref_path'}) {
				if ($this->mk_default_bak($shareable_db{$db}{'pref_path'},$shareable_db{$db}{'bak_path'},$main::prefid,$main::prefname,$main::noaddr)) {
					push(@pref_type,$shareable_db{$db}{'pref_type'});
				} else {
					push(@{$this->{'dialog'}},$shareable_db{$db}{'pref_type'} . 'ζͭ˼Ԥޤ');
				}
			}
		}
		$this->share_relational_files(\@main::shareable_db,$main::prefid);
		push(@{$this->{'dialog'}},'' . join('ס',@pref_type) . 'פ̾' . $main::prefname . '(' . $main::prefid . ')פȤƶͭޤ') if @pref_type;
		undef $main::prefid;
		undef $main::prefname;
		undef $main::noaddr;
		undef @main::shareable_db;
	}

} elsif ($main::a) {
	push(@{$this->{'dialog'}},'꤬ͭꤵƤޤ');

}

#ڡإå
$this->jump_menu('tools','share');
$this->print_page_header('tools');

print '<h1>ζͭ</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=>	'return cmonos.form.item(this).isNotSubmitted();',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="share" />';

print '<fieldset>';
print '<div class="hints">ͭ줿ϡ֥ǡ١ פѤ뤳Ȥޤ</div>';
print '<table class="field-table"><tbody>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">ͭ</span></td>';
print '<td class="field"><ol class="checkbox">';
if (%shareable_db) {
	foreach my $db (sort {$shareable_db{$a}{'pref_id'} cmp $shareable_db{$b}{'pref_id'} || $a cmp $b} keys %shareable_db) {
		print '<li><label><input type="checkbox" name="shareable_db" value="' . $db . '"' . ((grep($db eq $_,@main::shareable_db)) ? ' checked="checked"' : '') . ' />' . $shareable_db{$db}{'pref_type'} . '</label></li>';
	}
}
print '</ol></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="prefid"> ID</label></td>';
print '<td><input type="text" name="prefid" id="prefid" size="16" maxlength="16" value="' . $this->escape($main::prefid) . '" />16ʸȾѱѿ</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="prefname">̾</label></td>';
print '<td class="field"><input type="text" name="prefname" id="prefname" size="40" value="' . $this->escape($main::prefname) . '" /></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">궦ͭץ</span></td>';
print '<td class="field"><label><input type="checkbox" name="noaddr" id="noaddr"' . (($main::noaddr) ? ' checked="checked"' : '') . ' /> ᡼륢ɥ쥹Ӵ̾Ƥ鶦ͭ롣</label></td>';
print '</tr>';
print '</tbody></table></fieldset>';

print '<fieldset class="submit"><input type="submit" value="¹" class="save" /></fieldset></form>';

#ڡեå
$this->print_page_footer('tools');

}

sub get_existing_pref_id ($) {
my $this = shift;
my(%pref_id);
local(*DIR);
foreach my $type ($backup::default{'pref'},$backup::default{'field'}) {
	next if !$type;
	my $path = ($env::user_default_dir || $env::default_dir) . '/' . $type;
	if (opendir(DIR,$path)) {
		my $file;
		while ($file = readdir(DIR)) {
			next if $file =~ /^\./;
			$pref_id{$1} = 1 if $file =~ /^\w+\.([a-zA-Z0-9]+)\.default$/;
		}
		closedir(DIR);
	}
}
return keys %pref_id;
}

sub get_shareable_db_info ($$) {
my($this,$shareable_db) = @_;
return;
}

sub share_relational_files ($$$) {
my($this,$target,$prefid) = @_;
return 1;
}

######################################################################
# DBХåå
sub mk_default_bak ($$$$$;$) {
my($this,$pref_path,$bak_path,$ext,$name,$noaddr) = @_;
my(%db_hash,$k,$v,$done);
my $home_dir_id = ($env::home_dir_id) ? $env::home_dir_id : '';
my $user_directory = $this->home_directory(1);
my $home_url = $this->full_path('../../',1);
my $home_url_encoded = $this->url_encode($home_url);
$done = 0;
tie(%db_hash, $env::dbm_file, $pref_path, O_RDONLY, $env::dbm_mode);
if (ref tied %db_hash) {
	$bak_path .= '.' . $ext . '.default';
	local(*BAK);
	if (open (BAK, ">>$bak_path")) {
		binmode BAK;
		flock(BAK, LOCK_EX);
		truncate(BAK, 0);
		seek(BAK, 0, 0);
		print BAK $name . "\x0A";
		while (($k,$v) = each %db_hash) {
			next if grep($k eq $_,'latest','count','mastercginame');
			$k =~ s/\x09/&#09;/gs;
			$k =~ s/(\x0D\x0A|\x0D|\x0A)/\x0B/gs;
			if ($noaddr) {
				if ($k eq 'mastername' || $k eq 'master' || $k eq 'owners') {
					next;
				} else {
					$v =~ s!<?[\w\-\+\.]+\@[\w\-]+\.[\w\-\.]+>?!!g;
				}
			}
			$v =~ s!($user_directory|\.)(/lib/(?:xfiles|javascript|css)/)!(($1 && $1 eq '.') ? $1 . $2 : '<user-directory>' . $2)!ge;
			$v =~ s!(<\!--#include virtual=")$user_directory(/.*?"-->)!$1<user-directory>$2!g;
			if ($home_dir_id) {
				$v =~ s/#document_$home_dir_id/#document_<home-dir-id>/g;
			} else {
				$v =~ s/#document_(?!_)/#document_<home-dir-id>/g;
			}
			$v =~ s!$home_url!<home-url>!g;
			$v =~ s/$home_url_encoded/<home-url-encoded>/g;
			$v =~ s/\x09/&#09;/gs;
			$v =~ s/(\x0D\x0A|\x0D|\x0A)/\x0B/gs;
			print BAK $k;
			print BAK "\x09";
			print BAK $v;
			print BAK "\x0A";
		}
		close (BAK);
		chmod($env::file_mode, $bak_path);
		$done = 1;
	}
}
untie %db_hash;
return $done;
}

1;
