package Restore;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ⥸塼
# Restore.pm ver1.1.6
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-09-25
######################################################################
# ¹
sub run ($) {
my $this = shift;
if ($env::preference_dir && (!$default::subdivided || !defined $main::c || $main::c eq '')) {
	$backup::default{'table'} = 'table';
}

if (defined $main::a && $main::a eq 'r' && %main::restore) {
	my(%db_path,%db_name,$k,$ext);

	use Fcntl qw(:DEFAULT :flock);
	eval 'use ' . $env::dbm_file . ';';

	%db_path = (%backup::db_path) ? %backup::db_path : ();
	%db_name = (%backup::db_name) ? %backup::db_name : ();
	if ($env::preference_dir && (!$default::subdivided || !defined $main::c || $main::c eq '')) {
		($db_path{'deco'},$db_name{'deco'}) = ($env::preference_dir . '/deco','ʶ̡') if $setting::deco;
		($db_path{'table'},$db_name{'table'}) = ($env::preference_dir . '/table','ơ֥ʶ̡') if $setting::table;
	}
	($db_path{'pref'},$db_name{'pref'}) = ($default::preference_dir,'') if defined $default::preference_dir && $default::preference_dir;
	($db_path{'field'},$db_name{'field'}) = ($default::field_pref_dir,'ե') if $default::field_pref_dir && (!$default::subdivided || (defined $main::c && $main::c ne ''));

	#ǡ١ 
	foreach my $k (sort keys %main::restore) {
		my $ext = $main::restore{$k};
		my $check = 0;
		my $default_dir = ($ext && $ext =~ s/^~// && $env::user_default_dir) ? $env::user_default_dir : $env::default_dir;
		my $default_path = ($backup::default{$k}) ? $default_dir . '/' . $backup::default{$k} : '';
		if (!$ext || ($ext ne 'bak' && $ext !~ /^\w+\.default$/)) {
			next;
		} elsif (defined $db_path{$k} && -d $db_path{$k}) {
			$check = 1 if $this->restore_dir($default_path,$db_path{$k},$ext,$backup::find{$k});
			$this->restore_relational_files($ext,$default_dir) if $ext ne 'bak' && %backup::relational_file && $k eq 'pref';
		} elsif (defined $db_path{$k}) {
			$check = 1 if $this->restore_db($default_path,$db_path{$k},'',$ext);
		}
		if (defined $check && $check) {
			push(@{$this->{'dialog'}},$db_name{$k} . 'ޤ');
		} else {
			push(@{$this->{'dialog'}},$db_name{$k} . '˼Ԥޤ');
		}
	}
}

#ڡإå
$this->jump_menu('tools','backup');
$this->print_page_header('tools');

print '<h1>ǡ١ </h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="r" />';

print '<fieldset><legend>ǽʥǡ</legend><table class="field-table"><tbody>';
if ($env::preference_dir && (!$default::subdivided || !defined $main::c || $main::c eq '')) {
	$this->print_backup_menu('deco',$env::preference_dir . '/deco','ʶ̡') if $setting::deco;
	$this->print_backup_menu('table',$env::preference_dir . '/table','ơ֥ʶ̡') if $setting::table;
}
$this->print_backup_menu('pref',$default::preference_dir,'') if defined $default::preference_dir && $default::preference_dir;
$this->print_backup_menu('field',$default::field_pref_dir,'ե') if $default::field_pref_dir && (!$default::subdivided || (defined $main::c && $main::c ne ''));

if (%backup::db_name) {
	foreach (sort keys %backup::db_name) {
		$this->print_backup_menu($_,$backup::db_path{$_},$backup::db_name{$_},$backup::find{$_},$backup::skip{$_});
	}
}

if (defined $this->{'count'} && $this->{'count'}) {
	print '</tbody></table></fieldset><fieldset class="submit">';
	print '<label><input type="checkbox" name="clear" value="1" title="ǡ١Ƥƾä塢ޤ" /> </label> ';
	print '<input type="submit" value="" class="save" onclick="return confirm(\'ߤΥǡ˾񤭤ޤ¹Ԥޤ\')" /></fieldset>';
} else {
	print '<tr><td>ǽե뤬ޤ</td></tr></tbody></table></fieldset>';
}

print '</form>';

#ڡեå
$this->print_page_footer('tools');

}

######################################################################
# ˥塼
sub print_backup_menu ($$$$;$$) {
my($this,$key,$path,$name,$find,$skip) = @_;
return if !defined $key || !defined $path;
my %bak = ();

$this->get_backup_list_hash($path,\%bak,$find,$skip);
if ($backup::default{$key}) {
	$this->get_backup_list_hash($env::default_dir . '/' . $backup::default{$key},\%bak,$find,$skip);
	$this->get_backup_list_hash($env::user_default_dir . '/' . $backup::default{$key},\%bak,$find,$skip,1) if $env::user_default_dir;
}
return if !%bak;

print '<tr><td class="field-name"><label for="restore:', $key, '">';
print ((defined $name) ? $name : $key);
print '</label></td>';
print '<td class="field"><select name="restore:', $key, '" id="restore:', $key, '">';
print '<option value="">ʤ</option>';
print '<option value="bak">' . $bak{'bak'} . ' </option>' if $bak{'bak'};
foreach my $ext (sort keys %bak) {
	next if $ext eq 'bak';
	print '<option value="', $ext, '">';
	print $bak{$ext};
	print ' </option>';
}

print '</select></td></tr>';

$this->{'count'}++;
}

sub get_backup_list_hash ($$$;$$$) {
my($this,$path,$bak,$find,$skip,$user_dir) = @_;
my($db,@files,$name);
if (-d $path) {
	$db = '\w+';
} else {
	($path,$db) = ($1,$2) if $path =~ m!^(.*)/([^/]+)$!;
	$db =~ s/\.[^\/\.]+$//;
}
$path =~ s!/$!!;

return unless opendir(DIR,$path);
@files = grep($_ !~ /^\./,readdir(DIR));
closedir(DIR);

foreach $name (@files) {
	if ($name =~ /^$db\.bak$/) {
		next if defined $$bak{'bak'} && $$bak{'bak'} ne '';
		$$bak{'bak'} = 'Хåå';
		return if defined $skip && $skip;
	} elsif (!$skip && $name =~ /^$db\.(\w+\.default)$/) {
		my $ext = (($user_dir) ? '~' : '') . $1;
		next if defined $$bak{$ext} && $$bak{$ext} ne '';
		local(*FILE);
		if (open (FILE, "$path/$name")) {
			binmode FILE;
			$$bak{$ext} = <FILE>;
			close(FILE);
			chomp $$bak{$ext};
			$$bak{$ext} .= '&lt;ͭ&gt;' if $env::user_default_dir && !$user_dir;
		}
	} elsif ($find && -d $path . '/' . $name) {
		$this->get_backup_list_hash($path . '/' . $name,$bak,$find,$skip,$user_dir);
	}
}
}

######################################################################
# ǥ쥯ȥDB
sub restore_dir ($$$$;$) {
my($this,$default_path,$path,$ext,$find) = @_;
my(@db,$check,%restore);
$path =~ s!/$!!;

return unless opendir(DIR,$path);
@db = readdir(DIR);
closedir(DIR);

foreach my $name (@db) {
	next if $name =~ /^[\-\.]/ || $name =~ /\.(txt|html|htm|gif|jpg|png)$/i;
	if (-d $path . '/' . $name) {
		$check = 1 if $find && $this->restore_dir($default_path,$path . '/' . $name,$ext,$find);
	} elsif (-f $path . '/' . $name) {
		$name =~ s/\.[^\/\.]+$//;
		$restore{$name}++;
	}
}

if ($default_path && opendir(DIR,$default_path)) {
	my(@db2);
	@db2 = readdir(DIR);
	closedir(DIR);
	foreach my $name (@db2) {
		next if $name =~ /^\./ || $name =~ /\.(txt|html|htm|gif|jpg|png)$/i || !-f $default_path . '/' . $name;
		$name =~ s/\.[^\/\.]+$//;
		$restore{$name}++;
	}
}

foreach my $name (keys %restore) {
	$check = 1 if $this->restore_db($default_path,$path,$name,$ext);
}
return $check;
}

######################################################################
# DB
sub restore_db ($$$$$) {
my($this,$default_path,$path,$file,$ext) = @_;
my(%db,$check);
$file = $1 if (!defined $file || $file eq '') && defined $path && $path =~ s!/([^/]+)$!!;
return 0 if !defined $file || $file eq '' || $file =~ /\.(html|htm|ssi|js|gif|png|jpg|txt)$/i || !defined $path || !defined $ext;
$file =~ s/\.[^\/\.]+$//;
my $data = $this->read_file($path . '/' . $file . '.' . $ext);
$data = $this->read_file($default_path . '/' . $file . '.' . $ext) if !$data && $default_path;
return 0 if !$data;
my $home_dir_id = ($env::home_dir_id) ? $env::home_dir_id : '';
my $user_directory = $this->home_directory(1);
my $home_url = $this->full_path('../../',1);
my $home_url_encoded = $this->url_encode($home_url);
my $error = 0;
tie(%db, $env::dbm_file, $path . '/' . $file, O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %db) {
	%db = () if ($main::clear || $file =~ /field$/) && (!defined $ext || $ext eq '' || $ext !~ /^_/);	#ꥢ
	while ($data =~ /([^\x09\x0A\x0D]+)\x09([^\x0A\x0D]*)[\x0A\x0D]*/sg) {
		my($k,$v) = ($1,$2);
		$k =~ s/\&#09;/\x09/gs;
		$k =~ s/\x0B/\x0A/gs;
		$v =~ s/\&#09;/\x09/gs;
		$v =~ s/\x0B/\x0A/gs;
		$v =~ s!<home-dir-id>!$home_dir_id!gs;
		$v =~ s/<home-url>/$home_url/gs;
		$v =~ s/<home-url-encoded>/$home_url_encoded/gs;
		$v =~ s!<user-directory>!$user_directory!gs;
		eval '$db{$k} = $v;';
		$error++ if defined $@ && $@;
		$check = 1;
	}
} else {
	$check = 0;
}
untie %db;
push(@{$this->{'dialog'}},'̤礭᤮' . $error . '˼Ԥޤ(' . (($path =~ m!/(?:data|preferences)(/.+)$!) ? $1 . '/' : '') . $file . ')') if $error;
return $check;
}

######################################################################
# Ϣե
sub restore_relational_files ($$$) {
my($this,$id,$default_dir) = @_;
$id =~ s/\.default$//;
return if $id eq '';
while (my($name,$file) = each %backup::relational_file) {
	my $path = $default_dir . '/' . $file->{'path'} . '.' . $id . '.' . $file->{'ext'};
	$this->file_copy($path,$file->{'target'}) if -f $path;
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('xxbr','Restore');

	#˥塼Ͽ
	$setting::jump_menu{'xxbr'} = 'ǡ١ ';
}


1;
