package DetailViewer;
require CMONOS::Calendar::CalCommon;
@ISA = qw(CalCommon);
use strict;
######################################################################
# ܺ٥ӥ塼⥸塼
# DetailViewer.pm ver1.1.10
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-02-15
######################################################################
# ᥤ
sub run ($) {
my $this = shift;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

#---------------------------------------------------------------------
#׵å
$this->error404 if $this->is_nan($main::n) || !-d $default::db;
my(%mtime,$last_modified);
tie(%mtime, $env::dbm_file, "$default::db/mtime", O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %mtime) {
	$last_modified = $mtime{$main::n} if defined $mtime{$main::n} && $mtime{$main::n};
}
untie %mtime;
$this->error404 if !$last_modified;


#---------------------------------------------------------------------
#å
if (!$this->is_secure('detail',1) || (defined $setting::security{'detail'}{'passwordCheck'} && $setting::security{'detail'}{'passwordCheck'} eq 'member' && !$this->is_one_of_owners && !$this->is_guest)) {
	$this->print_password_check_form($setting::key);
	return;
}

#ƥ꡼å
if ((!$setting::security{'closed'}{'passwordCheck'} || $setting::security{'closed'}{'passwordCheck'} ne 'nocheck') && %setting::event_category && ref $setting::event_category{'ORDER'} && %{$setting::event_category{'ORDER'}}) {
	my(%db,$category);
	tie(%db, $env::dbm_file, $default::db . '/category', O_RDONLY, $env::dbm_mode);
	if (ref tied %db) {
		$category = $db{$main::n};
	}
	untie(%db);
	if (defined $category && ref $setting::event_category{$category} && $setting::event_category{$category}{'closed'} && !$this->is_secure('closed') && !$this->is_guest) {
		$this->print_password_check_form($setting::key);
		return;
	}
}

#---------------------------------------------------------------------
#üեɽ
if (defined $main::id && $main::id ne '' && ref $field::obj{$main::id} && $field::obj{$main::id}->update_enabled && $field::obj{$main::id}->is_secure_user_for_update && $field::obj{$main::id}->update) {
	$this->set_onload('cmonos.window.refreshOpener(\'\',false)');
}


#---------------------------------------------------------------------
#񤭽Ф
my($have_template,$this_template,%temp,$path);

#եǼǥ쥯ȥ
$path = "$default::file/$main::n";

#ƥץ졼
if (defined $setting::page{$setting::key}{'template'} && $setting::page{$setting::key}{'template'} ne '') {
	require CMONOS::CGI_Lib::Template;
	$this_template = Template->new;
	$this_template->set(
		'field_style_disabled' => $setting::field_style_disabled,
		'field_tag_enabled' => $setting::field_tag_enabled
	);
	$have_template = 1;
	$have_template++ if $setting::page{$setting::key}{'template'} =~ /<body(?!\w)[^>]*>/i;
	$this_template->template_parser(\$setting::page{$setting::key}{'template'});
}

#ȥ
my $title_id;
if ($field::for{'title'} || $field::for{'key'} || $field::for{'name'}) {
	my(%db);
	$title_id = ($field::for{'title'}) ? $field::for{'title'} : ($field::for{'key'}) ? $field::for{'key'} : $field::for{'name'};
	my $title_db = $field::obj{$title_id}->db;
	tie(%db, $env::dbm_file, "$default::db/$title_db", O_RDONLY, $env::dbm_mode);
	my $title = $field::obj{$title_id}->format_for_text($db{$main::n});
	untie %db;
	$this->push_window_title($title) if defined $title && $title ne '';
}

#ڡإå
if (!$have_template || $have_template < 2) {
	$this->set_canonical($this->my_url . '?m=DetailViewer' . (($default::subdivided && defined $main::c && $main::c ne '') ? '&c=' . $main::c : '') . ((defined $main::n && $main::n ne '') ? '&n=' . $main::n : ''));
	$this->print_page_header($setting::key);
	print $this->get_tool_buttons($main::n,'event-editor',1);
} else {
	my $buttons = $this->get_tool_buttons($main::n,'event-editor',1);
	$setting::page{$setting::key}{'template'} =~ s/(<body(?!\w)[^>]*>)/$1$buttons/si;
}

my($table_field,$top_field) = ('','');
my($event_dt,$target_date) = $this->get_event_date($main::n);
if (!defined $have_template || !$have_template) {

	#Ĵ

	#ܥե졼Ĵ
	if ($setting::page{$setting::key}{'fieldFrame'} && ref $frame::obj{'frame'}{$setting::page{$setting::key}{'fieldFrame'}}) {
		my @frame_setting = (
			'framewidth' => $setting::page{$setting::key}{'fieldWidth'},
			'fixed' => 'no',
			'frameclass' => 'item-body'
		);
		push(@frame_setting,'contentsalign',$setting::page{$setting::key}{'boxAlign'}) if defined $setting::page{$setting::key}{'boxAlign'} && $setting::page{$setting::key}{'boxAlign'};
		push(@frame_setting,'contentsvalign',$setting::page{$setting::key}{'boxValign'}) if defined $setting::page{$setting::key}{'boxValign'} && $setting::page{$setting::key}{'boxValign'};
		$frame::obj{'frame'}{$setting::page{$setting::key}{'fieldFrame'}}->set_direct(@frame_setting);
	}

	#̾ե졼Ĵ
	if (defined $setting::page{$setting::key}{'fieldTitleOption'} && $setting::page{$setting::key}{'fieldTitleOption'}) {
		if ($setting::page{$setting::key}{'fieldFrame'} && ref $frame::obj{'frame'}{$setting::page{$setting::key}{'fieldFrame'}}) {
			$frame::obj{'frame'}{$setting::page{$setting::key}{'fieldFrame'}}->{'type'} = 'frame';
		}
	} elsif ($setting::page{$setting::key}{'fieldTitleFrame'} && ref $frame::obj{'frame'}{$setting::page{$setting::key}{'fieldTitleFrame'}}) {
		$frame::obj{'frame'}{$setting::page{$setting::key}{'fieldTitleFrame'}}->set_direct('framewidth',$setting::page{$setting::key}{'fieldTitleWidth'},'frameclass','item-titlebar');
	}

	#ȥå׹
	if (defined $field::for{'top'} && $field::for{'top'} ne '' && 
			ref $field::obj{$field::for{'top'}} && 
			$field::obj{$field::for{'top'}}->format_for_detail_enabled &&
			!$field::obj{$field::for{'top'}}->{'Hidden'} && 
			($field::obj{$field::for{'top'}}->{'Open'} || $this->is_secure('secret'))
		) {
		my $db = $field::obj{$field::for{'top'}}->db;
		if (defined $db && $db) {
			my($contents,%db);
			tie(%db, $env::dbm_file, "$default::db/$db", O_RDONLY, $env::dbm_mode);
			$contents = $field::obj{$field::for{'top'}}->format_for_detail($db{$main::n},$path,$main::c,$main::n);
			untie(%db);
			$top_field .= ($field::for{'top'} eq $title_id) ? '<h1 id="top-item">' . $contents . '</h1>' : '<div id="top-item" class="section"><div class="body">' . $contents . '</div></div>' if defined $contents && $contents ne '';
		}
	}

	# ɽ
	my($table,$table_check,$name);
	if (defined $setting::page{$setting::key}{'table'} && $setting::page{$setting::key}{'table'} ne '' && ref $table::obj{$setting::page{$setting::key}{'table'}}) {
		$table = $table::obj{$setting::page{$setting::key}{'table'}};
		$table_field = $table->table;
	} else {
		$table_field = '<table class="field-table"><tbody>';
	}
	if (ref $table) {
		$table_field .= $table->tr;
		$table_field .= $table->td('');
		$table_field .= $table->td($event_dt);
		$table_field .= $table->_tr;
	} else {
		$table_field .= '<tr class="event-date"><td class="field-name"><span class="datatitle"></span></td><td class="field">' . $event_dt . '</td></tr>';
	}
	foreach (sort {$a <=> $b} keys %field::ORDER) {
		my($id,%db,$db,$title,$contents);
		$id = $field::ORDER{$_};

		#ȥå׹ܤ򥹥å
		next if $id eq $field::for{'top'};

		#ơ֥ܰʳ򥹥å/ʹܤ򥹥å
		next unless ref $field::obj{$id} && $field::obj{$id}->{'detailTable'} && !$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret')) && $field::obj{$id}->format_for_detail_enabled;

		$db = $field::obj{$id}->db;
		next if !defined $db ||  !$db;
		tie(%db, $env::dbm_file, "$default::db/$db", O_RDONLY, $env::dbm_mode);
		$contents = $field::obj{$id}->format_for_detail($db{$main::n},$path,$main::c,$main::n);
		untie %db;
		next if !defined $contents || $contents eq '';

		#ȥС
		if ($setting::page{$setting::key}{'fieldTitleOption'} && (!defined $name || $name eq '') && ($id eq $field::for{'title'} || $id eq $field::for{'key'} || $id eq $field::for{'name'}) && $contents =~ /\S/ && $contents ne '&nbsp;') {
			$name = '<h2 class="item-title">' . $contents . '</h2>';
			next;
		}
	
		#ɽ
		$title = $field::obj{$id}->name;
		if (ref $table) {
			$table_field .= $table->tr;
			$table_field .= $table->td($title);
			$table_field .= $table->td($contents);
			$table_field .= $table->_tr;
		} else {
			$table_field .= '<tr><td class="field-name"><span class="datatitle">' . $title . '</span></td><td class="field">' . $contents . '</td></tr>';
		}
		$table_check = 1;
	}
	if ($table_check) {
		$table_field .= (ref $table) ? $table->_table : '</tbody></table>';
	} else {
		$table_field = '';
	}
	$table_field = ($setting::page{$setting::key}{'fieldFrame'}) ? $this->get_frame($setting::page{$setting::key}{'fieldFrame'},$table_field,$name,'no','section','item-table') : '<div id="item-table" class="section">' . ((defined $name) ? $name : '') . '<div class="body">' . $table_field . '</div></div>' if defined $table_field && $table_field ne '';
	$table_field = $top_field . $table_field;

	#ɽ
	print $table_field if !defined $setting::page{$setting::key}{'tableValign'} || $setting::page{$setting::key}{'tableValign'} ne 'bottom';
}

#񤭽Ф
foreach (sort {$a <=> $b} keys %field::ORDER) {
	my($id,%db,$db,$title,$contents);
	$id = $field::ORDER{$_};

	if (!$have_template) {

		#ȥå׹ܤ򥹥å
		next if $id eq $field::for{'top'};

		#ơ֥ܤ򥹥å/ʹܤ򥹥å
		next unless ref $field::obj{$id} && !$field::obj{$id}->{'detailTable'} && !$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret')) && $field::obj{$id}->format_for_detail_enabled;

	}

	$db = $field::obj{$id}->db;
	if (defined $db && $db) {
		tie(%db, $env::dbm_file, "$default::db/$db", O_RDONLY, $env::dbm_mode);
	}
	if (defined $have_template && $have_template) {
		$temp{$id} = $db{$main::n};
		untie %db;

	} else {
		my($name,$title,$contents);

		#ƥĤ򥹥å
		$contents = $field::obj{$id}->format_for_detail($db{$main::n},$path,$main::c,$main::n);
		untie %db;
		next if $contents !~ /\S/ || $contents eq '&nbsp;';
		print '<div class="section" id="item-' . $id . '">';

		#̾
		$name = $field::obj{$id}->name;
		if (defined $name && $name ne '' && $name ne '&nbsp;' && $name =~ /\S/) {
			$name = '<h2 class="item-title">' . $name . '</h2>';
			if (defined $setting::page{$setting::key}{'fieldTitleOption'} && $setting::page{$setting::key}{'fieldTitleOption'}) {
				$title = $name;
			} else {
				print(($setting::page{$setting::key}{'fieldTitleFrame'}) ? $this->get_frame($setting::page{$setting::key}{'fieldTitleFrame'},$name,'','no','item-titlebar') : $name);
			}
		}

		#
		print(($setting::page{$setting::key}{'fieldFrame'}) ? $this->get_frame($setting::page{$setting::key}{'fieldFrame'},$contents,$title,'no','item-body') : ((defined $title) ? $title : '') . '<div class="body">' . $contents . '</div>');
		print '</div>';
	}
}

#ƥץ졼Ȥˤäƽ
if (defined $have_template && $have_template) {
	print $this_template->replace(
		$this->event_dt_replace(
			$this->page_item_replace(
				$this_template->deco($setting::page{$setting::key}{'template'}),
				0,
				'',
				$setting::page{$setting::key}{'title'}
			),
			$event_dt
		),
		\%temp,
		'detail',
		$path,
		$main::c,
		$main::n
	);

#ɽ
} elsif (defined $setting::page{$setting::key}{'tableValign'} && $setting::page{$setting::key}{'tableValign'} eq 'bottom') {
	print $table_field;
}

#ڡեå
if (!$have_template || $have_template < 2) {
	print '<div id="close-button" class="panel">' . $this->close_button(
			(($target_date && !$ENV{'HTTP_REFERER'}) ? $cgi::path . '?' . ((defined $main::c) ? 'c=' . $main::c . '&' : '') . 'date=' . $target_date : ''),
			$setting::page{'closeButton'},
			$setting::page{'backButton'}
		) . '</div>';
	$this->print_page_footer($setting::key);
}

}

sub is_guest ($) {
my $this = shift;
return $this->{'is_guest'} if defined $this->{'is_guest'};
my($id,$field,@mail,$is_guest);
$is_guest = 0;
FIELD:
while (($id,$field) = each %field::obj) {
	if ($field->{'e-mail'} || $field->{'class'} eq 'xcal_inviter') {
		my(%db);
		tie(%db, $env::dbm_file, $default::db . '/' . $field->db, O_RDONLY, $env::dbm_mode);
		if (ref tied %db) {
			if ($field->{'class'} eq 'xcal_inviter') {
				my $data = $db{$main::n};
				GUEST:
				while ($data =~ /^(.*?)$/mg) {
					my $line = $1;
					next GUEST if $line =~ /^organizer=/;
					chomp $line;
					my($email,$key) = split(/\x09/,$line);
					next GUEST if !$email;
					push(@mail,$email);
					if ($main::guest{'email'} && $email eq $main::guest{'email'} && $main::guest{'key'} && $key eq $main::guest{'key'}) {
						$is_guest = 1;
						last GUEST;
					}
				}
			} else {
				push(@mail,$db{$main::n});
			}
		}
		untie(%db);
		last FIELD if $is_guest;
	}
}
if (!$is_guest && @mail) {
	@mail = $this->get_address(@mail);
	$is_guest = 1 if $this->is_authorized(@mail);
}
$this->{'is_guest'} = $is_guest;
return $is_guest;
}

sub event_dt_replace ($$$) {
my($this,$template,$event_dt) = @_;
$template =~ s/<\!--dt(?!\w)([^>]*)-->(.*?)<\!--\/dt(?!\w)[^>]*-->/$this->item_tag_replace('dt',$1,$2,$event_dt)/ges;
return $template;
}

sub get_event_date ($$) {
my($this,$n) = @_;
my(%dt,$dt_start,$dt_end,$rrule);
tie(%dt, $env::dbm_file, $default::db . '/dt', O_RDONLY, $env::dbm_mode);
if (ref tied %dt && $dt{$n} && $dt{$n} =~ /^(\w+)-(\w+)\x09(\S*)\x09/) {
	($dt_start,$dt_end,$rrule) = ($1,$2,$3);
}
untie %dt;
$rrule = {$this->get_hash_from_rrule($rrule)};
return($this->get_event_date_info($dt_start,$dt_end,$rrule),(((!$rrule->{'FREQ'} || $rrule->{'UNTIL'}) && $dt_start =~ /^(\d{8})/) ? $1 : ''));
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;						#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 1;						#ơ֥ɤ߹
	$setting::page = 1;						#ڡɤ߹

	$setting::field_db_name = 'inputfield';	#եDB
	$setting::field = 2;						#եɤ߹ߡ2=ꥸʥɤ߹
	$setting::field_style_disabled = 0;			#2=եꥹ̵/1=եΤ̵
	$setting::field_tag_enabled = 'no';				#tag=Τ/all=Ƥ/no=Ĥʤ

	#省
	$setting::security_key = 'browse';							#ǥեȥƥ
	$setting::key = 'detail';						#ڡꥭ

	#å
	$cookie::id_enabled = 1;							#ID󥯥åɤ߹

	#ǥեȥ
	$main::k = 'detail' if !defined $main::k ||  !$main::k;

	#ɬܥե
	@setting::form = ('m','k','n');
	push(@setting::form,'c') if $default::subdivided;

	#饹Ͽ
	Common::class_register('detail','DetailViewer');

}

1;
