package CategoryEditor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ƥ꡼Խ⥸塼
# CategoryEditor.pm ver1.0.7
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-09-25
######################################################################
# ¹
sub run ($) {
my $this = shift;
my($newname,$newid,@folder);

use Fcntl qw(:DEFAULT :flock);
eval 'use ' . $env::dbm_file . ';';

unless (opendir(DIR, $default::db)) {
	push(@{$this->{'dialog'}},'ǡ١ǥ쥯ȥǧƤ');
} else {
	#no warnings qw(numeric);
	@folder = sort {$a <=> $b || $a cmp $b} grep(-d "$default::db/$_" && $_ !~ /^\-/ && -d "$default::master_preference_dir/$_",readdir(DIR));
	closedir(DIR);
}


#񤭹
if (defined $main::a && $main::a eq 'e') {

	#ǡ
	push (@main::delete,$main::delete) if defined $main::delete && $main::delete;
	@main::delete = grep($_ ne '',@main::delete);
	$this->delete_category(\@main::delete);

	#
	if (defined $main::new{'id'} && $main::new{'id'} ne '') {
		$main::new{'id'} = $this->z_to_h($main::new{'id'});
		if ($this->mk_category($main::new{'id'},\@folder,$main::new{'name'},$main::new{'mastername'},$main::new{'master'})) {
	
			#
			if (defined $main::notification && $main::notification) {
				my %installmsg;
				$this->import_db($default::preference_dir . '/installmsg',\%installmsg);
				$installmsg{'subject'} = 'ڤΤ餻ۥߤޤ' if !defined $installmsg{'subject'} || !$installmsg{'subject'};
				$installmsg{'msg'} = 'URL' . "\x0A" . '<uri>' . "\x0A\x0A" . 'ĶġURL' . "\x0A" . '<tool>' . "\x0A" if !defined $installmsg{'msg'} || !$installmsg{'msg'};
				my $tool = $this->my_url . '?m=Tools&c=' . $main::new{'id'};
				my $uri = $this->my_url . '?c=' . $main::new{'id'};
				$installmsg{'msg'} =~ s/<(uri|url)>/$uri/igs;
				$installmsg{'msg'} =~ s/<tool>/$tool/igs;
				unless (ref $cgi::SendMail) {
					require CMONOS::CGI_Lib::SendMail;
					$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
				}
				$cgi::SendMail->send_mail(
					'To'		=>  (($main::new{'master'}) ? (($main::new{'mastername'}) ? $main::new{'mastername'} . ' <' . $main::new{'master'} . '>' : $main::new{'master'}) : $env::master_email),
					'From'		=>  (($setting::general{'master'}) ? (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}) : $env::master_email),
					'Subject'	=>  $installmsg{'subject'},
					'message'	=>  $installmsg{'msg'} . "\x0A\x0A"
				);
			}
			undef %main::new;
		}

	} elsif ($main::new{'name'} ne '' || $main::new{'mastername'} ne '' || $main::new{'master'} ne '') {
		push(@{$this->{'dialog'}},'ե̾Ƥ');
	}
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1 title="ƥ꡼ߤԤޤ">ƥ꡼Խ</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=> 'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="e" />';
print '<fieldset><legend>ƥ꡼Խ</legend>';

#ơ֥
require CMONOS::CGI_Lib::Table;
my $table = Table->new;
$table->set(
	'tableclass' => 'tooltable',
	'trclass' => 'odd,even',
	'class0' => 'odd,even',
	'classF' => 'caution',
	'thenabled' => 'true'
);

print $table->table;

#إå
print $table->tr;
print $table->td('');
print $table->td('ե̾');
print $table->td('ƥ꡼̾');
print $table->td('̾');
print $table->td('ͥɥ쥹');
print $table->td('Ķ');
print $table->_tr;

unless (opendir(DIR, $default::db)) {
	print $table->tr . $table->td('ǡ١ǥ쥯ȥǧƤ',{'colspan' => '6'}) . $table->_tr;
} else {
	#no warnings qw(numeric);
	@folder = sort {$a <=> $b || $a cmp $b} grep(-d "$default::db/$_" && $_ !~ /^[\.\-]/,readdir(DIR));
	closedir(DIR);
}

#
my(%name);
foreach (@folder) {
	my(%setting);
	print $table->tr;
	tie(%setting, $env::dbm_file, $default::master_preference_dir . '/' . $_ . '/general', O_RDONLY, $env::dbm_mode);
	$name{$_} = (ref tied %setting && $setting{'cginame'} ne '') ? $this->escape($setting{'cginame'}) : $_;
	print $table->td('<input type="checkbox" name="delete" value="' . $_ . '" onclick="cmonos.form.field(this).checkboxConfirm(\'' . $name{$_} . ' ˴ϢƤΥǡޤ˺ޤ\')" />');
	print $table->td($_);
	print $table->td($name{$_});
	print $table->td((ref tied %setting && defined $setting{'mastername'} && $setting{'mastername'} ne '') ? $this->escape($setting{'mastername'}) : '');
	print $table->td((ref tied %setting && defined $setting{'master'} && $setting{'master'} ne '') ? $this->escape($setting{'master'}) : '');
	untie %setting;
	print $table->td('<a href="./start.cgi?m=Tools&amp;c=' . $_ . '" target="_blank">Ķ</a>');
	print $table->_tr;
}

#
print $table->tr;
print $table->td('');
print $table->td('<input type="text" name="new:id" size="10" value="' . $this->escape($main::new{'id'}) . '" maxlength="16" />');
print $table->td('<input type="text" name="new:name" size="20" value="' . $this->escape($main::new{'name'}) . '" maxlength="30" />');
print $table->td('<input type="text" name="new:mastername" size="20" value="' . $this->escape($main::new{'mastername'}) . '" maxlength="20" />');
print $table->td('<input type="text" name="new:master" size="30" value="' . $this->escape($main::new{'master'}) . '" />');
print $table->td('');
print $table->_tr;

print $table->_table;
print '<div class="hints">ƥ꡼ɲäˤϿե̾ޤ</div>';
print '</fieldset>';

#ǥե
print '<fieldset><legend>ɤ߹</legend><table class="field-table"><tbody>';
if (@folder) {
	print '<tr><td class="field-name"><label for="import">Υݡ</label></td>';
	print '<td class="field"><select name="import" id="import" title="¸ߤ륫ƥ꡼ꡦʳɤ߹ߤޤ"><option value=""></option>';
	foreach my $f (@folder) {
		print '<option value="' . $f . '"' . (($main::import && $main::import eq $f) ? ' selected="selected"' : '') . '>' . $name{$f} . '</option>';
	}
	print '</select>';
	print '</td></tr>';
}
print '<tr><td class="field-name"><label for="pref">Υǥե</label></td><td class="field">';
$this->print_backup_menu('pref');
print '</td></tr><tr><td class="field-name"><label for="field">եΥǥե</label></td><td class="field">';
$this->print_backup_menu('field');
print '</td></tr></tbody></table></fieldset>';

print '<fieldset class="submit"><label><input type="checkbox" name="notification" value="1"' . (($main::notification) ? ' checked="checked"' : '') . ' /> ƥ꡼δͤ˥ƥ꡼Τ</label> <input type="submit" value="¸" class="save" /></fieldset>';
print '</form>';

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# ƥ꡼
sub delete_category ($$) {
my($this,$delete_ids) = @_;
return if !@$delete_ids;
my(@urls,$home_url);
$home_url = $this->my_url . '?m=DetailViewer&c=';

use File::Path;
foreach my $cid (@$delete_ids) {
	next if !defined $cid ||  $cid eq '';
	if (-d "$default::db/$cid") {
		rmtree "$default::db/$cid";
	}
	if (-d "$default::file/$cid") {
		rmtree "$default::file/$cid";
	}
	if (-d "$default::master_preference_dir/$cid") {
		rmtree "$default::master_preference_dir/$cid";
	}
	if (-d "$default::master_field_pref_dir/$cid") {
		rmtree "$default::master_field_pref_dir/$cid";
	}
	push(@urls,$home_url . $cid);
}
require CMONOS::CGI_Lib::IndexSweeper;
IndexSweeper->new(
	'index_files'	=>	[
							$env::externalfiles . '/recentcomments.ssi',
							$env::externalfiles . '/recenttrackbacks.ssi',
						],
	'rss_files'		=>	[
							'../../index.xml',
							'../../comment.xml',
							'../../trackback.xml',
							'../../podcast.xml',
							$default::file . '/index.xml',
							$default::file . '/comment.xml',
							$default::file . '/trackback.xml',
							$default::file . '/podcast.xml',
						],
)->sweep(\@urls,{$default::id => $delete_ids});

#ǡξõ
my(%mtime);
tie(%mtime, $env::dbm_file, $default::master_db_dir . '/category_mtime', O_RDWR, $env::dbm_mode);
foreach my $cid (@$delete_ids) {
	delete $mtime{$cid};
}
untie(%mtime);

return;
}

######################################################################
# ƥ꡼
sub mk_category ($$$$) {
my($this,$id,$folder,$name,$mastername,$master) = @_;
return if !defined $id ||  $id eq '';
my($error);
if ($master ne '' && $this->is_invalid_email_address($master)) {
	push(@{$this->{'dialog'}},'ƥ꡼ߤ˼Ԥޤͥɥ쥹ǧƤ');
	$error = 1;
}
if ($id =~ /\W/) {
	push(@{$this->{'dialog'}},'ƥ꡼ߤ˼Ԥޤե̾ȾѱѿˤƤ');
	$error = 1;
}
if (length $id > 32) {
	push(@{$this->{'dialog'}},'ƥ꡼ߤ˼Ԥޤե̾Ĺޤ');
	$error = 1;
}
if (grep($_ eq $id,@$folder)) {
	push(@{$this->{'dialog'}},'ƥ꡼ߤ˼ԤޤΥե̾ϴ˻ȤƤޤ');
	$error = 1;
}
return 0 if defined $error && $error;

#ɬפʥǥ쥯ȥ
my($pref,$field);
$pref = $default::master_preference_dir . '/' . $id;
($field = $default::master_field_pref_dir) =~ s!^$default::master_preference_dir/!$pref/!;

$this->set_dir("$default::file/$id");
$this->set_dir("$default::db/$id");
$this->set_dir($pref);
$this->set_dir($field);

#ΥݡorХååɤ߹
if (defined $main::import && $main::import ne '' && $main::import !~ /\W/ && -d $default::master_preference_dir . '/' . $main::import) {
	my($import,$import_field,$icon);
	$import = $default::master_preference_dir . '/' . $main::import;
	($import_field = $default::master_field_pref_dir) =~ s!^$default::master_preference_dir/!$import/!;
	$this->directory_copy($import,$pref,0,['^[\.\-]','\.(html|htm|txt|cgi)$']);
	$this->directory_copy($import_field,$field,0,['^[\.\-]','\.(html|htm|txt|cgi)$']);
	$icon = $this->fileglob($default::master_file_dir . '/' . $main::import,'^icon\.(gif|jpg|png)$');
	if (defined $icon && $icon) {
		my($icon_name);
		$icon_name = $1 if $icon =~ /(icon\.(gif|jpg|png)$)$/;		
		$this->file_copy($icon,$default::master_file_dir . '/' . $id . '/' . $icon_name);
	}
	if (-f $default::master_file_dir . '/' . $main::import . '/event-category.css') {
		$this->file_copy($default::master_file_dir . '/' . $main::import . '/event-category.css',$default::master_file_dir . '/' . $id . '/event-category.css');
	}
} else {
	$this->restore($backup::default{'pref'},$pref,'bak',$id);
	$this->restore($backup::default{'field'},$field,'bak');
}

#ǥեȤ
$this->restore($backup::default{'pref'},$pref,$main::restore{'pref'},$id);
$this->restore($backup::default{'field'},$field,$main::restore{'field'});

my(%general);
tie(%general, $env::dbm_file, $pref . '/general', O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %general) {
	$general{'cginame'} = $name if defined $name && $name;
	$general{'mastername'} = $mastername if defined $mastername && $mastername;
	$general{'master'} = $master if defined $master && $master;
}
untie %general;

#롼׹Ͽ
my(%category_mtime);
tie(%category_mtime, $env::dbm_file, $default::master_db_dir . '/category_mtime', O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %category_mtime) {
	$category_mtime{$id} = time;
}
untie %category_mtime;
return 1;
}

######################################################################
# ˥塼
sub print_backup_menu ($$) {
my($this,$key) = @_;
my(%bak);
%bak = ();
$this->get_backup_list_hash($backup::default{$key},\%bak) if defined $backup::default{$key} && $backup::default{$key};
if (!%bak) {
	print '<div class="hints">ե뤬ޤ</div>';
	return;
}
print '<select name="restore:', $key, '" id="restore:', $key, '" title="륫ƥ꡼ɬפưޤ">';
print '<option value=""></option>';
print '<option value="bak"' . (($main::restore{$key} && $main::restore{$key} eq 'bak') ? ' selected="selected"' : '') . '>' . $bak{'bak'} . '</option>' if $bak{'bak'};
foreach my $ext (sort keys %bak) {
	next if $ext eq 'bak';
	print '<option value="', $ext, '"', (($main::restore{$key} && $main::restore{$key} eq $ext) ? ' selected="selected"' : ''), '>';
	print $bak{$ext};
	print '</option>';
}
print '</select>';
}

sub get_backup_list_hash ($$$) {
my($this,$dir,$bak) = @_;
$this->_get_backup_list_hash($env::default_dir . '/' . $dir,$bak) if $env::default_dir;
$this->_get_backup_list_hash($env::user_default_dir . '/' . $dir,$bak,1) if $env::user_default_dir;
}

sub _get_backup_list_hash ($$$;$) {
my($this,$path,$bak,$user_dir) = @_;
my($db,@files);
if (-d $path) {
	$db = '.*?';
} else {
	($path,$db) = ($1,$2) if $path =~ m!^(.*)/([^/]+)$!;
	$db =~ s/\.([^\/\.]+)$//;
}
$path =~ s!/$!!;
if (opendir(DIR,$path)) {
	@files = grep(-f "$path/$_" && $_ !~ /^\./,readdir(DIR));
	closedir(DIR);
	foreach my $file_name (@files) {
		if ($file_name =~ /^$db\.bak$/) {
			next if defined $$bak{'bak'} && $$bak{'bak'} ne '';
			$$bak{'bak'} = 'ɸ';
		} elsif ($file_name =~ /^$db\.(\w+\.default)$/) {
			my $ext = (($user_dir) ? '~' : '') . $1;
			next if defined $$bak{$ext} && $$bak{$ext} ne '';
			if (open(FILE, "$path/$file_name")) {
				binmode FILE;
				$$bak{$ext} = <FILE>;
				close(FILE);
				chomp $$bak{$ext};
				$$bak{$ext} .= '&lt;ͭ&gt;' if $env::user_default_dir && !$user_dir;
			}
		}
	}
}
}

######################################################################
# ǥեȤ
sub restore ($$$$;$) {
my($this,$bakpath,$dbpath,$ext,$id) = @_;
my $default_dir;
if ($ext && $ext =~ s/^~//) {
	$default_dir = $env::user_default_dir || $env::default_dir;
	$bakpath = $default_dir . '/' . $bakpath;
} elsif ($bakpath) {
	$default_dir = $env::default_dir;
	$bakpath = $default_dir . '/' . $bakpath;
}
return if !$ext || ($ext ne 'bak' && $ext !~ /^\w+\.default$/) || !$bakpath || !$dbpath;
local(*DIR);
return unless opendir(DIR,$bakpath);
my @db = grep(-f "$bakpath/$_" && $_ !~ /^[\.\-]/,readdir(DIR));
closedir(DIR);
my $user_directory = $this->home_directory(1);
my $home_dir_id = ($env::home_dir_id) ? $env::home_dir_id : '';
my $home_url = $this->full_path('../../',1);
my $home_url_encoded = $this->url_encode($home_url);
my $error = 0;
foreach my $db (@db) {
	my(%db,$file,$db);
	$file = $bakpath . '/' . $db;
	$db = $dbpath . '/' . $db;
	next unless -f $file && $db =~ s/\.$ext$//;
	tie(%db, $env::dbm_file, $db, O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %db) {
		my $data = $this->read_file($file);
		if ($data) {
			while ($data =~ /([^\x09\x0A\x0D]+)\x09([^\x0A\x0D]*)[\x0A\x0D]*/sg) {
				my($k,$v) = ($1,$2);
				$k =~ s/\&#09;/\x09/gs;
				$k =~ s/\x0B/\x0A/gs;
				$v =~ s/\&#09;/\x09/gs;
				$v =~ s/\x0B/\x0A/gs;
				$v =~ s!<home-dir-id>!$home_dir_id!gs;
				$v =~ s/<home-url>/$home_url/gs;
				$v =~ s/<home-url-encoded>/$home_url_encoded/gs;
				$v =~ s!<user-directory>!$user_directory!gs;
				utf8::encode($k) if utf8::is_utf8($k);
				utf8::encode($v) if utf8::is_utf8($v);
				eval '$db{$k} = $v;';
				$error++ if defined $@ && $@;
			}
		}
	}
	untie %db;
}
if (defined $id && $id ne '') {
	$ext =~ s/\.default$//;
	my $css = $default::master_file_dir . '/' . $id . '/event-category.css';
	my $path = $default_dir . '/calendar/default/css/event-category.' . $ext . '.css';
	$this->file_copy($path,$css) if -f $path;
}
push(@{$this->{'dialog'}},'̤礭᤮' . $error . '˼Ԥޤ') if $error;
return;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);
if ($default::subdivided && (!defined $main::c || $main::c eq '')) {

	#饹Ͽ
	Common::class_register('00c0','CategoryEditor');

	#˥塼Ͽ
	$setting::jump_menu{'00c0'} = 'ƥ꡼Խ';

}
}



1;
