package GeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
######################################################################
# ⥸塼
# GeneralSetting.pm ver1.0.4
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
#  ǽ2011-02-04
######################################################################
# åܼ
sub get_sub_setting_items ($) {
my $this = shift;

#åܥå
push(@check::checkbox,'skipConfirmation','siteRSSEnabled','RSSEnabled','freqDisabled','dateDisabled','endDateDisabled');
push(@check::checkbox,'masterRSSEnabled') if $default::subdivided;

#
push(@check::notag,'description');

#å
$check::num{'boundsStart'} = 'դȻϰ()';
$check::num{'boundsEnd'} = 'դȻϰ(λ)';

#
if (!$default::subdivided) {
	$check::imagefile{'icon'} = 'ƥ꡼';								#̾
	
} else {
	if ($master::general{'subicon'}) {
		$check::imagefile{'icon'} = 'ƥ꡼';								#̾
		$check::maxsize{'icon'} = ($master::general{'iconMaxSize'}) ? $master::general{'iconMaxSize'} : 30000;	#ե륵
		$check::widthlimit{'icon'} = $master::general{'iconWidthLimit'};		#ե벣
		$check::heightlimit{'icon'} = $master::general{'iconHeightLimit'};		#ե⤵
	}
	push(@check::checkbox,'p');
}
return;
}

######################################################################
# Ķ2
sub sub_set_preferences ($) {
my $this = shift;

# ƥ꡼ʤ
if (!defined $default::subdivided || !$default::subdivided) {
	$cgi::enctype_multipart = 1;
	$default::file = '.' if !defined $default::file || $default::file eq '';
	$preference::filedir{'icon'} = $default::file;				#¸ǥ쥯ȥ

# ƥ꡼
} elsif ($default::subdivided && defined $main::c && $main::c ne '') {
	if (defined $master::general{'subicon'} && $master::general{'subicon'}) {
		$cgi::enctype_multipart = 1;
		$default::file = '.' if !defined $default::file || $default::file eq '';
		$preference::filedir{'icon'} = $default::file;				#¸ǥ쥯ȥ
	}
}
}

######################################################################
# ѥͥ
sub print_sub_preference_panel ($$) {
my($this,$master) = @_;

# ƥ꡼
if ($default::subdivided) {
	print '<fieldset><legend>ƥ꡼</legend>';
	if ($master::general{'subicon'}) {
		print '<fieldset><legend>ƥ꡼</legend>';
		$this->print_image_upload_form('icon','icon',\%main::data);
		print '</fieldset>';
	}
	print '<fieldset><legend><label for="data:description"></label></legend>';
	print '<textarea name="data:description" id="data:description" cols="56" rows="6" wrap="soft" title="ǥåɽ륫ꤷޤ">' . ((defined $main::data{'description'}) ? $main::data{'description'} : '') . '</textarea>';
	print '<div class="extra-field"><label><input type="checkbox" name="data:p" value="1"' . (($main::data{'p'}) ? 'checked="checked"' : '') . ' /> ԤϢ³ &lt;p&gt; Ѵ</label></div>';
	print '<div class="note">ǥåɽ륫ꤷޤ</div></fieldset>';
	print '</fieldset>';
}

print '<fieldset><legend>ͽԽ</legend>';
print '<table class="field-table"><tbody>';

print '<tr><td class="field-name"><span class="datatitle">Ƥγǧ</span></td>';
print '<td class="field"><label><input type="checkbox" name="data:skipConfirmation" id="data:skipConfirmation" value="1"' . (($main::data{'skipConfirmation'}) ? 'checked="checked"' : '') . ' /> ͽƳǧά</label></td>';
print '</tr>';

print '<tr>';
print '<td class="field-name"><label for="data:notice">ͽ</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	'data:notice','ͽͤӶƱʡΤ뤫ɤꤷޤ','',$main::data{'notice'},
	''			=>		'ͽεǽ',
	'on'		=>		'᡼ΡƤޤޤʤ',
	'data'		=>		'᡼ΡƤޤ'
);
print '</td>';
print '</tr>';

print '</tbody></table>';
print '</fieldset>';

print '<fieldset><legend>ϰ</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="data:freqDisabled" value="1"' . (($main::data{'freqDisabled'}) ? ' checked="checked"' : '') . ' /> ַ֤λѤߤ</label></li>';
print '<li><label><input type="checkbox" name="data:dateDisabled" value="1"' . (($main::data{'dateDisabled'}) ? ' checked="checked"' : '') . ' /> ֽλѤߤ</label>';
print ' (<label><input type="checkbox" name="data:endDateDisabled" value="1"' . (($main::data{'endDateDisabled'}) ? ' checked="checked"' : '') . ' /> դޤֻػߤ</label>)</li>';
print '</ol>';
print '<fieldset><legend>դȻ</legend>';
print '<input type="text" size="3" maxlength="3" name="data:boundsStart" value="' . $this->escape($main::data{'boundsStart'}) . '" />';
print $this->mk_select_menu(
	'data:boundsStartUnit','','',($main::data{'boundsStartUnit'} || 'day'),
	'min'		=>		'ʬ',
	'hour'		=>		'',
	'day'		=>		'',
	'week'		=>		'',
	'month'		=>		'',
	'year'		=>		'ǯ',
);
print $this->mk_select_menu(
	'data:boundsStartDirection','','',$main::data{'boundsStartDirection'},
	'before'	=>		'',
	'after'		=>		'',
);
print ' <input type="text" size="3" maxlength="3" name="data:boundsEnd" value="' . $this->escape($main::data{'boundsEnd'}) . '" />';
print $this->mk_select_menu(
	'data:boundsEndUnit','','',($main::data{'boundsEndUnit'} || 'day'),
	'min'		=>		'ʬ',
	'hour'		=>		'',
	'day'		=>		'',
	'week'		=>		'',
	'month'		=>		'',
	'year'		=>		'ǯ',
);
print $this->mk_select_menu(
	'data:boundsEndDirection','','',$main::data{'boundsEndDirection'},
	'before'	=>		'',
	'after'		=>		'',
);
print 'ޤ';
print '</fieldset>';
print '<fieldset><legend>٥ȤĹ</legend>';
print '<input type="text" size="3" maxlength="3" name="data:minLength" value="' . $this->escape($main::data{'minLength'}) . '" />';
print $this->mk_select_menu(
	'data:minLengthUnit','','',($main::data{'minLengthUnit'} || 'min'),
	'min'		=>		'ʬ',
	'hour'		=>		'',
	'day'		=>		'',
	'week'		=>		'',
	'month'		=>		'',
	'year'		=>		'ǯ',
);
print 'ʾ <input type="text" size="3" maxlength="3" name="data:maxLength" value="' . $this->escape($main::data{'maxLength'}) . '" />';
print $this->mk_select_menu(
	'data:maxLengthUnit','','',($main::data{'maxLengthUnit'} || 'min'),
	'min'		=>		'ʬ',
	'hour'		=>		'',
	'day'		=>		'',
	'week'		=>		'',
	'month'		=>		'',
	'year'		=>		'ǯ',
);
print 'ʲ';
print '</fieldset>';
print '<fieldset><legend>ʬ׻</legend>';
print $this->mk_select_menu(
	'data:minScale','','',$main::data{'minScale'},
	''		=>		'1ʬ',
	'5'		=>		'5ʬ',
	'10'		=>		'10ʬ',
	'15'		=>		'15ʬ',
	'20'		=>		'20ʬ',
	'30'		=>		'30ʬ',
);
print '</fieldset>';
print '</fieldset>';

#RSS
print '<fieldset><legend>RSS</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="data:siteRSSEnabled" value="1"' . (($main::data{'siteRSSEnabled'}) ? ' checked="checked"' : '') . ' /> ' . ((-f '../../index.xml') ? '<a href="../../index.xml" target="_blank">Το(RSS)</a>' : 'Το(RSS)') . '򹹿</label></li>';
print '<li><label><input type="checkbox" name="data:masterRSSEnabled" value="1"' . (($main::data{'masterRSSEnabled'}) ? ' checked="checked"' : '') . ' /> ' . (($default::master_file_dir && -f $default::master_file_dir . '/index.xml') ? '<a href="' . $default::master_file_dir . '/index.xml' . '" target="_blank">Το(RSS)</a>' : 'Το(RSS)') . '򹹿</label></li>' if $default::subdivided;
print '<li><label><input type="checkbox" name="data:RSSEnabled" value="1"' . (($main::data{'RSSEnabled'}) ? ' checked="checked"' : '') . ' /> ' . (($default::file && -f $default::file . '/index.xml') ? '<a href="' . $default::file . '/index.xml' . '" target="_blank">Υο(RSS)</a>' : 'Υο(RSS)') . '򹹿</label></li>';
print '</ol>';
print '</fieldset>';

}

######################################################################
# å
sub _is_valid_setting ($) {
my $this = shift;
my $start = $this->bounds_to_datetime($main::data{'boundsStart'},$main::data{'boundsStartUnit'},$main::data{'boundsStartDirection'});
my $end = $this->bounds_to_datetime($main::data{'boundsEnd'},$main::data{'boundsEndUnit'},$main::data{'boundsEndDirection'});
if ($start && $end && $start > $end) {
	push(@{$cgi::action->{'dialog'}},'դȻϰϤǧƤλˤʤäƤޤ') if ref $cgi::action;
	delete $main::data{'boundsStart'};
	delete $main::data{'boundsStartUnit'};
	delete $main::data{'boundsStartDirection'};
	delete $main::data{'boundsEnd'};
	delete $main::data{'boundsEndUnit'};
	delete $main::data{'boundsEndDirection'};
}
my $min = $this->timeunit_to_sec($main::data{'minLength'},$main::data{'minLengthUnit'});
my $max = $this->timeunit_to_sec($main::data{'maxLength'},$main::data{'maxLengthUnit'});
$main::data{'minLengthUnit'} = 'min' if !$main::data{'minLengthUnit'};
$main::data{'maxLengthUnit'} = 'max' if !$main::data{'maxLengthUnit'};
if ($min && $max && $min > $max) {
	push(@{$cgi::action->{'dialog'}},'٥ȤĹϰϤǧƤû֤Ĺ֤ĹʤäƤޤ') if ref $cgi::action;
	delete $main::data{'minLength'};
	delete $main::data{'minLengthUnit'};
	delete $main::data{'maxLength'};
	delete $main::data{'maxLengthUnit'};
}
if ($main::data{'minScale'} && !grep($_ eq $main::data{'minScale'},5,10,15,20,30)) {
	$main::data{'minScale'} = '';
}
return;
}

sub bounds_to_datetime ($$$$) {
my($this,$bounds,$bounds_unit,$bounds_direction) = @_;
if (defined $bounds && $bounds ne '') {
	$bounds = $this->timeunit_to_sec($bounds,$bounds_unit);
	if ($bounds_direction && $bounds_direction eq 'before') {
		return time - $bounds;
	} else {
		return time + $bounds;
	}
}
return 0;
}

sub timeunit_to_sec ($$$) {
my($this,$t,$unit) = @_;
if (defined $t && $t ne '') {
	$unit = 'day' if !$unit;
	if ($unit eq 'min') {
		$t *= 60;
	} elsif ($unit eq 'hour') {
		$t *= 3600;
	} elsif ($unit eq 'month') {
		$t *= 2592000;
	} elsif ($unit eq 'year') {
		$t *= 31536000;
	} elsif ($unit eq 'week') {
		$t *= 604800;
	} else {
		$t *= 86400;
	}
	return $t;
}
return 0;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);
unless ($default::subdivided && (!defined $main::c || $main::c eq '')) {
	#饹Ͽ
	Common::class_register('0000','GeneralSetting');

	#ġϿ
	$setting::jump_menu{'0000'} = '';
}
}

1;
