package Viewer;
require CMONOS::Calendar::CalCommon;
@ISA = qw(CalCommon);
use strict;
######################################################################
# ٥ɽ⥸塼
# Viewer.pm ver1.0.6
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-06-03
######################################################################
# $this->{'event'} = {
#	title		=>	ȥ,
#	start_date	=>	(20070505),
#	start_time	=>	ϻ(1010),
#	end_date	=>	λ(20070505),
#	end_time	=>	λ(1110),
#	category	=>	٥ȥƥ꡼ID,
#	rrurl		=>	RRULE ϥåե
# }
# $this->{'date'} = {
#	start_min	=>	ʬ(0-1440),
#	end_min		=>	λʬ(0-1440),
#	prev		=>	ޤ³,
#	next		=>	³,
# }
######################################################################
# ¹
sub run ($) {
my $this = shift;
my(%db,$view,$title_field,$title_db,%date,%event,@dates,%match);

#ǧԤܷٹ
$this->set_pending_item_alert if !defined $main::v && $this->is_secure('tools');

#ᥤ󥿡å
if ($main::today || !$main::date || $this->is_nan($main::date) || $main::date < 19700101 || $main::date > 20360101) {
	$main::date = $this->time_to_dtstamp(time,1);
} else {
	$main::date = $this->dt_fix($main::date,1);
}

#ꥻå
if ($main::reset) {
	undef %main::search;
	undef $main::and;
}

#ǥեɽ
if ($setting::page{'viewer'}{'defaultView'} && $setting::page{'viewer'}{'defaultView'} eq 'M') {
	$main::v = 'm';
} elsif (!$main::v) {
	$main::v = (($setting::page{'viewer'}{'defaultView'}) ? $setting::page{'viewer'}{'defaultView'} : 'w');
}

#ӥ塼֥
if ($main::srch) {
	require CMONOS::Calendar::CalSearch;
	$view = CalSearch->new;
	$this->print_calendar($view);
	return;
} elsif ($main::v eq 'm') {
	require CMONOS::Calendar::CalMonthlyView;
	$view = CalMonthlyView->new;
} elsif ($main::v eq 'd') {
	require CMONOS::Calendar::CalDailyView;
	$view = CalDailyView->new;
} else {
	$main::v = 'w';
	require CMONOS::Calendar::CalWeeklyView;
	$view = CalWeeklyView->new;
}
if ($main::next) {
	$main::date = $view->next_calendar_date($main::date);
} elsif ($main::prev) {
	$main::date = $view->prev_calendar_date($main::date);
}

#٥ȥƥ꡼å
if ($field::for{'category'}) {
	$this->import_db($default::preference_dir . '/event_category',\%setting::event_category,1) unless %setting::event_category && ref $setting::event_category{'ORDER'} && %{$setting::event_category{'ORDER'}};
}

#ɽоݤȤʤ
@dates = $view->get_target_dates($main::date);

use Fcntl qw(:DEFAULT :flock);
eval 'use ' . $env::dbm_file . ';';
tie(%{$db{'category'}}, $env::dbm_file, "$default::db/category", O_RDONLY, $env::dbm_mode) if $field::for{'category'};
tie(%{$db{'dt'}}, $env::dbm_file, "$default::db/dt", O_RDONLY, $env::dbm_mode);
tie(%{$db{'date'}}, $env::dbm_file, "$default::db/date", O_RDONLY, $env::dbm_mode);
$title_field = ($field::for{'title'}) ? $field::for{'title'} : ($field::for{'key'}) ? $field::for{'key'} : ($field::for{'name'}) ? $field::for{'name'} : "";
if ($title_field) {
	$title_db = $field::obj{$title_field}->db;
	tie(%{$db{$title_db}}, $env::dbm_file, "$default::db/$title_db", O_RDONLY, $env::dbm_mode);
}
require CMONOS::CGI_Lib::Holiday;
my $holiday = Holiday->new;

#ɽоݤȤʤ륤٥Ȥɤ߹
my @search_fields = (%main::search) ? keys %main::search : ();
DATE:
foreach my $ymd (@dates) {
	my($y,$m,$d,$md);
	$date{$ymd} = {};

	#Ϣ
	my @dt = ('DAILY',$ymd);
	if ($ymd =~ /^(\d{4})(\d{2})(\d{2})$/) {
		$md = $2 . $3;
		($y,$m,$d) = ($1,$2+0,$3+0);
		$date{$ymd}{'wday'} = $this->get_wday($y,$m,$d);
		my $holiday_name = $holiday->jp($y)->name($m,$d);
		$date{$ymd}{'holiday'} = $holiday_name if $holiday_name;
		my $w = $this->number_to_wday($date{$ymd}{'wday'});
		my $wn = int($d / 7) + (($d % 7) ? 1 : 0) . $w;
		push(@dt,$w,$wn,$d,$md);
	}

	#ϢդΥ٥
	DATEID:
	foreach my $dt (@dt) {
		if ($db{'date'}->{$dt}) {
			my @n = split(/,/,$db{'date'}->{$dt});
			EVENT:
			foreach my $n (@n) {
				my $category = '';
				my $category_name = '';
				my $prev = ($n =~ s/^([\-]?\d+)<//) ? eval($1) : 0;
				my $next = ($n =~ s/>([\-]?\d+)$//) ? eval($1) : 0;

				#ƥ꡼å
				if ($field::for{'category'} && %setting::event_category && ref $setting::event_category{'ORDER'} && %{$setting::event_category{'ORDER'}} && $db{'category'}->{$n}) {
					$category = $db{'category'}->{$n};
					if (!ref $setting::event_category{$category}) {
						undef $category;
					} elsif ($setting::event_category{$category}{'closed'} && !$this->is_secure('closed')) {
						next EVENT;
					}
					$category_name = $setting::event_category{$category}{'name'};
				}

				#
				if (@search_fields) {
					my($id,$is_matched,$search_enabled);
					SEARCH:
					foreach my $id (@search_fields) {
						if (
							ref $field::obj{$id}
							&& (
								$id eq $title_field
								|| $field::obj{$id}->{'class'} eq 'xcal_category'
								|| (defined $setting::security{'detail'}{'passwordCheck'} && $setting::security{'detail'}{'passwordCheck'} eq 'nocheck')
								|| $this->is_one_of_owners
							)
							&& !$field::obj{$id}->{'Hidden'}
							&& $field::obj{$id}->match_enabled
							&& ($field::obj{$id}->{'Open'} || $this->is_secure('secret'))
						) {
							$search_enabled = 1;
							my $db = $field::obj{$id}->db;
							next SEARCH if !defined $db || !$db;
							tie(%{$db{$db}}, $env::dbm_file, "$default::db/$db", O_RDONLY, $env::dbm_mode) if !ref tied %{$db{$db}};
							if ($field::obj{$id}->match(\$db{$db}->{$n})) {
								$is_matched	= 1;
							} elsif ($main::and) {
								next EVENT;
							}
						}
					}
					next EVENT if $search_enabled && !$is_matched;
					if (!$search_enabled) {
						undef %main::search;
						undef @search_fields;
					}
				}

				if (ref $event{$n}) {
					next EVENT if !$this->is_required_date($dt,$event{$n}->{'rrule'},$event{$n}->{'start_date'},$event{$n}->{'end_date'},$ymd,$y,$m,$d,$md,\$prev,\$next);
				} elsif ($db{'dt'}->{$n} =~ /^(\d{8})T?(\d{6}|)-(\d{8})T?(\d{6}|)\x09(\S*)/) {
					my($start_date,$start_time,$end_date,$end_time,$rrule) = ($1,$2,$3,$4,$5);
					my $rrule_hash;
					if ($rrule) {
						while ($rrule =~ /\G(\w+)=([\w,]+);?/g) {
							my($k,$v) = ($1,$2);
							if ($v =~ /,/) {
								$rrule_hash->{$k} = [split(/,/,$v)];
							} else {
								$rrule_hash->{$k} = $v;
							}
						}
						$this->scalar_to_array(\$rrule_hash->{'BYDAY'}) if $rrule_hash->{'BYDAY'};
						next EVENT if !$this->is_required_date($dt,$rrule_hash,$start_date,$end_date,$ymd,$y,$m,$d,$md,\$prev,\$next);
						$event{$n}->{'rrule'} = $rrule_hash;
					}
					$event{$n}->{'title'} = $this->detag_text($field::obj{$title_field}->usual_format($db{$title_db}->{$n},$default::file . '/' . $n,$main::c,$n)) if $title_field;
					$event{$n}->{'title'} = $category_name if (!defined $event{$n}->{'title'} || $event{$n}->{'title'} eq '') && $category_name;
					$event{$n}->{'start_date'} = $start_date;
					$event{$n}->{'start_time'} = $start_time if $start_time ne '';
					$event{$n}->{'end_date'} = $end_date;
					$event{$n}->{'end_time'} = $end_time if $end_time ne '';
					$event{$n}->{'category'} = $category if $category;
				} else {
					next EVENT;
				}
				my @available_wday;
				if ($category && defined $setting::event_category{$category}{'availableWday'} && (ref $setting::event_category{$category}{'availableWday'} || $setting::event_category{$category}{'availableWday'} ne '')) {
					$this->scalar_to_array(\$setting::event_category{$category}{'availableWday'});
					@available_wday = @{$setting::event_category{$category}{'availableWday'}};
					my $is_holiday = ($date{$ymd}{'wday'} != 0 && $date{$ymd}{'holiday'} && grep($_ == 7,@available_wday)) ? 1 : 0;
					unless (
							(grep($_ == $date{$ymd}{'wday'},@available_wday) && !$is_holiday)
						||	(!grep($_ == $date{$ymd}{'wday'},@available_wday) && $is_holiday)
					) {
						if (!$event{$n}->{'start_time'} && !$setting::event_category{$category}{'overlapDisabled'}) {
							$date{$ymd}{'date'}{$n}{'prev'} = $prev;
							$date{$ymd}{'date'}{$n}{'next'} = $next;
							$date{$ymd}{'date'}{$n}{'span'} = 0;
							$date{$ymd}{'date'}{$n}{'hidden'} = 1;
						}
						next EVENT;
					}					
				}
				if ($category && defined $setting::event_category{$category}{'availableTime'} && $setting::event_category{$category}{'availableTime'} ne '') {
					if ($event{$n}->{'start_time'} || $setting::event_category{$category}{'overlapDisabled'}) {
						my $start = "0000";
						my $start_time = "0000";
						my $end_time = "2400";
						my $start_min = 0;
						my $end_min = 1440;
						my $count = 0;
						my $this_event;
						if (!$prev && $event{$n}->{'start_time'} && $event{$n}->{'start_time'} =~ /^(\d{2})(\d{2})/) {
							$start_time = sprintf("%.2d", $1) . sprintf("%.2d", $2);
							$start = sprintf("%.2d", $1) . sprintf("%.2d", (($2 >= 30) ? 30 : 0));
							$start_min = $1 * 60 + $2;
						}
						if (!$next && $event{$n}->{'end_time'} && $event{$n}->{'end_time'} =~ /^(\d{2})(\d{2})/) {
							$end_time = sprintf("%.2d", $1) . sprintf("%.2d", $2);
							$end_min = $1 * 60 + $2;
						}
						SAMEEVENT:
						foreach my $span (split(/\s*,\s*/,$setting::event_category{$category}{'availableTime'})) {
							if ($span =~ /^(\d{1,2}):(\d{2})-(\d{1,2}):(\d{2})/) {
								my($f,$t) = (($1 * 60 + $2),($3 * 60 + $4));
								my $s = sprintf("%.2d", $1) . sprintf("%.2d", (($2 >= 30) ? 30 : 0));
								my $st = sprintf("%.2d", $1) . sprintf("%.2d", $2);
								my $et = sprintf("%.2d", $3) . sprintf("%.2d", $4);
								if ($start_min < $t) {
									my $num = $n . (($count) ? '.' . $count : '');
									$start = $s if $f > $start_min;
									$this_event = $date{$ymd}{'time'}{$start}{$num} = {};
									$this_event->{'start_time'} = ($f < $start_min) ? $start_time : $st;
									$this_event->{'end_time'} = ($end_min <= $t) ? $end_time : $et;
									$this_event->{'start_min'} = ($f < $start_min) ? $start_min : $f;
									$this_event->{'end_min'} = ($end_min <= $t) ? $end_min : $t;
									$this_event->{'prev_time'} = ($count) ? 1 : 0;
									$this_event->{'next_time'} = ($end_min > $t) ? 1 : 0;
									$this_event->{'prev'} = $prev;
									$this_event->{'next'} = $next;
									$event{$num} = $event{$n} if $num ne $n;
									last SAMEEVENT if $end_min <= $t;
									$start_min = $t;
									$count++;
								}
							}
						}
						$this_event->{'next_time'} = ($next) ? 1 : 0 if ref $this_event;
					} else {
						$date{$ymd}{'date'}{$n}{'prev'} = $prev;
						$date{$ymd}{'date'}{$n}{'next'} = $next;
						$date{$ymd}{'date'}{$n}{'span'} = $this->date_span($y,$m,$d,$next,\@available_wday,$holiday) if @available_wday;
					}

				} elsif ($event{$n}->{'start_time'}) {
					my $start = "0000";
					my $start_min = 0;
					my $end_min = 1440;
					if (!$prev && $event{$n}->{'start_time'} =~ /^(\d{2})(\d{2})/) {
						my($h,$min) = ($1+0,$2+0);
						$start = sprintf("%.2d", $h) . sprintf("%.2d", (($min >= 30) ? 30 : 0));
						$start_min = $h * 60 + $min;
					}
					if (!$next && $event{$n}->{'end_time'} =~ /^(\d{2})(\d{2})/) {
						$end_min = $1 * 60 + $2;
					}
					$date{$ymd}{'time'}{$start}{$n}{'start_min'} = $start_min;
					$date{$ymd}{'time'}{$start}{$n}{'end_min'} = $end_min;
					$date{$ymd}{'time'}{$start}{$n}{'prev'} = $prev;
					$date{$ymd}{'time'}{$start}{$n}{'next'} = $next;
				} else {
					$date{$ymd}{'date'}{$n}{'prev'} = $prev;
					$date{$ymd}{'date'}{$n}{'next'} = $next;
					$date{$ymd}{'date'}{$n}{'span'} = $this->date_span($y,$m,$d,$next,\@available_wday,$holiday) if @available_wday;
				}
			}
		}
	}
}
undef @search_fields;

#DB³
while (my($k,$db) = each %db) {
	untie(%$db);
}
undef %db;


#---------------------------------------------------------------------
#񤭽Ф
$view->set_event_data(\%date,\%event);
$this->print_calendar($view);
}

sub date_span ($$$$$) {
my($this,$y,$m,$d,$next,$available_wday_array,$holiday) = @_;
my $span = 1;
while ($span <= $next) {
	last if !$this->is_available_wday($available_wday_array,$this->get_next_date_array($y,$m,$d,$span),$holiday);
	$span++;
}
return($span-1);
}

######################################################################
# ϤҤʷ
sub print_calendar ($$) {
my($this,$view) = @_;
$this->use_icon('calendar');
$this->use_deco();

#إå
$this->set_style_sheet_link("$env::css/calendar-common.css");
if ($main::v ne 's') {
	$this->set_style_sheet_link("$default::file/event-category.css");
	if ($setting::page{'viewer'}{'customColorEnabled'}) {
		my $css = '';
		$css .= 'table#daytable, table#daytable td, div#timetable-box, table#timetable-grid, table#timetable-grid td, div.before-half, div.after-half {  border-color: ' . $setting::page{'viewer'}{'cellBorderColor'} . ";  }\x0A" if $setting::page{'viewer'}{'cellBorderColor'};
		$css .= 'table#daytable td, div#timetable-box table td {  background-color: ' . $setting::page{'viewer'}{'cellBgcolor'} . ";  }\x0A" if $setting::page{'viewer'}{'cellBgcolor'};
		$css .= 'div.cal-date {' . (($setting::page{'viewer'}{'cellDateBgcolor'}) ? '  background-color: ' . $setting::page{'viewer'}{'cellDateBgcolor'} . ';' : '') . (($setting::page{'viewer'}{'cellDateColor'}) ? '  color: ' . $setting::page{'viewer'}{'cellDateColor'} . ';' : '') . (($setting::page{'viewer'}{'cellDateBorderColor'}) ? '  border-color: ' . $setting::page{'viewer'}{'cellDateBorderColor'} . ';' : '') . "  }\x0A"if $setting::page{'viewer'}{'cellDateBgcolor'} || $setting::page{'viewer'}{'cellDateColor'} || $setting::page{'viewer'}{'cellDateBorderColor'};
		$css .= 'div.cal-date a {  color: ' . $setting::page{'viewer'}{'cellDateColor'} . ";  }\x0A" if $setting::page{'viewer'}{'cellDateColor'};
		$css .= 'td.calsaturday {  background-color: ' . $setting::page{'viewer'}{'saturdayBgcolor'} . " !important;  }\x0A" if $setting::page{'viewer'}{'saturdayBgcolor'};
		$css .= 'td.calsaturday div.cal-date {' . (($setting::page{'viewer'}{'saturdayDateBgcolor'}) ? '  background-color: ' . $setting::page{'viewer'}{'saturdayDateBgcolor'} . ';' : '') . (($setting::page{'viewer'}{'saturdayDateColor'}) ? '  color: ' . $setting::page{'viewer'}{'saturdayDateColor'} . ';' : '') . (($setting::page{'viewer'}{'saturdayDateBorderColor'}) ? '  border-color: ' . $setting::page{'viewer'}{'saturdayDateBorderColor'} . ';' : '') . "  }\x0A"if $setting::page{'viewer'}{'saturdayDateBgcolor'} || $setting::page{'viewer'}{'saturdayDateColor'} || $setting::page{'viewer'}{'saturdayDateBorderColor'};
		$css .= 'td.calsaturday div.cal-date a {  color: ' . $setting::page{'viewer'}{'saturdayDateColor'} . ";  }\x0A" if $setting::page{'viewer'}{'saturdayDateColor'};
		$css .= 'td.calsunday {  background-color: ' . $setting::page{'viewer'}{'sundayBgcolor'} . " !important;  }\x0A" if $setting::page{'viewer'}{'sundayBgcolor'};
		$css .= 'td.calsunday div.cal-date {' . (($setting::page{'viewer'}{'sundayDateBgcolor'}) ? '  background-color: ' . $setting::page{'viewer'}{'sundayDateBgcolor'} . ';' : '') . (($setting::page{'viewer'}{'sundayDateColor'}) ? '  color: ' . $setting::page{'viewer'}{'sundayDateColor'} . ';' : '') . (($setting::page{'viewer'}{'sundayDateBorderColor'}) ? '  border-color: ' . $setting::page{'viewer'}{'sundayDateBorderColor'} . ';' : '') . "  }\x0A"if $setting::page{'viewer'}{'sundayDateBgcolor'} || $setting::page{'viewer'}{'sundayDateColor'} || $setting::page{'viewer'}{'sundayDateBorderColor'};
		$css .= 'td.calsunday div.cal-date a {  color: ' . $setting::page{'viewer'}{'sundayDateColor'} . ";  }\x0A" if $setting::page{'viewer'}{'sundayDateColor'};
		$css .= 'td.calholiday {  background-color: ' . $setting::page{'viewer'}{'holidayBgcolor'} . " !important;  }\x0A" if $setting::page{'viewer'}{'holidayBgcolor'};
		$css .= 'td.calholiday div.cal-date {' . (($setting::page{'viewer'}{'holidayDateBgcolor'}) ? '  background-color: ' . $setting::page{'viewer'}{'holidayDateBgcolor'} . ';' : '') . (($setting::page{'viewer'}{'holidayDateColor'}) ? '  color: ' . $setting::page{'viewer'}{'holidayDateColor'} . ';' : '') . (($setting::page{'viewer'}{'holidayDateBorderColor'}) ? '  border-color: ' . $setting::page{'viewer'}{'holidayDateBorderColor'} . ';' : '') . "  }\x0A"if $setting::page{'viewer'}{'holidayDateBgcolor'} || $setting::page{'viewer'}{'holidayDateColor'} || $setting::page{'viewer'}{'holidayDateBorderColor'};
		$css .= 'td.calholiday div.cal-date a {  color: ' . $setting::page{'viewer'}{'holidayDateColor'} . ";  }\x0A" if $setting::page{'viewer'}{'holidayDateColor'};
		$css .= 'td.caltoday {  background-color: ' . $setting::page{'viewer'}{'todayBgcolor'} . " !important;  }\x0A" if $setting::page{'viewer'}{'todayBgcolor'};
		$css .= 'td.caltoday div.cal-date {' . (($setting::page{'viewer'}{'todayDateBgcolor'}) ? '  background-color: ' . $setting::page{'viewer'}{'todayDateBgcolor'} . ';' : '') . (($setting::page{'viewer'}{'todayDateColor'}) ? '  color: ' . $setting::page{'viewer'}{'todayDateColor'} . ';' : '') . (($setting::page{'viewer'}{'todayDateBorderColor'}) ? '  border-color: ' . $setting::page{'viewer'}{'todayDateBorderColor'} . ';' : '') . "  }\x0A"if $setting::page{'viewer'}{'todayDateBgcolor'} || $setting::page{'viewer'}{'todayDateColor'} || $setting::page{'viewer'}{'todayDateBorderColor'};
		$css .= 'td.caltoday div.cal-date a {  color: ' . $setting::page{'viewer'}{'todayDateColor'} . ";  }\x0A" if $setting::page{'viewer'}{'todayDateColor'};
		$css .= 'div.monthly-calendar table#daytable td.calextra {  background-color: ' . $setting::page{'viewer'}{'extraBgcolor'} . " !important;  }\x0A" if $setting::page{'viewer'}{'extraBgcolor'};
		$css .= 'div.monthly-calendar table#daytable td.calextra div.cal-date {' . (($setting::page{'viewer'}{'extraDateBgcolor'}) ? '  background-color: ' . $setting::page{'viewer'}{'extraDateBgcolor'} . ';' : '') . (($setting::page{'viewer'}{'extraDateColor'}) ? '  color: ' . $setting::page{'viewer'}{'extraDateColor'} . ';' : '') . (($setting::page{'viewer'}{'extraDateBorderColor'}) ? '  border-color: ' . $setting::page{'viewer'}{'extraDateBorderColor'} . ';' : '') . "  }\x0A"if $setting::page{'viewer'}{'extraDateBgcolor'} || $setting::page{'viewer'}{'extraDateColor'} || $setting::page{'viewer'}{'extraDateBorderColor'};
		$css .= 'div.monthly-calendar table#daytable td.calextra div.cal-date a {  color: ' . $setting::page{'viewer'}{'extraDateColor'} . ";  }\x0A" if $setting::page{'viewer'}{'extraDateColor'};
		$css .= 'table#timetable-grid td.time-scale div.hourly-list {  color: ' . $setting::page{'viewer'}{'timeColor'} . ";  }\x0A" if $setting::page{'viewer'}{'timeColor'};
		$this->set_css($css);
	}
	my($y,$m) = ($main::date =~ /^(\d{4})(\d{2})/) ? ($1+0,$2+0) : ('null','null');
	my $event_category_json = '';
	if (%setting::event_category && ref $setting::event_category{'ORDER'} && %{$setting::event_category{'ORDER'}}) {
		foreach my $o (sort {$a <=> $b} keys %{$setting::event_category{'ORDER'}}) {
			my $id = $setting::event_category{'ORDER'}{$o};
			next if $setting::event_category{$id}{'closed'} && !$this->is_secure('closed');
			$event_category_json .= ', ' if $event_category_json;
			$event_category_json .= "{id : '" . $id . "', name : '" . ((defined $setting::event_category{$id}{'name'} && $setting::event_category{$id}{'name'} ne '') ? $setting::event_category{$id}{'name'} : 'ƥ꡼' . $id) . "'}";
		}
	} else {
		$event_category_json = "{id : '1', name : '٥'}";
	}
	my $option = (%main::search) ? $this->set_query('url',['search','and'],1) : '';
my $javascript = <<JAVASCRIPT;
cmonos.tool.calendar.current = {
	year : $y,
	mon : $m,
	view : '$main::v',
	option : '$option',
	category : [$event_category_json]
};
JAVASCRIPT
	$this->set_javascript($javascript);
	$this->set_onload('cmonos.tool.calendar.restore(\'' . $cgi::path . '?m=Viewer' . (($default::subdivided && $main::c) ? '&amp;c=' . $main::c : '') . '\');');
	$this->set_onload('cmonos.tool.calendar.setUp(' . ((defined $setting::page{$setting::key}{'startTime'}) ? $setting::page{$setting::key}{'startTime'} : '') . ');') if $view->have_timetable;
	$this->push_title($view->page_title($main::date));
	$this->push_title((($default::english) ? 'Search Results' : '')) if %main::search && !$main::srch;
}
$this->set_javascript_link("$env::javascript/cal.js");
$this->print_page_header($setting::key);

#
$this->print_tool_button($view,'top') if $setting::page{$setting::key}{'headIcon'} || (!$setting::page{$setting::key}{'headIcon'} && !$setting::page{$setting::key}{'footIcon'});

#٥ȥꥹ
$view->print_events;

#
$this->print_tool_button($view,'bottom') if $setting::page{$setting::key}{'footIcon'};

#
$this->print_return_button;

#եå
$this->print_page_footer($setting::key);
}

sub push_title ($$) {
my($this,$title) = @_;
return if !defined $title || $title eq '';
$this->push_window_title($title);
if (defined $setting::page{$setting::key}{'titleText'} && $setting::page{$setting::key}{'titleText'} ne '') {
	my $tag = ($setting::page{$setting::key}{'titleText'} =~ s/((<\/[^>]+>)+)$//) ? $1 : '';
	$setting::page{$setting::key}{'titleText'} .= ' (' . $title . ')' . $tag;
}
}

######################################################################
# ɽڤؤܥ
sub view_switch_button ($$;$$$$$$$) {
my($this,$icon,$title,$url,$query,$li_class,$onclick,$target,$is_selected) = @_;
my $button;
$button = '<li' . ((defined $li_class && $li_class ne '') ? ' class="' . $li_class . '"' : '') . '>';
if (defined $url && $url ne '') {
	$url .= $this->amp_escape($this->add_query('url',$query)) if ref $query;
	$button .= $cgi::icon->button(
		$icon,
		$setting::page{'viewer'}{$icon} . (($is_selected) ? '-selected' : ''),
		$url,
		$title,
		$target,
		(($onclick) ? {'onclick' => $onclick} : '')
	);
} else {
	if ($target) {
		if ($onclick =~ /^return/) {
			$onclick =~ s/;$/ \&\& /;
			$onclick .= '(this.form.target=\'' . $target . '\');';
		} else {
			$onclick .= ';' if $onclick;
			$onclick .= 'this.form.target=\'' . $target . '\';';
		}
	}		
	$button .= $cgi::icon->submit_button(
		$icon,
		$setting::page{'viewer'}{$icon} . (($is_selected) ? '-selected' : ''),
		$title,
		(($onclick) ? {'onclick' => $onclick} : ''),
		$query
	);
}
$button .= '</li>';
return $button;
}

sub amp_escape ($$) {
my($this,$url) = @_;
return '' if !defined $url;
$url =~ s/\&/\&amp;/g;
return $url;
}

######################################################################
# ɽ
sub print_tool_button ($;$$) {
my($this,$view,$name) = @_;
my($url,$viewform_flag,$query);
my @form = @setting::form;
push(@form,'date');
if ($setting::general{'postMethod'}) {
	unshift(@form,'n') if $main::v eq 'listevent' && $main::n;
	print $this->form_start(
		'key'	=>	'browse',
		'name'	=>	'view_' . $name,
		'required'	=>	\@form
	);
	$viewform_flag = 1;	
} else {
	$url = $cgi::path . $this->amp_escape($this->set_query('url',\@form));
}
undef @form;
print '<ul class="tools panel" id="view-selector-' . $name . '">';
	
# ICSե
if ($setting::page{'viewer'}{'icsLink'}) {
	print '<li class="group-end"><a href="' . $cgi::path . '?m=Ics' . (($default::subdivided && $main::c) ? '&amp;c=' . $main::c : '') . '" id="ics-download" title="iCalendar ǥ">';
	print '<img src="' . $env::icon_dir . '/ics_16.png" width="16" height="16" border="0" title="iCalendar ǥ" alt="iCalendar ǥ" />';
	print '</a></li>';
}
	
# /ǥå/򥯥ꥢ//
print $this->view_switch_button('calprev','Υ',$url,{'v'=>$main::v,'prev'=>1});
print $this->view_switch_button('calindex','ǥå',$cgi::path) if $default::subdivided;
print $this->view_switch_button('calreset','ꥻå',$url,{'v'=>$main::v,'reset'=>1}) if %main::search;
print $this->view_switch_button('caltoday','',$url,{'v'=>$main::v,'today'=>1});
print $this->view_switch_button('calnext','Υ',$url,{'v'=>$main::v,'next'=>1});

# //
if (!$setting::page{'viewer'}{'defaultView'} || $setting::page{'viewer'}{'defaultView'} ne 'M') {
	print $this->view_switch_button('daily','',$url,{'v'=>'d'},'group-start','','',((!$main::srch && $main::v eq 'd') ? 1 : 0));
	print $this->view_switch_button('weekly','',$url,{'v'=>'w'},'','','',((!$main::srch && $main::v eq 'w') ? 1 : 0));
	print $this->view_switch_button('monthly','',$url,{'v'=>'m'},'','','',((!$main::srch && $main::v eq 'm') ? 1 : 0));
}

# ////ѥͥ//ȥѥͥ
print $this->view_switch_button('calsearch','',$url,{'v'=>$main::v,'srch'=>1},'group-start','','',(($main::srch) ? 1 : 0));
if ((!$setting::page{'viewer'}{'defaultView'} || $setting::page{'viewer'}{'defaultView'} ne 'M') && (!$ENV{'HTTP_USER_AGENT'} || $ENV{'HTTP_USER_AGENT'} !~ /mac/i || $ENV{'HTTP_USER_AGENT'} !~ /MSIE/i)) {
	print $this->view_switch_button('calendarpanel','ѥͥ','javascript:void(0)','','group-start','cmonos.tool.calendar.calendarPalette.open(\'' . $cgi::path . '?m=Viewer' . (($default::subdivided && $main::c) ? '&amp;c=' . $main::c : '') . '\');');
	print $this->view_switch_button('togglepanel','ɽȥѥͥ','javascript:void(0)','','group-start','cmonos.tool.calendar.togglePanel.open();');
}

# 
if ($this->is_secure('input')) {
	print $this->view_switch_button(
		'calinput',
		'ͽϤ',
		$cgi::path . '?m=Editor&amp;k=editor' . (($default::subdivided && $main::c) ? '&amp;c=' . $main::c : '') . '&amp;v=' . $main::v . '&amp;dtstart=' . $main::date,
		'',
		'group-start',
		$this->detail_viewer_opener,
		'detailViewer',
	);
}

# ġ
if ($this->is_secure('tools')) {
	print $this->view_switch_button('caltool','Ķ򳫤',$cgi::path . '?m=Tools' . ((defined $main::c) ? '&amp;c=' . $main::c : ''),'','group-start');
}

# ѥ
if (defined $setting::page{$setting::key}{'pswdIcon'} && $setting::page{$setting::key}{'pswdIcon'}) {
	print $this->view_switch_button(
		'callogin',
		'',
		$env::register_cgi . '?k=pswd&amp;m=Password',
		'',
		'group-start',
		"cmonos.window.open('LoginWindow',450,300)",
		'LoginWindow',
	);
}

print '</ul>';
print '</form>' if defined $viewform_flag && $viewform_flag;
}

######################################################################
# ܥ
sub print_return_button ($) {
my $this = shift;
my($url);
if (defined $setting::page{'returnUrl'} && $setting::page{'returnUrl'}) {
	$url = $setting::page{'returnUrl'};
} elsif (defined $default::subdivided && $default::subdivided) {
	$url = $cgi::path;
} else {
	return;
}
print '<div id="return-to" class="panel">';
print $cgi::Deco->button(
	'return',
	$setting::page{'returnButton'},
	$url,
	(($default::english) ? 'Return' : '')
);
print '</div>';
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);
if (!$default::subdivided || ($default::subdivided && defined $main::c && $main::c ne '')) {

	#Ƽ省
	$setting::security_key = 'browse' if !defined $setting::security_key || $setting::security_key eq '';	#ǥեȥƥ

	#ڡꥭ
	$setting::key = 'viewer' if !defined $setting::key || $setting::key eq '';

	#ǥեȥ
	$main::k = 'viewer' if !defined $main::k || !$main::k;

	#饹Ͽ
	Common::class_register('viewer','Viewer');

}
}

1;
