package CounterEditor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ⥸塼
# CounterEditor.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ¹
sub run ($) {
my $this = shift;
my $counter_pref = $default::preference_dir . '/counter';
my %counter;

#Խ񤭹
if (defined $main::a && $main::a eq 'e') {
	my($k);

	#ʥǡν
	while (($k) = each %main::data) {
		if ($k =~ /^(\d+)_bgcolor$/) {
			my $id = $1;
			if (!defined $main::data{$k} || $main::data{$k} eq '') {
				push(@{$this->{'dialog'}},'ID:' . $id . ' 򹹿ǤޤǤطʿꤵƤޤ');
				delete $main::data{$k};
			} elsif ($this->is_invalid_color($main::data{$k})) {
				push(@{$this->{'dialog'}},'ID:' . $id . ' 򹹿ǤޤǤطʿǧƤ');
				delete $main::data{$k};
			}
		}
		if ($k =~ /^(\d+)_title$/) {
			my $id = $1;
			if (!defined $main::data{$k} || $main::data{$k} eq '') {
				push(@{$this->{'dialog'}},'ID:' . $id . ' 򹹿ǤޤǤȥ뤬ꤵƤޤ');
				delete $main::data{$k};
			}
		}
	}

	#ǡ
	push(@main::delete,$main::delete) if defined $main::delete && $main::delete;
	@main::delete = (@main::delete) ?  grep(defined $_ && $_ ne '',@main::delete) : ();

	#
	if (defined $main::new{'title'} && $main::new{'title'} ne '') {
		if (!defined $main::new{'bgcolor'} || $main::new{'bgcolor'} eq '') {
			push(@{$this->{'dialog'}},'ɲäǤޤǤطʿꤵƤޤ');
			delete $main::new{'bgcolor'};
		} elsif ($this->is_invalid_color($main::new{'bgcolor'})) {
			push(@{$this->{'dialog'}},'ɲäǤޤǤطʿǧƤ');
			delete $main::new{'bgcolor'};
		} else {
			my($k,$v,$n);
			while (1) {
				$n++;
				last if !defined $main::data{$n . '_day'} || $main::data{$n . '_day'} eq '';
			}
			while (($k,$v) = each %main::new) {
				if (ref $v eq 'ARRAY') {
					@{$main::data{$n . '_' . $k}} = @$v;
				} else {
					$main::data{$n . '_' . $k} = $v;
				}
			}
			undef(%main::new);
		}
	}

	$this->write_db($counter_pref,\%main::data,'',\@main::delete,\%counter,1);

} else {
	$this->import_db($counter_pref,\%counter,1);

}
undef(%main::data);

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');
print '<h1></h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="e" />';
print '<fieldset><legend>󥿡ꥹ</legend>';

#ơ֥
require CMONOS::CGI_Lib::Table;
my $table = Table->new;
$table->set(
	'tableclass' => 'tooltable',
	'trclass' => 'odd,even',
	'class0' => 'odd,even',
	'classF' => 'caution',
	'thenabled' => 'true'
);

#ɽ
print $table->table;

#إå
print $table->tr;
print $table->td('');
print $table->td('ID');
print $table->td('ȥ');
print $table->td('');
print $table->td('о');
print $table->td('طʿ');
print $table->_tr;

#
my $id;
foreach $id (sort {$a <=> $b} keys %counter) {
	$this->scalar_to_array(\$counter{$id}{'target'});
	print $table->tr;
	print $table->td('<input type="checkbox" name="delete" value="' . $id . '" onclick="cmonos.form.field(this).checkboxConfirm(\'' . $this->escape($counter{$id}{'title'}) . ' ˴ϢƤΥǡޤ˺ޤ\')" />');
	print $table->td($id);
	print $table->td('<input type="text" name="data:' . $id . '_title" value="' . $this->escape($counter{$id}{'title'}) . '" size="20" />');
	print $table->td($this->day_count_menu('data:' . $id . '_day',$counter{$id}{'day'}));
	print $table->td($this->count_target_menu('data:' . $id . '_target',$counter{$id}{'target'}));
	print $table->td($this->cell_bgcolor('data:' . $id . '_bgcolor',$counter{$id}{'bgcolor'}));
	print $table->_tr;
}

#
$this->scalar_to_array(\$main::new{'target'});
print $table->tr;
print $table->td('');
print $table->td('');
print $table->td('<input type="text" name="new:title" value="' . $this->escape($main::new{'title'}) . '" size="20" />');
print $table->td($this->day_count_menu('new:day',$main::new{'day'}));
print $table->td($this->count_target_menu('new:target',$main::new{'target'}));
print $table->td($this->cell_bgcolor('new:bgcolor',$main::new{'bgcolor'}));
print $table->_tr;

print $table->_table;
undef %$table;
undef $table;

print '<div class="hints">ȤɲäˤϿȥޤ</div></fieldset>';
print '<fieldset class="submit"><input type="submit" value="¸" class="save" /></fieldset>';
print '</form>';
if ($main::a) {
	my $mkcal = $ENV{'SCRIPT_NAME'};
	$mkcal =~ s/start.cgi$/mkcal.cgi/;
	print '<img src="' . $mkcal . '?refresh" width="1" height="1" alt="" />';
}

#ڡեå
$this->print_page_footer('tools');
}

sub day_count_menu ($$$) {
my($this,$name,$default) = @_;
my($menu);
$menu = '<select name="' . $name . '" id="' . $name . '">';
foreach (0..31) {
	$menu .= '<option value="' . $_ . '"' . ((defined $default && $default == $_) ? ' selected="selected"' : '') . '>' . $_ . '</option>';
}
$menu .= '</select>';
return $menu;
}

sub count_target_menu ($$$) {
my($this,$name,$default) = @_;
my($menu);
@$default = ('exception','other') if !ref $default || @$default == 0;
$menu = '<select name="' . $name . '" id="' . $name . '" multiple="multiple" size="5">';
$menu .= '<option value="holiday"' . ((grep($_ eq 'holiday',@$default)) ? ' selected="selected"' : '') . '>˺</option>';
$menu .= '<option value="specialday"' . ((grep($_ eq 'specialday',@$default)) ? ' selected="selected"' : '') . '>̤</option>';
$menu .= '<option value="specialwday"' . ((grep($_ eq 'specialwday',@$default)) ? ' selected="selected"' : '') . '>̤</option>';
$menu .= '<option value="exception"' . ((grep($_ eq 'exception',@$default)) ? ' selected="selected"' : '') . '>̤㳰</option>';
$menu .= '<option value="other"' . ((grep($_ eq 'other',@$default)) ? ' selected="selected"' : '') . '>嵭ʳ</option>';
$menu .= '</select>';
}

sub cell_bgcolor ($$$) {
my($this,$name,$default) = @_;
my $form = '<input type="text" name="' . $name . '" id="' . $name . '" value="' . ((defined $default) ? $default : '') . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'' . $name . '\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"' . ((defined $default) ? ' style="background-color: ' . $default . '"' : '') . ' title="Υطʿꤷޤ" />';
$form .= ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'' . $name . '\')" ondblclick="cmonos.tool.colorPalette.open(\'' . $name . '\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
$form .= ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'' . $name . '\')" ondblclick="cmonos.tool.colorSlider.open(\'' . $name . '\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
return $form;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('d100','CounterEditor');

	#ġϿ
	$setting::jump_menu{'d100'} = '';

}


1;
