package GateKeeper;
require CMONOS::GateKeeper::Tools::DSelector;
@ISA = qw(DSelector);
use strict;
use Fcntl qw(:DEFAULT :flock);
######################################################################
# ´⥸塼
# GateKeeper.pm ver1.0.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-12-20
######################################################################
# ¹
sub run ($) {
my $this = shift;
my($auth_enabled,$auth_dbm_enabled,$auto_disabled,$auto_register_enabled,$auto_reissue_enabled,%name,@user,@options,@search,@account_list,$current_directory,$htaccess,$htpasswd,$htcomment,$htauthdb,$htmaildb,$comment_data,@search_list);
$main::a = '' if !defined $main::a;

#ľ墪˥ǥեȥǥ쥯ȥȤϿ
if ($main::a eq 'ds') {
	my(%general);
	$general{'current'} = $main::current = $this->current_directory;
	$this->write_db($default::preference_dir . '/general',\%general);
	$main::a = '';
}
$current_directory = $this->path_conv($main::current,'path');
$htaccess = $current_directory . '/.htaccess';

#¸Υå
$auto_disabled = 1 if $ENV{'SCRIPT_NAME'} =~ /^$main::current/;
($auth_dbm_enabled,$auto_register_enabled,$auto_reissue_enabled) = $this->get_auth_settings($htaccess);
$auto_register_enabled = ($main::reg eq 'on') ? 1 : 0 if $main::reg;
$auto_reissue_enabled = ($main::reis eq 'on') ? 1 : 0 if $main::reis;
$auto_register_enabled = $auto_reissue_enabled = $main::reg = $main::reis = 0 if $auto_disabled;
if ($auth_dbm_enabled) {
	use AnyDBM_File;
	$htauthdb = $current_directory . '/.htauthdb';
	$htmaildb = $current_directory . '/.htmaildb';
} else {
	$htpasswd = $current_directory . '/.htpasswd';
	$htcomment = $current_directory . '/.htcomment';
}

#²
if ($main::a eq 'cancel') {
	if ((
			($auth_dbm_enabled && $this->delete_auth_dbm($current_directory)) || 
			(!$auth_dbm_enabled && (!-f $current_directory . '/.htgroup' || unlink($current_directory . '/.htgroup')) && (!-f $htpasswd || unlink($htpasswd)) && (!-f $htcomment || unlink($htcomment)))
		) && $this->auth_cancel($htaccess,$current_directory)) {
		undef %main::data;
		$main::a = 'new';
		push(@{$this->{'dialog'}},'¤ޤ');
		($auth_dbm_enabled,$auto_register_enabled,$auto_reissue_enabled) = $this->get_auth_settings($htaccess);
		$auto_register_enabled = $auto_reissue_enabled = $main::reg = $main::reis = 0 if $auto_disabled;
		if ($auth_dbm_enabled) {
			use Fcntl qw(:DEFAULT);
			use AnyDBM_File;
			$htauthdb = $current_directory . '/.htauthdb';
			$htmaildb = $current_directory . '/.htmaildb';
		} else {
			$htpasswd = $current_directory . '/.htpasswd';
			$htcomment = $current_directory . '/.htcomment';
		}
	} else {
		push(@{$this->{'dialog'}},'¤β˼Ԥޤ');
		$main::a = '';
	}

#Ͽȥꥹ
#} elsif ($main::a eq 'list') {
#	undef %main::data;
#	$main::a = '';
}
push(@main::delete,$main::delete) if defined $main::delete && $main::delete;
@main::delete = grep($_ ne '',@main::delete);

#ϤΥå
#.htpasswd / .htcomment ȤΤ
my(%dialog,%new_account,%new_passwd,%mailto,%expiretime,@new_data);
if (%main::data) {
	#no warnings qw(untie);
	my($acc,@new_account,@new_addr,@all_addr,%htauthdb,%htmaildb);
	if ($auth_dbm_enabled) {
		tie(%htauthdb, 'AnyDBM_File', $htauthdb, O_RDONLY, $env::dbm_mode);
		tie(%htmaildb, 'AnyDBM_File', $htmaildb, O_RDONLY, $env::dbm_mode);
	} elsif ($setting::general{'uniqaddr'}) {
		if (open(CMT, $htcomment)) {
			binmode CMT;
			flock(CMT, LOCK_SH);
			my($line);
			while ($line = <CMT>) {
				chomp $line;
				my(@data) = split(/\t/,$line);
				push(@all_addr,$data[2]) if $data[2] && !$main::data{'acc'}{$data[0]};
			}
			close (CMT);
		}
	}
	while (($acc) = each %{$main::data{'acc'}}) {
		my($msg);

		#륢
		next if @main::delete && grep($_ eq $acc,@main::delete);

		#Ĵ
		$main::data{'name'}{$acc} =~ s/\s+/ /sg if defined $main::data{'name'}{$acc};
		$main::data{'cmt'}{$acc} =~ s/\s+/ /sg if defined $main::data{'cmt'}{$acc};
		if ($auth_dbm_enabled) {
			$main::data{'name'}{$acc} =~ s/:/=/g if defined $main::data{'name'}{$acc};
			$main::data{'cmt'}{$acc} =~ s/:/=/g if defined $main::data{'cmt'}{$acc};
		}

		#ȥå
		if (defined $main::data{'acc'}{$acc} && ($main::data{'acc'}{$acc} ne $acc || ($acc =~ /^_\d+$/ && $main::data{'acc'}{$acc} ne ''))) {
			if (($auth_dbm_enabled && $htauthdb{$main::data{'acc'}{$acc}}) || (!$auth_dbm_enabled && grep($_ eq $main::data{'acc'}{$acc},@new_account))) {
				$dialog{$acc} .= 'Υ (' . $main::data{'acc'}{$acc} . ') ϴ˻ѤƤޤ';
			} elsif ($main::data{'acc'}{$acc} =~ /^[0-9a-zA-Z]{1}\w{1,31}$/) {
				$new_account{$acc} = $main::data{'acc'}{$acc};
				push(@new_account,$main::data{'acc'}{$acc}) if !$auth_dbm_enabled;
			} elsif ($acc !~ /^_\d+$/ || $main::data{'acc'}{$acc} ne '') {
				$dialog{$acc} .= 'Ȥ2ʸʾ32ʸȾѱѿˤƤ';
			}
		}

		#ɥ쥹å
		if (defined $main::data{'addr'}{$acc} && $main::data{'addr'}{$acc} ne '') {
			if ($setting::general{'uniqaddr'} && (($auth_dbm_enabled && $htmaildb{$main::data{'addr'}{$acc}} && !grep($_ eq $acc,split(/,/,$htmaildb{$main::data{'addr'}{$acc}}))) || (!$auth_dbm_enabled && (grep($_ eq $main::data{'addr'}{$acc},@new_addr) || grep($_ eq $main::data{'addr'}{$acc},@all_addr))))) {
				$dialog{$acc} .= 'Υ᡼륢ɥ쥹 (' . $main::data{'addr'}{$acc} . ') ϴϿƤޤ';
			} elsif ($this->is_invalid_email_address($main::data{'addr'}{$acc})) {
				$dialog{$acc} .= '᡼륢ɥ쥹ǤϤޤ';
			} elsif (!$auth_dbm_enabled) {
				push(@new_addr,$main::data{'addr'}{$acc});
			}
		}

		#¥å³
		if (defined $main::data{'expire'}{$acc} && $main::data{'expire'}{$acc} ne '') {
			my($year,$mon,$mday) = split(/\D/,$main::data{'expire'}{$acc});
			if ($year && $year > 2000 && $mon && $mday && !$this->is_impossible_mday($year,$mon,$mday)) {
				use Time::Local;
				$main::data{'exptime'}{$acc} = timelocal(0,0,0,$mday+0,$mon-1,$year);
			} else {
				$dialog{$acc} .= 'ͭ¤դ˼ǤޤǤ';
			}
		} elsif (defined $main::data{'lifetime'}{$acc} && $main::data{'lifetime'}{$acc} ne '') {
			if ($main::data{'lifetime'}{$acc} eq 'ever') {
				$main::data{'exptime'}{$acc} = '';
			} elsif ($main::data{'lifetime'}{$acc} =~ /\D/) {
				$dialog{$acc} .= 'ͭ¤˼ǤޤǤ';	
			} else {
				$main::data{'exptime'}{$acc} = time + $main::data{'lifetime'}{$acc};
			}
		}
		if (defined $main::data{'exptime'}{$acc} && $main::data{'exptime'}{$acc} ne '' && $main::data{'exptime'}{$acc} < time) {
			$dialog{$acc} .= '꤬ͭǤޤǤ';
		}

		#ѥɥå
		if (defined $main::data{'passwd'}{$acc} && $main::data{'passwd'}{$acc} ne '' && $this->is_invalid_password($main::data{'passwd'}{$acc},4,8,1)) {
			$dialog{$acc} .= 'ѥɤ4ʸʾ8ʸαѻǻϤޤȾѱѿˤƤ';
		} elsif (defined $main::data{'passwd'}{$acc} && $main::data{'passwd'}{$acc} ne '') {
			$new_passwd{$acc} = $main::data{'passwd'}{$acc};
		}

		#ѥȯ
		if (defined $main::data{'mail'}{$acc} && $main::data{'mail'}{$acc}) {
			if (!defined $main::data{'addr'}{$acc} || $this->is_invalid_email_address($main::data{'addr'}{$acc})) {
				$dialog{$acc} .= '᡼륢ɥ쥹ϿƤʤ᡼ۿǤޤ';
			} elsif (!defined $dialog{$acc} || $dialog{$acc} eq '') {
				$mailto{$acc} = $main::data{'addr'}{$acc};
				$name{$acc} = $main::data{'name'}{$acc} if defined $main::data{'name'}{$acc};
				$expiretime{$acc} = $main::data{'exptime'}{$acc} if defined $main::data{'exptime'}{$acc};
				if (!defined $main::data{'passwd'}{$acc} || $main::data{'passwd'}{$acc} eq '') {
					$new_passwd{$acc} = $this->rand_char;
				}
			}
		}

		#顼
		if ($dialog{$acc} || ($acc =~ /^_\d+$/ && (!$new_account{$acc} || !$new_passwd{$acc}))) {
			$dialog{$acc} .= 'ȤȥѥɤɬꤷƲ' if $acc =~ /^_\d+$/ && ((!$new_account{$acc} && $new_passwd{$acc}) || ($new_account{$acc} && !$new_passwd{$acc} && !$main::data{'mail'}{$acc}));
			delete $new_account{$acc} if defined $new_account{$acc} && $new_account{$acc};
			delete $new_passwd{$acc} if defined $new_passwd{$acc} && $new_passwd{$acc};
		} else {
			push(@new_data,$acc) if ($auth_dbm_enabled && defined $main::data{'acc'}{$acc} && $main::data{'acc'}{$acc} ne '') || (!$auth_dbm_enabled && ($new_account{$acc} || $new_passwd{$acc}));
			delete $main::data{'passwd'}{$acc};
			delete $main::data{'mail'}{$acc};
		}
	}
	if ($auth_dbm_enabled) {
		untie(%htauthdb);
		untie(%htmaildb);
	}
}

#DBM
if ($auth_dbm_enabled) {
	my(%htauthdb,%htmaildb);
	@search = grep($_ ne '',split(/\s+|\xa1\xa1/,$main::search)) if $main::a ne 'new' && defined $main::search && $main::search ne '';
	$main::a = 'new' if !@search && !$main::expired_only;

	#Ͽ/
	if (@new_data || @main::delete || ($main::gc && $this->fileglob($current_directory,'^\.htauthdb','f'))) {
		my($acc,@delete);
		tie(%htauthdb, 'AnyDBM_File', $htauthdb, O_RDWR | O_CREAT, $env::dbm_mode);
		tie(%htmaildb, 'AnyDBM_File', $htmaildb, O_RDWR | O_CREAT, $env::dbm_mode);
		foreach $acc (@new_data) {

			#Ͽ
			if ($acc =~ /^_\d+$/) {
				if ($new_account{$acc} && $new_passwd{$acc}) {
					$htauthdb{$new_account{$acc}} = join(':',
						crypt($new_passwd{$acc}, $this->salt),
						'member',
						$main::data{'name'}{$acc},
						$main::data{'addr'}{$acc},
						$main::data{'cmt'}{$acc},
						((defined $main::data{'exptime'}{$acc}) ? $main::data{'exptime'}{$acc} : '')
					);
					$htmaildb{$main::data{'addr'}{$acc}} = $this->push_account($htmaildb{$main::data{'addr'}{$acc}},$new_account{$acc});
				}

			#
			} elsif ($htauthdb{$acc}) {
				my @data = split(/:/,$htauthdb{$acc});
				my $mail_is_changed = 0;
				if ($new_account{$acc}) {
					delete $htauthdb{$acc};
					$htauthdb{$new_account{$acc}} = join(':',
						(($new_passwd{$acc}) ? crypt($new_passwd{$acc}, $this->salt) : $data[0]),
						$data[1],
						$main::data{'name'}{$acc},
						$main::data{'addr'}{$acc},
						$main::data{'cmt'}{$acc},
						((defined $main::data{'exptime'}{$acc}) ? $main::data{'exptime'}{$acc} : $data[5])
					);
					$htmaildb{$main::data{'addr'}{$acc}} = $this->push_account($htmaildb{$main::data{'addr'}{$acc}},$new_account{$acc});
					$mail_is_changed = 1;
				} else {
					$htauthdb{$acc} = join(':',
						(($new_passwd{$acc}) ? crypt($new_passwd{$acc}, $this->salt) : $data[0]),
						$data[1],
						$main::data{'name'}{$acc},
						$main::data{'addr'}{$acc},
						$main::data{'cmt'}{$acc},
						((defined $main::data{'exptime'}{$acc}) ? $main::data{'exptime'}{$acc} : $data[5])
					);
					if ($data[3] ne $main::data{'addr'}{$acc}) {
						$htmaildb{$main::data{'addr'}{$acc}} = $this->push_account($htmaildb{$main::data{'addr'}{$acc}},$acc);
						$mail_is_changed = 1;
					}
				}
				if ($mail_is_changed) {
					my $old_acc = $this->shift_account($htmaildb{$data[3]},$acc);
					if ($old_acc) {
						$htmaildb{$data[3]} = $old_acc;
					} else {
						delete $htmaildb{$data[3]};
					}
				}
			}
			push(@delete,$acc);
		}
		foreach $acc (@main::delete) {
			my @data = split(/:/,$htauthdb{$acc});
			delete $htauthdb{$acc};
			my $old_acc = $this->shift_account($htmaildb{$data[3]},$acc);
			if ($old_acc) {
				$htmaildb{$data[3]} = $old_acc;
			} else {
				delete $htmaildb{$data[3]};
			}
		}
		if ($main::gc) {
			my($acc,$list,$time,$count);
			$time = time;
			$count = 0;
			while (($acc,$list) = each %htauthdb) {
				my @data = split(/:/,((defined $list) ? $list : ''));
				if ($data[5] && $data[5] < $time) {
					delete $htauthdb{$acc};
					my $old_acc = $this->shift_account($htmaildb{$data[3]},$acc);
					if ($old_acc) {
						$htmaildb{$data[3]} = $old_acc;
					} else {
						delete $htmaildb{$data[3]};
					}
					$count++;
				}
			}
			push(@{$this->{'dialog'}},$count . ' δڤ쥢Ȥޤ') if $count;
		}
		untie(%htauthdb);
		untie(%htmaildb);
		foreach (@delete) {
			$this->delete_data($_);
		}
	}

	#񤭴
	if (@new_data || $main::reg || $main::reis) {

		#.htaccess å
		if ($this->htaccess_is_prepared($htaccess,$current_directory,$auth_dbm_enabled,$auto_register_enabled,$auto_reissue_enabled)) {

				#᡼ˤѥɤ
				$this->mail_to_user(\%mailto,\%new_account,\%new_passwd,\%name,\%expiretime) if %mailto;

		} else {
			push(@{$this->{'dialog'}},'ɬפեǤޤǤѡߥåĴƲ');
		}
	}

	#ǡ١ΥХåå
	if ($main::backup) {
		my $htauthdb_bak = $htauthdb . '.bak';
		my $htmaildb_bak = $htmaildb . '.bak';
		if ($main::backup eq 'make') {
			if ($this->auth_dbm_backup($htauthdb,$htauthdb_bak) && $this->auth_dbm_backup($htmaildb,$htmaildb_bak)) {
				push(@{$this->{'dialog'}},'Хååפޤ');
			} else {
				push(@{$this->{'dialog'}},'ǡ١ ΥХååפ˼Ԥޤ');
			}
		} elsif ($main::backup eq 'restore') {
			if ($this->auth_dbm_restore($htauthdb,$htauthdb_bak) && $this->auth_dbm_restore($htmaildb,$htmaildb_bak)) {
				push(@{$this->{'dialog'}},'Хååפޤ');
			} else {
				push(@{$this->{'dialog'}},'Хååפ˼Ԥޤ');
			}
		} elsif ($main::backup eq 'remove') {
			if ((!-f $htauthdb_bak || unlink $htauthdb_bak) && (!-f $htmaildb_bak || unlink $htmaildb_bak)) {
				push(@{$this->{'dialog'}},'Хååפޤ');
			} else {
				push(@{$this->{'dialog'}},'Хååפκ˼Ԥޤ');
			}
		}
	}

#text
} else {
	my($passwd_data,$new_comment,@gc,$gc_done);
	local(*PASS,*CMT);

	#̾
	if (open(PASS, $htpasswd)) {
		binmode PASS;
		flock(PASS, LOCK_SH);
		my($get_data,$line);
		$get_data = 1 if @new_data || @main::delete || $main::gc;
		while ($line = <PASS>) {
			my($acc);
			$acc = $1 if $line =~ /^([^:]+)/;
			next if grep($_ eq $acc,@main::delete);
			push(@account_list,$acc);
			$passwd_data .= $line if $get_data;
		}
		close (PASS);
		chmod($env::file_mode, $htpasswd);
	}

	#Ƚʣå
	if (%new_account) {
		my($acc,@new_account);
		@new_account = keys %new_account;
		foreach $acc (@new_account) {
			if (grep($_ eq $new_account{$acc},@account_list)) {
				$dialog{$acc} .= 'Υ (' . $new_account{$acc} . ') ϴ˻ѤƤޤ';
				@new_data = grep($_ ne $acc,@new_data);
				delete $new_account{$acc};
				delete $new_passwd{$acc};
				delete $mailto{$acc};
				delete $name{$acc};
				delete $expiretime{$acc};
			} else {
				@account_list = grep($_ ne $acc,@account_list);
				push(@account_list,$new_account{$acc});
			}
		}
	}
	@account_list = sort @account_list;
	$main::a = 'new' if !@account_list;

	#
	if ($main::a ne 'new' && defined $main::search && $main::search ne '') {
		@search = grep($_ ne '',split(/\s+|\xa1\xa1/,$main::search));
		map($_ = quotemeta($_),@search) if !defined $main::regexp || !$main::regexp;
	}

	#.htpasswd 
	if (@new_data) {
		my($acc);
		foreach $acc (@new_data) {

			#Ͽ
			if ($acc =~ /^_\d+$/) {
				$passwd_data .= $new_account{$acc} . ':' . crypt($new_passwd{$acc}, $this->salt) . "\x0A";
			#
			} else {
				unless ($passwd_data =~ s/^$acc:(.*?)$/(($new_account{$acc}) ? $new_account{$acc} : $acc) . ':' . (($new_passwd{$acc}) ? crypt($new_passwd{$acc}, $this->salt) : $1)/me) {
					$passwd_data .= $new_account{$acc} . ':' . crypt($new_passwd{$acc}, $this->salt) . "\x0A" if $new_account{$acc} && $new_passwd{$acc};
				}
			}
		}
	}

	#ɤ߹/
	if (open(CMT, $htcomment)) {
		binmode CMT;
		flock(CMT, LOCK_SH);
		my($line);
		my $t = time;
		while ($line = <CMT>) {
			chomp $line;
			my(@data) = split(/\t/,$line,5);
			if (grep($_ eq $data[0],@main::delete)) {
				$this->delete_data($data[0]);
				$new_comment = 1;
				next;
			}
			if ($main::gc && ((defined $main::data{'exptime'}{$data[0]} && $main::data{'exptime'}{$data[0]} && $main::data{'exptime'}{$data[0]} < time) || ($data[4] && $data[4] < time))) {
				push(@gc,$data[0]);
				$this->delete_data($data[0]);
				$new_comment = 1;
				next;	
			}
			if (defined $main::data{'acc'}{$data[0]} && $main::data{'acc'}{$data[0]} ne '' && !$dialog{$data[0]}) {
				if ($main::data{'acc'}{$data[0]} ne $data[0] || $main::data{'name'}{$data[0]} ne $data[1] || 
					$main::data{'addr'}{$data[0]} ne $data[2] || $main::data{'cmt'}{$data[0]} ne $data[3] || defined $main::data{'exptime'}{$data[0]}) {
					$line = join("\x09",$main::data{'acc'}{$data[0]},$main::data{'name'}{$data[0]},$main::data{'addr'}{$data[0]},$main::data{'cmt'}{$data[0]},((defined $main::data{'exptime'}{$data[0]}) ? $main::data{'exptime'}{$data[0]} : $data[4]));
					$new_comment = 1;
				}
				$this->delete_data($data[0]);
			}
			if (@search) {
				my $dat = join("\t",@data[0..3]);
				push(@search_list,((defined $main::data{'acc'}{$data[0]} && $main::data{'acc'}{$data[0]} ne '') ? $main::data{'acc'}{$data[0]} : $data[0])) if (!$main::expired_only || ($data[4] && $data[4] < $t)) && ((!$main::and  && grep(eval{$line =~ /$_/},@search)) || ($main::and && grep(eval{$line !~ /$_/},@search) == 0));
			} elsif ($main::expired_only) {
				push(@search_list,((defined $main::data{'acc'}{$data[0]} && $main::data{'acc'}{$data[0]} ne '') ? $main::data{'acc'}{$data[0]} : $data[0])) if $data[4] && $data[4] < $t;
			}
			$comment_data .= $line . "\x0A";
		}
		close (CMT);
		chmod($env::file_mode, $htcomment);
	}

	#.htpasswd ڤ쥢Ȥ
	if ($main::gc && @gc && $passwd_data) {
		my $count = 0;
		my $gc;
		foreach $gc (@gc) {
			$count++ if $passwd_data =~ s/^$gc:.*?\x0A//m;
		}
		@account_list = grep{my $acc = $_;!grep($_ eq $acc,@gc)} @account_list;
		$main::a = 'new' if !@account_list;
		if ($count) {
			$gc_done = 1;
			push(@{$this->{'dialog'}},$count . ' δڤ쥢Ȥޤ');
		}
	}

	#Ͽ
	if (%main::data) {
		my($acc,@delete);
		while (($acc) = each %{$main::data{'acc'}}) {
			if (defined $main::data{'acc'}{$acc} && $main::data{'acc'}{$acc} ne '' && !$dialog{$acc}) {
				$comment_data .= join("\x09",$main::data{'acc'}{$acc},$main::data{'name'}{$acc},$main::data{'addr'}{$acc},$main::data{'cmt'}{$acc},((defined $main::data{'exptime'}{$acc}) ? $main::data{'exptime'}{$acc} : '')) . "\x0A";
				$new_comment = 1;
				push(@delete,$acc);
			}
		}
		foreach (@delete) {
			$this->delete_data($_);
		}
	}

	#񤭴
	if ($passwd_data || $new_comment) {

		#.htaccess å
		if ($this->htaccess_is_prepared($htaccess,$current_directory,$auth_dbm_enabled,$auto_register_enabled,$auto_reissue_enabled) &&

			#.htpasswd 
			(!$passwd_data || $this->write_file($htpasswd,\$passwd_data,1)) &&

			#.htcomment 
			(!$new_comment || $this->write_file($htcomment,\$comment_data,1))) {

				#᡼ˤѥɤ
				$this->mail_to_user(\%mailto,\%new_account,\%new_passwd,\%name,\%expiretime) if %mailto;

		} else {
			push(@{$this->{'dialog'}},'ɬפեǤޤǤѡߥåĴƲ');
		}
	} elsif ($main::reg || $main::reis) {
		push(@{$this->{'dialog'}},'ѹ˼Ԥޤ') if !$this->htaccess_is_prepared($htaccess,$current_directory,$auth_dbm_enabled,$auto_register_enabled,$auto_reissue_enabled)
	}
}

#顼
my($error_account);
if (%dialog) {
	my $acc;
	foreach $acc (sort keys %dialog) {
		push(@{$this->{'dialog'}},(($acc =~ /^_(\d+)$/) ? ' ' . ($1+0) . ' Ͽ' : ' ' . $acc . ' ι') . '˼Ԥޤ' . $dialog{$acc});
	}
	$error_account = 1;
}
undef %dialog;

#ڡ
my($lastpage,$pageoption);
$main::u = 10 if $this->is_nan($main::u) || $main::u > 100;
$main::p = 1 if $this->is_nan($main::p);

#Խо
my(@target);

#顼
if (defined $error_account && $error_account) {
	@target = sort keys %{$main::data{'acc'}};
	$main::u = @target if $main::u < @target;
	$main::a = (defined $main::ref) ? $main::ref : '';
	if ($main::a ne 'new') {
		if ($auth_dbm_enabled) {
			my(%htauthdb);
			tie(%htauthdb, 'AnyDBM_File', $htauthdb, O_RDONLY, $env::dbm_mode);
			if (ref tied %htauthdb) {
				foreach (@target) {
					my @data = split(/:/,$htauthdb{$_});
					$main::data{'exptime'}{$_} = $data[5];
				}
			}
			untie(%htauthdb);
		} else {
			if (open(CMT, $htcomment)) {
				binmode CMT;
				flock(CMT, LOCK_SH);
				my($line);
				while ($line = <CMT>) {
					if (grep($line =~ /^$_\t/,@target)) {
						chomp $line;
						my @data = split(/\t/,$line);
						$main::data{'exptime'}{$data[0]} = $data[4];
					}
				}
				close(CMT);
			}
		}
	}

#
} elsif ($main::a eq 'new') {
	foreach (1..$main::u) {
		push(@target,'_' . sprintf("%.2d", $_));
	}

#顼ʤ
} else {

	#CSV񤭽Ф
	if ($main::a eq 'csv') {
		my $agent = ($ENV{'HTTP_USER_AGENT'}) ? $ENV{'HTTP_USER_AGENT'} : '';
		my $jcode = '';
		my $r = "\x0A";
		if ($agent =~ /win/i) {
			$jcode = 'sjis';
			$r = "\x0D\x0A";
		} elsif ($agent =~ /mac/i) {
			$jcode = 'sjis';
			$r = "\x0D";
		}
		#$this->print_http_header('text/comma-separated-values');
		$this->print_http_header('application/csv');
		if ($auth_dbm_enabled) {
			my(%htauthdb);
			tie(%htauthdb, 'AnyDBM_File', $htauthdb, O_RDONLY, $env::dbm_mode);
			if (ref tied %htauthdb) {
				my($k,$v);
				while (($k,$v) = each %htauthdb) {
					my @data = split(/:/,$v);
					@data = splice(@data,2,3);
					my $value = $this->svjoin(',',$k,@data);
					$this->jcode_convert(\$value,$jcode,'euc') if $jcode;
					print($value,$r);
				}
			}
			untie(%htauthdb);
		} else {
			if (open(CMT, $htcomment)) {
				binmode CMT;
				flock(CMT, LOCK_SH);
				while (<CMT>) {
					$_ =~ s/\x09\d*\x0A//;
					my $v = $this->svjoin(',',split(/\t/,$_));
					$this->jcode_convert(\$v,$jcode,'euc') if $jcode;
					print($v,$r);
				}
				close(CMT);
			}
		}
		exit;
	}

	#no warnings qw(untie);
	my($account_list,$acc,$count,$from,$to,%htauthdb);
	undef %main::data;
	if ($auth_dbm_enabled) {
		@search_list = ();
		if (@search || $main::expired_only) {
			tie(%htauthdb, 'AnyDBM_File', $htauthdb, O_RDONLY, $env::dbm_mode);
			if (@search) {
				if ($main::field && $main::field eq 'addr') {
					my(%htmaildb);
					tie(%htmaildb, 'AnyDBM_File', $htmaildb, O_RDONLY, $env::dbm_mode);
					if (ref tied %htmaildb) {
						foreach (@search) {
							push(@search_list,split(/,/,$htmaildb{$_})) if $htmaildb{$_};
						}
					}
					untie(%htmaildb);
				} else {
					@search_list = grep($htauthdb{$_},@search) if ref tied %htauthdb;
				}
				if (@search_list && $main::expired_only) {
					my @temp_list = ();
					my $t = time;
					foreach (@search_list) {
						push(@temp_list,$_) if $htauthdb{$_} =~ /(\d+)$/ && $1 < $t;
					}
					@search_list = @temp_list;
				}
			} else {
				my($k,$v);
				my $t = time;
				while (($k,$v) = each %htauthdb) {
					push(@search_list,$k) if $v =~ /(\d+)$/ && $1 < $t;
				}
			}
		}
		@search_list = sort @search_list if @search_list;
		$account_list = \@search_list;
	} elsif (@search || $main::expired_only) {
		@search_list = sort @search_list;
		$account_list = \@search_list;
	} else {
		$account_list = \@account_list;
	}

	#ڡȽ
	$lastpage = ($main::u) ? ((@$account_list % $main::u) ? int(@$account_list / $main::u) + 1 : @$account_list / $main::u) : 1;
	if ($main::p < 1) {
		$main::p = 1;
	} elsif ($main::p > $lastpage) {
		$main::p = $lastpage;
	}
	($from,$to) = (($main::u * ($main::p - 1)),($main::u * $main::p)) if $main::u > 0;
	foreach $acc (@$account_list) {
		$count++;
	
		#ڡ
		if ($main::u > 0) {
			if ($from >= $count) {
				$pageoption = 1;
				next;
			} elsif ($to < $count) {
				$pageoption = 1;
				last;
			}
		}
		push(@target,$acc);
	}

	#ǡ
	foreach $acc (@target) {
		$main::data{'acc'}{$acc} = $acc;
		if ($auth_dbm_enabled) {
			my($passwd,$group);
			($passwd,$group,$main::data{'name'}{$acc},$main::data{'addr'}{$acc},$main::data{'cmt'}{$acc},$main::data{'exptime'}{$acc}) = split(/:/,$htauthdb{$acc});
		} elsif ($comment_data =~ /^$acc\t(.*)$/m) {
			($main::data{'name'}{$acc},$main::data{'addr'}{$acc},$main::data{'cmt'}{$acc},$main::data{'exptime'}{$acc}) = split(/\t/,$1);
		}
	}
	untie(%htauthdb) if $auth_dbm_enabled;
}
undef $comment_data if !$auth_dbm_enabled;
$lastpage = 1 if !defined $lastpage || !$lastpage;

$auth_enabled = 1 if ($auth_dbm_enabled && $this->fileglob($current_directory,'^\.htauthdb','f')) || (!$auth_dbm_enabled && -f $htpasswd);

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1 title="¤ˤĤꤷޤ"> (' . (($main::current) ? $main::current : '/') . ')' . (($auto_register_enabled) ? '<span style="background-color: #f66">[ưϿ ON]</span>' : '') . '' . (($auto_reissue_enabled) ? '<span style="background-color: #ff6">[ưȯ ON]</span>' : '') . '</h1>';

#ե೫
print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=> 'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	[@setting::form,'current']
);
print '<input type="hidden" name="ref" value="' . $main::a . '" />';
print '<fieldset class="submit">';
if ($auth_dbm_enabled) {
	print '<select name="field">';
	print '<option value="acc">Ȥ</option>';
	print '<option value="addr"' . (($main::field && $main::field eq 'addr') ? ' selected="selected"' : '') . '>᡼륢ɥ쥹</option>';
	print '</select>';
	print '<input type="search" placeholder="" results="5" autosave="' . (($default::id) ? $default::id : 'gatekeeper') . '" size="30" name="search" value="' . $this->escape($main::search) . '" title="ʸޤॢȤΤФޤ" />';
	print 'Τ줫˰פ桼';
	print '<input type="submit" value="" />';
} else {
	print '<input type="search" placeholder="" results="5" autosave="' . (($default::id) ? $default::id : 'gatekeeper') . '" size="30" name="search" value="' . $this->escape($main::search) . '" title="ʸޤॢȤΤФޤ" />';
	print '<select name="regexp">';
	print '<option value="">ɽԻ</option>';
	print '<option value="1"' . (($main::regexp) ? ' selected="selected"' : '') . '>ɽ</option>';
	print '</select>';
	print '<select name="and">';
	print '<option value="">Ĥ˰</option>';
	print '<option value="1"' . (($main::and) ? ' selected="selected"' : '') . '>Ƥ˰</option>';
	print '</select>';
	print '<input type="submit" value="" />';
}
print ' <label><input type="checkbox" name="expired_only" value="1"' . (($main::expired_only) ? ' checked="checked"' : '') . ' /> ڤ쥢ȤΤ߸</label>';
print '</fieldset>';

print '<fieldset><legend>Ȱ</legend>';
if (@target) {
	
	#桼ƥ꡼˥塼
	@options = split(/\x0A/,$setting::general{'options'}) if defined $setting::general{'options'} && $setting::general{'options'};

	print ' (' . $main::p . '/'. $lastpage . 'ڡ)';

	#Ϸ̥ơ֥
	require CMONOS::CGI_Lib::Table;
	my $table = Table->new;
	$table->set(
		'tableclass' => 'tooltable',
		'trclass' => 'odd,even',
		'class0' => 'odd,even',
		'classF' => (($main::a ne 'new') ? 'caution' : ''),
		'thenabled' => 'true'
	);

	print $table->table;
	print $table->tr;
	print $table->td('') if $main::a ne 'new';
	print $table->td('');
	print $table->td('̾');
	print $table->td('᡼륢ɥ쥹');
	print $table->td('');
	print $table->td('ͭ' . (($main::a ne 'new') ? '' : ''));
	print $table->td('ͭ' . (($main::a ne 'new') ? '' : ''));
	print $table->td('ѥ');
	print $table->td('');
	print $table->_tr;

	my($acc);
	foreach $acc (@target) {
		print $table->tr;
		print $table->td('<input type="checkbox" name="delete" value="' . $acc . '" />') if $main::a ne 'new';
		print $table->td('<input type="text" name="data:acc:' . $acc . '" value="' . $this->escape($main::data{'acc'}{$acc}) . '" size="10" />');
		print $table->td('<input type="text" name="data:name:' . $acc . '" value="' . $this->escape($main::data{'name'}{$acc}) . '" size="10" />');
		print $table->td('<input type="text" name="data:addr:' . $acc . '" value="' . $this->escape($main::data{'addr'}{$acc}) . '" size="24" />');
		print $table->td($this->account_comment($acc,\@options));
		print $table->td($this->mk_select_menu(
			'data:lifetime:' . $acc,'ѥɤͭ¤򤷤ޤ','',$main::data{'lifetime'}{$acc},
			''			=>		(($main::a eq 'new' || !$main::data{'exptime'}{$acc}) ? '̵' : $this->date($main::data{'exptime'}{$acc},0,'gmt' . $setting::general{'datetype'}) . (($main::data{'exptime'}{$acc} < time) ? '[!]' : '')),
			86400		=>		'1',
			604800		=>		'1',
			1209600		=>		'2',
			2678400		=>		'1',
			5270400		=>		'2',
			8208000		=>		'3',
			10540800	=>		'4',
			13219200	=>		'5',
			15811200	=>		'6',
			18489600	=>		'7',
			21081600	=>		'8',
			23760000	=>		'9',
			26352000	=>		'10',
			29030400	=>		'11',
			31536000	=>		'1ǯ',
			47347200	=>		'1ǯ6',
			63072000	=>		'2ǯ',
			94608000	=>		'3ǯ',
			(($main::a ne 'new') ? ('ever' => '̵') : ())
		));
		print $table->td('<input type="text" name="data:expire:' . $acc . '" value="' . $this->escape($main::data{'expire'}{$acc}) . '" size="10" maxlength="10" title="YYYY/MM/DD" />');
		print $table->td('<input type="text" name="data:passwd:' . $acc . '" value="' . $this->escape($main::data{'passwd'}{$acc}) . '" size="8" maxlength="8" />');
		print $table->td('<input type="checkbox" name="data:mail:' . $acc . '" value="1" ' . (($main::data{'mail'}{$acc}) ? 'checked="checked"' : '') . ' />');
		print $table->_tr;
	}
	print $table->_table;
} else {
	print '<div class="warning">' . ((@search || $main::expired_only) ? '˰פ' : '') . '桼¸ߤޤ</div>';
}
print '</fieldset>';

print '<fieldset class="submit">';
print '<label for="u" class="datatitle">ɽ</label><input type="text" name="u" id="u" value="' . $main::u . '" size="3" maxlength="3" /> ';
print '<input type="button" value="' . (($default::english) ? 'Reset' : 'ꥻå') . '" onclick="cmonos.form.item(this.form).resetAll(\'data:\')" /> ' if $main::a eq 'new';
if ($main::a eq 'new') {
	print '<input type="submit" value="ϿϿѥ' . (($auth_dbm_enabled) ? '' : 'Խ') . '" /> ';
} else {
	print '<input type="submit" name="a=new" value="Ͽ" /> ';
	if (defined $pageoption && $pageoption) {
		print '<input type="submit" name="p=' . ($main::p - 1) . '&amp;a=' . $main::a . '" value="Υڡ" />' if $main::p > 1;
		print '<input type="submit" name="p=' . ($main::p + 1) . '&amp;a=' . $main::a . '" value="Υڡ" />' if $main::p < $lastpage;
	}
}
if ($main::a eq 'new') {
	print ' <input type="submit" name="p=' . $main::p . '&amp;a=new" value="Ͽ" class="save" />';
} else {
	print ' <input type="submit" name="p=' . $main::p . '" value="" class="save" />';
}

print '</fieldset>';
if ($auth_enabled) {
	print '<fieldset class="submit">';
	print '<ul class="tools"><li>';
	print '</li>';
	if (!$auto_disabled) {
		print(($auto_register_enabled) ? '<li class="group-start"><input type="submit" name="reg=off&amp;a=' . $main::a . '" value="ưϿ OFF" /></li>' : '<li class="group-start"><input type="submit" name="reg=on&amp;a=' . $main::a . '" value="ưϿ ON" /></li>');
		print(($auto_reissue_enabled) ? '<li><input type="submit" name="reis=off&amp;a=' . $main::a . '" value="ưȯ OFF" /></li>' : '<li><input type="submit" name="reis=on&amp;a=' . $main::a . '" value="ưȯ ON" /></li>');
	}
	if ($auth_dbm_enabled) {
		print '<li class="group-start"><input type="submit" name="backup=make&amp;a=' . $main::a . '" value="Хåå׺" onclick="return confirm(\'Ⱦƥȥե˽񤭽ФޤνˤϿʬ뤳Ȥޤ\')" /></li>';
		if (-f $htauthdb . '.bak') {
			print '<li><input type="submit" name="backup=remove&amp;a=' . $main::a . '" value="Хåå׺" onclick="return confirm(\'ХååץեޤκȤϼäǤޤ˺ޤ\')" /></li>';
			print '<li><input type="submit" name="backup=restore&amp;a=' . $main::a . '" value="Хåå" onclick="return confirm(\'ХååפȸߤΥǡ񤭤ޤκȤϼäǤޤޤ\')" /></li>';
		}
	}
	print '<li class="group-start"><input type="submit" name="a=csv" value="CSV 񤭽Ф" onclick="cmonos.form.item(this.form).appendDownloadPath(\'register.csv\')" /></li>';
	print '</ul>';
	print '</fieldset>';

	print '<fieldset class="delete"><input type="submit" name="gc=1&amp;a=' . $main::a . '" value="ڤ쥢Ȥ" onclick="return confirm(\'ڤ쥢ȤξƼޤ˲ޤ\')" /></fieldset>';
	print '<fieldset class="delete"><input type="submit" name="a=cancel" value="²" onclick="return confirm(\'ƤΥȾ󤬼ޤ˲ޤ\')" /></fieldset>';
}
print '</form>';

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# ϥǡξõ
sub delete_data ($$) {
my($this,$acc) = @_;
my(@name) = keys %main::data;
foreach (@name) {
	delete $main::data{$_}{$acc};
}
}

######################################################################
# ȤΥ
sub account_comment ($$;$) {
my($this,$acc,$options) = @_;
my($menu,$selected);
if (ref $options && @$options) {
	$menu = '<select name="data:cmt:' . $acc . '">';
	foreach (@$options) {
		$menu .= '<option value="' . $_ . '"';
		if ($_ eq $main::data{'cmt'}{$acc}) {
			$menu .= ' selected="selected"';
			$selected = 1;
		}
		$menu .= '>' . $_ . '</option>';
	}
	if (!defined $selected || !$selected) {
		$menu .= '<option value="' . $main::data{'cmt'}{$acc} . '" selected="selected">' . $main::data{'cmt'}{$acc} . '</option>';
	}
	$menu .= '</select>';
} else {
	$menu = '<input type="text" name="data:cmt:' . $acc . '" value="' . $this->escape($main::data{'cmt'}{$acc}) . '" size="16" />';
}
return $menu;
}

######################################################################
# ᡼륢ɥ쥹=>
sub push_account ($$$) {
my($this,$data,$acc) = @_;
my @data = split(/,/,((defined $data) ? $data : ''));
return (grep($_ eq $acc,@data)) ? $data : join(',',@data,$acc);
}

sub shift_account ($$$) {
my($this,$data,$acc) = @_;
my @data = split(/,/,((defined $data) ? $data : ''));
@data = grep($_ ne $acc,@data);
return join(',',@data);
}

######################################################################
# Auth DBM å
sub get_auth_settings ($$) {
my($this,$htaccess) = @_;
my $data = $this->read_file($htaccess,1);
return(
	((defined $data && $data =~ /^AuthDBMUserFile\s/mi) ? 1 : (defined $data && $data =~ /^AuthUserFile\s/mi) ? 0 : ($setting::general{'authmod'} && $setting::general{'authmod'} eq 'dbm') ? 1 : 0),
	((defined $data && $data =~ /^# auto_register_enabled = true$/m) ? 1 : 0),
	((defined $data && $data =~ /^# auto_reissue_enabled = true$/m) ? 1 : 0),
);
}

######################################################################
# Auth DBM Хåå
sub auth_dbm_backup ($$$) {
my($this,$db_path,$bak_path) = @_;
my(%db,$done);
$done = 0;
tie(%db, 'AnyDBM_File', $db_path, O_RDONLY, $env::dbm_mode);
if (ref tied %db && open(BAK, ">>$bak_path")) {
	binmode BAK;
	flock(BAK, LOCK_EX);
	truncate(BAK, 0);
	seek(BAK, 0, 0);
	my($k,$v);
	while (($k,$v) = each %db) {
		print BAK $k . "\x09" . $v . "\x0A" if $k && $v;
	}
	close(BAK);
	chmod($env::file_mode, $bak_path);
	$done = 1;
}
untie(%db);
return $done;
}

sub auth_dbm_restore ($$$) {
my($this,$db_path,$bak_path) = @_;
my(%db,$done);
$done = 0;
tie(%db, 'AnyDBM_File', $db_path, O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %db && open(BAK, $bak_path)) {
	binmode BAK;
	flock(BAK, LOCK_SH);
	while (<BAK>) {
		chomp $_;
		next if !$_;
		my($k,$v) = split(/\x09/,$_,2);
		$db{$k} = $v if $k && $v;
	}
	close(BAK);
	chmod($env::file_mode, $bak_path);
	$done = 1;
}
untie(%db);
return $done;
}

######################################################################
# .htaccess Ĵ+.htgroup 
sub htaccess_is_prepared ($$$;$$$) {
my($this,$htaccess,$current_directory,$auth_dbm_enabled,$auto_register_enabled,$auto_reissue_enabled) = @_;
my($data,$temp,$htgroup,$setting);
$htgroup = $current_directory . '/.htgroup';
$data = $this->read_file($htaccess,1);
$temp = $data;

$setting = "\x0A# Gate Keeper - start -\x0A";
$setting .= '# auto_register_enabled = ' . (($auto_register_enabled) ? 'true' : 'false') . "\x0A";
$setting .= '# auto_reissue_enabled = ' . (($auto_reissue_enabled) ? 'true' : 'false') . "\x0A";
if ($auto_register_enabled || $auto_reissue_enabled) {
	$setting .= 'ErrorDocument 401 ' . $ENV{'SCRIPT_NAME'} . '?m=AutoRegister&refresh=1&path=' . $this->url_encode($main::current) . "\x0A";
}
$setting .= 'AuthType Basic' . "\x0A";
$setting .= 'AuthName "Member Site"' . "\x0A";
$setting .= 'Require valid-user' . "\x0A";

if ($auth_dbm_enabled) {
$setting .= <<SETTING;
AuthDBMUserFile  $current_directory/.htauthdb
AuthDBMGroupFile $current_directory/.htauthdb

<Files .htauthdb>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htauthdb.pag>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htauthdb.dir>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htauthdb.db>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htauthdb.bak>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htmaildb>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htmaildb.pag>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htmaildb.dir>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htmaildb.db>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htmaildb.bak>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files ~ "^\.[Hh][Tt]">
  Order allow,deny
  Deny from all
  Satisfy All
</Files>

SETTING

} else {
$setting .= <<SETTING;
AuthUserFile  $current_directory/.htpasswd
AuthGroupFile $current_directory/.htgroup

<Files .htaccess>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htpasswd>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htgroup>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files .htcomment>
  Order allow,deny
  Deny from all
  Satisfy All
</Files>
<Files ~ "^\.[Hh][Tt]">
  Order allow,deny
  Deny from all
  Satisfy All
</Files>

SETTING
}
$setting .= "# Gate Keeper - end -\x0A";
$data .= $setting unless $data =~ s/\x0A# Gate Keeper - start -\x0A.*?\x0A# Gate Keeper - end -\x0A/$setting/s;

#.htaccess 񤭹
unless (length $temp == length $data || $this->write_file($htaccess,\$data,1)) {
	return 0;
}

#.htgroup 
undef $temp;
$data = '';
if ($auth_dbm_enabled || -f $htgroup || $this->write_file($htgroup,\$data,1)) {
	return 1;
} else {
	return 0;
}
}

######################################################################
# .htaccess ²
sub auth_cancel ($$$) {
my($this,$htaccess,$current_directory) = @_;
my($data);
local(*FH);
return 1 unless -f $htaccess;

$data = $this->read_file($htaccess,1);
$data =~ s/\x0A# Gate Keeper - start -\x0A.*?\x0A# Gate Keeper - end -\x0A//s;
$data =~ s/[\x0A]+/\x0A/sg;
if (!$data || $data =~ /^\s+$/s) {
	return unlink($htaccess);
} else {
	return $this->write_file($htaccess,\$data,1);
}
}

sub delete_auth_dbm ($$) {
my($this,$current_directory) = @_;
my @db = $this->fileglob($current_directory,'^\.(htauthdb|htmaildb)','f');
return (!@db || unlink @db) ? 1 : 0;
}

######################################################################
# ᡼
sub mail_to_user ($$$$$$) {
my($this,$mailto,$new_account,$new_passwd,$name,$expiretime) = @_;
my($acc,$url);
$url = $this->http_my_domain . $main::current;

if (!defined $setting::general{'msg'} || $setting::general{'msg'} !~ /<account>/i || $setting::general{'msg'} !~ /<password>/i) {
$setting::general{'msg'} .= <<MSG;
$url
ʲγؤ˥ȤϡȤӥѥɤ
ϤƤ


ȡ<account>
ѥɡ<password>


MSG
} else {
	$setting::general{'msg'} =~ s/<url>/$url/ig;
}
if (!defined $setting::general{'subject'} || !$setting::general{'subject'}) {
	$setting::general{'subject'} = 'Τ餻';
} else {
	$setting::general{'subject'} =~ s/<url>/$url/ig;
}

unless (ref $cgi::SendMail) {
	require CMONOS::CGI_Lib::SendMail;
	$cgi::SendMail = SendMail->new(
		((defined $env::sendmail) ? $env::sendmail : ''),
		((defined $env::master_email) ? $env::master_email : ''),
		'',
		((defined $cgi::input) ? $cgi::input : ''),
		1
	);
}

my $from = (($setting::general{'master'}) ? (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}) : $env::master_email);

while (($acc) = each %$mailto) {
	my $account = (defined $$new_account{$acc} && $$new_account{$acc} ne '') ? $$new_account{$acc} : $acc;
	my $password = (defined $$new_passwd{$acc} && $$new_passwd{$acc} ne '') ? $$new_passwd{$acc} : 'ޤǤƱѥ';
	my $name = (defined $$name{$acc} && $$name{$acc} ne '') ? $$name{$acc} : $account;
	my $expire = (defined $$expiretime{$acc} && $$expiretime{$acc}) ? $this->date($$expiretime{$acc},0,'gmt' . $setting::general{'datetype'}) : '̵';

	my $msg = $setting::general{'msg'};
	$msg =~ s/<name>/$name/ig;
	$msg =~ s/<account>/$account/ig;
	$msg =~ s/<password>/$password/ig;
	$msg =~ s/<expire>/$expire/ig;

	my $subject = $setting::general{'subject'};
	$subject =~ s/<name>/$name/ig;
	$subject =~ s/<account>/$account/ig;
	$subject =~ s/<password>/$password/ig;
	$subject =~ s/<expire>/$expire/ig;

	unless ($cgi::SendMail->send_mail(
				'To'		=>  (($name ne '') ? $name . ' <' . $$mailto{$acc} . '>' : $$mailto{$acc}),
				'From'		=>  $from,
				'Subject'	=>  $subject,
				'message'	=>  $msg,
				'info'		=>  '0'
			)) {
		push(@{$this->{'dialog'}},'᡼ǤޤǤ' . $account . 'ˡ');
		push(@{$this->{'dialog'}},$cgi::SendMail->dialog);
	}
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('k201','GateKeeper');

	#ǥեȥ˥塼Ͽ
	$setting::selected_jump_menu{'k201'} = 'k200';	#ᥤ˥塼Υǥեȥ

}



1;
