package CategoryEditor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ƥ꡼Խ⥸塼
# CategoryEditor.pm ver1.0.6
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-11-03
######################################################################
# ¹
sub run ($) {
my $this = shift;
my($newname,$newid,@folder,$index_path,%subindex_order);

use Fcntl qw(:DEFAULT :flock);
eval 'use ' . $env::dbm_file . ';';

#ǡ
if (defined $main::a && $main::a eq 'e') {
	push (@main::delete,$main::delete) if defined $main::delete && $main::delete;
	@main::delete = grep(defined $_ && $_ ne '',@main::delete);
	if (@main::delete) {
		$this->delete_category(\@main::delete);
		foreach (@main::delete) {
			delete $main::order{$_} if defined $main::order{$_};
		}
	}
}

#եꥹȼ
@folder = $this->get_folder;

#񤭹
if (defined $main::a && $main::a eq 'e') {

	#
	if (defined $main::new{'id'} && $main::new{'id'} ne '') {
		$main::new{'id'} = $this->z_to_h($main::new{'id'});
		if ($this->mk_category($main::new{'id'},\@folder,$main::new{'name'},$main::new{'mastername'},$main::new{'master'})) {
	
			#
			if (defined $main::notification && $main::notification) {
				my %installmsg;
				$this->import_db($default::preference_dir . '/installmsg',\%installmsg);
				$installmsg{'subject'} = 'ڤΤ餻ۥڡߤޤ' if !defined $installmsg{'subject'} || !$installmsg{'subject'};
				$installmsg{'msg'} = 'URL' . "\x0A" . '<uri>' . "\x0A\x0A" . 'ĶġURL' . "\x0A" . '<tool>' . "\x0A" if !defined $installmsg{'msg'} || !$installmsg{'msg'};
				my $tool = $this->my_url . '?m=Tools&c=' . $main::new{'id'};
				my $uri = $this->http_my_domain . $this->path_change($default::home,$ENV{'SCRIPT_NAME'},'abs') . '/' . $main::new{'id'};
				$installmsg{'msg'} =~ s/<(uri|url)>/$uri/igs;
				$installmsg{'msg'} =~ s/<tool>/$tool/igs;
				unless (ref $cgi::SendMail) {
					require CMONOS::CGI_Lib::SendMail;
					$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
				}
				$cgi::SendMail->send_mail(
					'To'		=>  (($main::new{'master'}) ? (($main::new{'mastername'}) ? $main::new{'mastername'} . ' <' . $main::new{'master'} . '>' : $main::new{'master'}) : $env::master_email),
					'From'		=>  (($setting::general{'master'}) ? (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}) : $env::master_email),
					'Subject'	=>  $installmsg{'subject'},
					'message'	=>  $installmsg{'msg'} . "\x0A\x0A"
				);
			}
			undef %main::new;
		}
	} elsif ((defined $main::new{'name'} && $main::new{'name'} ne '') || (defined $main::new{'mastername'} && $main::new{'mastername'} ne '') || (defined $main::new{'master'} && $main::new{'master'} ne '')) {
		push(@{$this->{'dialog'}},'ե̾Ƥ');
	}
}

#ǥåɽ
if (@folder && %main::order) {
	#no warnings qw(numeric);
	my $no = 1;
	foreach (sort {$main::order{$a} <=> $main::order{$b} || $main::oldorder{$b} <=> $main::oldorder{$a} || $a <=> $b || $a cmp $b} @folder) {
		$main::order{$_} = $no++;
	}
	delete $main::order{''};
}
$index_path = $default::home . '/index.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html');
if (-f $index_path) {
	my($separator,$separator_interval) = ('','');
	my $index_html = $this->read_file($index_path,1);
	my $my_index_id = (defined $default::id && $default::id ne '') ? $default::id : 'homepage';
	my %subindex_temp;
	my $subindex_changed = 0;
	if ($index_html =~ /(<!--index(?!\w)[^>]*? id="$my_index_id"[^>]*-->.*?<!--\/index-->)/s) {
		my $my_index_html = $1;
		my $no = 0;
		if ($my_index_html =~ /<\!--separator(?!\w)([^>]*)-->(.*?)<\!--\/separator(?!\w)[^>]*-->/s) {
			my $separator_option = '';
			($separator_option,$separator) = ($1,$2);
			$separator_interval = ($separator_option =~ /\s+interval="(\d+)"/si) ? $1 : 1;
			$separator = $this->unescape($1) if $separator_option =~ /\s+value="([^"]+)"/si;
			$my_index_html =~ s/<\!--separator(?!\w)[^>]*-->.*?<\!--\/separator(?!\w)[^>]*-->//sg;
		}
		while ($my_index_html =~ /(<!--subindex(?!\w)([^>]*)-->.*?<!--\/subindex-->)/gs) {
			my($subindex_setting,$subindex_id,$subindex);
			($subindex,$subindex_setting) = ($1,$2);
			$subindex_id = ($subindex_setting =~ /\s*id\s*=\s*"([^"]+)"/s) ? $1 : '';
			$subindex_temp{$subindex_id} = $subindex;
			$subindex_order{$subindex_id} = ++$no;
		}
		if (%subindex_order) {
			#no warnings qw(numeric);
			if (%main::order) {
				my $prev_id = '';
				foreach (sort {$main::order{$a} <=> $main::order{$b} || $a <=> $b || $a cmp $b} @folder) {
					if ($prev_id ne '' && $subindex_order{$prev_id} > $subindex_order{$_}) {
						$subindex_changed = 1;
						last;
					}
					$prev_id = $_;
				}
			} else {
				my $no = 1;
				foreach (sort {(defined $subindex_order{$a} && defined $subindex_order{$b} && $subindex_order{$a} <=> $subindex_order{$b}) || $a <=> $b || $a cmp $b} @folder) {
					$main::order{$_} = $no++;
				}
			}
		}
		if ($subindex_changed) {
			my $my_subindex = '';
			my $count = 0;
			my $separator_done = 0;
			foreach (sort {$main::order{$a} <=> $main::order{$b} || $a cmp $b} keys %subindex_temp) {
				$my_subindex .= $subindex_temp{$_};
				$count++;
				if ($separator_interval && $count % $separator_interval == 0) {
					$my_subindex .= '<!--separator interval="' . $separator_interval . '"-->' . $separator . '<!--/separator-->';
					$separator_done = 1;
				}
			}
			$my_subindex .= '<!--separator interval="' . $separator_interval . '" value="' . $this->escape($separator) . '"--><!--/separator-->' if !$separator_done;
			$my_index_html =~ s/<!--subindex(?!\w)[^>]*?-->.*<!--\/subindex-->/$my_subindex/gs;
			$index_html =~ s/<!--index(?!\w)[^>]*? id="$my_index_id"[^>]*-->.*?<!--\/index-->/$my_index_html/s;
			$this->write_file($index_path,$index_html,1);
			push(@{$this->{'dialog'}},'祤ǥå򹹿ޤ');
		}
	}
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1 title="ƥ꡼ߤԤޤ">ƥ꡼Խ</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="e" />';
print '<fieldset><legend>ƥ꡼</legend>';

#ơ֥
require CMONOS::CGI_Lib::Table;
my $table = Table->new;
$table->set(
	'tableclass' => 'tooltable',
	'trclass' => 'odd,even',
	'class0' => 'odd,even',
	'classF' => 'caution',
	'thenabled' => 'true'
);

print $table->table;

#إå
print $table->tr;
print $table->td('');
print $table->td('ɽ');
print $table->td('ե̾');
print $table->td('ƥ꡼̾');
print $table->td('̾');
print $table->td('ͥɥ쥹');
print $table->td('Ķ');
print $table->_tr;

if (@folder) {
	#no warnings qw(numeric);
	@folder = sort {$main::order{$a} <=> $main::order{$b} || $a <=> $b || $a cmp $b} @folder;
}

#
my(%name);
my $order = 0;
foreach (@folder) {
	my(%setting);
	$order++;
	print $table->tr;
	tie(%setting, $env::dbm_file, $default::master_preference_dir . '/' . $_ . '/general', O_RDONLY, $env::dbm_mode);
	$name{$_} = (ref tied %setting && $setting{'cginame'} ne '') ? $this->escape($setting{'cginame'}) : $_;
	print $table->td('<input type="checkbox" name="delete" value="' . $_ . '" onclick="cmonos.form.field(this).checkboxConfirm(\'' . $name{$_} . ' ˴ϢƤΥǡޤ˺ޤ\')" />');
	print $table->td('<input type="hidden" name="oldorder:' . $_ . '" value="' . $order . '" /><input type="text" name="order:' . $_ . '" value="' . (($subindex_order{$_}) ? $order : '') . '"' . (($subindex_order{$_}) ? '' : ' disabled="disabled"') . ' size="3" />');
	print $table->td($_);
	print $table->td($name{$_});
	print $table->td((ref tied %setting && $setting{'mastername'} ne '') ? $this->escape($setting{'mastername'}) : '');
	print $table->td((ref tied %setting && $setting{'master'} ne '') ? $this->escape($setting{'master'}) : '');
	untie %setting;
	print $table->td('<a href="./start.cgi?m=Tools&amp;c=' . $_ . '" target="_blank">Ķ</a>');
	print $table->_tr;
}

#
print $table->tr;
print $table->td('');
print $table->td('');
print $table->td('<input type="text" name="new:id" size="10" value="' . $this->escape($main::new{'id'}) . '" maxlength="16" />');
print $table->td('<input type="text" name="new:name" size="20" value="' . $this->escape($main::new{'name'}) . '" maxlength="30" />');
print $table->td('<input type="text" name="new:mastername" size="20" value="' . $this->escape($main::new{'mastername'}) . '" maxlength="20" />');
print $table->td('<input type="text" name="new:master" size="30" value="' . $this->escape($main::new{'master'}) . '" />');
print $table->td('');
print $table->_tr;

print $table->_table;

print '<div class="hints">ƥ꡼ɲäˤϿե̾ޤ</div>';
print '</fieldset>';

#ǥե
print '<fieldset><legend></legend>';
print '<table class="field-table"><tbody>';
if (@folder) {
	print '<tr><td class="field-name"><label for="import">Υݡ</label></td>';
	print '<td class="field"><select name="import" id="import" title="¸ߤ륫ƥ꡼ɤ߹ߤޤ"><option value=""></option>';
	foreach my $f (@folder) {
		print '<option value="' . $f . '"' . (($main::import && $main::import eq $f) ? ' selected="selected"' : '') . '>' . $name{$f} . '</option>';
	}
	print '</select>';
	print '</td></tr>';
}
print '<tr><td class="field-name"><label for="restore:pref">Υǥե</label></td><td class="field">';
$this->print_backup_menu('pref');
print '</td></tr><tr><td class="field-name"><label for="restore:field">եΥǥե</label></td><td class="field">';
$this->print_backup_menu('field');
print '</td></tr></tbody></table></fieldset>';

print '<fieldset class="submit"><label><input type="checkbox" name="notification" value="1" /> ƥ꡼δͤ˥ƥ꡼Τ</label> <input type="submit" value="¸" class="save" /></fieldset>';
print '</form>';

#ڡեå
$this->print_page_footer('tools');
}

sub get_folder ($) {
my $this = shift;
my @folder = ();
local(*DIR);
if (opendir(DIR, $default::master_preference_dir)) {
	#no warnings qw(numeric);
	@folder = sort {$a <=> $b || $a cmp $b} grep($_ =~ /^\w+$/ && -d "$default::master_preference_dir/$_",readdir(DIR));
	closedir(DIR);
} else {
	push(@{$this->{'dialog'}},'ۡǥ쥯ȥǧƤ');
}
return @folder;
}

######################################################################
# ƥ꡼
sub delete_category ($$) {
my($this,$delete_ids) = @_;
return if !@$delete_ids;
my(@urls,@index_files,$index,$home_url);
$home_url = $this->full_path($default::home);
use File::Path;
foreach my $cid (@$delete_ids) {
	next if !defined $cid || $cid eq '';
	if (defined $default::home && -d "$default::home/$cid") {
		rmtree "$default::home/$cid";
	}
	if (defined $default::master_preference_dir && -d "$default::master_preference_dir/$cid") {
		rmtree "$default::master_preference_dir/$cid";
	}
	if (defined $default::master_field_pref_dir && -d "$default::master_field_pref_dir/$cid") {
		rmtree "$default::master_field_pref_dir/$cid";
	}
	push(@urls,$home_url . '/' . $cid);
}
@index_files = (
	$env::externalfiles . '/metaindex.ssi',
	$env::externalfiles . '/recentcomments.ssi',
	$env::externalfiles . '/recenttrackbacks.ssi',
	$default::home . '/navi.ssi',
	$default::home . '/recentcomments.ssi',
	$default::home . '/recenttrackbacks.ssi',
);
$index = $this->fileglob($default::home,'^index\.(html|htm|shtml|shtm|stm)$','f');
push(@index_files,$index) if defined $index && $index;
push(@index_files,$default::external_index) if defined $default::external_index && $default::external_index && !grep($_ eq $default::external_index,@index_files);
push(@index_files,$default::external_navi) if defined $default::external_navi && $default::external_navi && !grep($_ eq $default::external_navi,@index_files);
push(@index_files,$default::external_navi2) if defined $default::external_navi2 && $default::external_navi2 && !grep($_ eq $default::external_navi2,@index_files);
require CMONOS::CGI_Lib::IndexSweeper;
IndexSweeper->new(
	'index_files'	=>	\@index_files,
	'rss_files'		=>	[
							'../../index.xml',
							'../../comment.xml',
							'../../trackback.xml',
							'../../podcast.xml',
							$default::home . '/index.xml',
							$default::home . '/comment.xml',
							$default::home . '/trackback.xml',
							$default::home . '/podcast.xml',
						],
	'kml_files'		=>	[
							$default::home . '/index.kml',
						],
)->sweep(\@urls,{$default::id => $delete_ids});
return;
}

######################################################################
# ƥ꡼
sub mk_category ($$$$) {
my($this,$id,$folder,$name,$mastername,$master) = @_;
return 0 if !defined $id || $id eq '';
my($error);
if (defined $master && $master ne '' && $this->is_invalid_email_address($master)) {
	push(@{$this->{'dialog'}},'ƥ꡼ߤ˼Ԥޤͥɥ쥹ǧƤ');
	$error = 1;
}
if ($id =~ /\W/) {
	push(@{$this->{'dialog'}},'ƥ꡼ߤ˼Ԥޤե̾ȾѱѿˤƤ');
	$error = 1;
}
if (length $id > 32) {
	push(@{$this->{'dialog'}},'ƥ꡼ߤ˼Ԥޤե̾Ĺޤ');
	$error = 1;
}
if (grep($_ eq $id,@$folder)) {
	push(@{$this->{'dialog'}},'ƥ꡼ߤ˼ԤޤΥե̾ϴ˻ȤƤޤ');
	$error = 1;
}
return 0 if defined $error && $error;

#ɬפʥǥ쥯ȥ
my($import,$import_field,$pref,$field);
$pref = $default::master_preference_dir . '/' . $id;
($field = $default::master_field_pref_dir) =~ s!^$default::master_preference_dir/!$pref/!;

$this->set_dir("$default::home/$id");
$this->write_file("$default::home/$id/navi.ssi",'',1);
$this->set_dir($pref);
$this->set_dir($field);
push(@$folder,$id);

#ΥݡorХååɤ߹
if (defined $main::import && $main::import ne '' && $main::import !~ /\W/ && -d $default::master_preference_dir . '/' . $main::import) {
	my($import,$import_field,$icon);
	$import = $default::master_preference_dir . '/' . $main::import;
	($import_field = $default::master_field_pref_dir) =~ s!^$default::master_preference_dir/!$import/!;
	$this->directory_copy($import,$pref,0,['^[\.\-]','\.(html|htm|txt|cgi)$']);
	$this->directory_copy($import_field,$field,0,['^[\.\-]','\.(html|htm|txt|cgi)$']);
	$icon = $this->fileglob($default::home . '/' . $main::import,'^icon\.(gif|jpg|png)$');
	if (defined $icon && $icon) {
		my($icon_name);
		$icon_name = $1 if $icon =~ /(icon\.(gif|jpg|png)$)$/;		
		$this->file_copy($icon,$default::home . '/' . $id . '/' . $icon_name);
	}

} else {
	$this->restore($backup::default{'pref'},$pref,'bak');
	$this->restore($backup::default{'field'},$field,'bak');
}

#ǥեȤ
$this->restore($backup::default{'pref'},$pref,$main::restore{'pref'});
$this->restore($backup::default{'field'},$field,$main::restore{'field'});

if ((defined $name && $name ne '') || (defined $mastername && $mastername ne '') || (defined $master && $master ne '')) {
	my(%db);
	tie(%db, $env::dbm_file, $pref . '/general', O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %db) {
		$db{'cginame'} = (defined $name) ? $name : '';
		$db{'mastername'} = (defined $mastername) ? $mastername : '';
		$db{'master'} = (defined $master) ? $master : '';
	}
	untie %db;
}
return 1;
}

######################################################################
# ˥塼
sub print_backup_menu ($$) {
my($this,$key) = @_;
my(%bak);
%bak = ();
$this->get_backup_list_hash($backup::default{$key},\%bak) if defined $backup::default{$key} && $backup::default{$key};
if (!%bak) {
	print 'ե뤬ޤ';
	return;
}

print '<select name="restore:' . $key . '" id="restore:' . $key . '" title="륫ƥ꡼ɬפưޤ">';
print '<option value=""></option>';
print '<option value="bak"' . (($main::restore{$key} && $main::restore{$key} eq 'bak') ? ' selected="selected"' : '') . '>' . $bak{'bak'} . '</option>' if $bak{'bak'};
foreach my $ext (sort keys %bak) {
	next if $ext eq 'bak';
	print '<option value="', $ext, '"', (($main::restore{$key} && $main::restore{$key} eq $ext) ? ' selected="selected"' : ''), '>';
	print $bak{$ext};
	print '</option>';
}

print '</select>';
}

sub get_backup_list_hash ($$$) {
my($this,$dir,$bak) = @_;
$this->_get_backup_list_hash($env::default_dir . '/' . $dir,$bak) if $env::default_dir;
$this->_get_backup_list_hash($env::user_default_dir . '/' . $dir,$bak,1) if $env::user_default_dir;
}

sub _get_backup_list_hash ($$$;$) {
my($this,$path,$bak,$user_dir) = @_;
my($db,@files);
if (-d $path) {
	$db = '.*?';
} else {
	($path,$db) = ($1,$2) if $path =~ m!^(.*)/([^/]+)$!;
	$db =~ s/\.([^\/\.]+)$//;
}
$path =~ s!/$!!;
if (opendir(DIR,$path)) {
	@files = grep(-f "$path/$_" && $_ !~ /^\./,readdir(DIR));
	closedir(DIR);
	foreach my $file_name (@files) {
		if ($file_name =~ /^$db\.bak$/) {
			next if defined $$bak{'bak'} && $$bak{'bak'} ne '';
			$$bak{'bak'} = 'ɸ';
		} elsif ($file_name =~ /^$db\.(\w+\.default)$/) {
			my $ext = (($user_dir) ? '~' : '') . $1;
			next if defined $$bak{$ext} && $$bak{$ext} ne '';
			if (open(FILE, "$path/$file_name")) {
				binmode FILE;
				$$bak{$ext} = <FILE>;
				close(FILE);
				chomp $$bak{$ext};
				$$bak{$ext} .= '&lt;ͭ&gt;' if $env::user_default_dir && !$user_dir;
			}
		}
	}
}
}

######################################################################
# ǥեȤ
sub restore ($$$$;@) {
my($this,$bakpath,$dbpath,$ext,@db) = @_;
if ($ext && $ext =~ s/^~//) {
	$bakpath = ($env::user_default_dir || $env::default_dir) . '/' . $bakpath;
} elsif ($bakpath) {
	$bakpath = $env::default_dir . '/' . $bakpath;
}
return if !defined $ext || ($ext ne 'bak' && $ext !~ /^[0-9a-zA-Z_]+\.default$/) || !defined $bakpath || !defined $dbpath || $ext eq '' || $bakpath eq '' || $dbpath eq '';
if (!@db) {
	local(*DIR);
	return unless opendir(DIR,$bakpath);
	@db = grep(-f "$bakpath/$_" && $_ !~ /^[\.\-]/,readdir(DIR));
	closedir(DIR);
}
my $user_directory = $this->home_directory(1);
my $home_dir_id = ($env::home_dir_id) ? $env::home_dir_id : '';
my $home_url = $this->full_path('../../',1);
my $home_url_encoded = $this->url_encode($home_url);
my $error = 0;
foreach (@db) {
	my(%db,$file,$db);
	$file = $bakpath . '/' . $_;
	$db = $dbpath . '/' . $_;
	next unless -f $file && $db =~ s/\.$ext$//;
	tie(%db, $env::dbm_file, $db, O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %db) {
		my $data = $this->read_file($file);
		if ($data) {
			while ($data =~ /([^\x09\x0A\x0D]+)\x09([^\x0A\x0D]*)[\x0A\x0D]*/sg) {
				my($k,$v) = ($1,$2);
				$k =~ s/\&#09;/\x09/gs;
				$k =~ s/\x0B/\x0A/gs;
				$v =~ s/\&#09;/\x09/gs;
				$v =~ s/\x0B/\x0A/gs;
				$v =~ s!<home-dir-id>!$home_dir_id!gs;
				$v =~ s/<home-url>/$home_url/gs;
				$v =~ s/<home-url-encoded>/$home_url_encoded/gs;
				$v =~ s!<user-directory>!$user_directory!gs;
				eval '$db{$k} = $v;';
				$error++ if defined $@ && $@;
			}
		}
	}
	untie %db;
}
push(@{$this->{'dialog'}},'̤礭᤮' . $error . '˼Ԥޤ') if $error;
return;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);
if ($default::subdivided && (!defined $main::c || $main::c eq '')) {

	#饹Ͽ
	Common::class_register('00H0','CategoryEditor');

	#˥塼Ͽ
	$setting::jump_menu{'00H0'} = 'ƥ꡼Խ' if !defined $setting::jump_menu{'00H0'};

}
}



1;
