package NaviLayout;
require CMONOS::CGI_Lib::Tools::Preference;
@ISA = qw(Preference);
use strict;
######################################################################
# ʥӥ쥤ȥ⥸塼
# NaviLayout.pm ver1.0.4
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 2010-01-21
######################################################################
# å
sub get_setting_items ($) {
my $this = shift;

#åܥå
push(@check::checkbox,'accestat','icontable');

if (defined $env::inline_navi && $env::inline_navi) {
	push(@check::checkbox,'gsearchenabled','fontweight','colortabbgrepeatx','currentdisabled');
	push(@check::notag,'navi_gsearchtitle','navi_gsearchlabel');

	$check::color{'bgcolor'} = 'طʿ' if !defined $check::color{'bgcolor'};
	$check::color{'tabbgcolor'} = 'طʿ' if !defined $check::color{'tabbgcolor'};
	$check::color{'sitetitlecolor'} = 'ȥȥ뿧' if !defined $check::color{'sitetitlecolor'};
	$check::color{'sitesubtitlecolor'} = 'Ȥ ʸ' if !defined $check::color{'sitesubtitlecolor'};

	$check::num{'iconbgwidth'} = 'ط' if !defined $check::num{'iconbgwidth'};
	$check::num{'tabbgwidth'} = 'ط' if !defined $check::num{'tabbgwidth'};
	$check::num{'tabwidth'} = 'ΰ' if !defined $check::num{'tabwidth'};
	$check::num{'size'} = 'ʥӥ⤵' if !defined $check::num{'size'};
	$check::num{'tabmargintop'} = 'ξ;' if !defined $check::num{'tabmargintop'};
	$check::num{'tabmarginleft'} = 'κ;' if !defined $check::num{'tabmarginleft'};
	$check::num{'tabpaddingtop'} = 'ʸ;' if !defined $check::num{'tabpaddingtop'};
	$check::num{'tabpaddingbottom'} = 'ʸ;' if !defined $check::num{'tabpaddingbottom'};
	$check::num{'tabpaddingleft'} = 'ʸ;' if !defined $check::num{'tabpaddingleft'};
	$check::num{'tabpaddingright'} = 'ʸ;' if !defined $check::num{'tabpaddingright'};
	$check::num{'tabspace'} = 'ֳִ' if !defined $check::num{'tabspace'};
	$check::num{'fontsize'} = '֥եȥ' if !defined $check::num{'fontsize'};
	$check::num{'sitetitlesize'} = 'ȥȥեȥ' if !defined $check::num{'sitetitlesize'};
	$check::num{'titlewidth'} = 'ȥΰ' if !defined $check::num{'titlewidth'};
} else {
	push(@check::checkbox,'scroll');

	$check::num{'size'} = 'ե졼' if !defined $check::num{'size'};
}

#å
$check::num{'space'} = 'ֳ' if !defined $check::num{'space'};
}

######################################################################
# å
sub is_valid_setting ($) {
my $this = shift;
if ($env::inline_navi && defined $main::data{'navi_sitetitleurl'} && $main::data{'navi_sitetitleurl'} ne '' && $main::data{'navi_sitetitleurl'} !~ m!^/! && $this->is_invalid_url($main::data{'navi_sitetitleurl'})) {
	push(@{$this->{'dialog'}},'ȥȥΥ URL 򹹿ǤޤǤ URL ХѥǻꤷƤ');
	delete $main::data{'navi_sitetitleurl'};
}
return;
}

######################################################################
# Ķ
sub set_preferences ($) {
my $this = shift;
$preference::db = 'page' if !defined $preference::db || $preference::db ne 'page';							# Ͽѥǡ١̾
$preference::submenukey = 'page' if !defined $preference::submenukey || $preference::submenukey ne 'page';				# ֥˥塼

$preference::id = 'navi' if !defined $preference::id || $preference::id ne 'navi';							# ǡ
$preference::name = 'ʥӥ쥤' if !defined $preference::name;				# ѥͥ̾
$preference::title = 'ʥӥΥ쥤ȤˤĤꤷޤ' if !defined $preference::title;

unless (ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
my $js = <<SCRIPT;
function toggleNaviType () {
	var input_list = document.getElementsByTagName('input');
	var navi_type = '';
	for (var i=0; i<input_list.length; i++) {
		if (input_list[i].type != null && input_list[i].type == 'radio' && input_list[i].name == 'data:navi_type' && input_list[i].checked) {
			navi_type = input_list[i].value;
			break;
		}
	}
	var type_list = document.getElementsByTagName('div');
	for (var i=0; i<type_list.length; i++) {
		if (type_list[i].className != null && type_list[i].className == 'type-settings') {
			if (type_list[i].id == 'type-' + navi_type) {
				type_list[i].style.display = 'block';
			} else {
				type_list[i].style.display = 'none';
			}
		}
	}
	if (navi_type == 'tab' || navi_type == 'vicuna') {
		document.getElementById('title-url').style.display = 'block';
	} else {
		document.getElementById('title-url').style.display = 'none';
	}
};
SCRIPT
$this->set_javascript($js);
$this->set_onload('toggleNaviType();');
}

######################################################################
# ѥͥ
sub print_preference_panel ($) {
my $this = shift;
require CMONOS::CGI_Lib::StyleSheetHelper;
my $helper = StyleSheetHelper->new;

print '<input type="hidden" name="id" value="navi" />';

#ե졼
if (!defined $env::inline_navi || !$env::inline_navi) {
	print '<fieldset>';
	print '<legend>ʥӥե졼</legend>';
	print '<fieldset>';
	print '<legend>ե졼ʬ</legend>';
	print '<ol class="checkbox">';
	print '<li><label><input type="radio" name="data:navi_frametype" value="ht"' . ((defined $main::data{'navi_frametype'} && $main::data{'navi_frametype'} eq 'ht') ? ' checked="checked"' : '') . ' /> 岼ʬʾ夬ʥӥ</label></li>';
	print '<li><label><input type="radio" name="data:navi_frametype" value="hb"' . ((defined $main::data{'navi_frametype'} && $main::data{'navi_frametype'} eq 'hb') ? ' checked="checked"' : '') . ' /> 岼ʬʲʥӥ</label></li>';
	print '<li><label><input type="radio" name="data:navi_frametype" value="vl"' . ((defined $main::data{'navi_frametype'} && $main::data{'navi_frametype'} eq 'vl') ? ' checked="checked"' : '') . ' /> ʬʺʥӥ</label></li>';
	print '<li><label><input type="radio" name="data:navi_frametype" value="vr"' . ((defined $main::data{'navi_frametype'} && $main::data{'navi_frametype'} eq 'vr') ? ' checked="checked"' : '') . ' /> ʬʱʥӥ</label></li>';
	print '</ol>';
	print '</fieldset>';
	print '<fieldset>';
	print '<legend><label for="data:navi_size">ե졼</label></legend>';
	print '<input type="text" name="data:navi_size" id="data:navi_size" size="7" value="' . $this->escape($main::data{'navi_size'}) . '" /> <span class="unit">ԥ</span>';
	print '</fieldset>';
	print '<ol class="checkbox">';
	print '<li><label><input type="checkbox" name="data:navi_scroll" value="no"' . ((defined $main::data{'navi_scroll'} && $main::data{'navi_scroll'} eq 'no') ? ' checked="checked"' : '') . ' /> ʥӥե졼ΥСɽʤ</label></li>';
	print '<li><label><input type="checkbox" name="data:navi_accestat" value="1"' . ((defined $main::data{'navi_accestat'} && $main::data{'navi_accestat'}) ? ' checked="checked"' : '') . ' /> ϥ</label></li>';
	print '</ol>';
	print '</fieldset>';
} else {
	$this->use_icon('navi','navi_icon');
	print '<fieldset>';
	print '<legend></legend>';
	print '<label><input type="checkbox" name="data:navi_accestat" value="1"' . ((defined $main::data{'navi_accestat'} && $main::data{'navi_accestat'}) ? ' checked="checked"' : '') . ' /> ϥ</label>';
	print '</fieldset>';

	$main::data{'navi_gajaxkey'} = $env::google_maps_api_key if !$main::data{'navi_gajaxkey'} && $env::google_maps_api_key;
	$main::data{'navi_gsearchtitle'} = 'ȸ' if !$main::data{'navi_gsearchtitle'};
	$main::data{'navi_gsearchlabel'} = 'Υ' if !$main::data{'navi_gsearchlabel'};
	print '<fieldset>';
	print '<legend><a href="http://code.google.com/intl/ja_ALL/apis/ajaxsearch/" target="_blank">Google AJAX Search API</a> ˤ륵ȸ</legend>';
	print '<label><input type="checkbox" name="data:navi_gsearchenabled" value="1"' . ((defined $main::data{'navi_gsearchenabled'} && $main::data{'navi_gsearchenabled'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'gsearch-settings\').toggle();" /> <a href="http://code.google.com/intl/ja_ALL/apis/ajaxsearch/" target="_blank">Google AJAX Search API</a> ˤ륵ȸѤ</label>';
	print '<div id="gsearch-settings">';
	print '<table class="field-table"><tbody>';
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_gajaxkey"><a href="http://code.google.com/intl/ja_ALL/apis/ajaxsearch/signup.html" target="_blank">Google AJAX Search API </a></label></td>';
	print '<td class="field"><input type="text" name="data:navi_gajaxkey" id="data:navi_gajaxkey" value="' . $this->escape($main::data{'navi_gajaxkey'}) . '" size="60" /></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_gsearchtitle">Υȥ</label></td>';
	print '<td class="field"><input type="text" name="data:navi_gsearchtitle" id="data:navi_gsearchtitle" value="' . $this->escape($main::data{'navi_gsearchtitle'}) . '" size="16" title="֥ȸΥȥꤷޤ" /></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_gsearchlabel">̥٥</label></td>';
	print '<td class="field"><input type="text" name="data:navi_gsearchlabel" id="data:navi_gsearchlabel" value="' . $this->escape($main::data{'navi_gsearchlabel'}) . '" size="16" title="֤Υȡ̤ɽ٥ꤷޤ" /></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><span class="datatitle">ΰ</span></td>';
	print '<td class="field"><label><input type="radio" name="data:navi_gsearchalign" value="left"' . ((!$main::data{'navi_gsearchalign'} || $main::data{'navi_gsearchalign'} eq 'left') ? ' checked="checked"' : '') . ' />ü</label>';
	print '<label><input type="radio" name="data:navi_gsearchalign" value="right"' . (($main::data{'navi_gsearchalign'} && $main::data{'navi_gsearchalign'} eq 'right') ? ' checked="checked"' : '') . ' />ü</label></td>';
	print '</tr>';
	print '</tbody></table>';
	print '<fieldset>';
	print '<legend>ɽܥ</legend>';
	print $cgi::icon->button_menu('data:navi_gsearchbutton','search',120,$main::data{'navi_gsearchbutton'});
	print '</fieldset>';
	print '</div></fieldset>';
	print $this->javascript('cmonos.element.item(\'gsearch-settings\').disappear(true);') if !$main::data{'navi_gsearchenabled'};
	
	print '<fieldset>';
	print '<legend><label for="data:navi_naviheader">إå</label></legend>';
	print '<textarea name="data:navi_naviheader" id="data:navi_naviheader" cols="80" rows="5" wrap="off" class="content-editor-area">' . $this->escape($main::data{'navi_naviheader'}) . '</textarea>';
	$this->print_html_helper('data:navi_naviheader');
	print '</fieldset>';
}
print '<fieldset id="title-url"><legend><label for="data:navi_sitetitleurl">ȥȥΥ URL</label></legend>';
print '<input type="text" name="data:navi_sitetitleurl" id="data:navi_sitetitleurl" value="' . $this->escape($main::data{'navi_sitetitleurl'}) . '" size="50" title="Хѥǻꤷޤ" /></fieldset>';

print '<fieldset>';
print '<legend>ȥʥӥ</legend>';

print '<fieldset>';
print '<legend><label><input type="radio" name="data:navi_type" value="icon"' . ((defined $main::data{'navi_type'} && $main::data{'navi_type'} eq 'icon') ? ' checked="checked"' : '') . ' onclick="toggleNaviType()" /> : ꤵ줿ưŪ֤ޤ</label></legend>';
print '<div id="type-icon" class="type-settings">';
print '<table class="field-table"><tbody>';
if (defined $env::inline_navi && $env::inline_navi) {
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_iconbgwidth">ط</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_iconbgwidth" id="data:navi_iconbgwidth" value="' . $this->escape($main::data{'navi_iconbgwidth'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '<td class="field-name"><label for="data:navi_iconbgalign">طʤΰ</label></td>';
	print '<td class="q-field">';
	print $this->mk_select_menu(
		'data:navi_iconbgalign','','',$main::data{'navi_iconbgalign'},
		''			=>		'',
		'left'		=>		'',
		'center'	=>		'',
		'right'		=>		''
	);
	print '</td>';
	print '</tr>';
}
print '<tr>';
print '<td class="field-name"><label for="data:navi_cellvalign">·</label></td><td class="q-field">';
print $this->mk_select_menu(
	'data:navi_cellvalign','','',$main::data{'navi_cellvalign'},
	''			=>		'',
	'top'		=>		'ü·',
	'middle'	=>		'·',
	'bottom'	=>		'ü·'
);
print '</td>';
print '<td class="field-name"><label for="data:navi_space">ֳ</label></td>';
print '<td class="q-field"><input type="text" name="data:navi_space" id="data:navi_space" value="' . $this->escape($main::data{'navi_space'}) . '" size="7" title="ֳ֤ꤷޤ" /> <span class="unit">ԥ</span>';
print '</td></tr>';

if (defined $env::inline_navi && $env::inline_navi) {
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_align">ʥӥ</label></td>';
	print '<td class="q-field">';
	print $this->mk_select_menu(
		'data:navi_align','','',$main::data{'navi_align'},
		''			=>		'',
		'left'		=>		'',
		'center'	=>		'',
		'right'		=>		''
	);
	print '</td>';
	print '<td class="field-name"><label for="data:navi_size">ʥӥ⤵</label></td>';
	print '<td class="q-field">';
	print '<input type="text" name="data:navi_size" id="data:navi_size" size="7" value="' . $this->escape($main::data{'navi_size'}) . '" /> <span class="unit">ԥ</span>';
	print '</td></tr>';
	print '<tr>';
	print '<td class="field-name"><span class="datatitle">ɽˡ</span></td>';
	print '<td class="field" colspan="3"><label><input type="checkbox" name="data:navi_icontable" value="1"' . ((defined $main::data{'navi_icontable'} && $main::data{'navi_icontable'}) ? ' checked="checked"' : '') . ' /> ơ֥Ȥ</label>';
	print '</td></tr></tbody></table>';

	print '<fieldset>';
	print '<legend>طʲ</legend>';
	print $cgi::Deco->background_menu('data:navi_background','background',100,$main::data{'navi_background'});
	print '</fieldset>';
	print '<fieldset>';
	print '<legend><label for="data:navi_bgcolor">طʿ</label></legend>';
	print '<input type="text" name="data:navi_bgcolor" id="data:navi_bgcolor" value="' . $this->escape($main::data{'navi_bgcolor'}) . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:navi_bgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" style="background-color: ' . $this->escape($main::data{'navi_bgcolor'}) . '" />';
	print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:navi_bgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:navi_bgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
	print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:navi_bgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:navi_bgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
	print '</fieldset>';
	print '<fieldset>';
	print '<legend><label for="data:navi_iconcss">ɲå륷</label></legend>';
	print '<textarea name="data:navi_iconcss" id="data:navi_iconcss" cols="80" rows="5" wrap="off" class="content-editor-area" ondblclick="cmonos.tool.colorPalette.open(\'data:navi_iconcss+\',\'dom\')">';
	print $this->escape($main::data{'navi_iconcss'});
	print '</textarea>';
	$helper->print_menu('data:navi_iconcss');
	print '</fieldset>';
	print '</div></fieldset>';

	print '<fieldset>';
	print '<legend><label><input type="radio" name="data:navi_type" value="tab"' . ((defined $main::data{'navi_type'} && $main::data{'navi_type'} eq 'tab') ? ' checked="checked"' : '') . ' onclick="toggleNaviType()" />CSS  : CSS Ѥ֤ˤʥӥޤ</label></legend>';
	print '<div id="type-tab" class="type-settings">';

	print '<table class="field-table"><tbody>';
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_tabbgcolor">طʿ</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_tabbgcolor" id="data:navi_tabbgcolor" value="' . $this->escape($main::data{'navi_tabbgcolor'}) . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:navi_tabbgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" style="background-color: ' . $this->escape($main::data{'navi_tabbgcolor'}) . '" />';
	print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:navi_tabbgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:navi_tabbgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
	print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:navi_tabbgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:navi_tabbgcolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
	print '</td>';
	print '<td class="field-name"><label for="data:navi_tabbgwidth">ط</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_tabbgwidth" id="data:navi_tabbgwidth" value="' . $this->escape($main::data{'navi_tabbgwidth'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_tabbgalign">طʤΰ</label></td>';
	print '<td class="q-field">';
	print $this->mk_select_menu(
		'data:navi_tabbgalign','','',$main::data{'navi_tabbgalign'},
		''			=>		'',
		'left'		=>		'',
		'center'	=>		'',
		'right'		=>		''
	);
	print '</td>';
	print '<td class="field-name"><label for="data:navi_tabspace">ֳִ</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_tabspace" id="data:navi_tabspace" value="' . $this->escape($main::data{'navi_tabspace'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '</tr>';
	print '<tr class="tbody-end">';
	print '<td class="field-name"><label for="data:navi_tabmargintop">ξ;</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_tabmargintop" id="data:navi_tabmargintop" value="' . $this->escape($main::data{'navi_tabmargintop'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '<td class="field-name"><label for="data:navi_tabmarginleft">κ;</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_tabmarginleft" id="data:navi_tabmarginleft" value="' . $this->escape($main::data{'navi_tabmarginleft'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '</tr>';
	print '</tbody>';
	print '<tbody>';
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_tabpaddingtop">ʸ;</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_tabpaddingtop" id="data:navi_tabpaddingtop" value="' . $this->escape($main::data{'navi_tabpaddingtop'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '<td class="field-name"><label for="data:navi_tabpaddingbottom">ʸ;</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_tabpaddingbottom" id="data:navi_tabpaddingbottom" value="' . $this->escape($main::data{'navi_tabpaddingbottom'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_tabpaddingleft">ʸ;</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_tabpaddingleft" id="data:navi_tabpaddingleft" value="' . $this->escape($main::data{'navi_tabpaddingleft'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '<td class="field-name"><label for="data:navi_tabpaddingright">ʸ;</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_tabpaddingright" id="data:navi_tabpaddingright" value="' . $this->escape($main::data{'navi_tabpaddingright'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '</tr>';
	print '<tr class="tbody-end">';
	print '<td class="field-name"><span class="datatitle">֥ե</span></td>';
	print '<td class="q-field"><label><input type="checkbox" name="data:navi_fontweight" id="data:navi_fontweight" value="bold"' . ((defined $main::data{'navi_fontweight'} && $main::data{'navi_fontweight'} eq 'bold') ? ' checked="checked"' : '') . ' /> ˤ</label></td>';
	print '<td class="field-name"><label for="data:navi_fontsize">֥եȥ</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_fontsize" id="data:navi_fontsize" value="' . $this->escape($main::data{'navi_fontsize'}) . '" size="4" /> <span class="unit">%</span></td>';
	print '</tr>';
	print '</tbody>';
	print '<tbody>';
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_sitetitle">ȥȥ</label></td>';
	print '<td class="field" colspan="3">';
	print $this->mk_select_menu(
		'data:navi_sitetitle','','',$main::data{'navi_sitetitle'},
		''		=>		'ɽʤ',
		'1'		=>		'ȥȥɽ',
		'2'		=>		'ȥȥȥȤɽ',
	);
	print '</td></tr>';
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_sitetitlecolor">ȥȥ뿧</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_sitetitlecolor" id="data:navi_sitetitlecolor" value="' . $this->escape($main::data{'navi_sitetitlecolor'}) . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:navi_sitetitlecolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" style="background-color: ' . $this->escape($main::data{'navi_sitetitlecolor'}) . '" />';
	print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:navi_sitetitlecolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:navi_sitetitlecolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
	print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:navi_sitetitlecolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:navi_sitetitlecolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
	print '</td>';
	print '<td class="field-name"><label for="data:navi_sitetitlesize">ȥȥեȥ</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_sitetitlesize" id="data:navi_sitetitlesize" value="' . $this->escape($main::data{'navi_sitetitlesize'}) . '" size="4" /> <span class="unit">%</span></td>';
	print '</tr>';
	print '<tr class="tbody-end">';
	print '<td class="field-name"><label for="data:navi_sitesubtitlecolor">Ȥ ʸ</label></td>';
	print '<td class="field" colspan="3"><input type="text" name="data:navi_sitesubtitlecolor" id="data:navi_sitesubtitlecolor" value="' . $this->escape($main::data{'navi_sitesubtitlecolor'}) . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:navi_sitesubtitlecolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" style="background-color: ' . $this->escape($main::data{'navi_sitesubtitlecolor'}) . '" />';
	print ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:navi_sitesubtitlecolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:navi_sitesubtitlecolor\',\'window\')"><img src="' . $env::image_dir . '/tool/palette.gif" alt="ѥå" height="12" width="18" border="0" /></a>';
	print ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:navi_sitesubtitlecolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:navi_sitesubtitlecolor\',\'window\')"><img src="' . $env::image_dir . '/tool/picker.gif" alt="顼ԥå" height="12" width="18" border="0" /></a>';
	print '</td>';
	print '</tr>';
	print '</tbody></table>';

	print '<fieldset>';
	print '<legend></legend>';
	print $cgi::icon->image_menu('data:navi_logo','logo',100,$main::data{'navi_logo'});
	print '</fieldset>';

	print '<fieldset>';
	print '<legend title="֥ʥӥץڡǥ֤οꤷޤ"><label><input type="radio" name="data:navi_tabtype" value="color"' . ((defined $main::data{'navi_tabtype'} && $main::data{'navi_tabtype'} eq 'color') ? ' checked="checked"' : '') . ' />顼 : CSS ˤäƿĤ֤ޤ</label></legend>';

	print '<table class="field-table"><tbody>';
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_titlewidth">ȥΰ</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_titlewidth" id="data:navi_titlewidth" value="' . $this->escape($main::data{'navi_titlewidth'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '<td class="field-name"><label for="data:navi_colortabalign">ְ·</label></td>';
	print '<td class="q-field">';
	print $this->mk_select_menu(
		'data:navi_colortabalign','','',$main::data{'navi_colortabalign'},
		''			=>		'',
		'left'		=>		'',
		'center'	=>		'',
		'right'		=>		''
	);
	print '</td>';
	print '</tr>';
	print '</tbody></table>';

	print '<fieldset>';
	print '<legend><label for="data:navi_beltwidth"></label></legend>';
	print '<input type="text" name="data:navi_beltwidth" id="data:navi_beltwidth" value="' . $this->escape($main::data{'navi_beltwidth'}) . '" size="4" /> <span class="unit">ԥ</span>';
	print '</fieldset>';
	print '<fieldset>';
	print '<legend>طʲ</legend>';
	print $cgi::Deco->background_menu('data:navi_colortabbg','background',100,$main::data{'navi_colortabbg'});
	print '<label><input type="checkbox" name="data:navi_colortabbgrepeatx" id="data:navi_colortabbgrepeatx" value="1"' . ((defined $main::data{'navi_colortabbgrepeatx'} && $main::data{'navi_colortabbgrepeatx'}) ? ' checked="checked"' : '') . ' /> ü˸ꤹ</label>';
	print '</fieldset>';
	print '<fieldset>';
	print '<legend><label for="data:navi_colortabcss">ɲå륷</label></legend>';
	print '<textarea name="data:navi_colortabcss" id="data:navi_colortabcss" cols="80" rows="5" wrap="off" class="content-editor-area" ondblclick="cmonos.tool.colorPalette.open(\'data:navi_colortabcss+\',\'dom\')">';
	print $this->escape($main::data{'navi_colortabcss'});
	print '</textarea>';
	$helper->print_menu('data:navi_colortabcss');
	print '</fieldset>';
	print '</fieldset>';

	print '<fieldset>';
	print '<legend><label><input type="radio" name="data:navi_tabtype" value="image"' . ((defined $main::data{'navi_tabtype'} && $main::data{'navi_tabtype'} eq 'image') ? ' checked="checked"' : '') . ' />᡼ : CSS Ȳˤäƥ֤ޤ</label></legend>';

	print '<table class="field-table"><tbody>';
	print '<tr>';
	print '<td class="field-name"><label for="data:navi_tabwidth">ΰ</label></td>';
	print '<td class="q-field"><input type="text" name="data:navi_tabwidth" id="data:navi_tabwidth" value="' . $this->escape($main::data{'navi_tabwidth'}) . '" size="4" /> <span class="unit">ԥ</span></td>';
	print '<td class="field-name"><label for="data:navi_tabalign">ΰΰ</label></td>';
	print '<td class="q-field">';
	print $this->mk_select_menu(
		'data:navi_tabalign','','',$main::data{'navi_tabalign'},
		''			=>		'',
		'left'		=>		'',
		'center'	=>		'',
		'right'		=>		''
	);
	print '</td>';
	print '</tr>';
	print '</tbody></table>';

	print '<fieldset>';
	print '<legend>طʲ</legend>';
	print $cgi::icon->background_menu('data:navi_tabbg','tabbg',100,$main::data{'navi_tabbg'});
	print '</fieldset>';

	print '<fieldset>';
	print '<legend>ֲ</legend>';
	print $cgi::icon->tab_menu('data:navi_offtab','tab',$main::data{'navi_offtab'});
	print '</fieldset>';

	print '<fieldset>';
	print '<legend>Ѥߥֲ</legend>';
	print $cgi::icon->tab_menu('data:navi_ontab','tab',$main::data{'navi_ontab'});
	print '</fieldset>';

	print '<fieldset>';
	print '<legend><label for="data:navi_tabcss">ɲå륷</label></legend>';
	print '<textarea name="data:navi_tabcss" id="data:navi_tabcss" cols="80" rows="5" wrap="off" class="content-editor-area" ondblclick="cmonos.tool.colorPalette.open(\'data:navi_tabcss+\',\'dom\')">';
	print $this->escape($main::data{'navi_tabcss'});
	print '</textarea>';
	$helper->print_menu('data:navi_tabcss');
	print '</fieldset>';
	print '</fieldset>';

	print '</div></fieldset>';

	print '<fieldset>';
	print '<legend><label><input type="radio" name="data:navi_type" value="vicuna"' . ((defined $main::data{'navi_type'} && $main::data{'navi_type'} eq 'vicuna') ? ' checked="checked"' : '') . ' onclick="toggleNaviType()" />Vicuna ߴإå : Vicuna CMS ߴΥʥӥޤ</label></legend>';
	print '<div id="type-vicuna" class="type-settings"><p class="note">CSSեԽǡVicuna CMS ѤΥ륷Ȥɤ߹ɬפޤ</p>';
	print '<fieldset>';
	print '<legend>Vicuna CMS Ĵ</legend>';
	print '<label><input type="checkbox" name="data:navi_currentdisabled" id="data:navi_currentdisabled" value="1"' . (($main::data{'navi_currentdisabled'}) ? ' checked="checked"' : '') . ' /> Vicuna CMS 󤫤鸽ߤΥڡĴ륹륷Ȥ<strong>ɤ߹ޤʤ</strong></label>';
	print '</fieldset>';
	print '<fieldset>';
	print '<legend><label for="data:navi_vicunacss">ɲå륷</label></legend>';
	print '<textarea name="data:navi_vicunacss" id="data:navi_vicunacss" cols="80" rows="5" wrap="off" class="content-editor-area" ondblclick="cmonos.tool.colorPalette.open(\'data:navi_vicunacss+\',\'dom\')">';
	print $this->escape($main::data{'navi_vicunacss'});
	print '</textarea>';
	$helper->print_menu('data:navi_vicunacss',0, '<option value="/*CURRENT_LI*/">ߤΥڡб &lt;li&gt;</option><option value="/*CURRENT_A*/">ߤΥڡб &lt;a&gt;</option>');
	print '</fieldset>';
	print '</div></fieldset>';

	print '</fieldset>';

} else {
	print '</tbody></table></div></fieldset>';
}

print '<fieldset>';
print '<legend><label><input type="radio" name="data:navi_type" value="template"' . ((defined $main::data{'navi_type'} && $main::data{'navi_type'} eq 'template') ? ' checked="checked"' : '') . ' onclick="toggleNaviType()" />ƥץ졼 : ƥץ졼Ȥ˴Ťʥӥޤ</label></legend>';
print '<div id="type-template" class="type-settings">';

require CMONOS::CGI_Lib::Template;
my $this_template = Template->new;

#ϻٱġ
my $tool = '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:navi_template\').quotationByMenu(this)" title="Υϡ񤭽ФŬڤʥѴޤ">';
$tool .= '<option value="">ü쥿</option>';
$tool .= '<option value="&lt;!--sitenavi type=&quot;icon&quot;--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/sitenavi--&gt;">ȥʥӥ󥢥</option>';
$tool .= '<option value="&lt;!--sitenavi type=&quot;link&quot;--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/sitenavi--&gt;">ȥʥӥ</option>';
$tool .= '</select>';
$this_template->print_template_form('data:navi_template','ʥӥƥץ졼',\$main::data{'navi_template'},\$tool);

print '<fieldset>';
print '<legend><label for="data:navi_navicss">ʥӥ󥹥륷</label></legend>';
print '<textarea name="data:navi_navicss" id="data:navi_navicss" cols="80" rows="20" wrap="off" class="content-editor-area" ondblclick="cmonos.tool.colorPalette.open(\'data:navi_navicss+\',\'dom\')">';
print $this->escape($main::data{'navi_navicss'});
print '</textarea>';
$helper->print_menu('data:navi_navicss');
print '</fieldset>';
print '</div></fieldset>';

print '</fieldset>';

if (defined $env::inline_navi && $env::inline_navi) {
	print '<fieldset>';
	print '<legend><label for="data:navi_navifooter">եå</label></legend>';
	print '<textarea name="data:navi_navifooter" id="data:navi_navifooter" cols="80" rows="5" wrap="off" class="content-editor-area">' . $this->escape($main::data{'navi_navifooter'}) . '</textarea>';
	$this->print_html_helper('data:navi_navifooter');
	print '</fieldset>';
}
print '<fieldset class="submit"><span class="warning">ѹϼ֥ʥӥ񤭽Ф׻ȿǤޤ</span> <input type="submit" value="¸" class="save" /></fieldset>';
}

sub print_html_helper ($$) {
my($this,$name) = @_;
print '<div class="toolbox">';
require CMONOS::CGI_Lib::HTMLHelper;
print HTMLHelper->new->html_helper_menu($name);
print '<label class="auto-fit" title="⤵Ƥ˹碌"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'' . $name . '\').setAutoFit(this.checked);" />եå</label>';
print '</div>';
}

######################################################################
# Ͽ
#sub import {
BEGIN {

	#饹Ͽ
	Common::class_register('n000','NaviLayout');

	#ġϿ
	$setting::jump_menu{'n000'} = 'ʥӥ쥤' if !defined $setting::jump_menu{'n000'};
	$setting::sub_jump_menu{'page'}{'n000'} = 'ʥӥ쥤' if !defined $setting::sub_jump_menu{'page'}{'n000'} && (!defined !$env::inline_navi || !$env::inline_navi);
}

1;
