package FTPAccess;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# FTP¥⥸塼
# FTPAccess.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-06-07
######################################################################
# ¹
sub run ($) {
my $this = shift;
my $ftpaccess_path = '../../.ftpaccess';
if ((!defined $env::home_dir_id || $env::home_dir_id eq '') && !$env::multi_domain) {
	my $uid = (stat($this->path_conv($ENV{'SCRIPT_NAME'},'path')))[4];
	my $document_root = $this->document_root;
	my $prefix = '';
	while ($document_root =~ s!/[^/]+$!!) {
		if ($document_root) {
			my $duid = (stat($document_root))[4];
			if (!$duid || $duid ne $uid) {
				last;
			}
		}
		$prefix .= '../';
	}
	if ($prefix) {
		$ftpaccess_path = $prefix . $ftpaccess_path if $main::root;

		#饤֥˥塼
		$setting::page{'tools'}{'subMenu'} = $this->form_start(
			'key'	=>	$setting::security_key,
			'name'	=>	'dirselector',
			'required'	=>	\@setting::form
		);
		$setting::page{'tools'}{'subMenu'} .= '<select name="root" onchange="submit()">';
		$setting::page{'tools'}{'subMenu'} .= '<option value="">Υǥ쥯ȥ</option>';
		$setting::page{'tools'}{'subMenu'} .= '<option value="1"' . (($main::root) ? ' selected="selected"' : '') . '>ǽʺǾ</option>';
		$setting::page{'tools'}{'subMenu'} .= '</select>';
		$setting::page{'tools'}{'subMenu'} .= '<input name="subJumpMenu" type="submit" value="" /></form>';
		$setting::page{'tools'}{'topicpath'} .= ((defined $setting::page{'tools'}{'topicpath'} && $setting::page{'tools'}{'topicpath'} ne '') ? ' &gt; ' : '') . (($main::root) ? 'ǽʺǾ' : 'Υǥ쥯ȥ');
		$this->push_window_title(($main::root) ? 'ǽʺǾ' : 'Υǥ쥯ȥ');
	} else {
		undef $main::root;
	}
}

my $current_ftpaccess = $this->read_file($ftpaccess_path,1);
my $allowed_ip;
my $deny_from_all = 0;
my $allow_from_all = 0;
if ($current_ftpaccess && $current_ftpaccess =~ /<Limit\s+ALL>(.*?)<\/Limit>/is) {
	my $setting = $1;
	$allowed_ip = $1 if $setting =~ /Allow\s+from\s+([\w\-\.\/]+)/is;
	$deny_from_all = 1 if !$allowed_ip && ($setting =~ /Deny\s*All/is || $setting =~ /Deny\s+from\s+all/is);
	$allow_from_all = 1 if $setting =~ /Allow\s*All/is;
}
if ($main::limit) {
	if ($main::limit eq 'remove') {
		if ($current_ftpaccess) {
			$current_ftpaccess =~ s/<Limit\s+ALL>.*?<\/Limit>\x0A?//igs;
			if ($current_ftpaccess !~ /\S/s) {
				unlink $ftpaccess_path;
			} else {
				$this->write_file($ftpaccess_path,\$current_ftpaccess,1);
			}
		}
		$allowed_ip = '';
		$deny_from_all = 0;
		$allow_from_all = 0;
	} elsif ($main::limit eq 'none') {
		$current_ftpaccess = "<Limit ALL>\x0A  AllowAll\x0A</Limit>\x0A" unless $current_ftpaccess =~ s/<Limit\s+ALL>.*?<\/Limit>\x0A?/<Limit ALL>\x0A  AllowAll\x0A<\/Limit>\x0A/igs;
		$this->write_file($ftpaccess_path,\$current_ftpaccess,1);
		$allowed_ip = '';
		$deny_from_all = 0;
		$allow_from_all = 1;
	} elsif ($main::limit eq 'all') {
		$current_ftpaccess = "<Limit ALL>\x0A  DenyAll\x0A</Limit>\x0A" unless $current_ftpaccess =~ s/<Limit\s+ALL>.*?<\/Limit>\x0A?/<Limit ALL>\x0A  DenyAll\x0A<\/Limit>\x0A/igs;
		$this->write_file($ftpaccess_path,\$current_ftpaccess,1);
		$allowed_ip = '';
		$deny_from_all = 1;
		$allow_from_all = 0;
	} elsif ($main::limit eq 'ip') {
		$current_ftpaccess = "<Limit ALL>\x0A  Order Allow,Deny\x0A  Allow from $ENV{'REMOTE_ADDR'}\x0A  Deny from all\x0A</Limit>\x0A" unless $current_ftpaccess =~ s/<Limit\s+ALL>.*?<\/Limit>\x0A?/<Limit ALL>\x0A  Order Allow,Deny\x0A  Allow from $ENV{'REMOTE_ADDR'}\x0A  Deny from all\x0A<\/Limit>\x0A/igs;
		$this->write_file($ftpaccess_path,\$current_ftpaccess,1);
		$allowed_ip = $ENV{'REMOTE_ADDR'};
		$deny_from_all = 0;
		$allow_from_all = 0;
	}
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>FTP</h1>';
print '<p class="warning">' . (($main::root) ? '<strong>ǽʺǾ</strong>' : 'Υǥ쥯ȥ') . 'ؤ FTP ¤ꤷޤ.ftpaccessפˤ FTP ¤бƤʤ FTP ФǤϡ¤Ǥޤ</p>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="root" value="1" />' if $main::root;
print '<fieldset><legend>ߤ</legend><p>';
if ($allowed_ip) {
	print $this->escape($allowed_ip) . ' ʳ IP  FTP 䤷Ƥޤ';
} elsif ($deny_from_all) {
	print '٤Ƥ IP  FTP 䤷Ƥޤ';
} elsif ($allow_from_all) {
	print '٤Ƥ IP  FTP Ū˵ĤƤޤ';
} else {
	print 'FTP ¤ϼ»ܤƤޤ';
}
print '</p></fieldset>';
print '<fieldset><legend></legend><ol class="checkbox">';
print '<li><label><input type="radio" name="limit" value="none" /> եơ٤Ƥ IP  FTP Ū˵Ĥ(̳ؤ FTP ¤Ƥʤ)</label></li>' if !$allow_from_all;
print '<li><label><input type="radio" name="limit" value="remove" /> FTP (ǽʤեޤ)</label></li>' if $allow_from_all;
print '<li><label><input type="radio" name="limit" value="remove" /> FTP ¤(ǽʤեޤ)</label></li>' if $allowed_ip || $deny_from_all;
print '<li><label><input type="radio" name="limit" value="ip" /> ' . $this->escape($ENV{'REMOTE_ADDR'}) . ' ʳ IP  FTP 䤹롣</label></li>' if !$allowed_ip || $allowed_ip ne $ENV{'REMOTE_ADDR'};
print '<li><label><input type="radio" name="limit" value="all" /> ٤Ƥ IP  FTP 䤹롣</label></li>' if !$deny_from_all;
print '</ol></fieldset>';
print '<fieldset class="submit">';
print '<input type="submit" value="ѹ" /></fieldset></form>';

#ڡեå
$this->print_page_footer('tools');

}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
if ($env::ownerpowerv && !$env::subdirectory_disabled && !$env::user_site_template_dir) {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('00s2','FTPAccess');

	#˥塼Ͽ
	$setting::jump_menu{'00s2'} = 'FTP';

}
}



1;
