package SiteTemplateExporter;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use Fcntl qw(:flock);
use File::Path;
use strict;
######################################################################
# ȥƥץ졼Ƚ񤭽Ф⥸塼
# SiteTemplateExporter.pm ver1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-04-18
######################################################################
# ¹
sub run ($) {
my $this = shift;
my(@site_template_list,$site_template_dir);
$this->get_setup_env;
unless (eval 'use Archive::Tar;Archive::Tar->has_zlib_support;') {
	$this->jump_menu('tools');
	$this->print_page_header('tools');
	print '<h1>ȥƥץ졼Ƚ񤭽Ф</h1>';
	print '<p>Archive::Tar ⥸塼뤬ߤĤʤᡢεǽѤǤޤ󡣡~/cgi-data/template/siteפ˥ȥƥץ졼Ȥ¸ƤޤFTP ǥȥƥץ졼ȥեǥ˥ɤƤ</p>';
	$this->print_page_footer('tools');
	return 1;
}
$site_template_dir = $env::user_site_template_dir || $env::template_dir . '/site';

#ȥƥץ졼ȥ
local(*DIR);
if (opendir(DIR, $site_template_dir)) {
	@site_template_list = grep($_ !~ /^\./ && -d $site_template_dir . '/' . $_,readdir(DIR));
	closedir(DIR);
}

#ȥե
my $temp_dir = $env::clipboard . '/site_template_exporter' . ($env::home_dir_id || '');
my $status_file = $temp_dir . '/status';
my $target_info = $temp_dir . '/target';
my $pending_time = (!-f $status_file) ? 0 : time - (stat($status_file))[9];
if (-d $temp_dir && -f $status_file && $pending_time > 600) {
	my($t,$n,$l) = split(/\x09/,$this->read_file($target_info,1));
	push(@{$this->{'dialog'}},'󥵥ȥƥץ졼ȡ' . $this->site_template_title($n,($l || $t)) . 'פΰ̤˼Ԥǽޤȥեޤȥƥץ졼Ȥϡ~/cgi-data/template/siteפ¸ƤޤFTP ʤɤǥȥƥץ졼ȤեȥɤƤ');
	rmtree $temp_dir
}
my $status = $this->read_file($status_file,1) || 0;
my($tempid,$name,$label) = split(/\x09/,$this->read_file($target_info,1));

#񤭽Ф
if ($status == 2 && $tempid) {
	if ($main::cancel) {
		push(@{$this->{'dialog'}},'ȥƥץ졼ȡ' . $this->site_template_title($name,($label || $tempid)) . 'פν񤭽Фߤޤ');
		rmtree $temp_dir;
		$status = 0;
	} elsif ($ENV{'PATH_INFO'}) {
		my $path = $temp_dir . '/' . $tempid . '.tgz';
		my $size = -s $path;
		print "Content-Type: application/x-tar-gz\n";
		print "Content-Length: $size\n";
		print "\n";
		local(*FILE);
		if (open(FILE, $path)) {
			binmode FILE;
			flock(FILE, LOCK_SH);
			my $buf;
			while (read(FILE,$buf,$env::buffer_size)) {
				print $buf;
			}
			close(FILE);
		}
		rmtree $temp_dir;
		return;
	}
} elsif ($main::target) {
	if (!@site_template_list || !grep($_ eq $main::target,@site_template_list)) {
		push(@{$this->{'dialog'}},'ȥƥץ졼Ƚ񤭽Ф˼Ԥޤꤵ줿ȥƥץ졼Ȥ¸ߤޤ');
	} else {
		my($target,$home_dir);
		$tempid = $label = $target = $main::target;
		if (!$env::user_site_template_dir) {
			($tempid,$home_dir) = $this->get_sitetemplate_id_and_home_dir($target);
			if ($home_dir) {
				if ($default::home_dir && $home_dir !~ /^\Q$default::home_dir\E(?:\/|$)/) {
					undef $tempid;
				} else {
					$label = $this->escape($tempid . '@~' . $home_dir);
				}
			}
		}
		if (!$tempid) {
			push(@{$this->{'dialog'}},'ȥƥץ졼Ƚ񤭽Ф˼Ԥޤꤵ줿ȥƥץ졼Ȥ¸ߤޤ');
		} else {
			($name) = split(/\x09/,$this->read_file($site_template_dir . '/' . $target . '/name.txt'));
			$name = 'ǥեȤΥȥƥץ졼' if !$name && $tempid eq 'default';
			my $cwd = $this->get_cwd;
			$this->set_dir($temp_dir);
			$this->write_file($status_file,1,1);
			$this->write_file($target_info,$tempid . "\x09" . $name . "\x09" . $label,1);
			chdir($site_template_dir . '/' . $target);
			use File::Find qw(find);
			my $tar = Archive::Tar->new;
			my @files;
			find(sub { push(@files,$File::Find::name); },'.');
			$tar->add_files(@files);
			$tar->write($this->path_change($temp_dir . '/' . $tempid . '.tgz',$cwd . '/start.cgi','abs'),9);
			chdir($cwd);
			if (-f $temp_dir . '/' . $tempid . '.tgz') {
				$this->write_file($status_file,2,1);
				$status = 2;
			} else {
				push(@{$this->{'dialog'}},'ȥƥץ졼ȡ' . $this->site_template_title($name,($label || $tempid)) . 'פΰ̤˼Ԥޤ');
				rmtree $temp_dir;
				$status = 0;
			}
		}
	}
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>ȥƥץ졼Ƚ񤭽Ф</h1>';

if ($status == 1) {
	print '<p>ȥƥץ졼ȡ' . $this->site_template_title($name,($label || $tempid)) . 'פ򰵽̤Ƥޤ... (̤˼ԤƤ硢' . (($pending_time) ? 10 - int($pending_time/60) : 10) . 'ʬ˺ȥեޤ)</p>';
} elsif ($status == 2) {
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'method'	=>	'post',
		'path'	=>	'/' . $tempid . '.tgz',
		'required'	=>	\@setting::form
	);
	print '<p>ȥƥץ졼ȡ' . $this->site_template_title($name,($label || $tempid)) . 'פνޤ</p>';
	print '<fieldset class="submit" id="export"><input type="submit" value="񤭽Ф" onclick="cmonos.tool.hideSubmitButton()" /></fieldset></form>';
	print $this->javascript('cmonos.tool.hideSubmitButton = function () { document.getElementById("export").style.display = "none"; setTimeout(function () { location.href+="?m=Tools&k=s702"; } ,30000) }');
} elsif (@site_template_list) {
	#no warnings qw(numeric);
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'method'	=>	'post',
		'required'	=>	\@setting::form
	);
	print '<input type="hidden" name="export" value="1" />';
	print '<fieldset><legend>ȥƥץ졼Ȥ</legend><ol class="checkbox">';
	@site_template_list = sort {$a <=> $b || $a cmp $b} @site_template_list;
	foreach my $dir (@site_template_list) {
		my($tempid,$home_dir,$name);
		$tempid = $dir;
		if (!$env::user_site_template_dir) {
			($tempid,$home_dir) = $this->get_sitetemplate_id_and_home_dir($dir);
			if ($home_dir) {
				next if $default::home_dir && $home_dir !~ /^\Q$default::home_dir\E(?:\/|$)/;
				$tempid = $this->escape($tempid . '@~' . $home_dir);
			}
		}
		($name) = split(/\x09/,$this->read_file($site_template_dir . '/' . $dir . '/name.txt'));
		$name = 'ǥեȤΥȥƥץ졼' if !$name && $dir eq 'default';
		$name = '' if !defined $name;
		print '<li><label><input type="radio" name="target" value="' . $dir . '" /> ' . $this->site_template_title($name,$tempid) . '</lable></li>';
	}
	print '</ol></fieldset>';
	print '<fieldset class="submit"><input type="submit" value="񤭽Ф" /></fieldset></form>';
} else {
	print '<fieldset><div class="hints">񤭽Фǽʥȥƥץ졼Ȥ¸ߤޤ</div></fieldset>';
}

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('s702','SiteTemplateExporter');

	#˥塼Ͽ
	$setting::jump_menu{'s702'} = 'ȥƥץ졼Ƚ񤭽Ф';

}



1;
