package SubDirInstaller;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use strict;
use Fcntl qw(:flock);
######################################################################
# ֥ǥ쥯ȥߥ⥸塼
# SubDirInstaller.pm ver1.1.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-09-25
######################################################################
# ¹
sub run ($) {
my $this = shift;
my $error_flag = 0;
my $is_document_root = 1 if !$cgi::input->home_directory(1);
undef $main::multi_domain if $env::multi_domain || !$is_document_root;
undef $main::share_flag if $main::multi_domain;
$this->get_setup_env;
$this->get_perl_path;
my($multi_domain,$site_template_dir,$selected_template);
if ($main::template && $main::template =~ /^(user:|)([\w\-\@]+)$/) {
	my $user_template = $1;
	$selected_template = $2;
	my($tempid,$home_dir) = $this->get_sitetemplate_id_and_home_dir($selected_template);
	if ($default::home_dir && $home_dir && $home_dir !~ /^\Q$default::home_dir\E(?:\/|$)/) {
		undef $selected_template;
	} elsif ($user_template && $env::user_site_template_dir) {
		$site_template_dir = $env::user_site_template_dir;
	} else {
		$site_template_dir = $env::template_dir . '/site';
	}
}
my @targetable_directories = $this->targetable_directories($default::cgi_data_root . ($default::home_dir || ''));

#ϥå
if (defined $main::a && $main::a) {
	$main::name = $this->z_to_h($main::name,'euc') if defined $main::name && $main::name;
	$main::target_dir = '' if $main::multi_domain;
	if ($main::target_dir) {
		if (!@targetable_directories || $main::target_dir !~ /^\// || $main::target_dir =~ /\/\.\.\// || !grep($_ eq $main::target_dir,@targetable_directories) || !-d $default::cgi_data_root . $default::home_dir . $main::target_dir) {
			push(@{$this->{'dialog'}},'ǥ쥯ȥǧƤ');
			$main::target_dir = '';
			$error_flag = 1;
		} else {
			my($subdirectory_disabled,$user_site_template_dir,$user_default_dir);
			($multi_domain,$subdirectory_disabled,$user_site_template_dir,$user_default_dir) = $this->subdir_options($default::cgi_data_root . $default::home_dir . $main::target_dir . '/lib/env.pl');
			if ($subdirectory_disabled) {
				$main::user_site_template = ($user_site_template_dir) ? 1 : $main::user_site_template;
				$main::user_default = ($user_default_dir) ? 1 : $main::user_default;
				$main::subdirectory_disabled = 1;
				undef $multi_domain if $env::multi_domain;
			} else {
				push(@{$this->{'dialog'}},'ǥ쥯ȥǧƤ');
				$main::target_dir = '';
				$error_flag = 1;
			}
		}
	}
		push(@{$this->{'dialog'}},$multi_domain);
	if (!defined $main::name || $main::name eq '') {
		push(@{$this->{'dialog'}},'ե̾ϤƤ');
		$error_flag = 1;
	} elsif ($main::multi_domain) {
		if ($main::name !~ /^\w[\w\.\-]+$/) {
			push(@{$this->{'dialog'}},'ե̾ȾѱѻǻϤޤ20ʸȾѱѿ(a-z,A-Z,.,-,_)ˤƤ');
			$error_flag = 1;
		} elsif ($main::domain !~ /^[\w\.\-\%]+\.\w+$/) {
			push(@{$this->{'dialog'}},'ѿɥᥤʳꤹ뤳ȤϽޤ');
			$error_flag = 1;
		} elsif (!-d '../..' . ($main::target_dir || '') . '/' . $main::name) {
			push(@{$this->{'dialog'}},'ꤵ줿̥ɥᥤѥե¸ߤޤ');
			$error_flag = 1;
		} elsif ($this->name_is_unavailable($main::target_dir,$main::name,1)) {
			push(@{$this->{'dialog'}},'ꤵ줿̥ɥᥤѥեϴ˻ѤƤޤ');
			$error_flag = 1;
		}
	} elsif ($main::name !~ /^[a-zA-Z][a-zA-Z0-9]{0,20}$/) {
		push(@{$this->{'dialog'}},'ե̾ȾѱѻǻϤޤ20ʸȾѱѿˤƤ');
		$error_flag = 1;
	} elsif ($this->name_is_unavailable($main::target_dir,$main::name)) {
		push(@{$this->{'dialog'}},'Ϥ줿ե̾ϴ˻ѤƤޤ');
		$error_flag = 1;
	}
	if (defined $main::password && $main::password =~ /^\w{6,}$/) {
		if (!defined $main::password2 || $main::password ne $main::password2) {
			push(@{$this->{'dialog'}},'ǧΤΥѥɤפޤ');
			$error_flag = 1;
		}
	} else {
		push(@{$this->{'dialog'}},'ѥɤ6ʸʾȾѱѿˤƤ');
		$error_flag = 1;
	}
	$main::emailaddr = $this->z_to_h($main::emailaddr);
	if ($this->is_invalid_email_address($main::emailaddr)) {
		push(@{$this->{'dialog'}},'ͥ᡼륢ɥ쥹ǧƤ');
		$error_flag = 1;
	}
	$this->env_escape(\$main::title);
	if ($main::title ne '' && $main::title !~ /\S/) {
		push(@{$this->{'dialog'}},'ȥȥϤƤ');
		$error_flag = 1;
	}
	$this->env_escape(\$main::description);
	if ($main::description ne '' && $main::description !~ /\S/) {
		push(@{$this->{'dialog'}},'ȤϤƤ');
		$error_flag = 1;
	}
	$this->env_escape(\$main::copyright);
	if (!defined $main::template || $main::template eq '') {
		$selected_template = $main::template = 'default';
	} elsif (!-d $site_template_dir . '/' . $selected_template || !-f $site_template_dir . '/' . $selected_template . '/htdocs/cgi/setup/start.cgi') {
		push(@{$this->{'dialog'}},'ꤵ줿ȥƥץ졼Ȥ¸ߤޤ');
		$error_flag = 1;
	}

	#󥹥ȡ
	if (!$error_flag) {
		my($target_dir,$target_rel,$cgi_data_path,$shared_cgi_data_root,$home_dir,$http_home_dir,$home_dir_id,$cgi_data_root,$env_path,$home_url,$default_id,$javascript_dir,$user_directory);
		$target_dir = $main::target_dir || '';
		$target_rel = ($target_dir) ? ('../' x ($target_dir =~ tr!/!/!)) : '';
		$cgi_data_path = ((defined $default::cgi_data) ? $default::cgi_data : '') . $target_dir . '/' . $main::name;
		if ($main::multi_domain) {
			$home_dir = '/' . $main::name;
			$http_home_dir = $home_dir_id = $user_directory = '';
			$home_url = (($this->is_ssl) ? 'https://' : 'http://') . $main::domain;
			$javascript_dir = '/lib/javascript';
		} elsif ($multi_domain) {
			my $target = $target_dir;
			$target =~ s!^/[^/]+!!;
			$home_dir = $target_dir . '/' . $main::name;
			$http_home_dir = $user_directory = $target . '/' . $main::name;
			($home_dir_id = $http_home_dir) =~ tr!/!_!;
			$home_dir_id =~ s/^_//g;
			$home_dir_id .= '_';
			$home_url = (($this->is_ssl) ? 'https://' : 'http://') . $multi_domain . $http_home_dir;
			$javascript_dir = $user_directory . '/lib/javascript';
		} else {
			$home_dir = ((defined $default::home_dir) ? $default::home_dir : '') . $target_dir . '/' . $main::name;
			$http_home_dir = ((defined $default::http_home_dir) ? $default::http_home_dir : '') . $target_dir . '/' . $main::name;
			($home_dir_id = $http_home_dir) =~ tr!/!_!;
			$home_dir_id =~ s/^_//g;
			$home_dir_id .= '_';
			$user_directory = $this->home_directory(1) . $target_dir . '/' . $main::name;
			$home_url = $this->full_path('../../',1) . $target_dir . '/' . $main::name;
			$javascript_dir = $user_directory . '/lib/javascript';
		}
		$cgi_data_root = '../' . $target_rel . $default::cgi_data_root;
		$shared_cgi_data_root = '../' . $target_rel . $default::shared_cgi_data_root;

		#env.pl
		$this->set_dir($cgi_data_path . '/lib');
		$this->mk_env(
			$cgi_data_path,
			$cgi_data_root,
			$shared_cgi_data_root,
			$home_dir,
			$http_home_dir,
			$home_dir_id,
			$user_directory,
			$site_template_dir . '/' . $selected_template . '/env.bak',
			$main::conv_table,
			$multi_domain,
			(($env::user_site_template_dir) ? 1 : $main::user_site_template),
			(($env::user_default_dir) ? 1 : $main::user_default),
			(($env::subdirectory_disabled) ? 1 : $main::subdirectory_disabled),
		);

		#֥ǥ쥯ȥ
		$this->mk_sub_directory(
			$site_template_dir . '/' . $selected_template . '/htdocs',
			'../..' . $target_dir . '/' . $main::name,
			'../' . $target_rel . $cgi_data_path,
			$cgi_data_root,
			$shared_cgi_data_root,
			$home_dir,
			$http_home_dir,
			$home_dir_id,
			$home_url,
			$this->url_encode($home_url),
			$javascript_dir,
			$user_directory,
			$main::conv_table
		);

		#preferenceǥ쥯ȥ
		$this->restore_default_settings($site_template_dir . '/' . $selected_template . '/preferences',$cgi_data_path . '/preferences',1,$home_dir_id,$user_directory,$home_url,$main::conv_table);

		#dataǥ쥯ȥ
		$this->restore_default_settings($site_template_dir . '/' . $selected_template . '/data',$cgi_data_path . '/data',1,$home_dir_id,$user_directory,$home_url,$main::conv_table);

		#QRɲ
		require CMONOS::CGI_Lib::HTTP_Client;
		my $res = HTTP_Client->new->request(
			'GET' => 'http://chart.apis.google.com/chart?chs=160x160&cht=qr&chl=' . $this->url_encode($home_url . '/m.cgi/'),
			{},'','','',
			'../..' . $target_dir . '/' . $main::name . '/qr.png'
		);
		$res = HTTP_Client->new->request(
			'GET' => 'http://chart.apis.google.com/chart?chs=100x100&cht=qr&chl=' . $this->url_encode($home_url . '/m.cgi/'),
			{},'','','',
			'../..' . $target_dir . '/' . $main::name . '/qr_mini.png'
		);

		if ($main::multi_domain || $multi_domain) {
			if ($main::multi_domain) {
				$this->directory_copy($env::image_lib,'../..' . $target_dir . '/' . $main::name . '/cgi/imageLib',1);
				$this->directory_copy($env::icon_dir,'../..' . $target_dir . '/' . $main::name . '/icon',1);
				$this->directory_copy('../../error','../..' . $target_dir . '/' . $main::name . '/error',1);
				$this->file_copy($env::dummy_window,'../..' . $target_dir . '/' . $main::name . '/cgi/dummy4href.html');
				$this->file_copy($env::download_window,'../..' . $target_dir . '/' . $main::name . '/cgi/dummy.html');
			}
			if ($target_dir) {
				$target_dir =~ s/^\///;
				push(@{$this->{'dialog'}},'֥ǥ쥯ȥ' . (($target_dir) ? $target_dir . '/' : '') . $main::name . 'פ̥ɥᥤ' . (($multi_domain) ? '' . $multi_domain . '' : '') . 'ߤޤ');
			} else {
				push(@{$this->{'dialog'}},'֥ǥ쥯ȥ' . $main::name . 'פ̥ɥᥤȤߤޤ');
			}

		} else {

			#
			if (defined $main::notification && $main::notification) {
				my %installmsg;
				$this->import_db($default::preference_dir . '/installmsg',\%installmsg);
				$installmsg{'subject'} = 'ڤΤ餻ۥ֥ǥ쥯ȥߤޤ' if !$installmsg{'subject'};
				$installmsg{'msg'} = 'URL' . "\x0A" . '<uri>' . "\x0A\x0A" . 'ƥʥ󥹥ơ' . "\x0A" . '<tool>' . "\x0A" if !$installmsg{'msg'};
				my $uri = $home_url . '/';
				my $tool = $home_url . '/cgi/';
				$installmsg{'msg'} =~ s/<(uri|url)>/$uri/igs;
				$installmsg{'msg'} =~ s/<tool>/$tool/igs;
				$installmsg{'msg'} =~ s/<password>/$main::password/igs;
				unless (ref $cgi::SendMail) {
					require CMONOS::CGI_Lib::SendMail;
					$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
				}
				$cgi::SendMail->send_mail(
					'To'		=>  $main::emailaddr,
					'From'		=>  (($setting::general{'master'}) ? (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}) : $env::master_email),
					'Subject'	=>  $installmsg{'subject'},
					'message'	=>  $installmsg{'msg'} . "\x0A\x0A"
				);
			}
			if ($target_dir) {
				$target_dir =~ s/^\///;
				$target_dir .= '/';
			}
			$this->set_javascript(
<<SCRIPT
function jumpConfirmation () {
	if (confirm('$main::nameפ򥤥󥹥ȡ뤷ޤ\\n$target_dir$main::nameڡ˰ưޤ')) {
		top.document.location.href = '../../$target_dir$main::name/cgi/';
	}
}
SCRIPT
			);
			$this->set_onload('jumpConfirmation();');
		}
		undef $main::share_flag;
		undef $main::name;
		undef $main::title;
		undef $main::copyright;
		undef $main::description;
		undef $main::emailaddr;
		undef $main::notification;
	}
}

#ڡإå
if (!$env::multi_domain && $is_document_root) {
	if ($main::multi_domain) {
		$this->set_onload('cmonos.element.item(\'target-directory\',\'register-setting\',\'send-mail\').disappear(true);cmonos.element.item(\'new-domain\').disappear(false);');
	} else {
		$this->set_onload('cmonos.element.item(\'new-domain\').disappear(true);');
	}
}
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>֥ǥ쥯ȥ</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'onsubmit'	=>	'return confirm(\'ϼäޤ˥󥹥ȡ뤷ޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="1" />';
print '<fieldset><table class="field-table"><tbody>';
if (@targetable_directories) {
	print '<tr id="target-directory">';
	print '<td class="field-name"><label for="target_dir">ǥ쥯ȥ</label></td>';
	print '<td class="field">';
	print '<select name="target_dir" id="target_dir" onchange="document.getElementById(\'samplepage\').href = \'../..\'+this.value+\'/\'">';
	print '<option value="">Υǥ쥯ȥ</option>';
	foreach my $dir (@targetable_directories) {
		my $d = $dir;
		$d =~ s!^/!!;
		print '<option value="' . $dir . '"' . ((defined $main::target_dir && $main::target_dir eq $dir) ? ' selected="selected"' : '') . '>' . $d . '</option>';
	}
	print '</select> <a href="../..' . ($main::target_dir || '') . '/" id="samplepage" target="sample">[ǧ]</a><div class="hints">ǥ쥯ȥ򤹤ȥץǥ쥯ȥ˽सޤ</div>';
	print '</td>';
	print '</tr>';
}
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="name">ե̾</label></td>';
print '<td class="field"><input type="text" name="name" id="name" size="20" value="' . $this->escape($main::name) . '" />';
print ' <label title="Υե HTTP ǥ쥯ȥ(ɥȥ롼)Ȥߤޤ"><input type="checkbox" name="multi_domain" value="1"' . (($main::multi_domain) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'target-directory\',\'register-setting\',\'send-mail\').disappear(this.checked);cmonos.element.item(\'new-domain\').disappear(!this.checked);" /> ̥ɥᥤȤߤ</label>' if !$env::multi_domain && $is_document_root;
print '</td>';
print '</tr>';
print '</tbody><tbody>';
if (!$env::multi_domain && $is_document_root) {
	print '<tr id="new-domain">';
	print '<td class="field-name"><label for="title">ɥᥤ</label></td>';
	print '<td class="field">http://<input type="text" name="domain" id="title" size="20" value="' . $this->escape($main::domain) . '" />/';
	print '<div class="hints">ӥǡޤॵȥƥץ졼ȤѤɬܤǤ</div>';
	print '</td>';
	print '</tr>';
}
print '<tr>';
print '<td class="field-name"><label for="title">ȥȥ</label></td>';
print '<td class="field"><input type="text" name="title" id="title" size="20" value="' . $this->escape((defined $main::title && $main::title ne '') ? $main::title : $env::title) . '" /></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="copyright">Ȥ</label></td>';
print '<td class="field"><input type="text" name="copyright" id="copyright" size="30" value="' . $this->escape((defined $main::copyright && $main::copyright ne '') ? $main::copyright : $env::copyright) . '" />';
print '<div class="hints">RSSΥȤɽʤɤ˻Ѥޤ</div>';
print '</td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="description">Ȥ</label></td>';
print '<td class="field"><textarea name="description" id="description" cols="60" rows="2">' . $this->escape((defined $main::description && $main::description ne '') ? $main::description : $env::description) . '</textarea>';
print '<div class="hints">RSSΥȤʤɤ˻Ѥޤ</div>';
print '</td>';
print '</tr>';
print '</tbody><tbody>';
print '<tr id="register-setting">';
print '<td class="field-name"><span class="datatitle">Ͽѥɾ</span></td>';
print '<td class="field"><label><input type="checkbox" name="share_flag" id="share_flag"' . (($main::share_flag) ? ' checked="checked"' : '') . ' /> Ǿؤȶͭ</label></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="password">ޥѥ</label></td>';
print '<td class="field"><input type="password" name="password" id="password" size="20" /></td>';
print '</tr>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="password2">ޥѥɡʳǧ</label></td>';
print '<td class="field"><input type="password" name="password2" id="password2" size="20" />';
print '<div class="hints">ѥɤ "' . $this->rand_char_sample . '"</div></td>';
print '</tr>';
print '</tbody><tbody>';
print '<tr class="tbody-end">';
print '<td class="field-name"><label for="emailaddr">ͥɥ쥹</label></td>';
print '<td class="field"><input type="text" name="emailaddr" id="emailaddr" size="30" value="' . $this->escape($main::emailaddr) . '" />';
print '<div class="note" id="send-mail"><label><input type="checkbox" name="notification" value="1"' . (($main::notification) ? ' checked="checked"' : '') . ' /> ֥ǥ쥯ȥδͤ˥֥ǥ쥯ȥΤ</label></div>';
print '</td>';
print '</tr>';
if (!$env::user_site_template_dir || !$env::user_default_dir || !$env::subdirectory_disabled) {
	print '</tbody><tbody>';
	print '<tr class="tbody-end">';
	print '<td class="field-name"><span class="datatitle">ץ</span></td>';
	print '<td class="field">';
	print '<ol class="checkbox">';
	print '<li><label><input type="checkbox" name="user_site_template" value="1"' . (($main::user_site_template) ? ' checked="checked"' : '') . ' /> ȥƥץ졼Ȥ򥵥֥ǥ쥯ȥꤴȤ¸</label></li>' if !$env::user_site_template_dir;
	print '<li><label><input type="checkbox" name="user_default" value="1"' . (($main::user_default) ? ' checked="checked"' : '') . ' /> ͭ򥵥֥ǥ쥯ȥꤴȤ¸</label></li>' if !$env::user_default_dir;
	print '<li><label><input type="checkbox" name="subdirectory_disabled" value="1"' . (($main::subdirectory_disabled) ? ' checked="checked"' : '') . ' /> ֥ǥ쥯ȥߤػߤ</label></li>' if !$env::subdirectory_disabled;
	print '</ol>';
	print '<div class="warning">嵭ץϥ֥ǥ쥯ȥꥤ󥹥ȡѹǤޤ</div>';
	print '</td>';
	print '</tr>';
}
print '</tbody><tbody>';
print '<tr>';
print '<td class="field-name"><label for="template">ȥƥץ졼</label></td>';
print '<td class="field"><select name="template"><option value="default">ǥեȤΥȥƥץ졼</option>';
if (opendir(TEMP,$env::template_dir . '/site')) {;
	#no warnings qw(numeric);
	my @template = grep($_ ne 'default' && $_ !~ /\./ && -d $env::template_dir . '/site/' . $_ && -f $env::template_dir . '/site/' . $_ . '/htdocs/cgi/setup/start.cgi',readdir(TEMP));
	closedir(TEMP);
	foreach my $dir (sort {$a <=> $b || $a cmp $b} @template) {
		my($tempid,$home_dir,$name);
		$tempid = $dir;
		($tempid,$home_dir) = $this->get_sitetemplate_id_and_home_dir($dir);
		if ($home_dir) {
			next if $default::home_dir && $home_dir !~ /^\Q$default::home_dir\E(?:\/|$)/;
			$tempid = $this->escape($tempid . '@~' . $home_dir);
		}
		($name) = split(/\x09/,$this->read_file($env::template_dir . '/site/' . $dir . '/name.txt'));
		$name = '' if !defined $name;
		print '<option value="' . $dir . '"' . (($selected_template && $selected_template eq $dir) ? ' selected="selected"' : '') . '>' . $this->site_template_title($name,$tempid) . (($env::user_site_template_dir) ? '&lt;ͭ&gt;' : '') . '</option>';
	}
}
if ($env::user_site_template_dir && opendir(TEMP,$env::user_site_template_dir)) {;
	#no warnings qw(numeric);
	my @template = grep($_ !~ /\./ && -d $env::user_site_template_dir . '/' . $_ && -f $env::user_site_template_dir . '/' . $_ . '/htdocs/cgi/setup/start.cgi',readdir(TEMP));
	closedir(TEMP);
	foreach my $dir (sort {$a <=> $b || $a cmp $b} @template) {
		my($name) = split(/\x09/,$this->read_file($env::user_site_template_dir . '/' . $dir . '/name.txt'));
		$name = '' if !defined $name;
		print '<option value="user:' . $dir . '"' . (($selected_template && $dir eq $selected_template) ? ' selected="selected"' : '') . '>' . $this->site_template_title($name,$dir) . '</option>';
	}
}
print '</select></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="conv_table">ʸѴɽ</label></td>';
print '<td class="field"><textarea name="conv_table" id="conv_table" cols="72" rows="4" wrap="off" title="񼰤˽äʸѴɽꤷޤ">' . $this->escape($main::conv_table) . '</textarea>';
print '<label class="auto-fit" title="⤵Ƥ˹碌"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'conv_table\').setAutoFit(this.checked);" />եå</label>';
print '<div class="note">񼰡Ѵоʸ=&gt;Ѵʸ[]</div>';
print '</td>';
print '</tr>';
print '</tbody></table></fieldset>';
print '<fieldset class="submit"><input type="submit" value="֥ǥ쥯ȥꥤ󥹥ȡ" /></fieldset>';
print '</form>';

#ڡեå
$this->print_page_footer('tools');
}

#ե̾ʣå
sub name_is_unavailable ($$;$$) {
my($this,$target_dir,$name,$multidomain) = @_;
return ($name =~ /^\./ || ($env::user_default_dir && $name eq 'default') || ($env::user_site_template_dir && $name eq 'template') || $name eq 'clipboard' || (!$multidomain && -e '../..' . $target_dir . '/' . $name) || -e $default::cgi_data . $target_dir . '/' . $name) ? 1 : 0;
}

#env.pl
sub mk_env ($$$$$$$$$$$$) {
my($this,$env_path,$cgi_data_root,$shared_cgi_data_root,$home_dir,$http_home_dir,$home_dir_id,$user_directory,$env_setting,$conv_table,$multi_domain,$user_site_template,$user_default,$subdirectory_disabled) = @_;
my($image_lib,$icon_dir,$download_window,$dummy_window,$data,$master_password_encrypted,$master_password,$sub_cgi_data_root);
$master_password = $main::password;
if ($env::session_enabled) {
	$master_password_encrypted = 1;
	$master_password = $cgi::Register->encrypt($master_password);
}
$env_path .= '/lib/env.pl';
$data = $this->read_file($default::cgi_data_root . '/lib/env.pl');
$data =~ s/^use[\x20\x09]+utf8;\x0A?//mg;
if ($env::multi_domain && $default::cgi_data =~ m!^($default::cgi_data_root/[^/]+)!) {
	$sub_cgi_data_root = '../' . $1;
} elsif ($multi_domain) {
	$sub_cgi_data_root = $shared_cgi_data_root . (($home_dir =~ m!^(/[^/]+)!) ? $1 : '');
} else {
	$sub_cgi_data_root = $cgi_data_root;
}
if ($main::multi_domain) {
	$icon_dir = '../../icon';
	$image_lib = '../imageLib';
	$download_window = '../dummy.html';
	$dummy_window = '../dummy4href.html';	
} elsif ($multi_domain) {
	my $rel = '../' x ($http_home_dir =~ tr!/!/!);
	$icon_dir = $rel . '../../icon';
	$image_lib = $rel . '../../cgi/imageLib';
	$download_window = $rel . '../../cgi/dummy.html';
	$dummy_window = $rel . '../../cgi/dummy4href.html';
} else {
	$image_lib = $this->base_change($env::image_lib,$user_directory . '/cgi/cgi/start.cgi');
	$icon_dir = $this->base_change($env::icon_dir,$user_directory . '/cgi/cgi/start.cgi');
	$download_window = $this->base_change($env::download_window,$user_directory . '/cgi/cgi/start.cgi');
	$dummy_window = $this->base_change($env::dummy_window,$user_directory . '/cgi/cgi/start.cgi');
}
if ($default::cgi_data_name =~ /^\.\.\//) {
	$data =~ s!(['"])$default::cgi_data_name!$1$cgi_data_root!g;
} else {
	$data =~ s!(['"])\.\./\.\./\.\./$default::cgi_data_name!$1$cgi_data_root!g;
}
if ($default::cgi_data_name ne $default::shared_cgi_data_name) {
	if ($default::shared_cgi_data_name =~ /^\.\.\//) {
		$data =~ s!(['"])$default::shared_cgi_data_name!$1$shared_cgi_data_root!g;
	} else {
		$data =~ s!(['"])\.\./\.\./\.\./$default::shared_cgi_data_name!$1$shared_cgi_data_root!g;
	}
}
$data =~ s/^[\x20\x09]*\$master_password[\x20\x09]*=[^\x0A\x0D]*;/\$master_password = '$master_password';/gm;
$data =~ s/^[\x20\x09]*\$master_password_encrypted[\x20\x09]*=[^\x0A\x0D]*;/\$master_password_encrypted = 1;/gm if $master_password_encrypted;
$data =~ s/^[\x20\x09]*\$master_email[\x20\x09]*=[^\x0A\x0D]*;/\$master_email = '$main::emailaddr';/gm;
$data =~ s/^[\x20\x09]*\$title[\x20\x09]*=[^\x0A\x0D]*;/\$title = '$main::title';/gm;
$data =~ s/^[\x20\x09]*\$description[\x20\x09]*=[^\x0A\x0D]*;/\$description = '$main::description';/gm;
$data =~ s/^[\x20\x09]*\$copyright[\x20\x09]*=[^\x0A\x0D]*;/\$copyright = '$main::copyright';/gm;
$data =~ s/^[\x20\x09]*\$home_dir_id[\x20\x09]*=[^\x0A\x0D]*;/\$home_dir_id = '$home_dir_id';/gm;
if ($main::share_flag) {
	my $cookie_path = ($multi_domain) ? '' : $this->user_directory(1) . (($env::top_dir) ? $env::top_dir : '');
	$cookie_path = '/' if !$cookie_path;
	my $top_cgi_path = $image_lib;
	$top_cgi_path =~ s/\/[^\/]+$//;
	$data =~ s/\/(preferences|data(?!\/session_store))/$home_dir\/$1/g;
	$data =~ s!^[\x20\x09]*\$register_cgi[\x20\x09]*=[^\x0A\x0D]*;!\$register_cgi = '$top_cgi_path/pswd/start.cgi';!gm;
	$data =~ s!^[\x20\x09]*\$register_db[\x20\x09]*=[^\x0A\x0D]*;!\$register_db = '$sub_cgi_data_root/preferences/register';!gm;
	$data =~ s!^[\x20\x09]*\$session_store[\x20\x09]*=[^\x0A\x0D]*;!\$session_store = '$sub_cgi_data_root/data/session_store';!gm;
	$data =~ s/^[\x20\x09]*\$cookie_path[\x20\x09]*=[^\x0A\x0D]*;/\$cookie_path = '$cookie_path';/gm;
} else {
	my $cookie_path = $user_directory || '/';
	$data =~ s!/(preferences|data)!$home_dir/$1!g;
	$data =~ s/^[\x20\x09]*\$cookie_path[\x20\x09]*=[^\x0A\x0D]*;/\$cookie_path = '$cookie_path';/gm;
}
$data =~ s/^[\x20\x09]*\$page_header_path[\x20\x09]*=[^\x0A\x0D]*;/\$page_header_path = '';/gm;
$data =~ s/^[\x20\x09]*\$page_footer_path[\x20\x09]*=[^\x0A\x0D]*;/\$page_footer_path = '';/gm;
$data =~ s!^[\x20\x09]*\$image_lib[\x20\x09]*=[^\x0A\x0D]*;!\$image_lib = '$image_lib';!gm;
$data =~ s!^[\x20\x09]*\$icon_dir[\x20\x09]*=[^\x0A\x0D]*;!\$icon_dir = '$icon_dir';!gm;
$data =~ s!^[\x20\x09]*\$download_window[\x20\x09]*=[^\x0A\x0D]*;!\$download_window = '$download_window';!gm;
$data =~ s!^[\x20\x09]*\$dummy_window[\x20\x09]*=[^\x0A\x0D]*;!\$dummy_window = '$dummy_window';!gm;
$data =~ s!^[\x20\x09]*\$google_maps_api_key[\x20\x09]*=[^\x0A\x0D]*;!\$google_maps_api_key = '$env::google_maps_api_key';!gm if $env::google_maps_api_key;
$data =~ s!^[\x20\x09]*\$google_analytics_uacct[\x20\x09]*=[^\x0A\x0D]*;!\$google_analytics_uacct = '$env::google_analytics_uacct';!gm if $env::google_analytics_uacct;
$data =~ s!^[\x20\x09]*\$amazon_access_key[\x20\x09]*=[^\x0A\x0D]*;!\$amazon_access_key = '$env::amazon_access_key';!gm if $env::amazon_access_key;
$data =~ s!^[\x20\x09]*\$amazon_associates_id[\x20\x09]*=[^\x0A\x0D]*;!\$amazon_associates_id = '$env::amazon_associates_id';!gm if $env::amazon_associates_id;
if ($main::multi_domain) {
	$data =~ s!^[\x20\x09]*\$google_maps_api_key[\x20\x09]*=[^\x0A\x0D]*;!\$google_maps_api_key = '';!gm;
	$data =~ s!^[\x20\x09]*1;!\$multi_domain = '$main::domain';\x0A\x0A1;!gm unless $data =~ s!^[\x20\x09]*\$multi_domain[\x20\x09]*=[^\x0A\x0D]*;!\$multi_domain = '$main::domain';!gm;
} elsif ($multi_domain) {
	my $parent_env_path = $env_path;
	$parent_env_path =~ s!/[^/]+/lib/env.pl$!/lib/env.pl!;
	my $parent_data = $this->read_file($parent_env_path);
	if ($parent_data =~ m!^[\x20\x09]*\$google_maps_api_key[\x20\x09]*=[\x20\x09]*['"]([^'"]+)['"][\x20\x09]*;!m) {
		my $key = $1;
		$data =~ s!^[\x20\x09]*\$google_maps_api_key[\x20\x09]*=[^\x0A\x0D]*;!\$google_maps_api_key = '$key';!gm;
	}
	$data =~ s!^[\x20\x09]*1;!\$multi_domain = '$multi_domain';\x0A\x0A1;!gm unless $data =~ s!^[\x20\x09]*\$multi_domain[\x20\x09]*=[^\x0A\x0D]*;!\$multi_domain = '$multi_domain';!gm;
} elsif ($env::multi_domain) {
	$data =~ s!^[\x20\x09]*1;!\$multi_domain = '$env::multi_domain';\x0A\x0A1;!gm unless $data =~ s!^[\x20\x09]*\$multi_domain[\x20\x09]*=[^\x0A\x0D]*;!\$multi_domain = '$env::multi_domain';!gm;
}
if ($user_site_template) {
	my $user_site_template_dir = $cgi_data_root . $home_dir . '/template/site';
	$data =~ s/^[\x20\x09]*\$user_site_template_dir[\x20\x09]*=[^\x0A\x0D]*;/\$subdirectory_disabled = '$user_site_template_dir';/gm || $data =~ s/^[\x20\x09]*1;$/\$user_site_template_dir = '$user_site_template_dir';\x0A\x0A1;/gm;
}
if ($user_default) {
	my $user_default_dir = $cgi_data_root . $home_dir . '/default';
	$data =~ s/^[\x20\x09]*\$user_default_dir[\x20\x09]*=[^\x0A\x0D]*;/\$subdirectory_disabled = '$user_default_dir';/gm || $data =~ s/^[\x20\x09]*1;$/\$user_default_dir = '$user_default_dir';\x0A\x0A1;/gm;
}
if ($subdirectory_disabled) {
	$data =~ s/^[\x20\x09]*\$subdirectory_disabled[\x20\x09]*=[^\x0A\x0D]*;/\$subdirectory_disabled = 1;/gm || $data =~ s/^[\x20\x09]*1;$/\$subdirectory_disabled = 1;\x0A\x0A1;/gm;
}
if ($env_setting) {
	my $setting = $this->read_file($env_setting);
	if ($setting) {
		while ($setting =~ /([^\x09\x0A\x0D]+)\x09([^\x0A\x0D]*)[\x0A\x0D]*/sg) {
			my($k,$v) = ($1,$2);
			$v = $this->replace_text($v,$conv_table) if $conv_table;
			$v = "'" . $v . "'" if $v !~ /^\-?[0-9\.]+$/;
			$data =~ s!^[\x20\x09]*\$$k[\x20\x09]*=[^\x0A\x0D]*;!\$$k = $v;!gm;
		}
	}
}
$this->write_file($env_path,\$data,1);
}

sub mk_sub_directory ($$$$$$$$$$$$) {
my($this,$dir,$clone,$cgi_data_path,$cgi_data_root,$shared_cgi_data_root,$home_dir,$http_home_dir,$home_dir_id,$home_url,$home_url_encoded,$javascript_dir,$user_directory,$conv_table) = @_;
my(@files,@directories,$file,$default_id);
local(*DIR);
return unless opendir(DIR,$dir);
while ($file = readdir(DIR)) {
	my $path = $dir . '/' . $file;
	if ($clone . '/' . $file eq $default::cgi_data_root || $clone . '/' . $file eq $default::shared_cgi_data_root) {
		next;
	} elsif ($file !~ /^\.\./ && $file ne '.placeholder' && -f $path) {
		push(@files,$file);
	} elsif ($file !~ /^\./ && -d $path) {
		push(@directories,$file);
	}
}
closedir(DIR);
return unless $this->set_dir($clone);
if ($main::multi_domain) {
	$default_id = '_' . $1 if $dir =~ /(\w+)$/;
} else {
	($default_id = $http_home_dir . '/' . $1) =~ tr!/!_! if $http_home_dir && $http_home_dir ne '/' && $dir =~ /(\w+)$/;
}
my $meta_home_dir_id = $home_dir_id;
$meta_home_dir_id =~ s/_/-/g;
my $cgi_data_path_from_top = $cgi_data_path;
$cgi_data_path_from_top =~ s!^\.\./\.\./!!;
my $shared_cgi_data_root_from_top = $shared_cgi_data_root;
$shared_cgi_data_root_from_top =~ s!^\.\./\.\./!!;
foreach $file (@files) {
	if (($file =~ /\.[0-9a-zA-Z_]+$/ && $file ne '.htaccess' && $file !~ /\.(cgi|pl|s?html?|ssi|xml|kml|dat|js|css)$/ && $file ne 'name.txt') || $file =~ /[0-9a-zA-Z_]+\.[0-9a-zA-Z_]+\.[0-9a-zA-Z_]+\.dat$/ || (-s $dir . '/' . $file) > 1000000) {
		$this->file_copy($dir . '/' . $file,$clone . '/' . $file,(($file =~ /\.(cgi|pl)$/) ? $env::cgi_file_mode : $env::file_mode));
		next;
	}
	my $is_xfile = 0;
	my $data = $this->read_file($dir . '/' . $file,1);
	if ($file eq '.htaccess') {
		if ($data =~ /# Gate Keeper - start -/) {
			my $spath = $this->path_conv($clone,'path');
			$data =~ s!(AuthUserFile\s+)/[^\x0A]+(/\.htpasswd)!$1$spath$2!i;
			$data =~ s!(AuthGroupFile\s+)/[^\x0A]+(/\.htgroup)!$1$spath$2!i;
		}
		if ($data =~ /# For Mobile - start -/) {
			my $this_dir = $this->path_change($clone,$ENV{'SCRIPT_NAME'},'abs');
			$this_dir .= '/' if $this_dir !~ m!/$!;
			$data =~ s!\S+/m\.cgi/!${this_dir}m\.cgi/!s;
		}
	} elsif ($file =~ /\.cgi$/) {
		$data =~ s/^use[\x20\x09]+utf8;\x0A?//mg;
		$data =~ s/\->decode\(1,\s*'utf8'/->decode\(1,'euc'/sg;
		$data =~ s/\A#!.*?$/$default::perl_path/m if $default::perl_path;
		$data =~ s/<shared-cgi-data-root>/$shared_cgi_data_root/g;
		$data =~ s/<cgi-data-root>/$cgi_data_root/g;
		$data =~ s/<cgi-data-path>/$cgi_data_path/g;
		$data =~ s/<shared-cgi-data-root-from-top>/$shared_cgi_data_root_from_top/g;
		$data =~ s/<cgi-data-path-from-top>/$cgi_data_path_from_top/g;
	} elsif ($file eq 'default.pl') {
		$data =~ s/^use[\x20\x09]+utf8;\x0A?//mg;
		$data =~ s/<shared-cgi-data-root>/$shared_cgi_data_root/g;
		$data =~ s/<cgi-data-root>/$cgi_data_root/g;
		$data =~ s/<cgi-data-path>/$cgi_data_path/g;
		$data =~ s/<web-home-dir>/$user_directory/g;
		if ($dir =~ m!/gatekeeper$!) {
			$data =~ s/<home-dir>/$user_directory/g;
		} else {
			$data =~ s/<home-dir>/$home_dir/g;
		}
		$data =~ s/<home-dir-id>/$home_dir_id/g;
		$data =~ s/<default-id>/$default_id/g;
		$data =~ s/<cgi-name>/$file/g;
		if ($dir =~ m!/setup$!) {
			$data =~ s/^[\x20\x09]*\$cgi_data_name[\x20\x09]*=[^\x0A\x0D]*;/\$cgi_data_name = '$default::cgi_data_name';/gm;
			$data =~ s/^[\x20\x09]*\$shared_cgi_data_name[\x20\x09]*=[^\x0A\x0D]*;/\$shared_cgi_data_name = '$default::shared_cgi_data_name';/gm;
		}
	} elsif ($file eq 'cmonos.js') {
		$data =~ s!(\.\./\.\./|/)lib/javascript!$javascript_dir!g;
		if (defined $home_dir_id && $home_dir_id ne '') {
			$data =~ s/parent\.main/parent\.${home_dir_id}main/g;
			$data =~ s/parent\.navi/parent\.${home_dir_id}navi/g;
		}
	} elsif (($file =~ /^index\.s?html?$/ || $file eq 'frame.html') && $data =~ /<frameset/) {
		$data =~ s!<meta\s*http-equiv="Content-Type"\s*content="text/html;\s*charset=UTF-8"\s*/?>!<meta http-equiv="Content-Type" content="text/html;charset=EUC-JP" />!sig;
		$data =~ s!<meta\s*charset="UTF-8"\s*/?>!<meta charset="EUC-JP" />!sig;
		if (defined $home_dir_id && $home_dir_id ne '') {
			$data =~ s/ name="main"/ name="${home_dir_id}main"/g;
			$data =~ s/ name="navi"/ name="${home_dir_id}navi"/g;
		}
		$data = $this->replace_text($data,$conv_table) if $conv_table;
	} elsif ($file =~ /\.(s?html?|ssi|xml|kml|dat|css)$/i || ($file =~ /\.js$/i && $dir !~ m!/lib/javascript!)) {
		next if $file =~ /\.js$/;
		if ($file =~ s/^site-navi-euc\.ssi$/site-navi-utf8.ssi/) {
			$data =~ s!<meta\s*http-equiv="Content-Type"\s*content="text/html;\s*charset=EUC-JP"\s*/?>!<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />!sig;
			$data =~ s!<meta\s*charset="EUC-JP"\s*/?>!<meta charset="UTF-8" />!sig;
		} else {
			$data =~ s!<meta\s*http-equiv="Content-Type"\s*content="text/html;\s*charset=UTF-8"\s*/?>!<meta http-equiv="Content-Type" content="text/html;charset=EUC-JP" />!sig;
			$data =~ s!<meta\s*charset="UTF-8"\s*/?>!<meta charset="EUC-JP" />!sig;
			$data =~ s/\@charset "UTF-8";/\@charset "EUC-JP";/sig;
		}
		my $title = $main::title;
		my $description = $main::description;
		my $table = $conv_table;
		my $icon_dir = $this->base_change($env::icon_dir,$clone . '/' . $file);
		my $is_cms = 0;
		$data =~ s/<site-title>/$title/g;
		$data =~ s/<site-description>/$description/g;
		$data =~ s/<icon-dir>/$icon_dir/g;
		$is_cms = 1 if $data =~ s/<user-directory>/$user_directory/gs;
		$data =~ s/<home-dir>/$user_directory/g;
		$is_cms = 1 if $data =~ s/<home-dir-id>/$home_dir_id/g;
		$is_cms = 0 if $data =~ m!<link rel="canonical" href="<home-url>/[/0-9a-zA-Z_]+/start.cgi[^"]*?" />!s;
		$data =~ s/<meta-home-dir-id>/$meta_home_dir_id/g;
		$data =~ s/<home-url>/$home_url/g;
		$data =~ s/<home-url-encoded>/$home_url_encoded/g;
		$is_cms = 0 if $is_cms && $file =~ /^([0-9]+)\./ && (-f $dir . '/' . $1 . '.spch' || $dir . '/' . $1 . '.dat');
		if ($is_cms) {
			if ($file =~ /\.shtml?$/i && !$env::ssi) {
				$file =~ s/\.shtml?$/.html/i;
			} elsif ($file =~ /\.html?$/i && $env::ssi) {
				$file =~ s/\.html?$/.$env::ssi_ext/i;
			}
		}
		$data = $this->replace_text($data,$table) if $table;
		if ($file =~ /^site-navi-(sjis|utf8)\.ssi$/) {
			$this->jcode_convert(\$data,$1,'euc');
		} elsif ($file =~ /\.(?:xml|kml)$/i) {
			$this->jcode_convert(\$data,'utf8','euc');
		}
		$is_xfile = 1 if $file =~ /\.ssi$/;
	}
	$this->write_file($clone . '/' . $file,\$data,1,(($file =~ /\.(cgi|pl)$/) ? $env::cgi_file_mode : $env::file_mode));
	$this->mk_external_javascript($clone . '/' . $file,'','','',$home_url) if $is_xfile;
}
if (@directories) {
	foreach my $directory (@directories) {
		$this->mk_sub_directory($dir . '/' . $directory,$clone . '/' . $directory,$cgi_data_path,$cgi_data_root,$shared_cgi_data_root,$home_dir,$http_home_dir,$home_dir_id,$home_url,$home_url_encoded,$javascript_dir,$user_directory,$conv_table);
	}
}
}

sub targetable_directories ($$$) {
my($this,$dir,$home_dir) = @_;
my(@directories,@sub_directories);
@directories = @sub_directories = ();
local(*DIR);
return unless opendir(DIR,$dir);
$home_dir = '' if !defined $home_dir;
while (my $entry = readdir(DIR)) {
	next if $entry =~ /^\./;
	my $path = $dir . '/' . $entry;
	if (-d $dir . '/' . $entry && -f $dir . '/' . $entry . '/lib/env.pl') {
		my($multi_domain,$subdirectory_disabled,$user_site_template_dir,$user_default_dir) = $this->subdir_options($dir . '/' . $entry . '/lib/env.pl');
		push(@directories,$entry) if $subdirectory_disabled;
	}
}
closedir(DIR);
foreach my $d (@directories) {
	push(@sub_directories,$home_dir . '/' . $d,$this->targetable_directories($dir . '/' . $d,$home_dir . '/' . $d));
}
return @sub_directories;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
#no warnings qw(once);
if (!$env::subdirectory_disabled) {

	#饹Ͽ
	Common::class_register('s500','SubDirInstaller');

	#˥塼Ͽ
	$setting::jump_menu{'s500'} = '֥ǥ쥯ȥ';
}
}



1;
