package SystemUninstaller;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use File::Path;
use strict;
######################################################################
# ƥࡦ󥤥󥹥ȡ ⥸塼
# SystemUninstaller.pm ver1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-03-10
######################################################################
# ¹
sub run ($) {
my $this = shift;
$this->get_setup_env;
my @directories = ();
my @files = ();
push(@directories,$default::cgi_data_root . '/clipboard') if -d $default::cgi_data_root . '/clipboard';
push(@directories,$default::cgi_data_root . '/data') if -d $default::cgi_data_root . '/data';
push(@directories,$default::cgi_data_root . '/default') if -d $default::cgi_data_root . '/default';
push(@directories,$default::cgi_data_root . '/lib') if -d $default::cgi_data_root . '/lib';
push(@directories,$default::cgi_data_root . '/preferences') if -d $default::cgi_data_root . '/preferences';
push(@directories,$default::cgi_data_root . '/template') if -d $default::cgi_data_root . '/template';
push(@directories,$default::cgi_data_root . '/zipcode') if -d $default::cgi_data_root . '/zipcode';
push(@files,$default::cgi_data_root . '/.htaccess') if -f $default::cgi_data_root . '/.htaccess';
if ($default::cgi_data_root ne $default::shared_cgi_data_root) {
	push(@directories,$default::shared_cgi_data_root . '/clipboard') if -d $default::shared_cgi_data_root . '/clipboard';
	push(@directories,$default::shared_cgi_data_root . '/data') if -d $default::shared_cgi_data_root . '/data';
	push(@directories,$default::shared_cgi_data_root . '/default') if -d $default::shared_cgi_data_root . '/default';
	push(@directories,$default::shared_cgi_data_root . '/lib') if -d $default::shared_cgi_data_root . '/lib';
	push(@directories,$default::shared_cgi_data_root . '/preferences') if -d $default::shared_cgi_data_root . '/preferences';
	push(@directories,$default::shared_cgi_data_root . '/template') if -d $default::shared_cgi_data_root . '/template';
	push(@directories,$default::shared_cgi_data_root . '/zipcode') if -d $default::shared_cgi_data_root . '/zipcode';
	push(@files,$default::shared_cgi_data_root . '/.htaccess') if -f $default::shared_cgi_data_root . '/.htaccess';
}
local(*DIR);
if (opendir(DIR,$default::cgi_data_root)) {
	my @subdirectories = grep($_ =~ /^\w+$/ && -d $default::cgi_data_root . '/' . $_ && -f $default::cgi_data_root . '/' . $_ . '/lib/env.pl',readdir(DIR));
	closedir(DIR);
	push(@directories,map {($default::cgi_data_root . '/' . $_, '../../' . $_)} @subdirectories) if @subdirectories;
}

#CGIϢǥ쥯ȥ
push(@directories,'../');
push(@directories,'../../error') if -d '../../error';
push(@directories,$env::icon_dir) if -d $env::icon_dir;
push(@directories,$env::image_dir) if -d $env::image_dir;
push(@directories,'../../lib') if $env::javascript =~ m!^\.\./\.\./lib/! && -d '../../lib';
if (opendir(DIR, '../')) {
	my @cgi = grep($_ !~ /\./ && -d '../' . $_ && -f '../' . $_ . '/default.pl',readdir(DIR));
	closedir(DIR);
	foreach my $cgi (@cgi) {
		if (grep($_ eq $cgi,'accesscounter','accestat','gatekeeper','navimaker','pswd','setup','station','yahoosearch','zipcode') || -d '../' . $cgi . '/files') {
			next;
		} else {
			my $default = $this->read_file('../' . $cgi . '/default.pl',1);
			my $lib = ($default =~ /\$lib\s*=\s*'(\w+)';/s) ? $1 : '';
			if ($lib eq 'HomePageMaker') {
				if ($default =~ /\$home\s*=\s*(.*?);/s) {
					push(@directories,eval($1));
				}
			} elsif ($lib eq 'HomePageMakerLite') {
				my $rel_folder = (-d '../../' . $cgi) ? '../../' . $cgi : '';
				if ($default =~ /\$home\s*=\s*(.*?);/s) {
					my $home = eval($1);
					push(@files,$home) if !$rel_folder || $home !~ /^$rel_folder/;
				}
				if ($default =~ /\$file\s*=\s*(.*?);/s) {
					my $file = eval($1);
					push(@directories,$file) if !$rel_folder || $file !~ /^$rel_folder/;
				}
			}
		}
	}
}
push(@files,'../../.htaccess') if -f '../../.htaccess';
push(@files,'../../index.xml') if -f '../../index.xml';
push(@files,'../../index.kml') if -f '../../index.kml';
push(@files,'../../trackback.xml') if -f '../../trackback.xml';
push(@files,'../../podcast.xml') if -f '../../podcast.xml';
push(@files,'../../comment.xml') if -f '../../comment.xml';
push(@files,'../../m.cgi') if -f '../../m.cgi';

#󥤥󥹥ȡ
if ($this->is_master && $main::uninstall) {
	my $perl_path = $^X;
	my @target_directories = map { $this->base_change($_,'../../uninstaller.cgi','rel',1) } @directories;
	my @target_files = map { $this->base_change($_,'../../uninstaller.cgi','rel',1) } @files;
	my $target_directories_list = "'" . join("','",@target_directories) . "'";
	my $target_files_list = "'" . join("','",@target_files) . "'";
	my $remove = $main::remove || 0;
my $uninstaller = <<CGI;
#!$perl_path -w
use File::Find;
use File::Path;
use strict;
my \$remove = $remove;

my \@directories = ($target_directories_list);
my \@files = ($target_files_list);

foreach my \$path (\@files) {
	chmod(0666,\$path);
	unlink \$path if \$remove;
}
my \$log = '';
foreach my \$path (\@directories) {
	find(sub {
		my \$f = \$File::Find::dir . '/' . \$_;
		if (-f \$_) {
			\$log .= '<li>' . \$f . '</li>' if chmod(0666,\$_);
		} elsif (-d \$_) {
			\$log .= '<li>' . \$f . '</li>' if chmod(0777,\$_);
		}
	},\$path);
	rmtree \$path if \$remove;
}
chmod(0777,\$default::cgi_data_root);
chmod(0777,\$default::shared_cgi_data_root);
my \$msg = (\$remove) ? 'Ϣե򤹤٤ƺޤ' : 'ϢեΥѡߥå䤹Τѹޤ';
print <<MSG;
Content-Type: text/html

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html;charset=EUC-JP" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<title lang="ja">CMONOS.JP 󥤥󥹥ȡ顼</title>
<style type="text/css">
<!--
body, table {
  font: 14px 'Lucida Grande','Hiragino Kaku Gothic Pro','ҥ饮γѥ Pro W3','HiraKakuProN-W3',Verdana,'ᥤꥪ','Meiryo','ͣ Хå','MS PGothic',Osaka,arial,helvetica,sans-serif;
}
body {
  margin: 3em 10%;
  background-color: #FFF;
}
-->
</style>
</head>
<body>
<p>\$msg</p>
<ol>\$log</ol>
</body>
</html>
MSG

unlink './uninstaller.cgi';

CGI
	$this->write_file('../../uninstaller.cgi',$uninstaller,1);
	chmod($env::cgi_file_mode,'../../uninstaller.cgi');
	print 'Location: ' . $this->full_path('../../uninstaller.cgi') . "\n\n";
	return;
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>ƥࡦ󥤥󥹥ȡ</h1>';
if ($this->is_master) {
	print '<p class="warning">ڷٹۤκȤϼäǤޤ</p>';
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'target'	=>	'_top',
		'method'	=>	'post',
		'onsubmit'	=>	'return confirm(\'ϼäޤ CMONOS.JP 򥢥󥤥󥹥ȡ뤷ޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
		'required'	=>	\@setting::form
	);
} else {
	print '<p class="warning">κȤ¹Ԥˤϡ֥ޥѥɡפɬפǤ٥Ȥơ֥ޥѥɡפǥ󤷤Ƥ</p>';
	print '<form action="#">';
}
my $here = $this->get_cwd . '/start.cgi';
print '<input type="hidden" name="uninstall" value="1" />';
print '<fieldset><legend>󥤥󥹥ȡоݤȤʤե뤪ӥǥ쥯ȥ</legend>';
print '<fieldset><legend>ե</legend><ol><li>';
print join('</li><li>',map { $this->path_change($_,$here,'abs') } @files);
print '</li></ol></fieldset>';
print '<fieldset><legend>ǥ쥯ȥʲΤ٤ƤΥե뤪ӥǥ쥯ȥ</legend><ol><li>';
print join('</li><li>',map { $this->path_change($_,$here,'abs') } @directories);
print '</li></ol></fieldset>';
print '</fieldset>';
if ($this->is_master) {
	print '<fieldset><legend></legend><ol class="checkbox">';
	print '<li><label><input type="radio" name="remove" value="0" checked="checked" /> ٤ƤδϢեΥѡߥå FTP Ǻ䤹Τѹ</label></li>';
	print '<li><label><input type="radio" name="remove" value="1" /> ٤ƤδϢե</label></li>';
	print '</ol></fieldset>';
	print '<fieldset class="delete">';
	print '<input type="submit" value="CMONOS.JP 򥢥󥤥󥹥ȡ뤹" />';
	print '</fieldset>';
}
print '</form>';

#ڡեå
$this->print_page_footer('tools');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
if ($env::ownerpower && (!defined $env::home_dir_id || $env::home_dir_id eq '') && !$env::multi_domain) {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('yzzz','SystemUninstaller');

	#˥塼Ͽ
	$setting::jump_menu{'yzzz'} = 'ƥࡦ󥤥󥹥ȡ';
}
}



1;
