package SystemUpdater;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use File::Path;
use Fcntl qw(:DEFAULT :flock);
eval 'use ' . $env::dbm_file . ';';
use strict;
######################################################################
# ƥࡦåץǡ ⥸塼
# SystemUpdater.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-03-02
######################################################################
# ¹
sub run ($) {
my $this = shift;
$this->get_setup_env;

my $download_dir = 'http://cmonos.jp/download/CMONOS_JP_1x';
if ($] >= 5.008001 && $cgi::cmonos_ver >= 20110905) {
	$download_dir = ($default::beta_enabled) ? 'http://cmonos.jp/download/CMONOS_JP_beta' : 'http://cmonos.jp/download/CMONOS_JP_2x';
}

require CMONOS::CGI_Lib::HTTP_Client;
my $res = HTTP_Client->new->request('GET' => $download_dir . '/latest_version.txt');
my $latest_version = ($res->is_success) ? $res->content : 20110214;
$latest_version = 20110214 if !$latest_version || $latest_version =~ /\D/s;
unless (eval 'use Archive::Tar;Archive::Tar->has_zlib_support;') {
	$this->jump_menu('tools');
	$this->print_page_header('tools');
	my $dl_url = $download_dir . (($^X =~ /local/) ? '/CMONOS_JP_local.tgz' : '/CMONOS_JP.tgz');
	print '<h1>ƥࡦåץǡ</h1>';
	if ($latest_version > $cgi::cmonos_ver) {
		print '<p class="warning">꿷С󤬤ߤĤޤ</p>';
	} else {
		print '<p>ȤΥƥϺǿǤǤ</p>';
	}
	print '<p>Archive::Tar ⥸塼뤬ߤĤʤᡢεǽѤǤޤ</p>';
	print '<p><a href="' . $dl_url . '">CMONOS.JP ե륻å</a>פɤƱ HowToUpdate.html ˤäƥåץǡȤƤ</p>';
	$this->print_page_footer('tools');
	return 1;
}
my $temp_dir = $env::clipboard . '/system_updater';
my $status_file = $temp_dir . '/status';
rmtree $temp_dir if -d $temp_dir && -M $temp_dir > 1;
my $status = $this->read_file($status_file,1) || 0;
if ($status) {
	if ($status >= 5 || (stat($status_file))[9] <= time - 900) {
		$main::system_update = 1;
	} else {
		undef $main::system_update;
	}
}

#ѡߥåĴ
if ($main::system_update) {
	my $error;
	if ($status < 2) {
		$this->set_dir($temp_dir);
		$this->write_file($status_file,1,1);
		my $res = HTTP_Client->new->request('GET' => $download_dir . '/CMONOS_JP_Updater.tgz',{},'','','',$temp_dir . '/CMONOS_JP_Updater.tgz');
		if ($res->is_success && -f $temp_dir . '/CMONOS_JP_Updater.tgz') {
			$this->write_file($status_file,2,1);
		} else {
			$error = 1;
			push(@{$this->{'dialog'}},'CMONOS.JP ǿǤΥɤ˼Ԥޤ');
		}
	}
	if (!$error && $status < 3) {
		$this->write_file($status_file,3,1);
		my $tar = Archive::Tar->new();
		$tar->setcwd($temp_dir);
		$tar->read($temp_dir . '/CMONOS_JP_Updater.tgz',1);
		$tar->extract();
		if (-f $temp_dir . '/CMONOS_JP_Updater/Updater_Combo.pm') {
			$this->write_file($status_file,4,1);
		} else {
			$error = 1;
			push(@{$this->{'dialog'}},'CMONOS.JP ǿǤβ˼Ԥޤ');
		}
	}
	if (!$error && $status < 5) {
		#$this->system_chmod(1);
		unless ($this->directory_copy($temp_dir . '/CMONOS_JP_Updater/CMONOS',$default::shared_cgi_data_root . '/lib/CMONOS',1)) {
			push(@{$this->{'dialog'}},'CMONOS.JP 饤֥ι˼Ԥޤ');
			$error = 1;
		}
		unless ($this->directory_copy($temp_dir . '/CMONOS_JP_Updater/lib',$env::template_dir . '/site/default/htdocs/lib',1)) {
			push(@{$this->{'dialog'}},'ǥեȤ JavaScript/CSS 饤֥ι˼Ԥޤ');
			$error = 1;
		}
		$this->system_chmod();
		$this->write_file($status_file,5,1) if !$error;
	}
	if (!$error) {
		$this->write_file($status_file,6,1);
		push(@setting::form,'system_update');
		require $temp_dir . '/CMONOS_JP_Updater/Updater_Combo.pm';
		my $updater = new Common('....');
		if (!$main::ver && %setting::general && $setting::general{'ver'} && $latest_version > $setting::general{'ver'}) {
			$main::ver = $setting::general{'ver'};
			$main::updating = 1;
			$cgi::cmonos_ver = $latest_version;
		}
		$updater->run;
		exit;
	}
	rmtree $temp_dir;
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>ƥࡦåץǡ</h1>';
if ($latest_version > $cgi::cmonos_ver) {
	print '<p class="warning">꿷С󤬤ߤĤޤ</p>';
} else {
	print '<p>ȤΥƥϺǿǤǤ</p>';
}

if ($status) {
	my %status_msg = (
		1	=>	'CMONOS.JP ǿǤɤƤޤ...',
		2	=>	'CMONOS.JP ǿǤΥɤλޤ...',
		3	=>	'CMONOS.JP ǿǤषƤޤ...',
		4	=>	'CMONOS.JP ǿǤβबλޤ...',
		5	=>	'CMONOS.JP 饤֥ե򹹿ޤ...',
		6	=>	'CMONOS.JP ǿǤ˥åץǡȤƤޤ...',
	);
	print '<p>';
	print($status_msg{$status} || 'Error!');
	print '</p>';

#ե೫
} else {
	print '<p class="warning">ƥ򥢥åץǡȤȡ~/cgi-data/template/site/default/htdocs/libפǿΥեǾ񤭤ޤդ</p>';
	print $this->form_start(
		'key'	=>	'tools',
		'name'	=>	'input',
		'method'	=>	'post',
		'onsubmit'	=>	'return confirm(\'ϼäޤ˥ƥ򥢥åץǡȤޤ\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
		'required'	=>	\@setting::form
	);
	print '<input type="hidden" name="system_update" value="1" />';
	print '<fieldset class="delete">';
	print '<input type="submit" value="ǿǤɤƥƥ򥢥åץǡȤ" />';
	print '</fieldset>';
	print '</form>';
}
print '<p><a href="http://cmonos.jp/download/history.html" target="_blank">&raquo;С</a> <a href="http://cmonos.jp/download/CMONOS_JP_manual.zip">&raquo;ޥ˥奢ɤ</a></p>';

#ڡեå
$this->print_page_footer('tools');
}

sub clean_up ($) {
my $this = shift;
rmtree $env::clipboard . '/system_updater';
}

sub system_chmod ($$) {
my($this,$rw) = @_;
local($SystemUpdater::fmod,$SystemUpdater::dmod) = ($rw) ? (0666,0777) : ($env::ownerpower) ? (0600,0700) : ($env::file_mode,$env::dir_mode);

use File::Find;
find(sub {
	if (-f $_) {
		chmod($SystemUpdater::fmod,$_);
	} elsif (-d $_) {
		chmod($SystemUpdater::dmod,$_);
	}
},$default::shared_cgi_data_root . '/lib/CMONOS');
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
if ($env::ownerpower && (!defined $env::home_dir_id || $env::home_dir_id eq '') && !$env::multi_domain) {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('s201','SystemUpdater');

	#˥塼Ͽ
	$setting::jump_menu{'s201'} = 'ƥࡦåץǡ';
}
}



1;
