package CartViewer;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ɽ⥸塼
# CartViewer.pm ver1.0.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-08-25
######################################################################
# ᥤ
sub run ($) {
my $this = shift;
my(%item_data,@item_order,$item_id,$this_icon,$url,$referer_url);
require CMONOS::CGI_Lib::CartController;
$cgi::CartController = CartController->new;
if ($ENV{'HTTP_REFERER'}) {
	my $here = $this->my_url;
	$referer_url = $ENV{'HTTP_REFERER'} if $ENV{'HTTP_REFERER'} !~ /^\Q$here\E/;
}
$referer_url = $cgi::CartController->get_url_of_last_item if !$referer_url;
if ($main::cancel_all) {
	$cgi::CartController->cancel_all;
} elsif (%main::cart) {
	$cgi::CartController->add(\%main::cart,\%item_data,\@item_order);
} elsif (%main::quantity) {
	$cgi::CartController->change(\%main::quantity,\%item_data,\@item_order);
} else {
	$cgi::CartController->check('',\%item_data,\@item_order);
}
if (@item_order) {
	my($json,$item_id);
	foreach $item_id (@item_order) {
		$json .= ",\x0A" if $json;
		$json .= '		{"price":' . (($item_data{$item_id}{'optionprice'}) ? ($item_data{$item_id}{'price'} + $item_data{$item_id}{'optionprice'}) : $item_data{$item_id}{'price'}) . ',"quantity_id":"quantity:' . $item_id . '","price_id":"sc-item-' . $item_id . '-price"}';
	}
	$json = 'cmonos.tool.shoppingcart.data = {"item":[' . "\x0A" . $json . "\x0A";
	$json .= '	],"sc_sub_total_id": "sc-sub-total-value","sc_tax_id": "sc-tax-value","sc_total_id": "sc-total-value","tax_rate": ' . ((defined $env::tax_rate) ? $env::tax_rate : 0.05) . ',"tax_frac":"' . (($env::tax_frac) ? $env::tax_frac : 'ceil') . '"' . "\x0A";
	$json .= '}' . "\x0A";
	$json .= 'cmonos.tool.shoppingcart.ajaxDisabled = true' . "\x0A" if $setting::page{$setting::key}{'ajaxdisabled'};
	$this->set_javascript($json);
} else {
	$this->set_onload('cmonos.tool.shoppingcart.window.sizeCheck(640,480)');
	$this->print_page_header($setting::key);
	print '<p id="sc-empty-notice">Ȥ˲äƤޤ</p>';
	$this->print_close_button($setting::page{$setting::key}{'closeButton'},$setting::page{$setting::key}{'backButton'},$referer_url,1);
	$this->print_page_footer($setting::key);
	return;
}
require CMONOS::CGI_Lib::Deco;
$this_icon = Deco->new(
	$env::image_dir . '/order',
	$env::image_lib . '/order'
);

#ڡإå
$this->set_onload('cmonos.tool.shoppingcart.window.sizeCheck(640,480);');
$this->print_page_header($setting::key);

#ե
print $this->form_start(
	'key'	=>	'checkout',
	'name'	=>	'cart',
	'method'	=> 'post',
	'onsubmit'	=> 'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);

my $dc_only = 1;
if ($setting::key eq 'iframe') {
	my($item_id,$total,$count);
	print '<table id="sc-table-compact">';
	print '<tbody id="sc-item-tbody">';
	foreach $item_id (@item_order) {
		$count++;
		my $price = (($item_data{$item_id}{'optionprice'}) ? ($item_data{$item_id}{'price'} + $item_data{$item_id}{'optionprice'}) : $item_data{$item_id}{'price'});
		print '<tr class="' . (($count % 2) ? 'odd' : 'even') . '" id="sc-item-' . $item_id . '">';
		print '<td>';
		print '<div class="sc-item-name"><a href="' . $this->escape($item_data{$item_id}{'path'} . (($item_data{$item_id}{'anchor'}) ? $item_data{$item_id}{'anchor'} : '')) . '" target="_blank">' . $item_data{$item_id}{'name'} . (($item_data{$item_id}{'key'} && $item_data{$item_id}{'key'} ne $item_data{$item_id}{'name'}) ? '<span class="sc-item-key"> [' . $item_data{$item_id}{'key'} . ']</span>' : '') . '</a>' . (($item_data{$item_id}{'digitalcontent'}) ? '<span class="sc-item-filename"> (' . $this->escape($item_data{$item_id}{'digitalcontent'}) . ')</span>' : '') . '</div>';
		print '<div class="sc-item-option">' . $this->escape($item_data{$item_id}{'option'}) . '</div>' if $item_data{$item_id}{'option'};
		print '<div class="sc-item-info">';
		print '<span class="sc-item-unit-price">&yen;' . $this->digit($price) . '</span>';
		if ($item_data{$item_id}{'digitalcontent'}) {
			$item_data{$item_id}{'quantity'} = 1;
			print '<span class="sc-item-quantity">&times;<input type="hidden" id="quantity:' . $item_id . '" name="quantity:' . $item_id . '" value="1" />1</span>';
		} else {
			print '<span class="sc-item-quantity">&times;<input type="text" size="2" id="quantity:' . $item_id . '" name="quantity:' . $item_id . '" value="' . ((defined $item_data{$item_id}{'quantity'}) ? $item_data{$item_id}{'quantity'} : '') . '" onchange="' . (($setting::page{$setting::key}{'ajaxdisabled'}) ? 'cmonos.tool.shoppingcart.recalculate()' : 'cmonos.tool.shoppingcart.changeItem(\'' . $item_id . '\',this.value)') . '" /></span>';
			$dc_only = 0;
		}
		$price = (($price && $item_data{$item_id}{'quantity'}) ? $price * $item_data{$item_id}{'quantity'} : 0);
		print '=<span class="sc-item-price" id="sc-item-' . $item_id . '-price">&yen;' . $this->digit($price) . '</span>';
		print '<span class="sc-item-tool">';
		print $this_icon->button('trash',$setting::page{$setting::key}{'trashButton'},'#','X','',{'onclick' => 'cmonos.tool.shoppingcart.deleteItem(this,\'' . $item_id . '\')'});
		print '</span>';
		print '</div>';
		print '</td>';
		print '</tr>';
		$total += $price;
	}
	print '</tbody>';
	print '<tbody id="sc-total-tbody">';
	print '<tr>';
	print '<td>';
	print '<div class="sc-tool">';
	print $this_icon->button('empty',$setting::page{$setting::key}{'emptyButton'},'./start.cgi?m=CartViewer&cancel_all=1','Ȥˤ');
	print '</div>';
	if ($env::tax_rate) {
		print '<div id="sc-sub-total">:<span id="sc-sub-total-value">&yen;' . $this->digit($total) . '</span></div>';
		my $tax = ($env::tax_frac && $env::tax_frac eq 'floor') ? int(($total * $env::tax_rate) + 0.999) : ($env::tax_frac && $env::tax_frac eq 'round') ? int(($total * $env::tax_rate) + 0.5) : int($total * $env::tax_rate);
		print '<div id="sc-tax">:<span id="sc-tax-value">&yen;' . $this->digit($tax) . '</span></div>';
		$total += $tax;
	}
	print '<div id="sc-total">' . $this->carriage_and_fee_msg($dc_only) . ':<span id="sc-total-value">&yen;' . $this->digit($total) . '</span></div>';
	print '</td>';
	print '</tr>';
	print '</tbody>';
	print '</table>';
} else {
	my($item_id,$total,$count);
	print '<table id="sc-table">';
	print '<thead>';
	print '<tr class="odd">';
	print '<th class="sc-item-name">̾</th>';
	print '<th class="sc-item-option">ץ</th>';
	print '<th class="sc-item-unit-price">ñ</th>';
	print '<th class="sc-item-quantity"></th>';
	print '<th class="sc-item-price"></th>';
	print '<th class="sc-item-tool"></th>';
	print '</tr>';
	print '</thead>';
	print '<tbody id="sc-item-tbody">';
	foreach $item_id (@item_order) {
		$count++;
		my $price = (($item_data{$item_id}{'optionprice'}) ? ($item_data{$item_id}{'price'} + $item_data{$item_id}{'optionprice'}) : $item_data{$item_id}{'price'});
		$url = $item_data{$item_id}{'path'} . (($item_data{$item_id}{'anchor'}) ? $item_data{$item_id}{'anchor'} : '');
		print '<tr class="' . (($count % 2) ? 'odd' : 'even') . '" id="sc-item-' . $item_id . '">';
		print '<td class="sc-item-name"><a href="' . $this->escape($url) . '" target="_blank">' . $item_data{$item_id}{'name'} . (($item_data{$item_id}{'key'} && $item_data{$item_id}{'key'} ne $item_data{$item_id}{'name'}) ? '<span class="sc-item-key"> [' . $item_data{$item_id}{'key'} . ']</span>' : '') . '</a>' . (($item_data{$item_id}{'digitalcontent'}) ? '<span class="sc-item-filename"> (' . $this->escape($item_data{$item_id}{'digitalcontent'}) . ')</span>' : '') . '</td>';
		print '<td class="sc-item-option">' . $this->escape($item_data{$item_id}{'option'}) . '</td>';
		print '<td class="sc-item-unit-price">&yen;' . $this->digit($price) . '</td>';
		if ($item_data{$item_id}{'digitalcontent'}) {
			$item_data{$item_id}{'quantity'} = 1;
			print '<td class="sc-item-quantity"><input type="hidden" id="quantity:' . $item_id . '" name="quantity:' . $item_id . '" value="1" />1</td>';
		} else {
			print '<td class="sc-item-quantity"><input type="text" size="2" id="quantity:' . $item_id . '" name="quantity:' . $item_id . '" value="' . ((defined $item_data{$item_id}{'quantity'}) ? $item_data{$item_id}{'quantity'} : '') . '" onchange="' . (($setting::page{$setting::key}{'ajaxdisabled'}) ? 'cmonos.tool.shoppingcart.recalculate()' : 'cmonos.tool.shoppingcart.changeItem(\'' . $item_id . '\',this.value)') . '" /></td>';
			$dc_only = 0;
		}
		$price = (($price && $item_data{$item_id}{'quantity'}) ? $price * $item_data{$item_id}{'quantity'} : 0);
		print '<td class="sc-item-price" id="sc-item-' . $item_id . '-price">&yen;' . $this->digit($price) . '</td>';
		print '<td class="sc-item-tool">';
		print $this_icon->button('trash',$setting::page{$setting::key}{'trashButton'},'#','X','',{'onclick' => 'cmonos.tool.shoppingcart.deleteItem(this,\'' . $item_id . '\')'});
		print '</td>';
		print '</tr>';
		$total += $price;
	}
	print '</tbody>';
	print '<tbody id="sc-total-tbody">';
	if ($env::tax_rate) {
		print '<tr id="sc-sub-total" class="sc-total-start">';
		print '<td class="sc-name" colspan="4"></td>';
		print '<td class="sc-value" id="sc-sub-total-value">&yen;' . $this->digit($total) . '</td>';
		print '<td class="sc-tool empty"></td>';
		print '</tr>';
		my $tax = ($env::tax_frac && $env::tax_frac eq 'floor') ? int(($total * $env::tax_rate) + 0.999) : ($env::tax_frac && $env::tax_frac eq 'round') ? int(($total * $env::tax_rate) + 0.5) : int($total * $env::tax_rate);
		print '<tr id="sc-tax">';
		print '<td class="sc-name" colspan="4"></td>';
		print '<td class="sc-value" id="sc-tax-value">&yen;' . $this->digit($tax) . '</td>';
		print '<td class="sc-tool empty"></td>';
		print '</tr>';
		$total += $tax;
		print '<tr id="sc-total">';
	} else {
		print '<tr id="sc-total" class="sc-total-start">';
	}
	print '<td class="sc-name" colspan="4">' . $this->carriage_and_fee_msg($dc_only) . '</td>';
	print '<td class="sc-value" id="sc-total-value">&yen;' . $this->digit($total) . '</td>';
	print '<td class="sc-tool">';
	print $this_icon->button('empty',$setting::page{$setting::key}{'emptyButton'},'./start.cgi?m=CartViewer&cancel_all=1&iframe_disabled=1','Ȥˤ');
	print '</td>';
	print '</tr>';
	print '</tbody>';
	print '</table>';
}
print '<div id="sc-update-box">';
if (!$dc_only) {
	print '<div id="sc-update-sub-total">';
	print $this_icon->submit_button('sum',$setting::page{$setting::key}{'sumButton'},'Ʒ׻','',{'m'=>'CartViewer'});
	print '</div>';
}
print '<div id="sc-proceed-to-checkout">';
print $this_icon->submit_button('checkout',$setting::page{$setting::key}{'checkoutButton'},'쥸˿ʤ',{'onclick' => 'return cmonos.tool.shoppingcart.setTarget(this.form)'},{'m'=>'CheckOut'});
print '</div>';
$this->print_close_button($setting::page{$setting::key}{'closeButton'},$setting::page{$setting::key}{'backButton'},($referer_url || $url));
print '</div>';
print '</form>';

#ڡեå
$this->print_page_footer($setting::key);
}

sub carriage_and_fee_msg ($$) {
my($this,$dc_only) = @_;
my %payment_terms = ();
$this->import_db($default::preference_dir . '/terms',\%payment_terms,1);
my $carriage = (($payment_terms{'carriage'} && $payment_terms{'carriage'} eq 'disabled') || $dc_only) ? 0 : 1;
my $fee = (!$payment_terms{'otherenabled'} && (!$payment_terms{'codenabled'} || $dc_only)) ? 0 : 1;
return (($carriage || $fee) ? '(<a href="' . $default::file . '/payment_info.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html') . '" target="_blank">' . (($carriage && $fee) ? '' : ($fee) ? '' : '') . '</a>)' : '');
}

# ɥĤ
sub print_close_button ($;$$$) {
my($this,$close_image,$return_image,$url,$normal) = @_;
$this->use_deco();
print(($normal) ? '<div id="close-button">' : '<div id="sc-cartviewer-close-button">');
print '<script type="text/javascript" language="JavaScript">' . "\x0A";
print 'if (window.opener) {' . "\x0A";
print '	document.write(\'' . $cgi::Deco->button('close',$close_image,'#',(($default::english) ? 'Close.' : 'Ĥ'),'',{'onclick' => 'window.close()'}) . '\');' . "\x0A";
print '} else if (parent.document.getElementById(\'shoppingcart\')) {' . "\x0A";
print '	document.write(\'' . $cgi::Deco->button('close',$close_image,'#',(($default::english) ? 'Close.' : 'Ĥ'),'',{'onclick' => 'cmonos.tool.shoppingcart.window.close()'}) . '\');' . "\x0A";
print '} else {' . "\x0A";
if ($url) {
	print '	document.write(\'' . $cgi::Deco->button('return',$return_image,$url,(($default::english) ? 'Return.' : '')) . '\');' . "\x0A";
} else {
	print '	document.write(\'' . $cgi::Deco->button('return',$return_image,'#',(($default::english) ? 'Return.' : ''),'',{'onclick' => 'history.back();return false;'}) . '\');' . "\x0A";
}
print '}' . "\x0A";
print '//-->' . "\x0A";
print '</script>' . "\x0A";
print '<noscript><a href="' . $this->escape($url) . '">' . (($default::english) ? 'Return.' : '') . '</a></noscript>' . "\x0A" if $url;
print '</div>';
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
if ($default::type && $default::type eq 'order') {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;					#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 1;					#ơ֥ɤ߹
	$setting::page = 1;						#ڡɤ߹

	$setting::field_db_name = '';			#եDB
	$setting::field = 0;					#եɤ߹ߡ2=ꥸʥɤ߹

	#省
	$setting::security_key = 'checkout' if !defined $setting::security_key || !$setting::security_key;	#ǥեȥƥ

	#å
	$cookie::id_enabled = 1;						#ID󥯥åɤ߹

	#ɬܥե
	@setting::form = ('iframe_disabled');

	#᡼CSS
	$setting::image_css = 'order-image.css';

	#省
	$setting::key = ($env::checkout_window_type && $env::checkout_window_type eq 'iframe' && !$main::iframe_disabled) ? 'iframe' : 'cartviewer';		#ڡꥭ

	#ǥեȥ
	$main::k = 'cartviewer' if !defined $main::k || !$main::k;

	#饹Ͽ
	Common::class_register('cartviewer','CartViewer');
}
}

1;
