package DetailViewer;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
######################################################################
# ܺ٥ӥ塼⥸塼
# DetailViewer.pm ver1.1.13
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-05-31
######################################################################
# ᥤ
sub run ($) {
my $this = shift;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';


#---------------------------------------------------------------------
#쥯
if (defined $main::record_id && $main::record_id) {
	$main::c = int($main::record_id / 1000000);
	$main::n = $main::record_id - ($main::c * 1000000);
}
@main::c = (@main::ct) ? @main::ct : ($main::c);#üեѤξ狼鸵ξ

$this->replace_category_list;

#---------------------------------------------------------------------
#׵å
if ($this->is_nan($main::c) || $this->is_nan($main::n) || !-d "$default::db/$main::c") {
	$this->print_dialog($setting::key,'<form action="./start.cgi"><input type="hidden" name="m" value="DetailViewer" /><input type="text" size="8" name="record_id" value="' . $this->escape($main::record_id) . '" /><input type="submit" value="³" /></form>');
}
my(%mtime,$last_modified);
tie(%mtime, $env::dbm_file, "$default::db/$main::c/mtime", O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %mtime) {
	$last_modified = $mtime{$main::n} if defined $mtime{$main::n} && $mtime{$main::n};
}
untie %mtime;
if (!$last_modified) {
	$this->print_dialog($setting::key,'<form action="./start.cgi"><input type="hidden" name="m" value="DetailViewer" /><input type="text" size="8" name="record_id" value="' . $this->escape($main::record_id) . '" /><input type="submit" value="³" /></form>');
}
undef %mtime;

#եǼǥ쥯ȥ
my $path = "$default::file/$main::c/$main::n";

#---------------------------------------------------------------------
#ξ֤뤿ν
my($archives_dir);
if ($main::ver) {
	$main::ver =~ s/\D//g;
	if (!$main::ver || !-d "$default::file/$main::c/$main::n/archives.pending/$main::ver") {
		undef $main::ver;
	} else {
		$archives_dir = "$default::file/$main::c/$main::n/archives.pending/$main::ver";
		my $ip = $this->to_host($ENV{'REMOTE_ADDR'});
		$this->write_file(
			$archives_dir . '/.htaccess',
			'Satisfy all' . "\x0A"
				. 'order deny,allow' . "\x0A"
				. 'deny from all' . "\x0A"
				. 'allow from ' . $ip . "\x0A",
			1
		);
	}
}

#---------------------------------------------------------------------
#å
if ($main::ver) {
	if (!$this->is_secure('rewind')) {
		$this->print_password_check_form($setting::key);
		return;
	}
} elsif (defined $setting::security{'detail'}{'passwordCheck'} && $setting::security{'detail'}{'passwordCheck'} eq 'member' && !$this->is_one_of_owners) {
	my(@mail);
	if (ref $field::for{'mail_address'} && @{$field::for{'mail_address'}}) {
		foreach my $id (@{$field::for{'mail_address'}}) {
			my(%db);
			tie(%db, $env::dbm_file, $default::db . '/' . $main::c . '/' . $field::obj{$id}->db, O_RDONLY, $env::dbm_mode);
			if (ref tied %db) {
				push(@mail,$db{$main::n});
			}
			untie(%db);
		}
	}
	@mail = $this->get_address(@mail);
	if (!$this->is_authorized(@mail)) {
		$this->print_password_check_form($setting::key);
		return;
	}
}
if ($field::for{'pending'}) {
	my(%pending,%mtime,%general,$is_pending,$is_expired);
	tie(%pending, $env::dbm_file, "$default::db/$main::c/pending", O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %pending) {
		my($was_pending,$start,$end) = (defined $pending{$main::n}) ? split(/-/,$pending{$main::n}) : (0,0,0);
		if (!$start && !$end) {
			$is_pending = $was_pending;
		} else {
			$was_pending = 0 if !$was_pending;
			my $time = time;
			$is_pending = ((!$start || $start < $time) && (!$end || $time < $end)) ? 0 : 1;
			if ($was_pending ne $is_pending) {
				my(%category,%expire);
				tie(%category, $env::dbm_file, $default::preference_dir . '/category', O_RDWR | O_CREAT, $env::dbm_mode);
				if (ref tied %category) {
					if ($is_pending) {
						$category{$main::c . '_count'}--;
					} else {
						$category{$main::c . '_count'}++;
					}
				}
				untie %category;
				if ($end && $field::obj{$field::for{'pending'}}->{'margin'} && $time > $end) {
					if ($field::obj{$field::for{'pending'}}->{'margin'} == 1) {
						$is_expired = 1;
					} else {
						tie(%expire, $env::dbm_file, "$default::db/$main::c/expire", O_RDWR | O_CREAT, $env::dbm_mode);
						if (ref tied %expire) {
							$expire{$main::n} = $time + $field::obj{$field::for{'pending'}}->{'margin'};
							$pending{$main::n} = $is_pending . '-' . $start . '-' . $end . '-' . $expire{$main::n};
						}
						untie %expire;
					}
				} else {
					$pending{$main::n} = $is_pending . '-' . $start . '-' . $end;
				}
				if (!$is_expired && ($is_pending || $field::obj{$field::for{'pending'}}->{'mTime'})) {
					$this->rss_refresh($main::c,$main::n,$is_pending);
					if ($field::obj{$field::for{'pending'}}->{'mTime'}) {
						tie(%mtime, $env::dbm_file, "$default::db/$main::c/mtime", O_RDWR | O_CREAT, $env::dbm_mode);
						if (ref tied %mtime) {
							$mtime{$main::n} = $time;
						}
						untie %mtime;
						tie(%general, $env::dbm_file, $default::preference_dir . '/general', O_RDWR | O_CREAT, $env::dbm_mode);
						if (ref tied %general) {
							$general{'mtime'} = $time;
						}
						untie %general;
					}
					$setting::general{'mtime'} = $time;
				}
				$field::obj{$field::for{'pending'}}->pending_notice($field::obj{$field::for{'pending'}}->_pending_status($is_pending,$start,$end,0,1,1),$main::c,$main::n);
			}
		}
	}
	untie %pending;
	undef %pending;
	if ($is_expired) {
		$this->delete_all_data("$default::db/$main::c",$main::n);
		use File::Path;
		rmtree "$default::file/$main::c/$main::n";
		$this->index_sweeper($main::c,$main::n);
		$this->print_dialog($setting::key,'<p>ꤵ줿쥳ɤ¸ߤޤ</p>');
	} elsif (!$main::ver && $is_pending && !$this->is_secure('pending')) {
		$this->print_password_check_form($setting::key);
		return;
	}
}

#---------------------------------------------------------------------
#󥯸
if (!defined $cgi::path || $cgi::path eq '') {
	$cgi::path = $ENV{'SCRIPT_NAME'};
	$cgi::path = $env::cgi_server . $cgi::path if defined $env::cgi_server && $env::cgi_server;
}
my $referer_url = '';
if ($main::mod) {
	$referer_url = $cgi::path . '?m=' . $main::mod;
	if (@main::ct) {
		$referer_url .= '&c=' . $_ foreach @main::ct;
	} else {
		$referer_url .= '&c=' . $main::c;
	}
	$referer_url .= '&n=' . $main::n . $this->set_query('url+',['dn','s','w','f','u','uni','and','search','q','fv']);
} elsif ($ENV{'HTTP_REFERER'} && $ENV{'HTTP_REFERER'} =~ /\Q$cgi::path\E\?/) {
	$referer_url = $ENV{'HTTP_REFERER'};
}


#---------------------------------------------------------------------
#üեɽ
if (!$main::ver && defined $main::id && $main::id ne '' && ref $field::obj{$main::id} && $field::obj{$main::id}->update_enabled && $field::obj{$main::id}->is_secure_user_for_update && $field::obj{$main::id}->update) {
	$this->set_onload('cmonos.window.refreshOpener(\'' . (($main::mod) ? $this->escape($referer_url) : '') . '\',false)');
}


#---------------------------------------------------------------------
#쥳Ƚ
my($header_neighbor_link,$footer_neighbor_link) = ('','');
if ($setting::page{$setting::key}{'headerNeighborLink'} || $setting::page{$setting::key}{'footerNeighborLink'}) {
	my($prev_record,$next_record) = $this->get_neighbor_record;
	if ($prev_record || $next_record) {
		$header_neighbor_link = $this->get_neighbor_link($prev_record,$next_record) if defined $setting::page{$setting::key}{'headerNeighborLink'} && $setting::page{$setting::key}{'headerNeighborLink'};
		$footer_neighbor_link = $this->get_neighbor_link($prev_record,$next_record,$referer_url) if defined $setting::page{$setting::key}{'footerNeighborLink'} && $setting::page{$setting::key}{'footerNeighborLink'};
	}
}


#---------------------------------------------------------------------
#񤭽Ф
my($have_template,$this_template,%temp);

#ƥץ졼
if (defined $setting::page{$setting::key}{'template'} && $setting::page{$setting::key}{'template'} ne '') {
	require CMONOS::CGI_Lib::Template;
	$this_template = Template->new;
	$this_template->set(
		'field_style_disabled' => $setting::field_style_disabled,
		'field_tag_enabled' => $setting::field_tag_enabled
	);
	$have_template = 1;
	$have_template++ if $setting::page{$setting::key}{'template'} =~ /<body(?!\w)[^>]*>/i;
	$this_template->template_parser(\$setting::page{$setting::key}{'template'});
}

#ȥ
my $title_id;
if ($field::for{'title'} || $field::for{'key'} || $field::for{'name'}) {
	$title_id = ($field::for{'title'}) ? $field::for{'title'} : ($field::for{'key'}) ? $field::for{'key'} : $field::for{'name'};
	my $title = $field::obj{$title_id}->format_for_text($this->get_content($title_id,$path,$archives_dir,1));
	$this->push_window_title($title) if defined $title && $title ne '';
}

#ڡإå
my $info = '';
if ($main::ver) {
	my($ip,$ua,$email,$name) = split(/\x0A/,$this->read_file($archives_dir . '/data/author',1));
	if ($email) {
		my $user = $cgi::Register->email_to_name($main::pswd,$email,$this->is_secure('tools')) ;
		$name = $user if $user;
	}
	my $datetime = $this->date($main::ver,3,'c24');
	$info = '<div id="cms-rollback-infomation">';
	$info .= '<strong>' . $datetime . 'ǡ</strong>';
	if ($this->is_secure('tools')) {
		$info .= ' by'; 
		$info .= ' ' . $this->escape($name) if $name; 
		$info .= ' &lt;<a href="mailto:' . $email . '" title="' . $email . '">' . $email . '</a>&gt;' if $email;
		$info .= ' [' . $ip . ']' if $ip;
	}
	$info .= '</div>';
}
$this->set_favorites_control_js;
if (!$have_template || $have_template < 2) {
	$this->set_canonical($this->my_url . '?m=DetailViewer&c=' . $main::c . '&n=' . $main::n);
	$this->print_page_header($setting::key);
	if ($info) {
		print $info;
	} elsif ($this->is_secure('revise')) {
		print $this->get_rev_buttons($main::c,$main::n,($main::c * 1000000 + $main::n),'detailedit','detaildelete',$setting::key);
	}
} else {
	if ($this->{'JavaScript'}) {
		my $js = $this->javascript($this->{'JavaScript'},(($env::doctype && $env::doctype =~ /XHTML/) ? 1 : 0));
		$setting::page{$setting::key}{'template'} =~ s/(<\/head>)/$js$1/si;
	}
	if ($this->is_secure('revise')) {
		if ($info) {
			$setting::page{$setting::key}{'template'} =~ s/(<body(?!\w)[^>]*>)/$1$info/si;
		} else {
			my $buttons = $this->get_rev_buttons($main::c,$main::n,($main::c * 1000000 + $main::n),'detailedit','detaildelete',$setting::key);
			$setting::page{$setting::key}{'template'} =~ s/(<body(?!\w)[^>]*>)/$1$buttons/si;
		}
	}
}
print $header_neighbor_link;
my($table_field,$top_field) = ('','');
if (!defined $have_template || !$have_template) {

	#Ĵ

	#ܥե졼Ĵ
	if ($setting::page{$setting::key}{'fieldFrame'} && ref $frame::obj{'frame'}{$setting::page{$setting::key}{'fieldFrame'}}) {
		my @frame_setting = (
			'framewidth' => $setting::page{$setting::key}{'fieldWidth'},
			'fixed' => 'no',
			'frameclass' => 'item-body'
		);
		push(@frame_setting,'contentsalign',$setting::page{$setting::key}{'boxAlign'}) if defined $setting::page{$setting::key}{'boxAlign'} && $setting::page{$setting::key}{'boxAlign'};
		push(@frame_setting,'contentsvalign',$setting::page{$setting::key}{'boxValign'}) if defined $setting::page{$setting::key}{'boxValign'} && $setting::page{$setting::key}{'boxValign'};
		$frame::obj{'frame'}{$setting::page{$setting::key}{'fieldFrame'}}->set_direct(@frame_setting);
	}

	#̾ե졼Ĵ
	if (defined $setting::page{$setting::key}{'fieldTitleOption'} && $setting::page{$setting::key}{'fieldTitleOption'}) {
		if ($setting::page{$setting::key}{'fieldFrame'} && ref $frame::obj{'frame'}{$setting::page{$setting::key}{'fieldFrame'}}) {
			$frame::obj{'frame'}{$setting::page{$setting::key}{'fieldFrame'}}->{'type'} = 'frame';
		}
	} elsif ($setting::page{$setting::key}{'fieldTitleFrame'} && ref $frame::obj{'frame'}{$setting::page{$setting::key}{'fieldTitleFrame'}}) {
		$frame::obj{'frame'}{$setting::page{$setting::key}{'fieldTitleFrame'}}->set_direct('framewidth',$setting::page{$setting::key}{'fieldTitleWidth'},'frameclass','item-titlebar');
	}

	#ȥå׹
	if (defined $field::for{'top'} && $field::for{'top'} ne '' && 
			ref $field::obj{$field::for{'top'}} && 
			$field::obj{$field::for{'top'}}->format_for_detail_enabled &&
			!$field::obj{$field::for{'top'}}->{'Hidden'} && 
			($field::obj{$field::for{'top'}}->{'Open'} || $this->is_secure('secret'))
		) {
		my $contents = $this->get_content($field::for{'top'},$path,$archives_dir);
		$top_field .= ($field::for{'top'} eq $title_id) ? '<h1 id="top-item">' . $contents . '</h1>' : '<div id="top-item" class="section"><div class="body">' . $contents . '</div></div>' if defined $contents && $contents ne '';
	}

	# ɽ
	my($table,$table_check,$name);
	if (defined $setting::page{$setting::key}{'table'} && $setting::page{$setting::key}{'table'} ne '' && ref $table::obj{$setting::page{$setting::key}{'table'}}) {
		$table = $table::obj{$setting::page{$setting::key}{'table'}};
		$table_field = $table->table;
	} else {
		$table_field = '<table class="field-table"><tbody>';
	}
	foreach (sort {$a <=> $b} keys %field::ORDER) {
		my($id,$title,$contents);
		$id = $field::ORDER{$_};

		#ȥå׹ܤ򥹥å
		next if $id eq $field::for{'top'};

		#ơ֥ܰʳ򥹥å/ʹܤ򥹥å
		next unless ref $field::obj{$id} && $field::obj{$id}->{'detailTable'} && !$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret')) && $field::obj{$id}->format_for_detail_enabled;

		$contents = $this->get_content($id,$path,$archives_dir);
		next if !defined $contents || $contents eq '';

		#ȥС
		if ($setting::page{$setting::key}{'fieldTitleOption'} && (!defined $name || $name eq '') && ($id eq $field::for{'title'} || $id eq $field::for{'key'} || $id eq $field::for{'name'}) && $contents =~ /\S/ && $contents ne '&nbsp;') {
			$name = '<h2 class="item-title">' . $contents . '</h2>';
			next;
		}
	
		#ɽ
		$title = $field::obj{$id}->name;
		if (ref $table) {
			$table_field .= $table->tr;
			$table_field .= $table->td($title);
			$table_field .= $table->td($contents);
			$table_field .= $table->_tr;
		} else {
			$table_field .= '<tr><td class="field-name"><span class="datatitle">' . $title . '</span></td>';
			$table_field .= '<td class="field">' . $contents . '</td></tr>';
		}
		$table_check = 1;
	}
	if ($table_check) {
		$table_field .= (ref $table) ? $table->_table : '</tbody></table>';
	} else {
		$table_field = '';
	}
	$table_field = ($setting::page{$setting::key}{'fieldFrame'}) ? $this->get_frame($setting::page{$setting::key}{'fieldFrame'},$table_field,$name,'no','section','item-table') : '<div id="item-table" class="section">' . ((defined $name) ? $name : '') . '<div class="body">' . $table_field . '</div></div>' if defined $table_field && $table_field ne '';
	$table_field = $top_field . $table_field;

	#ɽ
	print $table_field if !defined $setting::page{$setting::key}{'tableValign'} || $setting::page{$setting::key}{'tableValign'} ne 'bottom';
}

#񤭽Ф
foreach (sort {$a <=> $b} keys %field::ORDER) {
	my($id,$title,$contents);
	$id = $field::ORDER{$_};

	if (!$have_template) {

		#ȥå׹ܤ򥹥å
		next if $id eq $field::for{'top'};

		#ơ֥ܤ򥹥å/ʹܤ򥹥å
		next unless ref $field::obj{$id} && !$field::obj{$id}->{'detailTable'} && !$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret')) && $field::obj{$id}->format_for_detail_enabled;

	}

	if (defined $have_template && $have_template) {
		$temp{$id} = $this->get_content($id,$path,$archives_dir,1);

	} else {
		my($name,$title,$contents);

		#ƥĤ򥹥å
		$contents = $this->get_content($id,$path,$archives_dir);
		next if $contents !~ /\S/ || $contents eq '&nbsp;';
		print '<div class="section" id="item-' . $id . '">';

		#̾
		$name = $field::obj{$id}->name;
		if (defined $name && $name ne '' && $name ne '&nbsp;' && $name =~ /\S/) {
			$name = '<h2 class="item-title">' . $name . '</h2>';
			if (defined $setting::page{$setting::key}{'fieldTitleOption'} && $setting::page{$setting::key}{'fieldTitleOption'}) {
				$title = $name;
			} else {
				print(($setting::page{$setting::key}{'fieldTitleFrame'}) ? $this->get_frame($setting::page{$setting::key}{'fieldTitleFrame'},$name,'','no','item-titlebar') : $name);
			}
		}

		#
		print(($setting::page{$setting::key}{'fieldFrame'}) ? $this->get_frame($setting::page{$setting::key}{'fieldFrame'},$contents,$title,'no','item-body') : ((defined $title) ? $title : '') . '<div class="body">' . $contents . '</div>');
		print '</div>';
	}
}

#ƥץ졼Ȥˤäƽ
if (defined $have_template && $have_template) {
	print $this_template->replace(
		$this->page_item_replace(
			$this_template->deco($setting::page{$setting::key}{'template'}),
			0,
			'',
			$setting::page{$setting::key}{'title'}
		),
		\%temp,
		'detail',
		(($main::ver) ? $archives_dir : $path),
		$main::c,
		$main::n
	);

#ɽ
} elsif (defined $setting::page{$setting::key}{'tableValign'} && $setting::page{$setting::key}{'tableValign'} eq 'bottom') {
	print $table_field;
}

print (($footer_neighbor_link) ? $footer_neighbor_link : $this->back_button($referer_url,'<div id="close-button" class="panel">','</div>'));

#ڡեå
$this->print_page_footer($setting::key) if !defined $have_template || $have_template < 2;

}

sub has_to_satisfy_queries ($) {
my $this = shift;
if ($field::for{'coordinates'} && ref $main::search{$field::for{'coordinates'}} && $main::search{$field::for{'coordinates'}}{'sw'} && $main::search{$field::for{'coordinates'}}{'ne'}) {
	return ($field::for{'coordinates'});
} else {
	return ();
}
}

sub get_data ($$$) {
my($this,$id,$path) = @_;
my $db = $field::obj{$id}->db;
my $data = '';
if ($main::ver) {
	$data = $this->read_file($path . '/data/' . $db,1);
} else {
	my(%db);
	tie(%db, $env::dbm_file, "$default::db/$main::c/$db", O_RDONLY, $env::dbm_mode) if defined $db && $db ne '';
	$data = $db{$main::n};
	untie(%db) if defined $db && $db ne '';
}
return $data;
}

sub get_content ($$$;$$) {
my($this,$id,$path,$archives_dir,$raw) = @_;
my $db = $field::obj{$id}->db;
my $data = '';
if ($main::ver && -f $archives_dir . '/data/' . $db) {
	$data = $this->read_file($archives_dir . '/data/' . $db,1);
	return $field::obj{$id}->format_for_detail($data,$archives_dir,$main::c,$main::n) if !$raw;
} else {
	my(%db);
	tie(%db, $env::dbm_file, "$default::db/$main::c/$db", O_RDONLY, $env::dbm_mode) if defined $db && $db ne '';
	$data = $db{$main::n};
	untie(%db) if defined $db && $db ne '';
	return $field::obj{$id}->format_for_detail($data,$path,$main::c,$main::n) if !$raw;
}
return $data;
}

######################################################################
# 嵭
sub get_neighbor_record ($) {
#no warnings qw(numeric);
my $this = shift;
my($next_record,$prev_record,$this_no,$is_checked);
push(@main::ct,$main::c) if !@main::ct && $main::c;
$this_no = $main::c * 1000000 + $main::n;

#---------------------------------------------------------------------
#
$this->sort_and_search($this_no);


#---------------------------------------------------------------------
#嵭Ƚ
$main::w = $field::SORTORDER if !$main::w && $field::SORTORDER;
$main::w = 'ascend' if !$main::w;

foreach my $no (
	sort {
		$this->sort_by(\$this->{'match'}{$b},\$this->{'match'}{$a}) || 
		$this->sort_by(\$this->{'sort'}{$a},\$this->{'sort'}{$b},$main::w) || 
		$a <=> $b || $a cmp $b
	} keys %{$this->{'sort'}}
) {
	if (defined $is_checked && $is_checked) {
		$next_record = $no;
		last;
	} elsif ($this_no == $no) {
		$is_checked = 1;
	} else {
		$prev_record = $no;
	}
}

#DBM³
$this->untie_all_dbm;

return ($prev_record,$next_record);
}

sub get_neighbor_link ($$$;$) {
my($this,$prev,$next,$referer_url) = @_;
my($page_navi,$form_enabled);
if ($setting::general{'postMethod'}) {
	$page_navi = $this->form_start(
		'key'	=>	$setting::security_key,
		'name'	=>	'jump'.((defined $referer_url) ? '2' : '1'),
		'required'	=>	['mod','dn','ct','s','w','f','u','uni','and','search','q','fv']
	);
	$form_enabled = 1;
} else {
	$form_enabled = 0;
	$this->use_deco;
}
$page_navi .= '<ul class="pager">';
$page_navi .= '<li class="prev">' . $this->get_link_button('prev',$prev) . '</li>' if $prev;
$page_navi .= $this->back_button($referer_url,'<li class="button">','</li>');
$page_navi .= '<li class="next">' . $this->get_link_button('next',$next) . '</li>' if $next;
$page_navi .= '</ul>';
$page_navi .= '</form>' if $form_enabled;
return $page_navi;
}

sub back_button ($$$$) {
my($this,$referer_url,$header,$footer) = @_;
if (defined $referer_url) {
	if ($setting::page{$setting::key}{'closeButtonDisabled'} && $referer_url) {
		return $header . $cgi::Deco->button('return',$setting::page{'backButton'},$referer_url,(($default::english) ? 'Return.' : '')) . $footer;
	} elsif (!$setting::page{$setting::key}{'closeButtonDisabled'}) {
		return $header . $this->close_button($referer_url,$setting::page{'closeButton'},$setting::page{'backButton'}) . $footer;
	}
}
return '';
}

sub get_link_button($$$) {
my($this,$type,$record_no) = @_;
return '' if !$record_no;
my($button,$name,$button_type,$c,$n);
$c = int($record_no / 1000000);
$n = $record_no - ($c * 1000000);
if ($type eq 'prev') {
	$name = (($default::english) ? 'Prev' : 'Υڡ');
	$button_type = 'prevButton';
} else {
	$name = (($default::english) ? $type : 'Υڡ');
	$button_type = 'nextButton';
}
if ($setting::general{'postMethod'}) {
	return $cgi::Deco->submit_button($type,$setting::page{$button_type},$name,'',{'m'=>$main::m,'k'=>$main::k,'c'=>$c,'n'=>$n});
} else {
	return $cgi::Deco->button(
		$type,
		$setting::page{$button_type},
		$cgi::path . '?m=' . $main::m . '&k=' . $main::k . '&c=' . $c . '&n=' . $n . $this->set_query('url+',['mod','dn','ct','s','w','f','u','uni','and','search','q','fv']),
		$name
	);
}
}

sub set_rss_link ($;$) {
my($this,$output) = @_;
if (defined $main::c) {
	$this->import_db($default::preference_dir . '/category',\%setting::category,1) if !%setting::category;
	$this->_set_rss_link($default::file . '/' . $main::c,((ref $setting::category{$main::c} && defined $setting::category{$main::c}{'name'} && $setting::category{$main::c}{'name'} ne '') ? $setting::category{$main::c}{'name'} : ''));
}
$this->_set_rss_link($default::file,((defined $setting::general{'cginame'} && $setting::general{'cginame'} ne '') ? $setting::general{'cginame'} : ''),$output);
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;						#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 1;						#ơ֥ɤ߹
	$setting::page = 1;						#ڡɤ߹

	$setting::field_db_name = 'inputfield';	#եDB
	$setting::field = 2;						#եɤ߹ߡ2=ꥸʥɤ߹
	$setting::field_style_disabled = 0;			#2=եꥹ̵/1=եΤ̵
	$setting::field_tag_enabled = 'no';				#tag=Τ/all=Ƥ/no=Ĥʤ

	$setting::pending_check = 1;			#쥳ɥå

	#省
	$setting::security_key = 'detail';							#ǥեȥƥ
	$setting::key = 'detail';						#ڡꥭ
	if ($main::dn && $main::dn >= 2 && $main::dn <= $default::detail_variation) {
		$main::dn = int($main::dn);
		$setting::key .= $main::dn;
	} else {
		$main::dn = '';
	}

	#å
	$cookie::id_enabled = 1;							#ID󥯥åɤ߹

	#ǥեȥ
	$main::k = 'detail' if !defined $main::k ||  !$main::k;

	#ɬܥե
	@setting::form = ('m','k','c','n','dn','mod','ct','s','w','f','u','uni','and','search','q','fv');

	#饹Ͽ
	Common::class_register('detail','DetailViewer');

	#᡼CSS
	$setting::image_css = 'tablemaker-image.css';
	$setting::image_css2 = 'order-image.css' if $default::type && $default::type eq 'order';
}

1;
