package Checker;
require CMONOS::TableMaker::Field::TMUserGeneratedField;
require CMONOS::CGI_Lib::Field::UserGeneratedField;
@ISA = qw(TMUserGeneratedField UserGeneratedField);
use strict;
######################################################################
# ե⥸塼ʺȾå
# Checker.pm 1.0.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
#support@cmonos.jp
#http://cmonos.jp/
# ǽ2010-06-15
######################################################################
sub __set ($$) {
my $this = shift;
if (!ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
if (!ref $cgi::Image) {
	require CMONOS::CGI_Lib::Image;
	$cgi::Image = Image->new;
}
@{$this->{'authorities'}} = $this->get_address($this->{'authority'});
$this->scalar_to_array(\$this->{'order'});
$this->{'phase'}{'1'} = {'name' => 'λ'} if !defined $this->{'phase'} || !ref $this->{'phase'};
$this->{'authorityName'} = 'åǤ' if !defined $this->{'authorityName'} || $this->{'authorityName'} eq '';
$this->{'lifetime'} = 604800 if !$this->{'lifetime'};
$this->{'datetype'} = (($setting::general{'datetype'}) ? $setting::general{'datetype'} : '') if !$this->{'datetype'};
$this->scalar_to_array(\$this->{'mailto'});
$this->{'field_for'}{'checker'} = $this->{'id'};
return;
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
return 1 if (defined $main::search{$this->{'id'}}{'str'} && $main::search{$this->{'id'}}{'str'} ne '') || (ref $main::search{$this->{'id'}}{'str'} && @{$main::search{$this->{'id'}}{'str'}} > 0);
return 0
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
my($pat,$phase);
return 1 if (!defined $main::search{$this->{'id'}}{'str'} || $main::search{$this->{'id'}}{'str'} eq '') && (!ref $main::search{$this->{'id'}}{'str'} || !@{$main::search{$this->{'id'}}{'str'}});
if (!ref $this->{'pattern'}) {
	$this->scalar_to_array(\$main::search{$this->{'id'}}{'str'});
	@{$this->{'pattern'}} = @{$main::search{$this->{'id'}}{'str'}};
}
$phase = $1 if $$str =~ /^.*?\x0A(\d+):/;
foreach $pat (@{$this->{'pattern'}}) {
	next if !defined $pat || $pat eq '';
	return ($main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'nor') ? 0 : 1 if (!$phase && !$pat) || ($phase && $phase == $pat);
}
return ($main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'nor') ? 1 : 0;
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status,$original,$path) = @_;
my $form = '';
if ($main::data{$this->{'id'}}{'str'}) {
	$main::data{$this->{'id'}}{'str'} =~ s/^.*?\x0A//;
	if ($main::data{$this->{'id'}}{'str'} =~ /^(\d+):([^:\x0A]*):[^:\x0A]*:(.*)$/m) {
		$form = $this->field_header;
		$form .= $this->get_oparation_phase($1,$2,$3);
		$form .= $this->get_oparation_phase_log(\$main::data{$this->{'id'}}{'str'});
		$form .= $this->field_footer;
	} elsif ($this->{'initialphase'}) {
		$form = $this->field_header;
		$form .= $this->{'initialphase'};
		$form .= $this->field_footer;
	}
} elsif ($this->{'initialphase'}) {
	$form = $this->field_header;
	$form .= $this->{'initialphase'};
	$form .= $this->field_footer;
}
return $form;
}

sub get_oparation_phase ($$$;$$) {
my($this,$phase,$authority,$comment,$short_ver) = @_;
return (($this->{'initialphase'}) ? $this->{'initialphase'} : '') if !$phase || ($phase != 999 && !defined $this->{'phase'}{$phase}{'name'});
if (!$short_ver && defined $this->{'authorityInfo'} && $this->{'authorityInfo'}) {
	$this->set_authority_name;
	return $this->get_phase_name($phase) . ' [' . $this->{'authorityName'} . ':<a href="' . $this->address_protector($authority,$this->{'addressProtector'}) . '">'
	. ((defined $authority && ref $this->{'authority_name'} && defined $this->{'authority_name'}{$authority} && $this->{'authority_name'}{$authority} ne '') ? $this->{'authority_name'}{$authority} : $this->address_camouflage($authority,$this->{'addressProtector'}))
	. '</a>]' . (($this->{'comment'} && $comment ne '') ? ' (' . $this->escape($comment) . ')' : '');
} else {
	return $this->get_phase_name($phase);
}
}

sub get_oparation_phase_log ($$;$$$) {
my($this,$str,$id,$class,$short_ver) = @_;
return ($id || $class) ? '<div' . (($id) ? ' id="' . $id . '"' : '') . (($class) ? ' class="' . $class . '"' : '') . '>Ϥޤ</div>' : '' if !defined $$str || $$str eq '';
$this->set_authority_name if !$short_ver && defined $this->{'authorityInfo'} && $this->{'authorityInfo'};
my($log);
$this->{'Table'}->set('thenabled' => 'true');
$log = '<div' . (($id) ? ' id="' . $id . '"' : '') . (($class) ? ' class="' . $class . '"' : '') . '>' if $id || $class;
$log .= $this->{'Table'}->table;
$log .= $this->{'Table'}->tr;
$log .= $this->{'Table'}->th($this->name(1));
$log .= $this->{'Table'}->th(($default::english) ? 'Comment' : '') if defined $this->{'comment'} && $this->{'comment'};
$log .= $this->{'Table'}->th($this->{'authorityName'}) if !$short_ver && defined $this->{'authorityInfo'} && $this->{'authorityInfo'};
$log .= $this->{'Table'}->th(($default::english) ? 'Date' : '');
$log .= $this->{'Table'}->_tr;
while ($$str =~ /^([^:\x0A]*):([^:\x0A]*):([^:\x0A]*):(.*)$/gm) {
	my($phase,$authority,$time,$comment) = ($1,$2,$3,$4);
	next if !defined $phase || $phase eq '';
	$log .= $this->{'Table'}->tr;
	if ($phase == 0) {
		$log .= $this->{'Table'}->td(($default::english) ? 'Reset' : 'ꥻå');
	} else {
		$log .= $this->{'Table'}->td($this->phase_distiller($this->get_phase_name($phase)));
	}
	$log .= $this->{'Table'}->td($this->escape($comment)) if defined $this->{'comment'} && $this->{'comment'};
	$log .= $this->{'Table'}->td('<a href="' . $this->address_protector($authority,$this->{'addressProtector'}) . '">' . ((defined $authority && ref $this->{'authority_name'} && defined $this->{'authority_name'}{$authority} && $this->{'authority_name'}{$authority} ne '') ? $this->{'authority_name'}{$authority} : $this->address_camouflage($authority,$this->{'addressProtector'}) . '</a>')) if !$short_ver && defined $this->{'authorityInfo'} && $this->{'authorityInfo'};
	$log .= $this->{'Table'}->td($this->date($time,$this->{'datelimit'},'gmt' . $this->{'datetype'}));
	$log .= $this->{'Table'}->_tr;
}
$log .= $this->{'Table'}->_table;
$log .= '</div>' if $id || $class;
return $log;
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
my $this = shift;
my($data,@addr,$user_addr);
$data = '';
if (defined $main::n && $main::n ne '') {
	my %db;
	use Fcntl qw(:DEFAULT);
	eval 'use ' . $env::dbm_file . ';';
	tie(%db, $env::dbm_file, "$default::db/$main::c/$this->{'id'}", O_RDONLY, $env::dbm_mode);
	if (ref tied %db && defined $db{$main::n}) {
		$data = $db{$main::n};
	}
	untie %db;
}
foreach my $id (@{$this->{'field_for'}{'mail_address'}}) {
	while (my($k,$v) = each %{$main::data{$id}}) {
		push(@addr,$this->get_address($v));
	}
}
$user_addr = (@addr) ? join(',',$this->get_address(@addr)) : '';
$data = $user_addr . "\x0A" . $data unless $data && $data =~ s/^.*?\x0A/$user_addr\x0A/;
$main::data{$this->{'id'}}{'str'} = $data;
return 1;
}

######################################################################
#	obj->is_secure;
sub is_secure_user ($) {
my $this = shift;

#ѥɥå
if (!defined $this->{'checkerLevel'} || $this->{'checkerLevel'} eq '' || $this->{'checkerLevel'} eq 'master') {
	if ($this->is_master) {
		return 1;
	} else {
		return 0;
	}

#ʡѥɥå
} elsif ($this->{'checkerLevel'} eq 'owner') {
	if ($this->is_owner) {
		return 1;
	} else {
		push(@{$cgi::action->{'dialog'}},$cgi::Register->error_dialog) if ref $cgi::Register;
		return 0;
	}

#Ʊʡѥɥå
} elsif ($this->{'checkerLevel'} eq 'owners') {
	if ($this->is_one_of_owners) {
		return 1;
	} else {
		push(@{$cgi::action->{'dialog'}},$cgi::Register->error_dialog) if ref $cgi::Register;
		return 0;
	}

#Ͽѥɥå
} elsif ($this->{'checkerLevel'} eq 'member') {
	if ($this->is_authorized(@{$this->{'authorities'}})) {
		return 1;
	} else {
		push(@{$cgi::action->{'dialog'}},$cgi::Register->error_dialog) if ref $cgi::Register;
		return 0;
	}

#åʤ
} elsif ((!$default::type || $default::type ne 'order') && $this->{'checkerLevel'} eq 'nocheck') {
	return 1;
}

return 0;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=ɽǡ/path=ե¸ǥ쥯ȥ
sub usual_format {
my($this,$str,@data) = @_;
return $this->phase_format(0,$str,@data);
}

sub has_content {
my $this = shift;
return 1;
}

sub phase_format {
my($this,$show_log,$str,$path,$c,$n) = @_;
my($phase,$authority,$comment,@user_addr,$form,$id,$is_updated_record);
$is_updated_record = $this->is_updated_record($c,$n);
$id = $this->mk_user_generated_field_id($c,$n);
$str = $$str{'str'} if ref $str eq 'HASH';
@user_addr = ($str && $str =~ s/^(.*?)\x0A//s) ? split(/,/,$1) : ();
($phase,$authority,$comment) = ($str && $str =~ /^(\d+):([^:\x0A]*):[^:\x0A]*:(.*)$/m) ? ($1,$2,$3) : ('','','');
if ($this->is_secure_user && (!$this->{'charge'} || !$phase || $authority eq $main::email || $this->is_secure('tools'))) {
	$form .= $this->get_oparation_phase_menu_header($c,$n,$id);
	$form .= $this->get_oparation_phase_menu('phase',[$phase]);
	$form .= '<input type="text" name="comment" size="16" title="' . (($default::english) ? 'Comment' : '') . '"' . (($is_updated_record && $this->{'is_invalid_field'}{'comment'}) ? ' class="invalid-field"' : '') . ' onchange="cmonos.validate.field(this).bailOut()"' . (($is_updated_record) ? $this->escape($main::comment) : '') . ' />' if defined $this->{'comment'} && $this->{'comment'};
	$form .= $cgi::Deco->submit_button('submit',$this->{'button'},(($default::english) ? 'Submit' : ''),{'id' => $id . '-submit'});
	$form .= '</form>';
	$form .= '<p class="checker-log"><a href="javascript:void(0)" onclick="cmonos.element.item(\'' . $id . '\').toggle()" class="toggle-link">[' . (($default::english) ? 'LOG' : '') . ']</a></p>';
	$form .= $this->get_oparation_phase_log(\$str,$id,(($show_log) ? '' : 'floating-box'),(($show_log) ? 0 : 1));
	$form .= $this->javascript('cmonos.element.item(\'' . $id . '\').disappear(true);') if !$show_log;
	return $this->field_tag($form);
} elsif ($this->{'cancelEnabled'} && (!$phase || ($phase && $phase != 999 && !$this->{'phase'}{$phase}{'aftercancel'}) && ($this->{'cancelAlwaysEnabled'} || !$this->{'phase'}{$phase}{'suspend'})) && @user_addr && $this->is_authorized(@user_addr)) {
	$form .= $this->get_oparation_phase_menu_header($c,$n,$id);
	$form .= '<input type="text" name="comment" size="16" title="' . (($default::english) ? 'Comment' : '') . '"' . (($is_updated_record && $this->{'is_invalid_field'}{'comment'}) ? ' class="invalid-field"' : '') . ' onchange="cmonos.validate.field(this).bailOut()"' . (($is_updated_record) ? $this->escape($main::comment) : '') . ' />' if defined $this->{'comment'} && $this->{'comment'};
	$form .= $cgi::Deco->submit_button('cancel',$this->{'cancelButton'},$this->phase_distiller($this->get_phase_name(999)),{'id' => $id . '-submit'},{'phase' => 999});
	$form .= '</form>';
	$form .= '<p class="checker-log"><a href="javascript:void(0)" onclick="cmonos.element.item(\'' . $id . '\').toggle()" class="toggle-link">[' . (($default::english) ? 'LOG' : '') . ']</a></p>';
	$form .= $this->get_oparation_phase_log(\$str,$id,(($show_log) ? '' : 'floating-box'),(($show_log) ? 0 : 1));
	$form .= $this->javascript('cmonos.element.item(\'' . $id . '\').disappear(true);') if !$show_log;
	return $this->field_tag($form);
} else {
	return $this->field_tag(
		$this->style(
			$this->get_oparation_phase($phase,$authority,$comment,(($show_log) ? 0 : 1)),
			$this->{'style'},
			$this->{'fontsize'},
			$this->{'fontcolor'},
			$this->{'fontface'}
		) .
		'<a href="javascript:void(0)" onclick="cmonos.element.item(\'' . $id . '\').toggle()" class="toggle-link">[' . (($default::english) ? 'LOG' : '') . ']</a>' . 
		$this->get_oparation_phase_log(\$str,$id,(($show_log) ? '' : 'floating-box'),(($show_log) ? 0 : 1)) .
		(($show_log) ? '' : $this->javascript('cmonos.element.item(\'' . $id . '\').disappear(true);'))
	);
}
}

sub get_oparation_phase_menu_header ($$$$) {
my($this,$c,$n,$id) = @_;
my @required = grep($_ ne 'n' && $_ ne 'c' && $_ ne 'id',@setting::form);
push(@required,'ct') if !grep($_ eq 'ct',@required);
@main::ct = @main::c if !@main::ct && @main::c;
my $form = $this->form_start(
	'key'		=>	(($setting::security_key) ? $setting::security_key : ''),
	'id'		=>	(($id) ? $id . '-form' : ''),
	'name'		=>	(($id) ? $id . '-form' : ''),
	'method'	=> 'post',
	'onsubmit'	=>	'return cmonos.form.item(this).submit(\'' . $id . '\');',
	'required'	=>	\@required
);
$form .= '<input type="hidden" name="id" value="' . $this->{'id'} . '" />';
$form .= '<input type="hidden" name="n" value="' . $n . '" />';
$form .= '<input type="hidden" name="c" value="' . $c . '" />';
return $form;
}

sub set_authority_name ($) {
my $this = shift;
return if ref $this->{'authority_name'};
$this->{'authority_name'}{$setting::general{'master'}} = $setting::general{'mastername'};
$this->set_authority_name_from_email_list($setting::general{'owners'});
$this->set_authority_name_from_email_list($this->{'authority'});
}

sub set_authority_name_from_email_list ($$) {
my($this,$list) = @_;
return if !defined $list || $list eq '';
my(@addr,$addr,%name);
@addr = split(/,\s*|[\x0A\x0D]+/,$list);
%{$this->{'authority_name'}} = $cgi::Register->get_name_hash_from_emails($this->get_address(@addr));
foreach $addr (@addr) {
	if ($addr =~ /^([^<>]*)<([^<>]+)>\s*$/) {
		$this->{'authority_name'}{$2} = $1;
		$this->{'authority_name'}{$2} =~ s/\s+$//;
	} elsif ($addr =~ s/\((.*)\)//g) {
		my $name = $1;
		$addr =~ s/\s+//g;
		$this->{'authority_name'}{$addr} = $name if defined $name && $name ne '';
	}
}
}

sub get_oparation_phase_menu ($$$;$) {
my($this,$name,$phase,$search_flag) = @_;
my($form,$id);
$form .= '<select name="' . $name . '"' . (($search_flag) ? ' multiple="multiple"' : '') . '>';
foreach $id (@{$this->{'order'}}) {
	if ($search_flag || (!$phase->[0] && !$this->{'phase'}{$id}{'aftercancel'}) || (
			$phase->[0] && (
				(($phase->[0] == 999 || $this->{'phase'}{$phase->[0]}{'aftercancel'}) && $this->{'phase'}{$id}{'aftercancel'}) || 
				($phase->[0] != 999 && !$this->{'phase'}{$phase->[0]}{'aftercancel'} && !$this->{'phase'}{$id}{'aftercancel'})
			)
		)
	) {
		$form .= '<option value="' . $id . '"' . ((grep(defined $_ && $_ ne '' && $_ == $id,@$phase)) ? ' selected="selected"' : '') . '>' . $this->phase_distiller($this->{'phase'}{$id}{'name'}) . '</option>';
	}
}
if ($search_flag) {
	$form .= '<option value="0"' . ((grep(defined $_ && $_ eq '0',@$phase)) ? ' selected="selected"' : '') . '>' . (($this->{'initialphase'}) ? $this->{'initialphase'} : ($default::english) ? 'No check' : '̤') . '</option><option value="999"' . ((grep(defined $_ && $_ == 999,@$phase)) ? ' selected="selected"' : '') . '>' . ((defined $this->{'cancelName'} && $this->{'cancelName'} ne '') ? $this->{'cancelName'} : (($default::english) ? 'Canceled' : '󥻥')) . '</option>' if $this->{'cancelEnabled'};
} else {
	$form .= '<option value="' . (($phase->[0]) ? $phase->[0] : '') . '"></option><option value="999">' . $this->phase_distiller($this->get_phase_name(999)) . '</option>' if $this->{'masterCancelEnabled'} && (!$phase->[0] || ($phase->[0] != 999 && !$this->{'phase'}{$phase->[0]}{'aftercancel'} && ($this->{'cancelAlwaysEnabled'} || !$this->{'phase'}{$phase->[0]}{'suspend'})));
	$form .= '<option value="' . $phase->[0] . '"></option><option value="0">' . (($default::english) ? 'Reset' : 'ꥻå') . '</option>' if $phase->[0];
}
$form .= '</select>';
return $form;
}

sub phase_distiller ($$) {
my($this,$str) = @_;
return '' if !defined $str || $str eq '';
my $extract = '';
while ($str =~ /(<([^>]*)>|[^<]*)/g) {
	if (defined $2 && $2) {
		my $tag = $2;
		$extract .= (($extract ne '') ? ' ' : '') . $2 if $tag =~ / (title|alt)="(.*?)"/i;
	} else {
		$extract .= (($extract ne '') ? ' ' : '') . $1;
	}
}
$extract =~ s/\s+$//;
return $extract;
}

sub get_phase_name ($$) {
my($this,$phase) = @_;
return (!$phase) ? (($this->{'initialphase'}) ? $this->{'initialphase'} : '') : ($phase == 999) ? (defined $this->{'cancelName'} && $this->{'cancelName'} ne '') ? $this->{'cancelName'} : ($default::english) ? 'Canceled' : '󥻥' : (defined $this->{'phase'}{$phase}{'name'}) ? $this->{'phase'}{$phase}{'name'} : ''; 
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
if (defined $str) {
	$str =~ s/^.*?\x0A//;
	if ($str =~ /^(\d+):([^:\x0A]*):[^:\x0A]*:(.*)$/m) {
		my($phase,$authority,$comment) = ($this->phase_distiller($this->get_phase_name($1)),$2,$3);
		$phase =~ s/\&lt;/</g;
		$phase =~ s/\&gt;/</g;
		$this->set_authority_name;
		return '[' . $this->name . "]\x0A" . $phase . (($this->{'authorityInfo'}) ? '(' . $this->{'authorityName'} . ((defined $this->{'authority_name'}{$authority} && $this->{'authority_name'}{$authority} ne '') ? ' ' . $this->{'authority_name'}{$authority} : '') . ' <' . $authority . '>)' : '') . (($this->{'comment'} && $comment) ? "\x0A" . $comment : '') . "\x0A\x0A";
	}
}
return '';
}

#---------------------------------------------------------------------
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail {
my($this,$str,@data) = @_;
return $this->phase_format($this->{'showLog'},$str,@data);
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
if (defined $str) {
	$str =~ s/^.*?\x0A//;
	if ($str =~ /^(\d+):([^:\x0A]*):[^:\x0A]*:(.*)$/m) {
		my($phase,$authority,$comment) = ($this->phase_distiller($this->get_phase_name($1)),$2,$3);
		$phase =~ s/\&lt;/</g;
		$phase =~ s/\&gt;/</g;
		$this->set_authority_name;
		return $phase . (($this->{'authorityInfo'}) ? ' [' . $this->{'authorityName'} . ((defined $this->{'authority_name'}{$authority} && $this->{'authority_name'}{$authority} ne '') ? ' ' . $this->{'authority_name'}{$authority} : '') . ' <' . $authority . '>]' : '') . (($this->{'comment'}) ? $comment : '');
	}
}
return '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$) {
my($this,$str) = @_;
my($phase,$authority,$comment);
$str = $$str{'str'} if ref $str eq 'HASH';
$str =~ s/^(.*?)\x0A//;
($phase,$authority,$comment) = ($1,$2,$3) if $str =~ /^(\d+):([^:\x0A]*):[^:\x0A]*:(.*)$/m;
return $this->field_tag(
	$this->style(
		$this->get_oparation_phase($phase,$authority,$comment),
		$this->{'style'},
		$this->{'fontsize'},
		$this->{'fontcolor'},
		$this->{'fontface'}
	)
);
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my $this = shift;
my($name,$id,$n);
$n = 0;

#̾
$name = 'data:' . $this->{'id'};

$this->print_field_info_form($name);

print '<fieldset>';
print '<legend>Ⱦå</legend>';

print '<table class="tooltable" style="margin-bottom: 20px">';
print '<thead>';
print '<tr class="odd">';
print '<th class="odd"></th>';
print '<th class="even">ɽ</th>';
print '<th class="odd">̾</th>';
print '<th class="even">Υ᡼(ɽ/)</th>';
print '<th class="odd">ͽ</th>';
print '<th class="even">ѹػ</th>';
print '<th class="odd">󥻥ͭ</th>';
print '<th class="even">Ѿǧ</th>' if $default::type && $default::type eq 'order';
print '</tr>';
print '</thead>';
print '<tbody>';
$this->print_phase_setting_form($name,0,$n++);
foreach $id (@{$this->{'order'}}) {
	$this->print_phase_setting_form($name,$id,$n++);
}
$id = 1;
$id++ while ref $this->{'phase'}{$id};
$this->print_phase_setting_form($name,$id,$n,1);
print '</tbody></table>';

print '<fieldset>';
print '<legend><label for="' . $name . '_initialphase">̾</label></legend>';
print '<input type="text" name="' . $name . '_initialphase" id="' . $name . '_initialphase" value="' . $this->escape($this->{'initialphase'}) . '" size="40" />';
print '</fieldset>';
print '<fieldset>';
print '<legend>Ⱦåν</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_comment" id="' . $name . '_comment" value="1"' . ((defined $this->{'comment'} && $this->{'comment'}) ? ' checked="checked"' : '') . ' /> Ѳǽˤ롣</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_mTime" id="' . $name . '_mTime" value="1" ' . ((defined $this->{'mTime'} && $this->{'mTime'}) ? ' checked="checked"' : '') . ' /> Ⱦå˹ǡ١򹹿롣</label></li>';
print '</ol>';
print '</fieldset>';
print '<fieldset>';
print '<legend>󥻥</legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">󥻥ܥ</span></td>';
print '<td class="field"><ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_cancelEnabled" id="' . $name . '_cancelEnabled" value="1" ' . ((defined $this->{'cancelEnabled'} && $this->{'cancelEnabled'}) ? ' checked="checked"' : '') . ' /> Ѳǽˤ롣</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_cancelAlwaysEnabled" id="' . $name . '_cancelAlwaysEnabled" value="1" ' . ((defined $this->{'cancelAlwaysEnabled'} && $this->{'cancelAlwaysEnabled'}) ? ' checked="checked"' : '') . ' /> 쥳ɤѹػߤƤƤѲǽˤ롣</label></li>';
print '</ol></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">֥åǤԡפˤ륭󥻥</span></td>';
print '<td class="field"><ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_masterCancelEnabled" id="' . $name . '_masterCancelEnabled" value="1" ' . ((defined $this->{'masterCancelEnabled'} && $this->{'masterCancelEnabled'}) ? ' checked="checked"' : '') . ' /> ֥åǤԡפˤ륭󥻥ǽˤ롣</label></li>';
print '</ol></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_cancelName">󥻥̾</label></td>';
print '<td class="field"><input type="text" name="' . $name . '_cancelName" id="' . $name . '_cancelName" size="30" value="' . $this->escape($this->{'cancelName'}) . '" /></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">󥻥</span></td>';
print '<td class="field"><ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_cancelExpire" id="' . $name . '_cancelExpire" value="1"' . ((defined $this->{'cancelExpire'} && $this->{'cancelExpire'}) ? ' checked="checked"' : '') . ' /> 쥳ɤκͽ󤹤롣</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_cancelSuspend" id="' . $name . '_cancelSuspend" value="1"' . ((defined $this->{'cancelSuspend'} && $this->{'cancelSuspend'}) ? ' checked="checked"' : '') . ' /> 쥳ɤѹػߤ롣</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_cancelSC" id="' . $name . '_cancelSC" value="1" ' . ((defined $this->{'cancelSC'} && $this->{'cancelSC'}) ? ' checked="checked"' : '') . ' /> ʤê᤹</label></li>' if $default::type && $default::type eq 'order';
print '</ol></td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';
print '<fieldset>';
print '<legend>ͽ󤵤줿Υߥ</legend>';
print $this->mk_select_menu(
	$name . '_lifetime','','',((defined $this->{'lifetime'}) ? $this->{'lifetime'} : 604800),
	1			=>		'ľ',
	86400		=>		'1ʹ',
	604800		=>		'1ָʹ',
	1209600		=>		'2ָʹ',
	2678400		=>		'1ʹ',
	5270400		=>		'2ʹ',
	8208000		=>		'3ʹ',
	10540800	=>		'4ʹ',
	13219200	=>		'5ʹ',
	15811200	=>		'6ʹ',
	18489600	=>		'7ʹ',
	21081600	=>		'8ʹ',
	23760000	=>		'9ʹ',
	26352000	=>		'10ʹ',
	29030400	=>		'11ʹ',
	31536000	=>		'1ǯʹ',
	47347200	=>		'1ǯ6ʹ',
	63072000	=>		'2ǯʹ',
	94608000	=>		'3ǯʹ'
);
print '</fieldset>';
print '</fieldset>';

print '<fieldset>';
print '<legend>åǤ</legend>';
print '<fieldset>';
print '<legend><label for="' . $name . '_checkerLevel">å¤Τ桼</label></legend>';
print $this->mk_select_menu(
	$name . '_checkerLevel','','',$this->{'checkerLevel'},
	'master'	=>		'ޥ',
	'owner'		=>		'',
	'owners'	=>		'Ʊʡ',
	'member'	=>		'ϿС',
	(($default::type && $default::type eq 'order') ? () : ('nocheck'	=>		'ƤΥ桼'))
);
print '</fieldset>';
print '<fieldset>';
print '<legend><label for="' . $name . '_authority">ϿСץ᡼륢ɥ쥹</label></legend>';
print '<textarea name="' . $name . '_authority" id="' . $name . '_authority" cols="56" rows="5" wrap="off">' . $this->escape($this->{'authority'}) . '</textarea>';
print '<div class="note">ϿСʣλϥޡ+ԡˤǶڤޤ</div>';
print '</fieldset>';
print '<fieldset>';
print '<legend><label for="' . $name . '_authorityName">åǤԤ̾</label></legend>';
print '<input type="text" name="' . $name . '_authorityName" id="' . $name . '_authorityName" value="' . $this->escape($this->{'authorityName'}) . '" size="20" /><span class="note">ʡôԡ</span>';
print '</fieldset>';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_authorityInfo" id="' . $name . '_authorityInfo" value="1"' . ((defined $this->{'authorityInfo'} && $this->{'authorityInfo'}) ? ' checked="checked"' : '') . ' /> åǤԤɽ롣</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_charge" id="' . $name . '_charge" value="1"' . ((defined $this->{'charge'} && $this->{'charge'}) ? ' checked="checked"' : '') . ' /> åǤԤꤹ롣</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_addressProtector" id="' . $name . '_addressProtector" value="1"' . ((defined $this->{'addressProtector'} && $this->{'addressProtector'}) ? ' checked="checked"' : '') . ' /> ᡼륢ɥ쥹 JavaScript + CSS + HTML ƥƥݸ롣</label></li>';
print '<li><label><input type="checkbox" name="' . $name . '_notice" id="' . $name . '_notice" value="1"' . ((defined $this->{'notice'} && $this->{'notice'}) ? ' checked="checked"' : '') . ' /> ƤΥåǤԤ˾᡼Τ롣</label></li>';
print '</ol>';
print '</fieldset>';
print '<fieldset>';
print '<legend>Ⱦå</legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">ɽ</span></td>';
print '<td class="field"><label><input type="checkbox" name="' . $name . '_showLog" id="' . $name . '_showLog" value="1"' . ((defined $this->{'showLog'} && $this->{'showLog'}) ? ' checked="checked"' : '') . ' /> ɽ롣</label></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">åɽ</span></td>';
print '<td class="field"><label><input type="text" size="3" maxlength="3" name="' . $name . '_datelimit" id="' . $name . '_datelimit" value="' . $this->escape($this->{'datelimit'}) . '" /> ʤɽʤ礦/Τ/</label></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_datetype">åɽ</label></td>';
print '<td class="field">';
$this->print_date_type_menu($name . '_',$this->{'datetype'});
print '</td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

print '<fieldset>';
print '<legend>ܥ</legend>';
print '<fieldset>';
print '<legend>ܥ</legend>';
print $cgi::Deco->button_menu(
	$name . '_button',
	'submit',
	120,
	$this->{'button'}
);
print '</fieldset>';
print '<fieldset>';
print '<legend>󥻥ܥ</legend>';
print $cgi::Deco->button_menu(
	$name . '_cancelButton',
	'cancel',
	120,
	$this->{'cancelButton'}
);
print '</fieldset>';
print '</fieldset>';

#ơ֥
$this->print_table_setting_form($name,'(ɽ)','none');

print '<fieldset>';
print '<legend>ȾåΥ᡼</legend>';
print '<div class="hints">Ⱦѹ줿Ȥޤ</div>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_mailto">Υ᡼</label></td>';
print '<td class="field"><select name="' . $name . '_mailto" id="' . $name . '_mailto" multiple="multiple">';

foreach my $id (sort {$this->{'field_obj'}->{$a}->{'ORDER'} <=> $this->{'field_obj'}->{$b}->{'ORDER'} || $a <=> $b} keys %{$this->{'field_obj'}}) {
	if (defined $this->{'field_obj'}{$id}->{'e-mail'} && $this->{'field_obj'}{$id}->{'e-mail'}) {
		print '<option value="' . $id . '"' . ((ref $this->{'mailto'} && grep($_ eq $id,@{$this->{'mailto'}})) ? ' selected="selected"' : '') . '>' . $this->{'field_obj'}{$id}->name . '</option>';
	}
}

print '</select>';
print '<div class="note">̵ξ硢εǽưޤ</div></td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';

$this->print_font_setting_form($name);
$this->print_setting_save_button;
return;
}

sub print_phase_setting_form ($$$$;$) {
my($this,$name,$id,$n,$new) = @_;
$name .= '_phase_' . $id . '_';
print '<tr class="' . ((($n+1) % 2) ? 'even' : 'odd') . '">';
if ($id) {
	print '<td class="caution">' . ((!$new) ? '<input type="checkbox" name="delete:' . $id . '" value="1" />' : '') . '</td>';
	print '<td class="even"><input type="hidden" name="oldorder:' . $id . '" value="' . $n . '" /><input type="text" name="order:' . $id . '" value="' . $n . '" size="2" /></td>';
	print '<td class="odd"><input type="text" name="' . $name . 'name" size="16" value="' . $this->escape($this->{'phase'}{$id}{'name'}) . '" /></td>';
} else {
	print '<td class="caution"></td>';
	print '<td class="even"><input type="hidden" name="order:' . $id . '" value="' . $n . '" /></td>';
	print '<td class="odd">ꥻå</td>';
}
print '<td class="even" style="text-align: left">';
print '<div class="email-subject"><input type="text" name="' . $name . 'subject" size="50" value="' . $this->escape($this->{'phase'}{$id}{'subject'}) . '" /></div>';
print '<div class="email-msg"><textarea name="' . $name . 'msg" cols="50" rows="5">' . $this->escape($this->{'phase'}{$id}{'msg'}) . '</textarea>';
print '<div class="toolbox">';
print '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'' . $name . 'msg\').quotationByMenu(this)" title="Υϥ᡼бͤѴޤ">';
print '<option value=""></option>';
print '<option value="&lt;phase&gt;">&lt;phase&gt;[ߤκȾ]</option>';
print '<option value="&lt;checker&gt;">&lt;checker&gt;[åǤԤΥ᡼륢ɥ쥹]</option>';
print '<option value="&lt;comment&gt;">&lt;comment&gt;[å]</option>';
print '<option value="&lt;name&gt;">&lt;name&gt;[̾ե' . (($this->{'field_for'}{'name'} && ref $this->{'field_obj'}{$this->{'field_for'}{'name'}}) ? '' . $this->{'field_obj'}{$this->{'field_for'}{'name'}}->name . '' : '') . ']</option>';
print '<option value="&lt;key&gt;">&lt;key&gt;[ե' . (($this->{'field_for'}{'key'} && ref $this->{'field_obj'}{$this->{'field_for'}{'key'}}) ? '' . $this->{'field_obj'}{$this->{'field_for'}{'key'}}->name . '' : '') . ']</option>';
print '<option value="&lt;title&gt;">&lt;title&gt;[ȥե' . (($this->{'field_for'}{'title'} && ref $this->{'field_obj'}{$this->{'field_for'}{'title'}}) ? '' . $this->{'field_obj'}{$this->{'field_for'}{'title'}}->name . '' : '') . ']</option>';
print '<option value="&lt;url&gt;">&lt;url&gt;[ܺ٥ڡURL]</option>';
print '<option value="&lt;input&gt;">&lt;input&gt;[ڡURL]</option>';
print '<option value="&lt;register&gt;">&lt;register&gt;[ɥ쥹ϿURL]</option>';
print '<option value="&lt;data&gt;">&lt;data&gt;[ǡΰ]</option>';
print '</select>';
print '</div></div>';
print '</td>';
if ($id) {
	print '<td class="odd" style="text-align: center; vertical-align: middle;"><input type="checkbox" name="' . $name . 'expire" value="1"' . (($this->{'phase'}{$id}{'expire'}) ? ' checked="checked"' : '') . '" /></td>';
	print '<td class="even" style="text-align: center; vertical-align: middle;"><input type="checkbox" name="' . $name . 'suspend" value="1"' . (($this->{'phase'}{$id}{'suspend'}) ? ' checked="checked"' : '') . '" /></td>';
	print '<td class="odd" style="text-align: center; vertical-align: middle;"><input type="checkbox" name="' . $name . 'aftercancel" value="1"' . (($this->{'phase'}{$id}{'aftercancel'}) ? ' checked="checked"' : '') . '" /></td>';
	print '<td class="even" style="text-align: center; vertical-align: middle;"><input type="checkbox" name="' . $name . 'paid" value="1"' . (($this->{'phase'}{$id}{'paid'}) ? ' checked="checked"' : '') . '" /></td>' if $default::type && $default::type eq 'order';
} else {
	print '<td class="odd"></td>';
	print '<td class="even"></td>';
	print '<td class="odd"></td>';
	print '<td class="even"></td>' if $default::type && $default::type eq 'order';
}
print '</tr>';
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my $is_valid = $this->is_valid_font_setting;
my @phases = ();
my $id;
while (($id) = each %main::order) {
	if (!$id) {
		$id = '0';
		$main::data{$this->{'id'} . '_phase_' . $id . '_subject'} =~ s/[\x0A\x0D]+//g if defined $main::data{$this->{'id'} . '_phase_' . $id . '_subject'};
		delete $main::data{$this->{'id'} . '_phase_' . $id . '_name'};
		delete $main::data{$this->{'id'} . '_phase_' . $id . '_expire'};
		delete $main::data{$this->{'id'} . '_phase_' . $id . '_suspend'};
		delete $main::data{$this->{'id'} . '_phase_' . $id . '_aftercancel'};
		delete $main::data{$this->{'id'} . '_phase_' . $id . '_paid'} if $default::type && $default::type eq 'order';
	} elsif ($main::delete{$id} || !defined $main::data{$this->{'id'} . '_phase_' . $id . '_name'} || $main::data{$this->{'id'} . '_phase_' . $id . '_name'} eq '') {
		$main::data{$this->{'id'} . '_phase_' . $id . '_name'} = "\x7F";
		$main::data{$this->{'id'} . '_phase_' . $id . '_subject'} = "\x7F";
		$main::data{$this->{'id'} . '_phase_' . $id . '_msg'} = "\x7F";
		$main::data{$this->{'id'} . '_phase_' . $id . '_expire'} = "\x7F";
		$main::data{$this->{'id'} . '_phase_' . $id . '_suspend'} = "\x7F";
		$main::data{$this->{'id'} . '_phase_' . $id . '_aftercancel'} = "\x7F";
		$main::data{$this->{'id'} . '_phase_' . $id . '_paid'} = "\x7F" if $default::type && $default::type eq 'order';
	} else {
		push(@phases,$id);
		$this->tag_fix(\$main::data{$this->{'id'} . '_phase_' . $id . '_name'});
		$main::data{$this->{'id'} . '_phase_' . $id . '_expire'} = 0 if !$main::data{$this->{'id'} . '_phase_' . $id . '_expire'};
		$main::data{$this->{'id'} . '_phase_' . $id . '_suspend'} = 0 if !$main::data{$this->{'id'} . '_phase_' . $id . '_suspend'};
		$main::data{$this->{'id'} . '_phase_' . $id . '_aftercancel'} = 0 if !$main::data{$this->{'id'} . '_phase_' . $id . '_aftercancel'};
		$main::data{$this->{'id'} . '_phase_' . $id . '_paid'} = 0 if $default::type && $default::type eq 'order' && !$main::data{$this->{'id'} . '_phase_' . $id . '_paid'};
		$main::data{$this->{'id'} . '_phase_' . $id . '_subject'} =~ s/[\x0A\x0D]+//g if defined $main::data{$this->{'id'} . '_phase_' . $id . '_subject'};
	}
}
$main::data{$this->{'id'} . '_order'} = [(sort {$main::order{$a} <=> $main::order{$b} || $main::oldorder{$b} <=> $main::oldorder{$a} || $main::order{$a} cmp $main::order{$b} || $a <=> $b} @phases)];

#Ĵ
$this->tag_fix(\$main::data{$this->{'id'} . '_initialphase'}) if defined $main::data{$this->{'id'} . '_initialphase'} && $main::data{$this->{'id'} . '_initialphase'};
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
$this->detag(\$main::data{$this->{'id'} . '_authorityName'}) if defined $main::data{$this->{'id'} . '_authorityName'} && $main::data{$this->{'id'} . '_authorityName'};
$this->tag_fix(\$main::data{$this->{'id'} . '_cancelName'});

#ȾѴ
$main::data{$this->{'id'} . '_authority'} = $this->z_to_h($main::data{$this->{'id'} . '_authority'},'euc') if defined $main::data{$this->{'id'} . '_authority'} && $main::data{$this->{'id'} . '_authority'};

#åܥå
$main::data{$this->{'id'} . '_cancelEnabled'} = 0 if !defined $main::data{$this->{'id'} . '_cancelEnabled'} || !$main::data{$this->{'id'} . '_cancelEnabled'};
$main::data{$this->{'id'} . '_cancelAlwaysEnabled'} = 0 if !defined $main::data{$this->{'id'} . '_cancelAlwaysEnabled'} || !$main::data{$this->{'id'} . '_cancelAlwaysEnabled'};
$main::data{$this->{'id'} . '_masterCancelEnabled'} = 0 if !defined $main::data{$this->{'id'} . '_masterCancelEnabled'} || !$main::data{$this->{'id'} . '_masterCancelEnabled'};
$main::data{$this->{'id'} . '_cancelExpire'} = 0 if !defined $main::data{$this->{'id'} . '_cancelExpire'} || !$main::data{$this->{'id'} . '_cancelExpire'};
$main::data{$this->{'id'} . '_cancelSuspend'} = 0 if !defined $main::data{$this->{'id'} . '_cancelSuspend'} || !$main::data{$this->{'id'} . '_cancelSuspend'};
$main::data{$this->{'id'} . '_cancelSC'} = 0 if $default::type && $default::type eq 'order' && !$main::data{$this->{'id'} . '_cancelSC'};
$main::data{$this->{'id'} . '_mTime'} = 0 if !defined $main::data{$this->{'id'} . '_mTime'} || !$main::data{$this->{'id'} . '_mTime'};
$main::data{$this->{'id'} . '_charge'} = 0 if !defined $main::data{$this->{'id'} . '_charge'} || !$main::data{$this->{'id'} . '_charge'};
$main::data{$this->{'id'} . '_authorityInfo'} = 0 if !defined $main::data{$this->{'id'} . '_authorityInfo'} || !$main::data{$this->{'id'} . '_authorityInfo'};
$main::data{$this->{'id'} . '_showLog'} = 0 if !defined $main::data{$this->{'id'} . '_showLog'} || !$main::data{$this->{'id'} . '_showLog'};
$main::data{$this->{'id'} . '_comment'} = 0 if !defined $main::data{$this->{'id'} . '_comment'} || !$main::data{$this->{'id'} . '_comment'};
$main::data{$this->{'id'} . '_addressProtector'} = 0 if !defined $main::data{$this->{'id'} . '_addressProtector'} || !$main::data{$this->{'id'} . '_addressProtector'};
$main::data{$this->{'id'} . '_notice'} = 0 if !defined $main::data{$this->{'id'} . '_notice'} || !$main::data{$this->{'id'} . '_notice'};
$main::data{$this->{'id'} . '_mailto'} = '' if !defined $main::data{$this->{'id'} . '_mailto'};

#å
if (defined $main::data{$this->{'id'} . '_datelimit'} && $main::data{$this->{'id'} . '_datelimit'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_datelimit'})) {
	push(@{$cgi::action->{'dialog'}},'򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_datelimit'};
	$is_valid = 0;
}
if (defined $main::data{$this->{'id'} . '_lifetime'} && $main::data{$this->{'id'} . '_lifetime'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_lifetime'})) {
	push(@{$cgi::action->{'dialog'}},'Υߥ󥰤򹹿ǤޤǤȾѿˤƤ') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_lifetime'};
	$is_valid = 0;
}
return $is_valid;
}

######################################################################
#	(6) obj->search_form;
sub search_form ($) {
my $this = shift;
my($form);
$this->scalar_to_array(\$main::search{$this->{'id'}}{'str'});
$form = '<tr><td class="field-name"><label for="search:' . $this->{'id'} . ':str">' . $this->{'name'} . '</label></td><td class="field">';
$form .= $this->get_oparation_phase_menu('search:' . $this->{'id'} . ':str',$main::search{$this->{'id'}}{'str'},1);
$form .= $this->mk_select_menu(
	'search:' . $this->{'id'} . ':mode','','',$main::search{$this->{'id'}}{'mode'},
	'or'		=>		(($default::english) ? 'Matches on any selection' : '줫˰'),
	'nor'		=>		(($default::english) ? 'Unmatches on any selection' : 'ˤפʤ')
);
$form .= '</td></tr>';
return $form;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(11) obj->update;
sub update_enabled ($) {
my $this = shift;
return 1;
}

sub is_secure_user_for_edit ($) {
my $this = shift;
return 0;
}

sub _update_error ($$) {
my($this,$is_ajax) = @_;
return ($is_ajax) ? {
	'status'			=>	'error',
	'message'			=>	$this->get_message_string,
	'authorized_level'	=>	$this->get_authorized_level
} : 0;
}

sub update ($;$) {
#no warnings qw(untie);
my($this,$is_ajax) = @_;
my($db,$n,$c,%db,$addr,@user_addr,$data,$latest_phase,$latest_authority,$content);
$this->save_update_target;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
$main::phase = 0 if !$main::phase;
if (!$this->is_secure_user && $main::phase != 999) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ⱦ') . '򹹿ǤޤǤå¤ޤ');
	return $this->_update_error($is_ajax);
}
if (!defined $main::n || $main::n eq '' || !defined $main::c || $main::c eq '' || $this->is_nan($main::phase) || ($main::phase && $main::phase != 999 && !ref $this->{'phase'}{$main::phase})) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ⱦ') . '򹹿ǤޤǤƤ꤬ޤ');
	return $this->_update_error($is_ajax);
}
$db = $default::db . '/' . $main::c;
$n = $main::n;
$c = $main::c;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
tie(%db, $env::dbm_file, $db . '/' . $this->{'id'}, O_RDWR | O_CREAT, $env::dbm_mode);
if (!ref tied %db) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ⱦ') . '򹹿ǤޤǤǡ١³ǤޤǤ');
	return $this->_update_error($is_ajax);
}
$data = $db{$n};
untie %db;
if ($data =~ s/^(.*?)\x0A//) {
	$addr = $1;
	@user_addr = split(/,/,$addr);
}
($latest_phase,$latest_authority) = ($1,$2) if $data =~ /^(\d+):([^:\x0A]*):/;
$latest_phase = 0 if !$latest_phase;
if ($this->{'charge'} && $latest_phase && $latest_authority ne $main::email && !$this->is_secure('tools')) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ⱦ') . '򹹿ǤޤǤå¤ޤ');
	return $this->_update_error($is_ajax);
}
if (($latest_phase && $main::phase && (
		(($latest_phase == 999 || $this->{'phase'}{$latest_phase}{'aftercancel'}) && !$this->{'phase'}{$main::phase}{'aftercancel'}) || 
		($latest_phase != 999 && !$this->{'phase'}{$latest_phase}{'aftercancel'} && $this->{'phase'}{$main::phase}{'aftercancel'})
	)
)) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ⱦ') . '򹹿ǤޤǤƤ꤬ޤ');
	return $this->_update_error($is_ajax);
}
if ($main::phase && $main::phase == 999) {
	if (!$this->is_authorized(@user_addr) && (!$this->{'masterCancelEnabled'} || !$this->is_secure_user)) {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ⱦ') . '򹹿ǤޤǤ󥻥븢¤ޤ');
		return $this->_update_error($is_ajax);
	} elsif ($latest_phase && !$this->{'cancelAlwaysEnabled'} && $this->{'phase'}{$latest_phase}{'suspend'}) {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ⱦ') . '򹹿ǤޤǤѹػߤƤޤ');
		return $this->_update_error($is_ajax);
	}
}
if ($this->{'comment'} && length $main::comment > 200) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ⱦ') . '򹹿ǤޤǤȤĹޤ100ˤƤ');
	$this->{'is_invalid_field'}{'comment'} = 1;
	return ($is_ajax) ? {
		'status'			=>	'error',
		'error_fields'		=>	'comment',
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level
	} : 0;
}
$main::comment =~ s/\s+/ /sg;

#åԥ󥰥Ȥν
if ($default::type && $default::type eq 'order') {
	my(%order,$order_info,@info);
	tie(%order, $env::dbm_file, $db . '/order', O_RDONLY, $env::dbm_mode);
	$order_info = $order{$n} if ref tied %order && defined $order{$n} && $order{$n};
	untie(%order);
	if ($order_info && $order_info =~ /^(.*?)\x0A/s) {
		#($total,$tax,$fee,$carriage,$carriage_total,$download_key,$ptime,$transaction_id,$status,$dc_only,$expense)
		my @info = split(/\x09/,$1);

		#ʧλϿ
		if ($this->{'phase'}{$main::phase}{'paid'}) {
			if (!$info[6]) {
				if ($info[7]) {
					my $paypal = $this->use_paypal;
					my($transaction_id,$ptime) = $paypal->do_capture($info[7],$info[0],'Complete');
					if (!$ptime) {
						push(@{$cgi::action->{'dialog'}},$paypal->errors('all'));
						return $this->_update_error($is_ajax);
					}
					push(@{$cgi::action->{'dialog'}},'PayPal ˤʧλޤ');
					$info[7] = $transaction_id;
					$info[8] = 'Completed';
					$main::comment .= (($main::comment) ? '' : '') . 'ʧλ(PayPal)' if $this->{'comment'} && length $main::comment < 170;
				}
				$info[6] = time;
				my $info = join("\x09",map(((defined $_) ? $_ : ''),@info));
				$order_info =~ s/^(.*?)\x0A/$info\x0A/s;
				tie(%order, $env::dbm_file, $db . '/order', O_RDWR, $env::dbm_mode);
				$order{$n} = $order_info if ref tied %order;
				untie(%order);
			}

		#ȤȤ᤹
		} elsif ($main::phase == 999 && $this->{'cancelSC'}) {
			if ($info[6]) {
				push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ⱦ') . '򹹿ǤޤǤ˻ʧλƤΤǥ󥻥Ǥޤ');
				return $this->_update_error($is_ajax);
			} else {
				if ($info[7] && (!$info[8] || $info[8] ne 'Canceled')) {
					my $paypal = $this->use_paypal;
					if (!$paypal->do_void($info[7])) {
						push(@{$cgi::action->{'dialog'}},$paypal->errors('all'));
						return $this->_update_error($is_ajax);
					}
					push(@{$cgi::action->{'dialog'}},'PayPal ˤʧ򥭥󥻥뤷ޤ');
					$info[8] = 'Canceled';
					my $info = join("\x09",map(((defined $_) ? $_ : ''),@info));
					$order_info =~ s/^(.*?)\x0A/$info\x0A/s;
					tie(%order, $env::dbm_file, $db . '/order', O_RDWR, $env::dbm_mode);
					$order{$n} = $order_info if ref tied %order;
					untie(%order);
					$main::comment .= (($main::comment) ? '' : '') . 'ʧ󥻥(PayPal)' if $this->{'comment'} && length $main::comment < 170;
				}
				if (!ref $cgi::CartController) {
					require CMONOS::CGI_Lib::CartController;
					$cgi::CartController = CartController->new;
				}
				$cgi::CartController->restore($order_info,$default::file . '/download');
			}
		}
	}
}

#Ⱦ
if ($latest_phase == $main::phase) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ⱦ') . '򹹿ǤޤǤ˹Ƥޤ');
	return $this->_update_error($is_ajax);
} else {
	tie(%db, $env::dbm_file, $db . '/' . $this->{'id'}, O_RDWR | O_CREAT, $env::dbm_mode);
	if (!ref tied %db) {
		push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : 'Ⱦ') . '򹹿ǤޤǤǡ١³ǤޤǤ');
		return $this->_update_error($is_ajax);
	}
	$db{$n} = $addr . "\x0A" . $main::phase . ':' . (($main::email) ? $main::email : $env::master_email) . ':' . time . ':' . (($this->{'comment'}) ? (defined $main::comment) ? $main::comment : '' : '') . "\x0A" . $data;
	$content = $db{$n} if $is_ajax;
	untie %db;
}

#ͽ/
if ($this->{'phase'}{$main::phase}{'expire'} || ($main::phase == 999 && $this->{'cancelExpire'})) {
	tie(%db, $env::dbm_file, $db . '/expire', O_RDWR | O_CREAT, $env::dbm_mode);
	if (ref tied %db) {
		$db{$n} = time + $this->{'lifetime'};
	}
	untie %db;
} else {
	tie(%db, $env::dbm_file, $db . '/expire', O_RDWR, $env::dbm_mode);
	if (ref tied %db) {
		delete $db{$n};
	}
	untie %db;
}

#Υ᡼
if (ref $this->{'mailto'} && @{$this->{'mailto'}} && $this->{'phase'}{$main::phase}{'msg'}) {
	my(@mailto);
	foreach my $id (@{$this->{'mailto'}}) {
		if (ref $this->{'field_obj'}{$id} && $this->{'field_obj'}{$id}->{'e-mail'}) {
			my(%mail);
			tie(%mail, $env::dbm_file, $db . '/' . $this->{'field_obj'}{$id}->db, O_RDONLY, $env::dbm_mode);
			push(@mailto,$this->get_address($mail{$n})) if ref tied %mail && defined $mail{$n} && $mail{$n};
			untie(%mail);
		}
	}
	if (@mailto) {
		my($subject,$msg,$name,$bcc,$phase,$email,$script_name,$url,$input,$record,$register_url);
		$subject = ($this->{'phase'}{$main::phase}{'subject'}) ? $this->{'phase'}{$main::phase}{'subject'} : '<phase> ΤΤ餻';
		$msg = $this->{'phase'}{$main::phase}{'msg'};
		$record = $c * 1000000 + $n;
		$subject =~ s/<record>/$record/igs;
		$msg =~ s/<record>/$record/igs;
		$phase = $this->phase_distiller($this->get_phase_name($main::phase));
		$subject =~ s/<phase>/$phase/igs;
		$msg =~ s/<phase>/$phase/igs;
		$subject =~ s/<comment>/$main::comment/igs;
		$msg =~ s/<comment>/$main::comment/igs;
		if ($subject =~ /<name>/i || $msg =~ /<name>/i) {
			$name = ($default::english) ? 'you' : 'ʤ';
			if (defined $this->{'field_for'}{'name'} && $this->{'field_for'}{'name'}) {
				my(%name);
				tie(%name, $env::dbm_file, $db . '/' . $this->{'field_obj'}{$this->{'field_for'}{'name'}}->db, O_RDONLY, $env::dbm_mode);
				$name = $name{$n} if defined $name{$n} && $name{$n} ne '';
				untie(%name);
			}
			$subject =~ s/<name>/$name/igs;
			$msg =~ s/<name>/$name/igs;
		}
		if ($subject =~ /<key>/i || $msg =~ /<key>/i) {
			my $key = ($default::english) ? 'this' : '';
			if (defined $this->{'field_for'}{'key'} && $this->{'field_for'}{'key'}) {
				my(%key);
				tie(%key, $env::dbm_file, $db . '/' . $this->{'field_obj'}{$this->{'field_for'}{'key'}}->db, O_RDONLY, $env::dbm_mode);
				$key = $key{$n} if defined $key{$n} && $key{$n} ne '';
				untie(%key);
			}
			$subject =~ s/<key>/$key/igs;
			$msg =~ s/<key>/$key/igs;
		}
		if ($subject =~ /<title>/i || $msg =~ /<title>/i) {
			my $title = ($default::english) ? 'this' : '';
			if (defined $this->{'field_for'}{'title'} && $this->{'field_for'}{'title'}) {
				my(%title);
				tie(%title, $env::dbm_file, $db . '/' . $this->{'field_obj'}{$this->{'field_for'}{'title'}}->db, O_RDONLY, $env::dbm_mode);
				$title = $title{$n} if defined $title{$n} && $title{$n} ne '';
				untie(%title);
			}
			$subject =~ s/<title>/$title/igs;
			$msg =~ s/<title>/$title/igs;
		}
		if ($msg =~ /<data>/i) {
			my($list,$file_dir);
			$file_dir = "$default::file/$c/$n";
			foreach my $id (sort {$this->{'field_obj'}->{$a}->{'ORDER'} <=> $this->{'field_obj'}->{$b}->{'ORDER'} || $a <=> $b} keys %{$this->{'field_obj'}}) {
				next if !$this->{'field_obj'}{$id}->format_for_mail_enabled;
				my(%data);
				tie(%data, $env::dbm_file, $db . '/' . $this->{'field_obj'}{$id}->db, O_RDONLY, $env::dbm_mode);
				$list .= $this->{'field_obj'}{$id}->format_for_mail($data{$n},$file_dir,$c,$n);
				untie(%data);
			}
			$msg =~ s/<data>/$list/igs;
		}
		$this->set_authority_name;
		$email = ($this->{'authority_name'}{$main::email} ne '') ? $this->{'authority_name'}{$main::email} . ' <' . $main::email . '>' : $main::email if defined $main::email && $main::email;
		$subject =~ s/<checker>/$email/igs;
		$msg =~ s/<checker>/$email/igs;

		$script_name = $this->my_url;
		$url = $script_name . '?m=DetailViewer&c=' . $c . '&n=' . $n;
		$msg =~ s/<url>/$url/igs;
		$input = ($this->{'phase'}{$main::phase}{'suspend'}) ? $url : $script_name . '?m=Input&k=input&c=' . $c . '&n=' . $n;
		$msg =~ s/<input>/$input/igs;
		$register_url = $this->http_my_domain . $this->path_change($env::register_cgi,$ENV{'SCRIPT_NAME'},'abs');
		$msg =~ s/<register>/$register_url/igs;
		unless (ref $cgi::SendMail) {
			require CMONOS::CGI_Lib::SendMail;
			$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
		}
		foreach (@mailto) {
			$bcc .= ',' if defined $bcc && $bcc ne '';
			$bcc .= ($name && $name ne 'you' && $name ne 'ʤ') ? $name . ' <' . $_ . '>' : $_;
		}
		$cgi::SendMail->send_mail(
			'Bcc'		=>  $bcc,
			'From'		=>  (($email) ? $email : (($setting::general{'master'}) ? (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}) : $env::master_email)),
			'Subject'	=>  $subject,
			'message'	=>  $msg . "\x0A\x0A",
			'info'		=>  0
		);
	}
}
if ($this->{'notice'} || $main::phase == 999) {
	my(@addr);
	push(@addr,$env::master_email);
	push(@addr,$setting::general{'master'}) if $setting::general{'master'} && $this->{'checkerLevel'} && ($this->{'checkerLevel'} eq 'owner' || $this->{'checkerLevel'} eq 'owners' || $this->{'checkerLevel'} eq 'member');
	push(@addr,$setting::general{'owners'}) if $setting::general{'owners'} && $this->{'checkerLevel'} && ($this->{'checkerLevel'} eq 'owners' || $this->{'checkerLevel'} eq 'member');
	push(@addr,$this->{'authority'}) if $this->{'authority'} && $this->{'checkerLevel'} && $this->{'checkerLevel'} eq 'member';
	@addr = $this->get_address(@addr);
	if (@addr) {
		unless (ref $cgi::SendMail) {
			require CMONOS::CGI_Lib::SendMail;
			$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
		}
		$cgi::SendMail->send_mail(
			'Bcc'		=>  join(',',@addr),
			'From'		=>  (($main::email) ? $main::email : (($setting::general{'master'}) ? (($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'}) : $env::master_email)),
			'Subject'	=>  '' . $this->name . '' . $this->phase_distiller($this->get_phase_name($main::phase)),
			'message'	=>  $this->my_url . '?m=DetailViewer&c=' . $c . '&n=' . $n . "\x0A\x0A" . (($main::comment) ? '[]' . "\x0A" . $main::comment . "\x0A\x0A" : ''),
			'info'		=>  1
		);
	}
}
$this->post_update;
if ($is_ajax) {
	return {
		'status'			=>	'success',
		'content'			=>	$this->get_oparation_phase_log(\$content),
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level,
		'hide_form'			=>	(($main::phase && $main::phase == 999) ? 1 : 0)
	};
} else {
	return 1;
}
}

sub editor_enabled ($) {
my $this = shift;
return 0;
}

sub use_paypal ($) {
my $this = shift;
$this->import_db($default::preference_dir . '/terms',\%setting::payment,1) if !%setting::payment;
require CMONOS::TableMaker::CheckOutAPI::PayPal;
return PayPal->new(
	$setting::payment{'paypal'}{'username'},
	$setting::payment{'paypal'}{'password'},
	$setting::payment{'paypal'}{'signature'},
	'JPY',
	$setting::payment{'paypal'}{'sandbox'},
);
}

######################################################################
#sub import {
BEGIN {
if (!$setting::field_for_mail) {
	Field::class_register('xtm_checker','Checker','Ⱦå');
	$setting::deco_dir{'submit'} = ' ܥ';
	$setting::deco_type{'submit'} = 'button';
	$setting::deco_dir{'cancel'} = '󥻥 ܥ';
	$setting::deco_type{'cancel'} = 'button';
}
}

1;
