package GoogleMaps;
require CMONOS::CGI_Lib::Field::GoogleMapsBase;
@ISA = qw(GoogleMapsBase);
use strict;
######################################################################
# ե⥸塼Googleޥåס
# GoogleMaps.pm 1.1.1
# Copyright (C) 2007-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-01-25
######################################################################
#	(4) obj->usual_format(str);
sub format_for_detail {
my($this,$str,$path,$c,$n) = @_;
return $this->field_tag('') if !defined $str || $str eq '';
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
delete $this->{'indexmap'} if defined $this->{'field_for'}{'coordinates'} && $this->{'field_for'}{'coordinates'} ne $this->{'id'};
if (%data) {
	my $static_map = $this->get_static_map(\%data);
	if ($data{'enabled'}) {
		$data{'mk'} = $this->full_path($path) . '/' . $data{'mk'} if $data{'mk'} && $data{'mk'} !~ /^https?:\/\//i;
		if ((!$this->{'showKml'} || $data{'fit'} || ($data{'m'} && $this->{'mHasPriority'})) && $data{'kml'}) {
			$data{'url'} = $this->full_path($path . '/' . $this->{'id'} . '.kml');
		} elsif ((!$data{'m'} || !$this->{'mHasPriority'}) && defined $this->{'field_for'}{'coordinates'} && $this->{'field_for'}{'coordinates'} eq $this->{'id'}) {
			$data{'url'} = $this->full_path($cgi::path . '?m=KMLViewer' . ((defined $c) ? '&c=' . $c : '') . ((defined $n) ? '&n=' . $n : '') . $this->set_query('url+',['mod','s','w','f','u','uni','and','search','q','fv']));
			$data{'opener_url'} = $this->my_url . '?m=DetailViewer&c=' . $c . '&n=' . $n;
			$data{'r'} = 1;
			$data{'tr'} = 'p';
			delete $data{'fit'};
			delete $data{'mk'};
			delete $data{'mka'};
			delete $data{'mkv'};
			delete $data{'m'};
		}
	}
	return $this->field_tag(
		(($data{'enabled'} && ($data{'url'} || $data{'c'})) ? 
			$this->gmap_iframe(
				\%data,
				$this->mk_user_generated_field_id($c,$n),
				(($this->{'maxwidth'} && $this->{'maxwidth'} < $this->{'viewerWidth'}) ? $this->{'maxwidth'} : $this->{'viewerWidth'}),
				$this->{'viewerHeight'},
				$this->{'viewerOverView'},
				$this->{'viewerStreetView'},
				$this->{'viewerGSearch'},
				$this->{'viewerLinkTarget'}
			) . $static_map : '')
	);
} else {
	return $this->field_tag('');
}
}

sub print_additional_comment_setting_form ($;$) {
my($this,$name) = @_;
if (defined $this->{'field_for'}{'coordinates'} && $this->{'field_for'}{'coordinates'} eq $this->{'id'}) {
	print '<fieldset>';
	print '<legend>ܺɽ</legend>';
	print '<label><input type="checkbox" name="' . $name . '_mHasPriority" id="' . $name . '_mHasPriority" value="1"' . (($this->{'mHasPriority'}) ? ' checked="checked"' : '') . ' /> 濴ɸȤͥ褹</label>';
	print '</fieldset>';
}
}

sub print_additional_gmap_option ($$) {
my($this,$name) = @_;
print '<fieldset><legend>Googleޥåץǥå</legend><label><input type="checkbox" name="' . $name . '_showKml" id="' . $name . '_showKml" value="1"' . (($this->{'showKml'}) ? ' checked="checked"' : '') . ' /> ǥåǤ KML ɽ</label></fieldset>';
}

sub _is_valid_setting ($) {
my $this = shift;
$main::data{$this->{'id'} . '_mHasPriority'} = '0' if !$main::data{$this->{'id'} . '_mHasPriority'};
$main::data{$this->{'id'} . '_showKml'} = '0' if !$main::data{$this->{'id'} . '_showKml'};
return 1;
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('webapi_gmap','GoogleMaps','Googleޥå') if !$setting::field_for_mail;
}


1;
