package Pending;
require CMONOS::TableMaker::Field::TMUserGeneratedField;
require CMONOS::CGI_Lib::Field::UserGeneratedField;
@ISA = qw(TMUserGeneratedField UserGeneratedField);
use strict;
use Time::Local;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# ե⥸塼ʸ/֡
# Pending.pm 1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-08-11
######################################################################
sub __set ($$) {
my $this = shift;
if (!ref $cgi::Deco) {
	require CMONOS::CGI_Lib::Deco;
	$cgi::Deco = Deco->new;
}
if (!ref $cgi::Image) {
	require CMONOS::CGI_Lib::Image;
	$cgi::Image = Image->new;
}
$this->{'field_for'}{'pending'} = $this->{'id'};
$this->scalar_to_array(\$this->{'mailto'});
$this->{'Hidden'} = 1 if ref $cgi::action && !$cgi::action->is_secure('pending') && !$cgi::action->is_secure('tools');
return;
}

sub pending_status ($$;$$) {
my($this,$status,$date_required,$notag) = @_;
my($is_pending,$start,$end,$expires) = split(/\-/,$status);
return $this->_pending_status($is_pending,$start,$end,$expires,$date_required);
}

sub _pending_status ($$$$$;$$) {
my($this,$is_pending,$start,$end,$expires,$date_required,$notag) = @_;
my $info;
if ($expires) {
	my $lifetime = int(($expires - time) / 86400);
	$info = (($notag) ? '' : '<strong>') . '/' . (($lifetime > 0) ? $lifetime . '' : '24ְ') . '˺ͽ' . (($notag) ? '' : '</strong>');
} else {
	$info = ($is_pending) ? ($default::english) ? 'Pending.' : '' : ($default::english) ? 'Published.' : '';
}
if ($this->{'schedulingEnabled'} && $date_required && ($start || $end)) {
	return (($start) ? $this->date($start,(($notag) ? 0 : 3),'gmt' . $this->{'datetype'}) : '') . (($default::english) ? ' - ' : '') . (($end) ? $this->date($end,(($notag) ? 0 : 3),'gmt' . $this->{'datetype'}) : '') . ' (' . $info. ')';
} else {
	return $info;
}
}

# --------------------------------------------------------------------
#	(0)-3 бDB
sub db ($) {
my $this = shift;
return 'pending';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
my $this = shift;
return 1 if !$this->{'Hidden'} && defined $main::search{$this->{'id'}}{'str'} && $main::search{$this->{'id'}}{'str'} ne '';
return 0
}

#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
return 1 if !$this->match_enabled;
my $is_pending = ($$str && $$str =~ /^1/) ? 1 : 0;
return (($main::search{$this->{'id'}}{'str'} && $is_pending) || (!$main::search{$this->{'id'}}{'str'} && !$is_pending)) ? 1 : 0;
}

######################################################################
#	(2) obj->form;
sub input_enabled ($) {
my $this = shift;
return ($cgi::action->{'new_data'} || $this->is_secure_user) ? 1 : 0;
}

sub form {
my($this,$status,$original,$path) = @_;
return $this->field_header . $this->pending_info($main::data{$this->{'id'}}{'str'},$main::c,$main::n,((!defined $status || $status eq '') ? 1 : 0),1) . $this->field_footer;
}

sub pending_info ($$$$;$$) {
my($this,$str,$c,$n,$is_new_record,$noform) = @_;
my $form = '';
my $id = $this->mk_user_generated_field_id($c,$n);
if (!$noform && $this->is_secure_user) {
	my @required = grep($_ ne 'n' && $_ ne 'c' && $_ ne 'id',@setting::form);
	push(@required,'ct') if !grep($_ eq 'ct',@required);
	@main::ct = @main::c if !@main::ct && @main::c;
	$form .= $this->form_start(
		'key'		=>	(($setting::security_key) ? $setting::security_key : ''),
		'id'		=>	(($id) ? $id . '-form' : ''),
		'name'		=>	(($id) ? $id . '-form' : ''),
		'method'	=> 'post',
		'onsubmit'	=>	'return cmonos.form.item(this).submit(\'' . $id . '\');',
		'required'	=>	\@required
	);
	$form .= '<input type="hidden" name="id" value="' . $this->{'id'} . '" />';
	$form .= '<input type="hidden" name="n" value="' . $n . '" />';
	$form .= '<input type="hidden" name="c" value="' . $c . '" />';
}
if ($this->{'schedulingEnabled'}) {
	if ($this->is_secure_user) {
		$str = ($is_new_record) ? ($this->{'pendingTime'}) ? '1-' . (time + $this->{'pendingTime'}) . '-0' : 0 : 0 if !defined $str || $str eq '';
		my($is_pending,$start,$end,$expires) = split(/\-/,$str);
		$form .= $this->datetime_form($start,$id,'f',(($noform) ? 0 : 1)) . (($default::english) ? ' - ' : '  ') . $this->datetime_form($end,$id,'t',(($noform) ? 0 : 1));
		$form .= ' (<span id="' . $id . '">' . $this->_pending_status($is_pending,$start,$end,$expires) . '</span>)';
	} elsif ($is_new_record) {
		if ($this->{'pendingTime'}) {
			$form .= $this->pending_status('1-' . (time + $this->{'pendingTime'}) . '-0');
		} else {
			$form .= $this->pending_status(0);
		}
	} else {
		$form .= $this->pending_status($str);
	}
} else {
	if ($this->is_secure_user) {
		if ($noform) {
			$form .= '<label><input type="checkbox" name="data:' . $this->{'id'} . ':str" value="1"' . ((($is_new_record && $this->{'default'}) || ($str && $str =~ /^1/)) ? ' checked="checked"' : '') . ' /> ' . $this->pending_status(1) . '</label>';
		} else {
			$form .= $this->pending_menu('pending',$str);
		}
	} elsif ($is_new_record) {
		$form .= $this->pending_status($this->{'default'});
	} else {
		$form .= $this->pending_status($str);
	}
}
if (!$noform && $this->is_secure_user) {
	$form .= $cgi::Deco->submit_button('submit',$this->{'button'},(($default::english) ? 'Submit' : ''),{'id' => $id . '-submit'});
	$form .= '</form>';
}
return $form;
}

sub datetime_form ($$$$;$) {
my($this,$t,$id,$prefix,$is_updater) = @_;
my($name,$form,$min,$h,$d,$m,$y,$year);
if ($t) {
	($min,$h,$d,$m,$y) = (localtime($t))[1..5];
	$m++;
	$y += 1900;
} else {
	($min,$h,$d,$m,$y) = ('','','','','');
}
if ($is_updater) {
	$name = $prefix;
} else {
	$name = 'data:' . $this->{'id'} . ':' . $prefix;
}
$id .= '-' . $name;
$year = (localtime(time))[5] + 1900;

#ǯ
$form .= '<label>';
$form .= ' Year ' if defined $default::english && $default::english;
$form .= '<select name="' . $name . 'y" id="' . $id . 'y">';
$form .= '<option value=""></option>';
for (my $i=$year-10; $i<=$year+10; $i++) {
	$form .= '<option value="' . $i . '"' . (($y ne '' && $i == $y) ? ' selected="selected"' : '') . '>' . $i . '</option>';
}
$form .= '</select>';
$form .= ($default::english) ? '</label>, ' : 'ǯ</label>';

#
my(@mon);
if (defined $defaut::english && $defaut::english) {
	@mon = ('','January','February','March','April','May','June','July','August','September','October','November','December');
} else {
	@mon = ('','1','2','3','4','5','6','7','8','9','10','11','12');
}
$form .= '<label><select name="' . $name . 'm" id="' . $id . 'm">';
$form .= '<option value=""></option>';
foreach my $i (1..12) {
	$form .= '<option value="' . $i . '"' . (($m ne '' && $i == $m) ? ' selected="selected"' : '') . '>' . $mon[$i] . '</option>';
}
$form .= '</select>';
$form .= ($default::english) ? '</label> ' : '</label>';

#
$form .= '<label><select name="' . $name . 'd" id="' . $id . 'd">';
$form .= '<option value=""></option>';
foreach my $i (1..31) {
	$form .= '<option value="' . $i . '"' . (($d ne '' && $i == $d) ? ' selected="selected"' : '') . '>' . $i . '</option>';
}
$form .= '</select>';
$form .= ($default::english) ? 'th</label>, ' : '</label>';
$form .= '<a href="javascript:void(0)" onclick="cmonos.tool.calendarPalette.open(\'' . $id . 'y\',\'' . $id . 'm\',\'' . $id . 'd\')" title="åȥդǤޤ"><img src="' . $env::image_dir . '/tool/calendar.gif" width="15" height="15" border="0" alt="ѥͥ" /></a>';

#
$form .= '<label><select name="' . $name . 'h" id="' . $id . 'h">';
$form .= '<option value=""></option>';
foreach my $i (0..23) {
	$form .= '<option value="' . $i . '"' . (($h ne '' && $i == $h) ? ' selected="selected"' : '') . '>' . $i . '</option>';
}
$form .= '</select>';
$form .= '' if !defined $default::english || !$default::english;
$form .= '</label>';

$form .= ':' if defined $default::english && $default::english;

#ʬ
$form .= '<label><select name="' . $name . 'min" id="' . $id . 'min">';
$form .= '<option value=""></option>';
foreach my $i (0..59) {
	$form .= '<option value="' . $i . '"' . (($min ne '' && $i == $min) ? ' selected="selected"' : '') . '>' . $i . '</option>';
}
$form .= '</select>';
$form .= 'ʬ' if !defined $default::english || !$default::english;
$form .= '</label>';

return $form;
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
my $this = shift;
my $was_pending = 0;
if (defined $main::n && $main::n ne '') {
	my %db;
	tie(%db, $env::dbm_file, "$default::db/$main::c/pending", O_RDONLY, $env::dbm_mode);
	$was_pending = (ref tied %db && $db{$main::n} && $db{$main::n} =~ /^1/) ? 1 : 0;
	untie %db;
}
if ($this->is_secure_user) {
	my($start,$end,$is_pending);
	if ($this->{'schedulingEnabled'}) {
		($is_pending,$start,$end) = $this->get_pending_data_from(
			$main::data{$this->{'id'}}{'fmin'},$main::data{$this->{'id'}}{'fh'},$main::data{$this->{'id'}}{'fd'},$main::data{$this->{'id'}}{'fm'},$main::data{$this->{'id'}}{'fy'},
			$main::data{$this->{'id'}}{'tmin'},$main::data{$this->{'id'}}{'th'},$main::data{$this->{'id'}}{'td'},$main::data{$this->{'id'}}{'tm'},$main::data{$this->{'id'}}{'ty'}
		);
	} else {
		$is_pending = ($main::data{$this->{'id'}}{'str'}) ? 1 : 0;
		$start = $end = '';
	}
	$main::data{$this->{'id'}} = {'str' => $is_pending . '-' . $start . '-' . $end};
	$this->{'pending_record_counter'} = ($is_pending) ? 1 : -1 if $was_pending != $is_pending;
} elsif (defined $main::n && $main::n ne '') {
	$main::data{$this->{'id'}}{'str'} = $was_pending;
} else {
	if ($this->{'schedulingEnabled'}) {
		$this->{'pending_record_counter'} = 1 if $this->{'pendingTime'};
		$main::data{$this->{'id'}}{'str'} = ($this->{'pendingTime'}) ? '1-' . (time + $this->{'pendingTime'}) . '-0' : 0;
	} else {
		$this->{'pending_record_counter'} = 1 if $this->{'default'};
		$main::data{$this->{'id'}}{'str'} = ($this->{'default'}) ? 1 : 0;
	}
}
return 1;
}

sub get_pending_data_from($$$$$$$$$$$) {
my($this,$fmin,$fh,$fd,$fm,$fy,$tmin,$th,$td,$tm,$ty) = @_;
my($is_pending,$start,$end,$time);
$start = $this->get_gmttime_from_datetime($fmin,$fh,$fd,$fm,$fy);
$end = $this->get_gmttime_from_datetime($tmin,$th,$td,$tm,$ty);
($start,$end) = ($end,$start) if $start && $end && $start > $end;
$time = time;
$is_pending = ((!$start || $start < $time) && (!$end || $time < $end)) ? 0 : 1;
return($is_pending,$start,$end);
}

sub get_gmttime_from_datetime ($$$$$$) {
my($this,$min,$h,$d,$m,$y) = @_;
if (!$this->is_nan($y) && $y && $d) {
	my $year = (localtime(time))[5] + 1900;
	$m = 1 if $this->is_nan($m);
	$y = ($year + 10 < $y) ? $year + 10 : ($year - 10 > $y) ? $year - 10 : $y;
	return timelocal(
		0,
		(($this->is_nan($min)) ? 0 : ($min >= 0 && $min < 60) ? $min : 0),
		(($this->is_nan($h)) ? 0 : ($h >= 0 && $h < 60) ? $h : 0),
		(($this->is_nan($d)) ? 1 : ($this->is_impossible_mday($y,$m,$d)) ? $this->max_mday($y,$m) : $d),
		(($m) ? $m-1 : 0),
		$y
	);
} else {
	return 0;
}
}

sub settle_up ($$) {
my $this = shift;
if ($this->{'pending_record_counter'}) {
	$this->counter_fix($main::c,$main::n,$this->{'pending_record_counter'});
	$cgi::action->index_sweeper($main::c,$main::n) if $this->{'pending_record_counter'} == 1;
}
}

######################################################################
#	obj->is_secure;
sub is_secure_user ($) {
my $this = shift;
return ($cgi::action->is_secure('pending') && $this->is_as_secure_as($this->{'checkerLevel'})) ? 1 : 0;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=ɽǡ/path=ե¸ǥ쥯ȥ
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return $this->field_tag(
	$this->style(
		$this->pending_info($str,$c,$n),
		$this->{'style'},
		$this->{'fontsize'},
		$this->{'fontcolor'},
		$this->{'fontface'}
	)
);
}

sub has_content {
my $this = shift;
return 1;
}

sub pending_menu ($$$;$) {
my($this,$name,$is_pending,$is_search) = @_;
$is_pending = ($is_pending && $is_pending =~ /^1/) ? 1 : 0 if !$is_search;
my $menu = '<select name="' . $name . '">';
$menu .= '<option value=""></option>' if $is_search;
$menu .= '<option value="1"' . (($is_pending) ? ' selected="selected"' : '') . '>' . $this->pending_status(1) . '</option>';
$menu .= '<option value="0"' . ((!$is_pending && (!$is_search || (defined $is_pending && $is_pending eq '0'))) ? ' selected="selected"' : '') . '>' . $this->pending_status(0) . '</option>';
$menu .= '</select>';
return $menu;
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return '[' . $this->name . "]\x0A" . $this->pending_status($str) . "\x0A\x0A";
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return $this->pending_status($str,1);
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$) {
my($this,$str) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return $this->field_tag(
	$this->style(
		$this->pending_status($str,1),
		$this->{'style'},
		$this->{'fontsize'},
		$this->{'fontcolor'},
		$this->{'fontface'}
	)
);
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my $this = shift;
my($name);

#̾
$name = 'data:' . $this->{'id'};

$this->print_field_info_form($name);

print '<fieldset>';
print '<legend><label><input type="radio" name="' . $name . '_schedulingEnabled" value="0" ' . ((!$this->{'schedulingEnabled'}) ? ' checked="checked"' : '') . ' /> </label></legend>';
print '<label><input type="checkbox" name="' . $name . '_default" id="' . $name . '_default" value="1" ' . ((defined $this->{'default'} && $this->{'default'}) ? ' checked="checked"' : '') . ' /> ǥեȤȤ</label>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label><input type="radio" name="' . $name . '_schedulingEnabled" value="1" ' . (($this->{'schedulingEnabled'}) ? ' checked="checked"' : '') . ' /> ֻ</label></legend>';
print '<fieldset>';
print '<legend><label for="' . $name . '_datetype">ɽ</label></legend>';
$this->print_date_type_menu($name . '_',$this->{'datetype'});
print '</fieldset>';
print '<fieldset>';
print '<legend>ǥե</legend>';
print $this->mk_select_menu(
	$name . '_pendingTime','','',((defined $this->{'pendingTime'}) ? $this->{'pendingTime'} : ''),
	''			=>		'˸',
	86400		=>		'24ָ˸',
	172800		=>		'48ָ˸',
	604800		=>		'1ָ˸',
	1209600		=>		'2ָ˸',
	2678400		=>		'1˸',
	5270400		=>		'2˸',
	8208000		=>		'3˸',
	10540800	=>		'4˸',
	13219200	=>		'5˸',
	15811200	=>		'6˸',
	18489600	=>		'7˸',
	21081600	=>		'8˸',
	23760000	=>		'9˸',
	26352000	=>		'10˸',
	29030400	=>		'11˸',
	31536000	=>		'1ǯ˸',
	47347200	=>		'1ǯ6˸',
	63072000	=>		'2ǯ˸',
	94608000	=>		'3ǯ˸'
);
print '</fieldset>';
print '<fieldset>';
print '<legend>ֽλν</legend>';
print $this->mk_select_menu(
	$name . '_margin','','',((defined $this->{'margin'}) ? $this->{'margin'} : ''),
	''			=>		'ưʤ',
	1			=>		'˺',
	60			=>		'1ʬʹߤ˼ư',
	86400		=>		'1ʹߤ˼ư',
	604800		=>		'1ָʹߤ˼ư',
	1209600		=>		'2ָʹߤ˼ư',
	2678400		=>		'1ʹߤ˼ư',
	5270400		=>		'2ʹߤ˼ư',
	8208000		=>		'3ʹߤ˼ư',
	10540800	=>		'4ʹߤ˼ư',
	13219200	=>		'5ʹߤ˼ư',
	15811200	=>		'6ʹߤ˼ư',
	18489600	=>		'7ʹߤ˼ư',
	21081600	=>		'8ʹߤ˼ư',
	23760000	=>		'9ʹߤ˼ư',
	26352000	=>		'10ʹߤ˼ư',
	29030400	=>		'11ʹߤ˼ư',
	31536000	=>		'1ǯʹߤ˼ư',
	47347200	=>		'1ǯ6ʹߤ˼ư',
	63072000	=>		'2ǯʹߤ˼ư',
	94608000	=>		'3ǯʹߤ˼ư'
);
print '<div class="note">˺륿ߥ󥰤Ͽ쥳ɤϿ줿ȤȤʤޤưꤵ줿֤ѹȡư꤬ޤ</div></fieldset>';
print '</fieldset>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label for="' . $name . '_checkerLevel">/ ѹ¤Τ桼</label></legend>';
print $this->mk_select_menu(
	$name . '_checkerLevel','','',$this->{'checkerLevel'},$this->checker_level_list
);
print '</fieldset>';

print '<fieldset>';
print '<legend>ܥ</legend>';
print $cgi::Deco->button_menu(
	$name . '_button',
	'submit',
	120,
	$this->{'button'}
);
print '</fieldset>';

print '<fieldset>';
print '<legend>/ ѹν</legend>';
print '<label><input type="checkbox" name="' . $name . '_mTime" id="' . $name . '_mTime" value="1" ' . ((defined $this->{'mTime'} && $this->{'mTime'}) ? ' checked="checked"' : '') . ' /> / ѹ˹ǡ١򹹿롣</label>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label for="' . $name . '_mailto">/ ѹΥ᡼</label></legend>';
print '<select name="' . $name . '_mailto" id="' . $name . '_mailto" multiple="multiple">';

print '<option value="master"' . ((ref $this->{'mailto'} && grep($_ eq 'master',@{$this->{'mailto'}})) ? ' selected="selected"' : '') . '>ޥ</option>';
print '<option value="owner"' . ((ref $this->{'mailto'} && grep($_ eq 'owner',@{$this->{'mailto'}})) ? ' selected="selected"' : '') . '></option>';
print '<option value="owners"' . ((ref $this->{'mailto'} && grep($_ eq 'owners',@{$this->{'mailto'}})) ? ' selected="selected"' : '') . '>Ʊʡ</option>';

foreach my $id (sort {$this->{'field_obj'}->{$a}->{'ORDER'} <=> $this->{'field_obj'}->{$b}->{'ORDER'} || $a <=> $b} keys %{$this->{'field_obj'}}) {
	if (defined $this->{'field_obj'}{$id}->{'e-mail'} && $this->{'field_obj'}{$id}->{'e-mail'}) {
		print '<option value="' . $id . '"' . ((ref $this->{'mailto'} && grep($_ eq $id,@{$this->{'mailto'}})) ? ' selected="selected"' : '') . '>оݥ쥳ɤ ' . $this->{'field_obj'}{$id}->name . '</option>';
	}
}

print '</select>';
print '<div class="note">̵ξ硢εǽưޤ</div>';
print '</fieldset>';


$this->print_font_setting_form($name);
$this->print_setting_save_button;
return;
}

sub checker_level_list ($) {
my $this = shift;
$setting::security{'pending'}{'passwordCheck'} = 'owner' if !defined $setting::security{'pending'}{'passwordCheck'} || $setting::security{'pending'}{'passwordCheck'} eq '';
if ($setting::security{'pending'}{'passwordCheck'} eq 'master') {
	return (
		'master'	=>		'쥳ɱ¤Τ桼'
	);
} elsif ($setting::security{'pending'}{'passwordCheck'} eq 'owner') {
	return (
		'master'	=>		'ޥ',
		'owner'		=>		'쥳ɱ¤Τ桼()'
	);
} elsif ($setting::security{'pending'}{'passwordCheck'} eq 'owners') {
	return (
		'master'	=>		'ޥ',
		'owner'		=>		'',
		'owners'	=>		'쥳ɱ¤Τ桼(Ʊʡ)'
	);
} elsif ($setting::security{'pending'}{'passwordCheck'} eq 'member') {
	return (
		'master'	=>		'ޥ',
		'owner'		=>		'',
		'owners'	=>		'Ʊʡ',
		'member'	=>		'쥳ɱ¤Τ桼(ϿС)'
	);
} elsif ($setting::security{'pending'}{'passwordCheck'} eq 'nocheck') {
	return (
		'master'	=>		'ޥ',
		'owner'		=>		'',
		'owners'	=>		'Ʊʡ',
		'member'	=>		'ϿС',
		'nocheck'	=>		'쥳ɱ¤Τ桼(åʤ)'
	);
}
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my $is_valid = $this->is_valid_font_setting;

#Ĵ
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};

#åܥå
$main::data{$this->{'id'} . '_default'} = 0 if !defined $main::data{$this->{'id'} . '_default'} || !$main::data{$this->{'id'} . '_default'};
$main::data{$this->{'id'} . '_mTime'} = 0 if !defined $main::data{$this->{'id'} . '_mTime'} || !$main::data{$this->{'id'} . '_mTime'};
$main::data{$this->{'id'} . '_mailto'} = '' if !defined $main::data{$this->{'id'} . '_mailto'};
$main::data{$this->{'id'} . '_schedulingEnabled'} = 0 if !defined $main::data{$this->{'id'} . '_schedulingEnabled'} || !$main::data{$this->{'id'} . '_schedulingEnabled'};

return $is_valid;
}

######################################################################
#	(6) obj->search_form;
sub search_form ($) {
my $this = shift;
my $form = '<tr><td class="field-name"><label for="search:' . $this->{'id'} . ':str">' . $this->{'name'} . '</label></td><td class="field">';
$form .= $this->pending_menu('search:' . $this->{'id'} . ':str',$main::search{$this->{'id'}}{'str'},1);
$form .= '</td></tr>';
return $form;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(11) obj->update;
sub update_enabled ($) {
my $this = shift;
return 1;
}

sub is_secure_user_for_edit ($) {
my $this = shift;
return 0;
}

sub _update_error ($$) {
my($this,$is_ajax) = @_;
return ($is_ajax) ? {
	'status'			=>	'error',
	'message'			=>	$this->get_message_string,
	'authorized_level'	=>	$this->get_authorized_level
} : 0;
}

sub update ($;$) {
#no warnings qw(untie);
my($this,$is_ajax) = @_;
my($n,$c,%db,$was_pending,$info,$short_info);
$this->save_update_target;
$main::pending = 0 if !$main::pending;
if (!$this->is_secure_user) {
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : ($this->{'schedulingEnabled'}) ? '' : '') . '򹹿ǤޤǤ¤ޤ');
	return $this->_update_error($is_ajax);
}
$n = $main::n;
$c = $main::c;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
tie(%db, $env::dbm_file, $default::db . '/' . $c . '/pending', O_RDWR | O_CREAT, $env::dbm_mode);
if (!ref tied %db) {
	untie %db;
	push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : ($this->{'schedulingEnabled'}) ? '' : '') . '򹹿ǤޤǤǡ١³ǤޤǤ');
	return $this->_update_error($is_ajax);
}
$was_pending = ($db{$n} && $db{$n} =~ /^1/) ? 1 : 0;

#깹
if ($this->{'schedulingEnabled'}) {
	my($start,$end,$is_pending);
	($is_pending,$start,$end) = $this->get_pending_data_from(
		$main::fmin,$main::fh,$main::fd,$main::fm,$main::fy,
		$main::tmin,$main::th,$main::td,$main::tm,$main::ty
	);
	$db{$n} = $is_pending . '-' . $start . '-' . $end;
	untie %db;
	$info = $this->_pending_status($is_pending,$start,$end,0,1,1);
	$short_info = $this->_pending_status($is_pending,$start,$end,0,0,1);
	$this->counter_fix($c,$n,(($is_pending == $was_pending) ? 0 : ($is_pending) ? 1 : -1),(($is_pending || $this->{'mTime'}) ? 1 : 0));
} else {
	if (($was_pending && $main::pending) || (!$was_pending && !$main::pending)) {
		untie %db;
		push(@{$cgi::action->{'dialog'}},(($this->{'name'} ne '') ? $this->{'name'} : ($this->{'schedulingEnabled'}) ? '' : '') . '򹹿ǤޤǤ˹Ƥޤ');
		return $this->_update_error($is_ajax);
	} else {
		$db{$n} = ($main::pending) ? 1 : 0;
		untie %db;
		$info = $short_info = $this->pending_status($main::pending);
		$this->counter_fix($c,$n,(($main::pending) ? 1 : -1),(($main::pending || $this->{'mTime'}) ? 1 : 0));
	}
}

#Υ᡼
$this->pending_notice($info,$c,$n);

$this->post_update;
if ($is_ajax) {
	return {
		'status'			=>	'success',
		'message'			=>	$this->get_message_string,
		'authorized_level'	=>	$this->get_authorized_level,
		'content'			=>	$short_info,
	};
} else {
	return 1;
}
}

sub pending_notice ($$$$) {
my($this,$info,$c,$n) = @_;
if (ref $this->{'mailto'} && @{$this->{'mailto'}}) {
	my(@mailto);
	foreach my $id (@{$this->{'mailto'}}) {
		if ($id eq 'master') {
			push(@mailto,$env::master_email) if $env::master_email;
		} elsif ($id eq 'owner') {
			push(@mailto,$setting::general{'master'}) if $setting::general{'master'};
		} elsif ($id eq 'owners') {
			push(@mailto,$setting::general{'owners'}) if $setting::general{'owners'};
		} elsif (ref $this->{'field_obj'}{$id} && $this->{'field_obj'}{$id}->{'e-mail'}) {
			my(%mail);
			tie(%mail, $env::dbm_file, $default::db . '/' . $c . '/' . $this->{'field_obj'}{$id}->db, O_RDONLY, $env::dbm_mode);
			push(@mailto,$mail{$n}) if ref tied %mail && defined $mail{$n} && $mail{$n};
			untie(%mail);
		}
	}
	@mailto = $this->get_address(@mailto);
	if (@mailto) {
		unless (ref $cgi::SendMail) {
			require CMONOS::CGI_Lib::SendMail;
			$cgi::SendMail = SendMail->new($env::sendmail,$env::master_email,'',$cgi::input,1);
		}
		my $msg = $this->name . 'ѹޤ';
		$cgi::SendMail->send_mail(
			'Bcc'		=>  join(',',@mailto),
			'From'		=>  (($setting::general{'master'}) ? ($setting::general{'mastername'}) ? $setting::general{'mastername'} . ' <' . $setting::general{'master'} . '>' : $setting::general{'master'} : $env::master_email),
			'Subject'	=>  '' . $setting::general{'cginame'} . '' . $msg,
			'message'	=>  '쥳ɤ' . $msg . "\x0A" . $this->my_url . '?m=DetailViewer&c=' . $c . '&n=' . $n . "\x0A\x0A" . $this->name . ':' . $info . "\x0A\x0A",
			'info'		=>  0
		);
	}
}
}

sub counter_fix ($$$$;$) {
my($this,$c,$n,$v,$rssrefresh) = @_;
my(%category,%expire);
if ($v != 0) {
	tie(%category, $env::dbm_file, $default::preference_dir . '/category', O_RDWR, $env::dbm_mode);
	if (ref tied %category) {
		$category{$c . '_count'} -= $v;
	}
	untie %category;
	require CMONOS::TableMaker::TMCommon;
	my $tablemaker = {};
	bless $tablemaker, 'TMCommon';
	$tablemaker->write_category_list;
	$tablemaker->rss_refresh($c,$n,(($v == 1) ? 1 : 0)) if $rssrefresh;
}
tie(%expire, $env::dbm_file, "$default::db/$main::c/expire", O_RDWR, $env::dbm_mode);
if (ref tied %expire && defined $expire{$main::n}) {
	delete $expire{$main::n};
}
untie %expire;
}

sub editor_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#sub import {
BEGIN {
if (!$setting::field_for_mail) {
	Field::class_register('xtm_pending','Pending','/');
	$setting::deco_dir{'submit'} = ' ܥ';
	$setting::deco_type{'submit'} = 'button';
	push(@field::redundancy_forbidden,'xtm_pending');
}
}

1;
