package SCOrderInfo;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
######################################################################
# ʧˡ⥸塼
# SCOrderInfo.pm 1.0.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-11-12
######################################################################
#	(0)-3 եDB
sub db ($) {
my $this = shift;
return 'order';
}

# --------------------------------------------------------------------
sub __set ($$) {
my $this = shift;
$this->{'field_for'}{'order_info'} = $this->{'id'};
return;
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
my($this,$str) = @_;
my($i,$euc);
return 1 if !defined $main::search{$this->{'id'}}{'str'} || $main::search{$this->{'id'}}{'str'} eq '';
$this->text_color($str);
$this->mk_pattern if !ref $this->{'pattern'};
$i = 'i' if defined $main::search{$this->{'id'}}{'i'} && $main::search{$this->{'id'}}{'i'};
foreach (@{$this->{'pattern'}}) {
	next if $_ eq '';
	if ($$str =~ /$_/) {
		return 1 if !defined $main::search{$this->{'id'}}{'mode'} || $main::search{$this->{'id'}}{'mode'} ne 'and';
	} elsif (defined $main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'and') {
		return 0;
	}
}
if (defined $main::search{$this->{'id'}}{'mode'} && $main::search{$this->{'id'}}{'mode'} eq 'and') {
	return 1;
} else {
	return 0;
}
}

sub mk_pattern ($) {
my $this = shift;
@{$this->{'pattern'}} = (defined $main::search{$this->{'id'}}{'str'}) ? split(/\s+|\xa1\xa1/,$main::search{$this->{'id'}}{'str'}) : ();
map($_ = $this->url_encode($_),@{$this->{'pattern'}});
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status,$original,$path) = @_;
return '' if !$main::data{$this->{'id'}}{'str'};
my($form);
$form = $this->field_header(60);
$form .= $this->order_info($main::data{$this->{'id'}}{'str'});
$form .= $this->field_footer;
return $form;
}

######################################################################
#	(3) obj->is_valid_data;
sub input_enabled ($) {
my $this = shift;
return 0;
}

sub is_valid_data ($;$) {
my $this = shift;
return 1;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=ɽǡ/path=ե¸ǥ쥯ȥ
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
$str = $$str{'str'} if ref $str eq 'HASH';
return ($str) ? $this->style(
	$this->order_info($str),
	$this->{'style'},
	$this->{'fontsize'},
	$this->{'fontcolor'},
	$this->{'fontface'}
) : '';
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
my($this,$str) = @_;
return (!defined $str || $str eq '') ? '' : '[' . $this->name . "]\x0A" . $this->format_for_text($str) . "\x0A";
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
my($this,$str) = @_;
return '' if !defined $str || $str eq '';
$str = $$str{'str'} if ref $str eq 'HASH';
return $this->order_info($str,1);
}

#---------------------------------------------------------------------
sub order_info ($$;$) {
my($this,$data,$is_text) = @_;
return '' if !$data;
my($sub_total,$total,$tax,$fee,$carriage,$carriage_total,$download_key,$ptime,$transaction_id,$status,$dc_only,$expense,$count,$info,$dl_url);
($total,$tax,$fee,$carriage,$carriage_total,$download_key,$ptime,$transaction_id,$status,$dc_only,$expense) = split(/\x09/,$1) if $data =~ s/^(.*?)\x0A//;
$dl_url = $this->full_path($cgi::path) . '?m=DL&key=' . $download_key if $download_key && $ptime && (!$status || $status ne 'Canceled');
if ($is_text) {
	$info .= '============================================================' . "\x0A";
	while ($data =~ /^(.*)$/mg) {
		next if !$1;
		my %item_data = ();
		$cgi::Session->read_data(\%item_data,$1);
		my $price = (($item_data{'optionprice'}) ? ($item_data{'price'} + $item_data{'optionprice'}) : $item_data{'price'});
		$info .= $this->jfold($item_data{'name'} . (($item_data{'key'} && $item_data{'key'} ne $item_data{'name'}) ? ' [' . $item_data{'key'} . ']' : '') . (($item_data{'digitalcontent'}) ? ' (' . $item_data{'digitalcontent'} . ')' : '') . "\x0A",56,'r','',"\x0A",'    ');
		$info .= (($info =~ /\x0A$/) ? '' : "\x0A") . $this->jfold($item_data{'option'} . "\x0A",56,'r','',"\x0A",'    ') if $item_data{'option'};
		$info .= (($info =~ /\x0A$/) ? '' : "\x0A") . '                              ' . $this->digit($price) . '  ' . ((defined $item_data{'quantity'}) ? $this->digit($item_data{'quantity'}) : '0');
		$price = (($price && $item_data{'quantity'}) ? $price * $item_data{'quantity'} : 0);
		$info .= ' = ' . $this->digit($price) . "\x0A";
		$info .= '------------------------------------------------------------' . "\x0A";
		$sub_total += $price;
	}
	undef $data;
	$info .= '                                    :  ' . $this->digit($sub_total) . "\x0A" if $sub_total != $total;
	$info .= '                                  :  ' . $this->digit($carriage) . "\x0A" if $carriage;
	$info .= '                                  :  ' . $this->digit($fee) . "\x0A" if $fee;
	$info .= '                                  :  ' . $this->digit($tax) . "\x0A" if $tax;
	$info .= '                                    :  ' . $this->digit($total) . "\x0A";
	$info .= '============================================================' . "\x0A";
	if ($dl_url) {
		$info .= "\x0A" . 'ڥɡ' . "\x0A";
		$info .= $dl_url . "\x0A";
	}
} elsif ($this->{'compact'}) {
	$info .= '<table id="sc-table-compact">';
	$info .= '<tbody id="sc-item-tbody">';
	while ($data =~ /^(.*)$/mg) {
		next if !$1;
		$count++;
		my %item_data = ();
		$cgi::Session->read_data(\%item_data,$1);
		my $price = (($item_data{'optionprice'}) ? ($item_data{'price'} + $item_data{'optionprice'}) : $item_data{'price'});
		$info .= '<tr class="' . (($count % 2) ? 'odd' : 'even') . '" id="sc-item-' . $count . '">';
		$info .= '<td>';
		$info .= '<div class="sc-item-name"><a href="' . $this->escape($item_data{'path'} . (($item_data{'anchor'}) ? $item_data{'anchor'} : '')) . '" target="_blank">' . $item_data{'name'} . (($item_data{'key'} && $item_data{'key'} ne $item_data{'name'}) ? ' [' . $item_data{'key'} . ']' : '') . '</a>' . (($item_data{'digitalcontent'}) ? ' (' . $this->escape($item_data{'digitalcontent'}) . ')' : '') . '</div>';
		$info .= '<div class="sc-item-option">' . $this->escape($item_data{'option'}) . '</div>' if $item_data{'option'};
		$info .= '<div class="sc-item-info">';
		$info .= '<span class="sc-item-unit-price">&yen;' . $this->digit($price) . '</span>';
		$info .= '<span class="sc-item-quantity">&times;' . ((defined $item_data{'quantity'}) ? $this->digit($item_data{'quantity'}) : '0') . '</span>';
		$price = (($price && $item_data{'quantity'}) ? $price * $item_data{'quantity'} : 0);
		$info .= '=<span class="sc-item-price" id="sc-item-' . $count . '-price">&yen;' . $this->digit($price) . '</span>';
		$info .= '</div>';
		$info .= '</td>';
		$info .= '</tr>';
		$sub_total += $price;
	}
	undef $data;
	$info .= '</tbody>';
	$info .= '<tbody id="sc-total-tbody">';
	$info .= '<tr>';
	$info .= '<td>';
	$info .= '<div id="sc-sub-total">:<span id="sc-sub-total-value">&yen;' . $this->digit($sub_total) . '</span></div>' if $sub_total != $total;
	if ($carriage) {
		$info .= '<div id="sc-carriage">';
		$info .= '<a href="' . $default::file . '/payment_info.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html') . '#carriage-info-header" target="_blank"></a>:';
		$info .= '<span id="sc-carriage-value">&yen;' . $this->digit($carriage) . '</span>';
		$info .= '</div>';
	}
	if ($fee) {
		$info .= '<div id="sc-fee">';
		$info .= '<a href="' . $default::file . '/payment_info.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html') . '#payment-info-header" target="_blank"></a>:';
		$info .= '<span id="sc-fee-value">&yen;' . $this->digit($fee) . '</span>';
		$info .= '</div>';
	}
	if ($tax) {
		$info .= '<div id="sc-tax">';
		$info .= ':';
		$info .= '<span id="sc-tax-value">&yen;' . $this->digit($tax) . '</span>';
		$info .= '</div>';
	}
	$info .= '<div id="sc-total">:<span id="sc-total-value">&yen;' . $this->digit($total) . '</span></div>';
	if ($expense && ($this->is_one_of_owners || $setting::payment{'paypal'}{'sandbox'})) {
		$info .= '<div id="sc-paypal">';
		$info .= 'PayPal :';
		$info .= '<span id="sc-paypal-fee">-&yen;' . $this->digit($expense) . '</span>';
		$info .= '<div id="sc-net">';
		$info .= '̣:';
		$info .= '<span id="sc-net-value">&yen;' . $this->digit($total - $expense) . '</span>';
		$info .= '</tr>';
	}
	$info .= '</td>';
	$info .= '</tr>';
	$info .= '</tbody>';
	$info .= '</table>';
	if ($dl_url) {
		$info .= '<p id="digital-content-download"><a href="' . $this->escape($dl_url) . '" target="_blank">&raquo; </a></p>';
	}
} else {
	$info .= '<table id="sc-table">';
	$info .= '<thead>';
	$info .= '<tr class="odd">';
	$info .= '<th class="sc-item-name">̾</th>';
	$info .= '<th class="sc-item-option">ץ</th>';
	$info .= '<th class="sc-item-unit-price">ñ</th>';
	$info .= '<th class="sc-item-quantity"></th>';
	$info .= '<th class="sc-item-price"></th>';
	$info .= '</tr>';
	$info .= '</thead>';
	$info .= '<tbody id="sc-item-tbody">';
	while ($data =~ /^(.*)$/mg) {
		next if !$1;
		$count++;
		my %item_data = ();
		$cgi::Session->read_data(\%item_data,$1);
		my $price = (($item_data{'optionprice'}) ? ($item_data{'price'} + $item_data{'optionprice'}) : $item_data{'price'});
		$info .= '<tr class="' . (($count % 2) ? 'odd' : 'even') . '" id="sc-item-' . $count . '">';
		$info .= '<td class="sc-item-name"><a href="' . $this->escape($item_data{'path'} . (($item_data{'anchor'}) ? $item_data{'anchor'} : '')) . '" target="_blank">' . $item_data{'name'} . (($item_data{'key'} && $item_data{'key'} ne $item_data{'name'}) ? ' [' . $item_data{'key'} . ']' : '') . '</a>' . (($item_data{'digitalcontent'}) ? ' (' . $this->escape($item_data{'digitalcontent'}) . ')' : '') . '</td>';
		$info .= '<td class="sc-item-option">' . $this->escape($item_data{'option'}) . '</td>';
		$info .= '<td class="sc-item-unit-price">&yen;' . $this->digit($price) . '</td>';
		$info .= '<td class="sc-item-quantity">' . ((defined $item_data{'quantity'}) ? $this->digit($item_data{'quantity'}) : '0') . '</td>';
		$price = (($price && $item_data{'quantity'}) ? $price * $item_data{'quantity'} : 0);
		$info .= '<td class="sc-item-price" id="sc-item-' . $count . '-price">&yen;' . $this->digit($price) . '</td>';
		$info .= '</tr>';
		$sub_total += $price;
	}
	undef $data;
	$info .= '</tbody>';
	$info .= '<tbody id="sc-total-tbody">';
	if ($sub_total != $total) {
		$info .= '<tr id="sc-sub-total" class="sc-total-start">';
		$info .= '<td class="sc-name" colspan="4"></td>';
		$info .= '<td class="sc-value" id="sc-sub-total-value">&yen;' . $this->digit($sub_total) . '</td>';
		$info .= '</tr>';
		if ($carriage) {
			$info .= '<tr id="sc-carriage">';
			$info .= '<td class="sc-name" colspan="4"><a href="' . $default::file . '/payment_info.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html') . '#carriage-info-header" target="_blank"></a></td>';
			$info .= '<td class="sc-value" id="sc-carriage-value">&yen;' . $this->digit($carriage) . '</td>';
			$info .= '</tr>';
		}
		if ($fee) {
			$info .= '<tr id="sc-fee">';
			$info .= '<td class="sc-name" colspan="4"><a href="' . $default::file . '/payment_info.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html') . '#payment-info-header" target="_blank"></a></td>';
			$info .= '<td class="sc-value" id="sc-fee-value">&yen;' . $this->digit($fee) . '</td>';
			$info .= '</tr>';
		}
		if ($tax) {
			$info .= '<tr id="sc-tax">';
			$info .= '<td class="sc-name" colspan="4"></td>';
			$info .= '<td class="sc-value" id="sc-tax-value">&yen;' . $this->digit($tax) . '</td>';
			$info .= '</tr>';
		}
		$info .= '<tr id="sc-total">';
	} else {
		$info .= '<tr id="sc-total" class="sc-total-start">';
	}
	$info .= '<td class="sc-name" colspan="4"></td>';
	$info .= '<td class="sc-value" id="sc-total-value">&yen;' . $this->digit($total) . '</td>';
	$info .= '</tr>';
	if ($expense && ($this->is_one_of_owners || $setting::payment{'paypal'}{'sandbox'})) {
		$info .= '<tr id="sc-paypal">';
		$info .= '<td class="sc-name" colspan="4">PayPal </td>';
		$info .= '<td class="sc-value" id="sc-paypal-fee">-&yen;' . $this->digit($expense) . '</td>';
		$info .= '</tr>';
		$info .= '<tr id="sc-net">';
		$info .= '<td class="sc-name" colspan="4">̣</td>';
		$info .= '<td class="sc-value" id="sc-net-value">&yen;' . $this->digit($total - $expense) . '</td>';
		$info .= '</tr>';
	}
	$info .= '</tbody>';
	$info .= '</table>';
	if ($dl_url) {
		$info .= '<p id="digital-content-download"><a href="' . $this->escape($dl_url) . '" target="_blank">&raquo; </a></p>';
	}
}
return $info;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my $this = shift;
my $name = 'data:' . $this->{'id'};
$this->print_field_info_form($name);
print '<fieldset><legend>ʸƤɽ</legend>';
print '<label><input type="checkbox" name="' . $name . '_compact" value="1"' . (($this->{'compact'}) ? 'checked="checked"' : '') . ' /> ѥȤɽ</label>';
print '</fieldset>';
$this->print_font_setting_form($name);
$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
$main::data{$this->{'id'} . '_compact'} = 0 if !$main::data{$this->{'id'} . '_compact'};
return $this->is_valid_font_setting;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
my $this = shift;
my($form);
$form = '<tr><td class="field-name"><label for="search:' . $this->{'id'} . ':str">' . $this->{'name'} . '</label></td><td class="field">';
$form .= '<input type="text" size="30" name="search:' . $this->{'id'} . ':str" value="' . $this->escape($main::search{$this->{'id'}}{'str'}) . '" /> ';

#Ѹɽ
if (defined $default::english && $default::english) {
	$form .= $this->mk_select_menu(
		'search:' . $this->{'id'} . ':mode','','',$main::search{$this->{'id'}}{'mode'},
		'and'	=>		'Matches on all words',
		'or'	=>		'Matches on any word',
	);
	$form .= '<div class="extra-field"><label><input type="checkbox" name="search:' . $this->{'id'} . ':i" value="1"' . ((defined $main::search{$this->{'id'}}{'i'} && $main::search{$this->{'id'}}{'i'}) ? ' checked="checked"' : '') . ' /> Do case-insensitive pattern matching.</label></div>';

#ܸ
} else {
	$form .= $this->mk_select_menu(
		'search:' . $this->{'id'} . ':mode','','',$main::search{$this->{'id'}}{'mode'},
		'and'	=>		'Ƥʸޤ',
		'or'	=>		'줫ʸޤ',
	);
	$form .= '<div class="extra-field"><label><input type="checkbox" name="search:' . $this->{'id'} . ':i" value="1"' . ((defined $main::search{$this->{'id'}}{'i'} && $main::search{$this->{'id'}}{'i'}) ? ' checked="checked"' : '') . ' /> ʸȾʸ̤ʤ</label></div>';
}
$form .= '</td></tr>';
return $form;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#sub import {
BEGIN {
#no warnings qw(once);
if (defined $default::type && $default::type eq 'order' && defined $env::checkout && $env::checkout && !$setting::field_for_mail) {
	Field::class_register('yorder_info','SCOrderInfo','ʸ');
	push(@field::redundancy_forbidden,'yorder_info');
}
}

1;
