package Index;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
######################################################################
# ǥå⥸塼
# Index.pm ver1.1.3
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-06-04
######################################################################
# ᥤ
sub run ($) {
my $this = shift;
my($title,$mailer_check,$field_selector_enabled);
$this->use_deco;
$main::mod = $setting::page{'defaultView'} if !defined $main::mod || !$main::mod;
$main::u = $main::uni if $main::uni;
$main::u = $setting::page{'u'} if $this->is_nan($main::u);
$main::u = 20 if !$main::u;
$field_selector_enabled = (!$setting::page{'index'}{'closedf'} || $this->is_secure('revise')) ? 1 : 0;

#---------------------------------------------------------------------
#ǧԤܷٹ
$this->set_pending_item_alert if !defined $main::mod && !defined $main::w && !defined $main::s && $this->is_secure('tools');

$this->replace_category_list;

#ڡإå
$this->set_javascript(
		'cmonos.tool.toggleSearchFormMode = function (this_mode) {if (this_mode == "TableViewer" || this_mode == "CsvViewer" || this_mode == "TsvViewer" || this_mode == "VCardViewer" || this_mode == "VCard2Viewer") {'
	 . (($field_selector_enabled) ? 'document.getElementById("tableview-f").style.display = "";' : '')
	 . '} else {'
	 . (($field_selector_enabled) ? 'document.getElementById("tableview-f").style.display = "none";' : '')
	 . '}}') if $field_selector_enabled;
$this->print_page_header('index');

#ե
print $this->form_start(
	'key'	=>	'browse',
	'name'	=>	'input',
	'id'	=>	'tm-search'
);


#---------------------------------------------------------------------
#
print '<fieldset id="view-selector"><legend>' . (($default::english) ? 'View' : 'ɽ') . '</legend>';


#---------------------------------------------------------------------
#ƥ꡼
$this->print_category_selector(
	'<table class="field-table"><tbody>',
	'<tr><td class="field-name"><label for="c">' . (($default::english) ? 'Category' : 'ƥ꡼') . '</label></td><td class="field">',
	'</td></tr>'
);


#---------------------------------------------------------------------
#
print '<tr>';
print '<td class="field-name"><label for="s">' . (($default::english) ? 'Sort' : '') . '</label></td>';
print '<td class="field">';

print '<select id="s" name="s">';

$main::s = ($field::for{'sort'}) ? $field::for{'sort'} : ($field::for{'key'}) ? $field::for{'key'} : ($field::for{'title'}) ? $field::for{'title'} : '' if !defined $main::s || $main::s eq '';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	my($id);
	$id = $field::ORDER{$_};
	next unless ref $field::obj{$id};
	$mailer_check = 1 if defined $field::obj{$id}->{'e-mail'} && $field::obj{$id}->{'e-mail'};
	next unless !$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret')) && $field::obj{$id}->sort_enabled && $field::obj{$id}->{'sortEnabled'};
	print '<option value="' . $id . '"' . ((defined $main::s && $main::s eq $id) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$id}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

#---------------------------------------------------------------------
#Ƚ
print '<tr>';
print '<td class="field-name"><label for="w">' . (($default::english) ? 'Sort By' : 'Ƚ') . '</label></td>';
print '<td class="field">';

$main::w = ($field::SORTORDER) ? $field::SORTORDER : 'ascend' if !defined $main::w || $main::w eq '';
print '<select id="w" name="w">';
print '<option value="ascend"' . ((defined $main::w && $main::w eq 'ascend') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'ascending' : '') . '</option>';
print '<option value="descend"' . ((defined $main::w && $main::w eq 'descend') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'descending' : '߽') . '</option>';
print '</select>';
print '</td></tr>';

#---------------------------------------------------------------------
#ɽ/ܥ
my $m_control = '';
$m_control .= 'cmonos.tool.toggleSearchFormMode(this.options[this.selectedIndex].value);' if $field_selector_enabled;
if ($setting::page{'download'}) {
	my $filename = $default::id || 'exported';
	$filename =~ s/^_//;
	$filename .= '_data';
	$m_control .= 'cmonos.form.item(this.form).field(this).appendDownloadPathByValue({\'CsvViewer\':\'' . $filename . '.csv\',\'TsvViewer\':\'' . $filename . '.tsv\',\'VCardViewer\':\'' . $filename . '.vcf\',\'VCard2Viewer\':\'' . $filename . '.vcf\'});';
}
print '<tr>';
print '<td class="field-name"><label for="m">' . (($default::english) ? 'View' : 'ɽ') . '</label></td>';
print '<td class="field">';
print '<select id="m" name="m"' . (($m_control) ? ' onchange="' . $m_control . '"' : '') . '>';
print '<option value="TableViewer"' . ((defined $main::mod && $main::mod eq 'TableViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Table' : 'ơ֥ɽ') . '</option>';
print '<option value="GMapViewer"' . ((defined $main::mod && $main::mod eq 'GMapViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'GoobleMaps' : 'Googleޥåɽ') . '</option>' if $this->gmap_view_enabled;
print '<option value="TileViewer"' . ((defined $main::mod && $main::mod eq 'TileViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Tile' : 'ɽ') . '</option>';
if ($setting::page{'download'}) {
	print '<option value="CsvViewer"' . ((defined $main::mod && $main::mod eq 'CsvViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Comma-Separated-Values (csv)' : '޶ڤƥ(csv)') . '</option>';
	print '<option value="TsvViewer"' . ((defined $main::mod && $main::mod eq 'TsvViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Tab-Separated-Values' : 'ֶڤƥ') . '</option>';
	if ($setting::page{'vcard'}) {
		print '<option value="VCardViewer"' . ((defined $main::mod && $main::mod eq 'VCardViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'vCard (vcf)' : 'vCard (vcf)') . '</option>';
		print '<option value="VCard2Viewer"' . ((defined $main::mod && $main::mod eq 'VCard2Viewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'vCard2.1 (vcf)' : 'vCard2.1 (vcf)') . '</option>';
	}
}
print '<option value="Mailer"' . ((defined $main::mod && $main::mod eq 'Mailer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Send mail by this list.' : '᡼ۿե򳫤') . '</option>' if $mailer_check && $this->is_secure('mail');
print '</select>';
print '<div class="extra-field"><label><input type="text" size="3" name="u" id="u" value="' . $main::u . '" />' . ($default::english ? 'records per page.' : '鷺ɽ') . (($setting::page{'uLimit'}) ? ' (&lt;' . $setting::page{'uLimit'} . ')' : '') . '</label></div>' if !$setting::page{'uStatic'};
print '</td></tr>';

#---------------------------------------------------------------------
#ɽ
push(@main::f,$main::f) if defined $main::f && $main::f;
if ($field_selector_enabled) {
	my $size = keys %field::obj;
	$size++ if $this->is_secure('revise');
	$size = 8 if $size > 8;
	$size = 1 if $size < 1;

	print '<tr id="tableview-f">';
	print '<td class="field-name"><label for="f">' . (($default::english) ? 'Field' : 'ɽ') . '</label></td>';
	print '<td class="field">';
	print ((($setting::page{'index'}{'checkboxf'}) ? '<ol class="checkbox"' : '<select id="f" name="f" size="' . $size . '" multiple="multiple"') . ' title="' . (($default::english) ? 'For Table' : 'ơ֥ɽΤͭ') . '">');

	foreach (sort {$a <=> $b} keys %field::ORDER) {
		my $id = $field::ORDER{$_};
		next if !ref $field::obj{$id} || $field::obj{$id}->{'Hidden'} || (!$field::obj{$id}->{'Open'} && !$this->is_secure('secret'));
		if ($setting::page{'index'}{'checkboxf'}) {
			print '<li><label><input type="checkbox" name="f" value="' . $id . '"' . (((!@main::f && $field::obj{$id}->{'Default'}) || (@main::f && grep($_ eq $id,@main::f))) ? ' checked="checked"' : '') . ' /> ' . $this->jfold($field::obj{$id}->name,32,'I',1) . '</label></li>';
		} else {
			print '<option value="' . $id . '"' . (((!@main::f && $field::obj{$id}->{'Default'}) || (@main::f && grep($_ eq $id,@main::f))) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$id}->name,32,'I',1) . '</option>';
		}
	}
	if ($this->is_secure('revise')) {
		if ($setting::page{'index'}{'checkboxf'}) {
			print '<li><label><input type="checkbox" name="f" value="r"' . ((!@main::f || (@main::f && grep($_ eq 'r',@main::f))) ? ' checked="checked"' : '') . ' /> ǡ' . '</label></li>';
		} else {
			print '<option value="r"' . ((!@main::f || (@main::f && grep($_ eq 'r',@main::f))) ? ' selected="selected"' : '') . '>ǡ' . '</option>';
		}
	}
	print (($setting::page{'index'}{'checkboxf'}) ? '</ol>' : '</select>');
	print '</td></tr>';
}

#---------------------------------------------------------------------
#ܥ
print '<tr><td colspan="2" class="submit-box">';
print '<input type="submit" value="' . (($default::english) ? 'OK' : 'ɽ') . '" />';
print '</td></tr></tbody></table>';


#---------------------------------------------------------------------
#λ
print '</fieldset>';


#---------------------------------------------------------------------
#ܺپ
my($search_form,$search);
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && !$field::obj{$field::ORDER{$_}}->{'Hidden'} && ($field::obj{$field::ORDER{$_}}->{'Open'} || $this->is_secure('secret')) && $field::obj{$field::ORDER{$_}}->{'searchEnabled'} && $field::obj{$field::ORDER{$_}}->search_form_enabled;
	$search_form .= $field::obj{$field::ORDER{$_}}->search_form;
	$search++;
}

if (defined $search && $search) {
	print '<fieldset id="search"><legend>' . (($default::english) ? 'Search' : 'ܺپ') . '</legend>';
	print '<table class="field-table"><tbody>';
	print $search_form;
	print '</tbody>';
	print '<tbody>';
	print '<tr class="tbody-start">';
	print '<td class="reset-box"><input type="button" value="' . (($default::english) ? 'Reset' : 'ꥻå') . '" onclick="cmonos.form.item(this.form).resetAll(\'search:\')" /></td>';
	print '<td class="submit-box">';
	if ($search > 1) {
		print '<select name="and">';
		print '<option value="1">' . (($default::english) ? 'Matches on all requirements' : 'Ƥξ˰') . '</option>';
		print '<option value="0"' . ((!$main::and) ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Matches on any requirements' : '줫ξ˰') . '</option>';
		print '</select>';
	}
	print '<input type="submit" value="' . (($default::english) ? 'Search' : '') . '" />';
	print '</td></tr></tbody></table></fieldset>';
}

print '</form>';
print $this->javascript('cmonos.tool.toggleSearchFormMode(\'' . (($main::mod) ? $main::mod : '') . '\')') if !$main::mod || $main::mod ne 'TableViewer';


#---------------------------------------------------------------------
#ܥ/Ͽܥ
$this->print_mini_toolbox('bottom') if defined $setting::page{'index'}{'toolIcon'} && $setting::page{'index'}{'toolIcon'};


#---------------------------------------------------------------------
#ڡեå
$this->print_page_return_form;
$this->print_page_footer('index');

}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;					#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 1;						#ơ֥ɤ߹
	$setting::page = 1;						#ڡɤ߹

	$setting::field_db_name = 'inputfield';	#եDB
	$setting::field = 2;						#եɤ߹ߡ2=ꥸʥɤ߹
	$setting::field_style_disabled = 2;			#2=եꥹ̵/1=եΤ̵
	$setting::field_tag_enabled = 'no';				#tag=Τ/all=Ƥ/no=Ĥʤ

	#省
	$setting::security_key = 'browse';							#ǥեȥƥ
	$setting::key = 'index';						#ڡꥭ

	#å
	$cookie::id_enabled = 1;							#ID󥯥åɤ߹

	#ǥեȥ
	$main::k = 'index' if !defined $main::k || !$main::k;

	#ɬܥե
	@setting::form = ('m','k');

	#饹Ͽ
	Common::class_register('index','Index');

	#᡼CSS
	$setting::image_css = 'tablemaker-image.css';

}

1;
