package MkPaymentTerms;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use Fcntl qw(:flock);
######################################################################
# ⥸塼
# MkPaymentTerms.pm ver1.1.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-02-21
######################################################################
# ¹
sub run ($) {
my $this = shift;
require CMONOS::CGI_Lib::JPrefecture;
$cgi::JPrefecture = JPrefecture->new;
my %pref_name_table = $cgi::JPrefecture->get_prefecture_name_hash;
my %region_name_table = $cgi::JPrefecture->get_region_name_hash;
my(%bank,%other,%weight);

#񤭹
if (defined $main::a && $main::a eq 'w') {
	#no warnings qw(numeric);
	my $is_valid = 1;
	$main::data{'bankenabled'} = 0 if !defined $main::data{'bankenabled'} || !$main::data{'bankenabled'};
	my($n,$no,$num);
	$no = $num = 0;
	foreach $n (sort {$main::bank{$a}{'order'} <=> $main::bank{$b}{'order'} || $a <=> $b} keys %main::bank) {
		next if $main::bank{$n}{'delete'} || !$main::bank{$n}{'bank'};		
		$num++;
		$bank{$num}{'bank'} = $main::bank{$n}{'bank'};
		$bank{$num}{'office'} = $main::bank{$n}{'office'};
		$bank{$num}{'deposit'} = $main::bank{$n}{'deposit'};
		$bank{$num}{'number'} = $main::bank{$n}{'number'};
		$bank{$num}{'name'} = $main::bank{$n}{'name'};
		$bank{$num}{'kana'} = $main::bank{$n}{'kana'};
		if (!$this->is_not_number(\$main::bank{$n}{'number'},$main::bank{$n}{'bank'} . 'ֹ') && !$this->is_not_kana_name(\$main::bank{$n}{'kana'},$main::bank{$n}{'bank'} . 'ɽ') && !$this->is_shortage($main::bank{$n}{'bank'},$main::bank{$n}{'bank'},$main::bank{$n}{'office'},$main::bank{$n}{'number'},$main::bank{$n}{'name'},$main::bank{$n}{'kana'})) {
			$no++;
			$main::data{'bank_' . $no . '_bank'} = $main::bank{$n}{'bank'};
			$main::data{'bank_' . $no . '_office'} = $main::bank{$n}{'office'};
			$main::data{'bank_' . $no . '_deposit'} = $main::bank{$n}{'deposit'};
			$main::data{'bank_' . $no . '_number'} = $main::bank{$n}{'number'};
			$main::data{'bank_' . $no . '_name'} = $main::bank{$n}{'name'};
			$main::data{'bank_' . $no . '_kana'} = $main::bank{$n}{'kana'};
		} else {
			$is_valid = 0;
		}
	}
	undef %main::bank;

	$main::data{'yubinenabled'} = 0 if !defined $main::data{'yubinenabled'} || !$main::data{'yubinenabled'};
	$is_valid = 0 if $this->is_not_number(\$main::data{'yubin_mark'},'椦Ը¤ε');
	$is_valid = 0 if $this->is_not_number(\$main::data{'yubin_digit'},'椦Ը¤Υǥå');
	$is_valid = 0 if $this->is_not_number(\$main::data{'yubin_number'},'椦Ը¤ֹ');
	$is_valid = 0 if $this->is_shortage('椦Ը',$main::data{'yubin_mark'},$main::data{'yubin_number'},$main::data{'yubin_name'},$main::data{'yubin_office'});

	$main::data{'codenabled'} = 0 if !defined $main::data{'codenabled'} || !$main::data{'codenabled'};
	$is_valid = 0 if $this->is_not_number(\$main::data{'cod_fee1'},'(1̤)');
	$is_valid = 0 if $this->is_not_number(\$main::data{'cod_fee2'},'(1߰ʾ3̤)');
	$is_valid = 0 if $this->is_not_number(\$main::data{'cod_fee3'},'(3߰ʾ10̤)');
	$is_valid = 0 if $this->is_not_number(\$main::data{'cod_fee4'},'(10߰ʾ30̤)');
	if ($main::data{'codenabled'} && (!defined $main::data{'cod_fee1'} || $main::data{'cod_fee1'} eq '')) {
		push(@{$this->{'dialog'}},'ꤵƤޤ');
		$is_valid = 0;
	}
	$main::data{'cod_fee3'} = $main::data{'cod_fee4'} = '' if !defined $main::data{'cod_fee3'} || $main::data{'cod_fee3'} eq '';
	$main::data{'cod_fee2'} = $main::data{'cod_fee3'} = $main::data{'cod_fee4'} = '' if !defined $main::data{'cod_fee2'} || $main::data{'cod_fee2'} eq '';
	$main::data{'cod_fee1'} = $main::data{'cod_fee2'} = $main::data{'cod_fee3'} = $main::data{'cod_fee4'} = '' if !defined $main::data{'cod_fee1'} || $main::data{'cod_fee1'} eq '';

	$main::data{'moneyorderenabled'} = 0 if !defined $main::data{'moneyorderenabled'} || !$main::data{'moneyorderenabled'};

	$main::data{'paypalenabled'} = 0 if !defined $main::data{'paypalenabled'} || !$main::data{'paypalenabled'};
	$is_valid = 0 if $this->is_not_number(\$main::data{'paypal_ratio'},'μΨ()');
	$is_valid = 0 if $this->is_not_number(\$main::data{'paypal_fee'},'θ()');
	$main::data{'paypal_incontext'} = 0 if !defined $main::data{'paypal_incontext'} || !$main::data{'paypal_incontext'};
	$is_valid = 0 if $this->is_not_number(\$main::data{'paypal_mratio'},'ޥڥȼΨ()');
	$is_valid = 0 if $this->is_not_number(\$main::data{'paypal_mfee'},'ޥڥȸ()');
	delete $main::data{'paypal_paymentaction'} if $main::data{'paypal_paymentaction'} && $main::data{'paypal_paymentaction'} ne 'Order' && $main::data{'paypal_paymentaction'} ne 'Sale'; 
	$main::data{'paypal_username'} = $this->z_to_h($main::data{'paypal_username'}) if $main::data{'paypal_username'};
	$main::data{'paypal_password'} = $this->z_to_h($main::paypal{'password'}) if $main::paypal{'password'};
	$main::data{'paypal_signature'} = $this->z_to_h($main::paypal{'signature'}) if $main::paypal{'signature'};
	if ($main::data{'paypalenabled'} && (!$main::data{'paypal_username'} || (!$main::paypal{'password'} && !$main::paypal{'old_password'}) || (!$main::paypal{'signature'} && !$main::paypal{'old_signature'}))) {
		push(@{$this->{'dialog'}},'PayPal ͭˤˤϡAPI桼̾סAPIѥɡסAPI̾פɬפǤ');
		$is_valid = 0;
		$main::data{'paypalenabled'} = 0
	}
	$main::data{'paypal_sandbox'} = 0 if !defined $main::data{'paypal_sandbox'} || !$main::data{'paypal_sandbox'};
	$main::data{'paypal_top'} = 0 if !defined $main::data{'paypal_top'} || !$main::data{'paypal_top'};
	$is_valid = 0 if $this->is_not_image(\$main::data{'paypal_checkoutbutton'},'åȥܥ');
	$is_valid = 0 if $this->is_not_image(\$main::data{'paypal_button'},'ܥ');
	$main::data{'paypal_pagestyle'} = $this->z_to_h($main::data{'paypal_pagestyle'}) if $main::data{'paypal_pagestyle'};

	$main::data{'otherenabled'} = 0 if !defined $main::data{'otherenabled'} || !$main::data{'otherenabled'};
	$no = $num = 0;
	foreach $n (sort {$main::other{$a}{'order'} <=> $main::other{$b}{'order'} || $a <=> $b} keys %main::other) {
		next if $main::other{$n}{'delete'} || !$main::other{$n}{'name'};
		$this->tag_fix(\$main::other{$n}{'name'});		
		$this->tag_fix(\$main::other{$n}{'note'});		
		$num++;
		$other{$num}{'name'} = $main::other{$n}{'name'};
		$other{$num}{'formula'} = $main::other{$n}{'formula'};
		$other{$num}{'frac'} = $main::other{$n}{'frac'};
		$other{$num}{'note'} = $main::other{$n}{'note'};
		if (!$this->is_invalid_formula(\$main::other{$n}{'formula'},$main::other{$n}{'name'} . '׻') && !$this->is_shortage($main::other{$n}{'name'},$main::other{$n}{'name'})) {
			$no++;
			$main::data{'other_' . $no . '_name'} = $main::other{$n}{'name'};
			$main::data{'other_' . $no . '_formula'} = $main::other{$n}{'formula'};
			$main::data{'other_' . $no . '_frac'} = $main::other{$n}{'frac'};
			$main::data{'other_' . $no . '_note'} = $main::other{$n}{'note'};
		} else {
			$is_valid = 0;
		}
	}
	undef %main::other;

	if (!defined $main::data{'carriage'} || $main::data{'carriage'} eq '') {
		push(@{$this->{'dialog'}},'ʬ򤵤Ƥޤ');
		$is_valid = 0;
	}
	$is_valid = 0 if $this->is_not_number(\$main::data{'nation'},'Χ');
	my($id);
	foreach $id (sort {$a <=> $b} keys %region_name_table) {		
		if (($main::data{'carriage'} && $main::data{'carriage'} eq 'region' && (!defined $main::data{'region_' . $id} || $main::data{'region_' . $id} eq '')) || $this->is_not_number(\$main::data{'region_' . $id},$region_name_table{$id} . '')) {
			push(@{$this->{'dialog'}},$region_name_table{$id} . '꤬ޤ');
			$is_valid = 0;
		}
	}
	foreach $id (sort {$a <=> $b} keys %pref_name_table) {
		if (($main::data{'carriage'} && $main::data{'carriage'} eq 'prefecture' && (!defined $main::data{'pref_' . $id} || $main::data{'pref_' . $id} eq '')) || $this->is_not_number(\$main::data{'pref_' . $id},$pref_name_table{$id} . '')) {
			push(@{$this->{'dialog'}},$pref_name_table{$id} . '꤬ޤ');
			$is_valid = 0;
		}
	}
	$no = $num = 0;
	foreach $n (sort {$main::weight{$a}{'weight'} <=> $main::weight{$b}{'weight'} || $a <=> $b} keys %main::weight) {
		next if $main::weight{$n}{'delete'} || !$main::weight{$n}{'weight'};
		$num++;
		$weight{$num}{'weight'} = $main::weight{$n}{'weight'};
		$weight{$num}{'carriage'} = $main::weight{$n}{'carriage'};
		if (!$this->is_nan($weight{$num}{'weight'}) && !$this->is_nan($weight{$num}{'carriage'})) {
			$no++;
			$main::data{'weight_' . $no . '_weight'} = $main::weight{$n}{'weight'};
			$main::data{'weight_' . $no . '_carriage'} = $main::weight{$n}{'carriage'};
		} else {
			$is_valid = 0;
		}
	}
	undef %main::weight;
	$is_valid = 0 if $this->is_not_number(\$main::data{'packageweight'},'');

	$is_valid = 0 if $this->is_not_number(\$main::data{'specialcarriage_requirements'},'ͥ');
	$is_valid = 0 if $this->is_not_number(\$main::data{'specialcarriage_cost'},'ͥΧ');

	$this->write_db($default::preference_dir . '/terms',\%main::data,'bank|other|weight','',\%setting::payment,1);
	if ($is_valid) {
		$this->print_payment_info_page(\%pref_name_table,\%region_name_table);
	} else {
		push(@{$this->{'dialog'}},'Ĥ꤬äᡢʧڡ򹹿ޤǤ');
	}

} else {
	#ɤ߹
	$this->import_db($default::preference_dir . '/terms',\%setting::payment,1);
	%bank = (ref $setting::payment{'bank'}) ? %{$setting::payment{'bank'}} : ();
	%other = (ref $setting::payment{'other'}) ? %{$setting::payment{'other'}} : ();
	%weight = (ref $setting::payment{'weight'}) ? %{$setting::payment{'weight'}} : ();
}

#椦᡼
if ($main::for_book) {
	undef %weight;
	%weight = (
		1	=> {'weight'	=> 150,		'carriage'	=>	180},
		2	=> {'weight'	=> 250,		'carriage'	=>	210},
		3	=> {'weight'	=> 500,		'carriage'	=>	290},
		4	=> {'weight'	=> 1000,	'carriage'	=>	340},
		5	=> {'weight'	=> 2000,	'carriage'	=>	450},
		6	=> {'weight'	=> 3000,	'carriage'	=>	590}
	);
}

#ڡإå
$this->set_javascript(
<<JAVA
cmonos.tool.prefSync = function () {
	if (document.getElementById('prefsync').checked == false) return;
	var v = arguments[0];
	if (arguments.length > 1) {
		for (var i=1; i<arguments.length; i++) {
			document.getElementById('data:pref_'+arguments[i]).value = v;
		}
	} else {
		for (var i=1; i<=47; i++) {
			document.getElementById('data:pref_'+i).value = v;
		}
	}
}
JAVA
);
$this->jump_menu('tools');
$this->print_page_header('tools');


print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="w" />';

print '<fieldset><legend></legend>';
print (($env::tax_rate*100) . '% (ü' . (($env::tax_frac eq 'floor') ? 'ڤ겼' : (($env::tax_frac eq 'round') ? 'ͼθ' : 'ڤ夲')) . ')');
print '<div class="hints">֥åȥåץ/ǡȾѹפѹǤޤ</div>';
print '</fieldset>';

if (-f $default::file . '/payment_info.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html')) {
	print '<fieldset><legend>ʧڡ</legend>';
	print '<a href="' . $default::file . '/payment_info.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html') . '" target="_blank">ʧˡˤĤ...</a>';
	print '</fieldset>';
}

#print '<fieldset><legend>ݥ</legend>';
#print $env::point_lifetime . ' ͭ';
#print '(üݥȤ' . (($env::tax_frac eq 'floor') ? 'ڤ夲' : (($env::tax_frac eq 'round') ? 'ͼθ' : 'ڤ겼')) . ')';
#print '<div class="hints">֥åȥåץ/ǡȾѹפѹǤޤ</div>';
#print '</fieldset>';

print '<h1>ʧˡ</h1>';

print '<fieldset><legend><label><input type="checkbox" name="data:bankenabled" id="data:bankenabled" value="1"' . (($setting::payment{'bankenabled'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'bank-fields\').disappear(!this.checked);" /> Կ</label></legend><div id="bank-fields">';
my $count = 0;
my $cell_limit = 1;
$cell_limit += scalar(keys %bank) if %bank;
while (1) {
	$count++;
	last if $count > 3 && $count > $cell_limit;
	print '<fieldset class="' . (($count % 2) ? 'odd' : 'even') . '">';
	print '<legend> <input type="text" name="bank:' . $count . ':order" id="bank:' . $count . ':order" size="3" value="' . $count . '" title="ɽ" />';
	print ' <label><input type="checkbox" name="bank:' . $count . ':delete" id="bank:' . $count . ':delete" value="1" /> </label></legend>';
	print '<table class="field-table"><tbody>';
	print '<tr>';
	print '<td class="field-name"><label for="bank:' . $count . ':bank">̾</label></td>';
	print '<td class="q-field"><input type="text" name="bank:' . $count . ':bank" id="bank:' . $count . ':bank" size="32" value="' . $this->escape($bank{$count}{'bank'}) . '" /></td>';
	print '<td class="field-name"><label for="bank:' . $count . ':office">Ź̾</label></td>';
	print '<td class="q-field"><input type="text" name="bank:' . $count . ':office" id="bank:' . $count . ':office" size="32" value="' . $this->escape($bank{$count}{'office'}) . '" /></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="bank:' . $count . ':number">ֹ</label></td><td class="field" colspan="3">';
	print '<select name="bank:' . $count . ':deposit" id="bank:' . $count . ':deposit">';
	print '<option value="ordinary"' . ((defined $bank{$count}{'deposit'} && $bank{$count}{'deposit'} eq 'ordinary') ? ' selected="selected"' : '') . '></option>';
	print '<option value="current"' . ((defined $bank{$count}{'deposit'} && $bank{$count}{'deposit'} eq 'current') ? ' selected="selected"' : '') . '></option>';
	print '</select><input type="text" name="bank:' . $count . ':number" id="bank:' . $count . ':number" size="16" value="' . $this->escape($bank{$count}{'number'}) . '" /></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="bank:' . $count . ':name">̾</label></td>';
	print '<td class="q-field"><input type="text" name="bank:' . $count . ':name" id="bank:' . $count . ':name" size="32" value="' . $this->escape($bank{$count}{'name'}) . '" /></td>';
	print '<td class="field-name"><label for="bank:' . $count . ':kana">ɽ</label></td>';
	print '<td class="q-field"><input type="text" name="bank:' . $count . ':kana" id="bank:' . $count . ':kana" size="32" value="' . $this->escape($bank{$count}{'kana'}) . '" /></td>';
	print '</tr>';
	print '</tbody></table>';
	print '</fieldset>';
}
print '<fieldset><legend><label for="data:bankinfo">ϰ</label></legend>';
print '<select name="data:bankinfo" id="data:bankinfo">';
print '<option value="0"' . ((!$setting::payment{'bankinfo'}) ? ' selected="selected"' : '') . '>̾Τ</option>';
print '<option value="1"' . (($setting::payment{'bankinfo'} && $setting::payment{'bankinfo'} eq '1') ? ' selected="selected"' : '') . '>̾Ź̾</option>';
print '<option value="2"' . (($setting::payment{'bankinfo'} && $setting::payment{'bankinfo'} eq '2') ? ' selected="selected"' : '') . '>̾Źֹ̾</option>';
print '<option value="3"' . (($setting::payment{'bankinfo'} && $setting::payment{'bankinfo'} eq '3') ? ' selected="selected"' : '') . '>̾Źֹ̾桦̾</option>';
print '</select>';
print '</fieldset>';
print '<fieldset><legend><label for="data:banknote">ջ</label></legend><textarea name="data:banknote" id="data:banknote" cols="56" rows="5">';
print $this->escape($setting::payment{'banknote'});
print '</textarea>';
print '</fieldset>';
print '</div></fieldset>';
print $this->javascript('cmonos.element.item(\'bank-fields\').disappear(true);') if !$setting::payment{'bankenabled'};

print '<fieldset><legend><label><input type="checkbox" name="data:yubinenabled" id="data:yubinenabled" value="1"' . (($setting::payment{'yubinenabled'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'yubin-fields\').disappear(!this.checked);" /> 椦(͹ؿ)</label></legend><div id="yubin-fields">';
print '<table class="field-table"><tbody>';
print '<tr>';
print '<td class="field-name"><span class="datatitle">/ֹ</span></td>';
print '<td class="field" colspan="3"><input type="text" name="data:yubin_mark" id="data:yubin_mark" size="6" value="' . $this->escape($setting::payment{'yubin'}{'mark'}) . '" /> - ';
print '<input type="text" name="data:yubin_digit" id="data:yubin_digit" size="2" value="' . $this->escape($setting::payment{'yubin'}{'digit'}) . '" /> - ';
print '<input type="text" name="data:yubin_number" id="data:yubin_number" size="6" value="' . $this->escape($setting::payment{'yubin'}{'number'}) . '" /> [] - [ο(ʤ̵)] - [ֹ]</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="data:yubin_office">͹ض</label></td>';
print '<td class="q-field"><input type="text" name="data:yubin_office" id="data:yubin_office" size="32" value="' . $this->escape($setting::payment{'yubin'}{'office'}) . '" /></td>';
print '<td class="field-name"><label for="data:yubin_bankname">Ź̾</label></td>';
print '<td class="q-field"><input type="text" name="data:yubin_bankname" id="data:yubin_office" size="32" value="' . $this->escape($setting::payment{'yubin'}{'bankname'}) . '" /></td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="data:yubin_name">̾</label></td>';
print '<td class="q-field"><input type="text" name="data:yubin_name" id="data:yubin_name" size="32" value="' . $this->escape($setting::payment{'yubin'}{'name'}) . '" /></td>';
print '<td class="field-name"><label for="data:yubin_kana">ɽ</label></td>';
print '<td class="q-field"><input type="text" name="data:yubin_kana" id="data:yubin_name" size="32" value="' . $this->escape($setting::payment{'yubin'}{'kana'}) . '" /></td>';
print '</tr>';
print '</tbody></table>';
print '<fieldset><legend><label for="data:yubininfo">ϰ</label></legend>';
print '<select name="data:yubininfo" id="data:yubininfo">';
print '<option value="0"' . ((!$setting::payment{'yubininfo'}) ? ' selected="selected"' : '') . '>椦</option>';
print '<option value="1"' . (($setting::payment{'yubininfo'} && $setting::payment{'yubininfo'} eq '1') ? ' selected="selected"' : '') . '>椦ԡ͹ض̾</option>';
print '<option value="2"' . (($setting::payment{'yubininfo'} && $setting::payment{'yubininfo'} eq '2') ? ' selected="selected"' : '') . '>椦ԡ͹ضֹ̾</option>';
print '<option value="3"' . (($setting::payment{'yubininfo'} && $setting::payment{'yubininfo'} eq '3') ? ' selected="selected"' : '') . '>椦ԡ͹ضֹ̾桦̾</option>';
print '</select>';
print '</fieldset>';
print '<fieldset><legend><label for="data:yubinnote">ջ</label></legend><textarea name="data:yubinnote" id="data:yubinnote" cols="56" rows="5">';
print $this->escape($setting::payment{'yubinnote'});
print '</textarea>';
print '</fieldset>';
print '</div></fieldset>';
print $this->javascript('cmonos.element.item(\'yubin-fields\').disappear(true);') if !$setting::payment{'yubinenabled'};

if (eval{require LWP::UserAgent} && eval 'use Crypt::SSLeay;1;') {
	$setting::payment{'paypal'}{'ratio'} = 3.6 if !defined $setting::payment{'paypal'}{'ratio'};
	$setting::payment{'paypal'}{'fee'} = 40 if !defined $setting::payment{'paypal'}{'fee'};
	$setting::payment{'paypal'}{'mratio'} = 5 if !defined $setting::payment{'paypal'}{'mratio'};
	$setting::payment{'paypal'}{'mfee'} = 7 if !defined $setting::payment{'paypal'}{'mfee'};
	print '<fieldset><legend><label><input type="checkbox" name="data:paypalenabled" id="data:paypalenabled" value="1"' . (($setting::payment{'paypalenabled'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'paypal-fields\').disappear(!this.checked);" /> PayPal</label></legend><div id="paypal-fields">';
	print '<fieldset><legend></legend>';
	print '<table class="field-table"><tbody>';
	print '<tr>';
	print '<td class="field-name"><span class="datatitle">μ()</span></td>';
	print '<td class="field">';
	print '&times;<input type="text" name="data:paypal_ratio" id="data:paypal_ratio" size="3" value="' . $this->escape($setting::payment{'paypal'}{'ratio'}) . '" />%';
	print ' + <input type="text" name="data:paypal_fee" id="data:paypal_fee" size="3" value="' . $this->escape($setting::payment{'paypal'}{'fee'}) . '" />';
	print '<div class="hints">ɥܥåѤƤ뤫ֶƱʡװʾθ¤ǥݤˤΤɽ롢PayPal ̣ۤ׻뤿ꤷޤPayPal εˤꡢPayPal ηѼ㤤ɲ᤹뤳ȤϤǤޤ󡣤ղ</div>';
	print '</td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="data:paypal_paymentaction">ѤΥߥ</label></td>';
	print '<td class="field">';
	print '<select name="data:paypal_paymentaction" id="data:paypal_paymentaction">';
	print '<option value="Order"' . (($setting::payment{'paypal'}{'paymentaction'} && $setting::payment{'paypal'}{'paymentaction'} eq 'Order') ? ' selected="selected"' : '') . '>ǧ塢Ѥǧ</option>';
	print '<option value="Sale"' . (($setting::payment{'paypal'}{'paymentaction'} && $setting::payment{'paypal'}{'paymentaction'} eq 'Sale') ? ' selected="selected"' : '') . '>¨</option>';
	print '</select>';
	print '<div class="hints">ܤǥ륳ƥĤΤߤξϾˡ¨׷Ѥޤ</div></td>';
	print '</tr>';
	print '</tbody></table>';
	print '</fieldset>';

	print '<fieldset><legend><label><input type="checkbox" name="data:paypal_incontext" id="data:paypal_incontext" value="1"' . (($setting::payment{'paypal'}{'incontext'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'paypal-micropayments\').disappear(!this.checked);" /> PayPal for Digital Goods</label></legend>';
	print '<table class="field-table" id="paypal-micropayments"><tbody>';
	print '<tr>';
	print '<td class="field-name"><span class="datatitle">ޥڥȼ()</span></td>';
	print '<td class="field">';
	print '&times;<input type="text" name="data:paypal_mratio" id="data:paypal_mratio" size="3" value="' . $this->escape($setting::payment{'paypal'}{'mratio'}) . '" />%';
	print ' + <input type="text" name="data:paypal_mfee" id="data:paypal_mfee" size="3" value="' . $this->escape($setting::payment{'paypal'}{'mfee'}) . '" />';
	print '<div class="hints">ɥܥåѤƤ뤫ֶƱʡװʾθ¤ǥݤˤΤɽ롢PayPal ̣ۤ׻뤿ꤷޤPayPal εˤꡢPayPal ηѼ㤤ɲ᤹뤳ȤϤǤޤ󡣤ղ</div>';
	print '</td>';
	print '</tr>';
	print '</tbody></table>';
	print '</fieldset>';
	print $this->javascript('cmonos.element.item(\'paypal-micropayments\').disappear(true);') if !$setting::payment{'paypal'}{'incontext'};

	print '<fieldset><legend>ץ쥹åAPI </legend>';
	print '<table class="field-table"><tbody>';
	print '<tr>';
	print '<td class="field-name"><label for="data:paypal_username">API桼̾</label></td>';
	print '<td class="field"><input type="text" name="data:paypal_username" id="data:paypal_username" size="72" value="' . $this->escape($setting::payment{'paypal'}{'username'}) . '" /></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="paypal:password">APIѥ</label></td>';
	print '<td class="field">';
	print '<input type="text" name="paypal:password" id="paypal:password" size="72" />';
	print '<div class="hints">̵ξѹޤ</div>';
	if ($setting::payment{'paypal'}{'password'} && $setting::payment{'paypal'}{'password'} =~ /(\w{4})$/) {
		print '<input type="hidden" name="paypal:old_password" id="paypal:old_password" value="1" />';
		print '<div class="hints">ߤ:****' . $1 . '</div>';
	}
	print '</td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="paypal:signature">API̾</label></td>';
	print '<td class="field">';
	print '<input type="text" name="paypal:signature" id="paypal:signature" size="72" />';
	print '<div class="hints">̵ξѹޤ</div>';
	if ($setting::payment{'paypal'}{'signature'} && $setting::payment{'paypal'}{'signature'} =~ /(\w{4})$/) {
		print '<input type="hidden" name="paypal:old_signature" id="paypal:old_signature" value="1" />';
		print '<div class="hints">ߤ:************' . $1 . '</div>';
	}
	print '</td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><span class="datatitle">ɥܥå</span></td>';
	print '<td class="field"><label><input type="checkbox" name="data:paypal_sandbox" id="data:paypal_sandbox" value="1"' . (($setting::payment{'paypal'}{'sandbox'}) ? ' checked="checked"' : '') . ' /> ưƥѤΥɥܥå API ˥롣</label></td>';
	print '</tr>';
	print '</tbody></table>';
	print '</fieldset>';
	print '<fieldset><legend>ɽ</legend>';
	print '<table class="field-table"><tbody>';
	print '<tr>';
	print '<td class="field-name"><span class="datatitle">ɽ</span></td>';
	print '<td class="field"><label><input type="checkbox" name="data:paypal_top" id="data:paypal_top" value="1"' . (($setting::payment{'paypal'}{'top'}) ? ' checked="checked"' : '') . ' /> åϲ̤ǻʧˡեɤǽɽ롣</label></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="data:paypal_button">åȥܥURL</label></td>';
	print '<td class="field"><input type="text" name="data:paypal_button" id="data:paypal_button" size="72" value="' . $this->escape($setting::payment{'paypal'}{'button'}) . '" /></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="data:paypal_banner">塼HTML</label></td>';
	print '<td class="field"><textarea name="data:paypal_banner" id="data:paypal_banner" cols="72" rows="5">' . $this->escape($setting::payment{'paypal'}{'banner'}) . '</textarea></td>';
	print '</tr>';
	print '<tr>';
	print '<td class="field-name"><label for="data:paypal_pagestyle">֥ʧץڡ̾</label></td>';
	print '<td class="field"><input type="text" name="data:paypal_pagestyle" id="data:paypal_pagestyle" size="72" value="' . $this->escape($setting::payment{'paypal'}{'pagestyle'}) . '" /></td>';
	print '</tr>';
	print '</tbody></table>';
	print '</fieldset>';
	$setting::payment{'paypalnote'} = '̵Ǥ' if !defined $setting::payment{'paypalnote'};
	print '<fieldset><legend><label for="data:paypalnote">ջ</label></legend><textarea name="data:paypalnote" id="data:paypalnote" cols="56" rows="5">';
	print $this->escape($setting::payment{'paypalnote'});
	print '</textarea>';
	print '</fieldset>';
	print '</div></fieldset>';
	print $this->javascript('cmonos.element.item(\'paypal-fields\').disappear(true);') if !$setting::payment{'paypalenabled'};
}

print '<fieldset><legend><label><input type="checkbox" name="data:codenabled" id="data:codenabled" value="1"' . (($setting::payment{'codenabled'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'cod-fields\').disappear(!this.checked);" /> </label></legend><div id="cod-fields">';
print '<fieldset><legend></legend>';
print '<table class="tooltable">';
print '<thead><tr class="odd"><th class="even"></th><th class="even"></th></tr></thead>';
print '<tbody>';
print '<tr class="even"><td class="odd"><label for="data:cod_fee1">1̤</label></td><td class="even"><input type="text" name="data:cod_fee1" id="data:cod_fee1" size="8" value="' . $this->escape($setting::payment{'cod'}{'fee1'}) . '" />  <span class="unit"></span></td></tr>';
print '<tr class="odd"><td class="odd"><label for="data:cod_fee2">1߰ʾ3̤</label></td><td class="even"><input type="text" name="data:cod_fee2" id="data:cod_fee2" size="8" value="' . $this->escape($setting::payment{'cod'}{'fee2'}) . '" />  <span class="unit"></span></td></tr>';
print '<tr class="even"><td class="odd"><label for="data:cod_fee3">3߰ʾ10̤</label></td><td class="even"><input type="text" name="data:cod_fee3" id="data:cod_fee3" size="8" value="' . $this->escape($setting::payment{'cod'}{'fee3'}) . '" />  <span class="unit"></span></td></tr>';
print '<tr class="odd"><td class="odd"><label for="data:cod_fee4">10߰ʾ30̤</label></td><td class="even"><input type="text" name="data:cod_fee4" id="data:cod_fee4" size="8" value="' . $this->escape($setting::payment{'cod'}{'fee4'}) . '" />  <span class="unit"></span></td></tr>';
print '</tbody></table>';
print '<div class="note">Ȥȳ뾦ΤȤդޤ</div>';
print '</fieldset>';
print '<fieldset><legend><label for="data:codnote">ջ</label></legend><textarea name="data:codnote" id="data:codnote" cols="56" rows="5">';
print $this->escape($setting::payment{'codnote'});
print '</textarea>';
print '</fieldset>';
print '</div></fieldset>';
print $this->javascript('cmonos.element.item(\'cod-fields\').disappear(true);') if !$setting::payment{'codenabled'};

print '<fieldset><legend><label><input type="checkbox" name="data:moneyorderenabled" id="data:moneyorderenabled" value="1"' . (($setting::payment{'moneyorderenabled'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'moneyorder-fields\').disappear(!this.checked);" /> <a href="http://www.jp-bank.japanpost.jp/kojin/tukau/sokin/hikoza/kj_tk_sk_hkz_kogawase.html" target="_blank">۾</a></label></legend><div id="moneyorder-fields">';
print '<fieldset><legend><label for="data:moneyordernote">ջ</label></legend><textarea name="data:moneyordernote" id="data:moneyordernote" cols="56" rows="5">';
print $this->escape($setting::payment{'moneyordernote'});
print '</textarea>';
print '</fieldset>';
print '</div></fieldset>';
print $this->javascript('cmonos.element.item(\'moneyorder-fields\').disappear(true);') if !$setting::payment{'moneyorderenabled'};

print '<fieldset><legend><label><input type="checkbox" name="data:otherenabled" id="data:otherenabled" value="1"' . (($setting::payment{'otherenabled'}) ? ' checked="checked"' : '') . ' onclick="cmonos.element.item(\'other-fields\').disappear(!this.checked);" /> ¾</label></legend>';
print '<table class="tooltable" id="other-fields">';
print '<thead><tr class="odd"><th class="odd"></th><th class="even">ɽ</th><th class="odd">ˡ̾</th><th class="even">׻(x=ʧ)</th><th class="odd">ü</th><th class="even"></th></tr></thead>';
print '<tbody>';
$count = 0;
$cell_limit = 1;
$cell_limit += scalar(keys %other) if %other;
while (1) {
	$count++;
	last if $count > 1 && $count > $cell_limit;
	print '<tr class="' . (($count % 2) ? 'even' : 'odd') . '">';
	print '<td class="caution">' . (($other{$count}{'name'}) ? '<input type="checkbox" name="other:' . $count . ':delete" id="other:' . $count . ':delete" value="1" />' : '') . '</td>';
	print '<td class="even"><input type="text" name="other:' . $count . ':order" id="other:' . $count . ':order" size="2" value="' . $count . '" /></td>';
	print '<td class="odd"><input type="text" name="other:' . $count . ':name" id="other:' . $count . ':name" size="16" value="' . $this->escape($other{$count}{'name'}) . '" /></td>';
	print '<td class="even"><input type="text" name="other:' . $count . ':formula" id="other:' . $count . ':formula" size="20" value="' . $this->escape($other{$count}{'formula'}) . '" /></td>';
	print '<td class="odd"><select name="other:' . $count . ':frac" id="other:' . $count . ':frac">';
	print '<option value="ceil"' . ((defined $other{$count}{'frac'} && $other{$count}{'frac'} eq 'ceil') ? ' selected="selected"' : '') . '>ڤ夲</option>';
	print '<option value="round"' . ((defined $other{$count}{'frac'} && $other{$count}{'frac'} eq 'round') ? ' selected="selected"' : '') . '>ͼθ</option>';
	print '<option value="floor"' . ((defined $other{$count}{'frac'} && $other{$count}{'frac'} eq 'floor') ? ' selected="selected"' : '') . '>ڤ겼</option>';
	print '</select></td>';
	print '<td class="even"><textarea name="other:' . $count . ':note" id="other:' . $count . ':note" cols="36" rows="3">' . $this->escape($other{$count}{'note'}) . '</textarea></td>';
	print '</tr>';
}
print '</tbody></table>';
print '</fieldset>';
print $this->javascript('cmonos.element.item(\'other-fields\').disappear(true);') if !$setting::payment{'otherenabled'};


print '<h1></h1>';
print '<fieldset><legend></legend>';
print '<fieldset><legend><label><input type="radio" name="data:carriage" value="disabled"' . ((defined $setting::payment{'carriage'} && $setting::payment{'carriage'} eq 'disabled') ? ' checked="checked"' : '') . ' /> </label></legend>';
print '<div class="note">ɬפʤ</div>';
print '</fieldset>';
print '<fieldset><legend><label><input type="radio" name="data:carriage" value="nation"' . ((defined $setting::payment{'carriage'} && $setting::payment{'carriage'} eq 'nation') ? ' checked="checked"' : '') . ' /> Χ</label></legend>';
print '<label><input type="text" name="data:nation" id="data:nation" size="8" value="' . $this->escape($setting::payment{'nation'}) . '" onchange="cmonos.tool.prefSync(this.value);" /> <span class="unit"></span></label>';
print '</fieldset>';
print '<fieldset><legend><label><input type="radio" name="data:carriage" value="region"' . ((defined $setting::payment{'carriage'} && $setting::payment{'carriage'} eq 'region') ? ' checked="checked"' : '') . ' /> ñ</label></legend>';
print '<table class="tooltable"><tbody>';
my($id);
foreach $id (sort {$a <=> $b} keys %region_name_table) {		
	print '<tr class="' . (($id % 6 == 1) ? 'odd' : 'even') . '">' if $id % 3 == 1;
	print '<td class="' . ((($id-1) % 3 % 2) ? 'even' : 'odd') . '"><label for="data:region_' . $id . '">' . $region_name_table{$id} . '</label> <input type="text" name="data:region_' . $id . '" id="data:region_' . $id . '" size="8" value="' . $this->escape($setting::payment{'region'}{$id}) . '" onchange="cmonos.tool.prefSync(this.value,' . (join(',',$cgi::JPrefecture->get_prefecture_id_array_by_region_id($id))) . ');" /> <span class="unit"></span></td>';
	print '</tr>' if $id % 3 == 0;
}
print '</tbody></table>';
print '</fieldset>';
print '<fieldset><legend><label><input type="radio" name="data:carriage" value="prefecture"' . ((defined $setting::payment{'carriage'} && $setting::payment{'carriage'} eq 'prefecture') ? ' checked="checked"' : '') . ' /> ƻܸñ</label></legend>';
print '<table class="tooltable"><tbody>';
foreach $id (sort {$a <=> $b} keys %pref_name_table) {		
	print '<tr class="' . (($id % 6 == 1) ? 'odd' : 'even') . '">' if $id % 3 == 1;
	print '<td class="' . ((($id-1) % 3 % 2) ? 'even' : 'odd') . '"><label for="data:pref_' . $id . '">' . $pref_name_table{$id} . '</label> <input type="text" name="data:pref_' . $id . '" id="data:pref_' . $id . '" size="8" value="' . $this->escape($setting::payment{'pref'}{$id}) . '" />  <span class="unit"></span></td>';
	print '</tr>' if $id % 3 == 0;
}
print '<td><label><input name="prefsync" id="prefsync" type="checkbox" value="1"' . ((!$main::a || $main::prefsync) ? ' checked="checked"' : '') . ' /> Ϣư</label></td></tr>';
print '</tbody></table>';
print '</fieldset>';
print '<fieldset><legend><label><input type="radio" name="data:carriage" id="data:carriage" value="weight"' . ((defined $setting::payment{'carriage'} && $setting::payment{'carriage'} eq 'weight') ? ' checked="checked"' : '') . ' /> </label></legend>';
print '<table class="tooltable">';
print '<thead><tr class="odd"><th class="odd"></th><th class="even"></th><th class="odd"></th></tr></thead>';
print '<tbody>';
$count = 0;
$cell_limit = 1;
$cell_limit += scalar(keys %weight) if %weight;
while (1) {
	$count++;
	last if $count > 1 && $count > $cell_limit;
	print '<tr class="' . (($count % 2) ? 'even' : 'odd') . '">';
	print '<td class="caution">' . (($weight{$count}{'weight'}) ? '<input type="checkbox" name="weight:' . $count . ':delete" id="weight:' . $count . ':delete" value="1" />' : '') . '</td>';
	print '<td class="even"><input type="text" name="weight:' . $count . ':weight" id="weight:' . $count . ':weight" size="16" value="' . $this->escape($weight{$count}{'weight'}) . '" /> <span class="unit">g</span></td>';
	print '<td class="odd"><input type="text" name="weight:' . $count . ':carriage" id="weight:' . $count . ':carriage" size="16" value="' . $this->escape($weight{$count}{'carriage'}) . '" /> <span class="unit"></span></td>';
	print '</tr>';
}
print '</tbody></table>';
print '<label><input type="checkbox" name="for_book" id="for_book" value="1" /> 椦᡼ɤ߹</label><div class="hints">åơ¸פȤ椦᡼꤬ɽޤλǤɽƤ¸ƤޤʤФ⤦١¸פƤ</div></fieldset>';
print '<fieldset><legend><label for="data:packageweight"></label></legend>';
print '<input name="data:packageweight" id="data:packageweight" type="text" size="5" value="' . $this->escape($setting::payment{'packageweight'}) . '" title="Ǽʽ񡢴˾׺ʤɺɬפʤΤ" />g';
print '</fieldset>';
print '</fieldset>';

print '<fieldset><legend>ͥ</legend>';
print '<label><input type="text" name="data:specialcarriage_requirements" id="data:specialcarriage_requirements" size="8" value="' . $this->escape($setting::payment{'specialcarriage'}{'requirements'}) . '" /> ߰ʾʸǡΧ</label> ';
print '<label><input type="text" name="data:specialcarriage_cost" size="8" value="' . $this->escape($setting::payment{'specialcarriage'}{'cost'}) . '" /> ߤˤ롣</label>';
print '</fieldset>';

print '<fieldset><legend><label for="data:carriagenote">ջ</label></legend>';
print '<textarea name="data:carriagenote" id="data:carriagenote" cols="56" rows="5">';
print $this->escape($setting::payment{'carriagenote'});
print '</textarea>';
print '</fieldset>';

print '<fieldset class="submit"><input type="submit" value="¸" class="save" /></fieldset>';
print '</form>';

#ڡեå
$this->print_page_footer('tools');

}

sub is_not_number ($$$) {
my($this,$value,$name) = @_;
if (defined $$value && $$value ne '' && $this->is_nan($$value)) {
	push(@{$this->{'dialog'}},$name . 'ǤϤޤȾѿˤƤ');
	undef $$value;
	return 1;
}
return 0;
}

sub is_not_image ($$$) {
my($this,$value,$name) = @_;
if (defined $$value && $$value ne '' && $$value !~ m!^s?https?://[\w~\-]+\.[\w~\-/\.#\?\&=\%,]+\.(gif|jpg|jpeg|png)$!i) {
	push(@{$this->{'dialog'}},$name . 'URLǤϤޤ󡣲URLˤƤ');
	undef $$value;
	return 1;
}
return 0;
}

# ¿ζԤϤǤ륫̾ɤå
# ѿ ()
# ѥ (...)
# ѥʾʸ (        )
# ե٥åʸ (£ãģţƣǣȣɣʣˣ̣ͣΣϣУѣңӣԣգ֣ףأ٣)
# Ⱦ ()
#  ()(ԥꥪ)ʡˡݡ֡ס ѥڡ 
sub is_not_kana_name ($$$) {
my($this,$value,$name) = @_;
$$value = $this->h_to_z($$value);
if ($$value ne '' && $$value !~ /^(\xa3[\xb0-\xb9]|\xa3[\xc1-\xda]|\xa5[\xa2-\xf4]|\xa1[\xab\xac\xa4\xa5\xca\xcb\xbf\xdd\xbc\xd6\xd7\xa1\xa6])+$/) {
	push(@{$this->{'dialog'}},$name . '̾ǤϤޤѥʤˤƤ');
	undef $$value;
	return 1;
}
return 0;
}

sub is_invalid_formula ($$$) {
my($this,$formula,$name) = @_;
$$formula = $this->z_to_h($$formula) if $$formula !~ /^[\+\-]{0,1}[0-9\.x]+$/;
$$formula =~ s/[^0-9\.+\-\*\/)(x]//g;
if ($$formula =~ /x/) {
	my $f = $$formula;
	$f =~ s/x/1/g;
	if (eval($f) <= 0) {
		push(@{$this->{'dialog'}},$name . 'ǧƤ');
		undef $$formula;
		return 1;
	}
} elsif ($$formula ne '' && $this->is_nan($$formula)) {
	push(@{$this->{'dialog'}},$name . 'ǧƤ');
	undef $$formula;
	return 1;
}
return 0;
}

sub is_shortage ($$@) {
my($this,$name,@value) = @_;
if (grep(defined $_ && $_ ne '',@value) && grep(!defined $_ || $_ eq '',@value)) {
	push(@{$this->{'dialog'}},$name . '­ޤ٤ƵƤ');
	return 1;
}
return 0;
}

sub is_empty_array ($@) {
my($this,@value) = @_;
return (grep(defined $_ && $_ ne '',@value) == 0) ? 1 : 0;
}

sub h_to_z ($$) {
my($this,$text) = @_;
return '' if !defined $text || $text eq '';
$text =~ s!([\x20-\x7a])!{
	my $j = $1;
	$j =~ s/\x20/\xa1\xa1/ ||
	$j =~ s/\x28/\xa1\xca/ ||
	$j =~ s/\x29/\xa1\xcb/ ||
	$j =~ s/\x2c/\xa1\xa4/ ||
	$j =~ s/\x2e/\xa1\xa5/ ||
	$j =~ s/\x2f/\xa1\xbf/ ||
	$j =~ s/\x3a/\xa1\xa7/ ||
	$j =~ s/\x3b/\xa1\xa8/ ||
	$j =~ s/\x3f/\xa1\xa9/ ||
	$j =~ s/\x21/\xa1\xaa/ ||
	$j =~ s/\x2f/\xa1\xbf/ ||
	$j =~ s/\x7c/\xa1\xc3/ ||
	$j =~ s/\x23/\xa1\xf4/ ||
	$j =~ s/\x3d/\xa1\xe1/ ||
	$j =~ s/\x26/\xa1\xf5/ ||
	$j =~ s/\x40/\xa1\xf7/ ||
#	$j =~ s/([\x30-\x7e])/"\xa3" . $this->_h_to_z($1,128)/e;
	$j =~ s/([\x30-\x5a])/"\xa3" . $this->_h_to_z($1,128)/e;
	$j =~ s/([\x61-\x7a])/"\xa3" . $this->_h_to_z($1,160)/e;
	$j;
}!ges;
return $text;
}

sub _h_to_z ($$$) {
my($this,$c,$c2) = @_;
$c = unpack("c",$c);
$c = $c - $c2;
$c = pack("c",$c);
return $c;
}

sub print_payment_info_page ($$$) {
my($this,$pref_name_table,$region_name_table) = @_;
local(*INFO);
my $path = $default::file . '/payment_info.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html');
return 0 if !open(INFO, ">>$path");
flock(INFO, LOCK_EX);
truncate(INFO, 0);
seek(INFO, 0, 0);
$this->import_db($default::preference_dir . '/page',\%setting::page,1,'info');
my $table = Table->new;
if (defined $setting::page{'info'}{'table'} && $setting::page{'info'}{'table'} ne '') {
	if (ref $table::obj{$setting::page{'info'}{'table'}}) {
		%$table = %{$table::obj{$setting::page{'info'}{'table'}}};
	} elsif (defined $setting::table{$setting::page{'info'}{'table'}}{'setting'} && $setting::table{$setting::page{'info'}{'table'}}{'setting'}) {
		$table->set($setting::table{$setting::page{'info'}{'table'}}{'setting'});
		$table->{'name'} = $setting::table{$setting::page{'info'}{'table'}}{'name'};
	}
}
$table->set('thenabled' => 'false');

$this->print_page_header('info',\*INFO,$path);
print INFO '<div class="section" id="payment-info-box"><h2 id="payment-info-header">ʧˡ</h2><div class="body">';
print INFO '<dl id="payment-info">';

if ($setting::payment{'bankenabled'}) {
	print INFO '<dt id="bank-info-name">Կ</dt>';
	my $n;
	foreach $n (sort {$a <=> $b} keys %{$setting::payment{'bank'}}) {
		print INFO '<dd class="bank-info-detail">';
		print INFO $table->table;
		print INFO $table->tr;
		print INFO $table->th('');
		print INFO $table->td($this->escape($setting::payment{'bank'}{$n}{'bank'}));
		print INFO $table->_tr;
		if ($setting::payment{'bankinfo'}) {
			print INFO $table->tr;
			print INFO $table->th('Ź');
			print INFO $table->td($this->escape($setting::payment{'bank'}{$n}{'office'}));
			print INFO $table->_tr;
			if ($setting::payment{'bankinfo'} >= 2) {
				print INFO $table->tr;
				print INFO $table->th('');
				print INFO $table->td(((defined $setting::payment{'bank'}{$n}{'deposit'} && $setting::payment{'bank'}{$n}{'deposit'} eq 'current') ? '[] ' : '[] ') . $setting::payment{'bank'}{$n}{'number'});
				print INFO $table->_tr;
				if ($setting::payment{'bankinfo'} == 3) {
					print INFO $table->tr;
					print INFO $table->th('̾');
					print INFO $table->td($this->escape($setting::payment{'bank'}{$n}{'name'}));
					print INFO $table->_tr;
					print INFO $table->tr;
					print INFO $table->th('ɽ');
					print INFO $table->td($setting::payment{'bank'}{$n}{'kana'});
					print INFO $table->_tr;
				}
			}
		}
		print INFO $table->_table;
		print INFO '</dd>';
	}
	print INFO '<dd id="bank-info-note">' . $setting::payment{'banknote'} . '</dd>' if $setting::payment{'banknote'};
}
if ($setting::payment{'yubinenabled'}) {
	print INFO '<dt id="yuubin-info-name">椦(͹ؿ)</dt>';
	print INFO '<dd id="yuubin-info-detail">';
	if ($setting::payment{'yubininfo'}) {
		print INFO $table->table('id' => 'yuubin-info-table');
		print INFO $table->tr;
		print INFO $table->th('͹ض');
		print INFO $table->td($this->escape($setting::payment{'yubin'}{'office'}));
		print INFO $table->_tr;
		if ($setting::payment{'yubin'}{'bankname'}) {
			print INFO $table->tr;
			print INFO $table->th('Ź̾');
			print INFO $table->td($this->escape($setting::payment{'yubin'}{'bankname'}));
			print INFO $table->_tr;
		}
		if ($setting::payment{'yubininfo'} >= 2) {
			print INFO $table->tr;
			print INFO $table->th('ֹ');
			print INFO $table->td(((defined $setting::payment{'yubin'}{'mark'} && $setting::payment{'yubin'}{'mark'} ne '') ? $setting::payment{'yubin'}{'mark'} . '-' : '') . ((defined $setting::payment{'yubin'}{'digit'} && $setting::payment{'yubin'}{'digit'} ne '') ? $setting::payment{'yubin'}{'digit'} . '-' : ' -') . $setting::payment{'yubin'}{'number'});
			print INFO $table->_tr;
			if ($setting::payment{'yubininfo'} >= 3) {
				print INFO $table->tr;
				print INFO $table->th('̾');
				print INFO $table->td($this->escape($setting::payment{'yubin'}{'name'}));
				print INFO $table->_tr;
				if ($setting::payment{'yubin'}{'kana'}) {
					print INFO $table->tr;
					print INFO $table->th('ɽ');
					print INFO $table->td($this->escape($setting::payment{'yubin'}{'kana'}));
					print INFO $table->_tr;
				}
			}
		}
		print INFO $table->_table;
	} else {
		print INFO '椦';
	}
	print INFO '</dd>';
	print INFO '<dd id="yuubin-info-note">' . $setting::payment{'yubinnote'} . '</dd>' if $setting::payment{'yubinnote'};
}
if ($setting::payment{'paypalenabled'}) {
	print INFO '<dt id="paypal-info-name">PayPal</dt>';
	print INFO '<dd id="paypal-info-detail">';
	if ($setting::payment{'paypal'}{'banner'}) {
		print INFO $setting::payment{'paypal'}{'banner'};
	} else {
		print INFO '<a href="#" onclick="javascript:window.open(\'https://www.paypal.com/jp/cgi-bin/webscr?cmd=xpt/Marketing/popup/OLCWhatIsPayPal-outside\',\'olcwhatispaypal\',\'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes, width=400, height=350\');"><img src="https://www.paypal.com/ja_JP/JP/i/bnr/horizontal_solution_4_jcb.gif" border="0" alt="PayPalΥ塼" /></a>';
	}
	print INFO '</dd>';
#	if ($setting::payment{'paypal'}{'ratio'} || $setting::payment{'paypal'}{'fee'}) {
#		my $bounds;
#		print INFO '<dd id="paypal-info-cost">';
#		if ($setting::payment{'paypal'}{'incontext'} && $setting::payment{'paypal'}{'ratio'} && $setting::payment{'paypal'}{'mratio'} && $setting::payment{'paypal'}{'ratio'} != $setting::payment{'paypal'}{'mratio'}) {
#			my $ratio = ($setting::payment{'paypal'}{'ratio'}) ? $setting::payment{'paypal'}{'ratio'}/100 : 0;
#			my $fee = ($setting::payment{'paypal'}{'fee'}) ? $setting::payment{'paypal'}{'fee'} : 0;
#			my $mratio = ($setting::payment{'paypal'}{'mratio'}) ? $setting::payment{'paypal'}{'mratio'}/100 : 0;
#			my $mfee = ($setting::payment{'paypal'}{'mfee'}) ? $setting::payment{'paypal'}{'mfee'} : 0;
#			$bounds = abs(($mfee - $fee)/($ratio-$mratio));
#			$bounds = ($bounds > int $bounds) ? int $bounds + 1 : int $bounds;
#			$bounds = $this->digit($bounds);
#			print INFO 'ۤ' . $bounds . '̤' . ((($setting::payment{'paypal'}{'paymentaction'} && $setting::payment{'paypal'}{'paymentaction'} eq 'Sale')) ? 'Ȥ' : 'ɾ') . ' =';
#			print INFO ' ' . $setting::payment{'paypal'}{'mratio'} . '%' if $setting::payment{'paypal'}{'mratio'};
#			print INFO (($setting::payment{'paypal'}{'mratio'}) ? ' + ' : ' ') . $setting::payment{'paypal'}{'mfee'} . '' if $setting::payment{'paypal'}{'mfee'};
#			print INFO '<br />';
#		}
#		print INFO (($bounds && $setting::payment{'paypal'}{'paymentaction'} && $setting::payment{'paypal'}{'paymentaction'} eq 'Sale') ? 'ۤ' . $bounds . '߰ʾΤȤ' : (($bounds) ? '嵭Τ' : '') . 'μ') . ' =';
#		print INFO ' ' . $setting::payment{'paypal'}{'ratio'} . '%' if $setting::payment{'paypal'}{'ratio'};
#		print INFO (($setting::payment{'paypal'}{'ratio'}) ? ' + ' : ' ') . $setting::payment{'paypal'}{'fee'} . '' if $setting::payment{'paypal'}{'fee'};
#		print INFO '</dd>';
#	}
	print INFO '<dd id="paypal-info-note">' . $setting::payment{'paypalnote'} . '</dd>' if $setting::payment{'paypalnote'};
}
if ($setting::payment{'codenabled'}) {
	$table->set('thenabled' => 'true');
	print INFO '<dt id="cod-info-name"></dt>';
	print INFO '<dd id="cod-info-detail">';
	print INFO $table->table('id' => 'cod-info-table');
	print INFO $table->tr;
	print INFO $table->th('');
	print INFO $table->th('');
	print INFO $table->_tr;
	print INFO $table->tr;
	print INFO $table->td('1̤');
	print INFO $table->td($this->digit($setting::payment{'cod'}{'fee1'}) . ' <span class="unit"></span>');
	print INFO $table->_tr;
	if ($setting::payment{'cod'}{'fee2'} ne '') {
		print INFO $table->tr;
		print INFO $table->td('1߰ʾ3̤');
		print INFO $table->td($this->digit($setting::payment{'cod'}{'fee2'}) . ' <span class="unit"></span>');
		print INFO $table->_tr;
		if ($setting::payment{'cod'}{'fee3'} ne '') {
			print INFO $table->tr;
			print INFO $table->td('3߰ʾ10̤');
			print INFO $table->td($this->digit($setting::payment{'cod'}{'fee3'}) . ' <span class="unit"></span>');
			print INFO $table->_tr;
			if ($setting::payment{'cod'}{'fee4'} ne '') {
				print INFO $table->tr;
				print INFO $table->td('10߰ʾ30̤');
				print INFO $table->td($this->digit($setting::payment{'cod'}{'fee4'}) . ' <span class="unit"></span>');
				print INFO $table->_tr;
			}
		}
	}
	print INFO $table->_table;
	print INFO '</dd>';
	print INFO '<dd id="cod-info-note">' . $setting::payment{'codnote'} . '</dd>' if $setting::payment{'codnote'};
	$table->set('thenabled' => 'false');
}
if ($setting::payment{'moneyorderenabled'}) {
	print INFO '<dt id="moneyorder-info-name"><a href="http://www.jp-bank.japanpost.jp/kojin/tukau/sokin/hikoza/kj_tk_sk_hkz_kogawase.html" target="_blank">۾</a></dt>';
	print INFO '<dd id="moneyorder-info-note">' . $setting::payment{'moneyordernote'} . '</dd>' if $setting::payment{'moneyordernote'};
}
if ($setting::payment{'otherenabled'}) {
	my $n;
	foreach $n (sort {$a <=> $b} keys %{$setting::payment{'other'}}) {
		print INFO '<dt class="payment-info-name">' . $setting::payment{'other'}{$n}{'name'} . '</dt>';
		print INFO '<dd class="payment-info-detail">' . $setting::payment{'other'}{$n}{'note'} . '</dd>';
	}
}
print INFO '</dl></div></div>';

my $carriagetable = Table->new;
if (defined $setting::page{'info'}{'carriagetable'} && $setting::page{'info'}{'carriagetable'} ne '') {
	if (ref $table::obj{$setting::page{'info'}{'carriagetable'}}) {
		%$carriagetable = %{$table::obj{$setting::page{'info'}{'carriagetable'}}};
	} elsif (defined $setting::table{$setting::page{'info'}{'carriagetable'}}{'setting'} && $setting::table{$setting::page{'info'}{'carriagetable'}}{'setting'}) {
		$carriagetable->set($setting::table{$setting::page{'info'}{'carriagetable'}}{'setting'});
		$carriagetable->{'name'} = $setting::table{$setting::page{'info'}{'carriagetable'}}{'name'};
	}
}
$carriagetable->set('thenabled' => 'false');

if ($setting::payment{'carriage'} ne 'disabled') {
	print INFO '<div class="section" id="carriage-info-box"><h2 id="carriage-info-header"></h2><div class="body">';
	if ($setting::payment{'carriage'} eq 'nation') {
		print INFO '<span class="datatitle">Χ</span> ' . $this->digit($setting::payment{'nation'}) . ' <span class="unit"></span>';
	} elsif ($setting::payment{'carriage'} eq 'weight') {
		my($id);
		print INFO $carriagetable->table('id' => 'weight-table');
		foreach $id (sort {$a <=> $b} keys %{$setting::payment{'weight'}}) {		
			print INFO $carriagetable->tr;
			print INFO $carriagetable->th('' . $this->digit($setting::payment{'weight'}{$id}{'weight'}) . '<span class="unit">g</span>');
			print INFO $carriagetable->td($this->digit($setting::payment{'weight'}{$id}{'carriage'}) . ' <span class="unit"></span>');
			print INFO $carriagetable->_tr;
		}
		print INFO $carriagetable->_table;
	} elsif ($setting::payment{'carriage'} eq 'region') {
		my($id);
		print INFO $carriagetable->table('id' => 'regeon-table');
		foreach $id (sort {$a <=> $b} keys %$region_name_table) {		
			print INFO $carriagetable->tr if $id % 3 == 1;
			print INFO $carriagetable->th($region_name_table->{$id});
			print INFO $carriagetable->td($this->digit($setting::payment{'region'}{$id}) . ' <span class="unit"></span>');
			print INFO $carriagetable->_tr if $id % 3 == 0;
		}
		print INFO $carriagetable->_table;
	} elsif ($setting::payment{'carriage'} eq 'prefecture') {
		my($id);
		print INFO $carriagetable->table('id' => 'pref-table');
		foreach $id (sort {$a <=> $b} keys %$pref_name_table) {		
			print INFO $carriagetable->tr if $id % 3 == 1;
			print INFO $carriagetable->th($pref_name_table->{$id});
			print INFO $carriagetable->td($this->digit($setting::payment{'pref'}{$id}) . ' <span class="unit"></span>');
			print INFO $carriagetable->_tr if $id % 3 == 0;
		}
		print INFO $carriagetable->th('');
		print INFO $carriagetable->td('');
		print INFO $carriagetable->_tr;
		print INFO $carriagetable->_table;
	}
	if ($setting::payment{'specialcarriage'}{'requirements'}) {
		print INFO '<p id="spesialcarriage-info">';
		print INFO $this->digit($setting::payment{'specialcarriage'}{'requirements'}) . ' ߰ʾʸǡΧ <span id="spesialcarriage-cost">';
		print INFO $this->digit($setting::payment{'specialcarriage'}{'cost'}) . ' </span>Ȥʤޤ';
		print INFO '</p>';
	}
	if ($setting::payment{'carriagenote'}) {
		print INFO '<p id="carrage-info-note">';
		print INFO $setting::payment{'carriagenote'};
		print INFO '</p>';
	}
	print INFO '</div></div>';
}
$this->print_page_footer('info',\*INFO,$path);
undef %{$setting::page{'info'}};
close(INFO);
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('c210','MkPaymentTerms');

	#˥塼Ͽ
	$setting::jump_menu{'c210'} = 'ʧˡ';
	
}



1;
