package CategoryEditor;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
######################################################################
# ƥ꡼Խ⥸塼
# CategoryEditor.pm ver1.1.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-08-11
######################################################################
# ¹
sub run ($) {
my $this = shift;

#񤭹
if (defined $main::a && $main::a eq 'e') {
	#no warnings qw(numeric);

	#ǡ
	push (@main::delete,$main::delete) if defined $main::delete && $main::delete;
	@main::delete = grep(defined $_ && $_ ne '',@main::delete);
	if (@main::delete) {
		#Ƚؤαƶ
		foreach (@main::delete) {
			delete $main::old{$_};
			delete $main::order{$_};
		}
		$this->delete_category(@main::delete);
	}

	#Ƚ
	my $no = 0;
	foreach (sort {$main::order{$a} <=> $main::order{$b} || $main::old{$b} <=> $main::old{$a} || $main::order{$a} cmp $main::order{$b}} keys %main::order) {
		$no++;
		$main::data{'ORDER_' . $no} = $_;
		$main::data{$_ . '_ORDER'} = $no;
	}

	#ʥǡν
	my($k,$v,@name);
	while (($k,$v) = each %main::order) {
		$this->detag(\$main::data{$k . '_name'});
		$main::data{$k . '_name'} =~ s!/$!!;
		push(@name,$main::data{$k . '_name'});
	}
	undef $main::data{'LIMIT'} if $this->is_nan($main::data{'LIMIT'});
	$main::data{'MULTIPLE'} = '' if !defined $main::data{'MULTIPLE'} || !$main::data{'MULTIPLE'};

	#
	if (defined $main::new{'name'} && $main::new{'name'} ne '') {
		$this->detag(\$main::new{'name'});
		$main::new{'name'} =~ s!/$!!;
		push(@name,$main::new{'name'});
		my($k,$v,$n);
		while (1) {
			$n++;
			last if !defined $main::old{$n} || $main::old{$n} eq '';
		}
		$no++;
		$main::data{'ORDER_' . $no} = $n;
		$main::data{$n . '_ORDER'} = $no;
		while (($k,$v) = each %main::new) {
			$main::data{$n . '_' . $k} = $v;
		}
		@main::delete = grep($_ ne $n,@main::delete);
		$this->mk_category($n);
	}

	#̾å
	while (($k,$v) = each %main::order) {
		$main::data{$k . '_name'} .= '/' . (($default::english) ? 'Others' : '¾') while (grep($_ =~ m!^$main::data{$k . '_name'}/!,@name));
	}

	$this->write_db($default::preference_dir . '/category',\%main::data,'ORDER',\@main::delete,\%setting::category,1);
	$this->write_category_list;

} else {
	#ɤ߹
	$this->import_db($default::preference_dir . '/category',\%setting::category,1);
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>ƥ꡼Խ</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="e" />';
print '<fieldset><legend>ƥ꡼Խ</legend>';

#ơ֥
require CMONOS::CGI_Lib::Table;
my $table = Table->new;
$table->set(
	'tableclass' => 'tooltable',
	'trclass' => 'odd,even',
	'class0' => 'odd,even',
	'classF' => 'name',
	'thenabled' => 'true'
);

print $table->table;

#إå
print $table->tr;
print $table->td('');
print $table->td('ɽ');
print $table->td('ƥ꡼̾');
print $table->_tr;

#
my(@categories,%done,$c);
if (%setting::category) {
	#no warnings qw(numeric);
	@categories = sort {$setting::category{$a}{'ORDER'} <=> $setting::category{$b}{'ORDER'} || $a <=> $b} grep(defined $_ && $_ !~ /\D/,keys %setting::category);
}
foreach $c (@categories) {
	$setting::category{$c}{'ORDER'} = $c if !defined $setting::category{$c}{'ORDER'};
	print $table->tr;
	print $table->td('<input type="checkbox" name="delete" value="' . $c . '" onclick="cmonos.form.field(this).checkboxConfirm(\'' . $setting::category{$c}{'name'} . '˴ϢƤΥǡޤ˺ޤ\')" />');
	print $table->td('<input type="hidden" name="old:' . $c . '" value="' . $setting::category{$c}{'ORDER'} . '" /><input type="text" name="order:' . $c . '" value="' . $setting::category{$c}{'ORDER'} . '" size="2" maxlength="2" />');
	print $table->td('<input type="text" name="data:' . $c . '_name" value="' . $setting::category{$c}{'name'} . '" size="60" />');
	print $table->_tr;
	$done{$c}++;
}

#
print $table->tr;
print $table->td('');
print $table->td('');
print $table->td('<input type="text" name="new:name" size="60" />');
print $table->_tr;

print $table->_table;
print '<div class="hints">ƥ꡼ɲäˤϿƥ꡼̾ޤ</div>';
print '<div class="hints">ƥ꡼̾ / ǶڤȳؤɽǤޤ</div>';
print '</fieldset>';

print '<fieldset class="submit"><input type="submit" value="¸" class="save" /></fieldset>';

print '<fieldset><legend>ƥ꡼</legend>';
print '<table class="field-table"><tbody>';

if (!ref $setting::category{'DEFAULT'}) {
	my $temp = (defined $setting::category{'DEFAULT'}) ? $setting::category{'DEFAULT'} : '';
	$setting::category{'DEFAULT'} = [];
	push(@{$setting::category{'DEFAULT'}},$temp) if $temp ne '';
}
my $size = 0;
my $selector = $this->mk_category_selector(\%setting::category,\@categories,$setting::category{'DEFAULT'},\$size);
print '<tr>';
print '<td class="field-name"><label for="data:DEFAULT">Ѥߥƥ꡼</label></td>';
print '<td class="field"><select name="data:DEFAULT" id="data:DEFAULT"';
if (defined $setting::category{'MULTIPLE'} && $setting::category{'MULTIPLE'}) {
	$size = 1 if $size < 1;
	print ' size="' . $size. '" multiple="multiple"';
}
print '>';
print $selector;
undef $selector;
undef $size;
print '</select>';
print ' <label><input type="checkbox" name="data:MULTIPLE" value="1"' . ((defined $setting::category{'MULTIPLE'} && $setting::category{'MULTIPLE'}) ? ' checked="checked"' : '') . ' /> ʣΥƥ꡼</label>';
print '</td>';
print '</tr>';

$setting::category{'LIMIT'} = ($default::max) ? $default::max : 2000 if !defined $setting::category{'LIMIT'} || $setting::category{'LIMIT'} eq '' || $setting::category{'LIMIT'} =~ /\D/;
print '<tr>';
print '<td class="field-name"><label for="data:ADD">쥳</label></td>';
print '<td class="field">';
print '<label for="data:LIMIT">쥳ɿ</label> <input type="text" size="4" maxlength="4" name="data:LIMIT" id="data:LIMIT" value="' . $setting::category{'LIMIT'} . '" /> ĶȤ ';
if (!$default::type || ($default::type ne 'account' && $default::type ne 'order')) {
	print $this->mk_select_menu(
		'data:ADD','','',$setting::category{'ADD'},
		'add'			=>		' ǤŤ쥳ɤõƿ쥳ɤɲä롣',
		'newcategory'		=>		' ƥ꡼ƿ쥳ɤɲä롣',
		'refuse'		=>		' 쥳ɤν񤭹ߤ䤹롣'
	);
} else {
	print 'ƥ꡼ƿ쥳ɤɲä롣';
}
print '</td>';
print '</tr>';

print '</tbody></table>';
print '</fieldset>';

print '<fieldset class="submit"><input type="submit" value="¸" class="save" /></fieldset>';
print '</form>';

print '<form name="sample-codes" id="sample-codes" action="#">';
my $target = $this->path_change($default::file,$ENV{'SCRIPT_NAME'},'abs') . '/category_list';
if (defined $env::ssi && $env::ssi) {
	print '<fieldset class="sample"><legend><label for="sample-ssi">ƥ꡼ꥹߥ(Ū SSI)</label></legend>';
	print '<textarea cols="70" rows="3">&lt;!--#include virtual=&quot;' . $target . '.ssi&quot;--&gt;</textarea>';
	print '</fieldset>';
}
$target = $this->http_my_domain . $target;
print '<fieldset class="sample"><legend><label for="sample-js">ƥ꡼ꥹߥ(Ū JavaScript)</label></legend>';
print '<textarea cols="70" rows="3">&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot; src=&quot;' . $target . '.js&quot;&gt;&lt;/script&gt;</textarea>';
print '</fieldset>';
print '</form>';

#ڡեå
$this->print_page_footer('tools');

}

sub delete_category ($@) {
my($this,@delete) = @_;
my($c,$mail_field,%email_to_id,$mail_tied,@urls,$home_url);
$home_url = $this->my_url . '?m=DetailViewer&c=';
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
#if (defined $default::type && $default::type eq 'account') {
#	my(%field);
#	undef %setting::field;
#	tie(%field, $env::dbm_file, $default::field_pref_dir . '/inputfield', O_RDONLY, $env::dbm_mode);
#	$mail_field = $field{'MAILFIELD'};
#	untie %field;
#	if (defined $mail_field && $mail_field) {
#		tie(%email_to_id, $env::dbm_file, $default::db . '/email_to_id', O_RDWR | O_CREAT, $env::dbm_mode);
#		undef $mail_field if !ref tied %email_to_id;
#		$mail_tied = 1;
#	}
#}
use File::Path;
foreach $c (@delete) {
	if (defined $mail_field && $mail_field) {
		my(%email);
		tie(%email, $env::dbm_file, $default::db . '/' . $c . '/' . $mail_field, O_RDONLY, $env::dbm_mode);
		if (ref tied %email) {
			my($id,$email);
			while (($id,$email) = each %email) {
				delete $email_to_id{$email};
			}
			untie %email;
		}
	}
	if (-d "$default::file/$c") {
		rmtree "$default::file/$c";
	}
	if (-d "$default::db/$c") {
		rmtree "$default::db/$c";
	}
	push(@urls,$home_url . $c);
}
if (defined $mail_tied && $mail_tied) {
	untie %email_to_id;
}
require CMONOS::CGI_Lib::IndexSweeper;
IndexSweeper->new(
	'index_files'	=>	[
							$env::externalfiles . '/recentcomments.ssi',
							$env::externalfiles . '/recenttrackbacks.ssi',
						],
	'rss_files'		=>	[
							'../../index.xml',
							'../../comment.xml',
							'../../trackback.xml',
							'../../podcast.xml',
							$default::file . '/index.xml',
							$default::file . '/comment.xml',
							$default::file . '/trackback.xml',
							$default::file . '/podcast.xml',
						],
)->sweep(\@urls,{$default::id => \@delete});
return;
}

sub mk_category ($$) {
my($this,$id) = @_;
$this->set_dir("$default::db/$id");
$this->set_dir("$default::file/$id");
return;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('00t0','CategoryEditor');

	#˥塼Ͽ
	$setting::jump_menu{'00t0'} = 'ƥ꡼Խ';
	
}



1;
