package InputField;
require CMONOS::CGI_Lib::Tools::FieldEditor;
@ISA = qw(FieldEditor);
use strict;
######################################################################
# ϥեԽ⥸塼
# InputField.pm ver1.1.8
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-08-16
######################################################################
# եɤ߹
sub set_field ($) {
#no warnings qw(once);
my $this = shift;
$setting::field_db_name = 'inputfield';
$setting::field = 2;
push(@check::checkbox,'protected','Hidden','Default','detailTable','searchEnabled','sortEnabled');
if ($default::type && $default::type eq 'order') {
	push(@check::checkbox,'skippable');
}
$this->{'foldable'} = 1;
}

######################################################################
# եDB
sub mk_field ($$) {
my($this,$id) = @_;
return if $field::obj{$id}->db ne $id;

my(@category,$c);
local(*CATEGORY,*DIR);

use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

#ǡ١
$default::db =~ s!/$!!;
opendir(CATEGORY,$default::db);
@category = grep($_ !~ /^\./ && -d "$default::db/$_",readdir(CATEGORY));
closedir(CATEGORY);
foreach $c (@category) {
	my $dir = $default::db . '/' . $c;
	if ($this->set_dir($dir)) {
		my(%new,%mtime);
		tie(%new, $env::dbm_file, $dir . '/' . $id, O_RDWR | O_CREAT, $env::dbm_mode);
		if (ref tied %new) {
			tie(%mtime, $env::dbm_file, $dir . '/mtime', O_RDONLY, $env::dbm_mode);
			if (ref tied %mtime) {
				my($n);
				while (($n) = each %mtime) {
					$new{$n} = '' if !defined $new{$n} ||  $new{$n} eq '';
				}
			}
			untie(%mtime);
		}
		untie(%new);
	}
}
}

######################################################################
# ̾
sub print_setting_item_name ($$) {
my($this,$table) = @_;
print $table->td('');
print $table->td('');
print $table->td('');
print $table->td('ݸ');
print $table->td('');
print $table->td('<br />ά') if $default::type && $default::type eq 'order';
print $table->td('');
print $table->td('ơ֥ɽ<br />ǥե');
print $table->td('ܺɽ<br />');
print $table->td('о');
print $table->td('о');
}

sub field_setting_check ($$) {
my($this,$k) = @_;
if (defined $main::data{$k . '_Hidden'} && $main::data{$k . '_Hidden'}) {
	$main::data{$k . '_Default'} = '';
	$main::data{$k . '_detailTable'} = '';
}
return;
}

sub note ($) {
my $this = shift;
return '<div class="warning">åץɤ줿եϥǽʰ֤¸ޤפޤϡֱפꤷƤľܥ뤳ȤϲǽǤ</div>';
}

######################################################################
# 
sub print_setting_items  ($$$$;$) {
my($this,$table,$field,$name,$id) = @_;

$field->{'cellWidth'} = '150' if !defined $field->{'cellWidth'} ||  $field->{'cellWidth'} eq '';
$field->{'Open'} = '1' if !defined $field->{'Open'} ||  $field->{'Open'} eq '';

print $table->td(
	$this->mk_select_menu(
		$name . 'cellWidth','','',$field->{'cellWidth'},
		'50'		=>		' 50',
		'100'		=>		'100',
		'150'		=>		'150',
		'200'		=>		'200',
		'250'		=>		'250',
		'300'		=>		'300',
		'350'		=>		'350',
		'400'		=>		'400'
	)
);

print $table->td(
	$this->mk_select_menu(
		$name . 'cellAlign','','',$field->{'cellAlign'},
		'left'		=>		'',
		'center'	=>		'',
		'right'		=>		''
	)
);

print $table->td(
	$this->mk_select_menu(
		$name . 'cellValign','','',$field->{'cellValign'},
		'top'		=>		'',
		'middle'	=>		'',
		'bottom'	=>		''
	)
);

if ($field->{'class'} !~ /^user_/) {
	print $table->td('<input type="checkbox" name="' . $name . 'protected" value="1"' . (($field->{'protected'}) ? ' checked="checked"' : '') . ' />') ;
} else {
	print $table->td('');
}

print $table->td(
	$this->mk_select_menu(
		$name . 'Open','','',$field->{'Open'},
		'1'		=>		'̸',
		'0'		=>		''
	)
);

if ($default::type && $default::type eq 'order') {
	if ($field->input_enabled && $field->{'class'} !~ /^(?:ug|xtm|yorder)_/ && (!$field->{'field_for'}{'mail'} || $field->{'field_for'}{'mail'} ne $field->{'id'})) {
		print $table->td('<input type="checkbox" name="' . $name . 'skippable" value="1"' . (($field->{'skippable'}) ? ' checked="checked"' : '') . ' />');
	} else {
		print $table->td('');
	}
}

print $table->td(
	'<input type="checkbox" name="' . $name . 'Hidden" value="1"' . (($field->{'Hidden'}) ? ' checked="checked"' : '')
	. ' onclick="cmonos.form.item(this.form).checkboxSync(this.checked,true,\'' . $name . 'Default\',false,\'' . $name . 'detailTable\',false)" />'
);

print $table->td(
	'<input type="checkbox" name="' . $name . 'Default" value="1"' . (($field->{'Default'}) ? ' checked="checked"' : '')
	. ' onclick="cmonos.form.item(this.form).checkboxSync(this.checked,true,\'' . $name . 'Hidden\',false)" />'
);
if ($field->format_for_detail_enabled) {
	print $table->td(
		'<input type="checkbox" name="' . $name . 'detailTable" value="1"' . (($field->{'detailTable'}) ? ' checked="checked"' : '')
		. ' onclick="cmonos.form.item(this.form).checkboxSync(this.checked,true,\'' . $name . 'Hidden\',false)" />'
	);
} else {
	print $table->td('');
}
if ($field->search_form_enabled) {
	print $table->td('<input type="checkbox" name="' . $name . 'searchEnabled" value="1"' . (($field->{'searchEnabled'}) ? ' checked="checked"' : '') . ' />') ;
} else {
	print $table->td('');
}
if ($field->sort_enabled) {
	print $table->td('<input type="checkbox" name="' . $name . 'sortEnabled" value="1"' . (($field->{'sortEnabled'}) ? ' checked="checked"' : '') . ' />');
} else {
	print $table->td('');
}
}

######################################################################
#
sub print_sub_setting_items ($) {
my $this = shift;
return if !%field::obj;

print '<fieldset><legend>üե</legend><table class="field-table"><tbody>';

print '<tr><td class="field-name"><label for="data:for_key">ե</label></td>';
print '<td class="field"><select name="data:for_key" id="data:for_key">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->sort_enabled;
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'key'} && $field::for{'key'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_title">ȥե</label></td>';
print '<td class="field"><select name="data:for_title" id="data:for_title">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->{'Open'} && !$field::obj{$field::ORDER{$_}}->{'Hidden'} && $field::obj{$field::ORDER{$_}}->sort_enabled && $field::obj{$field::ORDER{$_}}->{'class'} =~ /^text/;
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'title'} && $field::for{'title'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_content">ʸե</label></td>';
print '<td class="field"><select name="data:for_content" id="data:for_content">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->{'Open'} && !$field::obj{$field::ORDER{$_}}->{'Hidden'} && $field::obj{$field::ORDER{$_}}->{'class'} =~ /^text/;
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'content'} && $field::for{'content'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_name">̾ե</label></td>';
print '<td class="field"><select name="data:for_name" id="data:for_name">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->{'class'} =~ /^text/ && $field::obj{$field::ORDER{$_}}->sort_enabled;
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'name'} && $field::for{'name'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
if (!$default::type || $default::type ne 'order') {
	print '<ol class="checkbox"><li><label><input type="checkbox" name="data:NAMECHECK" value="1"' . (($field::NAMECHECK) ? ' checked="checked"' : '') . ' />';
	print ' ̾ʣåǡ١ϿϿѤߤ̾ȽʣƤʤå</label></li>';
	print '<li><label><input type="checkbox" name="data:NAMEREGISTER" value="1"' . (($field::NAMEREGISTER) ? ' checked="checked"' : '') . ' />';
	print ' ̾桼̾ǡ١Ͽ¾ CGI ѡ</label></li></ol>';
}
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_mail">ɽ᡼ե</label></td>';
print '<td class="field"><select name="data:for_mail" id="data:for_mail">';
print '<option value=""></option>' if !$default::type || $default::type ne 'order';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->{'e-mail'} && $field::obj{$field::ORDER{$_}}->{'class'} =~ /email/;
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'mail'} && $field::for{'mail'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_media">ǥե</label></td>';
print '<td class="field"><select name="data:for_media" id="data:for_media">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && ($field::obj{$field::ORDER{$_}}->{'class'} eq 'file' || $field::obj{$field::ORDER{$_}}->{'class'} eq 'file_media' || $field::obj{$field::ORDER{$_}}->{'class'} eq 'file_shipainter');
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'media'} && $field::for{'media'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_coordinates">ɸե</label></td>';
print '<td class="field"><select name="data:for_coordinates" id="data:for_coordinates" title="Googleޥåפ˥ǥåɽݺɸȤեɤꤷޤ">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->{'class'} eq 'webapi_gmap';
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'coordinates'} && $field::for{'coordinates'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

print '<tr><td class="field-name"><label for="data:for_sort">ȹܤΥǥե</label></td>';
print '<td class="field"><select name="data:for_sort" id="data:for_sort">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && $field::obj{$field::ORDER{$_}}->sort_enabled && $field::obj{$field::ORDER{$_}}->{'sortEnabled'};
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'sort'} && $field::for{'sort'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';
print '<tr class="tbody-end"><td class="field-name"><label for="data:SORTORDER">ˡΥǥե</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	'data:SORTORDER','','',$field::SORTORDER,
	'ascend'		=>		'',
	'descend'		=>		'߽'
);
print '</td></tr>';

print '</tbody><tbody>';

print '<tr><td class="field-name"><label for="data:for_top">ܺɽڡΥȥå׹</label></td>';
print '<td class="field"><select name="data:for_top" id="data:for_top">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next if !ref $field::obj{$field::ORDER{$_}} || $field::obj{$field::ORDER{$_}}->{'Hidden'} || !$field::obj{$field::ORDER{$_}}->format_for_detail_enabled;
	print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'top'} && $field::for{'top'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

if ($default::type && $default::type eq 'order') {
	print '</tbody><tbody>';

	print '<tr><td class="field-name"><label for="data:for_shippingaddress">轻ե</label></td>';
	print '<td class="field"><select name="data:for_shippingaddress" id="data:for_shippingaddress">';
	print '<option value=""></option>';
	foreach (sort {$a <=> $b} keys %field::ORDER) {
		next if !ref $field::obj{$field::ORDER{$_}} || $field::obj{$field::ORDER{$_}}->{'class'} ne 'addr_j';
		print '<option value="' . $field::ORDER{$_} . '"' . ((defined $field::for{'shippingaddress'} && $field::for{'shippingaddress'} eq $field::ORDER{$_}) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
	}
	print '</select>';
	print '</td></tr>';
}

print '</tbody></table>';
print '</fieldset>';

print '<fieldset class="submit"><input type="submit" value="¸" class="save" /></fieldset>';

}

sub field_general_setting_check ($) {
my $this = shift;
if ($default::type && $default::type eq 'order') {
	if (!$main::data{'for_mail'} || (@main::delete && grep($_ eq $main::data{'for_mail'},@main::delete))) {
		my @mail_fields = ();
		while (my($k,$v) = each %main::data) {
			if ($k && $v && $k =~ /^(\d+)_class$/) {
				my $id = $1;
				if ($v =~ /email/ && (!@main::delete || !grep($_ eq $id,@main::delete))) {
					push(@mail_fields,$id);
				}
			}
		}
		if (@mail_fields) {
			if (@mail_fields == 1) {
				$main::data{'for_mail'} = $mail_fields[0];
				push(@{$this->{'dialog'}},'' . ($main::data{$mail_fields[0] . '_name'} || '᡼륢ɥ쥹') . 'ץեɤɽ᡼եɡפꤷޤ');
			} else {
				push(@{$this->{'dialog'}},'ɽ᡼եɡפꤷƤ뤿ɬפȤʤޤ');
			}
		} else {
			push(@{$this->{'dialog'}},'֥᡼륢ɥ쥹ץեɥפɲäơɽ᡼եɡפꤷƤ뤿ɬפȤʤޤ');
		}
	}
	if ($main::data{'for_mail'} && !$main::data{$main::data{'for_mail'} . '_required'}) {
		$main::data{$main::data{'for_mail'} . '_required'} = 1;
		push(@{$this->{'dialog'}},'' . ($main::data{$main::data{'for_mail'} . '_name'} || '᡼륢ɥ쥹') . 'ץեɤɬܹܤꤷޤ');
	}
} else {
	$main::data{'NAMECHECK'} = '' if !defined $main::data{'NAMECHECK'} || !$main::data{'NAMECHECK'};
	$main::data{'NAMEREGISTER'} = '' if !defined $main::data{'NAMEREGISTER'} || !$main::data{'NAMEREGISTER'};
}
return;
}

######################################################################
# ǡ١
sub delete_field ($@) {
my($this,@delete) = @_;
my($category,$dir,$file,$delete_all);
local(*CATEGORY,*DIR);

#եɤ줿
$delete_all = 1 if keys %main::order == 0;

#ǡ١
opendir(CATEGORY,$default::db);
$default::db =~ s!/$!!;
foreach $category (readdir(CATEGORY)) {
	next unless $category !~ /^\./ && -d "$default::db/$category";
	opendir(DIR,"$default::db/$category");
	foreach $file (readdir(DIR)) {
		next unless $file !~ /^\./ && -f "$default::db/$category/$file";
		if ($delete_all || grep($file =~ /^$_(\.|_|$)/,@delete) > 0) {
			unlink "$default::db/$category/$file";
		}
	}
	closedir(DIR);
}
closedir(CATEGORY);

#źեե
opendir(CATEGORY,$default::file);
$default::file =~ s!/$!!;
foreach $category (readdir(CATEGORY)) {
	next unless $category !~ /^\./ && -d "$default::file/$category";
	opendir(DIR,"$default::file/$category");
	foreach $dir (readdir(DIR)) {
		next unless $dir !~ /^\./ && -d "$default::file/$category/$dir";
		opendir(NO,"$default::file/$category/$dir");
		foreach $file (readdir(NO)) {
			next unless $file !~ /^\./ && -f "$default::file/$category/$dir/$file";
			if (grep($file =~ /^$_(\.|$)/,@delete) > 0) {
				unlink "$default::file/$category/$dir/$file";
			}
		}
		closedir(NO);
	}
	closedir(DIR);
}
closedir(CATEGORY);
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('t100','InputField');

	#ġϿ
	$setting::jump_menu{'t100'} = 'ϥե';
}

1;
