package TableImport;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
#no warnings qw(untie);
######################################################################
# ƥɤ߹ߥ⥸塼
# TableImport.pm ver1.2.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-08-12
######################################################################
# ¹
sub run ($) {
my $this = shift;
$this->read_setting;

#Խ񤭹
if (defined $main::a && $main::a eq 'w' && defined $main::file && $main::file ne '' && defined $main::c && $main::c ne '') {
	
	#ƥ꡼ο
	if ($main::c =~ /\D/ || !ref $setting::category{$main::c}) {
		$main::c = $this->new_number(\%setting::category,1);
		$this->mk_category($main::c);
	}
	
	#񤭤
	if (defined $main::field && $main::field eq 'change') {
		$this->delete_category($main::c);
		$main::field = '';
	}

	$main::type = ($main::file =~ /\.csv$/i) ? 'csv' : ($main::file =~ /\.tsv$/i) ? 'tsv' : (defined $main::type) ? $main::type : 'csv';
	
	#礭ե
	if ($cgi::input->get_posted_file_size_from_param('file') > 8000000) {
		push(@{$this->{'dialog'}},'եɤ߹ߤ˼Ԥޤե륵礭ޤ');

	#ƥȤǡ١Ѵ
	} else {
		require CMONOS::CGI_Lib::Table;
		my $import = Table->new;
		my $data = $cgi::input->get_posted_file_data('file');
		$data =~ s/[\x0A\x0D]+\Z//;
		$data = $cgi::Jcode->set(\$data)->euc;
		$import->sv_to_table(\$data,'no',$main::type,$this);
		push(@{$this->{'dialog'}},'եɤ߹ߤޤ̤ǧƤ');
	}
	$cgi::input->clear_clipboard;
} elsif (defined $main::a && $main::a eq 'w') {
	push(@{$this->{'dialog'}},'եɤ߹ߤ˼Ԥޤե뤬åץɤƤޤ');
}

#ڡإå
$this->jump_menu('tools');
$this->print_page_header('tools');

print '<h1>եɤ߹</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'multi'	=> 1,
	'onsubmit'	=>	'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	\@setting::form
);
print '<input type="hidden" name="a" value="w" />';

print '<fieldset><table class="field-table"><tbody><tr><td class="field-name"><label for="c">ɤ߹襫ƥ꡼</label></td><td class="field">';
$this->print_category_selector(1);
print '</td></tr>';

print '<tr><td class="field-name"><label for="field">ȹե</label></td><td class="field">';
$this->print_field_menu;
print '<div class="hints">쥳ɿͤãƤȾȹǤޤ</div></td></tr>';

print '<tr class="tbody-end"><td class="field-name"><span class="datatitle">ե̾䴰</span></td><td class="field"><label for="option"><input type="checkbox" name="option" id="option" value="1" /> ܤե̾Ȥɤ߹ʥե̤</label></td></tr>';

print '</tbody><tbody>';

print '<tr><td class="field-name"><label for="file">ե</label></td>';
print '<td class="field"><input type="file" name="file" id="file" />';
print '</td></tr>';

print '<tr><td class="field-name"><label for="type">ե</label></td>';
print '<td class="field"><select name="type">';
print '<option value="csv">޶ڤƥȡExcel</option>';
print '<option value="tsv">ֶڤƥȡFileMaker</option>';
print '</select>';
print '</td></tr>';

print '</tbody></table></fieldset>';

print '<fieldset class="submit"><input type="submit" value="ɤ߹" /></fieldset></form>';

#ڡեå
$this->print_page_footer('tools');

}

######################################################################
# ƽ
sub read_setting ($) {
my $this = shift;

#ƥ꡼ɤ߹
$this->import_db($default::preference_dir . '/category',\%setting::category,1);
$setting::category{'LIMIT'} = 2000 if !defined $setting::category{'LIMIT'} || !$setting::category{'LIMIT'}; 
$setting::category{'ADD'} = '' if !defined $setting::category{'ADD'};

#եɤ߹
$this->use_field('field',$default::field_pref_dir . '/inputfield',2,2,'no');

}

######################################################################
# ƥ꡼˥塼
sub print_category_selector ($$) {
my($this,$option) = @_;
print '<select name="c" id="c">';
foreach my $o (sort {$a <=> $b} keys %{$setting::category{'ORDER'}}) {
	my $c = $setting::category{'ORDER'}{$o};
	print '<option value="', $c, '"', ((defined $main::c && $c eq $main::c) ? ' selected="selected"' : ''), '>', $setting::category{$c}{'name'}, ' (', ($setting::category{$c}{'count'} || 0), '/', ($setting::category{$c}{'total'} || 0), ')</option>';
}
print '<option value="new"></option>' if $option;
print '</select>';
}

######################################################################
# եɥ˥塼
sub print_field_menu ($) {
my $this = shift;
my($check);
print '<select name="field" id="field">';
print '<option value=""></option>';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless $field::obj{$field::ORDER{$_}}->sort_enabled && $field::obj{$field::ORDER{$_}}->{'sortEnabled'};
	print '<option value="' . $field::ORDER{$_} . '"';
	print ' selected="selected"' if (!$main::field && $field::ORDER{$_} == $field::for{'key'}) || ($main::field && $field::ORDER{$_} == $main::field);
	print '>' . $this->jfold($field::obj{$field::ORDER{$_}}->name,32,'I',1) . '</option>';
	$check = 1;
}
print '<option value=""></option>' if $check;
print '<option value="change"></option>';
print '</select>';

}

######################################################################
# ƥ꡼
sub mk_category ($$;$$) {
my($this,$id,$name,$order) = @_;
my(%new,$new_name,$category_count);
$this->set_dir("$default::db/$id");
$this->set_dir("$default::file/$id");
$category_count = keys %{$setting::category{'ORDER'}};
$new_name = (defined $name && $name) ? $name : ($main::file =~ m!([^/\\:]+?)(\.\w+|)$!) ? $1 : '';
if ($new_name ne '') {
	my(@names,$name_text,$name_no);
	@names = map($setting::category{$_}{'name'},grep(defined $_ && $_ !~ /\D/,keys %setting::category));
	($name_text,$name_no) = ($1,$2) if $new_name =~ /^(.*?)(\d*)$/;
	while (grep($_ eq $name_text . $name_no,@names)) {
		$name_no++;
		$name_no++ if $name_no == 1;
	}
	$new_name = $name_text . $name_no;
}
if ($order && $order <= $category_count) {
	my %order = %{$setting::category{'ORDER'}};
	foreach (sort {$a <=> $b} keys %order) {
		if ($_ == $order) {
			$setting::category{$id}{'ORDER'} =  $new{$id . '_ORDER'} = $order;
			$setting::category{'ORDER'}{$order} = $new{'ORDER_' . $order} = $id;
			$setting::category{$id}{'name'} = $new{$id . '_name'} = ($new_name ne '') ? $new_name : $order;
		}
		if ($new{'ORDER_' . $_}) {
			my $o = $_ + 1;
			my $i = $order{$_};
			$setting::category{$i}{'ORDER'} =  $new{$i . '_ORDER'} = $o;
			$setting::category{'ORDER'}{$o} = $new{'ORDER_' . $o} = $i;
		}
	}
} else {
	$setting::category{$id}{'ORDER'} = $new{$id . '_ORDER'} = $category_count + 1;
	$setting::category{'ORDER'}{$new{$id . '_ORDER'}} = $new{'ORDER_' . $new{$id . '_ORDER'}} = $id;
	$setting::category{$id}{'name'} = $new{$id . '_name'} = ($new_name ne '') ? $new_name : $new{$id . '_ORDER'};
}
$this->write_db($default::preference_dir . '/category',\%new);
}

sub delete_category ($$) {
my($this,$c) = @_;

if (opendir(DIR,"$default::db/$c")) {
	foreach (readdir(DIR)) {
		unlink "$default::db/$c/$_";
	}
	closedir(DIR);
}

#źեե
use File::Path;
rmtree "$default::file/$main::c";

return;
}

######################################################################
# ʲTable.pmǤζڤʸƥʬ˴ط
# TABLE
sub table {
my $this = shift;
$this->set_dir("$default::db/$main::c");
$this->{'db_dir'} = "$default::db/$main::c/";
$this->{'total'} = $this->{'row'} = 0;
$this->{'time'} = time;

use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
tie(%{$this->{'DB'}{'mtime'}}, $env::dbm_file, $this->{'db_dir'} . 'mtime', O_RDWR | O_CREAT, $env::dbm_mode);
tie(%{$this->{'DB'}{'ctime'}}, $env::dbm_file, $this->{'db_dir'} . 'ctime', O_RDWR | O_CREAT, $env::dbm_mode);

#쥳ɿ
while (my($k,$v) = each %{$this->{'DB'}{'mtime'}}) {
	$this->{'total'}++;
}

#ȹեɤ߹
if (defined $main::field && $main::field ne '' && $field::obj{$main::field}->sort_enabled && $field::obj{$main::field}->{'sortEnabled'}) {
	$this->{'KEY_DB'} = $field::obj{$main::field}->db;
	if (defined $this->{'KEY_DB'} && $this->{'KEY_DB'}) {
		unless (ref tied %{$this->{'DB'}{$this->{'KEY_DB'}}}) {
			tie(%{$this->{'DB'}{$this->{'KEY_DB'}}}, $env::dbm_file, $this->{'db_dir'} . $this->{'KEY_DB'}, O_RDWR | O_CREAT, $env::dbm_mode);
		}
		while (my($k,$v) = each %{$this->{'DB'}{$this->{'KEY_DB'}}}) {
			$this->{'KEY'}{$v} = $k;
		}
	}
}

return '';
}

######################################################################
# _TABLE
sub _table {
my $this = shift;

#ǡ١Ȥ³
my($k,$v);
while (($k,$v) = each %{$this->{'DB'}}) {
	untie %{$v} if ref tied %{$v};
	undef %{$v};
}
untie %{$this->{'DB'}{'mtime'}} if ref tied %{$this->{'DB'}{'mtime'}};
untie %{$this->{'DB'}{'ctime'}} if ref tied %{$this->{'DB'}{'ctime'}};
delete $this->{'DB'};
delete $this->{'REF'};
delete $this->{'KEY'};
delete $this->{'KEY_DB'};

#եϿ
$this->write_db($default::field_pref_dir . '/inputfield',$this->{'NewField'}) if ref $this->{'NewField'};
delete $this->{'NewField'};

my(%category,$nocount);
$nocount = 0;
if ($field::for{'pending'}) {
	my(%pending);
	tie(%pending, $env::dbm_file, $this->{'db_dir'} . 'pending', O_RDONLY, $env::dbm_mode);
	if (ref tied %pending) {
		while (my($k) = each %pending) {
			$nocount++ if $pending{$k} && $pending{$k} =~ /^1/;
		}
	}
	untie %pending;
}
$setting::category{$main::c}{'count'} = $this->{'total'} - $nocount;
$setting::category{$main::c}{'total'} = $this->{'total'};
tie(%category, $env::dbm_file, $default::preference_dir . '/category', O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %category) {
	$category{$main::c . '_count'} = $setting::category{$main::c}{'count'};
	$category{$main::c . '_total'} = $setting::category{$main::c}{'total'};
}
untie %category;
$this->write_category_list;
delete $this->{'row'};
delete $this->{'total'};
return '';
}

######################################################################
# TR
sub tr {
my $this = shift;
$this->{'col'} = 1;
$this->{'data_count'} = 0;

#쥳ɿ¥С
if ($this->{'total'} >= $setting::category{'LIMIT'}) {

	#üDB
	if (defined $default::type && ($default::type eq 'account' || $default::type eq 'order')) {
		$this->_table;
		my(@category_id,$name,$d);
		@category_id = sort {$a <=> $b || $a cmp $b} grep(defined $_ && $_ !~ /\D/,keys %setting::category);
		$name = $setting::category{$category_id[$#category_id]}{'name'};
		$main::c = $category_id[$#category_id] + 1;
		undef @category_id;
		$d = $1 if $name =~ s/(\d+)$//;
		$d = 1 if $d == 0;
		$this->mk_category($main::c,$name . $d);
		$this->table;

	#ǤŤ쥳ɤõƿ쥳ɤɲä
	} elsif ($setting::category{'ADD'} eq 'add') {
		$this->{'row'} = $this->minimum($this->{'DB'}{'mtime'}); 
		$this->{'total'}--;

		#źեե
		use File::Path;
		rmtree "$default::file/$main::c/$this->{'row'}";

	#ƥ꡼ƿ쥳ɤɲä
	} elsif ($setting::category{'ADD'} eq 'newcategory') {
		my($name,$my_name,$d,@category_id,@new);
		$this->_table;
		@category_id = sort {$a <=> $b || $a cmp $b} grep(defined $_ && $_ !~ /\D/,keys %setting::category);
		$name = (defined $setting::category{$main::c}{'name'}) ? $setting::category{$main::c}{'name'} : 1;
		$d = $1 if $name =~ s/(\d+)$//;
		$d++;
		$d++ if $d == 1;
		while (1) {
			$my_name = $name . $d;
			@new = ();
			@new = grep(defined $setting::category{$_}{'name'} && $setting::category{$_}{'name'} eq $my_name,@category_id);
			if (@new) {
				@new = grep(defined $setting::category{$_}{'total'} && $setting::category{$_}{'total'} < $setting::category{'LIMIT'},@new);
				if (@new) {
					last;
				} else {
					$d++;
					next;
				}
			} else {
				last;
			}
		}
		if (@new) {
			$main::c = $new[0];
		} else {
			my $order = $setting::category{$main::c}{'ORDER'} + 1;
			$main::c = $this->new_number(\%setting::category,1);
			$this->mk_category($main::c,$my_name,$order);
		}
		$this->table;

	#쥳ɤν񤭹ߤ䤹
	} else {
		$this->{'exit'} = 1;
		push(@{$this->{'dialog'}},'쥳ɿ ' . $setting::category{'LIMIT'} . ' ĶΤǡɤ߹ߤ˼Ԥޤ');

	}
}

#ǡֹФ
while (1) {
	last if !defined $this->{'DB'}{'mtime'}{$this->{'row'}} || $this->{'DB'}{'mtime'}{$this->{'row'}} eq '';
	$this->{'row'}++;
}

return '';
}

######################################################################
# _TR
sub _tr {
my $this = shift;
my($no_count,$row);
$main::option = '';
return '' if $this->{'exit'} || $this->{'data_count'} <= 1;

#ֹ
$row = $this->{'row'};	

#ȹ
if (defined $main::field && $main::field ne '' && ref $this->{'record'} && %{$this->{'record'}} && $this->{'data_count'}) {
	my($data,$no);

	#ǡȽʾȹեɡ͢orɤ߹ֹ
	if (defined $field::obj{$main::field}{'ORDER'} && defined $this->{'record'}{$field::obj{$main::field}{'ORDER'}} && defined $this->{'KEY'}{$this->{'record'}{$field::obj{$main::field}{'ORDER'}}} && $this->{'KEY'}{$this->{'record'}{$field::obj{$main::field}{'ORDER'}}} ne '') {
		$row = $this->{'KEY'}{$this->{'record'}{$field::obj{$main::field}{'ORDER'}}};
		$no_count = 1;
	}

	while (($no,$data) = each %{$this->{'record'}}) {
		$this->{'REF'}{$no}{$row} = $data unless $row == 0 && $main::option;
	}
}

#ν񤭹
$this->{'DB'}{'mtime'}{$row} = $this->{'time'};
$this->{'DB'}{'ctime'}{$row} = $this->{'time'} if !defined $this->{'DB'}{'ctime'}{$row} || !$this->{'DB'}{'ctime'}{$row};

undef %{$this->{'record'}};
if (!$no_count) {
	$this->{'row'}++;
	$this->{'total'}++;
}
return '';
}

######################################################################
# TD
sub td {
my($this,$data) = @_;
return '' if $this->{'exit'};
#$data = $cgi::Jcode->set(\$data)->euc;

$this->new_field($this->{'col'},$data) unless ref tied %{$this->{'REF'}{$this->{'col'}}};

if (defined $main::field && $main::field ne '') {
	$this->{'record'}{$this->{'col'}} = $data;
} else {
	$this->{'REF'}{$this->{'col'}}{$this->{'row'}} = $data unless $this->{'row'} == 0 && $main::option;
}

$this->{'data_count'}++ if defined $data && $data ne '' && ($this->{'row'} || !$main::option);
$this->{'col'}++;
return '';
}

######################################################################
# եɥ֥
sub new_field ($$$) {
my($this,$no,$name) = @_;
my($id,$db);

$id = $field::ORDER{$no};
unless ($id && ref $field::obj{$id}) {
	if (!defined %field::obj) {
		%field::obj = ();
		%field::for = ();
	}
	$id = $this->new_number(\%field::obj,1);

	$field::ORDER{$no} = $id;

	$this->{'NewField'}{'ORDER_' . $no} = $id;
	$this->{'NewField'}{$id . '_ORDER'} = $no;
	$this->{'NewField'}{$id . '_class'} = 'text';

	if ($name eq '' || length $name > 20) {
		$name = '' . $no;
	} else {
		$this->detag(\$name);
	}
	$this->{'NewField'}{$id . '_name'} = $name;

	$this->{'NewField'}{$id . '_Open'} = 1;
	$this->{'NewField'}{$id . '_searchEnabled'} = 1;
	$this->{'NewField'}{$id . '_sortEnabled'} = 1;
	$this->{'NewField'}{$id . '_Default'} = 1;
	$this->{'NewField'}{$id . '_cellWidth'} = 150;

	$field::obj{$id} = Field->new('text',$id,'field',\%field::obj,\%field::for);
	$field::obj{$id}->set(
		'ORDER' => $no,
		'name' => $name
	);
}

$db = $field::obj{$id}->db;
unless (!$db || ref tied %{$this->{'DB'}{$db}}) {
	tie(%{$this->{'DB'}{$db}}, $env::dbm_file, $this->{'db_dir'} . $db, O_RDWR | O_CREAT, $env::dbm_mode);
}

#ե
$this->{'REF'}{$no} = $this->{'DB'}{$db};
}

sub get_setting ($;$$$$$) {
my($this,$table,$type,$info,$op,$setting) = @_;
return '';
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#饹Ͽ
	Common::class_register('t301','TableImport');

	#˥塼Ͽ
	$setting::jump_menu{'t301'} = 'ɤ߹';
}

1;
