package VCardViewer;
require CMONOS::TableMaker::Viewer;
@ISA = qw(Viewer);
use strict;
######################################################################
# vCardɥ⥸塼
# VCardViewer.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ƥĥ
sub print_viewer_header ($) {
my $this = shift;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
$main::u = 0;
$this->print_http_header('text/x-vcard');
}

######################################################################
# ƥĥإå
sub print_contents_header ($) {
my $this = shift;
$this->field_to_vcard;
}

######################################################################
# եʬ
sub field_to_vcard ($) {
my $this = shift;
my($id);
foreach $id (@{$this->{'selectedField'}}) {
	next if !ref $field::obj{$id};
	my $name = $field::obj{$id}->name;
	my $class = $field::obj{$id}->{'class'};
	my $type = '';
	my $key = '';
	$name = $this->z_to_h($name,'euc');

	#̾
	if ($name =~ /name/i || $name =~ /\xbb\xe1\xcc\xbe/ || $name =~ /\xcc\xbe\xc1\xb0/ || $name =~ /\xa4\xca\xa4\xde\xa4\xa8/ || $name =~ /\xa5\xca\xa5\xde\xa5\xa8/) {
		if ($name =~ /\xa5\xd5\xa5\xea\xa5\xac\xa5\xca/ || $name =~ /\xa4\xd5\xa4\xea\xa4\xac\xa4\xca/ || $name =~ /\xa5\xd5\xa5\xea\xa5\xab\xa5\xca/ ||
			$name =~ /^\xa5\xca\xa5\xde\xa5\xa8$/) {
			$key = 'SORT-STRING';
		} else {
			$key = 'FN';
		}

	#
	} elsif ($name =~ /(family name|surname)/i || $name =~ /\xc0\xab/ || $name =~ /\xcc\xbe\xbb\xfa/ || $name =~ /^\xa5\xbb\xa5\xa4$/ || $name =~ /^\xa5\xdf\xa5\xe7\xa5\xa6\xa5\xb8$/) {
		if ($name =~ /\xa5\xd5\xa5\xea\xa5\xac\xa5\xca/ || $name =~ /\xa4\xd5\xa4\xea\xa4\xac\xa4\xca/ || $name =~ /\xa5\xd5\xa5\xea\xa5\xab\xa5\xca/ ||
			$name =~ /^\xa5\xbb\xa5\xa4$/ || $name =~ /^\xa5\xdf\xa5\xe7\xa5\xa6\xa5\xb8$/) {
			$key = 'SORT-STRING2';
		} else {
			$key = 'N2';
		}

	#̾
	} elsif ($name =~ /(first name|given name)/i || $name =~ /\xcc\xbe/ || $name =~ /^\xa5\xe1\xa5\xa4$/) {
		if ($name =~ /\xa5\xd5\xa5\xea\xa5\xac\xa5\xca/ || $name =~ /\xa4\xd5\xa4\xea\xa4\xac\xa4\xca/ || $name =~ /\xa5\xd5\xa5\xea\xa5\xab\xa5\xca/ ||
			$name =~ /^\xa5\xe1\xa5\xa4$/) {
			$key = 'SORT-STRING1';
		} else {
			$key = 'N1';
		}

	#եꥬ
	} elsif ($name =~ /\xa5\xd5\xa5\xea\xa5\xac\xa5\xca/ || $name =~ /\xa4\xd5\xa4\xea\xa4\xac\xa4\xca/ || $name =~ /\xa5\xd5\xa5\xea\xa5\xab\xa5\xca/) {
		$key = 'SORT-STRING';

	#˥å͡
	} elsif ($name =~ /(nickname|handle name)/i || $name =~ /\xa5\xcb\xa5\xc3\xa5\xaf\xa5\xcd\xa1\xbc\xa5\xe0/ || $name =~ /\xa5\xda\xa5\xf3\xa5\xcd\xa1\xbc\xa5\xe0/ || $name =~ /\xb0\xa6\xbe\xce/ || $name =~ /\xa5\xcf\xa5\xf3\xa5\xc9\xa5\xeb/) {
		$key = 'NICKNAME';

	#
	} elsif ($class eq 'time_date' && ($name =~ /birthday/i || $name =~ /\xa5\xd0\xa1\xbc\xa5\xb9\xa5\xc7\xa5\xa4/ || $name =~ /\xc3\xc2\xc0\xb8\xc6\xfc/ || $name =~ /\xa4\xbf\xa4\xf3\xa4\xb8\xa4\xe7\xa4\xa6/)) {
		$key = 'BDAY';

	#
	} elsif ($name =~ /(official title|official position|post)/ || $name =~ /\xcc\xf2\xbf\xa6/ || $name =~ /\xb8\xaa\xbd\xf1/) {
		$key = 'title';

	#
	} elsif ($name =~ /role/ || $name =~ /\xc9\xf4\xbd\xf0/) {
		$key = 'ROLE';

	#°
	} elsif ($name =~ /role/ || $name =~ /\xbd\xea\xc2\xb0/) {
		$key = 'ORG';

	#
	} elsif ($class eq 'user_xtime') {
		$key = 'REV' if $field::obj{$id}->{'timetype'} eq 'mtime';

	#¾
	} else {

		#̳
		if ($name =~ /(work|office|business)/i || $name =~ /\xb2\xf1\xbc\xd2/ || $name =~ /\xb6\xd0\xcc\xb3/) {
			$type = 'WORK';

		#
		} elsif ($name =~ /home/i || $name =~ /\xbc\xab\xc2\xf0/) {
			$type = 'HOME';

		#͹ã
		} elsif ($name =~ /postal/i || $name =~ /\xcd\xb9\xc1\xf7/ || $name =~ /\xa2\xa9/ || $name =~ /\xc1\xf7\xc9\xd5\xc0\xe8/) {
			$type = 'POSTAL';
			$key = 'ADR';

		#
		} elsif ($name =~ /parcel/i || $name =~ /\xc7\xdb\xc1\xf7\xc0\xe8/ || $name =~ /\xc2\xf0\xc7\xdb/ || $name =~ /\xc2\xf0\xb5\xde\xca\xd8/) {
			$type = 'PARCEL';
			$key = 'ADR';

		#
		} else {
			$type = 'HOME';
		}
	
		#E᡼
		if ($class =~ /email/i) {
			$type .= ',INTERNET';
			$key = 'EMAIL';

		#͹ֹ
		} elsif ($class eq 'addr_zipcode') {
			$key = 'ADR5';

		#
		} elsif ($name =~ /country/i || $name =~ /\xb9\xf1/) {
			$key = 'ADR6';

		#
		} elsif ($class eq 'addr_j') {
			$key = 'ADR';

		#
		} elsif ($class eq 'num_number' && ($name =~ /(cellular|PHS)/i || $name =~ /\xb7\xc8\xc2\xd3/ || $name =~ /\xa5\xb1\xa1\xbc\xa5\xbf\xa5\xa4/)) {
			$type .= ',CELL';
			$key = 'TEL';

		#եå
		} elsif ($class eq 'num_number' && ($name =~ /fax/i || $name =~ /\xa5\xd5\xa5\xa1\xa5\xc3\xa5\xaf\xa5\xb9/)) {
			$type .= ',FAX';
			$key = 'TEL';

		#
		} elsif ($class eq 'num_number' && ($name =~ /(tel|phone)/i || $name =~ /\xc5\xc5\xcf\xc3/ || $name =~ /\xa4\xc7\xa4\xf3\xa4\xef/)) {
			$type .= ',VOICE';
			$key = 'TEL';

		#URL
		} elsif ($class =~ /banner/i || $class =~ /url/) {
			$key = 'URL';
		}
	}
	if (defined $key && $key ne '') {
#		$this->{'vcard'}{$type}{$key} = $id if !$this->{'vcard'}{$type}{$key};
		$this->{'vcard'}{$type}{$key}{$id} = 1;
	} elsif ($class =~ /^text/ || $class eq 'select_menu' || $class eq 'select_box') {
#		$this->{'vcard'}{''}{'NOTE'} = $id;
		$this->{'vcard'}{''}{'NOTE'}{$id} = 1;
	}
}
#$this->{'vcard'}{''}{'FN'} = $field::for{'name'} if $field::for{'name'} && ref $field::obj{$field::for{'name'}};
$this->{'vcard'}{''}{'FN'}{$field::for{'name'}} = 1 if $field::for{'name'} && ref $field::obj{$field::for{'name'}};

#if ($ENV{'TZ'} =~ /([+\-])(\d+)$/) {
#	$this->{'vcard-TZ'} = $1 . sprintf("%.2d",$2) . ':00';
#}
}

######################################################################
# ڡեå
sub print_viewer_footer ($) {
my $this = shift;
}

######################################################################
# 쥳
sub print_record ($$$) {
my($this,$c,$n) = @_;
my(%data,$id);
foreach $id (@{$this->{'selectedField'}}) {
	next unless ref $field::obj{$id} && $field::obj{$id}->format_for_text_enabled;
	my $db = $field::obj{$id}->db;
	$field::obj{$id}->{'datetype'} = 'v' if $field::obj{$id}->{'class'} eq 'user_xtime' || $field::obj{$id}->{'class'} eq 'time_date';
	if (defined $db && $db) {
		unless (ref tied %{$this->{'DB'}{$c}{$db}}) {
			tie(%{$this->{'DB'}{$c}{$db}}, $env::dbm_file, "$default::db/$c/$db", O_RDONLY, $env::dbm_mode);
		}
		$data{$id} = $field::obj{$id}->format_for_text($this->{'DB'}{$c}{$db}{$n},"$default::file/$c/$n",$c,$n);
	} else {
		$data{$id} = $field::obj{$id}->format_for_text('');
	}
}

#񤭽Ф
$this->print_vcard('BEGIN','VCARD');
$this->print_vcard_header;

my($type);
TYPE:
foreach $type (sort keys %{$this->{'vcard'}}) {
	my($key,@types,%done);
	@types = split(/,/,$type) if defined $type && $type ne '';
	map($_ = 'type=' . $_,@types);
	KEY:
	foreach $key (sort keys %{$this->{'vcard'}{$type}}) {
		my($fid);
		ID:
		foreach $fid (sort keys %{$this->{'vcard'}{$type}{$key}}) {
			my $value = $data{$fid};
			next ID if !defined $value || $value eq '';
			next KEY if defined $done{$key} && $done{$key};
			if ($key eq 'FN') {
				if ((!defined $this->{'vcard'}{$type}{'N1'}{$fid} || $this->{'vcard'}{$type}{'N1'}{$fid} eq '') && (!defined $this->{'vcard'}{$type}{'N2'}{$fid} || $this->{'vcard'}{$type}{'N2'}{$fid} eq '')) {
					my(@name);
					@name = split(/\s+|\xa1\xa1/,$value,3);
					@name = ($name[0],$name[2],$name[1]) if defined $name[2] && $name[2] ne '';
					@name = ($name[1],$name[0],$name[2]);
					$this->print_vcard('N',\@name,\@types);
				}
			} elsif ($key eq 'N1' || $key eq 'N2') {
				next KEY if defined $done{'N'} && $done{'N'};
				my $firstname = (ref $this->{'vcard'}{$type} && ref $this->{'vcard'}{$type}{'N1'} && %{$this->{'vcard'}{$type}{'N1'}}) ? $data{(keys %{$this->{'vcard'}{$type}{'N1'}})[0]} : '';
				my $familyname = (ref $this->{'vcard'}{$type} && ref $this->{'vcard'}{$type}{'N2'} && %{$this->{'vcard'}{$type}{'N2'}}) ? $data{(keys %{$this->{'vcard'}{$type}{'N2'}})[0]} : '';
				if (!defined $this->{'vcard'}{$type}{'FN'}{$fid} || $this->{'vcard'}{$type}{'FN'}{$fid} eq '') {
					my($name);
					if ($firstname !~ /[^\w\s]/ && $firstname !~ /[^\w\s]/) {
						$name = $firstname . ' ' . $familyname;
					} else {
						$name = $familyname . ' ' . $firstname;
					}
					$this->print_vcard('FN',$name,\@types);
				}
				my @name = ($familyname,$firstname);
				$done{'N'} = 1;
				$this->print_vcard('N',\@name,\@types);
				next KEY;
			} elsif ($key eq 'SORT-STRING1' || $key eq 'SORT-STRING2') {
				next KEY if $done{'SORT-STRING'} || $this->{'vcard'}{$type}{'SORT-STRING'}{$fid};
				my $firstname = (ref $this->{'vcard'}{$type} && ref $this->{'vcard'}{$type}{'SORT-STRING1'} && %{$this->{'vcard'}{$type}{'SORT-STRING1'}}) ? $data{(keys %{$this->{'vcard'}{$type}{'SORT-STRING1'}})[0]} : '';
				my $familyname = (ref $this->{'vcard'}{$type} && ref $this->{'vcard'}{$type}{'SORT-STRING2'} && %{$this->{'vcard'}{$type}{'SORT-STRING2'}}) ? $data{(keys %{$this->{'vcard'}{$type}{'SORT-STRING2'}})[0]} : '';
				$value = $familyname . ' ' . $firstname;
				$done{'SORT-STRING'} = 1;
				$this->print_vcard('SORT-STRING',$value,\@types);
				next;
			} elsif ($key eq 'ADR5') {
				$done{'ADR5'} = 1;
				next KEY;
			} elsif ($key eq 'ADR6') {
				$done{'ADR6'} = 1;
				next KEY;
			} elsif ($key eq 'ADR') {
				$done{'ADR5'} = 1;
				$done{'ADR6'} = 1;
				$done{'ADR'} = 1;
				my @addr = split(/\x0A/,$value);
				@addr = (
					'',
					'',
					((defined $addr[2]) ? $addr[2] : '') . ((defined $addr[3]) ? $addr[3] : '') . ((defined $addr[4]) ? $addr[4] : ''),
					((defined $addr[1]) ? $addr[1] : ''),
					((defined $addr[0]) ? $addr[0] : ''),
					(ref $this->{'vcard'}{$type}{'ADR5'} && %{$this->{'vcard'}{$type}{'ADR5'}}) ? $data{(keys %{$this->{'vcard'}{$type}{'ADR5'}})[0]} : '',
					(ref $this->{'vcard'}{$type}{'ADR6'} && %{$this->{'vcard'}{$type}{'ADR6'}}) ? $data{(keys %{$this->{'vcard'}{$type}{'ADR6'}})[0]} : ''
				);
				$this->print_vcard('ADR',\@addr,\@types);
				next KEY;
			}
			$this->print_vcard($key,$value,\@types);
		}
	}
}
$this->print_vcard('END','VCARD');
}

sub print_vcard_header ($) {
my $this = shift;
$this->print_vcard('VERSION','3.0');
#$this->print_vcard('TZ',$this->{'vcard-TZ'}) if defined $this->{'vcard-TZ'} && $this->{'vcard-TZ'};
}

sub print_vcard ($$$;$) {
my($this,$key,$value,$types) = @_;
if (ref $value eq 'ARRAY') {
	map{
		$_ = (defined $_) ? $_ : '';
		$_ =~ s/(\x0D\x0A|\x0D|\x0A)/\\n/gs;
		$_ =~ s/,/\\,/g;
		$_ =~ s/;/\\;/g;
#		$_ =~ s/:/\\:/g;
	} @$value;
	$value = join("\x3B",@$value);
} elsif ($key ne 'REV' && $key ne 'BDAY') {
	$value =~ s/(\x0D\x0A|\x0D|\x0A)/\\n/gs;
#	$value =~ s/,/\\,/g;
	$value =~ s/;/\\;/g;
#	$value =~ s/:/\\:/g;
}
$key = join(';',$key,@$types) if ref $types;
$this->_print_vcard($key,$value);
}

sub _print_vcard ($$$) {
my($this,$key,$value) = @_;
print $cgi::Jcode->set(\$key)->ucs2;
print "\x00\x3A";
print $cgi::Jcode->set(\$value)->ucs2;
print "\x00\x0D\x00\x0A";
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#省
	$setting::key = 'none';						#ڡꥭ

	#ǥեȥ
	$main::k = 'vcard' if !defined $main::k || !$main::k;

	#饹Ͽ
	Common::class_register('vcard','VCardViewer');
}

1;
