package AjaxZipCodeSearch;
require CMONOS::CGI_Lib::AjaxSetUp;
@ISA = qw(AjaxSetUp);
use strict;
######################################################################
# Ajax ͹ֹ渡⥸塼
# ZipCodeSearch.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2008-05-28
######################################################################
# ᥤ
sub run ($) {
my $this = shift;
$this->print_response({'status' => 'error'}) if !defined $env::zipcode || !$env::zipcode;

use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

#---------------------------------------------------------------------
#
$this->fill(\$main::zip3,\$main::zip4,\$main::zip);
$main::zip3 = $this->z_to_h($main::zip3) if $main::zip3 =~ /\D/;
$main::zip4 = $this->z_to_h($main::zip4) if $main::zip4 =~ /\D/;
$main::zip = $this->z_to_h($main::zip) if $main::zip =~ /\D/;
$main::zip =~ s/\D//g;
$main::zip3 =~ s/\D//g;
$main::zip4 =~ s/\D//g;
$main::zip = $main::zip3 . $main::zip4 if $main::zip eq '' && $main::zip3 ne '' && $main::zip4 ne '';
if ($main::zip =~ /^\d{7}$/) {
	my @addr_list = ();
	my %zipcode;
	tie(%zipcode, $env::dbm_file, $env::zipcode . '/zipcode', O_RDONLY, $env::dbm_mode);
	if (ref tied %zipcode) {
		$this->mk_address_list_without_zipcode($zipcode{$main::zip},\@addr_list);
	} else {
		$this->print_response({'status' => 'dbm error'});
	}
	untie(%zipcode);
	if (@addr_list) {
		my @addr = split(/\x20/,$addr_list[0]);
		$this->print_response(
			{
				'status'	=>	'success',
				'pref'		=>	((defined $addr[0]) ? $addr[0] : ''),
				'city'		=>	((defined $addr[1]) ? $addr[1] : ''),
				'street'	=>	((defined $addr[2]) ? $addr[2] : '') . ((defined $addr[3]) ? $addr[3] : ''),
				'building'	=>	((defined $addr[4]) ? $addr[4] : '')
			}
		);
	} else {
		$this->print_response({'status' => 'unknown zipcode'});
	}
} else {
	$this->print_response({'status' => 'query error'});
}
}

######################################################################
#˥ޥåꥹȺ
sub mk_address_list_without_zipcode ($$$) {
my($this,$addr,$addr_list) = @_;
$addr = '' if !defined $addr;
if ($addr =~ /^(.*?)\(([^\(\)]+)\)(.*)$/) {
	my $addr1 = $1;
	my $addr3 = $3;
	my @addr = split(/\|/,$2,-1);
	my($addr2);
	foreach $addr2 (@addr) {
		$this->mk_address_list_without_zipcode($addr1 . $addr2 . $addr3,$addr_list);
	}
} elsif ($addr =~ /\|/) {
	my(@addr,$addr1);
	$addr =~ s/[\(\)]//g;
	@addr = split(/\|/,$addr,-1);
	foreach $addr1 (@addr) {
		$this->mk_address_list_without_zipcode($addr1,$addr_list);
	}
} elsif ($addr =~ /^(.*?)\[(\d+)\-(\d+)\](.*)$/) {
	my $addr1 = $1;
	my $d1 = $2;
	my $d2 = $3;
	my $addr2 = $4;
	if ($d2 - $d1 > 50) {
		$this->mk_address_list_without_zipcode($addr1,$addr_list);
	} else {
		my $d;
		foreach $d ($d1..$d2) {
			$this->mk_address_list_without_zipcode($addr1 . $d . $addr2,$addr_list);
		}
	}
} else {
	$addr =~ s/[\x0A\x0D]//g;
	push(@$addr_list,$addr) unless grep($_ eq $addr,@$addr_list);
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;					#ɤ߹
	$setting::security = 1;					#ɤ߹

	#省
	$setting::security_key = 'search';			#ǥեȥƥ
	$setting::key = 'search';					#ڡꥭ

	#å
	$cookie::id_enabled = 1;							#ID󥯥åɤ߹

	#ǥեȥ
	$main::k = 'asearch' if !defined $main::k ||  !$main::k;

	#饹Ͽ
	Common::class_register('asearch','AjaxZipCodeSearch');
}

1;
