package ZipCodeSearch;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# ͹ֹ渡⥸塼
# ZipCodeSearch.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# ᥤ
sub run ($) {
my $this = shift;
$this->print_dialog('search','ꥨ顼 : ѥɴǡ١ǥ쥯ȥΥѥꤵƤޤ') if !defined $env::zipcode ||  !$env::zipcode;

use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

#---------------------------------------------------------------------
#
$this->fill(\$main::zip3,\$main::zip4,\$main::zip);
$main::zip3 = $this->z_to_h($main::zip3) if $main::zip3 =~ /\D/;
$main::zip4 = $this->z_to_h($main::zip4) if $main::zip4 =~ /\D/;
$main::zip = $this->z_to_h($main::zip) if $main::zip =~ /\D/;
$main::zip =~ s/\D//g;
$main::zip3 =~ s/\D//g;
$main::zip4 =~ s/\D//g;
$main::zip = $main::zip3 . $main::zip4 if $main::zip eq '' && $main::zip3 ne '' && $main::zip4 ne '';
my @addr_list = ();
my $search_check;
if ($main::zip =~ /^\d{5,7}$/) {
	my @zip = ();
	if (length $main::zip == 7) {
		push(@zip,$main::zip);
	} elsif (length $main::zip == 6) {
		foreach (0..9) {push(@zip,($main::zip . $_))};
	} else {
		foreach (0..99) {push(@zip,($main::zip . sprintf("%.2d", $_)))};
	}
	my %zipcode;
	tie(%zipcode, $env::dbm_file, $env::zipcode . '/zipcode', O_RDONLY, $env::dbm_mode);
	if (ref tied %zipcode) {
		my $zip;
		foreach $zip (@zip) {
			next if !$zipcode{$zip};
			$this->mk_address_list($zip . ' ' . $zipcode{$zip},\@addr_list);
		}
	} else {
		push(@{$this->{'dialog'}},'͹ֹǡ١³ǤޤǤ');
	}
	untie(%zipcode);
	$search_check = 1;
}

#---------------------------------------------------------------------
#
if (!@addr_list) {
	if (defined $search_check && $search_check) {
		push(@{$this->{'dialog'}},'͹ֹ˳뽻꤬ߤĤޤǤ');
	} elsif ($main::zip ne '' || $main::zip3 ne '' || $main::zip4 ne '') {
		push(@{$this->{'dialog'}},'57͹ֹȾѿϤƤ');
	}

	#ڡإå
	if (defined $setting::page{'search'}{'title'}) {
		$setting::page{'search'}{'title'} =~ s/(͹(ֹ|)|ֹ|)/͹ֹ/g;
		$setting::page{'search'}{'title'} =~ s///g;
	} else {
		$setting::page{'search'}{'title'} = '͹ֹ';
	}
	if (defined $setting::page{'search'}{'titleText'}) {
		$setting::page{'search'}{'titleText'} =~ s/(͹(ֹ|)|ֹ|)/͹ֹ/g;
		$setting::page{'search'}{'titleText'} =~ s///g;
	}
	$this->print_page_header('search');

	print $this->form_start(
		'key'	=>	'search',
		'name'	=>	'input',
		'required'	=>	\@setting::form
	);

	print '<input type="text" name="zip3" size="3" maxlength="3" value="' . $main::zip3 . '" /> - ';
	print '<input type="text" name="zip4" size="4" maxlength="4" value="' . $main::zip4 . '" /> ';
	print '<input type="submit" value="" /></form>';
	
	#ڡեå
	$this->print_page_footer('search');
	return;
}

#---------------------------------------------------------------------
#񤭽Ф

#JavaScript;
$this->set_javascript(
<<JAVASCRIPT
window.focus();
cmonos.form.zipCodeExport = function () {
	if (this.currentField.selectedIndex < 0) {
		alert('򤷤Ƥ');
		return;
	}
	var addr = this.currentField.options[this.currentField.selectedIndex].value;
	var addr_list = addr.split(" ",6);
	if (opener) {
		if (opener.cmonos.form.zip3_field && opener.cmonos.form.zip4_field) {
			if (addr_list[0] == null) {
				addr_list[0] = '';
			}
			if (opener.cmonos.form.zip3_field == opener.cmonos.form.zip4_field) {
				opener.cmonos.form.zip3_field.value = addr_list[0];
			} else {
				opener.cmonos.form.zip3_field.value = addr_list[0].substr(0,3);
				opener.cmonos.form.zip4_field.value = addr_list[0].substr(3,4);
			}
		}
		if (opener.cmonos.form.pref_field && opener.cmonos.form.city_field && opener.cmonos.form.street_field && opener.cmonos.form.building_field) {
			if (addr_list[1] == null) {
				addr_list[1] = '';
			}
			if (addr_list[2] == null) {
				addr_list[2] = '';
			}
			if (addr_list[3] == null) {
				addr_list[3] = '';
			}
			if (addr_list[4] == null) {
				addr_list[4] = '';
			}
			if (addr_list[5] == null) {
				addr_list[5] = '';
			}
			if (opener.cmonos.form.pref_field.type == 'select-one') {
				cmonos.form.field(opener.cmonos.form.pref_field).getOptionByValue(addr_list[1]).selected = true;
			} else {
				opener.cmonos.form.pref_field.value = addr_list[1];
			}
			if (opener.cmonos.form.pref_field.className) {opener.cmonos.form.pref_field.className = opener.cmonos.form.pref_field.className.replace(/invalid-field/,'');}
			if (opener.cmonos.form.city_field == opener.cmonos.form.pref_field) {
				opener.cmonos.form.city_field.value += addr_list[2];
			} else {
				opener.cmonos.form.city_field.value = addr_list[2];
				if (opener.cmonos.form.city_field.className) {opener.cmonos.form.city_field.className = opener.cmonos.form.city_field.className.replace(/invalid-field/,'');}
			}
			if (opener.cmonos.form.street_field == opener.cmonos.form.city_field) {
				opener.cmonos.form.street_field.value += addr_list[3] + addr_list[4];
			} else {
				opener.cmonos.form.street_field.value = addr_list[3] + addr_list[4];
				if (opener.cmonos.form.street_field.className) {opener.cmonos.form.street_field.className = opener.cmonos.form.street_field.className.replace(/invalid-field/,'');}
			}
			if (opener.cmonos.form.building_field == opener.cmonos.form.street_field) {
				opener.cmonos.form.building_field.value += addr_list[5];
			} else {
				opener.cmonos.form.building_field.value = addr_list[5];
				if (opener.cmonos.form.building_field.className) {opener.cmonos.form.building_field.className = opener.cmonos.form.building_field.className.replace(/invalid-field/,'');}
			}
		}
		window.close();
	} else {
		this.writeAddressSample(true);
		alert('ץ򥳥ԡƤѲ');
	}
};
cmonos.form.writeAddressSample = function (select_all) {
	var selected_addr_num = this.currentField.selectedIndex;
	var sample_box = cmonos.element.form(this.currentForm).fieldname('sample').shift();
	if (selected_addr_num < 0) {
		sample_box.value = 'ꥵץɽ';
	} else {
		var sample_addr = this.currentField.options[selected_addr_num].value;
		sample_addr = sample_addr.replace(/ /g,"\\n");
		sample_box.value = sample_addr;
		if (select_all) sample_box.select();
	}
};
JAVASCRIPT
);

#ڡإå
$this->print_page_header('search');
my $size = @addr_list;
$size = 2 if $size == 1;
$size = 12 if $size > 12;
print '<form action="#" name="input">';
print '<table id="address-table"><tbody><tr><td colspan="2">';
print '<select name="zipcode" id="zipcode" size="' . $size . '" onchange="cmonos.form.item(this.form).field(this).writeAddressSample(\'sample\')">';
foreach (@addr_list) {
	print '<option value="' . $_ . '">' . $_ . '</option>';
}
print '</select>';
print '</td></tr><tr><td class="close-box">' . $this->close_button('',$setting::page{'closeButton'},$setting::page{'backButton'}) . '</td>';
print '<td class="submit-box"><input type="button" value="OK" onclick="cmonos.form.item(this.form).field(\'zipcode\').zipCodeExport()" class="save" /></td></tr></tbody></table>';
print '<textarea name="sample" cols="40" rows="4" wrap="off">ꥵץɽ</textarea>';
print '</form>';

#ڡեå
$this->print_page_footer('search');
}

######################################################################
#˥ޥåꥹȺ
sub mk_address_list ($$$) {
my($this,$addr,$addr_list) = @_;
$addr = '' if !defined $addr;
if ($addr =~ /^(.*?)\(([^\(\)]+)\)(.*)$/) {
	my $addr1 = $1;
	my $addr3 = $3;
	my @addr = split(/\|/,$2,-1);
	my($addr2);
	foreach $addr2 (@addr) {
		$this->mk_address_list($addr1 . $addr2 . $addr3,$addr_list);
	}
} elsif ($addr =~ /\|/) {
	my($base,@addr,$addr1);
	$addr =~ s/[\(\)]//g;
	($base,$addr) = ($1,$2) if $addr =~ /^(.*\x20)(\S+)$/;
	@addr = split(/\|/,$addr,-1);
	foreach $addr1 (@addr) {
		$this->mk_address_list($base . $addr1,$addr_list);
	}
} elsif ($addr =~ /^(.*?)\[(\d+)\-(\d+)\](.*)$/) {
	my $addr1 = $1;
	my $d1 = $2;
	my $d2 = $3;
	my $addr2 = $4;
	if ($d2 - $d1 > 50) {
		$this->mk_address_list($addr1,$addr_list);
	} else {
		my $d;
		foreach $d ($d1..$d2) {
			$this->mk_address_list($addr1 . $d . $addr2,$addr_list);
		}
	}
} else {
	$addr =~ s/[\x0A\x0D]//g;
	push(@$addr_list,$addr) unless grep($_ eq $addr,@$addr_list);
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;					#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::page = 1;						#ڡɤ߹

	#省
	$setting::security_key = 'search';			#ǥեȥƥ
	$setting::key = 'search';					#ڡꥭ

	#å
	$cookie::id_enabled = 1;							#ID󥯥åɤ߹

	#ǥեȥ
	$main::k = 'search' if !defined $main::k ||  !$main::k;

	#ɬܥե
	@setting::form = ('m','k');

	#饹Ͽ
	Common::class_register('search','ZipCodeSearch');
}

1;
